/***************************
**ZADANIE: 1
**SUBOR:  zadanie.cpp
**JAZYK:  Borland C 3.1
**AUTOR:  Alexander Mtyus, B-11
******************************/

/*  UCEL: vypocitanie funkcnych hodnot bud z intervalu po definovanych krokoch
 *        alebo z honot zadavanych zo vstupu
 *  Vstupne hodnoty pre intervalovu cast: a, b, c
 *  Pricom a je zaciato, b je koniec intervalu a c je definovany krok. Podmienka je, ze vsetky premenne su realne.
 *  Dalej su pouzite premenne i, j, maximum, minimum, priemer a pocet pre pripadne pomocne a pridavne vypocty
 *  Vstupne hodnoty pre hodnoty zo vstupu: a, ktore je realne
 *  Dalej su pouzite premenne a, maximum, minimum, priemer a pocet pre pripadne pomocne a pridavne vypocty
 *  Vystup: textovy subor v programe reprezentovany smernikovou premennou fout*/

#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<float.h>
#include<conio.h>

float min_f(float x, float y);              //funkcia pre vypocet minima
float max_f(float x, float y);              //funkcia pre vypocet maxima
float funkcia(float x);                     //funkcia pre vypocet funkcnych hodnot
void zapis(FILE *f, float max, float min, float priem);  //procedura zapisujuca do vystupneho suboru zvysne hodnoty

void main(void)                             //Hlavny program
 {
  FILE *fout_i;                             //definicia premennej fout_i pre pracu s vystupnym suborom pre hodnoty z intervalu
										//premenna fout_i je typu smernik na objekt FILE
  FILE *fout_p;                             //premenna pre vystupny subor pre pisanie vysledkov pre konkretne
  float a,b,c,i,j;                          //pomocne premenne pre pracu pri vypoctoch
  float minimum=FLT_MAX, maximum=FLT_MIN;   //premenne minima a maxima definovane na krajne hodnoty ciselneho typu float
  float priemer=0;                          //pomocna premenna pre vypocitanie priemeru vysledkov
  float pocet=0;                            //pomocna premenna pre uchovanie poctu premien
  char ch;                                  //pomocna hodnota pre zadanie vstupnej volby

  do
   {
    do                                      //jednoduchy cyklus pre zadanie spravnej vstupnej volby
     {
      clrscr();
      printf("Program na pisanie funkcnych hodnot f-cie 3*sin(cos(x)) do vystupneho suboru.\n");
      printf("Author: Alexander Mtyus B-11\nKontakt: am99471@decef...");
      printf("\n\n a, Zadaj inteval <a, b> a krok c\n b, Zadavaj jednotlive cisla a konci ENTERom\n");
      printf("Vyber z dvoch moznosti : ");
      do{
	 ch=getchar();                      //nacitanie volby
	}while((ch!='a')&&(ch!='b'));
     }while((ch!='a')&&(ch!='b'));          //ked nacitana hodnota nevyhovuje tak cely vyber sa opakuje


    if(ch=='a')                             //podprogram pre prvu moznost
     {
      printf("Musis zadat udaje\n");        //postupne nacitanie vstupnych hodnot s kontrolou spravnosti udaju
      printf("Zaciatok intervalu : "); if((scanf("%f", &a))==NULL) printf("\nZadaliste nespravnu hodnotu pre zaciatok intervalu!!!\n");
      printf("Koniec intervalu : "); if((scanf("%f", &b))==NULL) printf("\nZadaliste nespravnu hodnotu pre koniec intevalu!!!\n");
      printf("Krok na krokovanie : "); if((scanf("%f", &c))==NULL) printf("\nZadaliste nespravnu hodnotu pre krokovanie!!!\n");

	  fout_i = fopen("vys_int.txt","a");    //otvorenie vystupneho suboru na pripisanie v textovom rezimu pre interval

	  fprintf(fout_i,"Zadanie: 1\nMeno: Alexander Matyus\n");   //zapis hlavicky do vystupneho suboru
	  fprintf(fout_i,"Tento subor je vystupom programu na vypocet funkcnych hodnot.\n");
	  fprintf(fout_i,"Vysledne hodnoty sa vupocitavaju pre funkciu f(x)=3*sin(cos(x)).\n");
	  fprintf(fout_i,"Vstupne premenne sa zadavaly z intervalu.\n");
	  fprintf(fout_i,"\n  Vstup    Vystup\n");

	  for(i=a;i<=(b+c);i+=c)                //cyklus na krokovanie a vypocet funkcnych hodnot
       {
	j=funkcia(i);                       //volanie funkcie funkcia(float x)
	fprintf(fout_i,"%7.2f   %7.2f\n", i, j);  //zapis premennej a funkcnej hodnoty do vystupneho suboru
	minimum=min_f(minimum, j);          //zistovanie minima
	maximum=max_f(maximum, j);          //zistovanie maxima
	priemer+=j;                         //pripocitanie funkcnej hodnoty k premennej priemer
	pocet++;                            //zistovanie poctu premennych
       }
      priemer/=pocet;                       //konecny vypocet priemeru
      zapis(fout_i, maximum, minimum, priemer);  //zapis zvysnych udajov do vystupu
      fclose(fout_i);
     }                                      //koniec podprogramu

    if(ch=='b')                             //zaciatok podprogramu pre pripad vypoctu len jednotlivych hodnot
     {
      fout_p = fopen("vys_prem.txt","a");   //otvorenie suboru na pripisanie pre konkretne premenne

      fprintf(fout_p,"Zadanie: 1\nMeno: Alexander Matyus\n");   //zapis hlavicky do vystupneho suboru
      fprintf(fout_p,"Tento subor je vystupom programu na vypocet funkcnych hodnot.\n");
      fprintf(fout_p,"Vysledne hodnoty sa vupocitavaju pre funkciu f(x)=3*sin(cos(x)).\n");
      fprintf(fout_p,"Vstupne premenne sa zadavaly jednotlivo.\n");
      fprintf(fout_p,"\n  Vstup    Vystup\n");

      do{                                   //zaciatok cyklu pre vypocet premennych
					    //cyklus sa ukonci ked vstupna hodnota bude nulova
					    //nacitanie vstupnej hodnoty s kontrolou spravnosti
	 printf("Zadaj hodnotu : "); if((scanf("%f", &a))==NULL) printf("\nZadaliste nespravnu hodnotu pre pre vstupnu premenu!!!\n");
	 b=funkcia(a);                      //vypocitanie funkcnej hodnoty
	 fprintf(fout_p,"%7.2f   %7.2f\n", a, b); //zapis premennej a funkcnej hodnoty do vystupneho suboru
	 minimum=min_f(minimum, b);         //zistovanie minima
	 maximum=max_f(maximum, b);         //zistovanie maxima
	 priemer+=b;                        //spocitanie jednotlivych funkcnych hodnot
	 pocet++;                           //spocitanie poctu premien
	}while(a!=0);                       //koniec cyklu s podmienkou
      priemer/=pocet;                       //konecne dorazenie priemeru
      zapis(fout_p, maximum, minimum, priemer); //zapis minima, maxima a priemeru do vystupu
      fclose(fout_p);
     }								   //koniec druheho podprogramu

    printf("Ches skoncit (p-pokracovat, nieco k-koncit) : ");
    do{
       ch=getchar();
      }while((ch!='k')&&(ch!='p'));
   }while(ch!='k');
 }                                       //Konec hlavnej casti programu

void zapis(FILE *f, float max, float min, float priem)  //procedura pre zapis do vystupu
 {                                       //vstupne hodnoty su ukazatel na vystupny subor a realne hodnoty
					 //minima, maxima a priemeru
  fprintf(f,"maximalna hodnota bola %.2f.\n",max);        //zapis maxima
  fprintf(f,"minimalna hodnota bola %.2f.\n",min);        //zapis minima
  fprintf(f,"priemer vyslednych hodnot je %.4f.\n\n",priem);   //zapis priemeru
 }                                                      //koniec procedury

float min_f(float x, float y)            //realna funkcia pracujuca s dvoma realnymi premenami
 {                                       //funkcia vrati hodnotu mensiej vstupnej premennej
  if(x<y) return(x);
   else return(y);
 }                                      //koniec funkcie

float max_f(float x, float y)           //realna funkcie pracujuca s dvoma realnymi premenami
 {                                      //funkcia vrati hodnotu vacsiej vstupnej premennej
  if(x>y) return(x);
   else return(y);
  }                                     //koniec funkcie

float funkcia(float x)                  //realna funkcia na vypocet funkcie jednej realnej premennej
 {
  float vysledok;                       //definovanie pomocnej hodnoty pre prechodne uchovanie vysledku
  vysledok = 3*sin(cos(x));             //vypocet funkcnej hodnoty
  return(vysledok);                     //vratenie vysledku
 }                                      //koniec funkcie na vypocet vysledku