#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<process.h>

int pohyb_menu(void);
void menu(int aktivna_polozka);
void napoveda(void);
void vypocet_intervalu(void);
void vypocet_z_hodnot(void);
float vypocet_fx(float hodnota);

					   /*** HLAVNY PROGRAM. ***/
void main(void)
{

  int volba;
  clrscr();
  while (1) {
	volba = pohyb_menu();
	if (volba == 1) vypocet_intervalu();
	if (volba == 2) vypocet_z_hodnot();
	if (volba == 3) napoveda();
	if (volba == 4) break;

  }
  textcolor(15);
  clrscr();
  gotoxy(1,1);
  printf("Program bol korektne ukonceny !");
}


/* FUNKCIE */

int pohyb_menu(void)
{
  int pozicia,klavesa;
  pozicia = 1;
  klavesa = 0;
  menu(1);

  while (1){
	klavesa = getch();
	/* POHYB DOLE */
	if (klavesa == 80) {
		pozicia = pozicia + 1;
		if (pozicia == 5) pozicia = 1;
		menu(pozicia);
	}

	/* POHYB HORE */
	if (klavesa == 72) {
		pozicia = pozicia - 1;
		if (pozicia == 0) pozicia = 4;
		menu(pozicia);
	}

	/* POTVRDENIE */
	if (klavesa == 13) break;
  }
  return(pozicia);
}


void menu(int aktivna_polozka)
{
  /* DEFINICIA LOK PREMENNYCH */
  int farba_polozky = 10;

  /* VYPIS MENU */
  textcolor(9);
  gotoxy(1,3);
  cprintf("Zadajte vasu volbu (pohyb  alebo  a potvrdenie ENTER) :       \n");
  gotoxy(5,6);
  textcolor(15);
  cprintf("1.");
  textcolor(7);
  cprintf(" Vypocet funkcnych hodnot funkcie na intervale <d,h>     ");
  gotoxy(5,8);
  textcolor(15);
  cprintf("2.");
  textcolor(7);
  cprintf(" Vypocet funkcnych hodnot funkcie z konkretnych hodnot x    ");
  gotoxy(5,10);
  textcolor(15);
  cprintf("3.");
  textcolor(7);
  cprintf(" Napoveda   ");
  gotoxy(5,12);
  textcolor(15);
  cprintf("4.");
  textcolor(7);
  cprintf(" Koniec programu   ");

  /* VYZNACENIE AKTIVNEJ POLOZKY PODLA CISLA - 1,2,3,4 */
  if (aktivna_polozka == 1) {
	textcolor(farba_polozky);
	gotoxy(5,6);
	printf("1.");
	cprintf(" Vypocet funkcnych hodnot funkcie na intervale <d,h>");
  }
  if (aktivna_polozka == 2) {
	textcolor(farba_polozky);
	gotoxy(5,8);
	printf("2.");
	cprintf(" Vypocet funkcnych hodnot funkcie z konkretnych hodnot x");
  }
  if (aktivna_polozka == 3) {
	textcolor(farba_polozky);
	gotoxy(5,10);
	printf("3.");
	cprintf(" Napoveda");
	}
  if (aktivna_polozka == 4) {
	textcolor(farba_polozky);
	gotoxy(5,12);
	printf("4.");
	cprintf(" Koniec programu");
  }
}


void napoveda(void)
{
 int potvrdenie;

 textcolor(15);
 clrscr();
 gotoxy(1,1);
 printf("NAPOVEDA k programu \n\n");
 printf("Ucel programu :\n");
 printf(" \n");
 printf(" \n");
 printf(" \n");
 printf(" \n\n");

 printf("Sposob pouzitia :\n");
 printf("V uvodnom menu zvolte jednu z moznosti, podla toho akym sposobom chcete ratat a\n");
 printf("potom sa riadte vypismi na obrazovke.");

 textcolor(10);
 gotoxy(1,25);
 cprintf("                  STLACTE ENTER PRE NAVRAT DO HLAVNEHO MENU  ");

 while (1){
   potvrdenie = getch();
   if (potvrdenie == 13) break;
 }
 clrscr();
  /* ZNOVUVYPISANIE HLAVICKY ZADANIA */
  textcolor(7);
  clrscr();
}


float vypocet_fx(float hodnota)
{
 float y;
 y = (M_PI / 180) * hodnota;
 return(sin(y));
}


void vypocet_intervalu(void)
{
  int potvrdenie = 0, vstupOK = 1;
  int pocet_hodnot;
  float aktualne_x,aktualne_fx,suma,min,max;
  float d,h,k;
  FILE *fw;
  d = 0; h = 0; k = 0;pocet_hodnot = 0; suma = 0;
  clrscr();

  textcolor(11);
  gotoxy(2,2);
  cprintf("Zadajte pozadovane udaje");

  textcolor(14);
  gotoxy(1,25);
  cprintf("POPIS : Zadajte pozadovane cislo alebo stlacte lubovolnu inu klavesu pre koniec");

  textcolor(15);
  gotoxy(2,4);
  cprintf(">> Zadajte d - dolnu hranicu intervalu : ");
  cscanf("%f",&d);

  gotoxy(2,6);
  cprintf(">> Zadajte h - hornu hranicu intervalu : ");
  cscanf("%f",&h);

  gotoxy(2,8);
  cprintf(">> Zadajte k - krok delenia intervalu : ");
  cscanf("%f",&k);

  /* Kontrola Vstupu */
  textcolor(11);
  gotoxy(2,10);
  cprintf("Prebieha kontrola vstupu ... ");
  if ( k == 0 ){
	vstupOK = 0;
	textcolor(12);
	cprintf("CHYBA !");
	gotoxy(2,11);
	cprintf("Nezadali ste vsetky udaje (alebo ste sa rozhodli skoncit) !!!");
  }
  if (d > h  ||  k < 0){
	textcolor(12);
	cprintf("CHYBA !");
	gotoxy(2,11);
	cprintf("Skontrlujte rozsah intervalu -> musi platit d < h a k > 0 !!!");
	vstupOK = 0;
  }
  if (k > 0 && ((h - d) / k) > 1000)  {
	textcolor(12);
	cprintf("CHYBA !");
	gotoxy(2,11);
	cprintf("Zvacsite delenie k, lebo teraz je prilis male a vyslednych hodnot je viac");
	gotoxy(2,12);
	cprintf("ako 1000 !!!");
	vstupOK = 0;
  }

  if (vstupOK == 1) {
	textcolor(11);
	cprintf("OK !");
	vstupOK = 1;
  }
  if (vstupOK == 1) {
	fw = fopen("vystup.txt","a");
	textcolor(13);
	gotoxy(1,1);

	aktualne_x = d;
	printf("\n\n");
	textcolor(15);
	clrscr();
	min = vypocet_fx(aktualne_x); max = vypocet_fx(aktualne_x);
	/**/
	fprintf(fw,"************************************\n");
	fprintf(fw,"**    Vystupny subor programu     **\n");
	fprintf(fw,"************************************\n");
	fprintf(fw,"\n\n");
	fprintf(fw,"Zvolena metoda vypoctu : interval\n\n");
	fprintf(fw,"Horna hranica intervalu: %6.4f\n",h);
	fprintf(fw,"Dolna hranica intervalu: %6.4f\n",d);
	fprintf(fw,"Krok delenia  intervalu: %6.4f\n",k);
	fprintf(fw,"\n\n");
	fprintf(fw,"Vypocitane hodnoty su vo formate x -> f(x) :\n\n");
	fprintf(fw,"Kde f(x) reprezentuje funkciu y = sin(x) :\n\n");
	/**/
	while (aktualne_x <= h){
	  aktualne_fx = vypocet_fx(aktualne_x);
	  printf("%6.2f -> %1.6f\n",aktualne_x,aktualne_fx);
	  fprintf(fw,"%6.2f -> %1.6f\n",aktualne_x,aktualne_fx);
	  if (aktualne_fx > max) max = aktualne_fx;
	  if (aktualne_fx < min) min = aktualne_fx;
	  aktualne_x = aktualne_x + k;
	  pocet_hodnot++;
	  suma = suma + aktualne_fx;
	}
	printf("\n\n");
	fprintf(fw,"\n\n");
	printf(">> Minimalna funkcna hodnota je : %1.6f\n",min);
	fprintf(fw,">> Minimalna funkcna hodnota je : %1.6f\n",min);
	printf(">> Maximalna funkcna hodnota je : %1.6f\n",max);
	fprintf(fw,">> Maximalna funkcna hodnota je : %1.6f\n",max);
	printf(">> Priemerna funkcna hodnota je : %1.6f\n\n",suma/pocet_hodnot);
	fprintf(fw,">> Priemerna funkcna hodnota je : %1.6f\n",suma/pocet_hodnot);
	printf("Priebeh vypoctu je zaznamenany v subore vystup.txt\n");

	fclose(fw);

  }

  /***NAVRAT DO HL MENU **/
  textcolor(10);
  gotoxy(1,25);
  cprintf("                  STLACTE ENTER PRE NAVRAT DO HLAVNEHO MENU                    ");

  potvrdenie = getch();
  potvrdenie = 0;

  while (1){
	potvrdenie = getch();
	if (potvrdenie == 13) break;
  }
  clrscr();
   textcolor(7);
   clrscr();
   printf(" \n");
}


void vypocet_z_hodnot(void)
{
  int succes;
  int potvrdenie = 0;
  int pocet_hodnot;
  float aktualne_x,aktualne_fx,suma,min,max;
 // float fx;
  FILE *fw;
  pocet_hodnot = 0; suma = 0;

  fw = fopen("vystup.txt","a");
  printf("\n\n");
  textcolor(15);
  clrscr();
  min = 1; max = -1; /* Pretoze max sin(x) je 1 a min je -1 */
  textcolor(11);
  gotoxy(1,1);
  cprintf("Postupne zadavajte hodnoty pre ktore sa urci y = sin(x)");
  gotoxy(1,2);
  cprintf("Koncovym znakom na ukoncenie zadavania je cislo 123456789 !");
  gotoxy(1,4);
  textcolor(15);
  /**/
  fprintf(fw,"************************************\n");
  fprintf(fw,"**    Vystupny subor programu     **\n");
  fprintf(fw,"************************************\n");
  fprintf(fw,"\n\n");
  fprintf(fw,"Zvolena metoda vypoctu : postupne zadavanie vstupnych hodnot\n\n");
  fprintf(fw,"\n\n");
  fprintf(fw,"Vypocitane hodnoty su vo formate x -> f(x) :\n\n");
  fprintf(fw,"Kde f(x) reprezentuje funkciu y = sin(x) :\n\n");

  /**/
  while (1){
	fflush(stdin);
	succes = scanf("%f",&aktualne_x);
	if (succes == 0)
	{
	  gotoxy(1,25);
	  textcolor(13);
	  fflush(stdin);
	  gotoxy(1,24);
	  cprintf("Zadali ste nespravny parameter - pravdepodobne znak namiesto cisla !!!");
	  gotoxy(1,25);
	  cprintf("STLACTE ENTER PRE POKRACOVANIE V ZADAVANI !");
	  getch();
	  printf("\n\n");
	  textcolor(15);
	  clrscr();
	  min = 1; max = -1; /* Pretoze max sin(x) je 1 a min je -1 */
	  textcolor(11);
	  gotoxy(1,1);
	  cprintf("Postupne zadavajte hodnoty pre ktore sa urci y = sin(x)");
	  gotoxy(1,2);
	  cprintf("Koncovym znakom na ukoncenie zadavania je cislo 123456789 !");
	  gotoxy(1,4);
	  textcolor(15);

	  continue;
	}
	if (aktualne_x == 123456789) break;
	aktualne_fx = vypocet_fx(aktualne_x);
	printf("%6.2f -> %1.6f\n",aktualne_x,aktualne_fx);
	fprintf(fw,"%6.2f -> %1.6f\n",aktualne_x,aktualne_fx);
	if (aktualne_fx > max) max = aktualne_fx;
	if (aktualne_fx < min) min = aktualne_fx;
	pocet_hodnot++;
	suma = suma + aktualne_fx;
  }
  printf("\n\n");
  fprintf(fw,"\n\n");
  printf(">> Minimalna funkcna hodnota je : %1.6f\n",min);
  fprintf(fw,">> Minimalna funkcna hodnota je : %1.6f\n",min);
  printf(">> Maximalna funkcna hodnota je : %1.6f\n",max);
  fprintf(fw,">> Maximalna funkcna hodnota je : %1.6f\n",max);
  printf(">> Priemerna funkcna hodnota je : %1.6f\n\n",suma/pocet_hodnot);
  fprintf(fw,">> Priemerna funkcna hodnota je : %1.6f\n",suma/pocet_hodnot);
  printf("Priebeh vypoctu je zaznamenany v subore vystup.txt\n");

  fclose(fw);

  /***NAVRAT DO HL MENU **/
  textcolor(10);
  gotoxy(1,25);
  cprintf("                  STLACTE ENTER PRE NAVRAT DO HLAVNEHO MENU                    ");

/*  potvrdenie = getch();
  potvrdenie = 0; */

  while (1){
	potvrdenie = getch();
	if (potvrdenie == 13) break;
  }
  clrscr();
   textcolor(7);
   clrscr();
   printf(" \n");
}