/* A.Vaszondy
 * Evidencia knih v kniznici v1.00
 * Skupina C.26
 */
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#define maximum 100
/*definicia struktury*/
typedef struct{
	char nazov_knihy[24];
	int rok_vyd;
	char lit_zaner[22];
	int pocet_ks, cislo_knihy;
	} books;

/* NACITA UDAJE ZO VSTUPNEHO SUBORU */
nacitaj_udaje_zo_suboru(books pole[maximum], int pocet[3])
{
  int i;
  FILE *fr;
  fr = fopen ("books.dat","rb"); // otvori vstupni subor pre binarne nacitavanie
  fread(&pocet[0] , sizeof(pocet), 1, fr); // nacita pocet zaznamov
  if (pocet[0] > maximum) {   //nacita mximalny pocet vstupnych zaznamov
    clrscr();                 //vymaze obrazovku
    textcolor(12);
    cprintf("\nPocet nacitanich zaznamov je viac ako dovoluje parameter!\n\r");
    textcolor(7);
    exit(1);
 }
  // binarne nacitavanie zaznamov zo subaru
  for (i = 0; i < pocet[0]; i++) {fread(&pole[i], sizeof(books), 1, fr);}
  pocet[1] = pocet[0]; // nastavenie poctu aktualnych zaznamov
  fclose(fr);
  return 0;
}
/* FUNKCIA NA UMIESTNENIE TEXTU */
void center(int x,int y, char c[80], int u)
{
	  int i;
	  gotoxy(x,y);
	  for(i=0; i<=80; i++){textcolor(u);}
	  cprintf("%s", c);
}
/* UVODNA OBRAZOVKA A INF. O PROGRAME */
void begin()
	 {clrscr();
	 _setcursortype(_NOCURSOR); //vypne sa blikajuci kurzor
	 center(2,21, "Evidencia knh v kniznici v.1.00",7);
	 center(2,22, "Created by A.Vaszondy 2000\n\r"      ,7);
	 delay(1000);}
/* FUNKCIA PRE VYCISTENIE OBRAZOVKY */
void clean(int k)
{
   if (k == 0) clrscr();
   if (k == 1){}
}
/* FUNKCIA PRE NACITANIE INFORMACII */
void info()
{
   char riadok[81];      //staticke pole pre max pocet znakov v riadku
   FILE *fr;
   clrscr();
   center(30,2,"********************",14);
   center(38,2, "Info\n",15);
   //kontrola spravneho otvorenia suboru
   if ((fr = fopen("README.TXT", "r")) == NULL){
      printf("Subor readme.txt sa nepodarilo otvorit\n");
      getch();
   }
   //nacitanie a vypis udajov zo suboru na obrazovku
   while(fgets(riadok, 80, fr) != NULL)
	  printf("%s", riadok);
   center(4,20, "* stlacte lubovolnu klavesu *",15);
   if (fclose(fr) == EOF)  //kontrola spravne uzatvorenia suboru
      printf("Subor readme.txt sa nepodarilo zatvorit\n");
   getch();
}
/* FUNKCIA KTORA VYMAZE POLE */
void vymaz_pole(int pocet[3], books pole[maximum])
{
  int i;
  //cyklus v ktorom sa vymaze
  //0 pocet nacitanych suborov
  //1 pocet aktualnych suborov
  //2 cislo aktualneho zaznamu, na ktorom sa nachadza kurzor
  for (i = 0; i < 3; i++)
    pocet[i] = 0;

    for (i = 0; i < maximum; i++) {  //cyklus
    strcpy( pole[i].nazov_knihy, "");  //vymaze sa pole pre nazov knihy
    pole[i].rok_vyd = 0;               //vymaze sa pole pre rok vydania
    strcpy( pole[i].lit_zaner, "");    //vymaze sa pole pre literarny zaner
    pole[i].pocet_ks = 0;              //vymaze sa pole pre pocet kusov
    pole[i].cislo_knihy = 0;           //vymaze sa pole pre ncislo knihy
 }
}
/* FUNKCIA PRE KONTOLU SPRAVNOSTI OTVORENIA SUBORU */
int kont_vst_sub()
{
  FILE *fr;
  clrscr();
  _setcursortype(_SOLIDCURSOR);  //nastavenie typu blikajuceho kurzora
  if ( (fr = fopen("books.dat", "r")) == NULL){ //kontrola spravnosti otvorenia suboru
     clrscr();
     _setcursortype(_NOCURSOR);
     center(2,21,"\aSubor sa nepodarilo otvorit alebo sa nenasiel!",14);
     center(2,22,"Pokracovat s prazdnou databazo? [A/N]",7);
      while(1){
	switch(getch()){
	 case 'a': return 1;
	 case 'A': return 1;
	 case 'n': return 0;
	 case 'N': return 0;
	}
      }
  }
  //kontrola spravnosti uzatvorenia suboru
  if( fclose(fr) == EOF){printf("Subor sa nepodarilo zatvorit");}
  return 2;
}

/* FUNKCIA PRE VYKRESLENIE RAMIKA */
void frame(int x, int y, int z, int t, int u, int k)
{
  int i, j;
  textcolor(u);
  clean(k);
  gotoxy(x,z); cprintf("%c", char(201));   //
  gotoxy(x,t); cprintf("%c", char(200));   //
  gotoxy(y,z); cprintf("%c", char(187));   //
  gotoxy(y,t); cprintf("%c", char(188));   //
  for(i=x+1; i < y; i++){
     gotoxy(i,z);
     cprintf("%c", char(205)); //
     gotoxy(i,t);
     cprintf("%c", char(205));
  }
  for(j=z+1; j < t; j++){
     gotoxy(x,j);
     cprintf("%c", char(186));  //
     gotoxy(y,j);
     cprintf("%c", char(186));
  }
}
/* VYMAZE Y - TY RIADOK */
void vymaz(int y)
{
 gotoxy(3,y);
  printf("                        ");
 gotoxy(28,y);
  printf("        ");
 gotoxy(37,y);
  printf("                      ");
 gotoxy(60,y);
  printf("        ");
 gotoxy(69,y);
  printf("         ");
}
/* VYPISU SA ZAZNAMI DO TABULKY */
void vypis(books pole[maximum], int pocet[2]) // vypisu sa zaznami do tabulky
{
 int i = 4, aktual;
 aktual = pocet[2];    //vypis od aktualneho zaznamu
 if (pocet[1] != 0) {  //pole pre pocet aktualnych suborov
   textbackground(1);
   textcolor(15);
   i = 4;
   vymaz(i);
   gotoxy(3,i);cprintf("%24s",pole[aktual].nazov_knihy);
   gotoxy(28,i);cprintf("%8d",pole[aktual].rok_vyd);
   gotoxy(37,i);cprintf("%22s",pole[aktual].lit_zaner);
   gotoxy(60,i);cprintf("%8d",pole[aktual].pocet_ks);
   gotoxy(69,i);cprintf("%9d",pole[aktual].cislo_knihy);
   textbackground(0);
   aktual++;
   if (pocet[2] < pocet[1]) {           //
      for (i = 5; (i < ((pocet[1] - pocet[2]) + 4) && i < 20); i++, aktual++) {
	 vymaz(i);
	 gotoxy(3,i);cprintf("%24s",pole[aktual].nazov_knihy);
	 gotoxy(28,i);cprintf("%8d",pole[aktual].rok_vyd);
	 gotoxy(37,i);cprintf("%22s",pole[aktual].lit_zaner);
	 gotoxy(60,i);cprintf("%8d",pole[aktual].pocet_ks);
	 gotoxy(69,i);cprintf("%9d",pole[aktual].cislo_knihy);
      }
   }
 }
 for (i = i; i < 20; i++) vymaz(i);
 textcolor(7);
}
/* TESTUJE ROVNAKE CISLA KNIH */
testovanie(books pole[maximum], int pocet[3], int cislo)
{
 _setcursortype(0);
 int i = 0;
 for (i = 0; i < pocet[1]; i++) {           //testuje rovnost zadanych cisiel
   if (cislo == pole[i].cislo_knihy) {      //podmienka pre rovnost
	 pocet[2] = i;
	 center(24,15,"\007Kniha s danym cislom uz existuje!",12);
	 textcolor(7);
	 delay(2000);
	 _setcursortype(1);
	 return 0;
   }
 }
 return 1;
}

/* VYKRESLI SA TABULKA DATABAZY */
void tabulka()
{
   int i,j,u;
   frame(2,78,1,20, 9,0);
   textcolor(14);
	 gotoxy(2,21); cprintf("%c", char(201)); //
	 gotoxy(2,24); cprintf("%c", char(200)); //
	 gotoxy(78,21); cprintf("%c", char(187)); //
	 gotoxy(78,24); cprintf("%c", char(188));
	 for(i = 3; i < 78; i++){
	 gotoxy(i,21);cprintf("");
	 gotoxy(i,24);cprintf("");}
	 for(j = 22; j < 24; j++){
	 gotoxy(2,j);cprintf("");
	 gotoxy(78,j);cprintf("");}
   center(38,21," Menu ",12);
   textcolor(9);
   gotoxy(27,1); cprintf("%c", char(203));  //
   gotoxy(27,20);cprintf("%c", char(202));  //
   gotoxy(36,1); cprintf("%c", char(203));
   gotoxy(36,20);cprintf("%c", char(202));
   gotoxy(59,1); cprintf("%c", char(203));
   gotoxy(59,20);cprintf("%c", char(202));
   gotoxy(68,1); cprintf("%c", char(203));
   gotoxy(68,20);cprintf("%c", char(202));
   gotoxy(2,3);  cprintf("%c", char(204));  //
   gotoxy(78,3); cprintf("%c", char(185));  //
   for(i=2 ; i < 20; i++){
	  gotoxy(27,i);cprintf("%c", char(186));
	  gotoxy(36,i);cprintf("%c", char(186));
	  gotoxy(59,i);cprintf("%c", char(186));  //
	  gotoxy(68,i);cprintf("%c", char(186));
   }
   for( j=3; j < 78; j++){
	  gotoxy(j, 3); cprintf("%c", char(205));
   }
   gotoxy(27,3); cprintf("%c", char(206));  //
   gotoxy(36,3); cprintf("%c", char(206));  //
   gotoxy(59,3); cprintf("%c", char(206));  //
   gotoxy(68,3); cprintf("%c", char(206));  //
   center(9,2, "Nzov knihy",14);
   center(28,2,"Rok vyd.",14);
   center(37,2,"    Literarny zaner   ",14);
   center(60,2,"Pocet ks",14);
   center(69,2," C.knihy ",14);
}
/* FUNKCIA PRE PRIDANIE ZAZNAMU */
int pridaj_zaznam(books pole[maximum],int pocet[3])
{
  char kniha[24], zaner[22];
  unsigned int rok, i = pocet[1];
  int ks, cislo, porovnanie = 0;
  frame(15,65,5,13,12,0);
  center(33,5," Pridaj zaznam ",14);
  _setcursortype(1);
  center(17,7, "Zadaj nazov knihy   : ",7);
  center(17,8, "Zadaj rok vydania   : ",7);
  center(17,9, "Zadaj lit.zaner     : ",7);
  center(17,10,"Zadaj pocet ks knih : ",7);
  center(17,11,"Zadaj cislo knihy   : ",7);gotoxy(39,7);
  fflush(stdin);       //vycistenie buffera
  gets(kniha);         //nacita sa nazov knihy
  //kopirovanie zadaneho retazca do pola
  strcpy(pole[i].nazov_knihy, kniha);gotoxy(39,8);
  scanf("%d", &rok);   //nacita sa rok vydania
  //pridelenie zadaneho udaja do pola
  pole[i].rok_vyd = rok;gotoxy(39,9);
  fflush(stdin);
  gets(zaner);        //nacita sa lit. zaner
  //kopirovanie zadaneho retazca do pola
  strcpy(pole[i].lit_zaner, zaner);gotoxy(39,10);
  scanf("%d", &ks);   //nacita sa pocet kusov
  //pridelenie zadaneho udaja do pola
  pole[i].pocet_ks = ks;gotoxy(39,11);
  while(porovnanie == 0){
   center(17,11,"Zadaj cislo knihy   : ",7);
   scanf("%d", &cislo);//nacita sa cislo knihy
   porovnanie = testovanie(pole,pocet,cislo);
   }
  //pridelenie zadaneho udaja do pola
  pole[i].cislo_knihy = cislo;
  textcolor(7);
  pocet[1]++;//do databazy sa pripocitata a zobrazi novy zaznam
  _setcursortype(0);
  return(pocet[1]);
}
/* NAJDE NAZOV ZADANEJ KNIHY V DATABAZE */
najdi_nazov(books pole[maximum], int pocet[3])
{
 int i = 0, p = 0,klo = 0;
 char text[24];
 center(2,25,"Zadaj nazov knihy: ",12);
 fflush(stdin);            // vyprazdnenie bufera
 gets(text);               // zadanie retazca ktory sa bude porovnavat
 while (p == 0) {
   if (strcmp(text,pole[i].nazov_knihy) == 0) { // porovnavanie zaznamov
	 p = 1;
	 klo = i;
	 pocet[2] = i;
   } else p = 0;
   if (i >= maximum) {
	  frame(24,56,11,13,14,1);
	  center(25,12,"\aZadany nazov knihy sa nenasiel!",12);
	 delay(2500);
	 p = 1;
   }
   i++;
 }
// if (k == 1) return 0;
 return klo;
}
/* NAJDE CISLO KNIHY  V DATABAZE */
najdi_cislo(books pole[maximum], int pocet[3])
{
 int i = 0, p = 0, cislo = 0,kol = 0;
 center(2,25,"Zadaj cislo knihy: ",12);
 fflush(stdin);
 scanf("%d", &cislo);
 while (p == 0) {
   if (cislo == pole[i].cislo_knihy) { // porovnavanie zaznamov
	 p = 1;           //ak sa najde cislo v zozname cyklus sa ukonci
	 kol = i;         //kde sa nachadza udaj najdeny
	 pocet[2] = i;    //k i sa prideli aktualny zaznam
   } else p = 0;
   if (i >= maximum) {
	 frame(17,62,11,13,14,1);
	 center(19,12,"\007Nenasla sa kniha so zodpovedajucim cislom!",12);
	 delay(2500);
	 p = 1;           //ak sa cislo nenajde v zozname cyklus sa ukonci
   }
   i++;
   }
 return kol;
}


/* ODSTRANI AKTUALNY ZAZNAM V ZOZNAME */
odstran(books pole[maximum], int pocet[3])
{
 int cislo_akt_zaznamu,k,o = 0;
 char c = 'o';
 center(2,25,"\007Chces naozaj odstranit tento zaznam? [A/N]",12);
 while (o == 0) {                                 //cyklus
   c = getch();
   if (c == 'n' || c == 'N') {                    //podmienka pre stlacenie n
	 return 0;}
   if (c == 'a' || c == 'A') o = 1; else o = 0;   //podmienka pre stlacenie a
 }
 cislo_akt_zaznamu = pocet[2];
 if (pocet[1] > 0) {
   if (cislo_akt_zaznamu == (pocet[1] - 1)) {
	 pocet[2] -=1;
	 pocet[1] -=1;
   } else
   {for (k = cislo_akt_zaznamu; k < (pocet[1] - 1); k++)
     pole[k] = pole[k + 1];
     pocet[1] -= 1;
   }
 } else
 { pocet[2] = 0;
   pocet[1] = 0;
 }
 return 0;
}
/* ZORADI ZAZNAMY PODLA ABECEDNEHO PORADIA */
void zoradenie(books pole[maximum], int pocet[3])
{
 int i,k;
 books pomoc[1]; // vytvorenie pomocneho pola videozaznamov
 for (i = 0; i < (pocet[1] - 1); i++) {
   if (pocet[1] > i) {
	 for (k = i; k < pocet[1]; k++) {
	   if (strcmp(pole[i].nazov_knihy,pole[k].nazov_knihy) > 0) { // abecedne porovnavanie dvoch zaznamov
		 pomoc[0] = pole[i];
		 pole[i] = pole[k];
		 pole[k] = pomoc[0];
	   }
	 }
   }
 }
}

/* ULOZI SA DATABAZA */
void ulozenie(books pole[maximum],int pocet[3])
{
   FILE *fw;
   int i;
   if ((fw = fopen("books.dat","wb")) == NULL)
      printf("Neplatny zapis do suboru");
   fwrite(&pocet[1], sizeof(pocet), 1, fw);
   for (i = 0; i < pocet[1]; i++) {
   fwrite(&pole[i], sizeof(books), 1, fw);
   }
   if (fclose(fw)== EOF)
      printf("Subor sa nepodarilo zatvorit");    //zatvorenie suboru
   exit(1);
}
/* OVLADACIE PANELY */
void keybar1()
{
  center(3,22, "     1 - Info              3 - Pridaj zaznam            5 - Koniec   ", 7);
  center(3,23, "     2 - Najdi             4 - Zmaz zaznam              6 - Prepis zaznamu", 7);
}
/* OVLADACIE PANELY */
void keybar2()
{
  center(3,22, "     Najdi:    1 - Nazov knihy     3 - Literarny zaner      5 - Naspat     ",7);
  center(3,23, "               2 - Cislo knihy                                             ",7);
}
/* OVLADACIE PANELY */
void keybar3()
{
  center(3,22,"   Prepis:    1 - Nazov knihy     3 - Literarny zaner      5 - Naspat",7);
  center(3,23,"              2 - Rok vydania     4 - Pocet ks             6 - Cislo knihy ",7);
}
/* FUNKCIA PRE VYHLADAVANIE ZANRU */
najdi_zaner(books pole[maximum], int pocet[3])
{
 int i = 0, p = 0,klo = 0,pokus = 0;
 char text[24];
 center(2,25,"Zadaj zaner knihy: ",12);
 fflush(stdin);
 gets(text);	       // zadanie retazca ktory sa bude porovnavat
 while (p == 0) {
   if (strcmp(text,pole[i].lit_zaner) == 0) { // porovnavanie zaznamov
	 tabulka();
	 keybar1();
	 center(2,25,"Pre listovanie stlac - SPACE -",14);
	 pocet[2] = i;
	 klo = i;
	 vypis(pole,pocet);
	 getch();
	 pokus = 1;

   }
   else p = 0;
   if (i >= maximum) {
	  if (pokus == 1)  goto run;
	  else if(pokus==0) {
	  frame(24,56,11,13,14,1);
	  center(25,12,"\aZadany zaner knihy sa nenasiel!",12);
	 delay(2500);
	 goto run1;
	 }
   }
   i++;
 }
   run:
   center(2,25,"\aUz dalsi zaznam tohto zanru sa nenasiel",12);
   delay(2000);
   run1:
 return klo;
}
/* PREPISE SA NAZOV KNIHY */
void prepis_nazov(books pole[maximum], int cislo)
{
   char nazov_knihy[24];
   _setcursortype(2);
   center(2,25,"Zadaj novy nazov knihy : ",12);
   gets(nazov_knihy);
   strcpy(pole[cislo].nazov_knihy, nazov_knihy);
   _setcursortype(0);
}
/* PREPISE SA ROK VYDANIA */
void prepis_rok(books pole[maximum], int cislo)
{
   int rok;
   _setcursortype(2);
   center(2,25,"Zadaj novy rok vydania : ",12);
   scanf("%d",&rok);
   pole[cislo].rok_vyd = rok;
   _setcursortype(0);
}
/* PREPISE SA LITERARNY ZANER */
void prepis_zaner(books pole[maximum], int cislo)
{
   char lit_zaner[22];
   _setcursortype(2);
   center(2,25,"Zadaj novy lit.zaner : ",12);
   gets(lit_zaner);
   strcpy(pole[cislo].lit_zaner, lit_zaner);
   _setcursortype(0);
}
/* PREPISE SA POCET KUSOV KNIH */
void prepis_pocet(books pole[maximum], int cislo)
{
   int pocet_ks;
   _setcursortype(2);
   center(2,25,"Zadaj novy pocet knih : ",12);
   scanf("%d",&pocet_ks);
   pole[cislo].pocet_ks = pocet_ks;
   _setcursortype(0);
}
/* PREPISE SA CISLO KNIHY */
void prepis_cislo(books pole[maximum],int pocet[3], int cislo)
{
   int porovnanie = 0;
   int cislo_knihy;
   fflush(stdin);
   _setcursortype(2);
   while(porovnanie == 0){
     center(2,25,"Zadaj nove cislo knihy : ",12);
     scanf("%d",&cislo_knihy);
     porovnanie = testovanie(pole,pocet,cislo_knihy);
   }
   pole[cislo].cislo_knihy = cislo_knihy;
   _setcursortype(0);
}

/******************** HLAVNY PROGRAM **********************/
main()
{
   char c;
   books pole[maximum];
   int pocet[3];
   //0 - pre pocet nacitanych suborov
   //1 - pre pocet aktualnych suborov
   //2 - cislo aktualneho zaznamu, na ktorom sa nachadza kurzor
   int cislo=0,i;
   clrscr();
   begin();                 //uvodna obrazovka
   vymaz_pole(pocet,pole);    //vymaze sa pole zaznamov
   c = kont_vst_sub();
   if(c == 0) exit(1);
   if(c == 1 || c == 2){
	  _setcursortype(_NOCURSOR);
	  nacitaj_udaje_zo_suboru(pole,pocet);}
   start:
   tabulka();               //zozbrazi sa tabulka zaznamov
   keybar1();               //zobrazia sa ovladacie panely
   zoradenie(pole, pocet);
   vypis(pole,pocet);       //vypisu sa zaznami do databazi
   while (1){
    switch(getch()) {
     case 80 :{             //sipka smerom hore
	      if (pocet[2] == (pocet[0]-1)) goto a;
	      pocet[2] = ++cislo;//pocet aktualnych zaznamov sa zvacsi o jeden
	      vypis(pole,pocet);//vypisu sa zaznamy do tabulky
	      a:
	      break;
	      }
     case 72 :{            //sipka smero dole
	      if (pocet[2] == 0) goto b;
	      pocet[2] = --cislo;//pocet aktualnych zaznamov sa zmensi o jeden
	      vypis(pole,pocet);//vypisu sa zaznamy do tabulky
	      b:
	      break;
	      }
     case '1': info(); goto start;//zobrazia sa informacie
     case '2': keybar2();         //zobrazia sa ovladacie panely
		while(1){
		 switch(getch()){
		  case '1': { i = najdi_nazov(pole,pocet);
			      pocet[2]=i;
			      cislo = i;
			      goto start;
			    }
		  case '2':  {
			       i = najdi_cislo(pole,pocet);
			       pocet[2] = i;
			       cislo = i;
			       goto start;
			     }
		  case '3':  {
			       i = najdi_zaner(pole,pocet);
			       cislo = i;
			       goto start;
			     }
		  case '5': { pocet[2] = 0;
			      goto start;
			    }
		  default: break;}
		}
     case '3': {
		pocet[0] = pridaj_zaznam(pole, pocet);
		zoradenie(pole,pocet);
		goto start;
	       }
     case '4': odstran(pole,pocet); goto start;
     case '5':{int i;
	       for(i = 2; i <=78; i++){
		center(i,25,"",4);}
	       textbackground(4);
	       center(27,25,"Chces naozaj skoncit [A/N]", 0);
	       while(1){
		switch(c=getch()){
		 case 'a' : ulozenie(pole, pocet);
		 case 'A' : ulozenie(pole, pocet);
		 case 'n' : textbackground(0); goto start;
		 case 'N' : textbackground(0); goto start;
		 default: break;}
		}
	       }
     case '6': keybar3();
		while(1){
		 switch(c=getch()){
		  case '1': prepis_nazov(pole,cislo);goto start;
		  case '2': prepis_rok(pole,cislo);goto start;
		  case '3': prepis_zaner(pole,cislo);goto start;
		  case '4': prepis_pocet(pole,cislo);goto start;
		  case '5': {pocet[2] = 0 ;
			     goto start;}
		  case '6': prepis_cislo(pole,pocet,cislo);goto start;
		  default: break;}
		}
     default:  break;
    }
   }
}



