/* Martin Lacko B-18 */

/*  V jazyku C vytvorte program na evidenciu zamestnancov podniku */
/*	s pouzitm struktry.
/*	Pomocou funkci - nactajte   hodnoty    poloziek   struktry */
/*					  a zapste ich do vstupnho sboru           */

/*					- zabezpecte vylcenie poloziek struktry     */
/*					  podla daju na vstupe                       */

/*                  - vystupn zostavu zapste do vystupnho sboru  */

#include <stdio.h>
#include <conio.h>
#include <string.h>

/* Definicia struktury */

	typedef struct  { char meno[10];
					  char priezvisko[15];
					  int cislo_pracovnika;
					  int plat;
					} PRACA;

/* Definicia funkcii */

	char menu(void);
	void vypis(PRACA *p, int pocet);
	void find(PRACA *p,int pocet);
	void found(PRACA *p,int i);
	int add(PRACA *p,int pocet);
	int erase(PRACA *p,int pocet);
	void sort(PRACA *p,int pocet);
	void wrin (PRACA *p,int pocet);
	void wrout (PRACA *p,int pocet);

	void main (void)

	{
	int pocet=0;
	char v,volba;
	PRACA data[20];

/* Volanie funkcii na zaklade vyberu v menu */

	do {
		v=menu();
		switch (v){case '1' :  vypis(data,pocet);
							   getch();
							   break;
				   case '2' :  find(data,pocet);
							   break;
				   case '3' :  pocet=add(data,pocet);break;
				   case '4' :  vypis(data,pocet);
							   pocet=erase(data,pocet);
							   break;
				   case '5' :  sort(data,pocet);break;
				   case '6' :  wrin(data,pocet);break;
				   case '7' :  wrout(data,pocet);
							   fcloseall();
							   return;
				  }
	   } while (1);
	}

/* Funkcia Menu */

	char menu(void)

	{
	char q;

	clrscr();

	printf("\n\n\n\n\n\n\              Menu:\n\n");
	printf("   1. Vypis vsetkych poloziek\n");
	printf("   2. Vyhladanie polozky\n");
	printf("   3. Pridanie polozky\n");
	printf("   4. Vymazanie polozky\n");
	printf("   5. Triedenie podla kluca\n");
	printf("   6. Ulozenie vstupneho suboru\n");
	printf("   7. Ulozenie vystupneho suboru a ukoncenie programu");

	do{
	   q=getch();
	   }
	   while (q<'1' || q>'7');

	return(q);
	}

/* Funcia vypisu */

void vypis(PRACA *p, int pocet)

	{
	int i;

	clrscr();
	printf("     Meno        Priezvisko\tCislo pracovnika    Plat\n");
	for(i=0;i<pocet;i++)
		{
		printf("%-10s%-15s\t\t%d\t\t%d\n",
				p[i].meno,
				p[i].priezvisko,
				p[i].cislo_pracovnika,
				p[i].plat);
		}
	 }

/* Funkcia  vyberu hladania */

void find(PRACA *p,int pocet)

	{
	int volba,hlcislo, hlplat,a=1,i;
	char hlmeno[10],hlpriez[15];

/* Zadanie podla coho sa ma hladat v databaze */

	clrscr();
	printf("Zadaj podla coho sa ma vykonat vyhladavanie(0 spat):\n\n");
	printf("1. podla mena pracovnika\n");
	printf("2. podla priezviska pracovnika\n");
	printf("3. podla cisla pracovnika\n");
	printf("4. podla platu pracovnika\n");

/* Hladanie podla mena */

	volba=getch();
	switch (volba){ case '0': break;
					case '1': printf("Zadaj meno pracovnika:\n");
							  gets(hlmeno);
							  printf("   Meno\t\tPriezvisko\tCislo pracovnika\tPlat\n");
							  for(i=0;i<pocet;i++)
								  {
								  a=strcmp(hlmeno,p[i].meno);
									 if (a==0)
										{
										found (p,i);
										a=1;
										}
								  }
							  getch();
							  break;

/* Hladanie podla priezviska */

					case '2': printf("Zadaj priezvisko:\n");
							  gets(hlpriez);
							  printf("   Meno\t\tPriezvisko\tCislo pracovnika\tPlat\n");
							  for(i=0;i<pocet;i++)
								  {
								  a=strcmp(hlpriez,p[i].priezvisko);
									 if (a==0)
										{
										found (p,i);
										a=1;
										}
								  }
							  getch();
							  break;

/* Hladanie podla cisla pracovnika */

					case '3': printf("Zadaj cislo pracovnika:\n");
							  scanf("%d",&hlcislo);
							  printf("   Meno\t\tPriezvisko\tCislo pracovnika\tPlat\n");
							  for(i=0;i<pocet;i++)
								  {
								  if(hlcislo==p[i].cislo_pracovnika)
									  {
									  found(p,i);
									  a=1;
									  }
								  }
							  getch();
							  break;

/* Hladanie podla platu pracovnika */

					case '4': printf("Zadaj plat pracovnika:\r\n");
							  scanf("%d",&hlplat);
							  printf("   Meno\t\tPriezvisko\tCislo pracovnika\tPlat\n");
							  for(i=0;i<pocet;i++)
								  {
								  if(hlplat==p[i].plat)
									  {
									  found(p,i);
									  a=1;
									  }
								  }
							  getch();
							  break;
				  }
	}

/* Funkcia vypisu najdenych udajov */

	void found(PRACA *p,int i)

	{
	printf("\r%d.%s\t\t%s\t\t%d\t\t%d\r\n",(i+1),p[i].meno,p[i].priezvisko,
		   p[i].cislo_pracovnika,p[i].plat);
	}

/* Funkcia pridania polozky */

  int add(PRACA *p,int pocet)

  {
  clrscr();
  printf("Pridavam polozku cislo %d \n",(pocet+1));
  printf("\nMeno pracovnika: \n");
  scanf("%s",p[pocet].meno);
  printf("Priezvisko pracovnika: \n");
  scanf("%s",p[pocet].priezvisko);
  printf("Cislo pracovnika: \n");
  scanf("%d",&p[pocet].cislo_pracovnika);
  printf("Plat pracovnika: \n");
  scanf("%d",&p[pocet].plat);
  return(pocet+1);
  }

/* Funkcia zmazania polozky */

   int erase(PRACA *p,int pocet)

   {
   int i;

   printf("\nZmazat polozku cislo (0 spat):\n");
   scanf("%d",&i);
   if (i>0 && i<=pocet)
	  {
	  for(i;i<pocet;i++) p[i-1]=p[i];
	  return (pocet-1);
	  }
   else
	  return(pocet);
   }

/* Funkcia utriedenia databazy */

	void sort(PRACA *p,int pocet)

	{
	int j,triedene=0,a;
	char volba;
	PRACA pom;

	clrscr();
	printf("\rPodla coho sa ma triedit ?\n\r");
	printf("1. usporiadat podla mena pracovnika\n\r");
	printf("2. usporiadat podla priezviska pracovnika\n\r");
	printf("3. usporiadat podla cisla pracovnika\n\r");
	printf("4. usporiadat podla platu pracovnika\n\r");

	volba=getch();

/* Triedenie podla mena */

	switch (volba) {case '1' : while(triedene==0)
									{
									triedene=1;
									for(j=0;j<pocet-1;j++)
									   {
									   a=strcmp(p[j].meno,p[j+1].meno);
									   if(a>0)
											{
											 pom=p[j];
											 p[j]=p[j+1];
											 p[j+1]=pom;
											 triedene=0;
											 }
										}
									}
							   printf("\nDatabaza je utriedena.");
							   getch();
							   break;

/* Triedenie podla priezviska */

					case '2' : while(triedene==0)
									{
									triedene=1;
									for(j=0;j<pocet-1;j++)
									   {
									   a=strcmp(p[j].priezvisko,p[j+1].priezvisko);
									   if(a>0)
											{
											 pom=p[j];
											 p[j]=p[j+1];
											 p[j+1]=pom;
											 triedene=0;
											 }
										}
									}
							   printf("\nDatabaza je utriedena.");
							   getch();
							   break;

/* Triedenie podla cisla pracovnika */

					case '3' : while(triedene==0)
									{triedene=1;
									 for(j=0;j<pocet-1;j++)
										{
										if(p[j].cislo_pracovnika>p[j+1].cislo_pracovnika)
											{
											pom=p[j];
											p[j]=p[j+1];
											p[j+1]=pom;
											triedene=0;
											}
										}
									}
							   printf("\nDatabaza je utriedena.");
							   getch();
							   break;

/* Triedenie podla platu */

					case '4' : while(triedene==0)
									{triedene=1;
									 for(j=0;j<pocet-1;j++)
										{
										if(p[j].plat>p[j+1].plat)
											{
											pom=p[j];
											p[j]=p[j+1];
											p[j+1]=pom;
											triedene=0;
											}
										}
									}
							   printf("\nDatabaza je utriedena.");
							   getch();
							   break;
				   }
   }

/* Funkcia zapisu do vstupneho suboru */

void wrin (PRACA *p,int pocet)

	{
	int i;
	FILE *fin;
	fin=fopen("vstup.txt","w");
	fprintf(fin,"	 Meno         Priezvisko\t\tCislo pracovnika     Plat\n");
	for(i=0;i<pocet;i++)
	   {
	   fprintf(fin,"%10s %15s\t\t\t   %5d\t\t\t\t%5d\n",
				p[i].meno,
				p[i].priezvisko,
				p[i].cislo_pracovnika,
				p[i].plat);
	   }
	}

/* Funkcia zapisu do vystupneho suboru */

void wrout (PRACA *p,int pocet)

	{
	int i;
	FILE *fout;
	fout=fopen("vystup.txt","w");
	fprintf(fout,"	 Meno         Priezvisko\t\tCislo pracovnika     Plat\n");
	for(i=0;i<pocet;i++)
	   {
	   fprintf(fout,"%10s %15s\t\t\t   %5d\t\t\t\t%5d\n",
				p[i].meno,
				p[i].priezvisko,
				p[i].cislo_pracovnika,
				p[i].plat);
	   }
	}
