/* vlastny subor obraz.h k programu databaza
   obrazovka - nastavi sa povodne prostredie pre program ( pozadie )
   ponuka    - nakresli tabulku pre ponuku s moznostami prezeranie, pridat,
	       o programe, koniec
   tabulka   - nakresli na lubovolnom mieste tabulku, oramcekovanu, s tienmi
   zmaz_tabulku - zmaze lubovolnu tabulku na lubovolnom mieste
   zmaz_ponuku  - zmaze ponuku (Prezeranie, pridat, O programe, ... )

   Szabolcs Puskas                Trnovec nad Vahom 916            925 71  */

#include <stdio.h>
#include <conio.h>

/* vykresli zaciatocnu obrazovku - podklad */
void obrazovka()
{ int x,y;
	    /* vykresli celu obrazovku, podklad */
  clrscr(); textbackground(0); textcolor(7);
  for (y=1; y<=25; y++) {
  for (x=1; x<=79; x++) { gotoxy(0+x, 0+y); cprintf("%c",176);} }
  textcolor(7); textbackground(7);            /* ciara dole aj hore */
  for (x=1; x<=79; x++) { gotoxy(0+x, 1); cprintf("%c",219); }
  for (x=1; x<=79; x++) { gotoxy(0+x, 25); cprintf("%c",219); }
  gotoxy(1,25);textcolor(0);
  cprintf("     Copyright (c)             SZABOLCS PUSKAS              Inc. 2000-2001");
}

/* vykresli ponuka s textom */
void ponuka(int smer)
{ int x,y;

  textcolor(7);    /* vykresli okno pre ponuku, s ramcekom a textom */
  for (y=1; y<=9; y++) {
  for (x=1; x<=16; x++) {gotoxy(0+x,1+y); cprintf("%c", 219); } }

  /* text v ponuke */
  textbackground(7); textcolor(0);
      gotoxy(3,3);cprintf("Prezeranie");
      gotoxy(3,4);cprintf("Pridat");
      gotoxy(3,5);cprintf("O programe");
      gotoxy(3,6);cprintf("Ulozit bin");
      gotoxy(3,7);cprintf("Ulozit text");
      gotoxy(3,9);cprintf("Koniec");

  textbackground(2); textcolor(0); gotoxy(2,1);cprintf(" Ponuka ");
  switch (smer) {
    case 1: gotoxy(2,3);cprintf(" Prezeranie    ");break;
    case 2: gotoxy(2,4);cprintf(" Pridat        ");break;
    case 3: gotoxy(2,5);cprintf(" O programe    ");break;
    case 4: gotoxy(2,6);cprintf(" Ulozit bin    ");break;
    case 5: gotoxy(2,7);cprintf(" Ulozit text   ");break;
    case 6: gotoxy(2,9);cprintf(" Koniec        ");break;   }

   textbackground(7); textcolor(0);  /* ramcek okolo ponuky */
   gotoxy(1,2); cprintf("%c",218); gotoxy(16,2); cprintf("%c",191);
   gotoxy(16,10); cprintf("%c",217); gotoxy(1,10); cprintf("%c",192);

  /* vykresli vodorovne ciary v okne ponuky */
  for (x=1; x<=14; x++) { gotoxy(1+x,2); cprintf("%c",196); };
  for (x=1; x<=14; x++) { gotoxy(1+x,8); cprintf("%c",196); };
  for (x=1; x<=14; x++) { gotoxy(1+x,10); cprintf("%c",196); };

  /* vykresli zvisle ciary v okne ponuky */
  for (y=1; y<=7; y++) { gotoxy(1,2+y);cprintf("%c",179); }
  for (y=1; y<=7; y++) { gotoxy(16,2+y);cprintf("%c",179); }
  gotoxy(16,8);cprintf("%c",180);  gotoxy(1,8);cprintf("%c",195);

  /* tiene okolo ponuky */
  textcolor(0);
  for (y=1; y<=9; y++) { gotoxy(17,2+y); cprintf("%c",219); }
  for (y=1; y<=9; y++) { gotoxy(18,2+y); cprintf("%c",219); }
  for (x=1; x<=15; x++) { gotoxy(2+x,11); cprintf("%c",219); }
}

/* na lubovolnom mieste sa nakresli tabulka, kde zadate suradnice */
void tabulka(int x_zac,int y_zac,int dlzka_x,int dlzka_y,int back_col,int text_col,int col_ram)
{ int x, y;

  /* vykresli len cisto tabulku farby text_col, len tabulku */
  textbackground(back_col); textcolor(text_col);
  for (y=0; y<dlzka_y; y++) {
  for (x=0; x<dlzka_x; x++) { gotoxy(x_zac+x,y_zac +y); cprintf("%c", 176); } }

  /* vykresli ramcek okolo tabulky farby col_ram */
  textcolor(col_ram);
  for (y=1; y<dlzka_y-1; y++) { gotoxy(x_zac,y_zac+y); cprintf("%c", 186); }
  for (x=1; x<dlzka_x-1; x++) { gotoxy(x_zac+x,y_zac); cprintf("%c", 205); }
  for (x=1; x<dlzka_x-1; x++) { gotoxy(x_zac+x,y_zac+y); cprintf("%c", 205); }
  for (y=1; y<dlzka_y-1; y++) { gotoxy(x_zac+x,y_zac+y); cprintf("%c", 186); }

  gotoxy(x_zac,y_zac); cprintf("%c", 201);
  gotoxy(x_zac,y_zac+y); cprintf("%c", 200);
  gotoxy(x_zac+x,y_zac); cprintf("%c", 187);
  gotoxy(x_zac+x,y_zac+y); cprintf("%c", 188);

  /* tiene okolo tabulky */
  textcolor(0);
  for (y=1; y<dlzka_y+1; y++) { gotoxy(x_zac+x+1,y_zac+y); cprintf("%c", 219); }
  for (y=1; y<dlzka_y+1; y++) { gotoxy(x_zac+x+2,y_zac+y); cprintf("%c", 219); }
  for (x=2; x<dlzka_x+2; x++) { gotoxy(x_zac+x,y_zac+dlzka_y); cprintf("%c", 219); }
}

/* zmaze tabulku, ktoru chcete */
void zmaz_tabulku(int x_zac,int y_zac,int dlzka_x,int dlzka_y)
{ int x, y;
  textcolor(7); textbackground(8);
  for (y=0; y<=dlzka_y; y++) {
  for (x=0; x<=dlzka_x+1; x++) { gotoxy(x_zac+x,y_zac+y);cprintf("%c",176); } }
}

/* zmaze tabulku ponuky, tam kde je prezeranie, pridat, ... */
void zmaz_ponuku()
{ int x,y;
  textbackground(0); textcolor(7);
  for (y=1; y<=9; y++) {
  for (x=1; x<=18; x++) {gotoxy(0+x,1+y); cprintf("%c", 176); } }
}