/* vlastny subor prez.h k programu databaza
   prez_tabulka - vykresli celu tabulku pre ponuku prezeranie, aj so
		  zelenymi ramcekmi ( Ok, Pridat, ... )
   prezeranie_volba - pohyb medzi jednotlivymi moznostami v prezerani
		      pomocou tabulatora, alebo pomocou Hotkeys (Ok, Pridat,
		      Zmazat, Prepis, Meno, ... ) a pohyb hore dole

*/

#include <stdio.h>
#include <conio.h>

/* Vykresli tabulku pre ponuku prezeranie */
void prez_tabulka(int x_zac,int y_zac,int dlzka_x,int dlzka_y)
{ int x, y, i;

  textcolor(15);  /* dokresli este dva znaky a potom cely riadok = */
  gotoxy(x_zac,y_zac+2);cprintf("%c", 204);
  gotoxy(x_zac+dlzka_x-1,y_zac+2);cprintf("%c", 185);
   for (x=1; x<dlzka_x-1; x++) {gotoxy(x_zac+x, y_zac+2); cprintf("%c", 205);}

  textcolor(3); /* vykresli zelenu cast tabulky, v ktorej budu udaje */
  for (y=3; y<=dlzka_y-5; y++) {
  for (x=2; x<=dlzka_x-3; x++) {gotoxy(x_zac+x, y_zac+y);cprintf("%c", 219);}}

  textcolor(0);textbackground(2); /* vykresli moznosti zelenou */
  gotoxy(x_zac+2,y_zac+dlzka_y -3);    cprintf("   Ok   ");
  gotoxy(x_zac+15,y_zac+dlzka_y -3);   cprintf("   Pridat   ");
  gotoxy(x_zac+32,y_zac+dlzka_y -3);   cprintf("   Zmazat   ");
  gotoxy(x_zac+49,y_zac+dlzka_y -3);   cprintf("   Prepis   ");

  textbackground(7);textcolor(0);  /* tiene okolo OK, Pridat, ...  */
    for (i=1; i<=8; i++) { gotoxy(x_zac+2+i,y_zac+dlzka_y-2);
			   cprintf("%c", 223); }
    for (i=1; i<=12; i++) { gotoxy(x_zac+15+i,y_zac+dlzka_y-2);
			   cprintf("%c", 223); }
    for (i=1; i<=12; i++) { gotoxy(x_zac+32+i,y_zac+dlzka_y-2);
			   cprintf("%c", 223); }
    for (i=1; i<=12; i++) { gotoxy(x_zac+49+i,y_zac+dlzka_y-2);
			   cprintf("%c", 223); }
  gotoxy(x_zac+10,y_zac+dlzka_y-3);;cprintf("%c", 220); /* stale tiene zboku */
  gotoxy(x_zac+27,y_zac+dlzka_y-3);;cprintf("%c", 220);
  gotoxy(x_zac+44,y_zac+dlzka_y-3);;cprintf("%c", 220);
  gotoxy(x_zac+61,y_zac+dlzka_y-3);;cprintf("%c", 220);

  textbackground(7);textcolor(0);   /* zvisle ciary vedla Meno, Prizvisko, ... */
  gotoxy(x_zac+2,y_zac+1);cprintf("%c", 179);
  gotoxy(x_zac+15,y_zac+1);cprintf("%c", 179);
  gotoxy(x_zac+31,y_zac+1);cprintf("%c", 179);
  gotoxy(x_zac+60,y_zac+1);cprintf("%c", 179);

  /* vypise do tabulky Meno, Prizvisko, ... */
  textcolor(0);gotoxy(x_zac+3,y_zac+1);cprintf("Meno");
  gotoxy(x_zac+16,y_zac+1);cprintf("Priezvisko");
  gotoxy(x_zac+32,y_zac+1);cprintf("Futbalovy Klub");
  gotoxy(x_zac+61,y_zac+1);cprintf("Datum nar.");

  /* Niektore pismena vykresli zltou farbou, kvoli ovladaniu */
  textbackground(2);textcolor(14);
  gotoxy(x_zac+6,y_zac+dlzka_y-3);  cprintf("k");
  gotoxy(x_zac+18,y_zac+dlzka_y-3); cprintf("P");
  gotoxy(x_zac+35,y_zac+dlzka_y-3); cprintf("Z");
  gotoxy(x_zac+53,y_zac+dlzka_y-3); cprintf("r");
  textbackground(7); gotoxy(x_zac+3,y_zac+1); cprintf("M");
		     gotoxy(x_zac+18,y_zac+1); cprintf("i");

  gotoxy(x_zac+2, y_zac+3); textbackground(2);
  cprintf("                                                                      ");
}

int prezeranie_volba(int x_zac,int y_zac,int dlzka_y,int posun,int zac,UDAJE vstupy[],int dlzka)
{ int key ;
  FILE *zapis_zaciatok;

  do {   /* caka kym stlacite enter, aj s volbou OK, ULOZIT, PRIDAT */
    key=getch();
    if (key == '\t') posun += 1;      /* ak stlacite tabulator */
       if (posun == 7) posun=1;
/*    if ((key == 'k') || (key == 'K')) posun=1;
    if ((key == 'p')|| (key == 'P'))  posun=2;  */
    if (key == 'k') posun=1;
    if (key == 'p') posun=2;
    if ((key == 'z') || (key == 'Z')) posun=3;
    if ((key == 'r') || (key == 'R')) posun=4;
/*    if ((key == 'm') || (key == 'M')) posun=5; */
    if (key == 'm') posun = 5;
    if ((key == 'i') || (key == 'I')) posun=6;

    if (key == 80) { zac++; textbackground(3);textcolor(15);
    if (zac==dlzka) zac--;
    gotoxy(x_zac+2, y_zac+2+zac);               /* sipka dole */
    cprintf("                                                                      ");
    gotoxy(x_zac+3 ,y_zac+2+zac); cprintf("%s", vstupy[zac-1].meno);
    gotoxy(x_zac+16,y_zac+2+zac); cprintf("%s", vstupy[zac-1].priezvisko);
    gotoxy(x_zac+32,y_zac+2+zac); cprintf("%s", vstupy[zac-1].klub);
    gotoxy(x_zac+61,y_zac+2+zac); cprintf("%s", vstupy[zac-1].datum);

    textbackground(2);textcolor(0); gotoxy(x_zac+2, y_zac+3+zac);
    cprintf("                                                                      ");
    gotoxy(x_zac+3 ,y_zac+3+zac); cprintf("%s", vstupy[zac].meno);
    gotoxy(x_zac+16,y_zac+3+zac); cprintf("%s", vstupy[zac].priezvisko);
    gotoxy(x_zac+32,y_zac+3+zac); cprintf("%s", vstupy[zac].klub);
    gotoxy(x_zac+61,y_zac+3+zac); cprintf("%s", vstupy[zac].datum);  }

  if (key == 72) { zac--; textbackground(3);textcolor(15);
    if (zac==-1) zac=0;
    gotoxy(x_zac+2, y_zac+4+zac);               /* sipka hore */
    cprintf("                                                                      ");
    gotoxy(x_zac+3 ,y_zac+4+zac); cprintf("%s", vstupy[zac+1].meno);
    gotoxy(x_zac+16,y_zac+4+zac); cprintf("%s", vstupy[zac+1].priezvisko);
    gotoxy(x_zac+32,y_zac+4+zac); cprintf("%s", vstupy[zac+1].klub);
    gotoxy(x_zac+61,y_zac+4+zac); cprintf("%s", vstupy[zac+1].datum);

    textbackground(2);textcolor(0); gotoxy(x_zac+2, y_zac+3+zac);
    cprintf("                                                                      ");
    gotoxy(x_zac+3 ,y_zac+3+zac); cprintf("%s", vstupy[zac].meno);
    gotoxy(x_zac+16,y_zac+3+zac); cprintf("%s", vstupy[zac].priezvisko);
    gotoxy(x_zac+32,y_zac+3+zac); cprintf("%s", vstupy[zac].klub);
    gotoxy(x_zac+61,y_zac+3+zac); cprintf("%s", vstupy[zac].datum); }

      switch (posun) {
	case 2: textcolor(0); textbackground(2);
			gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
	/* pridat */    gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
		textbackground(7); gotoxy(x_zac+4,y_zac+1);cprintf("eno");
			gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
		textcolor(15); textbackground(2);
			gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");

		break;
	case 3: textcolor(0); textbackground(2);
			gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");
	/* zmazat */    gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
		textbackground(7); gotoxy(x_zac+4,y_zac+1);cprintf("eno");
			gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
		textcolor(15); textbackground(2);
			gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
		break;
	case 1: textcolor(0); textbackground(2);
			gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
	/* Ok */        gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
		textbackground(7); gotoxy(x_zac+4,y_zac+1);cprintf("eno");
			gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
		textcolor(15); textbackground(2);
			gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
		break;
	case 4: textcolor(0); textbackground(2);
			gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
	/* prepis */	gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");
			gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
		textbackground(7); gotoxy(x_zac+4,y_zac+1);cprintf("eno");
			gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
		textcolor(15); textbackground(2);
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
		break;
	case 5: textcolor(0);textbackground(2);
			gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
	/* Meno */	gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");
			gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
			textbackground(7); gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
		textcolor(15);textbackground(7);
			gotoxy(x_zac+4,y_zac+1);cprintf("eno"); break;
	case 6: textcolor(0);textbackground(2);
			gotoxy(x_zac+36,y_zac+dlzka_y-3); cprintf("mazat");
     /* Priezvisko */	gotoxy(x_zac+19,y_zac+dlzka_y-3); cprintf("ridat");
			gotoxy(x_zac+5,y_zac+dlzka_y-3);  cprintf("O");
			gotoxy(x_zac+52,y_zac+dlzka_y-3); cprintf("P");
			gotoxy(x_zac+54,y_zac+dlzka_y-3); cprintf("epis");
		 textbackground(7); gotoxy(x_zac+4,y_zac+1);cprintf("eno");
		 textcolor(15);textbackground(7);
			gotoxy(x_zac+16,y_zac+1);cprintf("Pr");
			gotoxy(x_zac+19,y_zac+1);cprintf("ezvisko");
			break;
		}
  } while ((key != 13) && (key != ' '));

  zapis_zaciatok=fopen("zaciatok","w");
  fprintf(zapis_zaciatok,"%d", zac);  fclose(zapis_zaciatok);

  return(posun);
}