entity ADDER is
    port ( 
    A1,A2,A3,A4,B1,B2,B3,B4: in Bit;    
    Y1,Y2,Y3,Y4: out Bit;
        Carry_In: in Bit;
        Carry_Out: out Bit
    );

end ADDER;

architecture BEHAVIOR of ADDER is
 
 begin
  Y1<=(A1 xor B1) xor Carry_In;
  Y2<=(A2 xor B2) xor (A1 and B1); 
  Y3<=(A3 xor B3) xor (A2 and B2);
  Y4<=(A4 xor B4) xor (A3 and B3);
  Carry_Out<= A4 xor B4;
 end BEHAVIOR;
