entity Coder is
  port(I1,I2,I3,I4:in Bit;O1,O2,O3,O4,O5,O6,O7:out Bit);
end Coder;

architecture beh of Coder is
  begin
    O1<=(I1 and(not I2) and(not I4))or((not I1) and I2 and(not I4))or(I1 and I2 and I4) or((not I1)and(not I2) and I4);
    O2<=(I1 and (not I3) and (not I4)) or ((not I1) and I3 and (not I4)) or (I1 and I3 and I4) or ((not I1) and (not I3) and I4);   
    O3<=I1;
    O4<=(I2 and (not I3) and (not I4)) or ((not I2) and I3 and (not I4)) or (I2 and I3 and I4) or ((not I2) and (not I3) and I4);
    O5<=I2;
    O6<=I3;
    O7<=I4;
end beh;

entity Correct is
  port(Ii1,Ii2,Ii3,Ii4,Ii5,Ii6,Ii7:in Bit;N1,N2,N3:out Bit);
end Correct;

architecture beh of Correct is
  begin
    N1<=((not Ii4)and (not Ii5) and Ii6 and(not Ii7))or((not Ii4)and(not Ii5)and(not Ii6)and Ii7)or(Ii4 and(not Ii5)and(not Ii6)and(not Ii7))or
            (Ii4 and(not Ii5)and Ii6 and Ii7)or(Ii4 and Ii5 and Ii6 and(not Ii7))or(Ii4 and Ii5 and(not Ii6) and Ii7)or((not Ii4) and Ii5 and(not Ii6)and(not Ii7))or
            ((not Ii4)and Ii5 and Ii6 and Ii7); 
    N2<=((not Ii2)and (not Ii3) and Ii6 and(not Ii7))or((not Ii2)and(not Ii3)and(not Ii6)and Ii7)or(Ii2 and(not Ii3)and(not Ii6)and(not Ii7))or
            (Ii2 and(not Ii3)and Ii6 and Ii7)or(Ii2 and Ii3 and Ii6 and(not Ii7))or(Ii2 and Ii3 and(not Ii6) and Ii7)or((not Ii2) and Ii3 and(not Ii6)and(not Ii7))or
            ((not Ii2)and Ii3 and Ii6 and Ii7); 
    N3<=((not Ii1)and (not Ii3) and Ii5 and(not Ii7))or((not Ii1)and(not Ii3)and(not Ii5)and Ii7)or(Ii1 and(not Ii3)and(not Ii5)and(not Ii7))or
            (Ii1 and(not Ii3)and Ii5 and Ii7)or(Ii1 and Ii3 and Ii5 and(not Ii7))or(Ii1 and Ii3 and(not Ii5) and Ii7)or((not Ii1) and Ii3 and(not Ii3)and(not Ii7))or
            ((not Ii1)and Ii3 and Ii5 and Ii7); 
  end beh;
  
entity Decoder is
  port(Din1,Din2,Din3,Din4,Din5,Din6,Din7,Dn1,Dn2,Dn3:in Bit;Do1,Do2,Do3,Do4:out Bit);
end Decoder;

architecture beh of Decoder is
  begin
    Do1<=((not Dn1)and Dn2 and Dn3) xor Din3;
    Do2<=(Dn1 and (not Dn2) and Dn3) xor Din5;
    Do3<=(Dn1 and Dn2 and(not Dn3)) xor Din6;
    Do4<=(Dn1 and Dn2 and Dn3) xor Din7;
  end beh;
  
entity Not_Gate is
  port(Nin:in Bit;Nout:out Bit);
end Not_Gate;  

architecture beh of Not_Gate is
  begin
    Nout<=(not Nin);
  end beh;        
      
            