entity Xor_Gate is				
  port(Xin1,Xin2:in Bit; Xout:out Bit);
end Xor_Gate;

architecture beh of Xor_Gate is
 begin Xout<= Xin1 xor Xin2;
 end beh;    
------------------------------------------------------------------------------------------------
entity And4_Gate is		
   port(Ain1,Ain2,Ain3,Ain4: in Bit;Aout:out Bit);
end And4_Gate;

architecture beh of And4_Gate is
 begin 	Aout<=Ain1 and Ain2 and Ain3 and Ain4;
end beh;
------------------------------------------------------------------------------------------------
entity Not_Gate is 		
  port(Nin:in Bit; Nout:out Bit);
end Not_Gate;

architecture beh of Not_Gate is
 begin 	Nout<=(not Nin);
 end beh;
------------------------------------------------------------------------------------------------
entity Or8_Gate is			
  port(O8in1,O8in2,O8in3,O8in4,O8in5,O8in6,O8in7,O8in8:in Bit;O8out:out Bit);
end Or8_Gate;

architecture beh of Or8_Gate is
 begin 	O8out<=O8in1 or O8in2 or O8in3 or O8in4 or O8in5 or O8in6 or O8in7 or O8in8;
 end beh;
------------------------------------------------------------------------------------------------
entity Modulo is	
  port(X1,X2,X3,X4:in Bit; Y:out Bit);
end Modulo;

architecture beh of Modulo is 
 signal Temp_not1,Temp_not2,Temp_not3,Temp_not4,Temp_and1,Temp_and2,Temp_and3,Temp_and4,Temp_and5,Temp_and6,Temp_and7,Temp_and8:Bit;

 component Not_Gate
   port(Nin: in Bit; Nout: out Bit);
 end component;

 component And4_Gate
  port(Ain1,Ain2,Ain3,Ain4:in Bit; Aout: out Bit);
 end component;

 component Or8_Gate
  port(O8in1,O8in2,O8in3,O8in4,O8in5,O8in6,O8in7,O8in8:in Bit;O8out:out Bit);      	  	   
 end component;

begin
  O_NOT1:Not_Gate  	port map(Nin=>X1,Nout=>Temp_not1);
  O_NOT2:Not_Gate  	port map(Nin=>X2,Nout=>Temp_not2);
  O_NOT3:Not_Gate  	port map(Nin=>X3,Nout=>Temp_not3);
  O_NOT4:Not_Gate      port map(Nin=>X4,Nout=>Temp_not4);	
  O_AND1:And4_Gate   	port map(Ain1=>Temp_not1,Ain2=>Temp_not2,Ain3=>X3,Ain4=>Temp_not4,Aout=>Temp_and1);
  O_AND2:And4_Gate  	port map(Ain1=>Temp_not1,Ain2=>Temp_not2,Ain3=>Temp_not3,Ain4=>X4,Aout=>Temp_and2);
  O_AND3:And4_Gate  	port map(Ain1=>X1,Ain2=>Temp_not2,Ain3=>Temp_not3,Ain4=>Temp_not4,Aout=>Temp_and3);
  O_AND4:And4_Gate  	port map(Ain1=>X1,Ain2=>Temp_not2,Ain3=>X3,Ain4=>X4,Aout=>Temp_and4);
  O_AND5:And4_Gate  	port map(Ain1=>X1,Ain2=>X2,Ain3=>X3,Ain4=>Temp_not4,Aout=>Temp_and5);
  O_AND6:And4_Gate  	port map(Ain1=>X1,Ain2=>X2,Ain3=>Temp_not3,Ain4=>X4,Aout=>Temp_and6);
  O_AND7:And4_Gate  	port map(Ain1=>Temp_not1,Ain2=>X2,Ain3=>Temp_not3,Ain4=>Temp_not4,Aout=>Temp_and7);
  O_AND8:And4_Gate  	port map(Ain1=>Temp_not1,Ain2=>X2,Ain3=>X3,Ain4=>X4,Aout=>Temp_and8);
  O_8OR:Or8_Gate    	port map(O8in1=>Temp_and1,O8in2=>Temp_and2,O8in3=>Temp_and3,O8in4=>Temp_and4,O8in5=>Temp_and5,
  	O8in6=>Temp_and6,O8in7=>Temp_and7,O8in8=>Temp_and8,O8out=>Y);
end beh;  						