use work.all;

entity Celok is
  port(Cin1,Cin2,Cin3,Cin4:in Bit;Cout1,Cout2,Cout3,Cout4:out Bit);
end Celok;

architecture beh of Celok is
  
  signal Temp_cod1,Temp_cod2,Temp_cod3,Temp_cod4,Temp_cod5,Temp_cod6,Temp_cod7,Temp_ch,Temp_err1,Temp_err2,Temp_err3:Bit;
    
component Coder 
  port(I1,I2,I3,I4:in Bit;O1,O2,O3,O4,O5,O6,O7:out Bit);
end component;

component Correct
  port(Ii1,Ii2,Ii3,Ii4,Ii5,Ii6,Ii7:in Bit;N1,N2,N3:out Bit);
end component;

component Decoder
  port(Din1,Din2,Din3,Din4,Din5,Din6,Din7,Dn1,Dn2,Dn3:in Bit;Do1,Do2,Do3,Do4:out Bit);
end component;

component Not_Gate
  port(Nin:in Bit;Nout:in Bit);
end component;
  
begin
  O_Coder:Coder
    port map(I1=>Cin1,I2=>Cin2,I3=>Cin3,I4=>Cin4,O1=>Temp_cod1,O2=>Temp_cod2,O3=>Temp_cod3,O4=>Temp_cod4,O5=>Temp_cod5,O6=>Temp_cod6,O7=>Temp_cod7);        
  O_Not:Not_Gate
    port map(Nin=>Temp_cod5,Nout=>Temp_ch);  -- Vytvara chybu
  O_Correct:Correct
    port map(Ii1=>Temp_cod1,Ii2=>Temp_cod2,Ii3=>Temp_cod3,Ii4=>Temp_cod4,Ii5=>Temp_ch,Ii6=>Temp_cod6,Ii7=>Temp_cod7,N1=>Temp_err1,N2=>Temp_err2,N3=>Temp_err3);
  O_Dec:Decoder
    port map(Din1=>Temp_cod1,Din2=>Temp_cod2,Din3=>Temp_cod3,Din4=>Temp_cod4,Din5=>Temp_ch,Din6=>Temp_cod6,Din7=>Temp_cod7,Dn1=>Temp_err1,Dn2=>Temp_err2,Dn3=>Temp_err3,Do1=>Cout1,Do2=>Cout2,Do3=>Cout3,Do4=>Cout4);
end beh;      

entity test is
end test;

architecture beh of test is
  
  component Celok
    port(Cin1,Cin2,Cin3,Cin4:in Bit; Cout1,Cout2,Cout3,Cout4:out Bit);
  end component;
  
signal Cin1,Cin2,Cin3,Cin4,Cout1,Cout2,Cout3,Cout4:Bit;

begin  
  O_Celok: Celok
    port map(Cin1=>Cin1,Cin2=>Cin2,Cin3=>Cin3,Cin4=>Cin4,Cout1=>Cout1,Cout2=>Cout2,Cout3=>Cout3,Cout4=>Cout4);
    
  Stimulus1:Cin1<='0' after 0ns,'1' after 400ns;  
  Stimulus2:Cin2<='0' after 0ns,'1' after 100ns,'0' after 300 ns,'1' after 400ns;  
  Stimulus3:Cin3<='0' after 0ns,'1' after 50ns,'0' after 100ns,'1' after 150ns, '0' after 200ns,'1' after 250ns,'0' after 300ns,'1' after 350ns;  
  Stimulus4:Cin4<='0' after 0ns,'1' after 200ns;  

end beh;        