entity And_Gate is
   port(Ain1,Ain2: in Bit;Aout:out Bit);
end And_Gate;

architecture beh of And_Gate is
 begin
 	Aout<=Ain1 and Ain2;
end beh;

--------------------------------------------------------------------
entity Or_Gate is 
  port(Oin1,Oin2:in Bit; Oout:out Bit);
end Or_Gate;

architecture beh of Or_Gate is
 begin
 	Oout<=Oin1 or Oin2;
 end beh;
 
---------------------------------------------------------------------
entity Or4_Gate is
  port(O4in1,O4in2,O4in3,O4in4:in Bit;O4out:out Bit);
end Or4_Gate;

architecture beh of Or4_Gate is
 begin
 	O4out<=O4in1 or O4in2 or O4in3 or O4in4;
 end beh;
 
--------------------------------------------------------------------- 	  
 entity Modus is
  port(X1,X2,X3:in Bit; Y:out Bit);
end Modus;

architecture beh of Modus is
 
 signal Temp_or1,
 	Temp_or2,
 	Temp_or3,
 	Temp_and1,
 	Temp_and2,
 	Temp_and3,
 	Temp_and4,
 	Temp_and5:Bit;
 	
 component Or_Gate
   port(Oin1,Oin2: in Bit; Oout: out Bit);
 end component;
 
 component And_Gate
  port(Ain1,Ain2:in Bit; Aout: out Bit);
 end component;
 
 component Or4_Gate
  port(O4in1,O4in2,O4in3,O4in4:in Bit;O4out:out Bit);      	  	   
 end component;
 
 begin
  O_OR1:Or_Gate
  	port map(Oin1=>X2 Oin2=>X3,Oout=>Temp_or1);
  	
  O_OR2:Or_Gate
  	port map(Oin1=>X1,Oin2=>X3,Oout=>Temp_or2);
  	
  O_Or3:Or_Gate
  	port map(Oin1=>X1,Oin2=>X2,Oout=>Temp_or3);
  	
  O_AND1:And_Gate
  	port map(Ain1=>X1,Ain2=>X2,Aout=>Temp_and1);
  	
  O_AND2:And_Gate
  	port map(Ain1=>Temp_or1,Ain2=>X1,Aout=>Temp_and2);
  	
  O_AND3:And_Gate
  	port map(Ain1=>Temp_or2,Ain2=>X2,Aout=>Temp_and3);
  	
  O_AND4:And_Gate
  	port map(Ain1=>Temp_or3,Ain2=>X3,Aout=>Temp_and4);
  	
  O_AND5:And_Gate
  	port map(Ain1=>Temp_and1,Ain2=>X3,Aout=>Temp_and5);
  	
  O_4OR:Or4_Gate
  	port map(O4in1=>Temp_and2,O4in2=>Temp_and3,O4in3=>Temp_and4,O4in4=>Temp_and5,O4out=>Y);
  	
end beh;  						