entity Counter is
  port(Enable,Up,Resetn,Clk:in Bit;Cout_vyst,Vystup: out Integer);
end Counter;

architecture behaviour of Counter is

constant Delay_asyn:Time :=8ns;
constant Delay_syn:Time :=5ns;
signal Res,Upp,En,Clock:Bit;
signal Vyst: Integer:=0;
  
  begin
  blok0: process(Vyst)	   
  	   begin
  	   Vystup<=Vyst; 
  	   end process;
  blok1: process(Resetn)
  	   begin
  	   if Resetn'Event then
  	     Res<=Resetn after Delay_asyn;  	 
  	   end if;
  	     end process;
  blok2: process(Enable)
  	   begin
  	   if Enable'Event then
  	     En<=Enable after Delay_syn;  	 
  	   end if;
  	   end process;
  blok3: process(Up)	   
  	   begin
  	   if Up'Event then
  	     Upp<=Up after Delay_syn;  	 
  	   end if;
  	   end process;
  block4: process(Clk)
  	   begin
  	   if Clk'Event then
  	     Clock<=Clk after Delay_asyn;
  	   end if;
  	   end process;  	     	     
  blok5: process(Clock,Res,Upp,En)
  	     begin
  	     if Res='1' then
  	       if(Clock='1' and not Clock'STABLE) then
  	         if En='1' then
  	           if Upp='1' then
  	             if Vyst=7 then
			       Cout_vyst<=1;
			       Vyst<=0;			         		  	          				   
  	             else
  	               Cout_vyst<=0;
  	               Vyst<=Vyst +1;  	               
  	             end if;
  	           else if Vyst=0 then
  	                  Cout_vyst<=1;
  	                  Vyst<=7;  	                  
  	                else
  	                  Cout_vyst<=0;
  	                  Vyst<=Vyst-1;
  	                end if; 
   	           end if;
   	         end if;
   	       end if;   	        	     
   	    else
   	      Vyst<=0;
   	    end if;   
   	 end process;  
 end behaviour;  	         