use work.all;

entity test_beh is
end test_beh;

architecture adder of test_beh is

component four_bit_adder is
        port(A:in Bit_Vector(0 to 3);B:in Bit_Vector(0 to 3);AB:out Bit_vector(0 to 3);CarryOut:out Bit);
end component;

signal  X:Bit_Vector(0 to 3);
signal  Y:Bit_Vector(0 to 3);
signal  CarryOut:Bit;
signal  Suma:Bit_Vector(0 to 3);

begin
        D0:four_bit_adder
           port map(A=>X,B=>Y,AB=>Suma,CarryOut=>CarryOut);
        D1:X<=(0,0,0,0) after 0ns,(0,1,1,1) after 5ns, (1,1,0,0) after 15ns,(0,0,0,1) after 25ns;
        D2:Y<=(1,1,1,1) after 0ns,(1,0,1,1) after 10ns,(1,0,1,0) after 20ns,(1,1,0,0) after 30ns;
end adder;

