ZAS SEGMENT
	DW 100
ZAS ENDS

DATA SEGMENT
  RIADOK STRUC
	R DW 8 DUP(?)
  RIADOK ENDS
	TAB RIADOK 20 DUP(<>)
	TEXT1 DB 'ZADAJ CISLO (1-20):$'
	TEXT2 DB 10,13,'ZADAJ MOCNINU(1-4):$'
	TEXT3 DB 10,13,'VYSLEDOK:$'
        ERRTXT DB 10,13,'Chyba.$'
	TEXT4 DB 10,13,'Vysledok >>$'
DATA ENDS

CODE SEGMENT
	ASSUME CS:CODE,DS:DATA,SS:ZAS
  NAPLN PROC
	MOV DX,OFFSET TAB
	MOV AL,1
	MOV CX,20
	MOV DI,DX
;do struktury si dam najprv cisla 1 az 20
    NAP:MOV [DI],0 ;do prveho slova dam 0
	MOV [DI+2],AL ;do druheho cislo 1-20
	INC AL
	ADD DI,16 ;posuniem sa na dalsie pole v strukture
	LOOP NAP
	MOV DI,DX ;nastavim di na zaciatok tabulky
	MOV CX,20 ;nastavim pocet opakovani
   STLP:MOV DX,0 ;nastavim dx,aby sa nepripisovali vysl z predch.nas.
	MOV AX,[DI+2] ;cislo presuniem do ax reg. a mocniny vyrabam 
	MOV BX,AX  ;opakovanym nasobenim
	ADD DI,4  ;nastavim di
	PUSH CX
	MOV CX,3
   RIAD:MUL BX  ;cisla nasobim ako slova,cize vysledok je v ax:dx
	MOV [DI],DX  ;horna cast vysledku je v slove s nepar.indexom
	MOV [DI+2],AX ;dolna cast vysl. je v slove s par.indexom
	ADD DI,4
	LOOP RIAD
	POP CX
	LOOP STLP
	RET
  NAPLN ENDP

  CITAJ PROC
	MOV DX,OFFSET TEXT1
	MOV AH,9
	INT 21H
	MOV AH,1  ;vstup 1.znaku
	INT 21H
	SUB AL,30H  ;odcitam od znaku ascii hodn '0'
	MOV CH,0
	MOV CL,AL
	MOV BH,10
  CISLO:MOV AH,1  ;vstup 2.znaku
	INT 21H
	MOV BL,AL
	SUB BL,30H
	CMP AL,13 ;ak cislo je iba 1 cif koniec
	JZ OK
	MOV AX,CX
	MUL BH
	ADD AL,BL
	ADC AH,0
	MOV CX,AX
        JMP CISLO
   OK: 
        CMP CX,20 ;osetrenie zakladu
        JA  ERROR
        CMP CX,0
        JB ERROR
	MOV DX,OFFSET TEXT2
	MOV AH,9
	INT 21H
	MOV AH,1
	INT 21H
	MOV AH,0
	SUB AL,30H
        CMP AX,4 ;osetrenie mocnitela
        JA  ERROR
        CMP AX,0 
        JB ERROR
 ;vypocet abs. adresy cisla
	MOV DX,OFFSET TAB
	MOV DI,DX
	DEC CX ;pocitanie indexov v strukture sa zacina od nuly
	PUSH AX  ;uschovam si mocnitela
	MOV AX,4
	MOV BX,4
	MUL BX ;prenasobim pocet bytov v riadku(16) zakladom
	MUL CX  
	ADD DI,AX  ;rel adresu riadku v struk.pripocitam k abs.adr.
	POP AX  ;vyberiem mocnitela
	DEC AX  ;index. sa zacina od nuly
	MOV BX,4
     	MUL BX  ;prenasobim mocnitela (1 cislo zabera 2 slova)
	ADD DI,AX  ;v di mam absol. adresu
	MOV DX,[DI]  ;v ax:dx mam vypocitane cislo
	MOV AX,[DI+2]
	RET
  CITAJ ENDP
ERROR:  MOV AH,09
        MOV DX,OFFSET ERRTXT
        INT 21H
        MOV AX,4C00h
        INT 21H
  START:MOV AX,SEG DATA
	MOV DS,AX
	CALL NAPLN
	CALL CITAJ
	PUSH DX
	PUSH AX
	MOV DX,OFFSET TEXT4
	MOV AH,9
	INT 21H
	POP AX
	POP DX
	MOV BX,10
	MOV CX,0
    VYP:DIV BX
	ADD DX,30H
	PUSH DX
	MOV DX,0
	INC CX
	CMP AX,BX
	JNB VYP
	ADD AX,30H
	MOV DL,AL
	MOV AH,2
	INT 21H
    PIS:POP DX
	INT 21H
	LOOP PIS
	MOV AH,8
	INT 21H
	MOV AX,4C00H
	INT 21H
CODE ENDS
END START