zas   segment
      assume ss:zas
      dw 64 dup(?)
zas      ends
;--------------------------
data      segment
vstup   db 80,0,80 dup(0);vstupny retazec
vx      db 13,10,'$'; je vlastne enter
vystup      db 80 dup(?),13,10,'$'
sprava  db 'zadaj retazec $'
menu   DB 'Ŀ',10,13
       DB '1   vypis retazca     ',10,13
       DB '2   male na velke     ',10,13
       DB '3   opacny vypis      ',10,13
       DB '4   triedenie         ',10,13
       DB 'Esc quit              ',10,13
       DB '',10,13,'$'
menu1  DB 'Ŀ',10,13
       DB '1   len velke pismena ',10,13
       DB '2   len male pismena  ',10,13
       DB '3   len cislice       ',10,13
       DB '4   ine znaky         ',10,13
       DB 'Esc spat              ',10,13
       DB '',10,13,'$'
data ends
;-------------------------
code      segment
      assume      cs:code

start:mov ax,seg data
      mov ds,ax
      mov es,ax
      mov ax,03h       		;vymazanie obrazovky
      int 10h
      mov ah,09h        	;vypis textu ulozeneho do sprava
      mov dx,offset sprava	;nastavi adresu sprava
      int 21h
      mov dx,offset vstup	;nastavi adresu vstupu
      mov ah,0ah        	;nacitanie retazca
      int 21h
      mov al,'$' 		;prida na koniec retazca $ aby sa retazec mohol pouzivat
      mov bl,byte ptr ds:[vstup+1]
      add bl,2   		;bl+2, bl obsahuje skutocny pocet nacitanych hodnot
      xor bh,bh
      mov di,bx
      mov si,offset vx 		;nastavi adresu vx vlstne enter
      mov cx,3
      rep movsb
      mov dl,ds:[vx]      	; dl obsahuje 13 co je carrige return
      mov ah,02h      		;vypis jedneho zanku
      int 21h
      mov dl,ds:[vx+1]		;dl obsahuje 10 co je line feed
      mov ah,02h      		;vypis jedneho znaku
      int 21h

zac:    mov ah,09h      	;vypis menu na obrazovku
      mov dx,offset menu
      int 21h
znova:  mov ah,08h      	;nacitanie jedneho znaku bez zobrazenia
      int 21h
      cmp al,'1'      		;porovnanie znaku a '1'
      loopnz dalej1      	; ak ZF=1 tak ide na navestie dalej1
      jmp vypis      		; ak ZF=0 tak ide na navestie vypis
dalej1: cmp al,'2'      	;porovnanie znaku s '2'
      loopnz dalej2      	; ak ZF=1 tak ide na dalej2
      jmp male      		; skok na male
dalej2: cmp al,'3'      	;porovnanie znaku s '3'
      loopnz dalej3      	;ak ZF=1 tak ide na dalej3
      jmp opak1      		; skok na opak1
dalej3: cmp al,'4'       	;porovananie znaku s '4'
      loopnz dalej4      	;ak ZF=1 tak ide na dalej4
      jmp usp            	;skok na usp
dalej4: cmp al,27        	;porovannie s esc
      jnz znova     		;ak ZF=1 tak ide na znova
      mov ax,4c00h              ;ak bolo nacitane ESC tak sa program konci
      int 21h
;--------------------------
vypis:mov al,'$'
      mov bl,byte ptr ds:[vstup+1];do bl ulozi skut hodnotu nacitanych cisel
      add bl,2			;prida 2 lebo retazec sa zacina len na 2 mieste
      xor bh,bh			;nuluje bh
      mov cx,bx			;cx hodnota nacitanych znakov lebo movsb pouziva kolko krat to ma zopakovat
      mov di,offset vystup	;do coho ma zapisat  retazec
      mov si,offset vstup+2	;odkial ma prepisat retazec
      rep movsb			;prepisanie retazca
      mov dx,offset vystup
      mov ah,09h		;vypise re4tazec na obrazovku
      int 21h
      jmp zac			;skoci na navestie zac teda zaciatok
male: mov si,offset vstup+2	;do si adresa prveho znaku
      mov di,offset vstup+1	;do di adresa skut. nac.znakov
      mov bx,[di]		; do bx hodnota skut. nac. znakov
      xor bh,bh			;nuluje bh
      add bx,si			; prida bx si
      inc bx      		;zvacsuje hodnotu bx
male1: mov dl,ds:[si] 		; do dl nastavi n-ty karakter
      inc si      		; zvacsuje si o 1
      cmp si,bx			; porovnava ci nie je koniec nacitaneho retazca
      loopz vypisend		; ak ZF=0 ide na navestie vypisend
      cmp dl,'a'		; porovnanie
      jl vypis1 		;ak dl je menej ako 'a'ide na navestie vypis1
      cmp dl,'z'		; porovnanie
      jg vypis1			;ak dl je viac ako 'z' ide tiez na navestie vypis1
      sub dl,20h		;urobi rozdiel teda dl=dl-20h
vypis1:
      mov ah,02h 		; vypis znaku na obrazovku
      int 21h
      jmp male1 		;skok na male1
vypisend:
      mov dl,ds:[vx]  		; do dl adresa vx
      mov ah,02h      		;vypise 13 teda cr
      int 21h            
      mov dl,ds:[vx+1]		;do dl adresa vx+1
      mov ah,02h      		;vypise 10 teda lf
      int 21h            
      jmp zac            	; skok na zac  zaciatok
opak1:
      mov si,offset vx-1	;nastavi sa na koniec retazca
      xor cl,cl      		;nuluje cl
opak:      mov dl,ds:[si]      	;do dl posledny znak
      dec si            	;zmensuje si
      cmp dl,0      		;porovnava ci znak je 0
      loopz opak          	;ak ZF=0  tak ide na opak
      cmp dl,13      		;porovnava ci nie je 13 teda cr
      loopz opak       		;ak ZF=0 tak ide na opak
      cmp dl,10      		;porovnava ci nie je 10 teda lf
      loopz opak       		;ak ZF=0 tak ide na opak
      cmp cl,1      		;porovnava cl 1 vtom pripade sa uz objavil $
      loopz opak2      		;ak ZF=0 ide na opak2
      cmp dl,'$'      		;porovnava ci znak je $
      loopnz opak2      		;ak ZF=1 ide na opak2
      mov cl,1       		;da do cl 1
      jmp opak      		;skok na opak
opak2:      mov ah,02h      	;zobrazi znak
      int 21h
      cmp si,offset vstup+1	;porovna ci este je nejaki znak
      loopnz opak       	;ak ZF=1 ide na opak
      mov dl,ds:[vx]     	;do dl adresa vx
      mov ah,02h      		;vypise 13 teda cr
      int 21h
      mov dl,ds:[vx+1]		;do dl adresa vx+1
      mov ah,02h      		;vypise 10 teda lf
      int 21h
      jmp zac      		; skok na zaciatok
usp:      mov dx,offset menu1	;do dx adfresa menu
      mov ah,09h     		;vypise menu
      int 21h
usp1:      mov ah,08h      	;nacita znak z klavesnice bez zobrazenia
      int 21h
      cmp al,27      		;porovna ci nebolo esc
      loopnz mnu11      		;ak ZF=1 tak ide na mnu11
      jmp zac            	;inak na zac zaciatok
mnu11:  cmp al,'1'      	;porovnava ci vstupny znak je 1
      loopnz mnu12      		;ak ZF=1 tak ide na mnu12
      jmp velke      		;skok na velke
mnu12:      cmp al,'2'      	;porovnanie ci znak je 2
      loopnz mnu13      		;ak ZF=1tak ide na mnu13
      jmp maleusp      		;skok maleusp
mnu13:      cmp al,'3'      	;porovnanie ci znak nie je3
      loopnz mnu14      		;ak ZF=1 tak ide na mnu14
      jmp cisla      		;skok na cisla
mnu14:      cmp al,'4'      	;porovnanie ci znak nie je 4
      loopnz usp1      		;skok na usp1
      jmp ine            	;skok na ine
velke:
      mov si,offset vstup+2	; do si adresa prveho znaku
      mov di,offset vstup+1	; adresa pocetu skutocne nacitanych znakov
      mov bx,[di]      		;obsah di do bx
      xor bh,bh      		;nulovanie bh
      add bx,si      		; prida k bx,si
      inc bx            	;zvacsuje bx o 1
velke1:      mov dl,[si]      	;da do dl n-ty znak kde n je 1,2...b[x]
      inc si            	;zvacsuje si o 1
      cmp si,bx      		; porovnava ci nie je koniec retazca
      loopz velkeend      		;ak ZF=1 ide na velkeend
      cmp dl,'A'      		;porovnanie s 'A'
      jl velke1      		;ak znak ma ascii mensie tak ide na velke1
      cmp dl,'Z'     		;porovannie s 'Z'
      jg velke1      		;ak znak ma ascii vacsie tak ide na velke1
      mov ah,02h      		;vypise znak
      int 21h
      jmp velke1      		;skok na velke1
velkeend:
      mov dl,ds:[vx] 		;do dl adresu vx
      mov ah,02h      		;vypise 13 teda cr
      int 21h
      mov dl,ds:[vx+1]		;do dl adresa vx+1
      mov ah,02h      		;vypise 10 teda lf
      int 21h
      jmp usp            	;skok na usp usporiadanie
maleusp:
      mov si,offset vstup+2	;do si adresa prveho znaku
      mov di,offset vstup+1	;do di adresa skut. nac. znakov
      mov bx,[di]		;do bx hodnotu skutocne nacitanych znakov
      xor bh,bh			;nuluje bh
      add bx,si			;prida bx si
      inc bx			;zvacsi bx
maleusp1:
      mov dl,[si]      		;do dl n-ty znak kde n=1,2....[bx]
      inc si            	;zvacsuje si
      cmp si,bx      		;porovnava ci nie je koniec retazca
      loopz maleuspend      	;ak ZF=1 maleuspend
      cmp dl,'a'      		;porovnava s 'a'
      jl maleusp1      		;ak mensie tak maleusp1
      cmp dl,'z'      		;porovnava s 'z'
      jg maleusp1     		;ak vacsie tak maleusp1
      mov ah,02h      ;vypis znaku
      int 21h
      jmp maleusp1      ;skok na maleusp1
maleuspend:
      mov dl,ds:[vx]      ;do dl 13 teda cr
      mov ah,02h      ;vypis znaku
      int 21h            ;
      mov dl,ds:[vx+1];do dl 10 tedalf
      mov ah,02h      ;vypis znaku
      int 21h            ;
      jmp usp            ;skok na usp
cisla:
      mov si,offset vstup+2;do si adresa prveho znaku
      mov di,offset vstup+1;do di adresa skutocne nacitanych znakov
      mov bx,[di]      ;do bx hodnota skut. nac. znakov
      xor bh,bh      ;nuluje sa bh
      add bx,si      ;prida sa bx si
      inc bx            ;zvacsuje sa bx
cisla1:
      mov dl,[si]      ;do dl n-ty znak kde n=1,2...[bx]
      inc si            ;zvacsuje sa si
      cmp si,bx      ;porovnava ci nie je koniec retazca
      loopz cislaend      ;ak ZF=1 tak ide na cislaend
      cmp dl,'0'      ;porovnava s '0'
      jl cisla1      ;ak menej ide na cisla1
      cmp dl,'9'      ;porovnava s '9'
      jg cisla1      ;ak viac ide na cisla1
      mov ah,02h      ;vypis znaku na obrazovku
      int 21h
      jmp cisla1      ;skok na cisla1
cislaend:
      mov dl,ds:[vx]      ;do dl adresa vx
      mov ah,02h      ;vypis 13 teda cr
      int 21h
      mov dl,ds:[vx+1];do dl adresa vx+1
      mov ah,02h      ;vypis 10 teda lf
      int 21h
      jmp usp            ;skok na usp
ine:
      mov si,offset vstup+2;do si adresa prveho znaku
      mov di,offset vstup+1;do di adresa skut. nac. znakov
      mov bx,[di]; do bx hodnota skut. nac. znakov
      xor bh,bh      ;nuluje bh
      add bx,si      ;prida bx,si
      inc bx            ;zvacsuje hodnotu bx o 1
ine1:
      mov dl,[si]      ;do dl n-ty znak kde n=1,2....[bx]
      inc si            ;zvacsuje si o 1
      cmp si,bx      ;porovnava ci nie koniec retazca
      loopz ineend      ;ak ZF=1 ide na ineend
      cmp dl,'0'      ;porovnava s '0'
      jl vypisine      ;ak menej tak ide na vypisine
      cmp dl,'9'      ;porovnava s '9'
      jng ine1      ;ak viac alebo = tak ide na ine1
      cmp dl,'A'      ;porovnava s 'A'
      jl vypisine      ;ak menej tak ide na vypisine
      cmp dl,'Z'      ;porovnava s 'Z'
      jng ine1      ;ak viac alebo = tak na ine1
      cmp dl,'a'      ;porovnava s 'a'
      jl vypisine      ;ak menej tak na vypisine
      cmp dl,'z'      ;porovnava s 'z'
      jng ine1      ;ak viac alebo = tak ide na ine1
vypisine:
      mov ah,02h;vypis znaku na obrazovku
      int 21h
      jmp ine1;skok na ine1
ineend:
      mov dl,ds:[vx];do dl adresa vx
      mov ah,02h;vypis 13teda cr
      int 21h
      mov dl,ds:[vx+1];do dl adresa vx+1
      mov ah,02h;vypis 10 teda lf
      int 21h
      jmp usp      ;skok na usp
code       ends      ;koniec code segmentu
      end start