;Zadanie c.3

;S vyuzitm  retazcovch  intrukci  (vade   kde  je  to  mozn) vytvorte program, ktor:
;a) nacta z  klvesnice dva  retazce do  dvoch rznych segmentov
;    (minimlne dlzky 20 Byte),
;c) zisti ci su  retazce rovnake
;d) zist,  ci  sa  v  niektorom   z  retazcov  nachdza zo
;   vstupu zadan podretazec.

;Autor: Tibor Szabo 
;Kruzok: Info b-13


ZAS	SEGMENT	STACK
	DW	400H DUP (?)
ZAS	ENDS

DATA1	SEGMENT
	MENU	DB	10,13,'MENU:',10,13,10,13
		DB	'< 1 > Nacitanie retazcov ',10,13
		DB	'< 2 > Porovnavanie retazcov ',10,13
		DB	'< 3 > Hladanie podretazca ',10,13
		DB	'< 4 > Koniec ',10,13,10,13
		DB	'Tvoja volba: $'
	ROVNE	DB	'Zadane retazce su totozne.$'
	CHYBA1	DB	'Retazce sa nerovnaju!$'
	CHYBA2	DB	'Podretazec v prvom retazci nie je ! $'
	CHYBA3	DB	'Podretazec v druhom retazci nie je !$'
	EXIST1	DB	'1 retazec obsahuje podretazec. $',10,13
	EXIST2	DB	'2 retazec obsahuje podretazec. $',10,13
	ZADAJ1	DB	10,13,'Zadaj 1 retazec: $'
	STR1	DB	40 
		DB	0
		DB	40 DUP (?)
DATA1	ENDS

DATA2	SEGMENT					
	ZADAJ2	DB	10,13,'Zadaj 2 retazec: $'
	STR2	DB	40
		DB	0
		DB	40 DUP (?)
	ZADAJ3	DB	'Zadaj hladany podretazec: $'
	STR3	DB	40
		DB	0
		DB	40 DUP (?)
DATA2	ENDS	

CODE	SEGMENT
	ASSUME CS:CODE, SS:ZAS, DS:DATA1, ES:DATA2   

START:	CALL VYMAZ		;vymazanie obrazovky
	MOV AX,SEG DATA1	;nastavenie segmentu
        MOV DS,AX		;
 	MOV DX,OFFSET MENU	;do DX sa da retazec
	CALL RETPIS		;vypis retazca

CYK:	MOV AH,08H		;z klavesnice zadam volbu z menu
	INT 21H			;volanie sluzby DOS-u
	CMP AL,31H		;porovnava s cislami
	JE MEDZI1		;	
	CMP AL,32H		;a ak sa rovna, skoci
	JE MEDZI2		;
	CMP AL,33H		;
	JE MEDZI3		;	
	CMP AL,34H		;
	JE KONEC		;
	JMP CYK			;skok na novu volbu

MEDZI1: CALL VYMAZ		;volanie procedur
	CALL NACITAJ		;
	JMP START		;skok do menu
MEDZI2: CALL NOVY_RIADOK	;volanie procedur
	CALL POROVNANIE		;
	CALL CAKAJ		;
	JMP START		;skok do menu	
MEDZI3: CALL VYMAZ		;volanie procedur
	CALL HLADAJ		;
	CALL CAKAJ		;
	JMP START		;skok do menu
KONEC:	CALL VYMAZ		;volanie procedury
	MOV AH,004CH		;koniec
	INT 21H			;volanie sluzby DOS-u

;*** caka na stlacenie klavesy ***
CAKAJ	PROC NEAR
	PUSH AX			;ulozenie AX do stacku
	MOV AH,01H		;z klavesnice zadam volbu z menu
	INT 21H			;volanie sluzby DOS-u
	POP AX			;vybratie zo stacku
	RET			;navrat z procedury
CAKAJ ENDP			;koniec procedury

;*** skoci na novy riadok ***
NOVY_RIADOK  PROC NEAR		;definovanie proc
	PUSH AX			;ulozenie AX do stacku
	PUSH DX			;ulozenie DX do stacku
	MOV AH,02H		;do AH ide zac. riadku
	MOV DL,0DH		;do DL ide enter
	INT 21H			;volanie sluzby DOS-u
	MOV AH,02H		;do AH ide zac. riadku
	MOV DL,0AH		;do DL ide enter
	INT 21H			;volanie sluzby DOS-u
	POP DX			;vybratie DX zo stacku
	POP AX			;vybratie AX zo stacku
	RET			;navrat z procedury
NOVY_RIADOK Endp		;koniec procedury

;*** vymaze obrazovku ***
VYMAZ	PROC NEAR
	PUSH AX			;ulozenie AX do stacku
	MOV AX,03H		;vymazanie obrazovky
	INT 10H			;volanie sluzby DOS-u 
	POP AX			;vybratie AX zo stacku
	RET			;navrat z procedury
VYMAZ ENDP			;koniec procedury

;*** vypis retazca ***
RETPIS  PROC NEAR		;procedura 
        PUSH AX			;ulozenie reg. AX
        MOV AH,9               	;ocakava pripravenost dat na DS:DX
        INT 21H			;volanie sluzby DOS-u
        POP AX			;vyber reg. AX zo stacku
        RET			;navrat
RETPIS	ENDP		        ;koniec procedury	

;*** nacitanie retazcov ***
NACITAJ	PROC NEAR
	MOV AX,SEG DATA1	;nastavenie adresy textu
        MOV DS,AX		;
 	MOV DX,OFFSET ZADAJ1	;
	CALL RETPIS		;vypis textu
	MOV DX,OFFSET STR1	;nastavenie adresy textu
	MOV AH,0AH		;nacitanie
  	INT 21H			;
	CALL NOVY_RIADOK	;skok do noveho riadku
	MOV AX,SEG DATA2	;nastavenie adresy textu
        MOV DS,AX		;
 	MOV DX,OFFSET ZADAJ2	;
	CALL RETPIS		;vypis retazca
 	MOV DX,OFFSET STR2	;nastavenie adresy textu
	MOV AH,0AH		;nacitanie	
	INT 21H			;
	RET			;navrat
NACITAJ	ENDP			;koniec procedury

;*** porovnanie retazcov ***
POROVNANIE PROC NEAR			
	XOR CX,CX		;nulovanie
	MOV AX,SEG DATA1	;nastavenie adresy textu
        MOV DS,AX		;
	MOV SI,OFFSET STR1	;nastavenie zaciatku retazca	
	MOV AX,SEG DATA2	;nastavenie adresy textu
        MOV ES,AX		;
	MOV DI,OFFSET STR2	;nastavenie zaciatku retazca	
	MOV CL,[DS:SI+1]	;nastavenie poctu znakov
	ADD CX,2		;posun na dalsi znak
	CLD			;clear direction flag, si a di sa budu ++
REPE	CMPSB			;porovnavanie
	JNE ROZNE		;skok
	CALL NOVY_RIADOK	;skok do noveho riadku
	MOV AX,SEG DATA1	;nastavenie adresy textu
        MOV DS,AX		;
 	MOV DX,OFFSET ROVNE	;
	CALL RETPIS		;vypis textu
	JMP END2		;skok
ROZNE:	CALL NOVY_RIADOK	;skok do noveho riadku
	MOV AX,SEG DATA1	;nastavenie adresy textu 
        MOV DS,AX		;
	MOV DX,OFFSET CHYBA1	;
	CALL RETPIS		;vypis chyby
END2:	RET			;navrat z procedury
POROVNANIE ENDP			;koniec procedury

;*** vyhladanie podretazca ***
HLADAJ  PROC NEAR
	CALL NOVY_RIADOK	;skok do noveho riadku
	MOV AX,SEG DATA2	;nastavenie adresy textu
        MOV DS,AX		;
 	MOV DX,OFFSET ZADAJ3	;
	CALL RETPIS		;vypis retazca
 	MOV DX,OFFSET STR3	;nastavenie adresy textu
	MOV AH,0AH		;nacitanie	
	INT 21H			;
	MOV AX,SEG DATA2        ;nastavenie adresy textu
	MOV DS,AX               ;
	MOV SI,OFFSET STR3      ;nastavenie podretazca do SI
	MOV AX,SEG DATA1        ;nastavenie adresy textu
	MOV ES,AX               ;                
	MOV DI,OFFSET STR1      ;nastavenie retazca do ES             
	XOR CX,CX		;nulovanie
	XOR BX,BX		;
	MOV BL,[DS:SI+1]	;nastavenie dlzky podretazca
	MOV CL,[ES:DI+1]	;nastavenie dlzky retazca
	PUSH DI			;ulozenie DI				
	ADD DI,2		;nastavenie na zaciatky retazcov	
	ADD SI,2		;             
	MOV AL,[DS:SI]		;prvy znakpodret. ide do AL
OPAK3:	CLD			;clear direction flag
REPNE	SCASB			;hladanie prveho pismena
	JE DALEJ3		;ak nenaslo
     	MOV AX,0		;nastavenie na 0
     	JMP KON3                ;skok
DALEJ3: INC CX                  ;posun
     	CMP CX,BX		;je zvysok retazca kratsi ako dlzka podretazca
     	DEC CX			;posun
     	JNL ODCIT		;skok
     	MOV AX,0		;nastavenie na 0
     	JMP KON3		;skok
ODCIT:	DEC DI			;posun			
     	MOV DX,CX		;nastavenie retazcov
     	MOV CX,BX		;	
REPE	CMPSB			;porovnanie retazcov
     	JE CITA			;skok, ak su rovnake
     	MOV SI,OFFSET STR3      ;nastavenie zaciatku podretazca
     	ADD SI,2		;posun na zaciatok
     	XOR CX,CX		;nulovanie
     	MOV CL,[ES:DI+1]	;pocet znakov retazca	
     	ADD DI,CX		;posun na zaciatok		
     	SUB DI,DX		;odcitanie
     	ADD DI,2		;posun
     	MOV CX,DX		;nastavenie
     	JMP OPAK3		;skok	
CITA:	MOV AX,1		;nastavenie na 1		
KON3:  	POP BX			;vybratie zo stacku
     	CMP AX,1		;porovnanie
     	JZ EXIS			;skok
     	JMP NEEXIS		;	
EXIS:	CALL NOVY_RIADOK	;skok do noveho riadku
	CALL NOVY_RIADOK	;skok do noveho riadku
     	MOV AX,SEG DATA1 	;nastavenie adresy ret.
     	MOV DS,AX               ;
     	MOV DX,OFFSET EXIST1	;
	CALL RETPIS     	;vypis retazca
     	JMP DRUHY		;skok
NEEXIS:	CALL NOVY_RIADOK	;skok do noveho riadku
     	CALL NOVY_RIADOK	;skok do noveho riadku
     	MOV AX,SEG DATA1	;nastavenie adresy ret.
     	MOV DS,AX		;
     	MOV DX,OFFSET CHYBA2	;
     	CALL RETPIS     	;vypis retazca

DRUHY:	XOR DX,DX		;nulovanie
	MOV AX,SEG DATA2        ;nastavenie adresy textu
	MOV DS,AX               ;
	MOV SI,OFFSET STR3      ;nastavenie podretazca do SI
	MOV AX,SEG DATA2        ;nastavenie adresy textu
	MOV ES,AX               ;                
	MOV DI,OFFSET STR2      ;nastavenie retazca do ES             
	XOR CX,CX		;nulovanie
	XOR BX,BX		;
	XOR AX,AX		;
	MOV BL,[DS:SI+1]	;nastavenie dlzky podretazca
	MOV CL,[ES:DI+1]	;nastavenie dlzky retazca
	PUSH DI			;ulozenie DI				
	ADD DI,2		;nastavenie na zaciatky retazcov	
	ADD SI,2		;             
	MOV AL,[DS:SI]		;prvy znak podretazca ide do AL
OPAK33:	CLD			;clear direction flag
REPNE	SCASB			;hladanie prveho pismena
	JE DALEJ33		;ak nenaslo
     	MOV AX,0		;nastavenie na 0
     	JMP KON33               ;skok
DALEJ33: 
	INC CX                  ;posun
     	CMP CX,BX		;je zvysok retazca kratsi ako dlzka podretazca
     	DEC CX			;posun
     	JNL ODCIT1		;skok
     	MOV AX,0		;nastavenie na 0
     	JMP KON33		;skok
ODCIT1:	DEC DI			;posun			
     	MOV DX,CX		;nastavenie retazcov
     	MOV CX,BX		;	
REPE	CMPSB			;porovnanie retazcov
     	JE CITA1		;skok, ak su rovnake
     	MOV SI,OFFSET STR3      ;nastavenie zaciatku podretazca
     	ADD SI,2		;posun na zaciatok
     	XOR CX,CX		;nulovanie
     	MOV CL,[ES:DI+1]	;pocet znakov retazca	
     	ADD DI,CX		;posun na zaciatok		
     	SUB DI,DX		;odcitanie
     	ADD DI,2		;posun
     	MOV CX,DX		;nastavenie
     	JMP OPAK33		;skok	
CITA1:	MOV AX,1		;nastavenie na 1		
KON33: 	POP BX			;vybratie zo stacku
     	CMP AX,1		;porovnanie
     	JZ EXIS1		;skok
     	JMP NEEXIS1		;	
EXIS1:	CALL NOVY_RIADOK	;skok do noveho riadku
     	MOV AX,SEG DATA1 	;nastavenie adresy ret.
     	MOV DS,AX               ;
     	MOV DX,OFFSET EXIST2	;
	CALL RETPIS     	;vypis retazca
     	JMP END3		;skok
NEEXIS1:
	CALL NOVY_RIADOK	;skok do noveho riadku
     	MOV AX,SEG DATA1	;nastavenie adresy ret.
     	MOV DS,AX		;
     	MOV DX,OFFSET CHYBA3	;
     	CALL RETPIS     	;vypis retazca
END3:	RET			;navrat z podretazca
HLADAJ  ENDP			;koniec procedury

CODE	ENDS			;koniec kodoveho segmentu
	END	START		;koniec, konec, vege, ende, end, fine, fin, koheu !!!