; Zadanie c.1
; Autor: Mario TRUBACIK,INFb 21 - b13 
; Termin odovzdania: 24.10.2000

ZAS	SEGMENT	STACK
	db	100h DUP(?)
ZAS	ENDS

DATA	SEGMENT	
TXTR	db	'Zadaj retazec znakov:  $'
TXTMenu	db	10,13,10,13
	db	' 1.  Vypis retazca znakov na obrazovku',10,13
	db	' 2.  Vypis miesta prveho vyskytu znaku',10,13
	db	' 3.  Vypis retazca v obratenom poradi',10,13
	db	' 4.  Vypis poctu cislic v retazci',10,13
	db	' 5.  Male pismena skonvertuje na velke',10,13
	db	' 6.  Velke pismena skonvertuje na male',10,13
	db	' 7.  EXIT',10,13,10,13,'$'
None	db	'Znak sa v retazci nenachadza .$'
TXTz	db	'Zadaj hladany znak: $'
TXTz1	db	' Hladany znak sa nachadza na pozicii: $'
Tpoc	db	'Pocet cislic v retazci je: $'
Clr	db	13,79 DUP(20h),13,'$'
Text	db	100h DUP(0)
Dlzka	db	0							       	

DATA	ENDS

CODE	SEGMENT
	ASSUME	CS:CODE,DS:DATA,SS:ZAS

START:	
	mov	dx,SEG DATA		;nastavenie ds na segment DATA	
	mov	ds,dx			;
	mov	dx,offset TXTR		;nastavenie relativnej adresy do dx
	mov	ah,09h			;vypis retazca TXTR
	int	21h			;volanie sluzby DOSu
	call	readret			;
	call 	menu
HLoop:				
opakuj:	mov	ah,08h            	;vstup bez echa -vyber z menu
	int	21h             	
	cmp	al,31h          	;porovnava vstup s ASCII kodom klavesy 1
	jz	z1			;skoci na navesti z1 ak je ZF=1
	cmp	al,32h          	;porovnava vstup s ASCII kodom klavesy 2
	jz	z2			;skoci na navestie z2 ak je ZF=1
	cmp	al,33h  	        ;analogicky ako hore
	jz	z3			;
	cmp	al,34h          	;
	jz	z4			;
	cmp	al,35h          	;
	jz	z5			;
	cmp	al,36h          	;
	jz	z6			;
	cmp	al,37h          	;ak je vstup 7 skoc na EXIT
	jz	EXIT			;
	jmp	opakuj                  ;
                                        ;
z1:	call	fcia1			;navestie z1, volanie fcie1
	jmp	HLoop			;navrat fcie1 na Hloop (Hlavna slucka)
z2:	call	fcia2			;navestie z2, volanie fcie2
	jmp	HLoop			;
z3:	call	fcia3			;analogicky ostatne 
	jmp	HLoop			;
z4:	call	fcia4			;
	jmp	HLoop			;
z5:	call	fcia5			;
	jmp	HLoop			;
z6:	call	fcia6			;
	jmp	HLoop			;po skonceni fcie6(ret), skok na Hloop
                                        ;
EXIT:					;
	mov	ah,4ch	          	;exit z programu
	int	21h     	        


menu	PROC				;hlavne menu
	mov	dx,offset TXTmenu		
	mov	ah,09h			;vypis mojho menu TXTmenu
	int	21h			;zavolanie sluzby DOSu
	ret				
menu	ENDP				

Cls	PROC				;fcia na vymazanie riadku
        mov     dx,offset Clr		;
        mov     ah,09h			;vypis textu Clr
        int     21h
	ret				;navrat z procedury
Cls	ENDP

readret	PROC				;fcia na citanie retazca z klavesnice
	mov	di,0h			;vynulovanie data index
	mov	cx,100			;pocitadlo nastavene na max znakov
read1:	mov	ah,01h			;nacita z klavesnice znak s echom
	int	21h			;
	cmp	al,13			;porovnaj znak s enterom
	jz	read2			;skok na navestie read2
	mov	Text[di],al		;na di-tu poziciu ulozi znak
	inc	di			;inkrementacia di
	loop	read1			;dekrementacia cx a ak cx<>0 skok na read1
read2:	mov	al,'$'			;do al priradi ukoncovaci znak
	mov	Text[di],al		;do Text prilep na koniec ukoncovaci znak $
	mov	ax,di			;do ax uloz index(pocet) prvku
	mov	Dlzka,al		;do Dlzka uloz al			
	ret				;
readret	ENDP				

Printc  PROC                            ;fcia Printc vypis cisiel 0 az 99
        mov     dl,10                   ;delitel je 10
        div     dl                      ;delenie do al ulozi podiel  al/dl
        cmp     al,0                    ;vysledok porovna s nulou(podiel)
        jz      Prnc                    ;ak cislo je <10, : 0 + zv. skoc na Prnc
        add     al,30h                  ;uprava na ascii kod cislice
        mov     dx,ax                   ;dl vstupny register sluzby 02 (v dh sa uschova zvysok)
        mov     ah,02h                  ;sluzba 02 - vypis znaku
        int     21h                     ;volanie DOS sluzby
        mov     ax,dx                   ;vratenie hodnoty dx do ax
Prnc:   mov     al,ah                   ;ah je zvysok po deleni
        add     al,30h                  ;pripocita do al 30h kod nuly
        mov     dl,al                   ;dl vstupny reg pre sluzbu 02h
        mov     ah,02h                  ;02h sluzba vypisujuca znak
        int     21h                     ;
        ret                             ;navrat z podprogramu
Printc  ENDP                            ;

fcia1	PROC				;fcia vypisujuca retazec na vystupne zariadenie
	call	Cls			;fcia vymazanie riadku
	mov	dx,offset Text		;nastavenie relativnej adresy Text do dx
	mov 	ah,09h			;vypis Text
	int	21h			;volanie sluzby DOSu
	ret				;navrat z fcie
fcia1   ENDP

fcia2	PROC				;vypis vyskytu prveho miesta zadaneho znaku
        call    Cls			;
	mov	dx,offset TXTz		;nastavenie relativnej adresy do dx
	mov	ah,09h			;vypis retazca
	int	21h			;
	mov	ah,01h			;vstup znaku z klavesnice
	int	21h			;
	mov	bl,al			;do bl ulozi znak (z klavesnice)
	xor	di,di			;vymazanie indexoveho registra
	mov	cl,Dlzka		;do cl ulozi dlzku retazca
	xor	ch,ch			;vynulovanie ch loop dekrementuje cx
fcia2l:	mov	al,Text[di]		;do al ulozi di-ty znak retazca
	cmp	al,bl			;porovna ho s hladanym znakom 
	jnz	fcia2i			;
        mov     dx,offset TXTz1		;	
	mov	ah,09h			;vypis textu TXTz1
	int	21h			;
	mov	ax,di			;do ax priradi pozicia znaku
	inc	ax			;inkrementuj ax, lebo pozicia je od 0
	call	Printc			;vypis cisla
	ret				;
fcia2i:	inc	di			;inkrementuj di nastavenie sa na dalsi znak
	loop	fcia2l			;a vrati sa do f2l
	mov	dx,offset None		;ak sa cx=0 tak loop konci a
	mov	ah,09h			;vypise sa NONE
	int	21h			;
	ret				;
fcia2	ENDP				;


fcia3	PROC				;fcia vypisujuca retazec v obratenom poradi
	call	Cls			;vymazanie riadku
	mov	cl,Dlzka		;do cl nastav dlzku retazca
	xor	ch,ch			;vynulovanie ch
	mov	di,cx			;do di vloz dlzku
	dec	di			;dekrementuj di , posledny znak je ukoncovaci dollar
f3:	mov	dl,Text[di]		;do dl nacitame znak na di-tej pozicii
	dec	di			;dekrementuj di
	mov	ah,02h			;posle znak v DL na standardny vystup
	int	21h			;
	loop	f3			;opakuj dokial nie je cx=0
	ret				;
fcia3	ENDP				;

fcia4	PROC				;vypise pocet cislic v retazci
        call    Cls			;vymaz riadok
	mov	cl,Dlzka		;do cl nastav dlzku retazca
	xor	ch,ch			;vynulovanie registrov
	xor	di,di			;	
	xor	bl,bl			;
fcia4l:	mov	al,Text[di]		;do al nacitaj nulty znak
	inc	di			;inkrementuj di
	cmp	al,'0'			;porovnaj ho s ASCII kodom  nuly
	jl	fcia4c			;ak je mensi skok na fcia4c
	cmp	al,'9'			;
	jg	fcia4c			;
	inc	bl			;ak je kod >='0' a <='9' inkrementuj bl
fcia4c:	loop	fcia4l			;slucka ak cx<>0 , cx je dlzka retazca
	mov	dx,offset TPoc		;
	mov	ah,09h			;vypisanie Tpoc
	int	21h			;
	xor 	ah,ah			;vynulovanie ah, fcia Printc pouziva div
	mov	al,bl			;v al je bl pocet cisel
	call	Printc			;vypis tohto poctu
	ret				;koniec podprogramu
fcia4	ENDP				;
		
fcia5	PROC				;konverzia malych na velke
        call    Cls			;vymazanie riadku
	mov	cl,Dlzka		;do cl nastav dlzku retazca	
	xor	ch,ch			;vynulovanie registrov ch , di
	xor	di,di			;
fcia5l:	mov	al,Text[di]		;do al uloz nulty znak retazca
	cmp	al,'a'			;porovnaj ho s ASCII kodom 'a'
	jl	fcia5i			;ak je kod di-teho znaku mensi ako kod a skok na fcia5i
	cmp	al,'z'			;alebo porovnaj ho s ASCII kodom 'z'
	jg	fcia5i			;ak je kod di-teho znaku vacsi ako kod z skok ns fcia5i
	sub	al,20h			;20h je rozdiel medzi kodom 'a' a 'A' , od al odcitaj 20h
	mov	Text[di],al		;do Text uloz uz konverzovane al
fcia5i:	inc	di			;
	loop	fcia5l			;
	mov	dx,offset Text          ;
	mov 	ah,09h                  ;vypis retazca Text
	int	21h	                ;
	ret				;
fcia5	ENDP				;
					
fcia6	PROC				;konverzia velkych na male
        call    Cls			;
	mov	cl,Dlzka		;do cl nastav dlzku retazca	
	xor	ch,ch			;vynulovanie registrov
	xor 	di,di			;
fcia6l:	mov	al,Text[di]		;
	cmp	al,'A'			;
	jl	fcia6i			;
	cmp	al,'Z'			;
	jg	fcia6i			;
	add	al,20h			;do al pripocitaj hodnotu 20h
	mov	Text[di],al		;
fcia6i:	inc	di			;
	loop	fcia6l			;
	mov	dx,offset Text		;vypis konvertovaneho textu Text
	mov 	ah,09h                  ;
	int	21h                     ;
	ret				;
fcia6	ENDP				;


CODE	ENDS				;koniec segmentu CODE
	END	START			;