;program vypise retazec znakov
;!!! COM subor >>> tlink /t nazov.obj

CODE	SEGMENT
.MODEL  TINY

ASSUME	CS:CODE, DS:code, es: code, ss:code

JUMPS

org 100h

START:	
        MOV AX, 03H		;vymazanie obrazovky cez sluzbu 10H
	INT 10H

	LEA DX, TEXTZ		;do DX vlozi retazec v dat. segmente
	MOV AH, 09H		;funkcia write string
	INT 21H			;volanie sluzby MS-DOSu

	MOV AH, 0AH             ; Funkcia nacita text do BUFFERU
	LEA DX, TEXT             ; DX => OFFSET TEXT
	INT 21H

        XOR AX,AX		;vynulovanie ax
	LEA SI, TEXT		;do DX vloz posunutie retazca v dat. segmente
	MOV AL,CS:[SI+1]        ;do AL vlozi CS:[SI+1]
	ADD SI,AX               ;do SI prida AX
	INC SI                  ;inkrementuje SI
	MOV CL,24H		;do CL da znak '$'
	MOV CS:[SI+1],CL        ;premiestni do CS:[SI+1],CL

MENU:
        MOV AX, 03H		;vymazenie obrazovky cez sluzbu 10H
	INT 10H

	LEA DX, TEXT1           ;do DX priradi OFFSET TEXT1
	MOV AH, 09H             ;inicializacia sluzby vypisu OFFSETu na monitor cez 21H
	INT 21H
	
OPAKUJ:	XOR AH,AH		;vynulovanie AH
	INT 16H			;sluzba na citanie znakov z klavesnice

 	MOV DL, AL		;do DL da AL
        CMP AL, 31H             ;porovnava stlacenu klavesu z hodnotami
	JE  JEDNA               ;podla menu, porovnava s cislami od 1 po 6
	CMP AL, 32H             ; a ESC klaves
	JE  DVA
	CMP AL, 33H
	JE  TRI                 ;ak sa rovna znaku 33H skoc na TRI
	CMP AL, 34H
	JE  STYRI
	CMP AL, 35H
	JE  PAT
	CMP AL, 36H
	JE  SEST
	CMP AL, 01BH
        JE KONIEC
        JMP OPAKUJ             ;ak sa nerovna ani jeden znak tak skoc na OPAKUJ

KONIEC:	MOV AX, 4C00H		;volanie sluzby MS-DOSu
	INT 21H                 ;ukoncenie programu

JEDNA:                          ;vypis znakov na obrazovku
	LEA SI, STRING		;do DX vloz posunutie retazca v dat. segmente
        XOR CX, CX
	MOV CL, [POCET]
       
OP:     MOV DL,[si]
	mov ah, 02h
	int 21h
	inc si
        loop OP

;	ADD DX,2                ;posun DX o 2
;	MOV AH, 09H		;funkcia write string
;	INT 21H			;volanie sluzby MS-DOSu

	CALL WAITKEY            ;volaj proceduru WAITKEY
        JMP MENU                ;skoc do MENU

DVA:  	                        ;vypise poradove cislo miesta
	LEA DX, TEXT9		;do DX vlozi retazec v dat. segmente
	MOV AH, 09H		;funkcia write string
	INT 21H			;volanie sluzby MS-DOSu

;       LEA DX, RTG             ; DX => OFFSET TEXT
	MOV AH, 01H             ; Funkcia nacita text do BUFFERU
	INT 21H
	MOV DL, AL

	XOR AH, AH
        LEA SI,TEXT             ;do SI priradi OFFSET TEXT
        XOR CH,CH               ;vynuluje CH
        MOV CL,CS:[SI+1]        ; CL = POCET ZNAKOV
        ADD SI,2                ;posunutie o 2 miesta

POM:    MOV AL,CS:[SI]           ;do AL vlozi retazec
        CMP AL, DL              ;porovnanie ci tam je 0 
	JE  HOPP

	INC SI
	INC AH
	LOOP POM
	JMP NENASIEL
HOPP:   
        MOV AL, AH
;	CMP AL, 0
;	JE NENASIEL
	INC AL
	
	PUSH AX 
	LEA DX, TEXT10		;do DX vlozi retazec v dat. segmente
	MOV AH, 09H		;funkcia write string
	INT 21H			;volanie sluzby MS-DOSu
	POP AX

	CALL VYPISCISLO         ;volanie VYPISCISLO
        CALL WAITKEY            ;volanie WAITKEY
        JMP MENU                ;skoc do MENU

NENASIEL:
	LEA DX, TEXT12		;do DX vlozi retazec v dat. segmente
	MOV AH, 09H		;funkcia write string
	INT 21H			;volanie sluzby MS-DOSu
        CALL WAITKEY            ;volanie WAITKEY
        JMP MENU                ;skoc do MENU


TRI:				;vypise retazec v obratenom poradi
	XOR CX,CX               ;vynulovanie CX
	LEA SI,TEXT		;do SI vloz retazec v dat. segmente
	LEA DI,TEXTR            ;do DI vloz posunutie retazca v dat. segmente
	MOV AL,CS:[SI]          ;do AL vlozi CS:[SI]
	MOV CS:[DI],AL          ;do CS:[DI] vlozi AL
	MOV AL,CS:[SI+1]        ;do AL vlozi CS:[SI+1] posunuty o jeden znak
	MOV CS:[DI+1],AL        ;do CS:[D1+1] posunuty o jeden znak vlozi AL
	ADD DI,2                ;nastavi DI o +2 znaky
        MOV CL,CS:[SI+1]        ;CL = POCET ZNAKOV
        ADD SI,CX               ;do SI da CX
        ADD SI,1

        PUSH CX                 ;CX vlozi do STACKu

OPAK_REV:   
        MOV AL,CS:[SI]		
        MOV CS:[DI],AL
        INC DI                  ;inkrementacia DI
        DEC SI                  ;dekrementacia SI

	LOOP OPAK_REV		;dekrementuje CL register -- podmienene opakovanie
				;ak nie je nulovy tak pokracuje
        POP CX			;vyber CX zo STACKu

	LEA SI,TEXT             ;do SI priradi OFFSET TEXT
	ADD SI,2                ;posunie o 2 miesta
	LEA DI,TEXTR            ;do DI obrateny OFFSET TEXTR
	ADD DI,2                ;posunutie o 2 miesta

COPY:
        MOV AL,CS:[DI]          ;kopirovanie retazcov
        MOV CS:[SI],AL
        INC DI                  ;inkrementacia DI
        INC SI                  ;aj inkrementacia SI
        LOOP COPY
	JMP JEDNA

STYRI:				;vypis poctu cislic v retazci
        LEA SI,TEXT             ;do SI priradi OFFSET TEXT
        XOR CH,CH               ;vynuluje CH
        MOV CL,CS:[SI+1]        ; CL = POCET ZNAKOV
        MOV NUMBERS,0           ;do NUMBERS vlozi 0
        ADD SI,2                ;posunutie o 2 miesta

NEXT:   MOV AL,CS:[SI]		;do AL vlozi retazec
        CMP AL,30H              ;porovnanie ci tam je 0 
        JLE HOP                 ;ak je vacsi alebo rovny nule skoc na HOP     
	CMP AL,39H              ;porovnaj ci tam je 9 
        JGE HOP                 ;ak je mensi alebo rovny 9 skoc na HOP
        INC NUMBERS             ;inkrementuj NUMBERS

HOP:    INC SI                  ;inkrementuj SI
        LOOP NEXT

        MOV AL,NUMBERS          ;do AL daj NUMBERS
        CALL VYPISCISLO         ;volanie VYPISCISLO
        CALL WAITKEY            ;volanie WAITKEY
        JMP MENU                ;skoc do MENU

PAT:
	XOR AX,AX		;vynulovanie registra
	XOR CX,CX
	LEA SI,TEXT		;do SI vloz OFFSET TEXT
        MOV CL,CS:[SI+1]        ;CL = POCET ZNAKOV
        ADD SI,2                ;posun o 2

OPAK_VELKE:   
	MOV AL,DS:[SI]		;do al vlozi retazec
	CMP AL,7BH		;je male z ?
	JGE POVODNY_VELKE       ;ak nie je mensi tak skoc

	CMP AL,61H		;porovnaj obsah zo 60H
	JGE DALEJ_VELKE		;ak je mensi alebo rovny
	JMP POVODNY_VELKE       ;inak skoc na POVODNY_VELKE

DALEJ_VELKE:	
	SUB AL,32               ; OPOCITA OD DL 32

POVODNY_VELKE:
        MOV CS:[SI],AL		;do retazca hodi povodny znak
        INC SI                  ;inkrementuje SI
	LOOP OPAK_VELKE	
	JMP JEDNA

SEST:	XOR AX,AX		;vynulovanie registra
	XOR CX,CX
	LEA SI,TEXT             ;do SI da OFFSET TEXT
        MOV CL,CS:[SI+1]        ; CL = POCET ZNAKOV
        ADD SI,2                ;posun o 2

OPAK_MALE:   
        MOV AL,DS:[SI]

	CMP AL,5AH              ;velke Z
	JGE POVODNY_MALE        ;ak  je mensi alebo rovny skoc na

	CMP AL,41H		;velke A
	JGE DALEJ_MALE		;ake je mensi alebo rovny skoc
	JMP POVODNY_MALE

DALEJ_MALE:
	ADD AL,32               ; pripocita do AL 32

POVODNY_MALE:
        MOV CS:[SI],AL		;priradenie retazca
        INC SI                  ;inkrementacia SI
	LOOP OPAK_MALE		
	JMP JEDNA

WAITKEY PROC			;procedura na cakanie stlacenia klavesy

	XOR AH,AH
	INT 16h
	RET			;navrat

ENDP                            ;koniec procedury

CONVERT PROC			;preklad tabulky

	PUSH BX
	LEA BX,CISLA
	XLATB
	POP BX

RET
ENDP

WRITECHAR PROC			;funkcia na vypis znaku

	PUSH AX
	PUSH DX
	MOV AH,02H
	MOV DL,AL
	INT 21H
	POP DX
	POP AX
RET
ENDP

VYPISCISLO PROC

	CMP AL,100		;porovna al zo 100
	JLE DESIATKY            ;ked je rovne alebo mensie skoc na DESIATKY

	MOV CL,100              ;do CL da 100
	DIV CL                  ;delenie AX\CL

	MOV DH,AH		;do DH da zvysok po deleni

	CALL CONVERT		;volaj CONVERT
	CALL WRITECHAR          ;volaj WRITECHAR
	JMP DESIATKY_OK         ;skoc na DESIATKY_OK

DESIATKY:
	MOV DH,AL               ;do DH da celu cast AL

DESIATKY_OK:

	CMP DH,10		;porovna DH s 10
	JLE JEDNOTKY            ;ak je rovny alebo mensi skoc na JEDNOTKY
	XOR AH,AH               ;vynuluj AH
	MOV AL,DH               ;do AL da DH
	MOV CL,10               ;do CL da 10
	DIV CL                  ;podeli AX\CL
	MOV DH,AH               ;do DH da zvysok po deleni
	CALL CONVERT            ;vola CONVERT
	CALL WRITECHAR          ;vola WRITECHAR
	JMP JEDNOTKY_OK         ;skoc na JEDNOTKY_OK

JEDNOTKY:
	MOV AH,AL               ;do AH da AL, da celu cast

JEDNOTKY_OK:

	MOV AL,AH               ;do al da zvysok
	CALL CONVERT
	CALL WRITECHAR

RET
ENDP

TEXTZ   DB      'vstupny retazec znakov : >>> '
TEXT0   DB      '$'
TEXT1	DB	'[1]    Vypis retazca znakov na obrazovku', 0AH, 0DH
TEXT2	DB      '[2]    Vypis poradov cslo miesta', 0AH, 0DH
TEXT3   DB      '[3]    Vypis retazca v obrtenom porad',0AH, 0DH
TEXT4   DB      '[4]    Vypis poctu cslic v retazci',0AH, 0DH
TEXT5   DB      '[5]    Konvertuje male na velke',0AH, 0DH
TEXT6   DB	'[6]    Konvertuje velke na male',0AH, 0DH
TEXT7   DB      '[ESC]  KONIEC',0AH, 0DH,0AH, 0DH,0AH, 0DH,0AH, 0DH
TEXT8   DB      '$'
TEXT9   DB      'HLADANY ZNAK : $'
TEXT10  DB      0AH, 0DH
TEXT11  DB      'POZICIA      : $'
TEXT12  DB      0AH, 0DH
TEXT13  DB      'HLADANY ZNAK NEBOL NAJDENY !!!', 0AH, 0DH,'$'
RTG     DB      0
PP	DB      0
XX      DB      3 DUP(?)
TEXT    DB      100 
POCET   DB      0
STRING  DB      101 DUP (?)
TEXTR   DB      101 DUP (?)
CISLA db 30h,31h,32h,33h,34h,35h,36h,37h,38h,39h
NUMBERS db ?


CODE	ENDS                    ;koniec kodoveho segmentu
	END	START		;koniec suboru pre assembler

