data 	segment					;Definicia datoveho segmentu
menu1 	db 'Zobrazit retazec na obrazovku'	;Jednotlive texty v menu	
menu2	db 'Pozicia zadaneho znaku'
menu3  	db 'Vypisat v obratenom poradi'
menu4	db 'Pocet cislic v retazci'
menu5	db 'Skonvertovat male na velke'
menu6	db 'Skonvertovat velke na male'
menu7	db 'Znova nacitat retazec'
menu8	db 'Koniec'
zadaj	db 09h,09h,09h,'Zadaj retazec (max 100 znakov): ',0Dh,0Ah,09h,09h,09h,'$'
max	db 100			;Pomocne premenne definujuce format retazca
pocet	db ?			;pre int 21h, podfunkciu 0Ah
retazec db 100 dup(?)		;Pamat rezervovana pre retazec
cezater	db 100 dup(?)		;Buffer v ktorom sa uskladnuje obrateny retazec
				;Pomocne texty zacinajuce vzdy tromi prikazmi 
				;TAB ktore text posuvaju do stredu obrazovky
znaktxt db 09h,09h,09h,'Zadaj znak, ktory chces v retazci vyhladat: $'
nontxt	db 09h,09h,09h,'Zadany znak sa v retazci nenachadza!$'
yestxt	db 09h,09h,09h,'Zadany znak je na pozicii $'
numtxt	db 09h,09h,09h,'Pocet cisel v retazci je $'
nnumtxt	db 09h,09h,09h,'V retazci sa nenachadza ziadne cislo!$'
data 	ends

prog 	segment
	assume	cs:prog,ds:data
start:	mov 	bx,data
	mov 	ds,bx		;Priprava DS a ES registra pre datovy segment
	mov	es,bx
	mov	si,1		;Inicializacia SI, v nom sa uskladnuje momentalne zvolena polozka menu
	call	_load		;Nacitanie retazca
opak2:	call 	_menu		;Vstup do hlavneho menu, procedura _menu sa ukonci stlacenim klavesy ENTER
	cmp	si,1		;Ak nebola zvolena polozka menu cislo 1,
	jnz	prskc10		;preskoci sa
	call	_view		;zobrazenie retazca na obrazovku,
	jmp 	opak2		;a navrat do hlavneho menu
prskc10:cmp	si,2		;Ak nebola zvolena polozka menu cislo 2,
	jnz	prskc11		;preskoci sa
	call	_position	;zistenie pozicie zadaneho znaku v retazci,
	jmp	opak2		;a navrat do hlavneho menu
prskc11:cmp	si,3		;Ak nebola zvolena polozka menu cislo 3,
	jnz	prskc13		;preskoci sa
	call	_backvw		;zobrazenie obrateneho retazca	
	jmp	opak2		;	.
prskc13:cmp	si,4		;	.
	jnz	prskc16		;	.
	call	_nrnum		;Pocet cisel v retazci
	jmp	opak2
prskc16:cmp	si,5
	jnz	prskc21
	call	_ltoh		;Konverzia malych pismen na velke
	jmp	opak2
prskc21:cmp	si,6
	jnz	prskc23
	call	_htol		;Konverzia velkych pismen na male
	jmp	opak2
prskc23:cmp	si,7
	jnz	prskc19
	call	_load		;Znovu nacitanie retazca
	jmp	opak2
prskc19:mov 	ax,4C00h	;Ukoncenie programu
	int 	21h

_view	proc	near		;Nacitanie retazca
	mov	dx,offset retazec	;Priprava registrov pre podfunkciu 09h
	mov	ah,09h
	int	21h		;Volanie prerusenia
	call	_wait		;Cakanie na stlacenie lubovolneho klavesu
	ret
_view	endp

_position proc	near		;//////Pozicia zadaneho znaku v retazci\\\\\\\\
	mov	dx,offset znaktxt
	mov	ah,09h
	int	21h		;Zobrazenie textu 'Zadaj znak, ktory . . . '
	mov	ah,01
	int	21h		;Nacitanie znaku
	mov	bx,offset retazec	;BX -> pointer na retazec
opak3:	cmp	byte ptr[bx],al		;Porovnavanie so zadanym znakom
	jz 	nasiel			;Ak ano, skok na Nasiel
	cmp	byte ptr[bx],24h	;Porovnavanie so znakom '$'
	jz	nenas			;Ak ano, koniec retazca => nenasiel
	inc	bx			;Zvyst pointer
	jmp	opak3			;a odznova dalsi znak
nasiel: mov	dx,offset yestxt	;Ak nasiel,
	mov	ah,09h
	int	21h			;zobrazime 'Zadany znak je na . . . '
	sub	bx,offset retazec	;Prevedieme pointer na poziciu znaku
	inc	bx
	cmp	bx,10			;Ak je vacsia alebo rovna ako 10,
	jl	prskc12			;robime prevod na dva znaky
	mov	ax,bx
	mov	dh,10
	div	dh			;Vydelime 10
	mov	dl,al
	add	dl,30h			;Vysledok prevedieme na ASCII
	mov	bl,ah
	mov	ah,02h
	int	21h			;a zobrazime
prskc12:add	bx,30h			;Zvysok po deleni tiez prevedieme na ASCII
	mov	dl,bl
	mov	ah,02h
	int	21h			;a zobrazime (ak je cislo jednociferne, vykonava sa len tento krok)
	call	_wait			;Cakanie na stlacenie klavesu
	ret
nenas:	mov	dx,offset nontxt	;Ak nenasiel,
	mov	ah,09h
	int	21h			;zobrazi sa text 'Znak sa nenachadza ...'
	call	_wait
	ret
_position endp

_backvw	proc	near			;////////Vypis v obratenom poradi\\\\\\\
	mov	bx,offset pocet
	mov	cl,[bx]			;Do CX umiestnime dlzku retazca
	mov	ch,0
	mov	bx,offset retazec
	add	bx,cx			;BX -> pointer na koniec retazca
	dec	bx
	mov	di,offset cezater	;DI -> pointer na cielovy buffer konverzie
opak4:	mov	al,byte ptr[bx]
	mov	byte ptr[di],al		;Presun jedneho znaku retazca do cieloveho bufferu
	dec	bx
	inc	di			;Inkrementacia hodnot pointerov
	loop	opak4			;Opakuje sa pre cely retazec
	inc	di
	mov	byte ptr[di],24h	;Na koniec skonvertovaneho retazca pride '$'
	mov	dx,offset cezater
	mov	ah,09h
	int	21h			;Vypis prekonvertovaneho retazca
	call	_wait			;Cakanie na klaves
	ret
_backvw	endp

_nrnum	proc	near			;////////////Pocet cislic\\\\\\\\\\\\\\\
	mov	bx,offset retazec	;BX -> pointer na znaky v retazci
	mov	cx,0			;CX -> pocet zatial najdenych cisel
	dec	bx
opak5:	inc	bx			;Inkrement pointera po kazdom kroku
	mov	al,byte ptr[bx]		;Do AL presunieme aktualny znak
	cmp	al,24h			;Ak je to koniec retazca,
	jz	kon1			;ideme na koniec
	cmp	al,30h			;Ak je znak mensi ako '0',
	jl	opak5
	cmp	al,39h			;alebo vacsi ako '9',
	jg	opak5			;ideme na dalsi znak,
	inc	cx			;inak zvysime pocet najdenych cisel
	jmp	opak5			;a ideme na dalsi znak
kon1:	cmp	cx,0			;Ak je pocet cisel 0
	jnz	prskc14
	mov	dx,offset nnumtxt
	mov	ah,09h			;zobrazime text 'Neobsahuje cisla . . .'
	int	21h
	jmp	prskc15
prskc14:mov	dx,offset numtxt	;inak zobrazime text 'Pocet najdenych ...'
	mov	ah,09h
	int	21h
	cmp	cx,10			;Ak je pocet cisel dvojciferny
	jl	prskc17
	mov	ax,cx
	mov	dh,10
	div	dh			;vydelime ho 10,
	mov	dl,al
	add	dl,30h			;vysledok prevedieme na ASCII
	mov	cl,ah
	mov	ah,02h
	int	21h			;a zobrazime ho
prskc17:mov	dl,cl			;Podobne prevedieme a zobrazime aj zvysok po deleni
	add	dl,30h			;(Tento krok sa vykonava aj pri jednocifernom cisle)
	mov	ah,02h
	int	21h
prskc15:call	_wait			;Cakanie na stlaceny klaves
	ret
_nrnum	endp

_ltoh	proc	near			;////////Male pismena na velke\\\\\\\\\
	mov	bx,offset retazec	;BX -> pointer na znaky v retazci
	mov	di,offset cezater	;DI -> pointer na vystupny buffer konverzie
	dec	bx
	dec	di
opak6:	inc	bx			;Inkrementacia pointerov po kazdom kroku
	inc	di
	mov	al,byte ptr[bx]		;Do AL presunieme znak z retazca
	cmp	al,61h			;Ak je vacsi ako 'a',
	jl	prskc20
	cmp	al,7Ah			;a mensi ako 'z'
	jg	prskc20
	sub	al,32			;znizime ho o roziel medzi 'A','a'
prskc20:mov	byte ptr [di],al	;Skonvertovany znak umiestnime do vystupneho bufferu
	cmp	al,24h			;Ak nie je koniec retazca
	jnz	opak6			;ideme na dalsi krok,
	mov	dx,offset cezater	;inak vystupny buffer zobrazime na obrazovku
	mov	ah,09h
	int	21h
	call	_wait			;Cakanie na stlacenie klavesy
	ret
_ltoh	endp
_htol	proc	near			;////////////Velke na male\\\\\\\\\\\\\\
	mov	bx,offset retazec	;BX -> pointer na znaky v retazci
	mov	di,offset cezater	;DI -> pointer na vystupny buffer kkonverzie
	dec	bx
	dec	di
opak7:	inc	bx			;Inkrementacia pointerov po kazdom kroku
	inc	di
	mov	al,byte ptr[bx]		;Do AL presunieme znak z retazca
	cmp	al,41h			;Ak je vacsi ako 'A',
	jl	prskc22
	cmp	al,5Ah			;a mensi ako 'Z'
	jg	prskc22
	add	al,32			;zvysime ho o rozdiel medzi 'A','a'
prskc22:mov	byte ptr [di],al	;Skonvertovany znak umiestnime do vystupneho bufferu
	cmp	al,24h			;Ak nie je koniec retazca
	jnz	opak7			;ideme na dalsi krok,
	mov	dx,offset cezater	;inak vystupny buffer zobrazime na obrazovku
	mov	ah,09h
	int	21h
	call	_wait			;Cakanie na stlacenie klavesy
	ret
_htol	endp

_load	proc 	near			;//////////Nacitanie retazca\\\\\\\\\\\
	mov 	ax,03
	int	10h			;Inicializacia obrazovky
	mov	dx,offset zadaj
	mov 	ah,09
	int	21h			;Zobrazenie textu 'Zadaj retazec . . . '
	mov 	dx,offset max
	mov	ah,0Ah
	int	21h			;Nacitanie retazca
	mov	bx,offset pocet
	mov	al,byte ptr[bx]
	mov	ah,0
	mov	bx,offset retazec
	add	bx,ax
	mov	al,24h			;Na koniec retazca pridame znak '$'
	mov	[bx],al
	ret
_load	endp

_menu	proc 	near			;//////////////Hlavne menu\\\\\\\\\\\\\\
opak1:	call	_clear			;Vymazanie obrazovky
	mov 	bp,offset menu1		;Priprava registrov pre int10h - adresa retazca
	mov	cx,offset menu2 - offset menu1	;Dlzka retazca
	mov	dh,8			;Riadok
	mov	dl,25			;Stlpec
	mov	bh,0			;Stranka obrazovky
	mov	bl,15			;Atribut ( biely text,cierne pozadie)
	cmp	si,1			;Ak je zvolena polozka menu c. 1,
	jnz	preskc3
	add	bl,16			;zmenime pozadie na modre
preskc3:mov	ah,13h			;Cislo podfunkcie int10h
	mov	al,0			;Mod zobrazenia
	int 	10h			;Vypis prvej casti menu na obrazovku
	mov	bp,offset menu2		;Adresa druhej casti menu
	mov	cx,offset menu3 - offset menu2	;Dlzka retazca
	inc	dh			;Novy riadok
	mov	bl,15			;Biele pismo, cierne pozadie
	cmp	si,2			;Ak bola zvolena polozka menu c. 2,
	jnz	preskc4
	add	bl,16			;zmenime pozadie na modre
preskc4:int	10h			;Zobrazenie druhej casti menu
	mov	bp,offset menu3		;			.
	mov	cx,offset menu4 - offset menu3	;		.
	inc	dh			;			.
	mov	bl,15
	cmp	si,3
	jnz	preskc5
	add	bl,16
preskc5:int	10h
	mov	bp,offset menu4
	mov	cx,offset menu5 - offset menu4
	inc	dh
	mov	bl,15
	cmp	si,4
	jnz	preskc6
	add	bl,16
preskc6:int	10h
	mov	bp,offset menu5
	mov	cx,offset menu6 - offset menu5
	inc	dh
	mov	bl,15
	cmp	si,5
	jnz	preskc7
	add	bl,16
preskc7:int 	10h
	mov	bp,offset menu6
	mov	cx,offset menu7 - offset menu6
	inc	dh
	mov	bl,15
	cmp	si,6
	jnz	preskc8
	add	bl,16
preskc8:int	10h
	mov	bp,offset menu7
	mov	cx,offset menu8 - offset menu7
	inc	dh
	mov	bl,15
	cmp	si,7
	jnz	preskc9
	add	bl,16
preskc9:int 	10h
	mov	bp,offset menu8
	mov	cx,offset zadaj - offset menu8
	inc	dh
	mov	bl,15
	cmp	si,8
	jnz	prskc18
	add	bl,16
prskc18:int	10h			;Zobrazenie poslednej casti menu na obrazovku
	mov	ah,08h
	int	21h			;Nacitanie klavesy {bez echa)
	cmp	al,0			;Ak je klavesa 0 (rozsireny kod)
	jnz	preskoc
	int	21h			;treba volat druhy krat
preskoc:cmp	al,72			;Ak bola stlacena sipka hore
	jz	hore
	cmp	al,80			;Ak bola stlacena sipka dole
	jz 	dole
	cmp	al,13			;Ak bol stlaceny ENTER
	jz	ok
dole:	inc	si			;SIPKA DOLE: zvysime cislo polozky menu
	cmp	si,9			;Ak sme na konci menu,
	jnz	preskc2
	mov	si,1			;presunieme sa na zaciatok menu
preskc2:jmp	opak1			;a nove prekreslenie
hore:	dec	si			;SIPKA HORE: znizime cislo polozky menu
	cmp	si,0			;Ak sme na zaciatku menu,
	jnz	preskc1
	mov	si,8			;presunieme sa na koniec menu
preskc1:jmp	opak1			;a znovu prekreslime
ok:	ret				;ENTER: ukoncenie procedury, v SI je zvolena polozka
_menu	endp

_clear	proc	near			;//////////Vymazanie obrazovky\\\\\\\\\\
	mov	ah,06h			;Pouzijeme podfunkciu pre rolovanie okna
	mov	ch,0			;Suradnice laveho horneho rohu okna
	mov	cl,0
	mov	dh,24			;Suradnice praveho dolneho rohu okna
	mov	dl,79
	mov	al,0			;Vymazat cele okno
	mov	bh,15			;Atribut pre prazdne riadky (biele pismo na ciernom pozadi)
	int	10h			;Vykonanie vymazania okna
	mov	ah,02h
	mov	bh,0
	mov	dx,0
	int	10h			;Nastavenie kurzora do laveho horneho rohu obrazovky
	ret
_clear	endp

_wait	proc	near			;//////Cakanie na stlaveny klaves\\\\\\
	mov	ah,01h
	int	21h
	ret
_wait	endp

prog 	ends
	end 	start