.model tiny                                      ; pamatovy model

textattr   macro attr                            ; nastavenie farby
           mov byte ptr [attribute], attr        ; vstup: farba
           endm

gotoxy     macro x, y                            ; nastavenie polohy kurzora
           mov dh, y                             ; vstup: suradnice kurzora
           mov dl, x
           call _gotoxy
           endm

cprintf    macro string                          ; vypis retazca na obrazovku
           mov bp, offset string                 ; vstup: premenna typu retazec
           call _cprintf                         ; pouziva premennu attribute
           endm                                  ; na nastavenie farby

.code
org 100h                                         ; potrebne pre *.com

start:
           mov ax,0003h                          ; textovy mod 80 x 25
           int 10h

           textattr <7 + 0 * 16>                 ; nastavenie farby
           gotoxy 0, 0
           cprintf hlavicka
           gotoxy 0, 2
           cprintf otazka                        ; otazka 'Zadaj retazec: '
           mov dx, offset maxretazec             ;nacitanie retazca do
           mov ah, 0Ah                           ;premennej maxretazec  
           int 21h                               ;
           gotoxy 0, 4                           ; zaciatok vypisania menu
           cprintf menu1
           gotoxy 0, 5
           cprintf menu2
           gotoxy 0, 6
           cprintf menu3
           gotoxy 0, 7
           cprintf menu4
           gotoxy 0, 8
           cprintf menu5
           gotoxy 0, 9
           cprintf menu6
           gotoxy 0, 10
           cprintf menu7                         ; koniec vypisania menu
                                                 ; zaciatok hlavneho cyklu
repeat:    mov ah, 08h                           ;nacita znak z klavesnice bez echa
           int 21h                               ;nacitany znak je v reg. al
                                                 ; obsluha 1. polozky v menu
m1:        cmp al, '1'                           ; stlacil som '1' ?
           jnz m2                                ; ak nie, skok na m2
           gotoxy 0, 12                          
           cprintf prazdny                       ; vypis prazdneho riadku
           gotoxy 0, 12
           cprintf retazec
           jmp repeat                            ; skok na zaciatok hl. cyklu
                                                 ; obsluha 2. polozky v menu
m2:        cmp al, '2'                           ; stlacil som '2' ?
           jnz m3                                ; ak nie, skok na m3
           gotoxy 0, 12
           cprintf prazdny                       ; vypis prazdneho riadku
           gotoxy 0, 12                          
           cprintf otazka2                       ; otazka 'Zadaj znak: '
           mov ah, 01h                           ;nacita znak z klavesnice s echom
           int 21h                               ;vystup do reg. al 
           xor ch, ch                            ; vynuluje reg. ch
           mov cl, byte ptr [retazec]            ; v cx bude dlzka retazca
           mov si, 1                             ; reg. si sluzi na adresovanie
hladaj:    cmp al, byte ptr [retazec + si]       ; porovna al, s si-itym znakom retazca
           jz nasiel                             ; ak sa rovnaju skok na nasiel
           inc si                                ; si = si + 1
           loop hladaj                           ; opakuj kym cx > 0
nenasiel:  gotoxy 20, 12
           cprintf odpoved2b                     ; ak nenasiel, poda o tom spravu
           jmp repeat
nasiel:    push si                               ; ulozi reg. si do zasobnika
           gotoxy 20, 12
           cprintf odpoved2a                     ; ak nasiel, poda o tom spravu 
           pop si                                ; vyberie reg. si zo zasobnika
           mov ax, si                            ; v ax je pozicia najdeneho znaku 
           mov bl, 10                            ; nasledujuci algoritmus     
           div bl                                ; konvertuje dvojciferne cislo
           mov dx, ax                            ; v ax na dve cislice,
           add dl, 30h                           ; pricita k nim 30h (znak '0')
           add dh, 30h
           mov ah, 02h                           ; a postupne vypise tieto dve 
           int 21h                               ; cislice pomocou int 21h
           mov dl, dh                            ; funkcia 02h, pricom v reg. dl
           mov ah, 02h                           ; je znak, ktory chceme vypisat
           int 21h
           jmp repeat                            ; skok na zaciatok hl. cyklu
                                                 ; obsluha 3. polozky v menu
m3:        cmp al, '3'                           ; stlacil som '3' ?
           jnz m4                                ; ak nie, skok na m4
           xor bh, bh                            ; vynuluje reg. bh
           mov bl, byte ptr [retazec]            ; v bx bude dlzka retazca a
           mov byte ptr [text], bl               ; priradime ju do noveho retazca
           mov si, 1                             ; sluzi na adresovanie
opakuj3:   mov al, byte ptr [retazec + bx]       ; v tomto cykle citame znaky
           mov byte ptr [text + si], al          ; z retazca odzadu a priradujeme   
           inc si                                ; ich do druheho retazca odpredu
           dec bx                                ; takto vznikne novy retazec
           cmp bx, 0                             ; ktory ma znaky v obratenom
           jnz opakuj3                           ; poradi ako ten povodny
           gotoxy 0, 12                          
           cprintf prazdny                       ; vypise prazdny riadok
           gotoxy 0, 12
           cprintf text                          ; vypise novy obrateny retazec
           jmp repeat                            ; skok na zaciatok hl. cyklu
                                                 ; obsluha 4. polozky v menu
m4:        cmp al, '4'                           ; stlacil som '4' ?
           jnz m5                                ; ak nie, skok na m5
           xor ch, ch                            ; vynuluje reg. ch
           mov cl, byte ptr [retazec]            ; v cx bude dlzka retazca
           xor bx, bx                            ; vynuluje bx, tu bude pocet cislic
           mov si, 1                             ; sluzi na adresovanie
opakuj4:   mov al, byte ptr [retazec + si]       ; v al bude si-ity znak retazca
           cmp al, 2Fh                           ; porovna ho so znakom '/'
           jbe dalej4                            ; (znak pred '0') a skok ak je
           cmp al, 3Ah                           ; mensi alebo rovny; porovna ho
           jnb dalej4                            ; s ':' (znak za '9') a skok ak je 
           inc bx                                ; vacsi alebo rovny, inak bx = bx + 1
dalej4:    inc si                                ; si = si + 1
           loop opakuj4                          ; opakuj kym cx > 0
           cmp bx, 0                             ; v bx je pocet cislic
           jnz vypis4                            ; ak je nenulovy, skok na vypis4
           gotoxy 0, 12
           cprintf prazdny                       ; vypise prazdny riadok
           gotoxy 0, 12                         
           cprintf odpoved4b                     ; vypise spravu o nenajdeni cislic
           jmp repeat                            ; skok na zaciatok hl. cyklu
vypis4:    push bx                               ; bx do zasobnika
           gotoxy 0, 12                         
           cprintf prazdny                       ; vypise prazdny riadok
           gotoxy 0, 12                           
           cprintf odpoved4a                     ; vypise spravu o pocte cislic
           pop bx                                ; vyberie bx zo zasobnika
           mov ax, bx                            ; algoritmus na konverziu
           mov bl, 10                            ; dvojciferneho cisla na dve
           div bl                                ; cislice vid riadok 81
           mov dx, ax
           add dl, 30h
           add dh, 30h
           mov ah, 02h
           int 21h
           mov dl, dh
           mov ah, 02h
           int 21h
           jmp repeat
                                                 ; obsluha 5. polozky v menu
m5:        cmp al, '5'                           ; stlacil som '5' ?
           jnz m6                                ; ak nie, skok na m6
           xor ch, ch                            ; vynuluje ch
           mov cl, byte ptr [retazec]            ; v cx bude dlzka retazca
           mov byte ptr [text], cl               ; dlzku ulozi do noveho retazca
           mov si, 1                             ; sluzi na adresovanie
opakuj5:   mov al, byte ptr [retazec + si]       ; v al bude si-ity znak retazca
           cmp al, 60h                           ; algoritmus na konverziu malych
           jbe dalej5                            ; pismen na velke, ak znak nie je
           cmp al, 7Bh                           ; v rozsahu a-z, skok na dalej 5,
           jnb dalej5                            ; inak odpocitaj od al 20h
           sub al, 20h                           ; (a-A)
dalej5:    mov byte ptr [text + si], al          ; skonvertovany znak ulozi
           inc si                                ; do noveho retazca
           loop opakuj5                          ; opakuj kym cx > 0
           gotoxy 0, 12
           cprintf prazdny                       ; vypise prazdny riadok
           gotoxy 0, 12
           cprintf text                          ; vypise novy retazec
           jmp repeat                            ; skok na zaciatok hl. cyklu
                                                 ; obsluha 6. polozky v menu
m6:        cmp al, '6'                           ; algoritmus na konverziu
           jnz m7                                ; velkych pismen na male
           xor ch, ch                            ; algoritmus je podobny
           mov cl, byte ptr [retazec]            ; ako v m5, vysvetlenie vid v m5
           mov byte ptr [text], cl
           mov si, 1
opakuj6:   mov al, byte ptr [retazec + si]
           cmp al, 40h
           jbe dalej6
           cmp al, 5Bh
           jnb dalej6
           add al, 20h
dalej6:    mov byte ptr [text + si], al
           inc si
           loop opakuj6
           gotoxy 0, 12
           cprintf prazdny
           gotoxy 0, 12
           cprintf text
hop:       jmp repeat
                                                 ; obsluha 7. polozky v menu
m7:        cmp al, '7'                           ; stlacil som '7' ?
           jnz hop                               ; ak nie, skok na hop
           int 20h                               ; koniec programu

_gotoxy    proc near                             ; procedura na nastavenie
           mov bh, 0                             ; polohy kurzora na obrazovke
           mov ah, 02h                           ; vstup: dh - riadok, dl -stlpec
           int 10h
           ret
_gotoxy    endp

_cprintf   proc near                             ; procedura na vypis textu
           mov bh, 0                             ; na obrazovku
           mov ah, 03h                           ; vstup: retazec na adrese es:bp
           int 10h                               ; dh, dl - suradnice
           mov cl, [bp]                          ; bl - farba textu
           xor ch, ch
           inc bp
           mov bl, byte ptr [attribute]          
           mov ah, 13h
           mov al, 01h
           int 10h
           ret
_cprintf   endp

attribute  db 7 + 0 * 16
hlavicka   db 64, 'Zadanie c.1, Ondrej Hluchy, 17.10.2000, 2.roc., sk.rok 2000/2001'
prazdny    db 80, '                                                                                '
menu1      db 39, '1. Vypisat retazec znakov na obrazovku.'
menu2      db 41, '2. Vypisat poziciu miesta zadaneho znaku.'
menu3      db 38, '3. Vypisat retazec v obratenom poradi.'
menu4      db 34, '4. Vypisat pocet cislic v retazci.'
menu5      db 37, '5. Konvertovat male pismena na velke.'
menu6      db 37, '6. Konvertovat velke pismena na male.'
menu7      db 32, '7. Ukoncit vykonavanie programu.'
otazka     db 15, 'Zadaj retazec: '
otazka2    db 12, 'Zadaj znak: '
odpoved2a  db 46, 'Zadany znak sa v retazci nachadza na pozicii: '
odpoved2b  db 22, 'Zadany znak nenajdeny.'
odpoved4a  db 27, 'Pocet cislic v retazci je: '
odpoved4b  db 41, 'V retazci sa nenachadzaju ziadne cislice.'

maxretazec db 100
retazec    db 101 dup (0)
text       db 101 dup (0)

end start