;++++++++++++++++++++++++++++++++++++++++
;     Zadanie c.1
;Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) a podla  menu vykona  jednu z moznosti:
;
;A) vypise retazec znakov na obrazovku
;B) vypise poradove cislo miesta, kde sa nachadza prvy krat znak nacitany z klavesnice,ak ho nenajde vypise o tom spravu.
;C) vypise retazec v obratenom poradi,
;D) vypise pocet cislic v retazci
;E) male pismena konvertuje na velke
;F) velke pismena konvertuje na male
;G) ukonci vykonvanie programu.
;
;Po vykonan zvolenej moznosti sa program vrti na vpis menu.
;
;Nepouzvajte retazcov instrukcie!
;Termn odovzdania:na cvicen do 5.tyzdna semestra (23.10-26.10.2000)
;
;Autor: tefan Sudolsk
;Termn odovzdania:24.10.2000
;2.roc.,kr.B21,sk.rok 2000/2001
;++++++++++++++++++++++++++++++++++++++++
ZAS SEGMENT STACK           ;zaciatok zasobnikoveho segmentu - prikaz pre prekladac
  DW 64 DUP(?)
ZAS ENDS                    ;koniec zas. segmentu
;++++++++++++++++++++++++++++++++++++++++
DATA SEGMENT                ;zac. datoveho segmentu   
ZNAK DB 1 DUP(?)            
VSTUP DB 80     
POCET DB 0
      DB 80 DUP(?)
VYSTUP DB 83 DUP(?)
CR  DB 10
    DB 13
    DB '$'
;---------------------------------
MENU1  DB  10,13,'         PRACA S RETAZCOM',10,13,10,13,'  a) Zadaj retazec znakov',10,13,'  b) Vypisem retazec na obrazovku',10,13,'  c) Hladanie zadaneho znaku',10,13,'  d) Vypisem retazec v obratenom poradi $'
MENU2  DB  10,13,'  e) Vypisem pocet cislic v retazci',10,13,'  f) Male pismena zmenim na velke',10,13,'  g) Velke pismena zmenim na male',10,13,'  h) Koniec',10,13,10,13,'  Tvoja volba (a-h): $'
CHYBAST DB 10,13,10,13,'   ZREJME SI STLACIL ZLU KLAVESU ! $'
ZADAJ DB 10,13,10,13,'  Zadaj retazec : $'
VYPIS DB 10,13,10,13,'  Zadany retazec bol :$'
STLAC DB 10,13,'      Stlac teraz klavesu ! $'
ZDZNAK DB 10,13,10,13,'  Zadaj znak, ktory mam najst :$'
NASIEL DB 10,13,10,13,'  Nasiel som zadany znak na mieste cislo :$'
NENASIEL DB 10,13,10,13,'   Zadany znak v retazci nie je.$'
OTOC DB 10,13,10,13,'  Otoceny retazec je :$'
CISRET DB 10,13,10,13,'  Pocet cislic v retazci je :$'
MAVELKE DB 10,13,10,13,'  Male pismena som zkonvertoval na velke :$'
VEMALE DB 10,13,10,13,'  Velke pismena som zkonvertoval na male :$'
SKONIEC DB 10,13,10,13,'   Chces skutocne skoncit (a/n) ? $'
DATA ENDS
;++++++++++++++++++++++++++++++++++++++++
CODE SEGMENT                      ;zac. kodoveho segmentu
  ASSUME CS:CODE, DS:DATA, SS:ZAS
;---------------------------------
CLRSCR  PROC                      ;procedura na vymazanie obrazovky
  MOV AH, 00H
  MOV AL, 03H
  INT 10H
  RET
  ENDP
;---------------------------------
CAKAJNA  PROC                     ;procedura ktora caka na stlacenie lub. klavesy
  MOV AH, 00H     
  INT 16H
  RET
  ENDP
;---------------------------------
STLAC_KL  PROC                    ;procedura na vypis cakania na klavesu
  MOV DX, OFFSET STLAC
  MOV AH, 09H
  INT 21H
  CALL CAKAJNA
  RET
  ENDP
;---------------------------------
NOVYR  PROC                       ;odriadkuje (da cursor do noveho riadku)
  MOV DX, OFFSET CR
  MOV AH, 09H
  INT 21H
  RET
  ENDP
;---------------------------------  
ZLA_KL  PROC                      ;vypise odkaz, ked bola stlacena nedefinovana klavesa
  MOV DX, OFFSET CHYBAST
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  RET
  ENDP
;---------------------------------
VYPISCISLA  PROC                  ;procedura pre vypis cisla na obrazovku ulozeneho v DX nie vacsieho ako 99 
  XOR BX, BX
  XOR CX, CX
VELKE: 
  CMP DX, 10                      ;postupne odcituje 10, az kym nedostane cislo mensie ako desat
  JB MAMHO  
  SUB DX, 10
  INC CL                          ;CL pocita desiatky
  JMP VELKE
MAMHO:
  MOV BL, DL              
  ADD BL, 30H             
  ADD CL, 30H                     ;z obidvoch cisel urobime znaky
  MOV AH, 02H                     ;vypis znakov
  MOV DL, CL
  INT 21H
  MOV DL, BL
  INT 21H
  RET
  ENDP
;---------------------------------
AVOL  PROC                        ;procedura volana moznostou a) 
  MOV DX, OFFSET ZADAJ            ;zadavanie noveho retazca 
  MOV AH, 09H
  INT 21H
  MOV DX,OFFSET VSTUP
  MOV AH,0AH
  INT 21H
  JMP START
  RET
  ENDP
;---------------------------------
BVOL  PROC                        ;procedura volana moznostou b) 
  MOV DX, OFFSET VYPIS            ;zkonvertuje zadany(vstup) retazec na vypis(vystup)
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 2
  MOV SI, DX
  MOV BX, OFFSET VYSTUP
  XOR AX,AX
  XOR CX,CX
  MOV CL,POCET
OPAKB:
  MOV AL,[SI]
  MOV [BX],AL
  INC SI
  INC BX
 LOOPNE OPAKB
  MOV byte ptr[BX],'$'
  MOV DX, OFFSET VYSTUP
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
CVOL  PROC                        ;procedura volana moznostou c) 
  MOV DX, OFFSET ZDZNAK           ;zadanie hladaneho znaku
  MOV AH, 09H
  INT 21H
  MOV AH, 1
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 2
  MOV SI,DX
  MOV BL, AL
  XOR DX, DX
  XOR AX, AX
  XOR CX, CX
  MOV CL, POCET
OPAKC:                            ;hlada zadany znak
  INC DX
  MOV AL, [SI]
  CMP AL, BL
  JZ MAHO
  INC SI
 LOOPNE OPAKC
  MOV DX, OFFSET NENASIEL         ;ak nenasiel znak vypise spravu
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  JMP START
MAHO:                             ;skoci sem ak nasiel zadany znak
  MOV BX, DX
  MOV DX, OFFSET NASIEL
  MOV AH, 09H
  INT 21H
  MOV DX, BX
  CALL VYPISCISLA
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
DVOL  PROC                        ;procedura volana moznostou d)  
  MOV DX, OFFSET OTOC
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 1
  XOR CX, CX
  MOV CL, POCET
POLOHA:
  INC DX
 LOOPNE POLOHA
  MOV SI, DX
  MOV BX, OFFSET VYSTUP
  XOR AX, AX
  XOR CX, CX
  MOV CL, POCET
OPAKD:                            ;otaca vstupny retazec - uklada ho do vystupu
  MOV AL, [SI]
  MOV [BX], AL
  INC BX
  DEC SI
 LOOPNE OPAKD
  MOV byte ptr[BX], '$'
  XOR BX, BX
  MOV DX, OFFSET VYSTUP
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
EVOL  PROC                        ;procedura volana moznostou e) 
  MOV DX, OFFSET CISRET
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 2
  MOV SI, DX
  XOR AX, AX
  XOR BX, BX
  XOR CX, CX
  MOV CL, POCET
OPAKE:                            ;do BX uklada pocet najdenych cisel 
  MOV AL, [SI]
  CMP AL, 2FH
  JBE DALEJE
  CMP AL, 3AH
  JNB DALEJE
  INC BX
DALEJE: 
  INC SI
 LOOPNE OPAKE 
  MOV DX, BX
  CALL VYPISCISLA
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
FVOL  PROC                        ;procedura volana moznostou f)  
  MOV DX, OFFSET MAVELKE
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 2
  MOV SI, DX
  MOV BX, OFFSET VYSTUP
  XOR AX, AX
  XOR CX, CX
  MOV CL, POCET
OPAKF:                            ;zkonvertuje male na velke, ale ostatne znaky necha tak
  MOV AL, [SI]
  CMP AL, 60H
  JBE DALEJF
  CMP AL, 7BH
  JNB DALEJF
  SUB AL, 20H
DALEJF: 
  MOV [BX], AL
  INC SI
  INC BX
 LOOPNE OPAKF
  MOV byte ptr[BX], '$'
  MOV DX, OFFSET VYSTUP
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
GVOL  PROC                        ;procedura volana moznostou g)  
  MOV DX, OFFSET VEMALE
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET VSTUP
  ADD DX, 2
  MOV SI, DX
  MOV BX, OFFSET VYSTUP
  XOR AX, AX
  XOR CX, CX
  MOV CL, POCET
OPAKG:                            ;zkonvertuje velke na male, ale ostatne znaky si nevsima
  MOV AL, [SI]
  CMP AL, 40H
  JBE DALEJG
  CMP AL, 5BH
  JNB DALEJG
  ADD AL, 20H
DALEJG: 
  MOV [BX], AL
  INC SI
  INC BX
 LOOPNE OPAKG
  MOV byte ptr[BX], '$'
  MOV DX, OFFSET VYSTUP
  MOV AH, 09H
  INT 21H
  CALL STLAC_KL
  JMP START
  RET
  ENDP
;---------------------------------
HVOL PROC                         ;procedura volana moznostou h) 
OPAKH:                            ;ukoncenie prog.  
  MOV DX, OFFSET SKONIEC
  MOV AH, 09H
  INT 21H
  MOV AH, 1
  INT 21H
  MOV DL, AL
  CMP DL, 061H
  JZ ENDPRG
  CMP DL, 06EH
  JZ START
  CALL ZLA_KL
  JMP OPAKH
  RET
  ENDP
;---------------------------------
VYPISMENU PROC                    ;vypise menu na obrazovku
  MOV DX, OFFSET MENU1
  MOV AH, 09H
  INT 21H
  MOV DX, OFFSET MENU2
  MOV AH, 09H
  INT 21H
  RET
  ENDP
;---------------------------------
BEGIN:                            ;zaciatok prog.
  MOV AX, SEG DATA                
  MOV DS, AX
  CALL CLRSCR                     ;vymazanie obrazovky
  CALL VYPISMENU
  CALL AVOL                       ;nacitanie retazca
START:
  CALL CLRSCR 
  CALL VYPISMENU
  MOV AH, 1                       ;caka na volbu 
  INT 21H
  MOV DL, AL
  MOV BX, OFFSET ZNAK
  MOV [BX], DL                    ;zapis volby 
  CMP BYTE PTR [BX], 061H         ;hlada ktora volba to bola
  JZ AV
  CMP BYTE PTR [BX], 062H
  JZ BV
  CMP BYTE PTR [BX], 063H
  JZ CV
  CMP BYTE PTR [BX], 064H
  JZ DV
  CMP BYTE PTR [BX], 065H
  JZ EV
  CMP BYTE PTR [BX], 066H
  JZ FV
  CMP BYTE PTR [BX], 067H
  JZ GV
  CMP BYTE PTR [BX], 068H
  JZ HV
  CALL ZLA_KL                     ;ak nenasiel vypis chyby    
  JMP START
AV: CALL AVOL
BV: CALL BVOL
CV: CALL CVOL
DV: CALL DVOL
EV: CALL EVOL
FV: CALL FVOL
GV: CALL GVOL
HV: CALL HVOL
;----------------------
ENDPRG:                          ;vrat ovladanie systemu
  MOV AX, 4C00H
  INT 21H
CODE ENDS
     END  BEGIN
