;ZADANIE 2
;Lubomir HLAVEK
JUMPS                       ;direktiva preprekladac - moze sa skakat s podm skokmi na viac ako 128B
clrscr macro                ;makro, ktore volam z programu
  call _clrscr              ;procedura na vymazanie obrazovky
endm                        ;koniec makra
writeln macro s             ;makro volane z programu
  mov dx,offset s           ;presum adresy vypisovaneho textu do registra dx
  call _writeln             ;volanie procedury na vypis
endm                        ;koniec makra
write macro s               ;makro na wypis textu bez zariadkovania
  mov dx,offset s           ;presun adresy argumentu do dx
  call _write               ;volanie procedury write
endm                        ;koniec makra
convert macro               ;makro na konvertovanie cisla na text
  call _convert             ;volanie procedury konvert
endm                        ;koniec
tobinar macro               ;makro na prevod cisla do bin. tvaru
  call _tobinar             ;volanie procedury tobinar
endm                        ;koniec makra

zas segment stack           ;definicia zasobnikoveho segmentu
  dw 64 dup(?)              ;alokuje sa v pameti 128B
zas ends                    ;koniec zasobnikoveho segmentu
data segment                ;zaciatok datoveho segmentu
  path db 'vstup.txt',0     ;cesta ku vstupnemu suboru, musi byt zakonceny nulou
  pathout db 'vystup.txt',0 ;cesta ku vystupnemu suboru
  vstup db 1 dup(?)         ;alokacia jedneho bytu, na nacitanie znaku zo suboru
  cisla dw 20 dup(?)        ;alokacia 40 bytov na 20 cisel nacitanych zo suboru
  cislasort dw 20 dup(?)    ;alokacia 40 bytov na 20 zotriedenych cisel
  binar db 19 dup('0')      ;alokacia 17 bytov na cislo prevedene na binarny tvar + $
  pocet dw 0                ;adresa na ktorej je ulozeny dvojnasobny pocet nacitanych cisel - kvoli adresovaniu - word
  skutpoc dw 0              ;adresa na ktorej je ulozeny skutocny pocet cisel
  znamienko db 0                                  ;adresa na ktorej ukladam znamieko cinitela/delenca pri nasobeni/deleni
  znamdel   db 0                                  ;adresa na ktorej ukladam znamieno cinitela/delitela pri nasobeni/deleni
  textA db '1. Suma vsetkych cisel$'              ;prvy prikaz v hlavnom menu
  textB db '2. Usporiadat cisla vzostupne$'
  textC db '3. Usporiadat cisla zostupne$'
  textD db '4. Vydelit dve cisla$'
  textE db '5. Vynasobit dve cisla$'
  textN db '6. Vypisat prve cislo v doplnkovom kode v binarnom tvare$'
  textF db '7. Ukoncit program$'                  ;posledny prikaz v hlavnom menu
  textG db 'Sucet vsetkych cisel je: $'           ;ine retazce vypisovania podla potreby
  textH db 'Nastalo pretecenie!$'
  textI db 'Zvol delenca!$'
  textJ db 'Zvol delitela (pokial mozno <>0)!$'
  textK db 'Zvol prveho cinitela!$'
  textL db 'Zvol druheho cinitela!$'
  textM db 'Si sa s konom zrazil??!!$'
  ent db 0Dh,0Ah                  ;enter, pri vypisani zariadkuje
  nic   db '$'                    ;prazdny retazec
  deleno db ' / $'                ;vypisuje sa pri deleni
  krat db ' x $'                  ;vypisuje sa pri nasobeni
  rovnasa db ' = $'               ;vypisuje sa pri deleni/nasobeni
  zvis db '  zvysok= $'           ;vypisuje sa pri deleni
  vystup db 6 dup(?)              ;alokacia 6 bytov na vypis skonvertovaneho cisla na retazec
data ends                         ;koniec datoveho segmentu
code segment                      ;zaciatok kodoveho segmentu
  assume cs:code,ds:data,ss:zas   ;direktivy pre prekladac - pouzitie kodoveho, datoveho a zasobnikoveho segmentu
start:mov ax,seg data             ;do ax sa presunie segmentova adresa data segmentu
      mov ds,ax                   ;adresa sa vlozi do ds
      mov ah,3Dh                  ;sluzba na otvorenie suboru
      mov dx,offset path          ;do dx sa vlozi adresa miesta, kde je cesta k vstupnemu suboru
      mov al,0h                   ;parameter pri otvarani - len na citanie
      int 21h                     ;volanie prerusenia
      xor si,si                   ;vynulovanie registra si
      mov bx,ax                   ;do bx sa vlozi rukojet otvoreneho suboru - manipulator - handle
      xor di,di                   ;vynulovanie registra di
citaj:mov ah,3fh                  ;do ah sa vlozi cislo sluzby na citanie otvoreneho suboru
      mov dx,offset vstup         ;do dx sa vlozi adresa miesta v pameti, kam sa maju nacitane data ukladat
      mov cx,1                    ;do cx sa vlozi pocet znakov, ktore sa maju nacitat
      int 21h                     ;volanie prerusenia
      cmp ax,0                    ;skotroluje sa, ci bol precitany znak, ak ano ax=1
      jz eof                      ;ak ax=0 tak sme na konci suboru- skoci sa na navestie eof
      cmp [vstup],0Dh             ;precitany znak sa porovna s prvym znakom enteru
      jz ent1                     ;ak sa rovna-skace sa na navestie ent1 odkial sa skoci spat na citaj
      cmp [vstup],0Ah             ;precitany znak sa porovna s druhym znakom enteru
      jz ent2                     ;ak sa rovna tak sa skoci na ent2 - uz je nacitane jedno cislo
      cmp [vstup],'-'             ;nacitany znak sa porovna s minusom, ci nie je zaporne cislo
      jz minus                    ;ak sa rovna tak sa skace na minus
      sub [vstup],30h             ;od ascii znaku sa odcita 30h aby sme dostali cislo, ktore predstavuje ta cislica
      mov ax,di                   ;do ax sa vlozi obsah registra di
      mov cx,10                   ;do cx sa vlozi 10 = 0Ah
      xor ch,ch                   ;ch sa vynuluje
      mul cx                      ;cx sa vynasobi s ax vysledok je v ax:dx, ale pregram uvazuje len s ax- teda cislo musi byt min -32768 a max 32767
      mov di,ax                   ;do di sa vlozi obsah ax
      mov al,[vstup]              ;al sa vlozi naposledy nacitane cislo
      xor ah,ah                   ;ah sa vynuluje
      add di,ax                   ;k di sa pricita ax
ent1: jmp citaj                   ;skace sa na citaj

ent2: mov dx,offset cisla         ;tu uz je nacitane cele cislo a je v di, do dx sa vlozi adresa cisla
      mov [cisla+si],di           ;na tuto adresu sa napise prave nacitane cislo ako word
      cmp [znamienko],1           ;hodnota na adrese znamienko sa porovna s 1
      jnz plus                    ;ak sa nerovna, skace sa na plus - je to kladne cislo
      neg [cisla+si]              ;ak je program tu tak cislo je zaporne teda ho treba pretranformovat do doplnkoveho kodu
plus: mov [znamienko],0           ;hodnata na adrese znamienko sa nastavy na 0 - implicitna uroven
      xor di,di                   ;vynulovanie di - ide sa nacitavat dalsie cislo
      inc si                      ;2x inkrementacia si, lebo adresu v cislach treba posunut o 2 byty - kazde cislo je word
      inc si
      jmp citaj                   ;skace sa na citaj
minus:mov [znamienko],1           ;sem sa skoci ak je nacitany minus, info o tom sa ulozi na adrese znamienko
      jmp citaj                   ;skace sa na citaj

eof:  mov ah,3eh                  ;do ah sa vlozi cislo sluzby uzavretia suboru
      int 21h                     ;volanie prerusenia
      mov ax,si                   ;do ax sa vlozi obsah si-2x pocet cisel - bude sa delit
      mov [pocet],si              ;dvojansobny pocet sa ulozi na adresu pocet
      mov bx,2                    ;do bx sa vlozi 2
      div bl                      ;ax sa podeli bl-kom
      xor ah,ah                   ;vynuluje sa ah
      mov [skutpoc],ax            ;skutocny pocet v al sa ulozi na adresu skutpoc
      add [skutpoc],97            ;pripocita sa k nemu 97, lebo sa bude porovnavat s malymi pismenami
      xor si,si                   ;vynuluje sa si
opakuj:mov bx,[cisla+si]          ;do bx sa vlozi cislo na adrese cisla+si
      mov [cislasort+si],bx       ;na adresu cislasort+si sa vlozi obsah bx
      add si,2                    ;si sa zvisi o 2
      cmp si,[pocet]              ;si sa porovna s cislom na adrese pocet
      jnz opakuj                  ;ak sa nerovna tak spet na opakuj inak skonci
                                  ;tymto sa cele pole cisla prekopiruje do cislasort
menu: clrscr                      ;volanie makra na vymazanie obrzovky
      writeln textA               ;volanie procedury na vypisanie asgumentu - textA so zariadkovanim
      writeln textB               ;tymto sa vypise cele menu
      writeln textC
      writeln textD
      writeln textE
      writeln textN
      writeln textF
      mov ah,07h                  ;pocka sa na stlacenie klavesy
      int 21h                     ;volanie prerusenia, nacitana klavesa bude al

      cmp al,31h                  ;al sa porovna s 31h-klavesa1
      jnz next2                   ;ak sa nerovna - skoci sa na navestie next2
      xor di,di                   ;di a si sa vynuluju
      xor si,si
znovu1:add di,[cisla+si]          ;k di sa pripocita cislo z adresy cisla+si
      jo over                     ;ak nastane pretecenie
      cmp si,[pocet]              ;si sa prorovna s cislom na adrese pocet
      jz dost1                    ;ak sa rovna tak sa skonci
      add si,2                    ;si sa zvisi o 2
      jmp znovu1                  ;skoci sa na znovu
over: writeln nic                 ;sem sa dostane, ked nastane pretecenie - zariadkuje sa
      write textH                 ;vypise sa text na adrese textH
      mov ah,07h                  ;do ah sa vlozi cislo zluzby na nacitanie znaku
      int 21h                     ;zavola sa prerusenie
      jmp menu                    ;skoci sa do menu
dost1:writeln nic                 ;sem sa skoci ak sa vsetky cisla scitali - zariadkuje sa
      write textG                 ;vypise sa text na adrese textG
      convert                     ;cislo v di - sucet sa skovertuje na retazec a ulozi sa na adresu vystup
      write vystup                ;retazec na adrese vystup sa vypise
      mov ah,07                   ;do ah sa vlozi cislo obsluhy na nacitanie znaku
      int 21h                     ;volanie prerusenia
      jmp menu                    ;skace sa do menu

next2:cmp al,32h                  ;al sa porovna s 32h - klavesa 2
      jnz next3                   ;ak sa nerovna, tak sa skace na next3
      writeln nic                 ;zariadkuje sa
znovu2:xor si,si                  ;vynuluje sa si a dh
      xor dh,dh
zn:   mov ax,[cislasort+si]       ;do ax sa vlozi cislo na adrese cislasort+si
      add si,2                    ;si sa zvysi o 2
      mov bx,[cislasort+si]       ;do bx sa vlozi cislo z cislasort+si
      cmp ax,bx                   ;porovnaju sa
      jle pokr                    ;ak je ax mensi alebo rovny skace sa na pokr
      inc dh                      ;indikacia vymeny - dh sa zvisi o 1
      mov cx,ax                   ;ax a bx sa vymenia
      mov ax,bx
      mov bx,cx
      mov [cislasort+si-2],ax     ;ax a bx sa zapisu spet na si-2 a si-te miesto
      mov [cislasort+si],bx
pokr: mov di,[pocet]              ;do di sa vlozi pocet cisel
      sub di,2                    ;odpocita sa 2, lebo v bublesorte sa ide len po n-1 prvkov
      cmp si,di                   ;si sa porovna s di
      jnz zn                      ;ak sa nerovnaju - nie sme na konci skoci sa na zn
      cmp dh,0                    ;sme na konci, treba zistit, ci bola vymena
      jnz znovu2                  ;ak ano - dh<>0 skace sa na znovu

      writeln nic                 ;zariadkuje sa
      xor si,si                   ;si sa vynuluje
      mov ah,3ch                  ;do ah sa vlozi cislo obsluhy na vytvorenie vystupneho suboru
      xor cx,cx                   ;zposob otvorenia
      mov dx,offset pathout       ;do dx s vlozi adresa na ktorej je cesta k vystupnemu suboru
      int 21h                     ;volanie prerusenia
      mov bx,ax                   ;do bx sa vlozi rukojet vytvoreneho suboru - manipulator - handle

ok:   mov di,[cislasort+si]       ;do di sa vlozi cislo z cislasort+si
      convert                     ;konvertuje sa na retazec do vystupu
      writeln vystup              ;vypise sa vystup a zariadkuje sa
      mov ah,40h                  ;do ah sa vlozi cislo sluzby na zapis do suboru
      mov dx,offset vystup        ;do dx sa vlozi adresa, kde je retazec na zapis do suboru
      mov cx,6                    ;do cx sa zapise pocet znakov na zapisanie
      int 21h                     ;zavola sa prerusenie
      mov dx,offset ent           ;do dx sa vlozi adresa, kde je enter
      mov ah,40h                  ;enter sa zapise do suboru - zariadkuje sa
      mov cx,2
      int 21h
      add si,2                    ;si sa zvacsi o 2
      cmp si,[pocet]              ;porovna sa s poctom
      jnz ok                      ;ok sa nerovna tak sa skace na ok
      mov ah,3eh                  ;inak sa zavrie subor
      int 21h
      mov ah,07h                  ;pocka sa na stlacenie klavesy
      int 21h
      jmp menu                    ;slace sa do menu

next3:cmp al,33h                  ;al sa porovna s 33h - klavesa 3
      jnz next4                   ;ak sa nerovna, tak sa skace na next4
      writeln nic                 ;zariadkuje sa
znovu3:xor si,si                  ;vynuluje sa si a dh
      xor dh,dh
zn1:  mov ax,[cislasort+si]       ;do ax sa vlozi cislo na adrese cislasort+si
      add si,2                    ;si sa zvysi o 2
      mov bx,[cislasort+si]       ;do bx sa vlozi cislo z cislasort+si
      cmp ax,bx                   ;porovnaju sa
      jge pokr1                   ;ak je ax vacsi alebo rovny skace sa na pokr
      inc dh                      ;indikacia vymeny - dh sa zvisi o 1
      mov cx,ax                   ;ax a bx sa vymenia
      mov ax,bx
      mov bx,cx
      mov [cislasort+si-2],ax     ;ax a bx sa zapisu spet na si-2 a si-te miesto
      mov [cislasort+si],bx
pokr1:mov di,[pocet]              ;do di sa vlozi pocet cisel
      sub di,2                    ;odpocita sa 2, lebo v bublesorte sa ide len po n-1 prvkov
      cmp si,di                   ;si sa porovna s di
      jnz zn1                     ;ak sa nerovnaju - nie sme na konci skoci sa na zn
      cmp dh,0                    ;sme na konci, treba zistit, ci bola vymena
      jnz znovu3                  ;ak ano - dh<>0 skace sa na znovu

      writeln nic                 ;zariadkuje sa
      mov si,0                    ;si sa vynuluje
      mov ah,3ch                  ;do ah sa vlozi cislo obsluhy na vytvorenie vystupneho suboru
      mov dx,offset pathout       ;zposob otvorenia
      mov cx,0                    ;do dx s vlozi adresa na ktorej je cesta k vystupnemu suboru
      int 21h                     ;volanie prerusenia
      mov bx,ax                   ;do bx sa vlozi rukojet vytvoreneho suboru - manipulator - ha
ok1:  mov di,[cislasort+si]       ;do di sa vlozi cislo z cislasort+si
      convert                     ;konvertuje sa na retazec do vystupu
      writeln vystup              ;vypise sa vystup a zariadkuje sa
      mov ah,40h                  ;do ah sa vlozi cislo sluzby na zapis do suboru
      mov dx,offset vystup        ;do dx sa vlozi adresa, kde je retazec na zapis do suboru
      mov cx,6                    ;do cx sa zapise pocet znakov na zapisanie
      int 21h                     ;zavola sa prerusenie
      mov dx,offset ent           ;do dx sa vlozi adresa, kde je enter
      mov ah,40h                  ;enter sa zapise do suboru - zariadkuje sa
      mov cx,2
      int 21h
      add si,2                    ;si sa zvacsi o 2
      cmp si,[pocet]              ;porovna sa s poctom
      jnz ok1                     ;ok sa nerovna tak sa skace na ok
      mov ah,3eh                  ;inak sa zavrie subor
      int 21h
      mov ah,07h                  ;pocka sa na stlacenie klavesy
      int 21h
      jmp menu                    ;slace sa do menu

next4:cmp al,34h                  ;al sa provnava s 34h - klavesa 4
      jnz next5                   ;ak sa nazhoduje tak sa skace na next5
      xor si,si
      clrscr                      ;vymazanie obrazovky
dalsi:mov ax,si                   ;do ax sa vlozi si
      mov bl,2                    ;do bl sa vlozi 2
      div bl                      ;ax sa vydeli bl-kom
      mov dl,al                   ;podiel sa vlozi do dl
      add dl,97                   ;propocita sa k nemu  97 - bude sa vypisivat prisluchajuce male pismenamo
      mov ah,02h                  ;do ah sa 02- cislo obsluhy na vypisanie znaku
      int 21h                     ;zavola sa prerusenie
      mov dl,32                   ;do dl sa vlozi ascii medzeri
      int 21h                     ;zavola sa prerusenie- vypise sa medzera
      mov di,[cisla+si]           ;do di sa lozi cislo z cisla+si
      convert                     ;konvertuje sa na retazec do vystupu
      writeln vystup              ;vypise sa vystup
      add si,2                    ;si sa zvysi o 2
      cmp si,[pocet]              ;porovna sa s poctom
      jz vyps                     ;ak sa rovna tak sa skovi na vyps
      jmp dalsi                   ;inak sa skace na dalsi
vyps: writeln nic                 ;zaradkuje sa
      write textI                 ;vypise sa texI
zle1: mov ah,7                    ;pocka sa na stlacenie klavesy - volba delenca
      int 21h
      cmp al,96                   ;klavesa sa porovna s 96
      jl zle1                     ;ak je mensia tak treba znovu nacitat klavesu - skace sa na zle1
      xor ah,ah
      cmp ax,[skutpoc]            ;ax sa provna so skutocnym poctom - ten uz je zviseny o 97
      jg zle1                     ;ak je stlacena klavesa vacsia ako pocet clenov - treba ju znovu nacitat
      sub al,97                   ;od al sa odcita 97
      mov bx,2
      xor ah,ah
      mul bl                      ;al sa vynasobi 2-omi
      mov si,ax                   ;vysledok sa vlozi do si
      mov cx,[cisla+si]           ;do cx sa vlozi prislusne cislo
      writeln nic                 ;zaradkuje sa
      write textJ                 ;vypise textJ
zle2: mov ah,07h                  ;znovu sa caka na stlacenie klavesy - volba delitela
      int 21h
      cmp al,96                   ;porovna sa s 96
      jl zle2                     ;ak je mensa skace sa na zle2
      xor ah,ah
      cmp ax,[skutpoc]            ;porovna sa so skutocnym poctom
      jg zle2                     ;ak je vacsia ako skutocny poce, tak sa  skace na zle2
      sub al,97                   ;odci ta sa od al 97
      mov bx,2
      xor ah,ah
      mul bl                      ;al sa vynasobi 2-omi
      mov si,ax                   ;vysledo sa vlozi do si
      mov bx,[cisla+si]           ;do bx sa vlozi prislusne cislo
      writeln nic
      writeln nic
      cmp bx,0                    ;bx treba porovnat s 0, lebo nulou nemozno delit
      jnz notz                    ;ak nie je nula tak skoci na norz
      write textM                 ;vypise texM
      mov ah,1                    ;pocka na klavesu
      int 21h
      jmp menu                    ;skoci do menu
notz: mov di,cx                   ;sem sa skoci,ak delitel nie je nula - do di sa vlozi delenec
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
      write deleno                ;vypise sa deleno
      mov di,bx                   ;do di sa vlozi delitel
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
      write rovnasa               ;vypise sa rovnasa
      xor dx,dx
      mov ax,cx

      cmp ax,-32768               ;pripad kedy delime -32768/-1 treba zvlast osetrit
      jnz pokr2
      cmp bx,-1
      jnz pokr2
      write textH                 ;sem sa dostene iba ak ax=-32768 a bx=-1, vypise sa sprava o preteceni lebo 32768 nie je v intervale
      mov ah,01h
      int 21h      
      jmp menu

pokr2:mov [znamienko],0           ;znamienko delenca sa implicitne nastavuju na 0 teda +
      mov [znamdel],0             ;to iste aj znam. delitela
      cmp ax,0                    ;ax porovna s 0
      jg pl2                      ;ak je kladny tak sa skace
      mov [znamienko],1           ;ak nie je info o znamienku sa ulozi
      neg ax                      ;prevedie sa na kladne
pl2:  cmp bx,0                    ;to iste sa urovi s delitelom
      jg pl3
      mov [znamdel],1
      neg bx
pl3:  div bx                      ;ax sa podeli s bx-om
      mov ch,[znamienko]          ;do ch sa vlozi cislo z adr. znamienko
      mov cl,[znamdel]            ;do cl sa vlozi cislo z adt znamdel
      cmp ch,cl                   ;porovnaju sa
      jz klad                     ;ak su zhodne - podiel je kladny skoi sa na klad
      neg ax                      ;ak nie prevedie sa na zaporny
klad: mov ch,[znamienko]
      cmp ch,0
      jz klad1                    ;ak je delenec kladny - aj zvysok je kladny - skoci sa na klad1
      neg dx                      ;inak sa zvysok prevedie na zaporny
klad1:mov cx,dx
      mov di,ax                   ;podiel sa vlozi do di
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
      mov di,cx                   ;zvisok sa vlozi do di
      convert                     ;konveruje sa
      write zvis                  ;napise sa text 'zvysok'
      write vystup                ;napise sa zvysok
      mov ah,01h                  ;pocka sa na slacenie klavesy
      int 21h
      jmp menu                    ;skace sa do menu

next5:cmp al,35h                  ;al sa provnava s 35h - klavesa 5
      jnz next6                   ;ak sa nazhoduje tak sa skace na next6
      mov si,0
      clrscr                      ;vymazanie obrazovky
dalsi1:mov ax,si                  ;do ax sa vlozi si
      mov bl,2                    ;do bl sa vlozi 2
      div bl                      ;ax sa vydeli bl-kom
      mov dl,al                   ;podiel sa vlozi do dl
      add dl,97                   ;propocita sa k nemu  97 - bude sa vypisivat prisluchajuce male pismena
      mov ah,02h                  ;do ah sa 02- cislo obsluhy na vypisanie znaku
      int 21h                     ;zavola sa prerusenie
      mov dl,32                   ;do dl sa vlozi ascii medzeri
      int 21h                     ;zavola sa prerusenie- vypise sa medzera
      mov di,[cisla+si]           ;do di sa lozi cislo z cisla+si
      convert                     ;konvertuje sa na retazec do vystupu
      writeln vystup              ;vypise sa vystup
      add si,2                    ;si sa zvysi o 2
      cmp si,[pocet]              ;porovna sa s poctom
      jz vyps1                    ;ak sa rovna tak sa skoci na vyps1
      jmp dalsi1                  ;inak sa skace na dalsi
vyps1:writeln nic                 ;zaradkuje sa
      write textK                 ;vypise sa texI
zle3: mov ah,7                    ;pocka sa na stlacenie klavesy - volba prveho cinitela
      int 21h
      cmp al,96                   ;klavesa sa porovna s 96
      jl zle3                     ;ak je mensia tak treba znovu nacitat klavesu - skace sa na zle3
      xor ah,ah
      cmp ax,[skutpoc]            ;ax sa provna so skutocnym poctom - ten uz je zviseny o 97
      jg zle3                     ;ak je stlacena klavesa vacsia ako pocet clenov - treba ju znovu nacita
      sub al,97                   ;od al sa odcita 97
      mov bx,2
      xor ah,ah
      mul bl                      ;al sa vynasobi 2-omi
      mov si,ax                   ;vysledok sa vlozi do si
      mov cx,[cisla+si]           ;do cx sa vlozi prislusne cislo
      writeln nic                 ;zaradkuje sa
      write textL                 ;vypise textL
zle4: mov ah,07h                  ;znovu sa caka na stlacenie klavesy - volba druheho cinitela
      int 21h
      cmp al,96                   ;porovna sa s 96
      jl zle4                     ;ak je mensa skace sa na zle4
      xor ah,ah
      cmp ax,[skutpoc]            ;porovna sa so skutocnym poctom
      jg zle4                     ;ak je vacsia ako skutocny pocet, tak sa  skace na zle2
      sub al,97                   ;odci ta sa od al 97
      mov bx,2
      xor ah,ah
      mul bl                      ;al sa vynasobi 2-omi
      mov si,ax                   ;vysledo sa vlozi do si
      mov bx,[cisla+si]           ;do bx sa vlozi prislusne cislo
      writeln nic
      writeln nic
      mov di,cx                   ;do di sa vlozi prvy cinitel
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
      write krat                  ;vypise sa krat
      mov di,bx                   ;do di sa vlozi druhy cinitel
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
      write rovnasa               ;vypise sa rovnasa
      mov dx,0
      mov ax,cx

      cmp ax,-32768               ;treba osetrit pripad -32768 x 1,lebo tento algoritmus by vyhlasil pretecenie
      jnz pokr3
      cmp bx,1
      jnz pokr3
      mov di,-32768               ;do dx sa vlozi vysledok -32768 x 1 teda -32768
      convert                     ;konvertuje sa na retazac
      write vystup                ;a vypise sa
      mov ah,01
      int 21h
      jmp menu
pokr3:cmp ax,1                    ;to iste treba urobit s pripadom 1 x -32768
      jnz pokr4
      cmp bx,-32768
      jnz pokr4
      mov di,-32768
      convert
      write vystup
      mov ah,01
      int 21h
      jmp menu

pokr4:mov [znamienko],0           ;znamienko delenca sa implicitne nastavuju na 0 teda +
      mov [znamdel],0             ;to iste aj znam. delitela
      cmp ax,0                    ;ax porovna s 0
      jg pl4                      ;ak je kladny tak sa skace na pl4
      mov [znamienko],1           ;ak nie je info o znamienku sa ulozi
      neg ax                      ;prevedie sa na kladne
pl4:  cmp bx,0                    ;to iste sa urovi s delitelom
      jg pl5
      mov [znamdel],1
      neg bx
pl5:  mul bx                      ;ax sa vynasobi s bx-om
      cmp ax,0                    ;ax sa porovna s 0, ak je sucin zaporny - nastalo pretecenie cez 32767
      jge nieje1                  ;ak je vacsi tka sa skace na nieje1
      write textH                 ;inka sa vypise textH a skoci sa na pock
      jmp pock
nieje1:mov ch,[znamienko]         ;do ch sa vlozi cislo z adr. znamienko
      mov cl,[znamdel]            ;do cl sa vlozi cislo z adt znamdel
      cmp ch,cl                   ;porovnaju sa
      jz klad2                    ;ak su zhodne - sucin je kladny skoci sa na klad2
      neg ax                      ;ak nie prevedie sa na zaporny
klad2:cmp dx,0                    ;ak je dx 0 - nenastalo pretecinie
      jz nieje
      write textH                 ;ak nastalo, tak sa vypise textH
      jmp pock                    ;skoci sa na pock
nieje:mov di,ax                   ;inka sa do di vlozi sucin
      convert                     ;konvertuje sa
      write vystup                ;vypise sa
pock: mov ah,01h                  ;pocka sa na stlacenie klavesy
      int 21h
      jmp menu                    ;skace do menu

next6:cmp al,36h                  ;al sa porovna s 36h - klavesa 6
      jnz next7                   ;ak sa nerovna tak sa skace na next7
      writeln nic
      writeln nic
      mov si,0
      mov bx,8000h                ;do bx sa vlozi 8000h to je 1 a 15 nul
znovu:mov ax,[cisla]              ;do ax sa vlozi 1 cislo
      and ax,bx                   ;logicky sa vynasobia
      cmp ax,bx                   ;ak bol najvyssi bit v ax 1 tak sa budu rovnat
      jnz nula                    ;ak nie tak sa skoci na nula
      mov [binar+si],'1'          ;inak sa do binar+si napise 1, implucitne je cele nulove
nula: inc si                      ;si sa inkrementuje
      cmp bx,1                    ;bx sa potovna s 1
      jz vypis                    ;ak sa rovna - sme na konci - treba vypisat binar
      mov ax,bx                   ;inak sa bx vlozi do ax
      xor dx,dx
      mov bx,2                    ;do bx sa vlozi 2
      div bx                      ;ax sa vydeli bx - om, tym dostavame v bin tvare o jednu nulu menej
      mov bx,ax
      jmp znovu                   ;skoci sa na znovu
vypis:mov [binar+16],13           ;nakoniec sa prida enter a $
      mov [binar+17],10
      mov [binar+18],'$'
      write binar                 ;binar sa vypise
      mov ah,01                   ;pocka sa na stlacenie klavesy
      int 21h
      jmp menu                    ;skoci sa do menu
next7:cmp al,37h                  ;al sa porovna s 37h - klavesa 7
      jnz menu                    ;ak sa nerovna, skoci sa spet do menu

konec:mov ah,4Ch                  ;inak sa program ukonci
      int 21h

_clrscr proc near                 ;deklaracia procedury _clrscr - vymazanie obrazovky
  mov ax,0003h                    ;do ax sa vlozi parametre grafickeho modu 80x25
  int 10h
  ret                             ;navrat k miestu, odkial bola procedura volana
_clrscr endp                      ;koniec procedury

_writeln proc near                ;deklaracia procedury _writeln - vypisanie retazca so zarodkovanim
  push ax                         ;ax sa odlozi do zasobnika
  push dx
  mov ah,09h                      ;do ah sa vlozi cislo obsluhy na vypisanie retazca
  int 21h
  mov ah,02                       ;vypise sa enter
  mov dl,13
  int 21h
  mov dl,10
  int 21h
  pop dx                          ;do dx sa vlozi jeho popvodna hodnota zo zasobnkika
  pop ax
  ret                             ;navrat k miestu, odkial bola procedura volana
_writeln endp                     ;koniec procedury

_write proc near                  ;deklaracia procedury _write - vypisanie retazca
  push ax                         ;ax sa odlozi do zasobnika
  mov ah,09h                      ;vypise sa retazec
  int 21h
  pop ax                          ;do ax sa vlozi jeho povodna hodnota
  ret                             ;navrat k miestu odkial bola procedura volana
_write endp                       ;koniec procedury

_convert proc near                ;deklaracia procedury _convert - na konvertovanie cisla v di do retazca vystup
      push si                     ;odlozenie registov do zasobnika
      push ax
      push bx
      push cx
      push dx
      push di
      mov si,0
      mov ax,di                   ;di sa vlozi do ax
      cmp ax,0                    ;ax porovna sa z 0
      jg pl                       ;ak je kladny skace na pl
      mov [vystup],'-'            ;inak nulty znak vystupu nastavi na -
      inc si                      ;zvisi si o 1
      mov bx,65535                ;ak je zaporne musim ho odcitat od 65535 - dostanem sice kladne, ale znamienko je uz napisane
      sub bx,ax
      mov ax,bx
      inc ax                      ;ax musim este o 1 zvysit - doplnkovy kod
      mov di,ax                   ;takto upravene cislo vratim do di
      jmp zac                     ;skoci na zac
pl:   mov [vystup],'+'            ;sem sa dostane, ak boli di na zaciatku kladne
      inc si
zac:  mov dx,0
      mov bx,10000                ;do bx sa vlozi  10000
      div bx                      ;ax sa vyseli bx - om
      mov [vystup+si],al          ;podiel sa zapise na prve miesto
      add [vystup+si],30h         ;pripocita sa 30h, abu sme dostali cislicu
      mov cl,al                   ;teraz sa podiel vlozi do cl
      xor ch,ch
      mov ax,bx                   ;do ax sa vlozi tych 10000
      mul cx                      ;ax sa vynasobi s podielom
      sub di,ax                   ;a odpocita od di
      mov ax,di                   ;spat sa sa to vlozi do ax
      mov bx,1000                 ;teraz sa postu opakuje pre 10krat mensie bx
      mov dx,0
      div bx
      inc si
      mov [vystup+si],al          ;podiel sa vlozi na 2 miesto
      add [vystup+si],30h         ;pripocita sa 30h
      mov cl,al
      xor ch,ch
      mov ax,bx
      mul cx                      ;vynasobi sa podiel krat 1000
      sub di,ax                   ;odpocita sa od di
      mov ax,di                   ;a vlozi do ax
      mov bx,100                  ;znovy pre 100
      mov dx,0
      div bx
      inc si
      mov [vystup+si],al          ;podiel sa napise na 3 miesto
      add [vystup+si],30h
      mov cl,al
      xor ch,ch
      mov ax,bx
      mul cx
      sub di,ax
      mov ax,di
      mov bx,10                   ;znavu pre 10
      mov dx,0
      div bx
      inc si
      mov [vystup+si],al          ;podiel sa napise na 4 miesto
      add [vystup+si],30h
      mov cl,al
      xor ch,ch
      mov ax,bx
      mul cx
      sub di,ax
      mov ax,di
      inc si
      mov [vystup+si],al          ;jednotkou uz netreba delit jednotky sa napisu na 5 miesto
      add [vystup+si],30h
      inc si
      mov [vystup+si],'$'         ;pripise sa $
      pop di                      ;do di sa vrati jeho povodna hodnota - ked bola procedura zavolana
      cmp di,0                    ;porovna sa z 0
      jnz neni1                   ;ak sa nerovna 0 tak skace na neni1
      mov [vystup],'+'            ;inak nestav znamienko na +
neni1:pop dx                      ;vrati registrom ich povodne hodnoty zo zasobnika
      pop cx
      pop bx
      pop ax
      pop si
      ret                         ;navrat k miestu, odkial bola procedura volana
_convert endp                     ;koniec procedury

code ends                         ;koniec datoveho segmentu
end start

;Program cita zo vstupneho suboru 'vstup.txt' ,ktory je priamo v aktualnom adresari
;kde je program spusteny. Vysledky triedeni vypisuje do vystupneho suboru 'vystup.txt'
;Program pracuje na intervale integer <-32768,32767>. Ak je vo vstupnom subore cislo mezi
;<32768,65535>, program ich konvertuje na zaporne cisla - doplnkovy kod.
;V programe je jedna funkcia navyse: Konveruje prve cislo v subore do binarneho
;kodu a vypisuje ho na obrazovku.