;Zadanie c.2
;Text zadania:
;Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
;(aspon 10) so znamienkom v desiatkovej ciselnej sustave, potom ich 
;transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom kode 
;a potom podla priania pouzivatela:
;a) vypocita sumu vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne resp. zostupne a zapise usporiadanu postupnost
;cisel do noveho textoveho suboru,
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.
;
;Na pracu so subormi mozete pouzit napr. sluzby 3dH, 3eH, 3fH,40H.
;Vysledky operacii treba vypisovat v desiatkovej ciselnej sustave.
;Ak by pri  vypocte doslo k preteceniu, oznamte prekrocenie pripustneho 
;ciselneho rozsahu.
;Autor: PETER HLOCKY
;Termin odovzdania: 14.11.2000
;2.roc.,sk.rok 2000/2001
;

ZAS	SEGMENT	STACK				;zasobnik
	DW	1000 DUP(?)
ZAS	ENDS

DATA	SEGMENT
VSTUP	DB	'vstup.txt',0
VYSTUP	DB	'vystup.txt',0	
VYSTUP2	DB	'vystup2.txt',0	
TEXT2	DB	'NASTALO PRETECENIE. $'
TEXT3	DB	'Suma vsetkych cisel je :$'
TEXT4	DB	10,13,'Zadaj index 1.cinitela : $'
TEXT5	DB	10,13,'Sucin : $'
TEXT6	DB	10,13,'Zadaj index 2.cinitela : $'
TEXT7	DB	10,13,'Zadaj index menovatela : $'
TEXT8	DB	10,13,'Podiel : $'
TEXT9	DB	10,13,'Zadaj index delitela : $'
MENU	DB	'1 - Vypocet sumy vsetkych cisel',10,13		;DEFINICIA TEXTOV PRE MENU
	DB	'2 - Usporiadanie cisel vzostupne',10,13
	DB	'3 - Usporiadanie cisel zostupne',10,13
	DB	'4 - Podiel dvoch cisel',10,13
	DB	'5 - Sucin dvoch cisel',10,13
	DB	'6 - Koniec programu$'
POCETC	DB	0
RETAZEC	DB	1001 DUP(?) 						;REZERVOVANIE MIESTA V PAMATI PRE RETAZEC NACITANYCH ZNAKOV
CISLO	DW	100 DUP(0)
POMCIS	DW	100 DUP(0)
VOLBA	DB	10
RETSUB	DW	1000 DUP(0)	
SUBOR	DW	1000 DUP(0)
FHANDLE	DW	?
;XXX	DB	?	
;ENT	DB	10,13
DATA 	ENDS

CODE	SEGMENT
	ASSUME	DS:DATA,CS:CODE, SS:ZAS

START:
	MOV 	AX,SEG DATA				
	MOV	DS,AX					;INICIALIZACIA DS
	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	AH,3DH
	MOV	AL,0					;READ ONLY
	MOV	DX,OFFSET VSTUP
	INT	21H					;OTVORENIE VSTUPNEHO SUBOR
	PUSH	AX
	MOV	BX,AX

	MOV	DX,OFFSET RETAZEC
	MOV	AH,3FH	
	MOV	CX,1000					;POCET NACITANYCH BYTOV				
	INT	21H					;NACITANIE ZO SUBORU
	MOV	DI,DX
	MOV	BX,AX					;V BX BUDE POCET ZNAKOV RETAZCA
	MOV	BYTE PTR [BX+DI],'$'			;RETAZEC SA UKONCI $
	
	POP	AX
	MOV	BX,AX	
	MOV	AH,3EH					;ZATVORENIE VSTUP. SUBORU
	INT	21H
	CALL	PCISLA					;PREVOD ZNAKOV NA CISLA
	
NMENU:	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET MENU				;VYPIS MENU
	MOV	AH,09H
	INT	21H
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	CMP	AL,'1'					;ZISTUJE CI BOL STLACENA NIEKTORA Z VOLIEB
	JE	NSUMA					;AK BOLA STLACENA 1 SKOC NA NA KONTRETNU FUNKCIU
	JMP	TEST1
NSUMA:	CALL	SUMA					;REALIZACIA MENU
	JMP	NMENU
TEST1:	CMP	AL,'2'	
	JE	NVZOS
	JMP	TEST2
NVZOS:	CALL	VZOS
	MOV	DX,OFFSET VYSTUP
	MOV	DI,OFFSET CISLO
	MOV	AH,3CH
	MOV	AL,1					;WRITE ONLY
	INT	21H					;OTVORENIE SUBORU
	MOV	[FHANDLE],AX
	MOV	BX,[FHANDLE]				;FILE HANDLE
	MOV	CL,[POCETC]				;POCET CISEL
OPAKUJ:	CMP	CL,0
	JE	KON100
	PUSH	CX
	MOV	AX,[DI]
	CALL	VYPSUB
	MOV	DX,OFFSET RETSUB			;BUFFER
	MOV	CX,7					;POCET ZAPISOVANYCH BYTOV
	MOV	BX,[FHANDLE]				;FILE HANDLE
	MOV	AH,40H
	INT	21H
	MOV	AH,42H					;POSUN NA KONIEC SUBORA	
	MOV	AL,2
	;MOV	BX,[FHANDLE]
	MOV	CX,0
	MOV	DX,0
	INT	21H
	
	;MOV	DX,OFFSET ENT
	;MOV	CX,1					;POCET ZAPISOVANYCH BYTOV
	;MOV	AH,40H
	;INT	21H					;VYPISE MEDZERU	
	POP	CX
	INC	DI
	INC	DI
	DEC	CL
	JMP	OPAKUJ
KON100:	MOV	AH,3EH					;ZATVORENIE VYSTUP. SUBORU
	INT	21H
	JMP	NMENU
TEST2:	CMP	AL,'3'	
	JE	NZOST
	JMP	TEST3
NZOST:	CALL	ZOST
	;MOV	DX,OFFSET VYSTUP2
	;MOV	DI,OFFSET CISLO
	;MOV	AH,3CH
	;MOV	AL,1					;WRITE ONLY
	;INT	21H					;OTVORENIE SUBORU
	;MOV	[FHANDLE],AX
	;MOV	BX,[FHANDLE]				;FILE HANDLE
	;MOV	CL,[POCETC]				;POCET CISEL
OPAKUJ2:;CMP	CL,0
	;JE	KON10
	;PUSH	CX
	;MOV	AX,[DI]
	;CALL	VYPSUB
	;MOV	DX,OFFSET RETSUB			;BUFFER
	;MOV	CX,7					;POCET ZAPISOVANYCH BYTOV
	;MOV	BX,[FHANDLE]				;FILE HANDLE
	;MOV	AH,40H
	;INT	21H
	;MOV	AH,42H					;POSUN NA KONIEC SUBORA	
	;MOV	AL,2
	;;;;;MOV	BX,[FHANDLE]
	;MOV	CX,0
	;MOV	DX,0
	;INT	21H
	;POP	CX
	;INC	DI
	;INC	DI
	;DEC	CL
	;JMP	OPAKUJ2
KON10:	;MOV	AH,3EH					;ZATVORENIE VYSTUP. SUBORU
	;INT	21H

	JMP	NMENU	
TEST3:	CMP	AL,'4'	
	JE	NPODIEL
	JMP	TEST4
NPODIEL:CALL	PODIEL
	JMP	NMENU
TEST4:	CMP	AL,'5'	
	JE	NSUCIN
	JMP	TEST5
NSUCIN:	CALL	SUCIN
	JMP	NMENU
TEST5:	CMP	AL,'6'	
	JE	KONIEC
	JMP	NMENU
	
KONIEC:	MOV	AX,4C00H				;KONIEC
	INT	21H	
			
PCISLA	PROC	NEAR
	MOV	DI,OFFSET RETAZEC
	MOV	SI,OFFSET CISLO
NOVEC:	MOV	BP,1					;ZATIAL JE ZNAMIEKO KLADNE
DALEJ:	MOV	AL,[DI]
	MOV	CL,AL					;ZALOHA DO CL
	CMP	AL,2FH
	JBE	NECIS	
	CMP	AL,3AH
	JNB	NECIS
	AND	AX,0FH					; V AX BUDE BCD TVAR
	PUSH	AX
	MOV	AX,[SI]
	MOV	CX,10
	IMUL	CX					;TO CO JE V CISLO VYNASOBI 10
	JO	PREPL					;PREPLNENIE
	MOV	[SI],AX
	POP	AX
	ADD	[SI],AX					;PRIPOCITA SA NIZSI RAD
	JO	PREPL
	INC	DI					;POSUN NA DALSI ZNAK
	JMP	DALEJ
NECIS:	PUSH	CX
	CMP	CL,'-'
	JE	ZNAM		
	MOV	CX,BP
	MOV	AX,[SI]
	IMUL	CX					;UPRAVI SA PODLA ZNAMIENKA
	MOV	[SI],AX					;ULOZI SA DO CISLA
	INC	BYTE PTR [POCETC]					;IKREMENTUJE SA POCET CISEL
	POP	CX
	CMP	CL,'$'
	JE	KONRET
	INC	DI	
	ADD	SI,2					;POSUNIE SA NA DALSIE MIESTO PRE DALSIE CISLO
	JMP	NOVEC
KONRET:	RET
ZNAM:	MOV	BP,0FFFFH				;AK JE CISLO ZAPORNE
	INC	DI
	JMP	DALEJ
PREPL:	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	DX,OFFSET TEXT2
	MOV	AH,09H
	INT	21H					;CHYBOVA HLASKA
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	MOV	AX,4C00H			
	INT	21H					;KONIEC
PCISLA	ENDP

SUCIN	PROC	NEAR					;PROCEDURA NA SUCIN DVOCH CISEL
	MOV	BX,OFFSET CISLO
	MOV	CX,WORD PTR [POCETC]			;CX=POCET CISEL
	XOR	CH,CH
	XOR	SI,SI
	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
SUOPAK:	CMP	CL,0					;SKAC KYM NIEJE POCET NULOVY
	JE	SUKON
	PUSH	SI
	MOV	AX,SI
	MOV	DX,0
	MOV	DI,5
	DIV	DI
	CMP	DX,0					;CI NIEJE PIATY PRVOK
	JNE	SUPOK
	MOV	DX,10
	MOV	AH,2
	INT	21H					;PO KAZDOM PIATOM CISLE ODRIADKUJE
	MOV	DX,13
	MOV	AH,2
	INT	21H					;PO KAZDOM PIATOM CISLE ODRIADKUJE
SUPOK:	POP	SI
	MOV	AX,SI					;POZICIA CISEL
	CALL	VYPIS
	MOV	DL,'.'
	MOV	AH,2
	INT	21H					;VYPISE BODKU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	AX,[BX]					;PRVOK Z RETAZCA DA DO AX
	CALL	VYPIS
	INC	BX
	INC	BX					;POSUN NA DALSI PRVOK
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	INC	SI					;INDEX PRED CISLOM
	DEC	CX
	JMP	SUOPAK		
SUKON:	MOV	DL,OFFSET TEXT4
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	DX,OFFSET VOLBA
	MOV	AH,0AH
	INT	21H					;NACITANIE VOLBY 1.CINITELA
	CALL	MSTOI
	MOV	CX,2
	IMUL	CX					;ZISTI SA POZICIA V RETAZCI
	MOV	DI,AX
	MOV	DL,OFFSET TEXT6
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	DX,OFFSET VOLBA
	MOV	AH,0AH
	INT	21H					;NACITANIE VOLBY 1.CINITELA
	CALL	MSTOI
	MOV	CX,2
	IMUL	CX					;ZISTI SA POZICIA V RETAZCI
	MOV	SI,AX
	MOV	DL,OFFSET TEXT5
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	BX,OFFSET CISLO
	MOV	AX,[BX+SI]
	MOV	CX,[BX+DI]				;AX=2. CINITEL,CX=1.CINITEL
	IMUL	CX					
	JO	SUPRET					;CI NENASTALO PRETECENIE
	CALL	VYPIS
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	RET
SUPRET:	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	DX,OFFSET TEXT2
	MOV	AH,09H
	INT	21H					;CHYBOVA HLASKA
	RET
SUCIN	ENDP

PODIEL	PROC	NEAR					;PROCEDURA NA SUCIN DVOCH CISEL
	MOV	BX,OFFSET CISLO
	MOV	CX,WORD PTR [POCETC]			;CX=POCET CISEL
	XOR	CH,CH
	XOR	SI,SI
	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
POOPAK:	CMP	CL,0					;SKAC KYM NIEJE POCET NULOVY
	JE	POKON
	PUSH	SI
	MOV	AX,SI
	MOV	DX,0
	MOV	DI,5
	DIV	DI
	CMP	DX,0					;CI NIEJE PIATY PRVOK
	JNE	POPOK
	MOV	DX,10
	MOV	AH,2
	INT	21H					;PO KAZDOM PIATOM CISLE ODRIADKUJE
	MOV	DX,13
	MOV	AH,2
	INT	21H					;PO KAZDOM PIATOM CISLE ODRIADKUJE
POPOK:	POP	SI
	MOV	AX,SI					;POZICIA CISEL
	CALL	VYPIS
	MOV	DL,'.'
	MOV	AH,2
	INT	21H					;VYPISE BODKU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	AX,[BX]					;PRVOK Z RETAZCA DA DO AX
	CALL	VYPIS
	INC	BX
	INC	BX					;POSUN NA DALSI PRVOK
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	MOV	DL,' '
	MOV	AH,2
	INT	21H					;VYPISE MEZERU
	INC	SI					;INDEX PRED CISLOM
	DEC	CX
	JMP	POOPAK		
POKON:	MOV	DL,OFFSET TEXT7
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	DX,OFFSET VOLBA
	MOV	AH,0AH
	INT	21H					;NACITANIE VOLBY 1.CINITELA
	CALL	MSTOI
	MOV	CX,2
	IMUL	CX					;ZISTI SA POZICIA V RETAZCI
	MOV	DI,AX
	MOV	DL,OFFSET TEXT9
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	DX,OFFSET VOLBA
	MOV	AH,0AH
	INT	21H					;NACITANIE VOLBY 1.CINITELA
	CALL	MSTOI
	MOV	CX,2
	IMUL	CX					;ZISTI SA POZICIA V RETAZCI
	MOV	SI,AX
	MOV	DL,OFFSET TEXT8
	MOV	AH,09H
	INT	21H					;VYPISE INFO PRE UZIVATELA
	MOV	BX,OFFSET CISLO
	MOV	AX,[BX+SI]
	MOV	CX,[BX+DI]				;AX=DELITEL,CX=MENOVATEL
	XCHG	CX,AX
	CWD						;UPRAVA ZNAMIENKA DELITELA
	IDIV	CX					
	JO	POPRET					;CI NENASTALO PRETECENIE
	CALL	VYPIS
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	RET
POPRET:	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	DX,OFFSET TEXT2
	MOV	AH,09H
	INT	21H					;CHYBOVA HLASKA
	RET
PODIEL	ENDP


MSTOI	PROC	NEAR					;PROCEDURA NA KONVERZIU RETAZCA NA CISLO
	PUSH	DI
	MOV	DI,OFFSET VOLBA
	MOV	AL,[DI+1]				;AX=POCET NAC. ZNAKOV 
	XOR	AH,AH
	CMP	AX,2					;PODLA POCTU NAC. CISEL
	JE	DVECIS
	MOV	AL,[DI+2]				;ZOBERE CISLO
	XOR	AH,AH
	SUB	AX,30H					;ODCITA 30H='0'  
	POP	DI
	RET
DVECIS:	MOV	AL,[DI+2]				;VEZME 1.CISLICU
	XOR	AH,AH
	SUB	AX,30H
	MOV	CX,10
	IMUL	CX
	MOV	CL,[DI+3]				;VEZME 2. CISLICU
	XOR	CH,CH
	SUB	CX,30H					;ODCITA 30H='0'
	ADD	AX,CX
	POP	DI
	RET
MSTOI	ENDP


SUMA	PROC	NEAR
	MOV	CX,WORD PTR [POCETC]				;CX=POCET CISEL
	XOR	CH,CH
	MOV	SI,OFFSET CISLO
	XOR	BX,BX
OPAK1:	ADD	BX,[SI]					;V BX BUDE SUMA CISEL
	JO	PRETEC
	DEC	CX
	JCXZ	KONSUM					;AK BOLO POSLEDNE CISLO
	INC	SI
	INC	SI
	JMP	OPAK1
KONSUM:	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	DX,OFFSET TEXT3
	MOV	AH,09H
	INT	21H					;TEXT PRE UZIVATELA
	MOV	AX,BX
	CALL	VYPIS
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	RET
PRETEC:	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	DX,OFFSET TEXT2
	MOV	AH,09H
	INT	21H					;CHYBOVA HLASKA
	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	MOV	AX,4C00H			
	INT	21H					;KONIEC
SUMA	ENDP

VZOS	PROC	NEAR					;PROCEDURA NA USPORIADANIE VZOSTUPNE
	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	CX,1					;AK JE CX=0,TAK JE HOTOVO
VZNOVA:	JCXZ	VKON					;USPORIADANE AK CX JE NULA
	MOV	BX,WORD PTR [POCETC]			;BX=POCET CISEL
	XOR	BH,BH
	DEC	BX					;BX=POCET-1
	MOV	SI,OFFSET CISLO
	MOV	CX,0
VZOPAK:	CMP	BX,0					;CI JE NA KONCI RIADKU
	JZ	VZNOVA
	MOV	DX,[SI]
	MOV	AX,[SI+2]
	CMP	DX,AX					;POROVNA CI MA PREHADZOVAT
	JG	PREHOD
	INC	SI
	INC	SI
	DEC	BX					;DEKREMENTNE POCET CISEL
	JMP	VZOPAK	
PREHOD:	MOV	DX,[SI]					;PREHODENIE DVOCH PRVKOV
	MOV	AX,[SI+2]
	XCHG	AX,DX
	MOV	[SI],DX
	MOV	[SI+2],AX
	INC	SI
	INC	SI
	DEC	BX					;DEKREMENTNE POCET CISEL
	MOV	CX,1
	JMP	VZOPAK
VKON:	MOV	SI,OFFSET CISLO
	MOV	CX,WORD PTR [POCETC]			;POCET CISEL
	XOR	CH,CH
VOPAK2:	JCXZ	VKON2
	MOV	DL,' '					;VYPISE MEDZERU
	MOV	AH,2
	INT	21H	
	MOV	AX,[SI]
	CALL	VYPIS					;POSTUPNE VYPISE CELY RETAZEC
	DEC	CX					;DEKREMENTNE POCET CISEL
	INC	SI
	INC	SI
	JMP	VOPAK2
VKON2:	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	RET
VZOS	ENDP

ZOST	PROC	NEAR					;PROCEDURA NA USPORIADANIE VZOSTUPNE
	MOV	AX,3
	INT	10H					;VYMAZE OBRAZOVKU
	MOV	CX,1					;AK JE CX=0,TAK JE HOTOVO
ZZNOVA:	JCXZ	ZKON					;USPORIADANE AK CX JE NULA
	MOV	BX,WORD PTR [POCETC]			;BX=POCET CISEL
	XOR	BH,BH
	DEC	BX					;BX=POCET-1
	MOV	SI,OFFSET CISLO
	MOV	CX,0
ZZOPAK:	CMP	BX,0					;CI JE NA KONCI RIADKU
	JZ	ZZNOVA
	MOV	DX,[SI]
	MOV	AX,[SI+2]
	CMP	DX,AX					;POROVNA CI MA PREHADZOVAT
	JL	ZPREHOD
	INC	SI
	INC	SI
	DEC	BX					;DEKREMENTNE POCET CISEL
	JMP	ZZOPAK	
ZPREHOD:MOV	DX,[SI]					;PREHODENIE DVOCH PRVKOV
	MOV	AX,[SI+2]
	XCHG	AX,DX
	MOV	[SI],DX
	MOV	[SI+2],AX
	INC	SI
	INC	SI
	DEC	BX					;DEKREMENTNE POCET CISEL
	MOV	CX,1
	JMP	ZZOPAK
ZKON:	MOV	SI,OFFSET CISLO
	MOV	CX,WORD PTR [POCETC]			;POCET CISEL
	XOR	CH,CH
ZOPAK2:	JCXZ	ZKON2
	MOV	DL,' '					;VYPISE MEDZERU
	MOV	AH,2
	INT	21H	
	MOV	AX,[SI]
	CALL	VYPIS					;POSTUPNE VYPISE CELY RETAZEC
	DEC	CX					;DEKREMENTNE POCET CISEL
	INC	SI
	INC	SI
	JMP	ZOPAK2
ZKON2:	MOV	AH,08H
	INT	21H					;CAKA NA KLAVESU
	RET
ZOST	ENDP


VYPIS	PROC	NEAR
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	MOV	SI,OFFSET POMCIS	
	XOR	DI,DI
	MOV	BX,AX					;AX SA DA DO BX ABY BOL AX POUZITELNY
	AND	BX,8000H				
	JZ	VZNAM					;ZISTI CI JE CISLO ZAPORNE
	MOV	BX,0FFFFH
	IMUL	BX					;AK JE CISLO ZAPORNE
	PUSH	AX
	MOV	DL,'-'
	MOV	AH,2
	INT	21H					;VYPISE SA MINUS
	POP	AX
VZNAM:	MOV	BX,AX
VOPAK:	ADD	SI,2
	CMP	BX,10000
	JAE	DESTIS
	CMP	BX,1000
	JAE	TIS
	CMP	BX,100
	JAE	STO
	CMP	BX,10
	JAE	DES
	MOV	DX,BX
	OR	DL,30H
	MOV	AH,2
	INT	21H				;VYPIS POSLEDNEHO RADU
	DEC	SI
	DEC	SI
VYOPAK:	CMP	DI,0
	JE	VOKEJ
	MOV	DL,[SI]
	MOV	AH,2
	INT	21H
	DEC	SI
	DEC	SI
	DEC	DI
	JMP	VYOPAK
VOKEJ:	POP	DI
	POP	SI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RET
DESTIS:	MOV	DX,0	
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	DI				;POCET RADOV
	JMP	VOPAK
TIS:	MOV	DX,0
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	DI				;POCET RADOV
	JMP	VOPAK
STO:	MOV	DX,0
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	DI				;POCET RADOV
	JMP	VOPAK
DES:	MOV	DX,0
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	MOV	BX,AX				;ZALOHA ZVYSKU
	OR	DX,30H				;VYROBI SA CISLICA TISICOK
	MOV	[SI],DX
	INC	DI				;POCET RADOV
	JMP	VOPAK
VYPIS	ENDP

VYPSUB	PROC	NEAR
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	MOV	SI,OFFSET POMCIS	
	MOV	DI,OFFSET RETSUB
	XOR	CX,CX
	MOV	BX,AX					;AX SA DA DO BX ABY BOL AX POUZITELNY
	AND	BX,8000H				
	JZ	SUBNAM					;ZISTI CI JE CISLO ZAPORNE
	MOV	BX,0FFFFH
	IMUL	BX					;AK JE CISLO ZAPORNE
	PUSH	AX
	MOV	WORD PTR [DI],'-'
	INC	DI
	POP	AX
SUBNAM:	MOV	BX,AX
SUBPAK:	ADD	SI,2
	CMP	BX,10000
	JAE	DESTIS2
	CMP	BX,1000
	JAE	TIS2
	CMP	BX,100
	JAE	STO2
	CMP	BX,10
	JAE	DES2
	MOV	DX,BX
	OR	DX,30H
	MOV	[DI],DX
	INC	DI
	DEC	SI
	DEC	SI
VYSUB:	CMP	CX,0
	JE	SUBKEJ
	MOV	AX,[SI]
	MOV	[DI],AX
	INC	DI
	DEC	SI
	DEC	SI
	DEC	CX
	JMP	VYSUB
SUBKEJ:	POP	DI
	POP	SI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RET
DESTIS2:MOV	DX,0	
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	DI				;POCET RADOV
	JMP	SUBPAK
TIS2:	MOV	DX,0
	PUSH	CX
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	POP	CX
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	CX				;POCET RADOV
	JMP	SUBPAK
STO2:	MOV	DX,0
	PUSH	CX
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	POP	CX
	MOV	BX,AX				;ZALOHA ZVYSKU
	MOV	AX,30H
	OR	DX,AX				;VYROBI SA CISLICA DESIATOK
	MOV	[SI],DX
	INC	CX				;POCET RADOV
	JMP	SUBPAK
DES2:	MOV	DX,0
	PUSH	CX
	MOV	CX,10
	MOV	AX,BX
	DIV	CX				;AX=PODIEL,DX=ZVYSOK
	POP	CX
	MOV	BX,AX				;ZALOHA ZVYSKU
	OR	DX,30H				;VYROBI SA CISLICA TISICOK
	MOV	[SI],DX
	INC	CX				;POCET RADOV
	JMP	SUBPAK

VYPSUB	ENDP

	MOV	AX,4C00H			
	INT	21H					;KONIEC

CODE	ENDS
	END	START
;Program spolahlivo funguje a vykonava vsetky pozadovane ulohy.
;Data vo vstupnom subore musia byt oddelene iba jednym znakom a -
;sa chape ako zaporne cislo. Dalej sa predpoklada ze budu zadane 
;aspon dve cisla. Zadane cisla ani vysledky operacii nesmu prekracovat
;interval <-32767,32767> inak sa vypise chybove hlasenie. Dalej sa 
;predpoklada, ze bude zadanych maximalne 100 cisel. Program vyuziva 
;sluzby Biosu.