; Zadanie c.2

ZAS SEGMENT stack 'stack'   
    DW 64 DUP(?)   
    assume ss:ZAS	
ZAS ENDS

DATA SEGMENT	
  Cesta1	DB 'c:\vstupny\vstup.txt$'    ;cesta k suboru	

  Cisla 	DW 20 DUP(0)                  ;zasobnik na usporiadane cisla
  Posun		DW 0
  Pocitad	DB 0
  Pocet		DB 0
  Buffer	DB 7 DUP(?),'$'               ;zasobnik na cislo max 6 znakov
  Handler 	DW ?
  zaloz		DB 2

  Novy_riad	DB 10,13,'$'                  ;odriadkovanie
  Text1		DB 'Subor sa nepodarilo otvorit',10,13,'$'
  Text2		DB 'Cislo mimo rozsah',10,13,'$'
  Cesta2	DB 'c:\vystupny\vystup.txt$' ;cesta k vystupnemu suboru

DATA ENDS

CODE SEGMENT
 	assume cs:CODE, ds:DATA

START:
	
Cit_sub:
	mov ax,seg DATA
	mov ds,ax
	mov ax,3d00h            ;otvorenie suboru,nastavuje carry=1 noopen
	mov dx,offset Cesta1	;nastavi do dx offset Cesta1
	int 21h
	jc Neotvor		;Subor sa nepodarilo otvorit
	mov Handler,ax	        ;vrateny handler v ax
        xor si,si
        xor di,di
        
Znova:

	xor si,si
	
Citaj:
	mov ah,3fh		;citaj zo suboru
	mov bx,Handler          ;Handler na subor,ktory som otvoril  
	mov cx,1		;citaj 1 byte
	mov dx,offset Buffer	;offset Bufra
	add dx,si
	int 21h
	cmp ax,0		;ax vracia pocet nacitanych bytov kontroluje koniec suboru
	je Koniec
	cmp [Buffer+si],' '	;porovna s medzerou-koniec cisla
	je Dalej                ;nie vsetky miesta sa zaplnia v Buffri   
	inc si
	jmp Citaj

Neotvor:jmp Neotvorim		;medziskok
Koniec:  
	cmp si,0		;aby sa nestratil posledny znak v subore
	jne Dalej		;treba zistit ci v si nieco je	
	jmp Koniec_sub		

Dalej:
	cmp si,0		;ak nenacital cislo, len medzeru,skoci na Znova
	je Znova
	mov [Buffer+si],'$'	;na koniec doklada $
	mov dx,offset Buffer		
	mov ah,09h		;vypis na obrazovku
	int 21h
	mov dx,offset Novy_riad   	;odriadkovanie
	mov ah,09h
	int 21h

	cmp si,6		;moze byt max. 6 cifier(+ znamienko)
	jnb mimo_roz
	
Dalej2:
	xor cx,cx		;nuluj
	
;---------------prevod cisla z buffru na normalne cislo---------
	
	xor ax,ax
	xor bx,bx
	xor cx,cx
	mov bl,1
op:        dec si
	sub [Buffer+si],30h 	;preved z ascii na cislo
	xor ah,ah
	mov al,[Buffer+si]
	imul bx                  ;do ax<- bl*al
	add cx,ax
	cmp cx,32767            ;max cislo v 15.bitoch
	jnb von
	mov al,10
	imul bl                ;do ax<- bl*al 
	mov bx,ax
	cmp si,1
	jbe pockaj
;	cmp si,0ffffh               ;neviem ci to funguje
;	jbe kladne
	jmp op
pockaj:	mov al,[Buffer]
  	cmp al,'-'
  	je zaporne
  	cmp si,1
  	je op
  	jmp kladne
zaporne:	
	not cx			;negacia cx
	inc cx			;inkrementacia
	
kladne:	mov bl,Pocitad		
;        add di,2                  ;posun v poli wordov
	mov word ptr [Cisla+di],cx  ;zapise do pola wordov
	inc Pocitad;		;pocita pocet nacitanych cisel
	add di,2
;	mov dx,offset blb
;	mov ah,09h
;	int 21h
	jmp Znova		;a vrati sa spet
;---------------------cislo je mimo rozsah------------------
mimo_roz:
	cmp si,7		;moze byt aj 7 znakov, ale potom
	jnb von
			  
			   ;na 0. mieste musi byt znamienko			   
        cmp [Buffer],'-'
	je Dalej2
von:	mov dx,offset Text2		;cislo mimo rozsah	
	mov ah,09h
	int 21h
	jmp Koniec_sub
;----------------------neotvorenie suboru--------------
	

Neotvorim:
	mov dx,offset Text1		;Subor sa nepodarilo otvorit	
	mov ah,09h		;Vypis retazca
	int 21h
	jmp Koniec
;----------------------------------------------------------
;--------------------koniec suboru a porovnavanie----------
Koniec_sub:
	push ax
	mov ah,3eh		;zavretie suboru 	  
	mov bx,[Handler]        ;	
	int 21h                 ;
 	mov al,Pocitad	
	mov Pocet,al              ;do pocet sa da pocet cisel
	mov bl,2
	imul bl
	sub ax,2
	mov Pocet,al             ;do pocet sa da pocet nacitanych Bytov
	pop ax
	cmp ax,0		;ak bol precitany cely subor
	je Tried		;tak utriedi prvky
	jmp Koniec

Tried:

	sub Pocitad,1		;v Pocitad je pocet prvkov
	mov al,2
	imul Pocitad		;nasobi dvomi:ax<- pocitad*al
	mov Pocitad,al          ;v pocitad je pocet nacitanych Bytov
	lea si,word ptr [cisla]	;naplni si registre na porovnanie
;	lea di,word ptr [cisla] ;do si,di sa naplni adresa cisla
	mov di,0
	mov bx,2
kolo: 
	mov ax,[si]         ;do ax cislo
	mov cx,word ptr [cisla+bx]      ;do cx cislo[bx]
	
	cmp ax,cx		;cmp [si],[di+cx] porovnava prvky
	jl Dobre
	mov [si],cx             ;na adresu kde ukazuje si dame cx
	mov word ptr [cisla+bx],ax   ;do cisla[bx] dame ax
	                         ;tymto sme ich vymenili
	cmp bl,Pocitad            ;porovnava ci sa nedostal na koniec cisel   
	je Zvys                   ;skok na zvys,kde si sa zvysi  
	add bx,2
	jmp kolo
Dobre:	
	cmp bl,Pocitad
	je Zvys			;ak je koniec triedenia
	add bx,2
	jmp kolo
	
	
Zvys:
        add di,2              ;neviem ci to pojde
        sub pocet,2
        lea si,word ptr [cisla+di]; 
;	sub Pocitad,2
	cmp Pocet,0
	je Usp_zapis
	mov bl,zaloz
	add zaloz,2
	jmp kolo
;----------------------------zapis do suboru----------------
Noopen2:jmp Neotvorim
Usp_zapis:
	mov ax,seg DATA
	mov ds,ax
	mov ah,3ch              ;vytvorenie suboru
	mov cx,0                ;cx=0 normal mode
	mov dx,offset Cesta2		;nastavi do dx offset Cesta2
	int 21h
	jc Noopen2		;Subor sa nepodarilo otvorit
	mov Handler,ax	        ;vrateny handler v ax
	
	xor si,si
	mov cx,6
@@1:
	mov [Buffer+si],0	;naplni Buffer nulami aby
	inc si			;nezavadzali zbytocne $(dolare)
	loop @@1		;z pred. pouzivania
	xor si,si
Toc2:	mov ax,word ptr [Cisla+si]
	mov bx,ax
	and bx,32768		;kontroluje 16.bit
	cmp bx,0		;ak je 1 pokracuje dalej,cislo je zaporne
	je kla
	dec ax			;prevod z doplnkoveho kodu
	not ax
	mov di,1		;poznaci si, ze je zaporne

kla:	mov bx,6

;------------prevod cisla na ascii------------------
Toc:				;prevod cisla na ascii
	xor dx,dx
	mov cx,10
	div cx			;deli desiatimi,ax:dx<- ax/cx,dx<- zvysok
	mov [Buffer+bx],dl	;zapis do Buffer od zadu
	add [Buffer+bx],30h	;prevadza na ascii
	dec bx
	mov Posun,bx		;zapameta posun v Buffer
	cmp ax,0		;v ax je podiel
	jne Toc
        
        mov [Buffer+bx],' '
	cmp di,1		;ak je zaporne, treba zapisat aj minus
	jne plus
	mov [Buffer+bx],'-'
	dec bx
	mov [Buffer+bx],' '
	mov Posun,bx  		;ulozi zaciatok cifier v retazci
plus:	xor di,di

Zapisuj:push si
;        mov si,dx
;        mov al,[si]
;        cmp al,'$'
;        pop si 
;        je  Tu
	mov ah,40h		;zapis do suboru
	mov bx,[Handler]
	mov cx,1		;pocet znakov na zapis
	lea dx,[Buffer+di]
	add dx,Posun
;	int 21h
	inc di
	push si                     ;odlozene poradove cislo
	mov si,dx
	mov al,[si]
	cmp al,'$'		;na konci znakov v Buffri je vzdy $
	pop si                   
	je Tu			;koniec zapisu

	int 21h	
	jmp Zapisuj

Tu:
	mov ax,si
	cmp Pocitad,al		;ci je koniec zapisovania
	je Zatvor_sub            ;koniec zapisovania,zatvorenie subora
	add si,2                 ;posunie na dalsie cislo
	mov bx,6
	jmp Toc2

Zatvor_sub:
	mov ah,3eh		;zavretie suboru
	mov bx,[Handler]
	int 21h



;Koniec:
	mov ax,4c00h		;DOS-ovske ukoncenie programu
	int 21h


CODE ENDS
END START