%Urcenie prenosovej funkcie riadenie, regulacmej odchylky a prenosovu funkcio poruchy
%v regulacnom obvode pre regulaciu uhlovej rychlosti jednosmerneho motora (JM) 
%s cudzim budenim, ak prenosova funkcia regulatora je Gr(s)= 1+ 14/s.
Ub=18;     Lm=1.53176e-3;     Km=2.4213;
Ib=1.95;   Rm=0.86;           Te=0.001787;
U=160;     Mz=20;             Tm=0.0726;
cu=0.413;  J=0.0144;          
Kmz=Rm/cu^2
%====================================================================================
num1=Km;
den1=[Te*Tm Tm 1];
num2=[Kmz*Te Kmz];
den2=[Te*Tm Tm 1];
num3=[1 14];
den3=[1 0];
disp('Prenosova funkcia riadeneho obvodu')
disp('G1:')
G1=tf(num1,den1)
disp('Prenosova funkcia poruchy')
disp('G2:')
G2=tf(num2,den2)
disp('prenosova funkcia regulatora')
disp('Gr:')
Gr=tf(num3,den3)
disp('prenosova funkcia riadenia')
disp('Griad=(Gr*G1)/(Gr*G1 + 1)')
Griad=(Gr*G1)/(Gr*G1 + 1);
minreal(Griad)
disp('prenosova funkcia poruchy v uzavretom obvode')
disp('i prenosova funkcia reg. odchylky vyhladom k poruche')
disp('')
Gporuch=G2/(1+G1*Gr);
minreal(Gporuch)
disp('prenosova funkcia regulacnej odchylky')
disp('Greg= (1 /(1+G1*Gr))')
Greg= (1 /(1+G1*Gr));
minreal(Greg)
disp('prenosova funkcia akcnej veliciny vyhladom na ziadanu vel.')
Gakc1= Gr/(1+Gr*G1);
minreal(Gakc1)
disp('prenos. f. akcnej vel. vyhladom na poruchu')
Gakc2= Gr*G2/(1+Gr*G1);
minreal(Gakc2)
