//Ratkovsky Marek (Pegamon) C/6
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

struct struktura {char meno[11];
		  char priezvisko[16];
		  int vek;
		  int zam;} *pr=NULL;

int p;
void nacitaj2(int);
void vypis(int);
void riadok();
void vypis2();
void tabulka();

void main()
{
  void nacitaj();
  void zmena();
  void zapis();
  int i;
  char vs[13];

  clrscr();
  window(1,1,80,25);
  printf("Chces vstupne data nacitat zo suboru? (a/n):");

  while((i=getch()) !='a' && i!='A' && i!='n' && i!='N');

  if(i=='a'||i=='A'){
    FILE *vstup;
    printf("\nZadaj meno vstupneho suboru:");
    scanf("%12s",vs);

    if ((vstup=fopen(vs,"rb"))==NULL) {   /* test pri otvarani  */
      printf("Error opening file \n");    /* suboru ci existuje */
      exit(-1);
    }

    fscanf(vstup,"%d",&p);
    pr=(struktura*)calloc(p,sizeof(struktura));
    fread(&pr[0],sizeof(struktura),p,vstup);  //Nacitanie struktury zo suboru
    fclose(vstup);
    vypis2();
  }
  else {
    printf("\nZadaj pocet poloziek:");
    scanf("%d",&p);
    pr=(struktura*)calloc(p,sizeof(struktura));

    if (pr==NULL){     //Test pri alokacii pameti, ci sa
      clrscr();        //  neprekroci povoleny limit
      gotoxy(10,10);
      printf("Error mallocation memory. Give less items.");
      getch();
      free(pr);
      exit (-1);
    }

    tabulka();
    nacitaj();
  }

  gotoxy(1,15);
  printf("Chces menit polozky struktury? (a/n)");

  while((i=getch()) !='a' && i!='A' && i!='n' && i!='N');

  if(i=='a'||i=='A') zmena();

  zapis();
  free(pr);
}

void tabulka() //Funkcia ktora vykresluje tabulku
{
  int i;
  clrscr();
  printf("\r\t\tĿ\n");
  printf("\t\t #    Meno      Priezvisko   Vek Zamestnany\n");
  printf("\t\tĴ\n");

  for (i=0;i<p && i<10;i++)
    printf("\t\t   \t       \t            \t        \n");

  printf("\t\t");
}

void nacitaj()           //Vlastna funkcia NACITAJ
{
  int i,k;

  for(i=0;i<p;i++){
    nacitaj2(i);
    gotoxy(1,15);
    delline();

    if (i%10==0 && i>0) tabulka();

    vypis(i);
  }
}

void vypis(int k)        //Pomocna funkcia na vypisanie riadku
{
  gotoxy(17,k%10+4);
  printf("%2d %-10.10s%-15.15s%4d  %5d    ",k+1,pr[k].meno,pr[k].priezvisko,pr[k].vek,pr[k].zam);

}

void zmena()            //Funkcia na Editovanie poloziek
{
  int k,j;
  char *i;
  gotoxy(1,15);
  delline();

  do{
    printf("\rZadaj cislo polozky, ktoru chces editovat: #");
    scanf("%d",&k);
  } while(k<=0 || k>p);

  k--;
  clrscr();
  printf("\nMeno: %-10.10s\nPriezvisko: %-15.15s\nVek: %d\nZamestnany: %d",pr[k].meno,pr[k].priezvisko,pr[k].vek,pr[k].zam);

  for (i=pr[k].meno;i<=(pr[k].meno+sizeof(struktura)-1);i++) *i=0;
			     //vycistenie miesta v strukture

  nacitaj2(k);
  gotoxy(1,15);
  delline();
  printf("Chces menit este dake polozky? (a/n)");

  while((j=getch()) !='a' && j!='A' && j!='n' && j!='N');

  if(j=='a'||j=='A'){
    clrscr();
    vypis2();
    zmena();
  }
}

void nacitaj2(int i)  //Vlastna funkcia na nacitanie poloziek struktury
{
  gotoxy(1,15);
  printf("#%d.",i+1);
  riadok();
  gotoxy(9,15);
  scanf("%10s",pr[i].meno);
  riadok();
  gotoxy(9,15);
  printf("%-10.10s ",pr[i].meno);
  fflush(stdin);
  gotoxy(31,15);
  scanf("%15s",pr[i].priezvisko);
  riadok();
  gotoxy(9,15);
  printf("%-10.10s ",pr[i].meno);
  gotoxy(31,15);
  printf("%-15.15s ",pr[i].priezvisko);
  fflush(stdin);
  gotoxy(51,15);
  scanf("%2d",&pr[i].vek);
  riadok();
  gotoxy(9,15);
  printf("%-10.10s ",pr[i].meno);
  gotoxy(31,15);
  printf("%-15.15s ",pr[i].priezvisko);
  gotoxy(51,15);
  printf("%-2d",pr[i].vek);
  fflush(stdin);
  gotoxy(69,15);
  scanf("%2d",&pr[i].zam);
  fflush(stdin);
  riadok();
  gotoxy(9,15);
  printf("%-10.10s",pr[i].meno);
  gotoxy(31,15);
  printf("%-15.15s",pr[i].priezvisko);
  gotoxy(51,15);
  printf("%-2d",pr[i].vek);
  gotoxy(69,15);
  printf("%-2d",pr[i].zam);
}

void zapis()     //Zapis do vystupneho suboru
{
  FILE *vystup;
  char vys[13];
  clrscr();
  printf("Zadaj meno vystupneho suboru: ");
  scanf("%12s",vys);

  if ((vystup=fopen(vys,"wb"))==NULL) {   /* test pri otvarani  */
    printf("Error opening file \n");      /* suboru ci existuje */
    exit(-1);
  }

  fprintf(vystup,"%d",p);
  fwrite(&pr[0],sizeof(struktura),p,vystup);//zapis struktury do suboru
  fclose(vystup);
}


void vypis2()  //Vypis Tabulky
{
  int z=1,j;
  clrscr();
  while(z<=p){
    tabulka();

    for(j=1;j%11!=0 && j<=p;j++,z++)
      if(z<=p) vypis(z-1);
    getch();
  }
}



void riadok()
{
  gotoxy(4,15);
  printf("Meno:           Priezvisko:                Vek:       Zamestnany:     ");
}

