/*Andrej Hozlar 97280 3TLK13 */
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#define max 10

void pempty(int *,int *);
int pnew(int *,int *,int);
int pdispose(int *,int *,int);
int pisempty(int *);
void pcollect(int *,int *);
void pconect(int *);
void vypisp(int *);
void vypisb(int *);
int zadaj(void);


int main(){
  int kolko,k,pamat[max+1],tab[max];


  pempty(pamat,tab);
  while(1){
	printf("\n************************ Zretazena volna pamat ************************\n");
	printf("1.empty  \t2.new    \t3.dispose\t4.isempty\t5.collect\n6.conect\t7.vypis pamete\t8.vypis tab.\tESC koniec\n");
	switch (getch()) {
	  case '1':   pempty(pamat,tab); break;
	  case '2':   printf("\nZadaj kolko buniek chces alokovat:");
				  if((k=pnew(pamat,tab,zadaj()))!=-1) printf("%d. blok.\n",k);
				  break;
	  case '3':   printf("\nZadaj cislo bloku ktory chces uvolnit:");
				  if(pdispose(pamat,tab,zadaj())!=0){
					printf("ERROR.\n");
				  } break;
	  case '4':   if(pisempty(tab)==1) printf("\nPamat je volna.\n");
				  else printf("\nPamat nie je volna.\n");
				  break;
	  case '5':   pcollect(pamat,tab); break;
	  case '6':   pconect(pamat);  break;
	  case '7':   vypisp(pamat);   break;
	  case '8':   vypisb(tab);   break;
	  case 27 :   return 0;
	  default:    printf("\n");
	}
  }
}

/*Inicializacia ZVP*/
void pempty(int *pamat,int *tab){
  int i;

  for(i=0;i<max;i++){
	pamat[i]=0;
	tab[i]=0;
	tab[i+max]=0;
  }

  pamat[0]=1;
  pamat[1]=max;
  pamat[max]=-1;
}

/*Alokovanie "kolko" bytov pola pamat*/
int pnew(int * pamat,int * tab,int kolko){
  int dblok,cblok=0,k,j,i=0;

  if(kolko==1) kolko=2;

  while (pamat[cblok]!=-1){
	dblok=pamat[pamat[cblok]];

	if(dblok==kolko+1) kolko++;

	if(dblok==kolko){
	  while(tab[i]!=0) i=i+2;
	  tab[i++]=pamat[cblok];
	  tab[i++]=kolko;
	  j=pamat[pamat[cblok]+dblok-1];
	  for(k=pamat[cblok];k<pamat[cblok]+kolko;k++) pamat[k]='x';
	  pamat[cblok]=j;
	  return((i)/2);
	}

	if(dblok>kolko){
	  while(tab[i]!=0) i=i+2;
	  tab[i++]=pamat[cblok];
	  tab[i++]=kolko;
	  for(k=pamat[cblok];k<pamat[cblok]+kolko;k++) pamat[k]='x';
	  pamat[cblok]=pamat[cblok]+kolko;
	  pamat[pamat[cblok]]=dblok-kolko;
	  return((i)/2);
	}

	cblok=dblok+pamat[cblok]-1;
  }

  printf("Nie je volna pamat. Skuste pouzit funkciu collect resp. conect");
  return(-1);
}

int pdispose(int *pamat,int *tab,int cblok){
  int i=0;
  cblok=cblok*2-2;

  if(tab[cblok]!=0){
	while((pamat[i]!=-1) && (pamat[i]<tab[cblok])) i=pamat[pamat[i]]+pamat[i]-1;

	pamat[tab[cblok]+tab[cblok+1]-1]=pamat[i];
	pamat[i]=tab[cblok];
	pamat[tab[cblok]]=tab[cblok+1];
	for(i=tab[cblok]+1;i<tab[cblok]+tab[cblok+1]-1;i++) pamat[i]=0;
	tab[cblok]=0;
	tab[cblok+1]=0; /*netreba je to len kvoli prehladnosti*/
	return(0);
  }
  else return(-1);
}

/*Testovanie ci je ZVP prazdna*/
int pisempty(int *tab){
  int i;
  for(i=0;i<max;i=i+2) if(tab[i]!=0) return(-1);

  return(1);
}

void pcollect(int *pamat,int *tab){
  int i,j=1,x=0,z=10,k=0;

  if(pamat[0]!=-1){  /*robi to len ked je miesto v ZVP*/
	do{
	  for(i=0;i<max;i=i+2){ 		  	/* Cyklus na najdenie dalsieho */
		if((tab[i]<z) && (tab[i]>x)){ 	/* najmensieho smernika  bloku */
			z=tab[i];    			  	/* ktory je  potom skopirovany */
			k=i;	 	       			/* na volne miesto od zac. ZVP */

		}
	  }

	  if(z!=10){
		x=z;
		tab[k]=j;

		for(i=z;i<z+tab[k+1];i++,j++) pamat[j]=pamat[i];  /*kopirovanie bloku*/

		z=10;
	  }
	  else{
		z=11;
	  }
	}while(z==10); /*Ak bol najdeny smernik ktory je vacsi ako */
				   /*predosli a najmensi najdeny zaroven, tak znova*/
	pamat[0]=1;

	for(i=1;i<max+1;i=i+2) pamat[0]=pamat[0]+tab[i]; /*urcenie 1. volneho bl.*/

	pamat[pamat[0]]=max-pamat[0]+1; /*velkost volneho bloku*/

	for(i=pamat[0]+1;i<max;i++) pamat[i]=0; /*doplnenei nulami*/

	pamat[max]=-1; /*na koniec da -1*/
  }
}

void pconect(int *pamat){
  int i=0,j;
  while(pamat[i]!=-1){
	if(pamat[pamat[pamat[i]]+pamat[i]-1]==pamat[pamat[i]]+pamat[i]){
	  pamat[pamat[i]]=pamat[pamat[i]]+pamat[pamat[pamat[i]]+pamat[i]];
	  for(j=pamat[i]+1;j<pamat[pamat[i]]+pamat[i]-1;j++) pamat[j]=0;

	}
	else{
	  i=pamat[pamat[i]]+pamat[i]-1;
	}
  }
}
void vypisp(int *pamat){
  int i;
  printf("\n\t\t\t* * *  VYPIS PAMATE  * * *\n");
  printf("\t __________________________________________________________________\nC.bunky: | PVB");
  for(i=1;i<=max;i++) printf(" | %2d ",i);
  printf("|\n\t __________________________________________________________________\nO.bunky:");
  for(i=0;i<=max;i++){
	if(pamat[i]<=10) printf(" | %2d ",pamat[i]);
	else printf(" | %2c ",pamat[i]);
  }
  printf("|\n\t ------------------------------------------------------------------\n");

}
void vypisb(int *tab){
  int i;
  printf("\n\t\t * * *  TABULKA BLOKOV  * * *\n\t\t");
  for(i=1;i<=max/2;i++) printf(" %2d.B ",i);
  printf("\n\t\t");
  for(;i>1;i--) printf(" s. d.");
  printf("\n\t\t");
  for(i=0;i<max;i++) printf("%2d ",tab[i]);
  printf("\n");

}

int zadaj(){
  int kolko=-1;
  while((kolko>max) || (kolko<=0)) scanf("%d",&kolko);
  return(kolko);
}

