uses crt;
{kolko prvkov ma zvp?}
const mem_size=128;

{na reprezentaciu prvku zvp som zvolil strukturu -
 val je hodnota prvku, nxt je ukazovatel na dalsi prvok zvp }
type next_type=integer;   {akeho typu je ukazovatel na dalsi prvok?}
     val_type=integer;    {akeho typu je hodnota prvku?}
     elm=record
       val:val_type;
       nxt:next_type;
     end;

var bmem:array[1..mem_size] of elm;  {rezervujeme pamat, nad ktorou budeme operovat}
    prvok,zvp:next_type;             {zvp - ukazovatel na zaciatok zretazenej volnej pam.}
    key:char;

procedure empty(var zvp:next_type);
var i:next_type;
begin
  {inicializujeme hodnoty vsetkych prvkov na nulu, kazdy prvok ukazuje na nasledujuci}
  for i:=1 to mem_size do begin
    bmem[i].val := 0;
    bmem[i].nxt := i+1;
  end;
  {posledny prvok ukazuje nikam - t.j. -1 }
  bmem[mem_size].nxt := -1;
  {pociatok zvp ukazuje na prvy prvok}
  zvp:=1;
end;

function isempty(zvp:next_type):boolean;
begin
  isempty := false;
  if zvp = -1 then isempty := true;
end;

procedure xnew(var zvp,prvok:next_type);
var i:next_type;
begin
  {bola uz pamat zretazena?}
  if zvp=0 then begin
    writeln('pamat este nebola zretazena.');
    readkey;
    exit;
  end;
  {nie je pamat vycerpana}
  if isempty(zvp) then begin
    writeln('Pamat vycerpana.');
    readkey;
    exit;
  end;
  {vsetko je ok, mozeme poskytnut prvok}
  prvok := zvp;
  i:=zvp;
  zvp := bmem[zvp].nxt;
  bmem[i].nxt := -2;
end;

{navratenie alokovaneho prvku do zretazenej pamati}
procedure xdispose(var zvp,prvok:next_type);
begin
  bmem[prvok].nxt := zvp;
  zvp := prvok;
end;

{zobrazenie aktualneho stavu zretazenej pamati}
procedure show;
var x,y,pom:integer;
begin
  clrscr;
  y:=1;
  pom:=0;
  for x:=1 to mem_size do
  begin
    inc(y);
    gotoxy(23+9*((x-1) div 23),y);
    write(' ',x:3,'>',bmem[x].nxt,'  ');
    if (zvp=x) then begin
      gotoxy(23+9*((x-1) div 23),y);
      write('>');
    end;
    if (x mod 23)=0 then y:=1;
  end;

  gotoxy(1,1);
  writeln('1.  empty');
  writeln('2.  new');
  writeln('3.  dispose');
  writeln('4.  end');
  writeln;
end;

{osetrenie uzivatelskeho vstupu funkcie xdispose}
procedure udispose;
var i:next_type;
begin
  write('cislo prvku : ');
  readln(i);
  if bmem[i].nxt = -2 then xdispose(zvp,i)
		     else begin
		       writeln('prvok ',i,' nebol alokovany, preto ho nemozno uvolnit.');
		       readkey;
		     end;
end;

procedure unew;
var i:next_type;
begin
  xnew(zvp,i);
end;

begin
  repeat
    show;
    key:=readkey;
    case key of
      '1':empty(zvp);
      '2':unew;
      '3':udispose;
      '4':break;
    end;
  until false;
end.
