// Meno   : Richard Hrubizna
// Kruzok : TLK 2
// Odbor  : Telekomunikacie
// Rocnik : 3



#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>

typedef struct STROM {                    // struktura
	  int hod,nasob;
	  struct STROM *lavy,*pravy;
	  }strom;

void menu(int *volba) {              // funkcia menu
char sos[10];

printf ("MENU:\n     1: Vlozenie cisla\n     2: Vypis predchodcu\n"
		"     3: Vypis nasledovnika\n     4: Najdenie praveho suseda\n"
		"     5: Vypis korena\n"
		"     6: Vypis stromu metodou inorder\n   inak: KONIEC\n");
printf ("Vasa volba:");
scanf ("%s",sos);
*volba=atoi(sos);
}


// funkcia na vlozenie noveho prvku do stromu

int vloz(int cislo,strom **root) {
 if (*root==NULL) {
  if ((*root=(strom *) malloc(sizeof(strom)))==NULL)
	   { printf ("Malo miesta v pamati\n"); return (0);}
   else { (*root)->hod=cislo; (*root)->nasob=1;
	  (*root)->lavy=(*root)->pravy=NULL; return(1); }}
 else {
	   if ((*root)->hod > cislo) vloz(cislo,&((*root)->lavy));
	   else if ((*root)->hod == cislo) { ((*root)->nasob)++; return (1); }
		else vloz(cislo,&((*root)->pravy));
	   }
 return(1); }

// funkcia na zadanie cisla prvku v strome

void nacitaj(int *cislo) {
char sos[10];
 printf ("Zadajte cislo:");
 scanf ("%s",sos);
 *cislo=atoi(sos);
  }

// funckia na urcenie laveho nasledovnika

int l_nasled(int cislo,strom **root,strom **vrat) {
 if (*root==NULL) return(1);
 else {
	   if ((*root)->hod > cislo) l_nasled(cislo,&((*root)->lavy),vrat);
	   else if ((*root)->hod == cislo) {
			*vrat=(*root)->lavy;
			return (1); }
		else l_nasled(cislo,&((*root)->pravy),vrat);
	   }
 return(1); }

// funkci na vypis binarneho stromu typu inorderd

int vypis(strom **root,int *i) {
 if ((*root)->lavy==NULL) { printf ("%d(%d)  ",(*root)->hod,(*root)->nasob);
				if (*i>7) { printf("\n"); (*i)=0; }
				(*i)++;
				if ((*root)->pravy!=NULL) vypis(&(*root)->pravy,i);
			 }
 else { vypis(&(*root)->lavy,i);
	printf ("%d(%d)  ",(*root)->hod,(*root)->nasob);
	if (*i>7) { printf("\n"); (*i)=0; }
		 (*i)++;
	if ((*root)->pravy!=NULL) vypis(&(*root)->pravy,i);
	  }
return (1); }

// funkcia na urcenie predchodcu daneho prvku

int pred(int cislo,strom **root,strom **vrat,int *pocet) {
if ((*root)->lavy==NULL) {
	 if (((*root)->pravy)->hod==cislo) {
	 (*pocet)=(*root)->nasob;
	  *vrat=*root; return (1); }

	 if ((*root)->pravy!=NULL) pred(cislo,&(*root)->pravy,vrat,pocet);
			 }
 else {  if (((*root)->pravy)->hod==cislo) {
		  (*pocet)=(*root)->nasob;
		  *vrat=*root; return (1); }
	 if (((*root)->lavy)->hod==cislo){
		(*pocet)=(*root)->nasob;
		  *vrat=*root; return (1); }
	pred(cislo,&(*root)->lavy,vrat,pocet);
	if (((*root)->pravy!=NULL) && (*vrat==NULL)) pred(cislo,&(*root)->pravy,vrat,pocet);
	  }
 return(1);
 }


// funkcia na urcenie praveho suseda

int psused(int cislo,strom **root,strom **vrat) {
if ((*root)->lavy==NULL) {
	 if (((*root)->pravy)->hod==cislo) {  *vrat=NULL; return (1); }
	 if ((*root)->pravy!=NULL) { psused(cislo,&(*root)->pravy,vrat); }
			 }
 else {  if (((*root)->pravy)->hod==cislo){ *vrat=NULL; return (1); }
	 if (((*root)->lavy)->hod==cislo) {
		  *vrat=(*root)->pravy; return (1); }
	psused(cislo,&(*root)->lavy,vrat);
	if (((*root)->pravy!=NULL) && (*vrat==NULL)) psused(cislo,&(*root)->pravy,vrat);
	  }
 return(1);
}

int main (void) {                    // hlavny program

strom **koren,**help;
int volba,cislo,pocet,day=0;


*koren=NULL;
clrscr();
do {
  *help=NULL;
  pocet=0;
  menu (&volba);
  clrscr();
  switch (volba) {
	 case 1: { printf("vlozenie\n");
		   nacitaj(&cislo); vloz(cislo,koren);
		   break;}
	 case 2: { printf("predchodca\n"); *help=NULL; pocet=0;
		   if (*koren==NULL)  printf ("Strom je prazdny\n");
		   else { nacitaj(&cislo);
			 if (((*koren)->hod)==cislo) printf ("Zadane cislo je koren => nema predchodcu\n");
			 else {
			  if ((*koren)->hod==cislo) { pocet++; }
			  pred (cislo,koren,help,&pocet);
			  if ((*help==NULL)) printf ("Cislo nie je v strome alebo nema predchodcu\n");
			  else printf ("Predchodca cisla %d je cislo %d -vyskytuje sa v strome %d krat.\n",cislo,(*help)->hod,pocet);
			   }}
		   printf ("\nstlac klavesu\n");   getche();
		   break;}
	 case 3: { printf("nasledovnik\n");
			   nacitaj(&cislo);
			   l_nasled (cislo,koren,help);
			   if (*help==NULL) printf ("Cislo nie je v strome alebo nema laveho nasledovnika\n");
			   else  printf ("Lavy nasledovnik cisla %d je cislo %d -vyskytuje sa v strome %d krat.\n",cislo,(*help)->hod,(*help)->nasob);
		   printf ("\nstlac klavesu\n");   getche();
		   break;}
	 case 4: { printf ("pravy sused\n");
		   *help=NULL; pocet=0;
		   if (*koren==NULL)  printf ("Strom je prazdny\n");
		   else {
			 nacitaj(&cislo);
			 psused (cislo,koren,help);
			 if (*help==NULL) printf ("Cislo nie je v strome alebo nema praveho suseda\n");
			 else  printf ("Pravy sused cisla %d je cislo %d -vyskytuje sa v strome %d krat.\n",cislo,(*help)->hod,(*help)->nasob);
			  }
		   printf ("\nstlac klavesu\n");   getche();
		   break;}
	 case 5: { printf("koren\n");
		   if (*koren==NULL) printf ("Strom je prazdny\n");
		   else printf ("Koren ma hodnotu: %d\n",((*koren)->hod));
		   printf ("\nstlac klavesu\n");   getche();
		   break;}
	 case 6: { printf("INORDER\n");
		   if (*koren!=NULL) { vypis(koren,&day); printf("\n");}
		   else printf ("Strom je prazdny\n");
		   printf ("\nstlac klavesu\n"); day=0;  getche();
		   break; }
	}
  clrscr();
}
while (volba>0 && volba<7);
return (1);
}





