program zvpp (input,output);
const
  KONIECZVP = -1;
  VOLNE = ' ';
  POUZITE = '$';

type
  elmptr=integer;
  elm = char;
  polozka = record
    data: elm;
    ukazovatel: elmptr;
  end;
  zvpt = array [0..25] of polozka;

var
   zvp: zvpt;
  volba,prvok,ukazovatel: integer;

procedure printzvp( mem: zvpt; velkost: integer);
var i:integer;
begin
  writeln;
  if ( ukazovatel <> KONIECZVP ) then begin
    writeln;
    for i:=0 to ukazovatel-1 do write('   ');
    writeln(' |');
    for i:=0 to ukazovatel-1 do write('   ');
    writeln('\/');
  end;
  for i:=0 to velkost-1 do write(i:3);
  writeln;
  for i:=0 to velkost-1 do write(mem[i].data:3);
  writeln;
  for i:=0 to velkost-1 do write(mem[i].ukazovatel:3);

  writeln;
end;

procedure empty(var ppp: zvpt;velkost: integer);
var i:elmptr;
begin
  for i:=0 to velkost-1 do begin
    ppp[i].data:=VOLNE;
    ppp[i].ukazovatel:=i+1;
  end;
  ppp[velkost-1].ukazovatel:=KONIECZVP;
  ukazovatel:=0;
end;

function isempty( free1: integer): Boolean;
begin
  if ( free1 = KONIECZVP ) then isempty:=FALSE
  else isempty:=TRUE;
end;

function new1(var mem:zvpt;var prvy:integer):elmptr;
begin
	if isempty(prvy) then begin
		new1:=prvy;
		prvy:=mem[prvy].ukazovatel;
		end
	else
		writeln('Nieto volny prvok!!!');
end;

function newz(var mem: zvpt ;free1: integer): integer;
var i,count,ii:integer;
    c:char;
begin
   i := free1;
   count := 0;
   if ( not isempty(free1) ) then begin
     writeln;
     write('Nieto co obsadit ! Skus uvolnit');
     read(c);
     newz:=free1;
   end else begin
     while(mem[i].ukazovatel<>KONIECZVP) do begin
       count:=count+1;
       i:=mem[i].ukazovatel;
     end;
     count:=count+1;
     writeln;
     write('Jesto ',count,' volnych prvkov! Kolko chces obsadit?:');
     repeat
       read(i);
       if( (i>count) or (i<0)) then
         write('Zadal si chybne cislo!Skus znova(max=',count,'):');
     until( (i<=count) and (i>=0) );
     if ( i=0 ) then begin
	write('0 => Neobsadzujem nic ...');
	newz:=free1;
     end else begin
       for ii:=0 to i-1 do mem[new1(mem,free1)].data:=POUZITE;
       newz:=free1;
     end;
   end;
end;

function isused(mem: zvpt;pol,free1: elmptr): boolean;
var i:elmptr;
begin
  isused:=TRUE;
  i:=free1;
  if i = pol then isused := FALSE;
  while(i<>KONIECZVP) do begin
    if mem[i].ukazovatel=pol then isused:=FALSE;
    i:=mem[i].ukazovatel;
  end;
end;


function dispose(var mem: zvpt;prvok,free1: elmptr): elmptr;
begin
  if( not isused(mem,prvok,free1) ) then begin
    writeln;
    write('Prvok ',prvok,' nie je obsadeny neda sa uvolnit !!!');
    dispose:=free1;
  end else begin
    mem[prvok].data:=VOLNE;
    mem[prvok].ukazovatel:=free1;
    dispose:=prvok;
  end;
end;

procedure menu;
begin
  writeln('Tvoje moznosti su:');
  writeln('1.new');writeln('2.dispoze');writeln('3.Empty');writeln('4.Koniec');
  write('Volba:');
end;

begin
  empty(zvp,25);
  repeat
    write('[H[J');
    printzvp(zvp,25);
    menu;
    read(volba);
    case volba of
      1 : ukazovatel:=newz(zvp,ukazovatel);
      2 : begin
            write('Zadaj,ktory prvok:');
            read(prvok);
            ukazovatel:=dispose(zvp,prvok,ukazovatel);
          end;
      3 : empty(zvp,25);
      4 : ;
  end;
  until(volba=4);
end.

