
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define true (1==1)
#define false (1==0)

#define Klen 6
#define NOELM 0

int max=10;

struct tabelm{
	char kluc[Klen];
	int elm;
	};

int HASH(char key[Klen]){int i,cnt=0,sum=0;
	for(i=0;i<(Klen-1);i++) if(key[i]!=' ') {sum+=key[i];cnt++;}
	sum=sum/cnt;sum=sum-'a';
	sum=(max-1)*(float)((float)(sum)/(int)('z'-'a'));
	return(sum);}

int iseq(char k1[Klen],char k2[Klen]){int i;
	for(i=0;i<(Klen-1);i++) if(k1[i]!=k2[i]) return(false);
	return(true);}

struct tabelm *empty(){struct tabelm *pom;int i;char pomk[Klen];
	for(i=0;i<(Klen-1);i++) pomk[i]=' ';pomk[Klen-1]='\0';
	if(NULL==(pom=malloc(max*sizeof(struct tabelm)))){
		perror("empty:");return(NULL);}
	for(i=0;i<max;i++){pom[i].elm= NOELM ;strcpy(pom[i].kluc,pomk);}
	return(pom);}

void insert(struct tabelm *tab,char key[Klen],int prvok){int a,i=HASH(key);
	a=i;
	if(tab!=NULL){
		printf("insert:hladam miesto:%i\n",a);
		for(;i<max;i++) if(NOELM==tab[i].elm){
			printf("insert:%i,vkladam na %i\n",a,i);
			strcpy(tab[i].kluc,key);
			tab[i].elm=prvok;
			return;}
			else
				if(iseq(key,tab[i].kluc)){printf("Rovnake kluce:");
					printf("insert:%i,prepisujem %i\n",a,i);
					strcpy(tab[i].kluc,key);
					tab[i].elm=prvok;
					return;}
		for(i=0;i<a;i++) if(NOELM==tab[i].elm){
			printf("insert:%i,vkladam na %i\n",a,i);
			strcpy(tab[i].kluc,key);
			tab[i].elm=prvok;
			return;}
			else
				if(iseq(key,tab[i].kluc)){printf("Rovnake kluce:");
					printf("insert:%i,prepisujem na %i\n",a,i);
					strcpy(tab[i].kluc,key);
					tab[i].elm=prvok;
					return;}
		printf("Nenasiel som miesto\n");
		}
	else printf("insert:tabulka nie je vytvorena !!!\n");
}

int search(struct tabelm *tab,char key[Klen]){int i;
	for(i=0;i<max;i++) if(iseq(tab[i].kluc,key)) return(true);
	return(false);
}

int Read(struct tabelm *tab,char key[Klen]){int a,i=HASH(key);
	a=i;
	if(!search(tab,key)) {printf("V tabulke nieto taky kluc\n");return(NOELM);}
	for(;i<max;i++) if(iseq(tab[i].kluc,key)) return(tab[i].elm);
	for(i=0;i<a;i++) if(iseq(tab[i].kluc,key)) return(tab[i].elm);
}

void Delete(struct tabelm *tab,char key[Klen]){int a,i=HASH(key);
	a=i;
	if(!search(tab,key)) {printf("V tabulke nieto taky kluc\n");return;}
	for(;i<max;i++) if(iseq(tab[i].kluc,key)){
		tab[i].elm= NOELM;
		for(a=0;a<(Klen-1);a++) tab[i].kluc[a]=' ';
		return;
		}
	for(i=0;i<a;i++) if(iseq(tab[i].kluc,key)){
		tab[i].elm= NOELM;
		for(a=0;a<(Klen-1);a++) tab[i].kluc[a]=' ';
		return;
		}
}	

/*--------------------------------------------------------*/

char *readkey(char sem[Klen]){int i;char pom[Klen];
	for(i=0;i<Klen;i++) pom[i]=0;scanf("%s",pom);
	for(i=0;i<Klen;i++){
		if((pom[i]>='a')&&(pom[i]<='z')) sem[i]=pom[i];
		else sem[i]=' ';}
	sem[Klen-1]='\0';
	return(sem);}

void printtab(struct tabelm *tab){int i;
	if(tab!=NULL){
		printf("  kluc    elment\n");
		for(i=0;i<max;i++)
			if(tab[i].elm==NOELM) printf("|%s|         \n",tab[i].kluc);
			else printf("|%s| %8i\n",tab[i].kluc,tab[i].elm);
		}
}

char menu(){char znak,*ms;int i;
	ms="keirdsq";
	printf("Ovladanie tabulky:\n1.Empty  2.Insert  3.Read  4.Delete  5.Search  6.iseQ\n");
	do{
		scanf("%c",&znak);
		printf("Zadal si %c\n",znak);
		if((znak<='6')&&(znak>='0')) return(ms[znak-'0']);
		for(i=0;i<7;i++) if((znak==ms[i])||((znak+32)==ms[i])) return(ms[i]);
		printf("Skus znovu:");
	}while(true);
}

int main(int argc,char **argv){
int koniec,myelm;
char klucik[Klen],volba,klucik1[Klen];
struct tabelm *tabulka;
	koniec=true;
	myelm= NOELM;
	tabulka=NULL;

        if(argc>1) max=atoi(argv[1]);
	if(max<=0) max=5;
	do{
		printtab(tabulka);
		volba=menu();
		switch(volba){
			case 'r':printf("Zadaj klucik:");readkey(klucik);
						myelm=Read(tabulka,klucik);
						if(NOELM!=myelm) printf("Nacitany element:%i\n",myelm);
						break;
			case 'd':printf("Zadaj klucik:");readkey(klucik);
						Delete(tabulka,klucik);
						break;
			case 's':printf("Zadaj klucik:");readkey(klucik);
						if(!search(tabulka,klucik)) printf("V tabulke nieto taky kluc\n");
						else printf("V tabulke jesto taky kluc\n");
						break;
			case 'q':printf("Zadaj klucik1:");readkey(klucik);
						printf("Zadaj klucik2:");readkey(klucik1);
						if(iseq(klucik,klucik1)) printf("%s = %s\n",klucik,klucik1);
						else printf("%s != %s\n",klucik,klucik1);
						break;
			case 'i':printf("Zadaj klucik:");readkey(klucik);
						printf("Zadaj elment:");scanf("%i",&myelm);
						insert(tabulka,klucik,myelm);
						break;
			case 'e':tabulka=empty();
						break;
			case 'k':koniec=false;
						break;
		}
	}while(koniec);
}

