/*
Marek Ratkovsky		3 INF 8
Zadanie:Tabulka
Implementacia:Pomocou pola
DRUHY: tab,elm,key,Bool
OPERACIE:
	empty:      -> tab
	insert: tab, elm -> tab
	read: tab, key -> elm
	delete: tab, key -> tab
	iseq: key, key -> Bool
	search: key, tab -> Bool
*/
#include <stdio.h>
#include <string.h>
#define MAX 10

typedef struct Tabulka
		{
		  int posledny;
		  char *slovo[MAX];
		};

struct Tabulka slovnik;

void zadajk(char*);
void zadajs(char*);
void empty(void);
void insert (char*);
char* read (char*);
void del (char*);
int search(char*);
void vypis (void);
int iseq(char*,char*);

void main(void)
{
   int i;
   char zal[15],*pom2,z;
   empty();
   for (;;)
	  {
	   printf ("Mozne funkcie:\n");
	   printf ("1.Empty   2.Insert   3.Delete  4.Read    5.Search   6.Vypis   7.Koniec\n");
	   printf ("Tvoj vyber:");
	   z=getc(stdin);
	   switch (z)
	   {
	   case '1':empty();break;
	   case '2':if (slovnik.posledny==MAX-1)
				{
				  printf ("Tabulka je obsadena\n");
				  fflush(stdin);
				  break;
				}
				zadajs(zal);
				insert(zal); break;
	   case '3':if (slovnik.posledny==-1)
				{
				  printf ("Tabulka je prazdna\n");
				  fflush(stdin);
				  break;
				}
				zadajs(zal);
				del(zal); break;
	   case '4':zadajk(zal);
				pom2=read(zal);
				if (pom2) printf ("Slovo s klucom '%2s' je %s\n",zal,pom2);
				else printf("Slovo s klucom '%2s' sa nenaslo\n",zal);break;
	   case '5':zadajk(zal);
				if (search(zal)) printf ("Slovo s klucom '%s' je v slovniku\n",zal);
				else printf("Slovo s klucom '%s' nie je v slovniku\n",zal);break;
	   case '6':vypis();break;
	   case '7':return;
	   default: printf("Skus este raz\n");
				getc(stdin);
				fflush(stdin);
	   }
	//   getc(stdin);
	  }
}

void vypis (void)
{
  int i,j;
  printf ("* * * * * * * * * * * * * * * * Vypis Tabulky * * * * * * * * * * * * * * * * *\n");
  for(i=0;i<=slovnik.posledny;i+=5)
  {
	for (j=i;j<=i+4 && j<=slovnik.posledny;j++) printf("%15s",slovnik.slovo[j]);
	printf("\n");
  }
  printf ("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
  fflush(stdin);
}

void zadajk(char* a)
{
  printf ("Zadaj kluc:");
  scanf("%2s",a);
  fflush(stdin);
}

void zadajs(char* a)
{
  printf("Zadaj slovo:");
  scanf("%14s",a);
  fflush(stdin);
}

void empty(void)
{
	while(slovnik.posledny!=-1)
	{
	  delete slovnik.slovo[slovnik.posledny];
	  slovnik.posledny--;
	}
	fflush(stdin);
}

void insert (char *slovo)
{
	slovnik.posledny++;
	slovnik.slovo[slovnik.posledny]=new char[strlen(slovo)+1];
	strcpy(slovnik.slovo[slovnik.posledny],slovo);
}

char * read (char *kluc)
{
	int i=0;
	slovnik.slovo[slovnik.posledny+1]=kluc;
	while (iseq(kluc,slovnik.slovo[i])) i++;
	if (i<=slovnik.posledny) return slovnik.slovo[i];
		else return NULL;
}

void del (char *slovo)
{
	int i=0,j;
	while ((i<MAX) &&(strcmp(slovo,slovnik.slovo[i]))) i++;
	if (i==MAX) printf("Dany prvok nie je v poli\n");
	if (i<=slovnik.posledny)
		{
		delete slovnik.slovo[i];
		for (j=i;j<slovnik.posledny;j++)
			slovnik.slovo[j]=slovnik.slovo[j+1];
		slovnik.posledny--;
		}
}

int iseq(char *a,char *b)
{
  if((a[0]==b[0]) && (a[1]==b[1]))  return 0;
  else return 1;
}

int search(char *kluc)
{
	int i=0;
	slovnik.slovo[slovnik.posledny+1]=kluc;
	while (iseq(kluc,slovnik.slovo[i])) i++;

	if (i<=slovnik.posledny) return 1;
	else return 0;
}

