program zasobnik(input,output);

{* Definicia typov. *}
type elm=char;
     stack=^stackelm;
     stackelm=record
                data:elm;
                next:stack
              end;

{* Deklaracia premennych. *}
var zasobnik:stack;
    chyba:boolean;
    c,ch:elm;

procedure myerror;
begin
  writeln('Zasobnik je prazdny !!!')
end;

{* Procedura PUSH vlozi prvok do zasobnika *}
procedure push(var zas:stack; prvok:elm);
var p:stack;
begin
  new(p);
  p^.data:=prvok;
  p^.next:=zas;
  zas:=p
end;

{* Funkcia ISEMPTY vrati hodnotu true ak je zasobnik prazdny, inac vrati false.
 *}
function isempty(var zas:stack):boolean;
begin
  isempty:= zas=nil
end;

{* Funkcia TOP vrati prvok, ktory je na vrchu zasobnika, pricom vrchol nemeni.
 *}
function top(var zas:stack):elm;
begin
  if isempty(zas) then myerror
  else top:=zas^.data
end;

{* Procedura POP zrusi prvok na vrchole zasobnika a posunie vrchol. *}
procedure pop(var zas:stack);
var p:stack;
begin
  if isempty(zas) then myerror
  else begin
    p:=zas;
    zas:=zas^.next;
    dispose(p)
  end
end;

{* Procedura EMPTY vytvori prazdny zasobnik. *}
procedure empty(var zas:stack);
begin
  zas:=nil
end;

begin
  empty(zasobnik);                                    {* Vytvorenie zasobnika *}
  writeln('Kontrolovany riadok :');
  chyba:=false;
  repeat
  begin
    read(ch);
                                 {* Ak je lava zatvorka, uloz ju do zasobnika *}
    if (ch='[') or (ch='(') or (ch='{') then
       push(zasobnik,ch)
                                          {* Inak, ak je prava zatvorka a ... *}
    else if (ch=']') or (ch=')') or (ch='}') then
      begin
        c:=top(zasobnik);
             {* ... a v zasobniku je jej protipar, zrus zatvorku zo zasobnika *}
        if ((c='[') and (ch=']')) or ((c='(') and (ch=')')) or ((c='{') and (ch='}')) then
          pop(zasobnik)
        else
          chyba:=true;                 {* Ak to nie je protipar, potom chyba. *}
      end;
  end until (eoln) or (chyba=true);
  if chyba=true then
    writeln('Vstupny riadok obsahuje zle sparovane zatvorky !')
  else if not isempty(zasobnik) then
    writeln('Vo vstupnom riadku chybaju uzatvarajuce zatvorky !')
  else writeln('Vstupny riadok je spravny.')
end.

