/*
**
**
**
**	Autor:	Marek Gresko
**	Kruzok:	3INF-2
**
**	Zadanie c. 29
**
**
**
**
*/




#include <stdlib.h>
#include <stdio.h>
#include "elm.h"
#include "sqelm.h"
#include "mq.h"
#include "stack.h"

extern mq* parse2q (char*);
extern mq* conv2post (mq*);
extern elm spocitaj (mq*);

int main (int argc, char* argv[])
{
	mq* z;
	mq* po;
	elm e;

#if defined DEBUG1 || defined DEBUG2
	elm t;
#endif

	if (argc != 2)
	{
		fprintf (stderr, "%s: usage %s arithmetic_expression\n",
			argv[0], argv[0]);
		exit (0);
	}

	if (argv[1][0] == '-' && (argv[1][1] == 'h' || argv[1][1] == '?'))
	{
		fprintf (stderr, "%s: usage %s arithmetic_expression\n",
			argv[0], argv[0]);
		exit (0);
	}

	if ((z = parse2q (argv[1])) == NULL) // prepis char* na front objektov
	{
		fprintf (stderr, "Syntax error (p2q)\n");
		exit (-1);
	}

#ifdef DEBUG1
	while ((t = z->remove ()).op ())
	{
		if (t.op () != ' ') printf ("%c\n", t.op ());
		else printf ("%f\n", t.value ());
	}

	return 0;
#endif

	if ((po = conv2post (z)) == NULL) // prepis frontu objektov do postfixu
	{
		fprintf (stderr, "Syntax error (c2p)\n");
		exit (-1);
	}

#ifdef DEBUG2
	while ((t = po->remove ()).op ())
	{
		if (t.op () != ' ') printf ("%c\n", t.op ());
		else printf ("%f\n", t.value ());
	}

	return 0;
#endif

	if (!(e = spocitaj (po)).op ()) // vyhodnotenie postfixoveho vyrazu
	{
		fprintf (stderr, "Syntax error\n");
		exit (-1);
	}

	printf ("%f\n", e.value ());	

	return 0;
}

