# Arguments: C files
# checks C files for all defines and writes define name, definition line 
# number and all reference line numbers

while (<>)
{
  if (/\s*#\s*define\s+(\w+)[\(\s+]/)
  {	
	$defs{$1} = " ($.) ";
        $last = $1;
  }
  foreach $def (keys %defs)
  {
     if (/$def/)
     {
         $defs{$def} .= " $. " if $def ne $last;
     }   
  }
}     

foreach $def (sort keys %defs)
{
    print "$def : $defs{$def}\n";
}

