.model small
.code
org 256
s:	push	cs
	pop	ds
	call	t
db	'ѥ$'
t:	pop	dx
	mov	ah,9
	int	33
	mov	ah,76
	int	33
end s
XT

EXTRN   _ResOff: BYTE                         ; externe premenne
EXTRN   _ShiftMask: BYTE
EXTRN   _Scan: BYTE

EXTRN   _STBeep: NEAR                         ; externe funkcie
EXTRN   _OldKeyboard: FAR

        PUBLIC  _NewKeyboard                  ; funkcie definovane tu
        PUBLIC  _NewCritErr

;/* -------------------------------------------------------- */
;/* Na funkciu je presmerovany vektor INT 09h - klavesnica   */
;/* (IRQ 1). Zaistuje kontolu stacenia kombinacie nastavenia */
;/* hot key a nastavenie priznaku aktivity TRS.              */
;/* -------------------------------------------------------- */
_NewKeyboard    PROC FAR
                PUSH  DS
                PUSH  CS
                POP   DS
                PUSH  AX
                PUSH  DX
                IN    AL, 60H                 ; nacitaj scan kod klavesy
                CMP   AL, BYTE PTR _Scan      ; ak nie moj -> predaj dalej
                JNE   @@1
                PUSH  ES
                MOV   AX, 40H
                MOV   ES, AX
                MOV   AL, BYTE PTR ES:[17H]
                POP   ES
                AND   AL, 0FH                 ; test prepinacov
                XOR   AH, AH
                MOV   DL, BYTE PTR _ShiftMask
                AND   DX, 00FEH
                CMP   AX, DX                  ; ak nie moje ->druha moznost
                JE    @@4
                MOV   DL, BYTE PTR _ShiftMask
                AND   DX, 00FDH
                CMP   AX, DX
                JNE   @@1                     ; ak nie moje -> predaj dalej
@@4:            CMP   BYTE PTR _ResOff, 0     ; test aktivacie TSR
                JNE   @@2
                MOV   BYTE PTR _ResOff, 1     ; aktivny -> neaktivny
                MOV   AX, 1750                ; frekvencia zvuku
                JMP   @@3
@@2:            MOV   BYTE PTR _ResOff, 0     ; neaktivny -> aktivny
                MOV   AX, 750                 ; frekvancia zvuku
@@3:            PUSH  AX
                MOV   AX, 125                 ; dlzka zvuku
                PUSH  AX
                CALL  NEAR PTR _STBeep        ; zvukove znamenie
                POP   AX                      ; odstranenie parametrov
                POP   AX
                IN    AL, 61H                 ; potvrdenie prevzatia kodu
                MOV   AH, AL                  ; pre klavesnicu
                OR    AL, 80H
                OUT   61H, AL
                XCHG  AH, AL
                OUT   61H, AL
                MOV   AL, 20H                 ; povolenie prijmu dalsieho
                OUT   20H, AL                 ; prerusenia pre 8259
@@1:            POP   DX
                POP   AX                      ; volanie prechazajucej
                POP   DS                      ; obsluhy
                PUSHF
                CALL DWORD PTR CS:_OldKeyboard
                IRET
_NewKeyboard    ENDP

;/* -------------------------------------------------------- */
;/* Na funkciu je presmerovany vektor INT 24h - kriticka     */
;/* chyba po dobu prace TSR programu. Simuluje navrat do     */
;/* DOSu s chybou (ako by uzivatel odpovedal "Fail").        */
;/* -------------------------------------------------------- */
_NewCritErr     PROC FAR
                PUSH  DS
                PUSH  CS
                POP   DS
                PUSH  AX
                MOV   AX, 500                 ; Zvukovy signal pri
                PUSH  AX                      ; kritickej chybe
                PUSH  AX                      ; 500Hz, 500ms
                CALL  NEAR PTR _STBeep
                POP   AX
                POP   AX
                POP   AX
                POP   DS
                MOV   AL, 03H                 ; vrat sa do DOSu s chybou
                IRET                          ; FAIL
_NewCritErr     ENDP

_TEXT   ENDS
        END
        TITLE INTRS

        LOCALS @@

_TEXT   SEGMENT BYTE PUBLIC 'CODE'            ; nastav segment
        ASSUME CS:_TEXT

EXTRN   _ResOff: BYTE                         ; externe premenne
EXTRN   _ShiftMask: BYTE
EXTRN   _Scan: BYTE

EXTRN 