//Program HPcalc by Marek Ratkovsky 94551 SI8

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <process.h>
#include <alloc.h>

#define VERSION "4.1"

int ukaz=0;
float *zasobnik=NULL;
extern int Incr(int*);
char VypisError(char);

void main (int ac,char *av[])
{
	int i,velkost_riadku=1,ek=0;
	char ch;
	char *str;
	int uprav(char *,float *);
	float vrat;

	clrscr();

	if(!(strcmp(av[1],"-h"))||!(strcmp(av[1],"-H"))){
		cprintf("\r\nHPcalc version " VERSION ".  (c) 1997 Pegamon the Rilfin\r\n"
						"usage hpcalc [-a|-h|arg1..argn]\r\n"
						"             -h     -  this help\r\n"
						"             -a     -  directly enter. You can use redirect\r\n"
						"         arg1..argn -  get arguments and give result.\r\n");
		exit(0);
	}

	if(!(strcmp(av[1],"-a"))){

		if(ac>2)
			if(VypisError(12)==1) exit(-1);

		if((str = (char *) calloc(velkost_riadku=1,sizeof(char)))==NULL)
      if(VypisError(11)==1)
        exit(-1);

		while(1){
			while((ch=getchar())!='\n'){
				if(ch==EOF){
					cprintf("\r\nThanx for using HPcalc.\r\n");
					exit(0);
				}

				//if((ch=='X')||(ch=='x')||((ch<='9')&&(ch>='0'))||((ch<='F')&&(ch>='A'))||((ch<='f')&&(ch>='a'))||(ch==' ')||(ch=='+')||(ch=='-')||(ch=='*')||(ch=='/')){
        if(ch!='\n'){
					if((str = (char *) realloc(str,Incr(&velkost_riadku)))==NULL)
						if(VypisError(11)==1)
              exit(-1);

					str[velkost_riadku-2]=ch;
					str[velkost_riadku-1]='\x0';
				}
			}

			if((ch=='\n')&&(*str!='\x0')){

				if((ek=uprav(str,&vrat))==0)
          printf("Vysledok je:%.0f\n",vrat);
				else if(VypisError(ek)==1)
            exit(-1);

				free(str);

				if((str = (char *) calloc(velkost_riadku=1,sizeof(char)))==NULL)
					if(VypisError(11)==1)
            exit(-1);

				velkost_riadku=1;
			}
		}
	}

	if(ac<3){
		cprintf("\r\nHPcalc version " VERSION ".  (c) 1997 Pegamon the Rilfin\r\n"
						"Try hpcalc -h \r\n");
		exit(1);
	}

	for(i=1;i<ac-1;Incr(&i)) av[i][strlen(av[i])]=' ';

	if((ek=uprav(av[1],&vrat))==0){
		printf("\nVysledok je:%.0f\nThanx to using HPcalc.",vrat);
		exit(0);
	}
	else VypisError(ek);

}

int uprav(char *ret,float *vrat) //hlavna funkcia na vypocet ,
{																 //pricom vstupom je retazec znakou
	int poc=0;                     //sformatovany tak, ze medzi operandami
	int znamienko=0;               //a medzi operandom a operatorom su medzery
	float cislo=0;                 //retazec je zakonceny znakom '\x0'
	void push(float);
	float pop(void);

	ukaz=0;
	zasobnik = (float *) malloc(sizeof(float));

	do{
		switch(ret[poc]){
		case '/':if(ukaz>1){
							 cislo=pop();
							 push(pop()/cislo);
						 }
						 else{
							 free(zasobnik); //Error
							 return(1);
						 }break;
		case '*':if(ukaz>1)
							 push(pop()*pop());
						 else{
							 free(zasobnik); //Error
							 return(1);
						 }break;
		case ' ':break;
		case '+':if(!((ret[poc+1]<='9')&&(ret[poc+1]>='0')))
							 if(ukaz>1){
								 push(pop()+pop());
							 }
							 else{
								 free(zasobnik); //Error
								 return(1);
							 }
						 else znamienko=0;
						 break;
		case '-':if(!((ret[poc+1]<='9')&&(ret[poc+1]>='0')))
							 if(ukaz>1)
								 push(-pop()+pop());
							 else{
								 free(zasobnik); //Error
								 return(1);
							 }
						 else znamienko=1;
						 break;
		default: cislo=0;
						 if((ret[poc]=='0')&&((ret[poc+1]=='x')||(ret[poc+1]=='X'))){
							 Incr(&poc);

							 while(((ret[Incr(&poc)]<='9')&&(ret[poc]>='0'))||((ret[poc]<='F')&&(ret[poc]>='A'))||((ret[poc]<='f')&&(ret[poc]>='a'))){
								 switch(ret[poc]){
									 case 'A':
									 case 'a':ret[poc]=10;break;
									 case 'B':
									 case 'b':ret[poc]=11;break;
									 case 'C':
									 case 'c':ret[poc]=12;break;
									 case 'D':
									 case 'd':ret[poc]=13;break;
									 case 'E':
									 case 'e':ret[poc]=14;break;
									 case 'F':
									 case 'f':ret[poc]=15;break;
									 default: ret[poc]=ret[poc]-48;break;
								 }

								 cislo=cislo*16+ret[poc];
							 }

							 if((ret[poc]!=' ')&&(ret[poc]!='\x0')){
								 free(zasobnik);
								 return(3);
							 }
							 else{

								 if(znamienko==1){
									 cislo*=-1;
									 znamienko=0;
								 }

								 push(cislo);
							 } continue;
						 }
						 else{
							 if((ret[poc]<='9')&&(ret[poc]>='0')){
								 while((ret[poc]<='9')&&(ret[poc]>='0')){
									 cislo=cislo*10+ret[poc]-48;
									 Incr(&poc);
								 }

								 if((ret[poc]!=' ')&&(ret[poc]!='\x0')){
									 free(zasobnik);
									 return(3);
								 }
								 else {
									 if(znamienko==1){
										 cislo*=-1;
										 znamienko=0;
									 }

									 push(cislo);
								 } continue;
							 }
							 else
								 if(ret[poc]!='\x0') return(ret[poc]);
						 }
		}

		Incr(&poc);

	}while(ret[poc]!='\x0');

	*vrat=*zasobnik;
	free(zasobnik);

	if(ukaz==1) return(0);
	else return(2);

}

void push(float prvok)//ulozi prvok do zasobnika
{
 zasobnik[ukaz]=prvok;
 ukaz+=1;

 if((zasobnik = (float *) realloc(zasobnik,(ukaz+1)*sizeof(float)))==NULL)
   if(VypisError(11)==1)
     exit(-1);
}

float pop(void)//vybere zo zasobnika prvok
{
	float zal;
	ukaz-=1;
	zal=zasobnik[ukaz];

  if((zasobnik = (float *) realloc(zasobnik,(ukaz+1)*sizeof(float)))==NULL)
    if(VypisError(11)==1)
      exit(-1);

	return(zal);
}

char VypisError(char ek)//Vypise chybovu hlasku a
{          						  //vrati ci ma nastat exit, alebo nie
	switch(ek){
		case 1 :printf("HPcalc error #1:Too many operators\n");break;
		case 2 :printf("HPcalc error #2:Too few operators\n");break;
		case 3 :printf("HPcalc error #3:Bad operand\n");break;
    case 11:printf("HPcalc error #11: Not enough memory to allocate.\n");break;
    case 12:printf("HPcalc error #12:Bad arguments. When you use switch -a,\n"
							"\t\t               you have to use directly enter\r\n");break;
		default:printf("HPcalc error #4:%c is unknown symbol.\n",ek);
            ek=4;break;
	}

	if(ek>10) return(1);

	return(0);
}
