sub shelp
{
  print "\n(c)1997 Assembler Ratkovsky v1.3 .\n";
  print "Pouzitie: perl asembler.pl <meno vstupneho suboru>";
  exit(1);
}

sub jecislo
{
  ($cislo)=@_;
  $dlzka=length($cislo);
  if(($cislo=~/[0-9a-f]{$dlzka}/i) && ($dlzka<=4))
  {
     return("0" x (4-$dlzka).$cislo);
  }
  else
  {
    die("Chyba na riadku $. .Zle cislo $cislo .");
  }
}

sub jecislo1
{
  ($cislo)=@_;
  $dlzka=length($cislo);
  if(($cislo=~/[0-9a-f]{$dlzka}/i) && ($dlzka<=4))
  {
     return(hex($cislo));
  }
  else
  {
    die("Chyba na riadku $. .Zle cislo $cislo .");
  }
}


if( $#ARGV>1 || $#ARGV<0 )
{
  print "Zle parametre !!!, skus $0 -h \n";
  exit(1);
}

if(!($ARGV[0] cmp "-h") || !($ARGV[0] cmp "-H"))
{
  shelp();
}

if((-z $ARGV[0]) || !(-e $ARGV[0]))
{
  print "Vstupny subor ma nulovu dlzku ,alebo neexistuje!!!";
  exit(1);
}

$file_handle=$ARGV[0];
open (file_handle);
  
while ($riadok=<file_handle>)
{
  $riadok=~s/^\s+|\s+$//g;
  @rr2=split (/\s+/,$riadok);
  
  if((@rr2!=0) && !($riadok=~m/^\;/))
  {
#################DATA_CODE#################
    if((!($rr2[0] cmp "DATA")) || (!($rr2[0] cmp "CODE")))
    {
      if((@rr2==3) || ($rr2[3]=~m/^\;/))
      {
        if(!($rr2[1] cmp "ORG"))
      	{
	  $ofset=$ofset+$rr2[2];
          $subor[++$#subor]=("00" x hex($rr2[2]));
      	}
      	else
      	{
	  die("Chyba na $. riadku. Syntax DATA ORG xxxx");
      	}
      }
      else
      {
	die("Chyba na $. riadku. DATE ORG ma jeden parameter.");
      }
    }
###################DB#################
    elsif(!($rr2[0] cmp "DB"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
	$dlzka=length($rr2[1]);

	if(($rr2[1]=~/[0-9a-f]{$dlzka}/) && ($dlzka<=2))
	{
      	  $subor[++$#subor]=("0" x (2-$dlzka).$rr2[1]);
	}
	else
	{
	  die("Chyba parameter nie je cislo,alebo je velke cislo.")
	}
      }
      else
      {
	die("Chyba na $. riadku. DB ma jeden parameter.");
      }
    }
###################DW#################
    elsif(!($rr2[0] cmp "DW"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
      	  $subor[++$#subor]=jecislo($rr2[1]);
      }
      else
      {
	die("Chyba na $. riadku. DW ma jeden parameter.");
      }
    }
###################DS#################
    elsif(!($rr2[0] cmp "DS"))
    {
      $riadok=~/\s/;
      $riadok=$';
      if(($riadok=~s/^"//) && ($riadok=~s/"$//))
      {
	@pomocn1=split(//,$riadok);
	foreach(@pomocn1)
	{
	  $subor[++$#subor]=sprintf("%0x",ord($_));
	}
	$subor[++$#subor]="00";
      }
      else
      {
	die("Chyba na $. riadku. Syntax: DS \"retazec\".");
      }
    }
###################LABEL#################
    elsif(!($rr2[0] cmp "LABEL"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        if(($rr2[1]=~/^[A-Za-z]/) || ($lab{"$rr2[1]"}!=0))
        {
	  $lab{"$rr2[1]"} =$ofset+1;
	}
	else
	{
	  die("Chyba na $. riadku. LABEL sa musi zacinat pismenom a nesmie sa opakovat.");
	}
      }
      else
      {
	die("Chyba na $. riadku. LABEL ma jeden parameter.");
      }
    }
###################NOP#################
    elsif(!($rr2[0] cmp "NOP"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      { 
        $ofset++;
	$subor[++$#subor]="00";

      }
      else
      {
	die("Chyba na $. riadku. NOP je bezparametrova instrukcia.");
      }
    }
###################MVI#################
    elsif(!($rr2[0] cmp "MVI"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      { 
        $ofset=$ofset+3;
 	@rr3=split(/\,/,$rr2[1]);

	if(!($rr3[0] cmp "A"))
	{
	  $subor[++$#subor]="0a";
	  $subor[++$#subor]=jecislo($rr3[1]);
	}
	elsif(!($rr3[0] cmp "B"))
	{
	  $subor[++$#subor]="0b";
	  $subor[++$#subor]=jecislo($rr3[1]);
	}
	else
	{
	  die("Chyba na $. riadku. Syntax MVI A,\#konstanta.");
	}
      }
      else
      {
	die("Chyba na $. riadku. MVI ma dva parametre.");
      }
    }
###################MOV#################
    elsif(!($rr2[0] cmp "MOV"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
 	@rr3=split(/\,/,$rr2[1]);

        if(!($rr3[1] cmp "A"))
        {
          $subor[++$#subor]="0c";
	  if(($rr3[0]=~/\]$/)&&($rr3[0]=~/^\[/))
	  {
	    $rr3[0]=~s/^\[|\]$//g;
	    $subor[++$#subor]=jecislo($rr3[0]);
	  }
	  else
	  {
	    die("Chyba na $. riadku.");
	  }
        }
        elsif(!($rr3[0] cmp "A"))
        {
          $subor[++$#subor]="0d";
	  if(($rr3[1]=~/\]$/)&&($rr3[1]=~/^\[/))
	  {
	    $rr3[1]=~s/^\[|\]$//g;
	    $subor[++$#subor]=jecislo($rr3[1]);
	  }
	  else
	  {
	    die("Chyba na $. riadku.");
	  }
        }
        else
        {
          die("Chyba na $. riadku. Syntax MOV A,[adresa] ,alebo MOV [adresa],A.");
        }
      }
      else
      {
	die("Chyba na $. riadku. MOV ma dva parametre.");
      }
    }
###################MVR#################
    elsif(!($rr2[0] cmp "MVR"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset++;
        if(!($rr2[1] cmp "A,B"))
        {
          $subor[++$#subor]="04";
        }
        elsif(!($rr2[1] cmp "B,A"))
        {
          $subor[++$#subor]="05";
        }
        else
        {
          die("Chyba na $. riadku. Syntax MVR A,B , alebo MVR B,A.");
        }
      }
      else
      {
	die("Chyba na $. riadku. MVR ma dva parametre.");
      }
    }
###################ADD B#################
    elsif(!($rr2[0] cmp "ADD"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset++;
        if(!($rr2[1] cmp "B"))
        {
          $subor[++$#subor]="06";
        }
        else
        {
          die("Chyba na $. riadku. Syntax ADD B.");
        }
      }
      else
      {
	die("Chyba na $. riadku. ADD ma jeden parameter.");
      }
    }
###################ADC B#################
    elsif(!($rr2[0] cmp "ADC"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset++;
        if(!($rr2[1] cmp "B"))
        {
          $subor[++$#subor]="07";
        }
        else
        {
          die("Chyba na $. riadku. Syntax ADC B.");
        }
      }
      else
      {
	die("Chyba na $. riadku. ADC ma jeden parameter.");
      }
    }
###################SUB B#################
    elsif(!($rr2[0] cmp "SUB"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset++;
        if(!($rr2[1] cmp "B"))
        {
          $subor[++$#subor]="08";
        }
        else
        {
          die("Chyba na $. riadku. Syntax SUB B.");
        }
      }
      else
      {
	die("Chyba na $. riadku. SUB ma jeden parameter.");
      }
    }
###################SBC B#################
    elsif(!($rr2[0] cmp "SBC"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset++;
        if(!($rr2[1] cmp "B"))
        {
          $subor[++$#subor]="09";
        }
        else
        {
          die("Chyba na $. riadku. Syntax SBC B.");
        }
      }
      else
      {
	die("Chyba na $. riadku. SBC ma jeden parameter.");
      }
    }

###################ADI#################
    elsif(!($rr2[0] cmp "ADI"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="0e";
	$subor[++$#subor]=jecislo($rr2[1]);
      }
      else
      {
	die("Chyba na $. riadku. ADI ma jeden parameter.");
      }
    }

###################SBI#################
    elsif(!($rr2[0] cmp "SBI"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="0f";
	$subor[++$#subor]=jecislo($rr2[1]);
      }
      else
      {
	die("Chyba na $. riadku. SBI ma jeden parameter.");
      }
    }
###################INC#################
    elsif(!($rr2[0] cmp "INC"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      {
        $ofset++;
        $subor[++$#subor]="01";
      }
      else
      {
	die("Chyba na $. riadku. INC nema parametre.");
      }
    }
###################DEC#################
    elsif(!($rr2[0] cmp "DEC"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      {
        $ofset++;
        $subor[++$#subor]="02";
      }
      else
      {
	die("Chyba na $. riadku. DEC nema parametre.");
      }
    }
###################CLR#################
    elsif(!($rr2[0] cmp "CLR"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      {
        $ofset++;
        $subor[++$#subor]="03";
      }
      else
      {
	die("Chyba na $. riadku. CLR nema parametre.");
      }
    }
###################JZ#################
    elsif(!($rr2[0] cmp "JZ"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="11";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. JZ ma jeden parameter.");
      }
    }
###################JC#################
    elsif(!($rr2[0] cmp "JC"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="12";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. JC ma jeden parameter.");
      }
    }
###################JMP#################
    elsif(!($rr2[0] cmp "JMP"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="10";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. JMP ma jeden parameter.");
      }
    }
###################JR#################
    elsif(!($rr2[0] cmp "JR"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="13";
	$dlzka=length($rr2[1])-1;

	if($rr2[1]=~s/^\-//)
	{
	  die("Chyba na $. riadku. Cislo je cez rozsah.") if(jecislo1($rr2[1])>=32000);
	  $subor[++$#subor]=sprintf("%0x",jecislo1($rr2[1])+32768);
	}
	else
	{
	  die("Chyba na $. riadku. Cislo je cez rozsah.") if(jecislo1($rr2[1])>=32000);
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. JR ma jeden parameter.");
      }
    }

###################PUSH#################
    elsif(!($rr2[0] cmp "PUSH"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="14";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. PUSH ma jeden parameter.");
      }
    }
###################POP#################
    elsif(!($rr2[0] cmp "POP"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="15";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. POP ma jeden parameter.");
      }
    }
###################CALL#################
    elsif(!($rr2[0] cmp "CALL"))
    {
      if((@rr2==2) || ($rr2[2]=~m/^\;/))
      {
        $ofset=$ofset+3;
        $subor[++$#subor]="16";

        if($rr2[1]=~/^[A-Za-z]/)
        {
	  $labely{"$rr2[1].$ofset"}="$#subor";
	  $subor[++$#subor]="xxxx";
	}
	else
	{
	  $subor[++$#subor]=jecislo($rr2[1]);
	}
      }
      else
      {
	die("Chyba na $. riadku. CALL ma jeden parameter.");
      }
    }
###################RET#################
    elsif(!($rr2[0] cmp "RET"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      {
        $ofset++;
        $subor[++$#subor]="1a";
      }
      else
      {
	die("Chyba na $. riadku. RET nema parametre.");
      }
    }

###################HALT#################
    elsif(!($rr2[0] cmp "HALT"))
    {
      if((@rr2==1) || ($rr2[1]=~m/^\;/))
      {
        $ofset++;
        $subor[++$#subor]="ff";
      }
      else
      {
	die("Chyba na $. riadku. HALT nema parametre.");
      }
    }
#################KED ZLE###################
    else
    {
      die("Chyba na $. riadku. Nedefinovana instrukcia.");
    }
  }
}

while (($meno, $pozicia) = each(%labely)) 
{
  @meno1=split(/\./,$meno);
  $hexcislo=sprintf("%0x",$lab{$meno1[0]}-1);
  if($lab{$meno1[0]})
  {
    $subor[++$pozicia] = ("0" x (4-length($hexcislo)).$hexcislo);
  }
  else
  {
    die("Chyba LABEL $meno1[0] nebol definovany");
  }
}

$subor=join("",@subor);
@subor=split(//,$subor);

if (open(FILE, ">vystup.mif"))
{
  print FILE ("REGISTERS:0000 0000");
  foreach(@subor)
  { 
    $zalozna=sprintf ("%0x",$pocitadlo/2);
    print FILE "  " if(($pocitadlo%8)==0);
    print FILE "\n",("0" x (4-length($zalozna))).$zalozna,":" if(($pocitadlo%32)==0);
    print FILE " " if(($pocitadlo%2)==0);
    print FILE $_;
    $pocitadlo++;
  }
  close(FILE);
  print "OK vysledok bol ulozeny do suboru vystup.mif";
}
else
{
  print "Nemozem otvorit subor vystup.mif";
}