; ECB
; +0h	4b	link address = xxx
; +4h	4b	ESR address
; +8h	1b	in use flag = 0 ak sa nepouziva
; +9h	1b	completion code = 0 ak bol poslany v poriadku 0fdh chybny paket 0feh no listener 0ffh network error
; +0ah	2b	bigendian local socket
; +18h	4b	destination network address (even router)
; +1ch	6b	destination node address (even router)
; +22h	2b	fragment count
; +24h	4b	little endian first fragment address
; +28h	2b	first fragment size	

; IPX
; +0h	1w	checksum = 0ffffh
; +2h	1w	length
; +4h	1b	transport control = 0
; +5h	1b	packet type = 0
; +6h	4b	destination network
; +0ah	6b	destination node
; +10h	1w	destination socket
; +12h	4b	source network
; +16h	6b	source node
; +1ch	1w	source socket
; +1eh	546b	data

; int 7ah
; 0000h	open socket

;	bx = 0000h
;	al = 00h otvor do uzavretia alebo skoncenia programu
;	dx = socket number 0 dynamic

;	al = 0 ok 0feh socket table full 0ffh socket already opened
;	dx = socket number if 0 was

; 0001h	close socket

;	bx = 0001h
;	dx = socket number

; 0002h	next node

;	bx = 0002h
;	es:si = dest addr
;	es:di = 6b buffer for next node hw addr

;	al = 0 ok 0fah no addr
;	cx = time
;	es:di = next node hw addr

; 0003h	ipxsend

;	bx = 0003h
;	es:si = ptr to ECB

; 0004h	ipxreceive

;	bx = 0004h
;	es:si = ptr to ECB

; 0005h	schedule

;	bx = 0005h
;	ax = time to wait
;	es:si = ptr to ECB

; 0006h	cancel

;	bx = 0006h
;	es:si = ptr to ECB

;	al = 0 ok 0f9h running now 0ffh not scheduled

; 0009h	getmyaddr

;	bx = 0009h
;	es:si = buffer 10b

;	es:si = my addr



;	databazka mien

mena1	db 20*20 dup(0)
local1	db 10*20 dup(0)

;		---=== VYPIS MENA ===---

vypismena:
	pusha
	push es
	mov ax,0b800h
	mov es,ax

	mov si,offset mena1
	mov cx,20
sl:	cmp [byte si],0
	jz nicego
	push cx si
	push ds si
	push es
	pop ds
	mov cx,80*22
	mov si,160
	xor di,di
	rep movsw
	pop si ds

	mov ah,15
	mov cx,10
;	mov di,160*22
sl2:	lodsb
	stosw
	loop sl2
	mov cx,70
	mov al,0
	rep stosw
	pop si cx
nicego:	add si,20
	loop sl

	pop es
	popa
	ret

;		---=== SNDTST ===---

sndtst:
	nop
	nop
	push bp
	mov bp,sp
			;vstup bp+4 az bp+18
			;bp+4 mtime
			;bp+6 myaddr
			;bp+8 lsndsck
			;bp+10 buffer + 4
			;bp+12 pozicia(pocat znakov mena) - 4
			;bp+14 sndipx
			;bp+16 sndecb
	pusha
	mov di,[bp+14]
	mov ax,[bp+4]
	inc ax
	jnz koncek
	mov [word di],0ffffh
	mov [word di+10],0ffffh
	mov [word di+12],0ffffh
	mov [word di+14],0ffffh
	mov [word di+16],lrcvsck	
	mov ax,[bp+8]
	add di,12h
	mov si,[bp+6]
	mov cx,5
	rep movsw
	stosw
	add di,10
	push di
	mov si,[bp+10]	
	mov cx,[bp+12]
	mov al,20h
	mov di,si
	rep scasb
	inc cx
	dec di
	mov si,di	
	pop di
	push di
	cmp cx,10
	jna spravne1
	mov cx,10
spravne1:
	rep movsb
	mov cx,di
	pop ax
	sub cx,ax
	sub cx,12	; doplnime na dlzku retazca 12 (meno+typ+dlzka)
	neg cx
	mov al,0
	rep stosb
	sub di,[bp+14]
	push di
	push bx
	mov bx,[bp+14]
	mov [word bx+2],di
	pop bx
	mov di,[bp+16]
	mov ax,[bp+8]
	mov [di+10],ax
	mov [word di+1ch],0ffffh
	mov [word di+1eh],0ffffh
	mov [word di+20h],0ffffh
	mov [word di+22h],1
	mov ax,[bp+14]
	mov [word di+24h],ax
	mov ax,cs
	mov [word di+26h],ax
	pop ax
	mov [word di+28h],ax
	mov si,[bp+16]
	mov bx,3
	int 7ah
dokonci:
	cmp [byte si+8],0
	jnz dokonci
	mov [word bp+4],20
koncek:
	popa
	mov sp,bp
	pop bp
	ret		

;	






;	---=== SNDREG ===---

sndreg:	push bp
	mov bp,sp
		;bp+4 sndecb
		;bp+6 sndipx

	pusha
	mov di,[bp+6]
	mov [byte di+50],2
	mov si,[bp+4]
	mov bx,3
	int 7ah
dokonci2:
	cmp [byte si+8],0
	jnz dokonci2
	popa

	mov sp,bp
	pop bp
	ret

;		---=== SNDDEL ===---

snddel:	push bp
	mov bp,sp
			;vstup bp+4 az bp+16
			;bp+4 myaddr
			;bp+6 lsndsck
			;bp+8 buffer + 4
			;bp+10 pozicia(pocat znakov mena) - 4
			;bp+12 sndipx
			;bp+14 sndecb
	pusha
	mov di,[bp+12]
	mov [word di],0ffffh
	mov [word di+10],0ffffh
	mov [word di+12],0ffffh
	mov [word di+14],0ffffh
	mov [word di+16],brcvsck	
	mov ax,[bp+6]
	add di,12h
	mov si,[bp+4]
	mov cx,5
	rep movsw
	stosw
	add di,10
	push di
	mov si,[bp+8]	
	mov cx,[bp+10]
	mov al,20h
	mov di,si
	rep scasb
	inc cx
	dec di
	mov si,di	
	pop di
	push di
	cmp cx,10
	jna dspravne1
	mov cx,10
dspravne1:
	rep movsb
	mov cx,di
	pop ax
	sub cx,ax
	sub cx,12	; doplnime na dlzku retazca 12 (meno+typ+dlzka)
	neg cx
	mov al,0
	rep stosb
	mov al,3
	mov [di-2],al
	sub di,[bp+12]
	push di
	push bx
	mov bx,[bp+12]
	mov [word bx+2],di
	pop bx
	mov di,[bp+14]
	mov ax,[bp+6]
	mov [di+10],ax
	mov [word di+1ch],0ffffh
	mov [word di+1eh],0ffffh
	mov [word di+20h],0ffffh
	mov [word di+22h],1
	mov ax,[bp+12]
	mov [word di+24h],ax
	mov ax,cs
	mov [word di+26h],ax
	pop ax
	mov [word di+28h],ax
	mov si,[bp+14]
	mov bx,3
	int 7ah
dokonci3:
	cmp [byte si+8],0
	jnz dokonci3
	popa
	mov sp,bp
	pop bp
	ret		

;			---=== TESTUJ MENO LOKALNE ===---
errmsg	db "meno existuje: "

erroro: push bp
	mov bp,sp
		;bp+4	buf
		;bp+6	len
	push es
	push ds
	mov ax,0b800h
	mov es,ax
	mov ds,ax
	mov si,160
	xor di,di
	mov cx,80*22
	rep movsw
	pop ds
	mov si,offset errmsg
	mov ah,11
	mov cx,erroro-errmsg
	push cx
sle:	lodsb
	stosw
	loop sle
	mov ah,14
	mov si,[bp+4]
	mov cx,[bp+6]
	jcxz pres6
sle2:	lodsb
	stosw
	loop sle2
pres6:	pop cx
	sub cx,80
	neg cx
	sub cx,[bp+6]
	mov al,0
	rep stosw
	pop es
	mov sp,bp
	pop bp
	ret
	

ltstname:
	push bp
	mov bp,sp
		;bp+4	myaddr
		;bp+6	len
		;bp+8	buf
	mov di,[bp+8]
	mov cx,[bp+6]
	mov al,20h
	rep scasb
	inc cx
	dec di
	jcxz tdoko1
	mov si,di
	cmp cx,10
	jna tjetok
	mov cx,10
tjetok:	mov di,offset local1
	mov bx,cx
	mov cx,10
tlslu:	push cx
	mov cx,bx
	push si di
	rep cmpsb
	jnz tneobsadl
	cmp bx,10
	jz tobsadl
	cmp [byte di],0
	jz tobsadl
tneobsadl:
	pop di si
	add di,20
	pop cx
	loop tlslu

	mov di,offset mena1
	mov cx,20
tgslu:	push cx
	mov cx,bx
	push si di
	rep cmpsb
	jnz tneobsadl2
	cmp bx,10
	jz tobsadl
	cmp [byte di],0
	jz tobsadl
tneobsadl2:
	pop di si
	add di,20
	pop cx
	loop tgslu

	clc
tdoko1:	mov sp,bp
	pop bp
	ret

tobsadl:
	add sp,6
	mov ax,[bp+6]
	push ax
	mov ax,[bp+8]
	push ax
	call erroro
	add sp,4
	stc
	jmp short tdoko1

;		---=== pridaj meno do tabuliek ===---

laddname:
	push bp
	mov bp,sp
	sub sp,8
		;bp-2	local name free number
		;bp-4	reqmeno
		;bp-6	reqmenolen
		;bp-8	global name free number
		;bp+4	myaddr
		;bp+6	len
		;bp+8	buf
	pusha
	mov di,[bp+8]
	mov cx,[bp+6]
	mov al,20h
	rep scasb
	inc cx
	dec di
	mov si,di
	cmp cx,10
	jna jetok
	mov cx,10
jetok:	mov di,offset local1
	mov [bp-4],si
	mov [bp-6],cx
	mov bx,cx
	mov cx,10
lslu:	push cx
	cmp [byte di],0
	jnz pokr1
	mov [word bp-2],10
	sub [bp-2],cx
pokr1:	mov cx,bx
	push si di
	rep cmpsb
	jnz neobsadl
	cmp bx,10
	jz obsadl
	cmp [byte di],0
	jz obsadl
neobsadl:
	pop di si
	add di,20
	pop cx
	loop lslu

	mov di,offset mena1
	mov cx,20
gslu:	push cx
	cmp [byte di],0
	jnz pokr2
	mov [word bp-8],20
	sub [bp-8],cx
pokr2:	mov cx,bx
	push si di
	rep cmpsb
	jnz neobsadl2
	cmp bx,10
	jz obsadl
	cmp [byte di],0
	jz obsadl
neobsadl2:
	pop di si
	add di,20
	pop cx
	loop gslu

	mov ax,[bp-2]
	mov cx,20
	mul cx
	mov di,offset local1
	add di,ax
	mov si,[bp-4]
	mov cx,[bp-6]
	rep movsb
	mov cx,10
	sub cx,[bp-6]
	mov al,0
	rep stosb
	mov ax,[bp-8]
	mov di,offset mena1
	mov cx,20
	mul cx
	add di,ax
	mov si,[bp-4]
	mov cx,[bp-6]
	rep movsb
	mov cx,10
	sub cx,[bp-6]
	mov al,0
	rep stosb

	clc

doko1:	popa
	mov sp,bp
	pop bp
	ret

obsadl:
	add sp,6
	call erroro
	stc
	jmp short doko1

;		---=== uber meno z tabuliek ===---

ldelname:
	push bp
	mov bp,sp
	sub sp,4
		;bp-2	local name match number
		;bp-4	global name match number
		;bp+4	myaddr
		;bp+6	len
		;bp+8	buf
	pusha
	mov di,[bp+8]
	mov cx,[bp+6]
	mov al,20h
	rep scasb
	inc cx
	dec di
	mov si,di
	mov dx,si
	cmp cx,10
	jna jetok9
	mov cx,10
jetok9:	mov di,offset local1
	mov bx,cx
	mov cx,10
dlslu:	mov [word bp-2],10
	sub [bp-2],cx
	push cx
	mov cx,bx
	push si di
	rep cmpsb
	jnz dneobsadl
	cmp bx,10
	jz dobsadl
	cmp [byte di],0
	jz dobsadl

dneobsadl:
	pop di si
	add di,20
	pop cx
	loop dlslu

dlocaldel:
	mov si,dx
	mov di,offset mena1
	mov cx,20
dgslu:	mov [word bp-4],20
	sub [bp-4],cx
	push cx
	mov cx,bx
	push si di
	rep cmpsb
	jnz dn2eobsadl2
	cmp bx,10
	jz dobsadl2
	cmp [byte di],0
	jz dobsadl2
dn2eobsadl2:
	pop di si
	add di,20
	pop cx
	loop dgslu
dlocal2del:
	mov ax,[bp-2]
	mov cx,20
	mul cx
	mov di,offset local1
	add di,ax
	mov cx,10
	xor ax,ax
	rep stosw
	mov ax,[bp-4]
	mov di,offset mena1
	mov cx,20
	mul cx
	add di,ax
	mov cx,10
	xor ax,ax
	rep stosw
	clc
	popa
	mov sp,bp
	pop bp
	ret

dobsadl:
	add sp,6
	jmp short dlocaldel

dobsadl2:
	add sp,6
	jmp short dlocal2del
