; ECB
; +0h	4b	link address = xxx
; +4h	4b	ESR address
; +8h	1b	in use flag = 0 ak sa nepouziva
; +9h	1b	completion code = 0 ak bol poslany v poriadku 0fdh chybny paket 0feh no listener 0ffh network error
; +0ah	2b	bigendian local socket
; +0ch	4b	IPX workspace
; +10h	12b	driver workspace
; +1ch	6b	destination node address (even router)
; +22h	2b	fragment count
; +24h	4b	little endian first fragment address
; +28h	2b	first fragment size	

; IPX
; +0h	1w	checksum = 0ffffh
; +2h	1w	length
; +4h	1b	transport control = 0
; +5h	1b	packet type = 0
; +6h	4b	destination network
; +0ah	6b	destination node
; +10h	1w	destination socket
; +12h	4b	source network
; +16h	6b	source node
; +1ch	1w	source socket
; +1eh	546b	data

; int 7ah
; 0000h	open socket

;	bx = 0000h
;	al = 00h otvor do uzavretia alebo skoncenia programu
;	dx = socket number 0 dynamic

;	al = 0 ok 0feh socket table full 0ffh socket already opened
;	dx = socket number if 0 was

; 0001h	close socket

;	bx = 0001h
;	dx = socket number

; 0002h	next node

;	bx = 0002h
;	es:si = dest addr
;	es:di = 6b buffer for next node hw addr

;	al = 0 ok 0fah no addr
;	cx = time
;	es:di = next node hw addr

; 0003h	ipxsend

;	bx = 0003h
;	es:si = ptr to ECB

; 0004h	ipxreceive

;	bx = 0004h
;	es:si = ptr to ECB

; 0005h	schedule

;	bx = 0005h
;	ax = time to wait
;	es:si = ptr to ECB

; 0006h	cancel

;	bx = 0006h
;	es:si = ptr to ECB

;	al = 0 ok 0f9h running now 0ffh not scheduled

; 0009h	getmyaddr

;	bx = 0009h
;	es:si = buffer 10b

;	es:si = my addr



;

ideal
model tiny
p386

lrcvsck=4400h
brcvsck=0044h

;lrcvsck=4444h
;brcvsck=4444h


typeofpacket=30+2

datapacket=0
testpacket=1
registerpacket=2
unregisterpacket=3

dataseg

initxt	db "     add - pridaj meno   del - zmaz meno   snd - posli spravu      ESC - koniec "
nodrv	db "nenasiel som IPX driver",13,10,'$'
scknfr	db "socket na pocuvanie nie je volny",13,10,'$'
memisfull	db "nedostatok volnej pamati",13,10,'$'

chflag	db 0

mtime	dw -1

bsndsck	dw 0
lsndsck	dw 0

f1free	dw 0
memtop	dw 0

pkt1adr	dw 0
pktladr dw 0

myaddr	db 10 dup(0)

pozicia	db 0
dlzka	db 0
buffer	db 80 dup(0)

rcvecb	db 2ah dup(0)
sndecb	db 2ah dup(0)
sndipx	db 30 dup(0)
ipxdata	db 546 dup(?)

codeseg
startupcode
	mov ax,7a00h
	int 2fh
	mov dx,offset nodrv
	cmp al,0ffh
	jne error

	mov al,0
	mov bx,0
	mov dx,lrcvsck
	int 7ah			;otvori socket
	mov dx,offset scknfr
	cmp al,0
	jne error

	mov al,0
	mov bx,0
	mov dx,0
	int 7ah
	mov [lsndsck],dx
	xchg dh,dl
	mov [bsndsck],dx

	push ds
	pop es
	mov bx,9
	mov si,offset myaddr
	int 7ah

	mov ax,3508h
	int 21h
	mov [tmofs],bx
	mov [tmseg],es
	mov dx,offset timer
	mov ax,2508h
	int 21h

	call initi

slucka: push ax
	mov ax,[mtime]
	inc ax
	pop ax
	jnz nokeypress
	mov ax,100h
	int 16h
	jz nokeypress
	xor ax,ax
	int 16h
	cmp al,27
	jz ukonci
	mov dl,60
	cmp [pozicia],dl
	ja preskoc
	int 29h
preskoc:
	cmp al,8
	jnz nobsp
	cmp [pozicia],0
	jz slucka
	cmp [pozicia],dl
	jna presk2
	int 29h
presk2:	dec [pozicia]
	mov al,0
	int 29h
	mov al,8
	int 29h
	jmp short slucka
nobsp:	cmp al,13
	jnz nespracuj
	push ax
	mov al,[pozicia]
	mov [dlzka],al
	pop ax
	push es
	push di
	push ax
	mov di,0b800h
	mov es,di
	mov di,160*24
	mov ax,700h
	mov cx,80
	rep stosw
	pop ax
	pop di
	pop es
	jmp short spracuj
nespracuj:
	mov dl,60
	cmp [pozicia],dl
	ja nokeypress
	mov bh,0
	mov bl,[pozicia]
	mov [buffer+bx],al
	inc bl
	mov [pozicia],bl
nokeypress:
	call prichod
	call timeout
	jmp slucka

ukonci:	mov dx,lrcvsck
	mov bx,1
	int 7ah
	mov dx,[cs:lsndsck]
	mov bx,1
	int 7ah
	mov dx,[cs:tmofs]
	mov ds,[cs:tmseg]
	mov ax,2508h
	int 21h
	mov ax,4c00h
	int 21h

error:	mov ah,9
	int 21h
	jmp short ukonci

;			---=== SPRACOVANIE ODOSLANEHO RIADKA ===---

spracuj:
	push es
	push ds
	pop es

		; tu prebehne akcia spracovania uzivatelskeho vstupu	

;	call scroll	

;	mov si,offset buffer
;	mov ch,0
;	mov cl,[pozicia]
;	mov ah,7
;	jcxz nevypis
;vypis:	lodsb
;	stosw
;	loop vypis
;nevypis:

	call enterpressed

	pop es
	mov [pozicia],0
	mov al,13
	int 29h
	jmp slucka

scroll:
	push ds
	mov ax,0b800h
	mov es,ax
	mov ds,ax
	mov cx,22*80
	xor di,di
	mov si,160
	rep movsw
	mov ax,700h
	mov cx,80
	rep stosw
	sub di,160
	pop ds
	ret

;			---=== SPRACOVANIE PRICHODZICH PAKETOV ===---

prichod:
	push es
	push ds
	push cs
	pop ds
	pusha
	mov ax,[pkt1adr]
	mov es,ax
	xor si,si
	mov ax,[es:si]
	cmp ax,si
	jz preskocho
;	exitcode 0
preskocho:
	popa
	pop ds
	pop es
	ret

;			---=== INICIALIZACIA ===---

initi:	mov ax,[word 2]
	sub ax,72
	mov [memtop],ax
	mov ax,ds
	add ax,1000h
	mov [pkt1adr],ax
	mov [pktladr],ax
	mov es,ax
	xor bx,bx
	mov [word es:bx],bx
	cmp ax,[memtop]
	ja memfull
	add ax,36
	mov [f1free],ax
	cmp ax,[memtop]
	ja memfull
dalsi:	mov es,ax
	add ax,36
	mov [es:bx],ax
	cmp ax,[memtop]
	jb dalsi
	mov [es:bx],bx

; tu je hotova inicializacia buffera

; inicializacia obrazovky
	mov ax,3
	int 10h
	mov cx,25
	mov al,10
ttt:	int 29h
	loop ttt
	mov al,13
	int 29h
	mov ax,0b800h
	mov es,ax
	mov di,160*23
	mov si,offset initxt
	mov ah,70h
	mov cx,80
slck:	lodsb
	stosw
	loop slck
;hotova inicializacia obrazovky
;naplanovanie cakania na prvy paket
	
plan1:	push ds
	pop es
	mov si,offset rcvecb
	mov [word rcvecb+0ah],lrcvsck
	mov [word rcvecb+22h],1
	mov [word rcvecb+28h],576
	mov ax,[pkt1adr]
	mov [word rcvecb+26h],ax
	mov ax,cs
	mov [word rcvecb+6],ax
	mov ax,offset pktrcvd
	mov [word rcvecb+4],ax
	mov bx,4
	int 7ah			; tu je hotove plnenie buffera na pozadi
	ret

memfull:
	mov dx,offset memisfull
	pop ax
	jmp error
	

include 'sprac.inc'
include 'mena.inc'
;			---=== BUFFER FILLING - ESR ===---

pktrcvd:
	cli
	pusha
	push ds
	push es
	push cs
	pop ds

	cmp [byte es:si+9],0
	jne nomem
	mov ax,[f1free]
	push es
	mov es,ax
	xor bx,bx
	mov dx,[es:bx]
	cmp dx,bx
	pop es
	je nomem
	mov [f1free],dx
	mov [pktladr],ax
	mov cx,ax
	xchg cx,[word es:si+26h]	;cx - seg posl IPX paketu
	push es
	mov es,cx
	mov [word es:0],ax	;do pola checksum posl IPX paketu vloz seg buff
	mov es,ax
	xor cx,cx
	mov [word es:0],cx	;do pola checksum buff pre pkt vloz 0
	pop es

nomem:	mov bx,4
	int 7ah
	cli

	pop es
	pop ds
	popa
	retf

;		---=== CASOVAC VYPRSANIA CASU DORUCENIA KONFLIKTU ===---

timer:	cli
	push bx
	pushf
	mov bx,[word cs:mtime]
	or bx,0
	jz vyprsal		; time == 0
	inc bx
	jz vyprsal		; time == -1
	sub [word cs:mtime],1
vyprsal:
	popf
	pop bx
	db 0eah
tmofs	dw 0
tmseg	dw 0

enterpressed:
	mov al,[pozicia]
	cmp al,5
	jb kratkyvstup
	mov ax,[word buffer]
	mov cx,[word buffer+2]
	mov bx,ax
	mov dx,cx
	sub bx,'da'
	sub dx,' d'
	or bx,dx
	jz pridajmeno
	mov bx,ax
	mov dx,cx
	sub bx,'ed'
	sub dx,' l'
	or bx,dx
	jz zmazmeno
	mov bx,ax
	mov dx,cx
	sub bx,'ns'
	sub dx,' d'
	or bx,dx
;	jz poslipaket
kratkyvstup:
	ret

mam	db "nevlastnim meno: "

zmazmeno:
	nop
	nop
	mov di,offset buffer
	add di,4
	push di
	mov bh,0
	mov bl,[dlzka]
	sub bl,4
	push bx
	mov di,offset myaddr
	push di
	call ltstname
	lahf
	add sp,6
	sahf
	jnc zconfl
	mov di,offset sndecb
	push di
	mov di,offset sndipx
	push di
	mov bl,[dlzka]
	mov bh,0
	sub bl,4
	push bx
	mov di,offset buffer
	add di,4
	push di
	mov bx,[lsndsck]
	push bx
	mov di,offset myaddr
	push di
	call snddel
	add sp,12

	mov di,offset buffer
	add di,4
	push di
	mov bh,0
	mov bl,[dlzka]
	sub bl,4
	push bx
	mov di,offset myaddr
	push di
	call ldelname
	mov [chflag],1
	add sp,6
	ret

zconfl:	call scroll
	push es
	pusha
	mov ax,0b800h
	mov es,ax
	mov di,22*160
	mov si,offset mam
	mov cx,zmazmeno-mam
	mov ah,11
slu1:	lodsb
	stosw
	loop slu1
	mov si,offset buffer
	push di
	mov di,si
	add di,4
	mov al,20h
	mov cl,[dlzka]
	mov ch,0
	rep scasb
	sub cx,3
	dec di
	mov si,di
	pop di
	mov ah,14
slu2:	lodsb
	stosw
	loop slu2
	mov al,0
	mov cx,23*160
	sub cx,di
	shr cx,1
	rep stosw
	popa
	pop es
	ret

pridajmeno:
	mov di,offset buffer
	add di,4
	push di
	mov bh,0
	mov bl,[dlzka]
	sub bl,4
	push bx
	mov di,offset myaddr
	push di
	call ltstname
	lahf
	add sp,6
	sahf
	jc confl
	mov ax,[mtime]
	mov di,offset sndecb
	push di
	mov di,offset sndipx
	push di
	mov bl,[dlzka]
	mov bh,0
	sub bl,4
	push bx
	mov di,offset buffer
	add di,4
	push di
	mov bx,[lsndsck]
	push bx
	mov di,offset myaddr
	push di
	push ax
	call sndtst
	pop ax
	mov [mtime],ax
	add sp,12
confl:	ret		

timeout:
	push es
	push ax bx cx dx
	push ds
	pop es
	call vypistime
	push ds
	pop es
	cmp [chflag],0
	jz nevypis
	mov [chflag],0
	call vypismena
nevypis:
	mov ax,[mtime]
	inc ax
	jz notimer
	dec ax
	jnz notimer

	mov di,offset buffer
	add di,4
	push di
	mov bh,0
	mov bl,[dlzka]
	sub bl,4
	push bx
	mov di,offset myaddr
	push di
	call laddname
	mov [chflag],1
	lahf
	add sp,6
	sahf
	jc confladd
	
	mov di,offset sndipx
	push di
	mov di,offset sndecb
	push di
	call sndreg
	add sp,4
confladd:
	mov [word mtime],0ffffh
notimer:
	pop dx cx bx ax
	pop es
	ret

vypistime:
	push es
	pusha
	mov ax,0b800h
	mov es,ax
	mov di,23*160
	mov ax,[mtime]
	mov cx,ax
	shr ax,12
	mov ah,1eh
	add al,30h
	cmp al,39h
	jna p1
	add al,7
p1:	stosw
	mov al,ch
	and al,0fh
	add al,30h
	cmp al,39h
	jna p2
	add al,7
p2:	stosw
	mov al,cl
	shr al,4
	add al,30h
	cmp al,39h
	jna p3
	add al,7
p3:	stosw
	mov al,cl
	and al,0fh
	add al,30h
	cmp al,39h
	jna p4
	add al,7
p4:	stosw

	popa
	pop es
	ret
end

