// PGView.cpp : implementation of the CPGView class
//

#include "stdafx.h"
#include "PG.h"

#include "PGDoc.h"
#include "PGView.h"
#define OEMRESOURCE

#include <windows.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPGView

IMPLEMENT_DYNCREATE(CPGView, CScrollView)

BEGIN_MESSAGE_MAP(CPGView, CScrollView)
	//{{AFX_MSG_MAP(CPGView)
	ON_COMMAND(ID_VIEW_POINTS, OnViewPoints)
	ON_COMMAND(ID_VIEW_WIREFRAME, OnViewWireframe)
	ON_COMMAND(ID_VIEW_WIREFRAME2, OnViewWireframe2)
	ON_UPDATE_COMMAND_UI(ID_VIEW_POINTS, OnUpdateViewPoints)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WIREFRAME, OnUpdateViewWireframe)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WIREFRAME2, OnUpdateViewWireframe2)
	ON_COMMAND(ID_VIEW_STENOVY, OnViewStenovy)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STENOVY, OnUpdateViewStenovy)
	ON_COMMAND(ID_BUTTON32778, OnButton32778)
	ON_COMMAND(ID_BUTTON32779, OnButton32779)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32778, OnUpdateButton32778)
	ON_COMMAND(ID_BUTTON32780, OnButton32780)
	ON_COMMAND(ID_BUTTON32781, OnButton32781)
	ON_COMMAND(ID_BUTTON32782, OnButton32782)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32780, OnUpdateButton32780)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32781, OnUpdateButton32781)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32782, OnUpdateButton32782)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_UPDATE_COMMAND_UI(ID_BUTTON32779, OnUpdateButton32778)
	ON_COMMAND(ID_BUTTON32783, OnViewPoints)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32783, OnUpdateViewPoints)
	ON_COMMAND(ID_BUTTON32784, OnViewWireframe)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32784, OnUpdateViewWireframe)
	ON_COMMAND(ID_BUTTON32785, OnViewWireframe2)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32785, OnUpdateViewWireframe2)
	ON_COMMAND(ID_BUTTON32786, OnViewStenovy)
	ON_UPDATE_COMMAND_UI(ID_BUTTON32786, OnUpdateViewStenovy)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPGView construction/destruction

CPGView::CPGView()
{
	// TODO: add construction code here
	m_uView=1;
	rotacia=4;
}

CPGView::~CPGView()
{
}

BOOL CPGView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPGView drawing

void CPGView::OnDraw(CDC* pDC)
{	//aktualizuje okno
	int i,maxx,maxy;		
	CPGDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	//SetScrollSizes(MM_TEXT, CSize(::GetSystemMetrics(SM_CXSCREEN),
	//							  ::GetSystemMetrics(SM_CYSCREEN)));

	if (!pDoc->updated)
	{
		pDoc->Update();
		if (pDoc->poleMnohostenov.GetSize()) //vypocita minimalne okno, do ktoreho sa zmesti cela scena
		{
			maxx=pDoc->poleMnohostenov[0]->maxwin.right;
			maxy=pDoc->poleMnohostenov[0]->maxwin.bottom;

			for(i=1;i<pDoc->poleMnohostenov.GetSize();i++)
			{
				maxx=max(maxx,pDoc->poleMnohostenov[i]->maxwin.right);//-pDoc->poleMnohostenov[i]->maxwin.left);
				maxy=max(maxy,pDoc->poleMnohostenov[i]->maxwin.bottom);//-pDoc->poleMnohostenov[i]->maxwin.top);
				
			}
		SetScrollSizes(MM_TEXT,CSize(maxx,maxy));  //nastavi velkost zobrazovacej plochy okna
		}
	}
	if (pDoc->poleMnohostenov.GetSize()==0)
		SetScrollSizes(MM_TEXT,CSize(0,0));

	for(i=0;i<pDoc->poleMnohostenov.GetSize();i++)  //vykresli jednotlive mnohosteny
		pDoc->poleMnohostenov[i]->Vykresli(pDC,m_uView);

}

/////////////////////////////////////////////////////////////////////////////
// CPGView printing

BOOL CPGView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPGView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPGView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPGView diagnostics

#ifdef _DEBUG
void CPGView::AssertValid() const
{
	CView::AssertValid();
}

void CPGView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPGDoc* CPGView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPGDoc)));
	return (CPGDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPGView message handlers


void CPGView::OnViewPoints() 
{
	// TODO: Add your command handler code here
	m_uView=1;
	Invalidate();
	UpdateWindow();
	//MessageBox("Zobrazi oblak bodov","Info",MB_OK | MB_ICONASTERISK);

}

void CPGView::OnViewWireframe() 
{
	// TODO: Add your command handler code here
	m_uView=2;
	Invalidate();
	UpdateWindow();
	//MessageBox("Zobrazi drotovy model","Info",MB_OK | MB_ICONASTERISK);
	
}

void CPGView::OnViewWireframe2() 
{
	// TODO: Add your command handler code here
	m_uView=3;
	Invalidate();
	UpdateWindow();
//	MessageBox("Zobrazi drotovy model bez zadnych stien","Info",MB_OK | MB_ICONASTERISK);
	
}

void CPGView::OnUpdateViewPoints(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_uView==1)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CPGView::OnUpdateViewWireframe(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_uView==2)
	{
		pCmdUI->SetCheck(TRUE);
		//pCmdUI->SetText("Wireframed");
	}
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CPGView::OnUpdateViewWireframe2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_uView==3)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CPGView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	SetScrollSizes(MM_TEXT, CSize(::GetSystemMetrics(SM_CXSCREEN),
								  ::GetSystemMetrics(SM_CYSCREEN)));
	ResizeParentToFit( );
}

void CPGView::OnViewStenovy() 
{
	// TODO: Add your command handler code here
	m_uView=4;
	Invalidate();
	UpdateWindow();
//	MessageBox("Zobrazi scenu s diskr. tienovanim","Info",MB_OK | MB_ICONASTERISK);
	
}

void CPGView::OnUpdateViewStenovy(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_uView==4)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}



/////////////////////////////////////////////////////////////////////////////
// CNastavenie dialog


CNastavenie::CNastavenie(CWnd* pParent /*=NULL*/)
	: CDialog(CNastavenie::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNastavenie)
	m_posunx = 0;
	m_posuny = 0;
	m_posunz = 0;
	m_otocx = 0;
	m_otocy = 0;
	m_otocz = 0;
	//}}AFX_DATA_INIT
}


void CNastavenie::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNastavenie)
	DDX_Text(pDX, IDC_EDIT1, m_posunx);
	DDX_Text(pDX, IDC_EDIT2, m_posuny);
	DDX_Text(pDX, IDC_EDIT3, m_posunz);
	DDX_Text(pDX, IDC_EDIT4, m_otocx);
	DDV_MinMaxUInt(pDX, m_otocx, 0, 360);
	DDX_Text(pDX, IDC_EDIT5, m_otocy);
	DDV_MinMaxUInt(pDX, m_otocy, 0, 360);
	DDX_Text(pDX, IDC_EDIT6, m_otocz);
	DDV_MinMaxUInt(pDX, m_otocz, 0, 360);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNastavenie, CDialog)
	//{{AFX_MSG_MAP(CNastavenie)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CNastavenie::DoModal(UINT &x,UINT &y,UINT &z,int &a,int &b,int &c) 
{
	// TODO: Add your specialized code here and/or call the base class
	int value;

	m_posunx=x;//nastavime premenne v dialogu na aktualne hodnoty
	m_posuny=y;
	m_posunz=z;
	m_otocx=a;
	m_otocy=b;
	m_otocz=c;
	
	value=CDialog::DoModal();
	if(value == 1)		//Bolo stlacene OK
	{
		x=m_posunx;		//aktualizujeme hodnoty tymi, ktore boli zadane v dialogu
		y=m_posuny;
		z=m_posunz;
		a=m_otocx;
		b=m_otocy;
		c=m_otocz;
	}

	return value;
}


void CPGView::OnButton32778() //osetrenie butonu na nastavenie posunutia a otocenia sceny
{
	// TODO: Add your command handler code here
	
	CNastavenie dialog;
	CPGDoc *doc=GetDocument();
	dialog.DoModal(doc->posunutieX,doc->posunutieY,doc->posunutieZ,
				   doc->otocenieX,doc->otocenieY,doc->otocenieZ);
	doc->updated=FALSE;
	Invalidate();
	UpdateWindow();
}
/////////////////////////////////////////////////////////////////////////////
// CStredDialog dialog


CStredDialog::CStredDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CStredDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStredDialog)
	m_stredx = 0;
	m_stredy = 0;
	m_stredz = 0;
	//}}AFX_DATA_INIT
}


void CStredDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStredDialog)
	DDX_Text(pDX, IDC_EDIT1, m_stredx);
	DDX_Text(pDX, IDC_EDIT3, m_stredy);
	DDX_Text(pDX, IDC_EDIT4, m_stredz);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStredDialog, CDialog)
	//{{AFX_MSG_MAP(CStredDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStredDialog message handlers

int CStredDialog::DoModal(CBod *bod) 
{
	// TODO: Add your specialized code here and/or call the base class
	int value;
	//nastavime aktualne hodnoty stredoveho bodu
	m_stredx=bod->x;
	m_stredy=bod->y;
	m_stredz=bod->z;
	
	value=CDialog::DoModal();
	if(value == 1)		//Bolo stlacene OK
	{
		bod->x=m_stredx;	//aktualizujeme aktualne hodnoty
		bod->y=m_stredy;
		bod->z=m_stredz;
		
	}

	return value;
}

void CPGView::OnButton32779() //stred otacania
{
	// TODO: Add your command handler code here
	CStredDialog dialog;
	CPGDoc *doc=GetDocument();
	dialog.DoModal(doc->bodOtacania);
	doc->updated=FALSE;
	Invalidate();
	UpdateWindow();
}

void CPGView::OnUpdateButton32778(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CPGDoc *doc=GetDocument();
	if(doc->poleMnohostenov.GetSize()>0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}


void CPGView::OnButton32780() 
{
	// TODO: Add your command handler code here
	rotacia^=1;		//zapne/vypne roataciu okolo osi X	
}

void CPGView::OnButton32781() 
{
	// TODO: Add your command handler code here
	rotacia^=2;		//zapne/vypne roataciu okolo osi Y
	
}

void CPGView::OnButton32782() 
{
	// TODO: Add your command handler code here
	rotacia^=4;		//zapne/vypne roataciu okolo osi Z	
	
}


void CPGView::OnUpdateButton32780(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(rotacia & 1)	
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CPGView::OnUpdateButton32781(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(rotacia & 2)	
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CPGView::OnUpdateButton32782(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(rotacia & 4)	
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CPGView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	SetCapture();       // Capture the mouse until button up.
	prevPoint = point;  // Serves as the MoveTo() anchor point for the
						// LineTo() the next point, as the user drags the
						// mouse.

	CScrollView::OnLButtonDown(nFlags, point);
}

void CPGView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (GetCapture() != this)
		return; // If this window (view) didn't capture the mouse,
				// then the user isn't drawing in this window.


	ReleaseCapture();   // Release the mouse capture established at
						// the beginning of the mouse drag.

	CScrollView::OnLButtonUp(nFlags, point);
}

void CPGView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (GetCapture() != this)
		return; // If this window (view) didn't capture the mouse,
				// then the user isn't drawing in this window.

	int increment=prevPoint.x-point.x;
	CPGDoc *doc=GetDocument();

	if(rotacia & 1)  //ak je nastavene rotovanie okolo osi X
	{
		doc->otocenieX+=increment+360;
		doc->otocenieX%=360;
	}
	if(rotacia & 2)	//ak je nastavene rotovanie okolo osi Y
	{
		doc->otocenieY+=increment+360;
		doc->otocenieY%=360;
	}
	if(rotacia & 4) //ak je nastavene rotovanie okolo osi Z
	{
		doc->otocenieZ+=increment+360;
		doc->otocenieZ%=360;
	}
	
	if(prevPoint != point && rotacia)  //Ak treba aktualizovat
	{
		doc->updated=FALSE;
		Invalidate();
		UpdateWindow();
		prevPoint = point;

	}

	CScrollView::OnMouseMove(nFlags, point);
}

