// GRAFIKA2View.h : interface of the CGRAFIKA2View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAFIKA2VIEW_H__843247CF_5C5C_11D2_9245_00608C63A44F__INCLUDED_)
#define AFX_GRAFIKA2VIEW_H__843247CF_5C5C_11D2_9245_00608C63A44F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CGRAFIKA2View : public CView
{
protected: // create from serialization only
	CGRAFIKA2View();
	DECLARE_DYNCREATE(CGRAFIKA2View)

// Attributes
public:
	CGRAFIKA2Doc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGRAFIKA2View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	bool RotujZ;
	bool RotujY;
	bool RotujX;
	UINT Menu1;
	virtual ~CGRAFIKA2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGRAFIKA2View)
	afx_msg void OnZobrazenieBodove();
	afx_msg void OnZobrazenieDrotove();
	afx_msg void OnZobrazenieStenove();
	afx_msg void OnUpdateZobrazenieBodove(CCmdUI* pCmdUI);
	afx_msg void OnUpdateZobrazenieDrotove(CCmdUI* pCmdUI);
	afx_msg void OnUpdateZobrazenieStenove(CCmdUI* pCmdUI);
	afx_msg void OnRotujokoloz();
	afx_msg void OnUpdateRotujokoloz(CCmdUI* pCmdUI);
	afx_msg void OnRotujokoloy();
	afx_msg void OnUpdateRotujokoloy(CCmdUI* pCmdUI);
	afx_msg void OnRotujokolox();
	afx_msg void OnUpdateRotujokolox(CCmdUI* pCmdUI);
	afx_msg void OnButton32783();
	afx_msg void OnButton32787();
	afx_msg void OnZobrazenieTienovane();
	afx_msg void OnUpdateZobrazenieTienovane(CCmdUI* pCmdUI);
	afx_msg void OnButton32789();
	afx_msg void OnButton32793();
	afx_msg void OnButton32794();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GRAFIKA2View.cpp
inline CGRAFIKA2Doc* CGRAFIKA2View::GetDocument()
   { return (CGRAFIKA2Doc*)m_pDocument; }
#endif
#endif
/////////////////////////////////////////////////////////////////////////////
// CBodOtocDlg dialog

class CBodOtocDlg : public CDialog
{
// Construction
public:
	CBodOtocDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CBodOtocDlg)
	enum { IDD = IDD_DIALOG1 };
	int		m_BodOtocZ;
	int		m_BodOtocX;
	int		m_BodOtocY;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBodOtocDlg)
	public:
	virtual int DoModal(CBod *);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CBodOtocDlg)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
