#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

void RotatePixel(int *m_iX,int *m_iY,float m_fDegree,int m_iRadius);
void DrawLineDDA(int,int,int,int,int);
main()
{

	int GraphDriver ,GraphMode,ErrorCode;
	int gdriver = EGA, gmode = EGAHI, errorcode;


	 int xmax, ymax;
	 float m_fStep;
	 int m_iX;
	 int m_iY;
	 /* initialize graphics and local variables */
	initgraph(&gdriver, &gmode, "c:\\work\\egavga.bgi");
	errorcode = graphresult();

  if (errorcode != grOk)
  {
    printf("Graphics error: %s\n", grapherrormsg(errorcode));
    printf("Press any key to halt:");
    getch();
    exit(1);
  }

		m_iX=0;
    m_iY=0;
    for(m_fStep=0;m_fStep<6.28;m_fStep+=0.1)
    {
        m_iX=(int)100*sin(m_fStep);
        m_iY=(int)100*cos(m_fStep);
        DrawLineDDA(100,100,100+m_iX,100+m_iY,1);
    }
    getch();
   closegraph();
   return 0;
}

void DrawLineDDA(int m_iX1,int m_iY1,int m_iX2,int m_iY2, int m_iColor)
{
        int i_Index;
        int m_iDx;
        int m_iDy;
        int m_iStep;
        float m_fX;
        float m_fY;
        float m_fXIter;
        float m_fYIter;

        m_iDx=m_iX2-m_iX1;
        m_iDy=m_iY2-m_iY1;


        if (abs(m_iDx)>abs(m_iDy))
        {
                m_iStep=abs(m_iDx);
        }
        else
        {
                m_iStep=abs(m_iDy);
        }
        m_fXIter=(float)m_iDx/(float)m_iStep;
        m_fYIter=(float)m_iDy/(float)m_iStep;
        m_fX=m_iX1;
        m_fY=m_iY1;
        for(i_Index=1;i_Index<m_iStep;i_Index++)
        {
                putpixel((int)m_fX,(int)m_fY,m_iColor);
                m_fX+=m_fXIter;
                m_fY+=m_fYIter;
        }
}

