#include "lubo.h"

void Mys::get()
 {
  char txt[13];
  struct REGPACK reg;
  struct viewporttype viewinfo;
  reg.r_ax = 3;
  intr(0x33, &reg);
  x = reg.r_cx;
  y = reg.r_dx;
  buttons = reg.r_bx;
  if ((x!=xx ||y!=yy) )
    {
     getviewsettings(&viewinfo);
     sprintf (txt,"X:%-3d,Y:%-3d",x,y-20);
     setfillstyle(0,0);
     if (viewinfo.right<620) setviewport(0,0,639,479,1);
     bar (552,2,639,10);
     if (x<610 && y>=20 && vis) setcolor(LIGHTGRAY); else setcolor(0);
     outtextxy(552,2,txt);
     if (viewinfo.right<620) setviewport(0,20,609,479,1);
     xx=x;
     yy=y;
    }
 }

void Button::off()
	{
	 Mys::off();
	 unsigned int xtn,ytn;
	 setfillstyle(1,7);
	 bar(x1+2,y1+2,x2-2,y2-2);
	 setcolor(15);
	 rectangle(x1+1,y1+1,x2-1,y2-1);
	 setcolor(8);
	 line(x1+1,y2-1,x2-1,y2-1);
	 line(x2-1,y2-1,x2-1,y1+2);
	 xtn = ((x2+x1)/2) - (strlen(name)/2)*8;
	 ytn = ((y2+y1)/2) - 4;
	 setcolor(0);
	 outtextxy(xtn,ytn,name);
	 setcolor(15);
	 outtextxy(xtn-1,ytn-1,name);
	 stav = 0;
	 Mys::on();
	}
void Button::on()
	{
	 Mys::off();
	 unsigned int xtn,ytn;
	 setfillstyle(1,7);
	 bar(x1+2,y1+2,x2-2,y2-2);
	 setcolor(8);
	 rectangle(x1+1,y1+1,x2-1,y2-1);
	 setcolor(15);
	 line(x1+1,y2-1,x2-1,y2-1);
	 line(x2-1,y2-1,x2-1,y1+2);
	 xtn = ((x2+x1)/2)-(strlen(name)/2)*8;
	 ytn = ((y2+y1)/2)-4;
	 setcolor(0);
	 outtextxy(xtn+1,ytn+1,name);
	 setcolor(15);
	 outtextxy(xtn,ytn,name);
	 stav = 1;
	 Mys::on();
	}

void Button::off_c()
	{
	 Mys::off();
	 setfillstyle(1,7);
	 bar(x1+1,y1+1,x2-1,y2-1);
	 setfillstyle(1,farba);
	 bar(x1+6,y1+6,x2-6,y2-6);
	 setcolor(15);
	 rectangle(x1,y1,x2,y2);
	 rectangle(x1+5,y1+5,x2-5,y2-5);
	 setcolor(8);
	 line(x1,y2,x2,y2);
	 line(x2,y2,x2,y1+1);
	 line(x1+5,y1+5,x1+5,y2-6);
	 line(x1+5,y1+5,x2-5,y1+5);
	 stav = 0;
	 Mys::on();
	}
void Button::on_c()
	{
	 Mys::off();
	 setfillstyle(1,7);
	 bar(x1+1,y1+1,x2-1,y2-1);
	 setfillstyle(1,farba);
	 bar(x1+6,y1+6,x2-6,y2-6);
	 setcolor(8);
	 rectangle(x1,y1,x2,y2);
	 rectangle(x1+5,y1+5,x2-5,y2-5);
	 setcolor(15);
	 line(x1,y2,x2,y2);
	 line(x2,y2,x2,y1+1);
	 line(x1+5,y1+5,x1+5,y2-6);
	 line(x1+5,y1+5,x2-5,y1+5);
	 stav = 1;
	 * pf=farba;
	 Mys::on();
	}

void Button::off_s()
     {
      off();
      Mys::off();
      setcolor(0);
      rectangle((x1+x2)/2-6,(y1+y2)/2-6,(x1+x2)/2+6,(y1+y2)/2+6);
      setcolor(15);
      rectangle((x1+x2)/2-7,(y1+y2)/2-7,(x1+x2)/2+5,(y1+y2)/2+5);
      Mys::on();
      stav=0;
     }
void Button::on_s()
     {
      on();
      Mys::off();
      setcolor(0);
      rectangle((x1+x2)/2-6+1,(y1+y2)/2-6+1,(x1+x2)/2+6+1,(y1+y2)/2+6+1);
      setcolor(15);
      rectangle((x1+x2)/2-7+1,(y1+y2)/2-7+1,(x1+x2)/2+5+1,(y1+y2)/2+5+1);
      Mys::on();
      stav=1;
     }
void Button::on_k()
     {
      on();
      Mys::off();
      setcolor(0);
      circle ((x1+x2)/2-1+1,(y1+y2)/2-1+1,(y1+y2)/3);
      setcolor(15);
      circle ((x1+x2)/2+1,(y1+y2)/2+1,(y1+y2)/3);
      Mys::on();
      stav=1;
     }
void Button::off_k()
     {
      off();
      Mys::off();
      setcolor(0);
      circle ((x1+x2)/2-1,(y1+y2)/2-1,(y1+y2)/3);
      setcolor(15);
      circle ((x1+x2)/2,(y1+y2)/2,(y1+y2)/3);
      Mys::on();
      stav=0;
     }

void Button::on_t()
     {
      on();
      Mys::off();
      setcolor(0);
      line((x1+x2)/2+1,y1+4+1,(x1+x2)/2-6+1,y2-4+1);
      line((x1+x2)/2-6+1,y2-4+1,(x1+x2)/2+6+1,y2-4+1);
      line((x1+x2)/2+6+1,y2-4+1,(x1+x2)/2+1,y1+4+1);
      setcolor(15);
      line((x1+x2)/2-1+1,y1+3+1,(x1+x2)/2-7+1,y2-5+1);
      line((x1+x2)/2-5+1,y2-5+1,(x1+x2)/2+5+1,y2-5+1);
      line((x1+x2)/2+5+1,y2-5+1,(x1+x2)/2-1+1,y1+3+1);
      Mys::on();
      stav=1;
     }
void Button::off_t()
     {
      off();
      Mys::off();
      setcolor(0);
      line((x1+x2)/2,y1+4,(x1+x2)/2-6,y2-4);
      line((x1+x2)/2-6,y2-4,(x1+x2)/2+6,y2-4);
      line((x1+x2)/2+6,y2-4,(x1+x2)/2,y1+4);
      setcolor(15);
      line((x1+x2)/2-1,y1+3,(x1+x2)/2-7,y2-5);
      line((x1+x2)/2-5,y2-5,(x1+x2)/2+5,y2-5);
      line((x1+x2)/2+5,y2-5,(x1+x2)/2-1,y1+3);
      Mys::on();
      stav=0;
     }
void Button::off_l()
     {
      off();
      Mys::off();
      setcolor(0);
      line (x1+6,y2-6,x2-6,y1+6);
      setcolor(15);
      line (x1+7,y2-5,x2-5,y1+7);
      Mys::on();
      stav=0;
     }

void Button::on_l()
     {
      on();
      Mys::off();
      setcolor(0);
      line (x1+6+1,y2-6+1,x2-6+1,y1+6+1);
      setcolor(15);
      line (x1+7+1,y2-5+1,x2-5+1,y1+7+1);
      Mys::on();
      stav=1;
     }

void Button::on_p()
     {
      on();
      Mys::off();
      setcolor(0);
      line((x1+x2)/2+1,y1+4-1+1,(x1+x2)/2-6+1,y2-8+1);
      line((x1+x2)/2+1-6,y2-8+1,(x1+x2)/2+1,y2-4+1);
      line((x1+x2)/2+1,y2-4+1,(x1+x2)/2+1,y1+10+1);
      line((x1+x2)/2+1,y1+10+1,(x1+x2)/2+8+1,y2-8+1);
      line((x1+x2)/2+1+8,y2-8+1,(x1+x2)/2+1,y1+4+1);

      setcolor(15);
      line((x1+x2)/2-1+1,y1+4-1+1,(x1+x2)/2-6-1+1,y2-8-1+1);
      line((x1+x2)/2-6-1+1,y2-8-1+1,(x1+x2)/2-1+1,y2-4-1+1);
      line((x1+x2)/2-1+1,y2-4-1+1,(x1+x2)/2-1+1,y1+10-1+1);
      line((x1+x2)/2-1+1,y1+10-1+1,(x1+x2)/2+8+1,y2-8-1+1);
      line((x1+x2)/2+8-1+1,y2-8-1+1,(x1+x2)/2-1+1,y1+4-1+1);
      Mys::on();
      stav=1;
     }
void Button::off_p()
     {
      off();
      Mys::off();
      setcolor(0);
      line((x1+x2)/2,y1+4-1,(x1+x2)/2-6,y2-8);
      line((x1+x2)/2-6,y2-8,(x1+x2)/2,y2-4);
      line((x1+x2)/2,y2-4,(x1+x2)/2,y1+10);
      line((x1+x2)/2,y1+10,(x1+x2)/2+8,y2-8);
      line((x1+x2)/2+8,y2-8,(x1+x2)/2,y1+4);

      setcolor(15);
      line((x1+x2)/2-1,y1+4-1,(x1+x2)/2-6-1,y2-8-1);
      line((x1+x2)/2-6-1,y2-8-1,(x1+x2)/2-1,y2-4-1);
      line((x1+x2)/2-1,y2-4-1,(x1+x2)/2-1,y1+10-1);
      line((x1+x2)/2-1,y1+10-1,(x1+x2)/2+8,y2-8-1);
      line((x1+x2)/2+8-1,y2-8-1,(x1+x2)/2-1,y1+4-1);

      Mys::on();
      stav=0;
     }






void Polozka::vypisn()
   {
     Mys::off();
     setcolor(15);
     settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
     outtextxy(tx,ty,meno);
     Mys::on();
   }
void Polozka::vypisa()
   {
     Mys::off();
     setcolor(RED);
     settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
     outtextxy(tx,ty,meno);
     Mys::on();
   }
void Roll::draw()
    {
     Mys::off();
     image=(void far *)farmalloc(imagesize(rx1,ry1,rx2,ry2));
     if (image==NULL){closegraph();printf ("Not enough memory to roll menu\n");}

     getimage(rx1,ry1,rx2,ry2,image);

     setfillstyle(1,7);
     bar(rx1+2,ry1+2,rx2-2,ry2-2);
     setcolor(15);
     rectangle(rx1+1,ry1+1,rx2-1,ry2-1);
     setcolor(8);
     line(rx1+1,ry2-1,rx2-1,ry2-1);
     line(rx2-1,ry2-1,rx2-1,ry1+2);
     for (int i=0;i<pocet;i++)
	{
	pol[i]=new Polozka(rx1+5,ry1+4+i*12,polozky[i]);
	pol[i]->vypisn();
	}

     Mys::on();
    }
Roll::~Roll()
    {
     Mys::off();
     for (int i=0;i<pocet;delete pol[i++]);
     putimage(rx1,ry1,image,COPY_PUT);
     farfree(image);
     Mys::on();
    }
int Roll::aktiv()
{   int in=0,predch=0;
    pol[0]->vypisa();
    Mys::buttons=0;
    Mys::vis=0;
    while (Mys::buttons==0)
     {
      Mys::get();
      if (Mys::x>=rx1 && Mys::x<rx2 && Mys::y>=ry1 && Mys::y<ry2)
	{
	 in=1;
	 for (int i=0;i<pocet;i++)
	   {
	     if (Mys::y>=pol[i]->ty && Mys::y<pol[i]->ty+12)
	       {
	       if (predch!=i)
		 {
		  pol[predch]->vypisn();
		  pol[i]->vypisa();
		  predch=i;
		 }
	       }
	    }
	}
	else in=0;
      if (Mys::buttons==1)
	   {
	 if (in==1) in=predch;
	   else in=-1;
	 }
      else {in=-1;while (Mys::buttons!=0) Mys::get();}
     }
   delete this;
   return in;
}

Menu::Menu(char **m)
{
    obj=-1;
    pf=0;
    mena=m;
    popol[0]=4;
    popol[1]=7;
    for (int i=0;i<3;i++)
      {
       to[i]=new Button(i*70,0,(i+1)*70,20,mena[i],15);
       to[i]->off();
      }

     to[4]=new Button(270,0,300,20,"");
     to[5]=new Button(300,0,330,20,"");
     to[6]=new Button(330,0,360,20,"");
     to[7]=new Button(360,0,390,20,"");
     to[8]=new Button(390,0,420,20,"");
     to[4]->off_s();
     to[5]->off_t();
     to[6]->off_k();
     to[7]->off_l();
     to[8]->off_p();	//!!!!!!!!!!!!


     to[9]=new Button(450,0,500,20,"<<<<");
     to[10]=new Button(500,0,550,20,">>>>");
     to[9]->off();
     to[10]->off();

   for (i=1;i<8;i++)
     {
      to[i+10]=new Button(610,i*30,639,(i+1)*30,"",i+8);
      to[i+10]->off_c();
     }
   to[i+10]=new Button(610,i*30,639,(i+1)*30,"",i+8);

   to[11]->on_c();
   pf=11;

    for (int j=0;j<2;j++)
      for (int i=0;i<popol[j];i++)
	{
	 mpo[j][i]=new char[8];
	}
      strcpy(mpo[0][0],"Otvorit");
      strcpy(mpo[0][1],"Pridat");
      strcpy(mpo[0][2],"Ulozit");
      strcpy(mpo[0][3],"Zavriet");

      strcpy(mpo[1][0],"Posunut");
      strcpy(mpo[1][1],"Tvar");
      strcpy(mpo[1][2],"Farba");
      strcpy(mpo[1][3],"Otocit");
      strcpy(mpo[1][4],"Vyplnit");
      strcpy(mpo[1][5],"Orezat");
      strcpy(mpo[1][6],"Zmazat");

}
int Menu::vyber()
{
     int i,vrat=-1,vrat2=0;
     get();
     if (buttons==1)
     {
     for (i=0;i<3;i++)
       {
	if (x>=to[i]->x1 && x<to[i]->x2 && y>=to[i]->y1 && y<to[i]->y2)
	  {
	  to[i]->on();
	  if (i==2) {to[i]->on();return -2;}
	  rol=new Roll(to[i]->x1,20,to[i]->x1+70,popol[i],mpo[i]);
	  rol->draw();
	  while (buttons!=0) get();
	  vrat=rol->aktiv();
	  to[i]->off();
	  if (vrat==-1) return -1;
	  else
	    {
	     vrat2=i;
	     get();
	     while (buttons!=0) get();
	  }

	  }
       }
     }
   return (vrat2*10+vrat);
}
int Menu::vyber2()
{
     int i;
     get();
     if (buttons==1)
       {
	for (i=4;i<=17;i++)
	  if (x>=to[i]->x1 && x<=to[i]->x2 && y>=to[i]->y1 && y<=to[i]->y2)
	    switch(i){
	      case 4:if (to[4]->stav) { to[4]->off_s();obj=-1;}
		     else { to[4]->on_s();to[5]->off_t();to[6]->off_k();to[7]->off_l();to[8]->off_p();obj=1;}
		     while (buttons!=0) get();
		     break;
	      case 5:if (to[5]->stav) { to[5]->off_t();obj=-1;}
		     else { to[4]->off_s();to[5]->on_t();to[6]->off_k();to[7]->off_l();to[8]->off_p();obj=2;}
		     while (buttons!=0) get();
		     break;
	      case 6:if (to[6]->stav) { to[6]->off_k();obj=-1;}
		     else { to[4]->off_s();to[5]->off_t();to[6]->on_k();to[7]->off_l();to[8]->off_p();obj=3;}
		     while (buttons!=0) get();
		     break;
	      case 7:if (to[7]->stav) { to[7]->off_l();obj=-1;}
		     else { to[4]->off_s();to[5]->off_t();to[6]->off_k();to[7]->on_l();to[8]->off_p();obj=4;}
		     while (buttons!=0) get();
		     break;
	      case 8:if (to[8]->stav) { to[8]->off_p();obj=-1;}
		     else { to[4]->off_s();to[5]->off_t();to[6]->off_k();to[7]->off_l();to[8]->on_p();obj=5;}
		     while (buttons!=0) get();
		     break;
	      case 9:
	      case 10:to[i]->on();delay(75);to[i]->off();
		       return (i-3);
	      case 11:
	      case 12:
	      case 13:
	      case 14:
	      case 15:
	      case 16:
	      case 17:if (i!=pf)
			 {
			  to[pf]->off_c();
			  to[i]->on_c();
			  pf=i;
			 }
		      while (buttons!=0) get();
		     }
	      }
	return obj;

}

void Bod::vypln(int x, int y,int f)
{
  int i,tmp;
  Mys::off();

  if (getpixel(x,y)!=f && y>=0 && y<640)
    {
     i=x;
     while (getpixel(i,y)!=f && i<609)
       putpixel(i++,y,f);
     tmp=i;

     i=x-1;
     while (getpixel(i,y)!=f && i>=0)
       putpixel(i--,y,f);

     vypln((i+tmp)/2,y+1,f);
     vypln((i+tmp)/2,y-1,f);
    }
  Mys::on();

}





Kruh::Kruh(int f)
{ int xo,yo;
  r=0;
  color=f;
  vypl=0;
  setviewport(0,20,609,479,1);
  setwritemode(XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  x1=xo;
  y1=yo;
  kresli(1);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
	{
	 xo=Mys::x;
	 yo=Mys::y-20;
	 kresli(-1);
	 r=(int)sqrt(double(pow(xo-x1,2)+pow(yo-y1,2)));
	 kresli(1);
	}
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,0);
}

Kruh::~Kruh()
{
  setviewport(0,20,609,479,1);
  kresli(-1);
  setviewport(0,0,639,479,1);
}
void Kruh::kresli(int a)
{
  int x,y;
  Mys::off();
  if (a==1)
    {
//     setcolor (color);
     orez(0,0,609,479,0);
//       kruznica(x1,y1,r,color);
    }
  if (a==0)
    {
//     setcolor (color-8);
     orez(0,0,609,479,8);
//       kruznica(x1,y1,r,color-8);

    }
  if (a==-1)
    {
//     setcolor (0);
     orez(0,0,609,479,color);
//       kruznica(x1,y1,r,0);
     if (vypl==1)
       {
	stred(x,y);
	vypln(x,y,0);
       }
    }

  if (a==10)
    {
     kresli(1);
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color);
       }
    }

  if (a==11)
    {
     kresli();
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color-8);
       }
    }



  Mys::on();
}


void Kruh::zvzm()
{
  int xo,ro=0;
  setviewport (0,20,609,479,1);
  kresli(-1);
  kresli(1);
  setwritemode (XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  while (Mys::buttons==1)
     {
      Mys::get();
      if (Mys::x!=xo)
	{
	 ro=Mys::x-xo;
	 kresli(-1);
	 r=r+ro;
	 if (r<0) r=1;
	 else
	   {
	    xo=Mys::x;
	    kresli(1);
	   }
	}
     }
   setwritemode (COPY_PUT);
   kresli(1);

   setviewport(0,0,639,479,1);
}
void Kruh::posun()
{
  int xo,yo;
  kresli(-1);
  kresli(1);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  if ((int)sqrt(double(pow(xo-x1,2)+pow(yo-y1,2)))>r) {while (Mys::buttons==1) Mys::get();return; }
  setviewport (0,20,609,479,1);
  setwritemode (XOR_PUT);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	kresli(-1);
	x1+=Mys::x-xo;
	y1+=Mys::y-20-yo;
	if (x1<0) x1=0;
	if (y1<0) y1=0;
	if (x1>609) x1=609;
	if (y1>479) y1=479;
	if (x1>=0 && x1<610 && y1>=0 && y1<480)
	  {
	   xo=Mys::x;
	   yo=Mys::y-20;
	   kresli(1);
	  }
       }
    }
   setwritemode (COPY_PUT);
   kresli(1);
   setviewport(0,0,639,479,1);
}

void Kruh::otoc()
{
  int rx,ry,xo;
  double dx,dy,uhol=0;
  setviewport (0,20,609,479,1);
  setwritemode (XOR_PUT);
  kresli(-1);
  kresli(1);
  Mys::get();
  while(Mys::buttons!=1) Mys::get();
  Mys::off();
  rx=Mys::x;
  ry=Mys::y-20;
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  Mys::on();
  while(Mys::buttons!=0) Mys::get();
  while(Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  Mys::off();
  while(Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo)
       {
	kresli(-1);
	dx= x1-rx;
	dy= y1-ry;
	uhol=(float)(Mys::x-xo)/90;
	x1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	xo=Mys::x;
	kresli(1);
       }
    }
   Mys::on();
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  setwritemode (COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

void Kruh::uloz(FILE *out)
{
 fprintf(out,"%d,%d,%d,%d,%d\n",color,vypl,x1,y1,r);
}

Kruh::Kruh(FILE *in)
{
 fscanf(in,"%d,%d,%d,%d,%d\n",&color,&vypl,&x1,&y1,&r);
}






Stvorec::Stvorec(int f)
{
  int xo,yo;
  color=f;
  vypl=0;
  setviewport(0,20,609,479,1);
  setwritemode(XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  x1=x2=x3=x4=xo;
  y1=y2=y3=y4=yo;
  kresli(1);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	kresli(-1);
	x3=Mys::x;
	y3=Mys::y-20;
	x2=x3;
	x4=x1;
	y2=y1;
	y4=y3;
	kresli(1);
	xo=Mys::x;
	yo=Mys::y-20;
       }
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,0);
  if (x1>x2) {int pom=x1;int pom2=y1;x1=x2;y1=y2;x2=pom;y2=pom2;}
  x2=x3;
  x4=x1;
  y2=y1;
  y4=y3;

}
void Stvorec::kresli(int a)
{
   Mys::off();
   int x,y;
   if (a)
     {
      setcolor(color);
      lineb(x1,y1,x2,y2,color);
      lineb(x2,y2,x3,y3,color);
      lineb(x3,y3,x4,y4,color);
      lineb(x4,y4,x1,y1,color);

     }
   if (a==0)
     {
      setcolor(color-8);
      lineb(x1,y1,x2,y2,color-8);
      lineb(x2,y2,x3,y3,color-8);
      lineb(x3,y3,x4,y4,color-8);
      lineb(x4,y4,x1,y1,color-8);
     }
   if (a==-1)
     {
      setcolor(0);
      lineb(x1,y1,x2,y2,0);
      lineb(x2,y2,x3,y3,0);
      lineb(x3,y3,x4,y4,0);
      lineb(x4,y4,x1,y1,0);
      if (vypl==1)
	{
	stred(x,y);
	vypln(x,y,0);
	}
     }
   Mys::on();
   if (a==10)
    {
     kresli(1);
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color);
       }
    }

  if (a==11)
    {
     kresli();
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color-8);
       }
    }

}
void Stvorec::posun()
{
  int xo,yo;
  while (Mys::buttons!=1) Mys::get();
//  if ((Mys::x<x1 || Mys::x>x2 || Mys::y-20<y1 ||Mys::y-20>y2) && y1<=y2 || y1>y2 && (Mys::x<x1 || Mys::x>x2 || Mys::y-20>y1 ||Mys::y-20<y2)) {while (Mys::buttons==1) Mys::get();return; }
  setviewport (0,20,609,479,1);
  Mys::off();
//  kresli(-1);
  setwritemode (XOR_PUT);
//  kresli(1);
  xo=Mys::x;
  yo=Mys::y-20;
  while (Mys::buttons==1 )
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	kresli(-1);
	x1+=Mys::x-xo;
	x2+=Mys::x-xo;
	x3+=Mys::x-xo;
	x4+=Mys::x-xo;
	y1+=Mys::y-20-yo;
	y2+=Mys::y-20-yo;
	y3+=Mys::y-20-yo;
	y4+=Mys::y-20-yo;
	xo=Mys::x;
	yo=Mys::y-20;
	kresli(1);
       }
   }
   setwritemode (COPY_PUT);
   kresli(1);
   Mys::on();
   setviewport(0,0,639,479,1);
}

void Stvorec::zvzm()
{
  int xo,yo;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  while (Mys::buttons!=1) Mys::get();
  Mys::off();
  xo=Mys::x;
  yo=Mys::y-20;
  while (Mys::buttons==1)
     {
      Mys::get();
      if (Mys::x!=xo || Mys::y-20!=yo)
	{
	 kresli(-1);
	 x1+=xo-Mys::x;
	 x2-=xo-Mys::x;
	 x3-=xo-Mys::x;
	 x4+=xo-Mys::x;
	 y1+=yo-Mys::y+20;
	 y2+=yo-Mys::y+20;
	 y3-=yo-Mys::y+20;
	 y4-=yo-Mys::y+20;
	 xo=Mys::x;
	 yo=Mys::y-20;
	 kresli(1);
	}
     }
   setwritemode (COPY_PUT);
   kresli(1);
   Mys::on();
   setviewport(0,0,639,479,1);
   if (x1>x2) {int pom=x1;int pom2=y1;x1=x2;y1=y2;x2=pom;y2=pom2;}

}

void Stvorec::otoc()
{
  int rx,ry,xo;
  double dx,dy,uhol=0,xx1,xx2,xx3,xx4,yy1,yy2,yy3,yy4;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  Mys::get();
  while(Mys::buttons!=1) Mys::get();
  Mys::off();
  rx=Mys::x;
  ry=Mys::y-20;
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  Mys::on();
  while(Mys::buttons!=0) Mys::get();
  while(Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  Mys::off();
  xx1=x1;xx2=x2;xx2=x2;xx3=x3;xx4=x4;yy1=y1;yy2=y2;yy3=y3;yy4=y4;

  while(Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo)
       {
	kresli(-1);
	dx= xx1-rx;
	dy= yy1-ry;
	uhol=(float)(Mys::x-xo)/90;
	xx1=cos(uhol)*dx-sin(uhol)*dy+rx;
	yy1=cos(uhol)*dy+sin(uhol)*dx+ry;

	dx= xx2-rx;
	dy= yy2-ry;
	xx2=cos(uhol)*dx-sin(uhol)*dy+rx;
	yy2=cos(uhol)*dy+sin(uhol)*dx+ry;

	dx= xx3-rx;
	dy= yy3-ry;
	xx3=cos(uhol)*dx-sin(uhol)*dy+rx;
	yy3=cos(uhol)*dy+sin(uhol)*dx+ry;

	dx= xx4-rx;
	dy= yy4-ry;
	xx4=cos(uhol)*dx-sin(uhol)*dy+rx;
	yy4=cos(uhol)*dy+sin(uhol)*dx+ry;
	xo=Mys::x;
	x1=xx1;x2=xx2;x3=xx3;x4=xx4;y1=yy1;y2=yy2;y3=yy3;y4=yy4;

	kresli(1);
       }
    }
  Mys::on();
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  setwritemode (COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

int Stvorec::orez(int ox1,int oy1, int ox2, int oy2, int cm)
{
  Ciara *pom;
  int o=0,x,y;
  pom=new Ciara(x1,y1,x2,y2,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  pom=new Ciara(x2,y2,x3,y3,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  pom=new Ciara(x3,y3,x4,y4,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  pom=new Ciara(x4,y4,x1,y1,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  o/=4;

  if(o==2) return 2;
  if(vypl)
    {
     stred(x,y);
     setcolor(color-cm);
     rectangle(ox1,oy1,ox2,oy2);
     while(x-- >= ox2);
     while(x++ <= ox1);
     while(y-- >= oy2);
     while(y++ <= oy1);
     vypln(x,y,color-cm);
     setcolor(0);
     rectangle(ox1,oy1,ox2,oy2);
    }

  return o;
}

void Stvorec::uloz(FILE *out)
{
 fprintf(out,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",color,vypl,x1,y1,x2,y2,x3,y3,x4,y4);
}

Stvorec::Stvorec(FILE *in)
{
 fscanf(in,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",&color,&vypl,&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4);
}



Stvorec::~Stvorec()
{
  setviewport(0,20,609,479,1);
  kresli(-1);
  setviewport(0,0,639,479,1);
}

Troj::Troj(int f)
{
  int xo,yo;
  color=f;
  vypl=0;
  setviewport(0,20,609,479,1);
  setwritemode(XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  x1=xo;
  y1=yo;
//  setcolor(color);
  lineb (x1,y1,xo,yo,color);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	 Mys::off();
//	 setcolor(color);
	 lineb (x1,y1,xo,yo,0);
	 Mys::on();
	 xo=Mys::x;
	 yo=Mys::y-20;
	 Mys::off();
//	 setcolor(color);
	 lineb (x1,y1,xo,yo,color);
	 Mys::on();
       }
    }
  x2=xo;
  y2=yo;
  x3=xo;
  y3=yo;
  while (Mys::buttons!=1) Mys::get();
  setcolor(color);
  line (x2,y2,x1,y1);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	 kresli(-1);
	 xo=Mys::x;
	 yo=Mys::y-20;
	 x3=xo;
	 y3=yo;
	 kresli(1);
       }
    }
  setwritemode(COPY_PUT);
//  kresli(1);
  setviewport(0,0,639,479,1);

}
void Troj::kresli(int a)
{
   Mys::off();
   if (a)
     {
//      setcolor(color);
      lineb (x1,y1,x2,y2,color);
      lineb (x2,y2,x3,y3,color);
      lineb (x3,y3,x1,y1,color);
     }
   if (a==0)
     {
//      setcolor(color-8);
      lineb (x1,y1,x2,y2,color-8);
      lineb (x2,y2,x3,y3,color-8);
      lineb (x3,y3,x1,y1,color-8);
     }
   if (a==-1)
     {
//      setcolor(0);
      lineb (x1,y1,x2,y2,0);
      lineb (x2,y2,x3,y3,0);
      lineb (x3,y3,x1,y1,0);
      if (vypl==1)
	{
	stred(x,y);
	vypln(x,y,0);
	}

     }
   if (a==2)
     {
      setcolor(color);
      rectangle (x1-5,y1-5,x1+5,y1+5);
      rectangle (x2-5,y2-5,x2+5,y2+5);
      rectangle (x3-5,y3-5,x3+5,y3+5);
     }
   if (a==-2)
     {
      setcolor(color);
      rectangle (x1-5,y1-5,x1+5,y1+5);
      rectangle (x2-5,y2-5,x2+5,y2+5);
      rectangle (x3-5,y3-5,x3+5,y3+5);
      kresli(-1);
     }



   if (a==10)
    {
     kresli(1);
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color);
       }
    }

  if (a==11)
    {
     kresli();
     if (vypl==1)
       {
       stred(x,y);
       vypln(x,y,color-8);
       }
    }

   Mys::on();
}
void Troj::zvzm()
{
  int xo,yo;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(2);
  while (Mys::buttons!=1) Mys::get();
  while ((x1-6<Mys::x && x1+6>Mys::x && y1-6<Mys::y-20 && y1+6>Mys::y-20) || (x2-6<Mys::x && x2+6>Mys::x && y2-6<Mys::y-20 && y2+6>Mys::y-20) || (x3-6<Mys::x && x3+6>Mys::x && y3-6<Mys::y-20 && y3+6>Mys::y-20))
    {
     xo=Mys::x;
     yo=Mys::y-20;
     if (x1-6<Mys::x && x1+6>Mys::x && y1-6<Mys::y-20 && y1+6>Mys::y-20)
	while (Mys::buttons==1)
	  {
	   Mys::get();
	   if (Mys::x!=xo || Mys::y-20!=yo)
	     {
	      kresli(-2);
	      x1+=Mys::x-xo;
	      y1+=Mys::y-20-yo;
	      xo=Mys::x;
	      yo=Mys::y-20;
	      kresli(2);
	     }
	  }
     if (x2-6<Mys::x && x2+6>Mys::x && y2-6<Mys::y-20 && y2+6>Mys::y-20)
	while (Mys::buttons==1)
	  {
	   Mys::get();
	   if (Mys::x!=xo || Mys::y-20!=yo)
	     {
	      kresli(-2);
	      x2+=Mys::x-xo;
	      y2+=Mys::y-20-yo;
	      xo=Mys::x;
	      yo=Mys::y-20;
	      kresli(2);
	     }
	  }
     if (x3-6<Mys::x && x3+6>Mys::x && y3-6<Mys::y-20 && y3+6>Mys::y-20)
	while (Mys::buttons==1)
	  {
	   Mys::get();
	   if (Mys::x!=xo || Mys::y-20!=yo)
	     {
	      kresli(-2);
	      x3+=Mys::x-xo;
	      y3+=Mys::y-20-yo;
	      xo=Mys::x;
	      yo=Mys::y-20;
	      kresli(2);
	     }
	  }
     while (Mys::buttons==0) Mys:get();
    }
  while (Mys::buttons==1) Mys::get();
  kresli(2);
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);

}
void Troj::posun()
{
  int xo,yo;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  while (Mys::buttons==1)
    {
     Mys::get();
     if (xo!=Mys::x || yo!=Mys::y-20)
       {
	kresli(-1);
	x1+=Mys::x-xo;
	x2+=Mys::x-xo;
	x3+=Mys::x-xo;
	y1+=Mys::y-20-yo;
	y2+=Mys::y-20-yo;
	y3+=Mys::y-20-yo;
	kresli(1);
	xo=Mys::x;
	yo=Mys::y-20;
       }
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);

}
void Troj::otoc()
{
  int rx,ry,xo;
  double dx,dy,uhol=0;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  Mys::get();
  while(Mys::buttons!=1) Mys::get();
  Mys::off();
  rx=Mys::x;
  ry=Mys::y-20;
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  Mys::on();
  while(Mys::buttons!=0) Mys::get();
  while(Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  Mys::off();
  while(Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo)
       {
	kresli(-1);
	dx= x1-rx;
	dy= y1-ry;
	uhol=(float)(Mys::x-xo)/90;
	x1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	dx= x2-rx;
	dy= y2-ry;
	x2=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y2=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	dx= x3-rx;
	dy= y3-ry;
	x3=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y3=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	xo=Mys::x;
	kresli(1);
       }
    }
  Mys::on();
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  setwritemode (COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

int Troj::orez(int ox1,int oy1, int ox2, int oy2, int cm)
{
  Ciara *pom;
  int o=0,x,y;
  pom=new Ciara(x1,y1,x2,y2,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  pom=new Ciara(x2,y2,x3,y3,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  pom=new Ciara(x3,y3,x1,y1,color);
  o+=pom->orez(ox1,oy1,ox2,oy2,cm);

  o/=3;

  if(o==2) return 2;
  if(vypl)
    {
     stred(x,y);
     setcolor(color-cm);
     rectangle(ox1,oy1,ox2,oy2);
     while(x-- >= ox2);
     while(x++ <= ox1);
     while(y-- >= oy2);
     while(y++ <= oy1);
     vypln(x,y,color-cm);
     setcolor(0);
     rectangle(ox1,oy1,ox2,oy2);
    }

  return o;
}

void Troj::uloz(FILE *out)
{
 fprintf(out,"%d,%d,%d,%d,%d,%d,%d,%d\n",color,vypl,x1,y1,x2,y2,x3,y3);
}

Troj::Troj(FILE *in)
{
 fscanf(in,"%d,%d,%d,%d,%d,%d,%d,%d\n",&color,&vypl,&x1,&y1,&x2,&y2,&x3,&y3);
}




Troj::~Troj()
{
  setviewport(0,20,609,479,1);
  kresli(-1);
  setviewport(0,0,639,479,1);
}

Ciara::Ciara(int f)
{
  int xo,yo;
  color=f;
  setviewport(0,20,609,479,1);
  setwritemode(XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  x1=x2=xo;
  y1=y2=yo;
  kresli(1);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	 kresli(-1);
	 x2=Mys::x;
	 y2=Mys::y-20;
	 xo=x2;
	 yo=y2;
	 kresli(1);
       }
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);

}

Ciara::Ciara(int f,int x,int y)
{
  int xo,yo;
  color=f;
  setviewport(0,20,609,479,1);
  setwritemode(XOR_PUT);
  while (Mys::buttons!=1) Mys::get();
  Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  x1=x2=xo=x;
  y1=y2=yo=y;
  kresli(1);
  while (Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo || Mys::y-20!=yo)
       {
	 kresli(-1);
	 x2=Mys::x;
	 y2=Mys::y-20;
	 xo=x2;
	 yo=y2;
	 kresli(1);
       }
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}



void Ciara::kresli(int a)
{
  Mys::off();
  if (a==1 || a==10 || a==2)
    {
//     setcolor(color);
     lineb (x1,y1,x2,y2,color);
    }
  if (a==0 || a==11)
    {
//     setcolor(color-8);
     lineb (x1,y1,x2,y2,color-8);
    }
  if (a==2)
    {
     setcolor(color);
     rectangle (x2-5,y2-5,x2+5,y2+5);
    }
  if (a==-1)
    {
//     setcolor(0);
     lineb (x1,y1,x2,y2,0);
    }
  if (a==-2)
    {
     setcolor(color);
     rectangle (x2-5,y2-5,x2+5,y2+5);
     kresli(-1);
    }
  Mys::on();
}
void Ciara::zvzm()
{
  int xo,yo;
  if (x1>x2) {int pom=x1;int pom2=y1;x1=x2;y1=y2;x2=pom;y2=pom2;}
  setviewport (0,20,609,479,1);
  setwritemode (XOR_PUT);
//  kresli(1);
  kresli(2);
  while (Mys::buttons!=1) Mys::get();
  if (x2-6<Mys::x && x2+6>Mys::x && y2-6<Mys::y-20 && y2+6>Mys::y-20)
    {
     xo=Mys::x;
     yo=Mys::y-20;
     while (Mys::buttons==1)
	{
	 Mys::get();
	 if (Mys::x!=xo || Mys::y-20!=yo)
	   {
	    kresli(-2);
	    x1+=xo-Mys::x;
	    x2-=xo-Mys::x;
	    y1+=yo-Mys::y+20;
	    y2-=yo-Mys::y+20;
	    xo=Mys::x;
	    yo=Mys::y-20;
	    kresli(2);
	   }
	}
    }
   while (Mys::buttons!=0) Mys::get();
   kresli(-2);
   setwritemode (COPY_PUT);
   kresli(1);
   setviewport(0,0,639,479,1);
   if (x1>x2) {int pom=x1;int pom2=y1;x1=x2;y1=y2;x2=pom;y2=pom2;}
}
void Ciara::posun()
{
  int xo,yo;
  if (x1>x2) {int pom=x1;int pom2=y1;x1=x2;y1=y2;x2=pom;y2=pom2;}
  setviewport (0,20,609,479,1);
  setwritemode (XOR_PUT);
  kresli(1);
  kresli(2);
  while (Mys::buttons!=1) Mys::get();
  if (x2-6<Mys::x && x2+6>Mys::x && y2-6<Mys::y-20 && y2+6>Mys::y-20)
    {
     xo=Mys::x;
     yo=Mys::y-20;
     while (Mys::buttons==1)
	{
	 Mys::get();
	 if (Mys::x!=xo || Mys::y-20!=yo)
	   {
	    kresli(-2);
	    x1+=Mys::x-xo;
	    x2+=Mys::x-xo;
	    y1+=Mys::y-20-yo;
	    y2+=Mys::y-20-yo;
	    kresli(2);
	    xo=Mys::x;
	    yo=Mys::y-20;
	   }
	}
    }
  while (Mys::buttons!=0) Mys::get();
  kresli(-2);
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

void Ciara::otoc()
{
  int rx,ry,xo;
  double dx,dy,uhol=0;
  setviewport (0,20,609,479,1);
  setwritemode (XOR_PUT);
  Mys::get();
  while(Mys::buttons!=1) Mys::get();
  Mys::off();
  rx=Mys::x;
  ry=Mys::y-20;
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  Mys::on();
  while(Mys::buttons!=0) Mys::get();
  while(Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  Mys::off();
  while(Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo)
       {
	kresli(-1);
	dx= x1-rx;
	dy= y1-ry;
	uhol=(float)(Mys::x-xo)/90;
	x1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	dx= x2-rx;
	dy= y2-ry;
	x2=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	y2=cos(uhol)*dy+sin(uhol)*dx+ry+.5;


	xo=Mys::x;
	kresli(1);
       }
    }
  Mys::on();
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,0);
  lineb (rx,ry-5,rx,ry+5,0);
  setwritemode (COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);

}

int Ciara::orez(int ox1,int oy1,int ox2, int oy2, int cm)
{			//vrati: 0 - ak us. je cela vokne
			//       1 - ak sa orezala
			//	 2 - ak je cela mimo okna

 double k,q;
 int xx1=-1,xx2=1000,yy1,yy2,px,py,tx1=x1,ty1=y1,tx2=x2,ty2=y2;

 if (ty1 <ty2) {yy1=-1;yy2=1000;}
 else { yy1=1000;yy2=-1;}

 if (tx1 >tx2) {int pom=tx1 ;int pom2=ty1 ;tx1 =tx2;ty1 =ty2;tx2=pom;ty2=pom2;}

 if ((tx1 >=ox1 && tx1 <=ox2) && (ty1 >=oy1 && ty1 <=oy2))
   { xx1=tx1 ;yy1=ty1 ; }
 if ((tx2>=ox1 && tx2<=ox2) && (ty2>=oy1 && ty2<=oy2))
   { xx2=tx2;yy2=ty2; }

 if (tx1 <ox1 && tx2<ox1) return 2;
 if (tx1 >ox2 && tx2>ox2) return 2;
 if (ty1 <oy1 && ty2<oy1) return 2;
 if (ty1 >oy2 && ty2>oy2) return 2;

 if(tx2-tx1==0) k=10000.0;
 else k=(double)(ty2-ty1 )/(tx2-tx1 );
 q=ty1 -k*tx1 ;
 if (tx2>ox2) { xx2=ox2; yy2=k*xx2+q; }

 if (tx1 <ox1) { xx1=ox1; yy1=k*xx1+q; }

 if (ty1 <oy1 && ty1 <ty2)
    {
     py=oy1;
     px=1/k*(py-q);
     if (xx1<px || yy1<py) { yy1=py; xx1=px;}
    }

 if (ty2<oy1 && ty1 >ty2)
   {
    py=oy1;
    px=1/k*(py-q);
    if (xx2>px || yy2<py) { yy2=py; xx2=px;}
   }

 if (ty2>oy2 && ty1 <ty2)
   {
    py=oy2;
    px=1/k*(py-q);
    if (xx2>px || yy2>py) {yy2=py; xx2=px;}
   }

 if (ty1 >oy2 && ty1 >ty2)
   {
    py=oy2;
    px=1/k*(py-q);
    if (xx1<px || yy1>py) {yy1=py; xx1=px;}
   }

//  k2=(double)(yy2-yy1)/(xx2-xx1);
//  if((double)floor(k2*10)/10 != (double)floor(k*10)/10) return;
//  if (xx1<ox1 || xx2>ox2 || (yy1<oy1 && ty1 <ty2) || (yy1>oy2 && ty1 >ty2) || (yy2>oy2 &&ty1 <ty2) || (yy2<oy1 && ty2<ty1 ))
//    return;
 if (!((xx1>=ox1 && xx1<=ox2) && (yy1>=oy1 && yy1<=oy2)))
   return 2;
 if (!((xx2>=ox1 && xx2<=ox2) && (yy2>=oy1 && yy2<=oy2)))
   return 2;

// setcolor(color-cm);
 lineb(xx1,yy1,xx2,yy2,color-cm);

 if (xx1==tx1 && xx2==tx2 && yy1==ty1 && yy2==ty2) return 0;
 else return 1;
}

void Ciara::uloz(FILE *out)
{
 fprintf(out,"%d,%d,%d,%d,%d\n",color,x1,y1,x2,y2);
}

Ciara::Ciara(FILE *in)
{
 fscanf(in,"%d,%d,%d,%d,%d\n",&color,&x1,&y1,&x2,&y2);
}




Ciara::~Ciara()
{
  setviewport(0,20,609,479,1);
  kresli(-1);
  setviewport(0,0,639,479,1);
}

void Polygon::Polygon(int f)
{
  Ciara *t,*t2;
  color=f;
  vypl=0;
  t=new Ciara(f);
  t2=t;
  ciary.ins(t);
  Mys::get();
  while(Mys::buttons!=2)
    {
     t2=new Ciara(f,t2->x2,t2->y2);
     ciary.ins(t2);
     Mys::get();
     while (Mys::buttons==0) Mys::get();
    }
  setviewport(0,20,609,479,1);
  ciary.ins(new Ciara(t2->x2,t2->y2,t->x1,t->y1,f));
  ciary.akt()->kresli(1);
  setviewport(0,0,639,479,1);

}


void Polygon::kresli(int a)
{
  DAtom *tmp;
  int x,y;
  Mys::off();
  if (a)
    {
     tmp=ciary.kurzor;
     while(ciary.next()!=tmp)
       {
	ciary.akt()->color=color;
	ciary.akt()->kresli(a);
       }
     ciary.akt()->color=color;
     ciary.akt()->kresli(a);

    }
  if (a==0)
    {
     tmp=ciary.kurzor;
     while(ciary.next()!=tmp)
       {
	ciary.akt()->color=color;
	ciary.akt()->kresli(a);
       }
     ciary.akt()->color=color;
     ciary.akt()->kresli(a);

    }
  if (a==-1)
    {
     if (vypl)
       {
	stred(x,y);
	vypln(x,y,0);
       }
     tmp=ciary.kurzor;
     while(ciary.next()!=tmp)
       ciary.akt()->kresli(a);
     ciary.akt()->kresli(a);
    }
  if (a==-2)
    {
     while(ciary.next()!=tmp)
       ciary.akt()->kresli(a);
     ciary.akt()->kresli(a);
    }





  if (a==10)
    {
     kresli(1);
     if (vypl)
       {
	stred(x,y);
        vypln(x,y,color);
       }
    }
  if (a==11)
    {
     kresli();
     if (vypl)
       {
        stred(x,y);
        vypln(x,y,color-8);
       }
    }
  Mys::on();
}

void Polygon::zvzm()
{
  DAtom *pom;
  Bod *t,*t2;
  int xo,yo,in;

  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(2);

  while(1)
  {
  while (Mys::buttons!=1) Mys::get();
  pom=ciary.kurzor;
  in=0;
  do
    {
     t=ciary.akt();
     if (t->x2-6<Mys::x && t->x2+6>Mys::x && t->y2-6<Mys::y-20 && t->y2+6>Mys::y-20)
       {
	in=1;
	xo=Mys::x;
	yo=Mys::y-20;
	t2=ciary.next()->akt();
	ciary.prev();	//!!!!!!!!!!!
	while(Mys::buttons==1)
	  {
	   Mys::get();
	   if (Mys::x!=xo || Mys::y-20!=yo)
	     {
	      kresli(-2);
	      t->x2+=Mys::x-xo;
	      t2->x1+=Mys::x-xo;
	      t->y2+=Mys::y-yo-20;
	      t2->y1+=Mys::y-yo-20;
	      kresli(2);
	      xo=Mys::x;
	      yo=Mys::y-20;
	     }
	  }
       }
    } while (ciary.next()!=pom);

  if (in==0)
    {
     kresli(2);
     setwritemode(COPY_PUT);
     kresli(1);
     setviewport(0,0,639,479,1);
     while(Mys::buttons!=0) Mys::get();
     return;
    }
  }
}
void Polygon::posun()
{
  int xo,yo;
  DAtom *pom;
  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  while (Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  yo=Mys::y-20;
  while (Mys::buttons==1)
    {
     Mys::get();
     if (xo!=Mys::x || yo!=Mys::y-20)
       {
	kresli(-1);
	pom=ciary.kurzor;
	do
	  {
	   ciary.akt()->x1+=Mys::x-xo;
	   ciary.akt()->x2+=Mys::x-xo;
	   ciary.akt()->y1+=Mys::y-yo-20;
	   ciary.akt()->y2+=Mys::y-yo-20;
	  } while (ciary.next()!=pom);
	kresli(1);
	xo=Mys::x;
	yo=Mys::y-20;
       }
    }
  setwritemode(COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

void Polygon::stred(int &sx,int &sy)
{
  DAtom *pom;
  int i=0;

  sx=0;
  sy=0;
  pom=ciary.kurzor;
  do
    {
     sx+=ciary.akt()->x1;
     sx+=ciary.akt()->x2;
     sy+=ciary.akt()->y1;
     sy+=ciary.akt()->y2;
     i++;
    } while (ciary.next()!=pom);
  sx/=2*i;
  sy/=2*i;
}

void Polygon::vypln(int x,int y,int f)
{
  Mys::off();
//  stred(x,y);
  setfillstyle(SOLID_FILL,f);
  floodfill(x,y,f);
  Mys::on();
}

void Polygon::otoc()
{
  int rx,ry,xo;
  double dx,dy,uhol=0;
  DAtom *pom;

  setviewport (0,20,609,479,1);
  kresli(-1);
  setwritemode (XOR_PUT);
  kresli(1);
  Mys::get();
  while(Mys::buttons!=1) Mys::get();
  Mys::off();
  rx=Mys::x;
  ry=Mys::y-20;
//  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  Mys::on();
  while(Mys::buttons!=0) Mys::get();
  while(Mys::buttons!=1) Mys::get();
  xo=Mys::x;
  Mys::off();
  while(Mys::buttons==1)
    {
     Mys::get();
     if (Mys::x!=xo)
       {
	kresli(-1);
	uhol=(float)(Mys::x-xo)/10;
	pom=ciary.kurzor;
	do
	  {
	   dx=ciary.akt()->x1-rx;
	   dy=ciary.akt()->y1-ry;
	   ciary.akt()->x1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	   ciary.akt()->y1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	   dx=ciary.akt()->x2-rx;
	   dy=ciary.akt()->y2-ry;
	   ciary.akt()->x2=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	   ciary.akt()->y2=cos(uhol)*dy+sin(uhol)*dx+ry+.5;
	  } while (ciary.next()!=pom);

	xo=Mys::x;
	kresli(1);
       }
    }
   Mys::on();
  setcolor(7);
  lineb (rx-5,ry,rx+5,ry,7);
  lineb (rx,ry-5,rx,ry+5,7);
  setwritemode (COPY_PUT);
  kresli(1);
  setviewport(0,0,639,479,1);
}

int Polygon::orez(int ox1,int oy1,int ox2,int oy2,int cm)
{
  DAtom *pom;
  int o=0,i=0,x,y;
  pom=ciary.kurzor;
  do
    {
     ciary.akt()->color=color;
     o+=ciary.akt()->orez(ox1,oy1,ox2,oy2,cm);
     i++;
    } while (pom!=ciary.next());
  o/=i;

  if(o==2) return 2;
  if(vypl)
    {
     stred(x,y);
     setcolor(color-cm);
     rectangle(ox1,oy1,ox2,oy2);
     while(x-- >= ox2);
     while(x++ <= ox1);
     while(y-- >= oy2);
     while(y++ <= oy1);
     vypln(x,y,color-cm);
     setcolor(0);
     rectangle(ox1,oy1,ox2,oy2);
    }

  return o;
}


void Polygon::uloz(FILE *out)
{
  int i=0;
  DAtom *pom;
  pom=ciary.kurzor;
  do i++;
  while (ciary.next()!=pom);

  fprintf(out,"%d,%d\n",i,vypl);
  do ciary.akt()->uloz(out);
  while (ciary.next()!=pom);

}
Polygon::Polygon(FILE *in)
{
 int i;
 fscanf(in,"%d,%d\n",&i,&vypl);
 for (;i>0;i--)
   ciary.ins(new Ciara(in));
 color=ciary.akt()->color;

}







Polygon::~Polygon()
{
  setviewport(0,20,609,479,1);
  kresli(-1);
  do
    if(!ciary.isempty()) delete ciary.akt();
  while(ciary.del());
  setviewport(0,0,639,479,1);
}
































void Obraz::novy(int t,int farba)
{
   Bod * utvar;
   get();
   if (x<609 && y>20)
     {
      setviewport(0,20,609,479,1);
      if(zozn.kurzor)
	if (ore)
	  zozn.akt()->orez(ox1,oy1,ox2,oy2,8);
	else
	  zozn.akt()->kresli(11);
      switch(t)
	{
	 case 1:utvar=new Stvorec(farba);break;
	 case 2:utvar=new Troj(farba);break;
	 case 3:utvar=new Kruh(farba);break;
	 case 4:utvar=new Ciara(farba);break;
	 case 5:utvar=new Polygon(farba);break;
	}
      zozn.ins(utvar);
      redraw();
     }
}
void Obraz::redraw()
{
 DAtom *pom;
 pom=zozn.kurzor;
 setviewport(0,20,609,479,1);
 Mys::off();
 clearviewport();
 if(ore)
   {
    while (zozn.next()!=pom) zozn.akt()->orez(ox1,oy1,ox2,oy2,8);
    zozn.akt()->orez(ox1,oy1,ox2,oy2,0);
   }
 else
   {
    while (zozn.next()!=pom) zozn.akt()->kresli(11);
    zozn.akt()->kresli(10);
   }

 Mys::on();
 setviewport(0,0,639,479,1);

}


void Obraz::zrus()
{
 Bod *pom;
 pom=zozn.akt();
 if(zozn.del())
   {
    pom->zmaz();
    if (zozn.kurzor!=NULL)
      {
//       zozn.akt()->kresli(10);
       redraw();
      }
    else
      {
       setviewport(0,20,609,479,1);
       clearviewport();
      }

   }
 setviewport(0,0,639,479,1);
}
void Obraz::dalsi()
{
  if (zozn.kurzor)
    {
     setviewport(0,20,609,479,1);
     if (ore)
       {
	zozn.akt()->orez(ox1,oy1,ox2,oy2,8);
	zozn.next();
	zozn.akt()->orez(ox1,oy1,ox2,oy2,0);
       }
     else
       {
	zozn.akt()->kresli(11);
	zozn.next();
	zozn.akt()->kresli(10);
       }
     setviewport(0,0,639,479,1);
    }
}

void Obraz::predch()
{
  if (zozn.kurzor)
    {
     setviewport(0,20,609,479,1);
     if (ore)
       {
	zozn.akt()->orez(ox1,oy1,ox2,oy2,8);
	zozn.prev();
	zozn.akt()->orez(ox1,oy1,ox2,oy2,0);
       }
     else
       {
	zozn.akt()->kresli(11);
	zozn.prev();
	zozn.akt()->kresli(10);
       }
     setviewport(0,0,639,479,1);
    }
}

void Obraz::load(char *meno,int la)
{
  FILE *in;
  Window *win;
  int typ;
//  int k,l,m,n,o,p,q;
  char *a;
  in=(FILE *)fopen(meno,"r");
  if (in==NULL)
    {
     a=new char[50];
     sprintf (a,"Nemozem otvorit subor '%s'.",meno);
     win=new Window(100,210,540,270,"Chyba:",a);
     win->zrus();
     return;
    }
  if (la) zavri();
  setviewport(0,20,609,479,1);


  fscanf(in,"%d,%d,%d,%d,%d\n",&ore,&ox1,&ox2,&oy1,&oy2);
  while (!feof(in))
    {
     if (fscanf(in,"%d\n",&typ))
       if (!feof(in))
       switch (typ)
	 {
	  case 's':
		   zozn.ins(new Stvorec(in));
		   break;
	  case 't':
		   zozn.ins(new Troj(in));
		   break;
	  case 'k':
		   zozn.ins(new Kruh(in));
		   break;
	  case 'c':
		   zozn.ins(new Ciara(in));
		   break;
	  case 'p':
		   zozn.ins(new Polygon(in));
		   break;
	  default:
		   a=new char[50];
		   sprintf (a,"Chyba pri citani '%s'.",meno);
		   win=new Window(100,210,540,270,"Chyba:",a);
		   win->zrus();
		   setviewport(0,0,639,479,1);
		   return;
	 }
    }
  zozn.next();
  redraw();
  fclose(in);
  setviewport(0,0,639,479,1);
}

void Obraz::save(char *meno)
{
FILE *out;
DAtom *pom;
char *a;

  Window *win;
  out=fopen(meno,"wt");
  pom=zozn.kurzor;
  if (!pom) return;
  if (out==NULL)
	{
	 a=new char[50];
	 sprintf (a,"Nemozem otvorit subor '%s'.",meno);
	 win=new Window(100,210,540,270,"Chyba:",a);
	 win->zrus();
	 return;
	}

  fprintf(out,"%d,%d,%d,%d,%d\n",ore,ox1,ox2,oy1,oy2);
  do
    {
     fprintf(out,"%d\n",zozn.akt()->ident());
     zozn.akt()->uloz(out);
    } while (zozn.next()!=pom);

  fclose(out);

}



void Obraz::zavri()
{
   while (zozn.kurzor)
     {
      zozn.akt()->zmaz();
      zozn.del();
     }
   Mys::off();
   setviewport(0,20,609,479,1);
   clearviewport();
   setviewport(0,0,639,479,1);
   Mys::on();
}


void Obraz::otoc()
{
  if (zozn.kurzor)
    {
     setviewport(0,20,609,479,1);
     if (ore)
       {
	zozn.akt()->orez(ox1,oy1,ox2,oy2,+zozn.akt()->color);
	zozn.akt()->kresli(1);
       }
     zozn.akt()->otoc();
     redraw();
     setviewport(0,0,639,479,1);
    }

}



void Obraz::vypln()
{
  int x,y;
  setviewport(0,20,609,479,1);
  if (zozn.kurzor)
    {
     if(ore)
       {
	if(zozn.akt()->vypl==0)
	  {
	   zozn.akt()->vypl=1;
	   zozn.akt()->orez(ox1,oy1,ox2,oy2,0);
	  }
	else
	  {
	   zozn.akt()->vypl=0;
	   redraw();
	  }
       }
     else
       {
	if(zozn.akt()->vypl==0)
	  {
	   zozn.akt()->vypl=1;
	   zozn.akt()->stred(x,y);
	   zozn.akt()->vypln(x,y,zozn.akt()->color);
	  }
	else
	  {
	   zozn.akt()->vypl=0;
	   redraw();
	  }
       }
    }
  setviewport(0,0,639,479,1);
}

void Obraz::orez()
{
 int xo,yo;
 if (!zozn.kurzor) return;

 setviewport(0,20,609,479,1);

 if(ore==0)
   {
   setwritemode(XOR_PUT);
   ore=1;
   Mys::get();

   while(Mys::buttons!=1) Mys::get();
   xo=Mys::x;
   yo=Mys::y-20;
   ox1=ox2=xo;
   oy1=oy2=yo;
   setcolor(WHITE);
   rectangle(ox1,oy1,ox2,oy2);
// rectangle(ox1,oy1,ox2,oy2);

   while (Mys::buttons==1)
     {
      Mys::get();
      if (Mys::x!=xo || Mys::y-20!=yo)
	{
	 Mys::off();
	 rectangle(ox1,oy1,ox2,oy2);
	 ox2=Mys::x;
	 oy2=Mys::y-20;
	 rectangle(ox1,oy1,ox2,oy2);
	 Mys::on();
	 xo=Mys::x;
	 yo=Mys::y-20;
	}
     }
   if (ox1>ox2) {int pom=ox1;ox1=ox2;ox2=pom;}
   if (oy1>oy2) {int pom2=oy1;oy1=oy2;oy2=pom2;}
// rectangle(ox1,oy1,ox2,oy2);

   }
  else
  ore=0;

 setwritemode(COPY_PUT);
 redraw();

 setviewport(0,0,639,479,1);

}



void Obraz::farba(int a)
{
  if(zozn.kurzor)
    {
     zozn.akt()->color=a;
     setviewport(0,20,609,479,1);
     if (ore)
       {
	zozn.akt()->orez(ox1,oy1,ox2,oy2,0);
       }
     else zozn.akt()->kresli(10);
     setviewport(0,0,639,479,1);
    }
}


Window::~Window()
  {
  Mys::off();
  putimage(wx1,wy1,imag,COPY_PUT);
  farfree(imag);
  Mys::on();
  }

Window::Window(int x1,int y1,int x2,int y2,char *lis,char *text="")
  {  int xtn,ytn;
     wx1=x1;
     wy1=y1;
     wx2=x2;
     wy2=y2;
     Mys::off();
     imag=farmalloc(imagesize(x1,y1,x2,y2));
     if (imag==NULL){closegraph();printf ("Not enough memory\n");}
     getimage(x1,y1,x2,y2,imag);

     setfillstyle(1,7);
     bar(x1+2,y1+2,x2-2,y2-2);
     setcolor(15);
     rectangle(x1+1,y1+1,x2-1,y2-1);
     setcolor(8);
     line(x1+1,y2-1,x2-1,y2-1);
     line(x2-1,y2-1,x2-1,y1+2);

     buton=new Button((x1+x2)/2-20,y2-25,(x1+x2)/2+20,y2-7,"OK",15);
     buton->off();
     Mys::off();
     setcolor(15);
     xtn = ((x2+x1)/2) - (strlen(text)/2)*8;
     ytn = ((y2+y1)/2) - 12;
     outtextxy(xtn,ytn,text);
     setfillstyle(1,RED);
     bar (x1+2,y1+2,x2-3,y1+12);
     outtextxy(x1+5,y1+3,lis);
     Mys::on();
}

void Window::zrus()
{ int in=0,a;

  while (!in)
  {
  get();
  if (kbhit())
    {
     a=getch();
     if (a==10 || a==13)
       {
	delete this;
	on();
	in=1;
       }
    }
  if (buttons==1)
     if (x>buton->x1 && x<buton->x2 && y>buton->y1 && y<buton->y2)
       {
       in=1;
       off();
       buton->on();
       while (buttons!=0) get();
       delete this;
       on();
       }
  }
}

Winlo::Winlo():Window(100,190,540,290,"Ulozit / Nacitat","")
{
  Mys::off();
  setfillstyle(1,7);
  bar(wx1+2+15,wy2-50,wx2-2-15,wy2-35);
  setcolor(8);
  rectangle(wx1+1+15,wy2-51,wx2-1-15,wy2-36);
  setcolor(15);
  line(wx1+1+15,wy2-36,wx2-1-15,wy2-36);
  line(wx2-1-15,wy2-36,wx2-1-15,wy2-50);
  outtextxy(wx1+18,wy2-62,"Zadaj meno:");
  Mys::on();
}
char *Winlo::getname()
{
char ret[50]="_\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
char a;
int i=0;
  do
    {
     setfillstyle(1,7);
     bar(wx1+19,wy2-46,wx2-17,wy2-38);
     setcolor(BLACK);
     outtextxy(wx1+19,wy2-46,ret);
     while(!kbhit())
       {
	Mys::get();
	if (Mys::buttons==1)
	  if (x>buton->x1 && x<buton->x2 && y>buton->y1 && y<buton->y2)
	    {
	     Mys::off();
	     buton->on();
	     while (buttons!=0) Mys::get();
	     Mys::on();
	     ret[i]='\0';
	     delete this;
	     return (strdup(ret));
	    }
	}
     a=getch();
     if (a!=10 && a!=13 && a!=0 && a!='\b')
       {
	ret[i]=a;
	ret[++i]='_';
       }
     if (a==0) getch();
     if (a=='\b' && i>0)
       {
	ret[i]='\0';
	ret[--i]='_';
       }

    }
  while (a!=13 && a!=10);
  ret[i]='\0';
  delete this;
  return (strdup(ret));
}



int Kruh::orez(int ox1, int oy1, int ox2,int oy2,int cm)
{
 int p1,x,y,vrat;


 if (x1+r<ox1 || x1-r>ox2 || y1-r >oy2 || y1+r<oy1) return 2;

 x=0;
 y=r;
 p1=3-2*r;

 if (x+x1>=ox1 && x+x1<=ox2 && y+y1>=oy1 && y+y1<=oy2)     putpixel(x+x1,y+y1,color-cm);
 if (y+x1>=ox1 && y+x1<=ox2 && x+y1>=oy1 && x+y1<=oy2)     putpixel(y+x1,x+y1,color-cm);
 if (-y+x1>=ox1 && -y+x1<=ox2 && x+y1>=oy1 && x+y1<=oy2)   putpixel(-y+x1,x+y1,color-cm);
 if (-x+x1>=ox1 && -x+x1<=ox2 && y+y1>=oy1 && y+y1<=oy2)   putpixel(-x+x1,y+y1,color-cm);
 if (-x+x1>=ox1 && -x+x1<=ox2 && -y+y1>=oy1 && -y+y1<=oy2) putpixel(-x+x1,-y+y1,color-cm);
 if (-y+x1>=ox1 && -y+x1<=ox2 && -x+y1>=oy1 && -x+y1<=oy2) putpixel(-y+x1,-x+y1,color-cm);
 if (y+x1>=ox1 && y+x1<=ox2 && -x+y1>=oy1 && -x+y1<=oy2)   putpixel(y+x1,-x+y1,color-cm);
 if (x+x1>=ox1 && x+x1<=ox2 && -y+y1>=oy1 && -y+y1<=oy2)   putpixel(x+x1,-y+y1,color-cm);

 while (x<y)
   {

   if (p1<0)
     p1+=4*x+6;
   else
     {
     y--;
     p1+=4*(x-y)+10;
     }
   x++;
   if (x+x1>=ox1 && x+x1<=ox2 && y+y1>=oy1 && y+y1<=oy2)     putpixel(x+x1,y+y1,color-cm);
   if (y+x1>=ox1 && y+x1<=ox2 && x+y1>=oy1 && x+y1<=oy2)     putpixel(y+x1,x+y1,color-cm);
   if (-y+x1>=ox1 && -y+x1<=ox2 && x+y1>=oy1 && x+y1<=oy2)   putpixel(-y+x1,x+y1,color-cm);
   if (-x+x1>=ox1 && -x+x1<=ox2 && y+y1>=oy1 && y+y1<=oy2)   putpixel(-x+x1,y+y1,color-cm);
   if (-x+x1>=ox1 && -x+x1<=ox2 && -y+y1>=oy1 && -y+y1<=oy2) putpixel(-x+x1,-y+y1,color-cm);
   if (-y+x1>=ox1 && -y+x1<=ox2 && -x+y1>=oy1 && -x+y1<=oy2) putpixel(-y+x1,-x+y1,color-cm);
   if (y+x1>=ox1 && y+x1<=ox2 && -x+y1>=oy1 && -x+y1<=oy2)   putpixel(y+x1,-x+y1,color-cm);
   if (x+x1>=ox1 && x+x1<=ox2 && -y+y1>=oy1 && -y+y1<=oy2)   putpixel(x+x1,-y+y1,color-cm);
   }

 if (x1+r<=ox2 && x1-r>=ox1 && y1+r<=oy2 && y1-r>=oy1) vrat=0;
 else vrat=1;
 if(vypl)
   {
    stred(x,y);
    if (!(x<=ox2 && x>=ox1 && y<=oy2 && y>=oy1))
      {
       while(x-- >= ox2);
       while(x++ <= ox1);
       while(y-- >= oy2);
       while(y++ <= oy1);
      }
    setcolor(color-cm);
    rectangle(ox1,oy1,ox2,oy2);

    vypln(x,y,color-cm);
    setcolor(0);
    rectangle(ox1,oy1,ox2,oy2);
   }

 return vrat;
}
