// === tree.cpp ===

#include "tree.h"
#include <alloc.h>

vertex *empty00()
{
  vertex *v;

  if ((v = new vertex) == NULL) return NULL;
  v->left = NULL;
  v->right = NULL;
  v->ch = 0;
  v->weight = 0;
  return v;
}

vertex *empty00(alpha *a)
{
  vertex *v;

  if ((v = new vertex) == NULL) return NULL;
  v->left = NULL;
  v->right = NULL;
  v->ch = a->ch;
  v->weight = a->weight;
  return v;
}

vertex *empty02(vertex *v1,vertex *v2)
{
  vertex *v;

  if ((v = new vertex) == NULL) return NULL;
  v->left = v1;
  v->right = v2;
  v->ch = 0;
  v->weight = v1->weight + v2->weight;
  return v;
}

void hod(vertex *v,uint *ch,float *weight)
{
  *ch = v->ch;
  *weight = v->weight;
}

vertex *nextl(vertex *v)
{
  return v->left;
}

vertex *nextr(vertex *v)
{
  return v->right;
}

vertex *setnextl(vertex *v1,vertex *v2)
{
  v1->left = v2;
  return v1;
}

vertex *setnextr(vertex *v1,vertex *v2)
{
  v1->right = v2;
  return v1;
}

void drop(vertex *tree)
{
  if ( (tree->left == NULL) && (tree->right == NULL) ) {
    delete tree;
    return ;
  }
  if ( tree->left != NULL)
    drop(tree->left);
  if ( tree->right != NULL)
    drop(tree->right);
  return;
}
