// === tree.h ===
// deklaracia stromu a operacii nad nim

#ifndef __TREE
#define __TREE

#include "types.h"

const int NALPHA=257;
const char MAX_CODE_SIZE=5;  //in bites, 2^5=32

typedef struct alpha {
  float weight;    
  uint ch;         
  uchar sz;        
  uint code;       
};

struct vertex {
  uint ch;           // symbol
  float weight;      // pravdepodobnost vyskytu symbolu 
  vertex *left;      // lavy nasledovnik 
  vertex *right;     // pravy nasledovnik 
};

vertex *empty00();
vertex *empty00(alpha *a);
vertex *empty02(vertex *v1,vertex *v2);
void hod(vertex *v,uint *ch,float *weight);
void drop(vertex *tree);
vertex *nextl(vertex *v);
vertex *nextr(vertex *v);
vertex *setnextl(vertex *v1,vertex *v2);
vertex *setnextr(vertex *v1,vertex *v2);

#endif