; ZADANIE C.3   PRODUKCNY SYSTEM S DOPREDNYM ZRETAZENIM
; 
; (C) JURAJ SPAL			4 INFO 6

(DEFUN L ()
	(LOAD 'UI3)
)

(SETQ VARS '(?X ?Y ?Z))

(SETQ F '(	(JANO JE OTEC FERO)
		(JANO JE OTEC JOZO)
		(MISO JE OTEC LOJZO)
		(JANO JE OTEC JANA)
		(DETI FERO JOZO)
		(SURODENCI FERO JOZO)
		(MUZ JOZO)
		(ZENA JANA)
		(END)
))

(SETQ P '(	( ((?X JE OTEC ?Y) (?X JE OTEC ?Z)) 
			( (PRIDAJ (SURODENCI ?Y ?Z)) 
			  (PRIDAJ (DETI ?Y ?Z)) ) )
		( ((?X JE OTEC ?Y) (MUZ ?Y))
			( (PRIDAJ (?Y JE SYN ?X)) ) )
		( ((SURODENCI ?X ?Y) (MUZ ?X))
			( (PRIDAJ (?X JE BRAT ?Y)) ) )
		( ((SURODENCI ?X ?Y) (ZENA ?X))
			( (PRIDAJ (?X JE SESTRA ?Y)) ) )
		( ((SURODENCI ?X ?Y))
			( (PRIDAJ (SURODENCI ?Y ?X)) ) )
))

(DEFUN FAZA_3 (ZOZ)
	(COND	((NULL ZOZ) NIL)
		((FILTER (FIRST ZOZ)) (FAZA_3 (REST ZOZ)) )
		(T (CONS (FIRST ZOZ) (FAZA_3 (REST ZOZ)) ))
))
(DEFUN FILTER (ZOZ)
	(COND	((NULL ZOZ) T)
		((EQ (FIRST (FIRST ZOZ)) 'PRIDAJ)
			(COND	((NAJDI (SECOND (FIRST ZOZ)) F) 
					(FILTER (REST ZOZ)) )
				(T NIL) ) )
		((EQ (FIRST (FIRST ZOZ)) 'ZRUS)
			(COND	((NAJDI (SECOND (FIRST ZOZ)) F) NIL)
				(T (FILTER (REST ZOZ))) ) )
		(T T)
))

(DEFUN FAZA_2 (FAKTY PRAVIDLA)
	(RESET VARS)
	(COND	((NULL PRAVIDLA) NIL)
		(T (APPEND (INST FAKTY (FIRST PRAVIDLA)) 
			(FAZA_2 FAKTY (REST PRAVIDLA)) ))
))

(DEFUN INST (FAKTY PRAVIDLO)
	(VYTVOR (UPRAV (INST1 FAKTY (FIRST PRAVIDLO) (GET_VARS VARS))) 
		(SECOND PRAVIDLO))
)

(DEFUN VYTVOR (ZOZ PRAVIDLO)
	(COND	((NULL ZOZ) NIL)
		(T (SET_VARS VARS (FIRST ZOZ)) 
		   (CONS (APLIKUJOP PRAVIDLO) (VYTVOR (REST ZOZ) PRAVIDLO) ))
))
(DEFUN APLIKUJOP (PRAV)
	(COND	((NULL PRAV) NIL)
		(T (CONS (APL_OP (FIRST PRAV)) (APLIKUJOP (REST PRAV)) ))
))
(DEFUN APL_OP (PRAV)
	(COND	((NULL PRAV) NIL)
		((VAR PRAV) (EVAL PRAV))
		((ATOM PRAV) PRAV)
		(T (CONS (APL_OP (FIRST PRAV)) (APL_OP (REST PRAV)) ))
))

(DEFUN UPRAV (ZOZ)
	(COND	((NULL ZOZ) NIL)
		((NULL (ZISTI (FIRST ZOZ))) (UPRAV (REST ZOZ)))
		(T (CONS (FIRST ZOZ) (UPRAV (REST ZOZ))))
))

(DEFUN ZISTI (ZOZ)
	(COND	((NULL ZOZ) T)
		((NULL (NAJDI (FIRST ZOZ) (REST ZOZ))) (ZISTI (REST ZOZ)))
		(T NIL)
))

(DEFUN NAJDI (A ZOZ)
	(COND	((NULL ZOZ) NIL)
		((NULL A) NIL)
		((EQUAL (FIRST ZOZ) A) T)
		(T (NAJDI A (REST ZOZ)))
))
		
(DEFUN INST1 (FAKTY PRAVIDLO ZOZ)

	(COND	((NULL PRAVIDLO) (CONS ZOZ NIL))
		((INST2 FAKTY (FIRST PRAVIDLO) ZOZ)
		  (APPEND 
  (INST1 FAKTY (REST PRAVIDLO) (GET_VARS VARS))
  (INST1 (INST2 FAKTY (FIRST PRAVIDLO) (SET_VARS VARS ZOZ))
	PRAVIDLO (SET_VARS VARS ZOZ)) ) )
		(T NIL)
))

(DEFUN INST2 (FAKTY PRAVIDLO ZOZ)
	(SET_VARS VARS ZOZ)
	(COND	((NULL FAKTY) NIL)
		((NAVIAZ (FIRST FAKTY) PRAVIDLO) (REST FAKTY))
		(T (INST2 (REST FAKTY) PRAVIDLO ZOZ))
))

(DEFUN NAVIAZ (A B)
	(COND	((AND (NULL A) (NULL B)) T)
		((EQ (FIRST A) (FIRST B)) (NAVIAZ (REST A) (REST B)) )
		((VAR (FIRST B)) 
			(COND	((NULL (EVAL (FIRST B))) 
			  (SET (FIRST B) (FIRST A))
			  (NAVIAZ (REST A) (REST B)) )
				((EQ (EVAL (FIRST B)) (FIRST A))
			  (NAVIAZ (REST A) (REST B)) )
				(T NIL) ))
		(T NIL)
))

(DEFUN VAR (A)
	(VAR1 A VARS)
)
(DEFUN VAR1 (A ZOZ)
	(COND	((NULL ZOZ) NIL)
		((EQ (FIRST ZOZ) A) T)
		(T (VAR1 A (REST ZOZ)))
))

(DEFUN RESET (ZOZ)
	(COND	((NULL ZOZ) NIL)
	(T (SET (FIRST ZOZ) NIL) (RESET (REST ZOZ)))
))

(DEFUN GET_VARS(ZOZ)
	(COND	((NULL ZOZ) NIL)
		(T (CONS (EVAL (FIRST ZOZ)) (GET_VARS (REST ZOZ))))
))

(DEFUN VYPIS (ZOZ)
	(COND 	((NULL ZOZ) NIL)
		(T (PRINC (FIRST ZOZ)) (TERPRI) (VYPIS (REST ZOZ)))
))
(DEFUN SET_VARS(ZOZV ZOZ)
	(COND ((NULL ZOZ) NIL)
	(T 	(SET (FIRST ZOZV) (FIRST ZOZ))
		(CONS (FIRST ZOZ) (SET_VARS (REST ZOZV) (REST ZOZ))))
))

(DEFUN VYKONAJ (PRAVIDLO)
	(COND	((NULL PRAVIDLO) NIL)
		(T 	(COND 	((EQ (FIRST (FIRST PRAVIDLO)) 'PRIDAJ) 
					(PRIDAJ (SECOND (FIRST PRAVIDLO))) )
			 	((EQ (FIRST (FIRST PRAVIDLO)) 'ZRUS)
					(ZRUS (SECOND (FIRST PRAVIDLO))) )
			)
		(VYKONAJ (REST PRAVIDLO)))
))

(DEFUN PRIDAJ (FAKT)
	(COND	((NAJDI FAKT F) NIL)
		(T (SETQ F (CONS FAKT F)))
))

(DEFUN ZRUS (FAKT) (SETQ F (ODSTRAN FAKT F)) )
	
(DEFUN ODSTRAN (A ZOZ)
	(COND	((NULL ZOZ) NIL)
		((EQUAL A ZOZ) (ODSTRAN (REST ZOZ)))
		(T (CONS (FIRST ZOZ) (ODSTRAN (REST ZOZ))))
))

(DEFUN MAIN ()
	(SETQ I (FAZA_3 (FAZA_2 F P)))
	(COND	((NULL I) (TERPRI) (VYPIS F) NIL)
		(T (VYKONAJ (FIRST I)) (MAIN))
	)
)
