#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

FILE *vystup;
int Vystup(int *,float *);
int Vstup[8][4]=
					{
					 {-1,-1,-1,-1},{-1,-1,1,-1},{-1,1,-1,-1},{-1,1,1,-1},
					 { 1,-1,-1,-1},{ 1,-1,1,-1},{ 1,1,-1,-1},{ 1,1,1,-1}
					};      //Vstupne vektory

void main(void)
{
	void Trenuj(int *,float *);
	float Vaha[4];
	int VystupAND[8]={-1,-1,-1,-1,-1,-1,-1,1}; //Vystupny vektor fcie AND
	int VystupOR[8]={-1,1,1,1,1,1,1,1};        //Vystupny vektor fcie OR
	int VystupXOR[8]={-1,1,1,-1,1,-1,-1,1};    //Vystupny vektor fcie XOR
	int i;
	char Fcia;

	if ((vystup = fopen("percep.txt","a")) == NULL)
	{
		printf("\nNemozem otvorit subor \"percep.txt\" !");
		exit(1);
	}

	do{
		clrscr();
		printf("\nStlac cislo funckie ktorou chces trenovat perceptron:\n 1..AND\n 2..OR\n 3..XOR");

		do{
			Fcia=getch();
		}while(Fcia<'1' || Fcia>'3');  //vyber fcie AND,OR,XOR

		for(i=0;i<3;i++)
			Vaha[i]=(10-rand()%20)/10.0;

		Vaha[3]=0;
		fprintf(vystup,"\nLogicka fcia ktoru sa ma perceptron natrenovat je ");

		switch(Fcia) //Vyber Fcie na trenovanie perceptronu
		{
			case '1':
					printf("\nFunkcia AND.");
					fprintf(vystup,"AND");
					Trenuj(VystupAND,Vaha);
					break;
			case '2':
					printf("\nFunkcia OR.");
					fprintf(vystup,"OR");
					Trenuj(VystupOR,Vaha);
					break;
			case '3':
					printf("\nFunkcia XOR.");
					fprintf(vystup,"XOR");
					Trenuj(VystupXOR,Vaha);
					break;
		}

		printf("\nNEXT?(x/N)");
	}while(getch()!='n');
}

void Trenuj(int *ZiadanyVystup,float *Vaha) //Fcia na trenovanie perceptronu
{
	int i,j,p=0;
	float E,S,w[4],Eta=0.025;                   //Eta urcuje rychlost ucenia sa

	printf("\nRychlost ucenia je %f\n",Eta);
	fprintf(vystup,"\nRychlost ucenia je %f",Eta);

	do{
		S=0;
		fprintf(vystup,"\nZelany vystup:   ");
		printf("\nZelany vystup:   ");

		for (i=0;i<8;i++)                       //Vypocet chybovej fcie E
		{
			fprintf(vystup,"%d  ",(ZiadanyVystup[i]+1)/2);
			printf("%d  ",(ZiadanyVystup[i]+1)/2);
			S+=pow(ZiadanyVystup[i]-Vystup(Vstup[i],Vaha),2);
		}

		fprintf(vystup,"\nSkutocny vystup: ");
		printf("\nSkutocny vystup: ");

		for(i=0;i<8;i++)
		{
			fprintf(vystup,"%d  ",(Vystup(Vstup[i],Vaha)+1)/2);
			printf("%d  ",(Vystup(Vstup[i],Vaha)+1)/2);
		}

		E=0.5*S;
		printf("\nCyklus%d Chyba:%6.3f  Vaha1:%6.3f Vaha2:%6.3f Vaha3:%6.3f Theta:%6.3f\n",p,E,Vaha[0],Vaha[1],Vaha[2],Vaha[3]);
		fprintf(vystup,"\nCyklus%d Chyba:%6.3f  Vaha1:%6.3f Vaha2:%6.3f Vaha3:%6.3f Theta:%6.3f\n",p++,E,Vaha[0],Vaha[1],Vaha[2],Vaha[3]);

		for(j=0;j<4;j++)                        //Vlastne trenovanie
		{
			w[j]=0;

			for (i=0;i<8;i++)
				w[j]+=Eta*(ZiadanyVystup[i]-Vystup(Vstup[i],Vaha))*Vstup[i][j];

			Vaha[j]+=w[j];                        //vypocitaju sa nove vahy pre
		}                                       //vstupy ako aj theta

	}while(p<11 && E!=0);

	if((p==11)&&(E!=0))
	{
		fprintf(vystup,"\nPerceptron sa pri rychlosti %4.2f nemoze natrenovat danu fciu v 10 krokoch\n\n",Eta);
		printf("\nPerceptron sa pri rychlosti %4.2f nemoze natrenovat danu fciu v 10 krokoch\n\n",Eta);
	}
}

int Vystup(int*vstup,float *Vaha)  //Vypocita vystup o=sign(net)
{
	float x=0;

	for(int i=0;i<4;i++)
		x+=Vaha[i]*vstup[i];
	if (x>0)
		return 1;
	else
		return -1;
}
