//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "Unit1.h"
#include <math.h>
#include <stdlib.h>
#include <alloc.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int ppx[10],ppy[10],lpx[10],lpy[10],sumclick=0;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
// ohniskova vzdialenost
	f = -100;
// vzdialenost kamier
	bx = 150;

	P1.setvector(50, -50, 100);
	P2.setvector(50, -50, 200);
	P3.setvector(-50, -50, 200);
	P4.setvector(-50, -50, 100);
	V.setvector(0, 150, 150);

	/* left camera */
	CL.setvector(-bx/2 , 0 , 0);
	/* right camera */
	CR.setvector(bx/2 , 0 , 0);
}
//---------------------------------------------------------------------------
void TForm1::showobject(){

	PaintBox->Canvas->Pen->Color = clBlue;
	PaintBox2->Canvas->Pen->Color = clBlue;
	line(P1, P2);
	line(P2, P3);
	line(P3, P4);
	line(P4, P1);
	line(P1, V);
	line(P2, V);
	line(P3, V);
	line(P4, V);
}

void TForm1::hideobject(){
	/* object */
	PaintBox->Canvas->Pen->Color = clBlack;
	PaintBox2->Canvas->Pen->Color = clBlack;
	line(P1, P2);
	line(P2, P3);
	line(P3, P4);
	line(P4, P1);
	line(P1, V);
	line(P2, V);
	line(P3, V);
	line(P4, V);
}
void TForm1::line(Vector4 A, Vector4 B){
  int stredx, stredy, x1, y1, x2, y2;
     stredx=PaintBox->Width/2;
     stredy=PaintBox->Height/2;
if((CL.z()-A.z()!=0)&&(CL.z()-B.z()!=0))
 {
     x1=-f*(CL.x()-A.x())/(CL.z()-A.z());
     y1=-f*(CL.y()-A.y())/(CL.z()-A.z());
     x2=-f*(CL.x()-B.x())/(CL.z()-B.z());
     y2=-f*(CL.y()-B.y())/(CL.z()-B.z());
     PaintBox->Canvas->MoveTo(stredx+x1,stredy-y1);
     PaintBox->Canvas->LineTo(stredx+x2,stredy-y2);

     x1=-f*(CR.x()-A.x())/(CR.z()-A.z());
     y1=-f*(CR.y()-A.y())/(CR.z()-A.z());
     x2=-f*(CR.x()-B.x())/(CR.z()-B.z());
     y2=-f*(CR.y()-B.y())/(CR.z()-B.z());
     PaintBox2->Canvas->MoveTo(stredx+x1,stredy-y1);
     PaintBox2->Canvas->LineTo(stredx+x2,stredy-y2);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBoxPaint(TObject *Sender){
	showobject();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBoxMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
sumclick++;
lpx[0]=X-PaintBox->Width/2;
lpy[0]=Y-PaintBox->Height/2;
for(int i=9;i>0;i--)
  {
    lpx[i]=lpx[i-1];
    lpy[i]=lpy[i-1];
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintBox2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
ppx[0]=X-PaintBox->Width/2;
ppy[0]=Y-PaintBox->Height/2;
for(int i=9;i>0;i--)
  {
    ppx[i]=ppx[i-1];
    ppy[i]=ppy[i-1];
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
 if (sumclick>0)
  {
  int x,y,z;
  z=-(f*bx)/(lpx[0]-ppx[0]);
  x=(z*lpx[0])/f+bx/2;
  y=(z*lpy[0])/f;
  ShowMessage(" X=" + FloatToStr(x) + "\n Y=" + FloatToStr(y) +"\n Z=" + FloatToStr(z));
  sumclick=0;
  }
 else
  ShowMessage("Musis kliknut jeden vrchol");

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
 int i,j,r,s,ls[3][3],ps[3],psc[3];
 double riadok,stlpec,riadokc,stlpecc,omega=0,omegac=0;


 int a[velkost+1][velkost+1];
 int fr[velkost][velkost],fc[velkost][velkost],frc[velkost][velkost];

 progressbar1->Max=PaintBox->Width;
 for(i=1; i<PaintBox->Width-1; i++)
 {progressbar1->Position=i;
 for(j=1; j<PaintBox->Height-1; j++)
 {if(PaintBox->Canvas->Pixels[i][j]>0)
  {int susedia=0;   // test ci ma prave tolko susedov aby mohol byt vrchol
   for(r=0;r<3;r++)
    for(s=0;s<3;s++)
        susedia=susedia+(PaintBox->Canvas->Pixels[i+r-1][j+s-1]>0);

   if((susedia==4)||(susedia==5))
   {susedia=0;
    for(r=1;r<velkost+1;r++)
     for(s=1;s<velkost+1;s++)
     {a[r][s]=(PaintBox->Canvas->Pixels[i+s-velkost/2-1][j+r-velkost/2-1]>0);
      susedia=susedia+a[r][s];
     }

    if(susedia>0)
    {for(r=1;r<velkost;r++)
      for(s=1;s<velkost;s++)
      {fr[r][s]=a[r+1][s]-a[r][s+1]+a[r+1][s+1]-a[r][s];
       fc[r][s]=a[r][s+1]-a[r+1][s]+a[r+1][s+1]-a[r][s];
       frc[r][s]=fc[r][s]*fr[r][s];
      }

    for(r=1;r<3;r++)
    {  ps[r]=0;
       psc[r]=0;
       for(s=1;s<3;s++)
        ls[r][s]=0;
   }
// vytvorenie sustavy rovnic

     for(r=1;r<velkost;r++)
      for(s=1;s<velkost;s++)
      {ls[1][1]=ls[1][1]+pow(fr[r][s],2);
       ls[1][2]=ls[1][2]+fc[r][s]*fr[r][s];
       ls[2][1]=ls[2][1]+fc[r][s]*fr[r][s];
       ls[2][2]=ls[2][2]+pow(fc[r][s],2);

       ps[1]=ps[1]+((pow(fr[r][s],2)*r)+(fr[r][s]*fc[r][s]*s));
       ps[2]=ps[2]+((pow(fc[r][s],2)*s)+(fr[r][s]*fc[r][s]*r));
       psc[1]=psc[1]+((pow(fc[r][s],2)*r)-(fr[r][s]*fc[r][s]*s));
       psc[2]=psc[2]+((pow(fr[r][s],2)*s)-(fr[r][s]*fc[r][s]*r));
      }
// jej vyriesenie
     if((ls[1][1]*ls[2][2]-ls[1][2]*ls[2][1])!=0)
     {riadok=(ps[1]*ls[2][2]-ps[2]*ls[2][1])/(double)(ls[1][1]*ls[2][2]-ls[1][2]*ls[2][1]);
      stlpec=(ps[2]*ls[1][1]-ps[1]*ls[1][2])/(double)(ls[1][1]*ls[2][2]-ls[1][2]*ls[2][1]);

      riadokc=(psc[1]*ls[1][1]+psc[2]*ls[2][1])/(double)(ls[1][1]*ls[2][2]-ls[1][2]*ls[2][1]);
      stlpecc=(psc[2]*ls[2][2]+psc[1]*ls[1][2])/(double)(ls[1][1]*ls[2][2]-ls[1][2]*ls[2][1]);

// omega, omega s ciarou
      omega=0; omegac=0;
      for(r=1;r<velkost;r++)
       for(s=1;s<velkost;s++)
       {omega=omega+pow((r-riadok),2)*pow(fr[r][s],2)+pow((s-stlpec),2)*pow(fc[r][s],2)+2*(r-riadok)*(s-stlpec)*frc[r][s];
        omegac=omegac+(r-riadokc)*(r-riadokc)*fr[r][s]*fr[r][s]+(s-stlpecc)*(s-stlpecc)*fc[r][s]*fc[r][s] -2*(r-riadokc)*(s-stlpecc)*frc[r][s];
       }
//test ci je to vrchol alebo co
      if(omegac>0) omega=omega/omegac; else omega=1;
      if (omega<.7)
       {int x=i+stlpec-velkost/2;int y=j+riadok-velkost/2;
        PaintBox->Canvas->Pixels[x+1][y]=clYellow;
        PaintBox->Canvas->Pixels[x-1][y]=clYellow;
        PaintBox->Canvas->Pixels[x][y+1]=clYellow;
        PaintBox->Canvas->Pixels[x][y-1]=clYellow;
        PaintBox->Canvas->Pixels[x+1][y+1]=clYellow;
        PaintBox->Canvas->Pixels[x-1][y-1]=clYellow;
        PaintBox->Canvas->Pixels[x+1][y-1]=clYellow;
        PaintBox->Canvas->Pixels[x-1][y+1]=clYellow;
       }
     }
    }
   }
  }
 }
 }
 progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::zminusClick(TObject *Sender)
{
 class Matrix44 K1;
 double surx,sury;
  progressbar1->Min=0;
  progressbar1->Max=200;
  surx=V.coor[0];
  sury=V.coor[1]-100;
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,-surx,-sury,0,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,cos (2*3.14159265359/200),-sin (2*3.14159265359/200),0,0);
    K1.setrow(2,sin (2*3.14159265359/200),cos (2*3.14159265359/200),0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,0,0,1);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,surx,sury,0,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::zplusClick(TObject *Sender)
{
 class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=200;
  double surx,sury;
  surx=V.coor[0];
  sury=V.coor[1]-100;
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,-surx,-sury,0,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,cos (-2*3.14159265359/200),-sin (-2*3.14159265359/200),0,0);
    K1.setrow(2,sin (-2*3.14159265359/200),cos (-2*3.14159265359/200),0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,0,0,1);

    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,surx,sury,0,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::xplusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=200;
  double surz,sury;
  surz=V.coor[2];
  sury=V.coor[1]-100;
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,-sury,-surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,cos (2*3.14159265359/200),-sin (2*3.14159265359/200),0);
    K1.setrow(3,0,sin (2*3.14159265359/200),cos (2*3.14159265359/200),0);
    K1.setrow(4,0,0,0,1);

    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,sury,surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::xminusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=200;
  double surz,sury;
  surz=V.coor[2];
  sury=V.coor[1]-100;
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,-sury,-surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,cos (-2*3.14159265359/200),-sin (-2*3.14159265359/200),0);
    K1.setrow(3,0,sin (-2*3.14159265359/200),cos (-2*3.14159265359/200),0);
    K1.setrow(4,0,0,0,1);

    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,sury,surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::yplusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=200;
  double surx,surz;
  surx=V.coor[0];
  surz=V.coor[2];
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,-surx,0,-surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,cos (2*3.14159265359/200),0,sin (2*3.14159265359/200),0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,-sin (2*3.14159265359/200),0,cos (2*3.14159265359/200),0);
    K1.setrow(4,0,0,0,1);

    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,surx,0,surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::yminusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=200;
  double surx,surz;
  surx=V.coor[0];
  surz=V.coor[2];
  for (int k=0; k<200; k++){
    hideobject();
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,-surx,0,-surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,cos (-2*3.14159265359/200),0,sin (-2*3.14159265359/200),0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,-sin (-2*3.14159265359/200),0,cos (-2*3.14159265359/200),0);
    K1.setrow(4,0,0,0,1);

    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,surx,0,surz,0);
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;

    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::zmplusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=10;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,0,-1,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::zmminusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=9;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,0,1,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::xmplusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=9;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,1,0,0,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::xmminusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=9;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,-1,0,0,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ymplusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=9;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,1,0,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ymminusClick(TObject *Sender)
{
  class Matrix44 K1;
  progressbar1->Min=0;
  progressbar1->Max=9;

  for (int k=0; k<10; k++){
    K1.setrow(1,1,0,0,0);
    K1.setrow(2,0,1,0,0);
    K1.setrow(3,0,0,1,0);
    K1.setrow(4,0,-1,0,0);
    hideobject();
    P1=P1*K1;
    P2=P2*K1;
    P3=P3*K1;
    P4=P4*K1;
    V=V*K1;
    showobject();
    delay();
    progressbar1->Position=k;
  }
  progressbar1->Position=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Correspond1Click(TObject *Sender)
{
if (sumclick>0)
 {
if (sumclick>9) sumclick=9;
for(int i=1;i<=sumclick;i++)
 { // test, ci su dve rovnake y
  int min=0;
  for(int pom=1;pom<=sumclick;pom++)
     if((lpy[i]>=(lpy[pom]-5)&& lpy[i]<=(lpy[pom]+5) && (i!=pom)))
      if (lpx[i]<lpx[pom]) min=1;
        else min=-1;
// vieme ci je to mesie al. vacsie...

  for(int j=1;j<=sumclick;j++){
   if(lpy[i]>=(ppy[j]-5)&& lpy[i]<=(ppy[j]+5) )
    {    PaintBox->Canvas->Pixels[lpx[i]+PaintBox->Width/2][lpy[i]+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]+1+PaintBox->Width/2][lpy[i]+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]+PaintBox->Width/2][lpy[i]+1+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]-1+PaintBox->Width/2][lpy[i]+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]+PaintBox->Width/2][lpy[i]-1+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]+1+PaintBox->Width/2][lpy[i]+1+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]-1+PaintBox->Width/2][lpy[i]+1+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]+1+PaintBox->Width/2][lpy[i]-1+PaintBox->Height/2]=clRed;
         PaintBox->Canvas->Pixels[lpx[i]-1+PaintBox->Width/2][lpy[i]-1+PaintBox->Height/2]=clRed;
       if (min==0)
            {     int x,y,z;
                  z=-(f*bx)/(lpx[i]-ppx[j]);
                  x=(z*lpx[i])/f+bx/2;
                  y=(z*lpy[i])/f;
                  ShowMessage(" XL="+FloatToStr(lpx[i])+"\n YL="+FloatToStr(lpy[i])+"\n XP="+FloatToStr(ppx[j])+"\n YP="+FloatToStr(ppy[j])+"\n\n X=" + FloatToStr(x) + "  Y=" + FloatToStr(y) +"  Z=" + FloatToStr(z));
            }
       else
            for(int pom=1;pom<=sumclick;pom++)
             if( ppy[j]>=(ppy[pom]-5) && ppy[j]<=(ppy[pom]+1))
             {if((min==1)&&(pom!=j))
               if((ppx[j]<(ppx[pom])))
                  {     int x,y,z;
                        z=-(f*bx)/(lpx[i]-ppx[j]);
                        x=(z*lpx[i])/f+bx/2;
                        y=(z*lpy[i])/f;
                        ShowMessage(" XL="+FloatToStr(lpx[i])+"\n YL="+FloatToStr(lpy[i])+"\n XP="+FloatToStr(ppx[j])+"\n YP="+FloatToStr(ppy[j])+"\n\n X=" + FloatToStr(x) + "  Y=" + FloatToStr(y) +"  Z=" + FloatToStr(z));
                  }
            if((min==-1)&&(j!=pom))
               if((ppx[j]>(ppx[pom])))
                  {     int x,y,z;
                        z=-(f*bx)/(lpx[i]-ppx[j]);
                        x=(z*lpx[i])/f+bx/2;
                        y=(z*lpy[i])/f;
                        ShowMessage(" XL="+FloatToStr(lpx[i])+"\n YL="+FloatToStr(lpy[i])+"\n XP="+FloatToStr(ppx[j])+"\n YP="+FloatToStr(ppy[j])+"\n\n X=" + FloatToStr(x) + "  Y=" + FloatToStr(y) +"  Z=" + FloatToStr(z));
                  }
            }

      }
  }

 }
for(int i=0;i<sumclick;i++)
 {lpx[i]=0;lpy[i]=0;ppx[i]=0;ppy[i]=0;}
 sumclick=0;
  }
  else
  ShowMessage("Musis kliknut niekolko vrcholov");
}
//---------------------------------------------------------------------------


