function [u]=mf(in);

w=in(1);
yi=in(2);
di=in(3);
Umin=-5;
Umax=5;
l=0;
T=0.03;
k=1;

p=2*(yi-w)+T*(1+l)/(1-l)*di;
if (p<0)
  Uj=k*Umin-9.81*sin(yi);
else
  Uj=k*Umax-9.81*sin(yi);
end;
if (p/(Uj*T^2)>2*l/(1-l)^2)
  N=fix((1-3*l)/(2*(1-l))+sqrt((1-6*l+l^2)/(4*(1-l)^2)+p/(Uj*T^2)));
else 
 N=1;
end;
r0=-(1-l)^2/(T^2*(1+(N-1)*(1-l)));
r1=-(1-l)*(3+l+2*(N-1)*(1-l))/(2*T*(1+(N-1)*(1-l)));
rc=-(1-l)*((N-1)*(1+l)+(N-1)^2*(1-l))*Uj/(2*(1+(N-1)*(1-l)))
u=r0*(yi-w)+r1*di+rc;
if (((p<0) & (u<Uj)) | ((p>=0) & (u>Uj)))
  u=Uj;
end;
u=(u+9.81*sin(yi))/k;
