% *****************************
% programek na 6te cviko
% *****************************

T(1)=1;
T(2)=3;
t1(1)=2; t1(2)=2; t1(3)=4;
t2(1)=4; t2(2)=4; t2(3)=2;
a=1;
K=1;
b=[1; 0; 0];
cT=[0 0 1];

% ************
% vypocet a simulacia
% ************

for i=1:3
for j=1:2
	Tv=T(j);	
	T1=t1(i);
	T2=t2(i);
	A=[-a 0 0; 1/T1 -1/T1 0; 0 1/T2 -1/T2];
	[Ad,bd]=c2d(A,b,Tv);
	Adi=inv(Ad);
	Q=[cT; cT*Adi; cT*Adi*Adi];
	R1=[0; cT*Adi*bd; cT*Adi*Adi*bd];
	R2=[0; 0; cT*Adi*bd];
	aM=inv(Q)*R1;	% matica alfa
	bM=inv(Q)*R2;	% matica beta
	
	Qi=inv(Q);

	% **************
	% parametre sustavy
	% **************


	% **************
	% parametre regulatora
	% **************
	if (i==1)
		Da=exp(-a*Tv);
      Kr=1/K*a*Da/(1-Da*a);
      q1=Qi(1,1);
      q2=Qi(1,2);
      q3=Qi(1,3);
      a1=aM(1);
      b1=bM(1);
     
	end
   if (i==2 | i==3)
      q1=Qi(2,1);
      q2=Qi(2,2);
      q3=Qi(2,3);
   	a1=aM(2);
      b1=bM(2);
   
      pom=conv([1 a],[T1 1]);
		[num,den]=c2dm(K,pom,Tv,'zoh');
		odm=sqrt((den(2)*num(2)-2*num(3))^2-num(2)^2*(den(2)^2-4*den(3)));
		c=2*num(3)-den(2)*num(2)-odm;
		m=num(2)^2*K;
		
		Kr=c/m;
	end
	
	sim('mlp1',30);
   if (j==1) 
      figure;
      subplot(2,1,1);
      plot(t,y);
   end
   if( j==2 )
      subplot(2,1,2);
      plot(t,y);
   end
end
end