function [K,T1]=prony1(m,t,y,T)
%Pronyho metoda pre aproximaciu monotonych
%prechodovych charakteristik I1T1-clenom

B=(y(2)-2*y(3)+y(4));
C=(y(1)-2*y(2)+y(3));
M=min(m,length(y)-3);
for i = 2:M,
  B=[B;(y(i+1)-2*y(i+2)+y(i+3))];
  C=[C;(y(i)-2*y(i+1)+y(i+2))];
end
D=nnls(C,B);
T1=-T/log(D);

N=min(m,length(y)-1);
A=T+T1*(D-1);
for i = 2:N,
   A=[A;i*T+T1*(D^i-1)];
end
K=nnls(A,y(2:N+1));
