function [K,T1]=prony2(m,t,y,T)
%Pronyho metoda pre aproximaciu monotonych
%prechodovych charakteristik I2T1-clenom

B=(y(2)-3*y(3)+3*y(4)-y(5));
C=(y(1)-3*y(2)+3*y(3)-y(4));
M=min(m,length(y)-3);
for i = 2:M,
  B=[B;(y(i+1)-3*y(i+2)+3*y(i+3)-y(i+4))];
  C=[C;(y(i)-3*y(i+1)+3*y(i+2)-y(i+3))];
end
D=nnls(C,B);
T1=-T/log(D);

N=min(m,length(y)-1);
A=T*(T/2-T1)+T1^2*(1-D);
for i = 2:N,
   A=[A;i*T*(i*T/2-T1)+T1^2*(1-D^i)];
end
K=nnls(A,y(2:N+1));
