function [u]=regulator(in)

% konstanty
U1=-1;
U2=1.8;
I=eye(2);
T0=0.02;
%T=50*T0;
T=1;
lambda1=0; lambda2=0;
Ks=1;
A=[ 1 T; 0 1];
b=[ T^2/2 T]';

% vstupy
y=in(1);
dy=in(2);
w=in(3);
y=y-w;


Xk=[y dy]';

% vyber Uj
if y<0 
   Uj=U1;
else
   Uj=U2;
end;

v=-inv(A-lambda1*I)*b;
X0j=v*Uj;
% algoritmus
t1=(X0j(2)-Ks*Uj*T^2/2+sqrt((Ks*Uj*T^2/2-X0j(2))^2-2*Ks*Uj*(X0j(1)-Xk(1)-T/2*(X0j(2)-Xk(2)))))/(Ks*Uj);
t2=(X0j(2)-Ks*Uj*T^2/2-sqrt((Ks*Uj*T^2/2-X0j(2))^2-2*Ks*Uj*(X0j(1)-Xk(1)-T/2*(X0j(2)-Xk(2)))))/(Ks*Uj);

if t1>0
   i=fix(t1);
elseif t2>0
   i=fix(t2);
else
   i=-1;
end;

X0k=A*Xk;
t1=(X0j(2)-Ks*Uj*T^2/2+sqrt((Ks*Uj*T^2/2-X0j(2))^2-2*Ks*Uj*(X0j(1)-X0k(1)-T/2*(X0j(2)-X0k(2)))))/(Ks*Uj);
t2=(X0j(2)-Ks*Uj*T^2/2-sqrt((Ks*Uj*T^2/2-X0j(2))^2-2*Ks*Uj*(X0j(1)-X0k(1)-T/2*(X0j(2)-X0k(2)))))/(Ks*Uj);

if t1>0
   j=fix(t1);
elseif t2>0
   j=fix(t2);
else
   j=-1;

end;

%[i j]
XN=[];
vi=[];

if i>0
   %regulator pre obmedzenie
   v1=(1-lambda1)*v;
   XN=[XN X0j];
   vi=[vi v1];
   
   for q=1:i+1
      %toto jw az od dva; jedna je naplnen predtym
      xpom=inv(A)^(q-1)*XN(:,1)+[-(q-1)*b(1); -(q-1)*b(2)]*Uj;
      XN=[XN xpom];
   end;
   
   for q=1:i+1
      %vpom=XN(:,i+1)-XN(:,i);
      vpom=inv(A)^(q)*v1;
      vi=[vi vpom];
   end;
   
   Q=[-b vi(:,i+1)];
   
   dk=[1 0]*inv(Q)*(Xk-XN(:,i));
   
   if j>0
      %dk1=[1 0]*inv(Q)*(A*Xk-XN(:,j-1));    
       dk1=[1 0]*inv(Q)*(A*Xk-XN(:,i));    

   else
      dk1=[1 0]*inv(Q)*(A*Xk-X0j);    

   end
   
   %akcny zasah
   u=dk1-lambda2*dk;
else
   	%linearny regulator
   u=-(1-lambda1)*(1-lambda2)*y/T^2-(3-lambda1-lambda2-lambda1*lambda2)*dy/(2*T);
end;   
