// === bita.h ===

#ifndef __BITA
#define __BITA

#include <stdio.h>
#include "types.h"

const uint BUF_SZ=40000;

typedef struct {
  char *buf;
  FILE *file;
  ulong pos;
  ulong full;
} bita;

bita *bitar_create(char fn[]);
BOOLEAN bita_read(bita *ba,uchar count,uint *val);
void bitar_drop(bita *ba);
bita *bitaw_create(char fn[]);
BOOLEAN bita_write(bita *ba,uchar count,uint val);
void bitaw_drop(bita *ba);

#endif