#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <complex.h>
#include <dos.h>
#include <ctype.h>

/* funkcia k funkcii norma() na vypocet suctu druhych mocnin premennych */
vypocet_norma(int i,int pocet_prem, FILE *subor_citaj_nm, float *premenna, float *mocnina )
{ for (i=0; i<pocet_prem; i++)      /* nacita premenne zo suboru, pole */
		  fscanf(subor_citaj_nm, "%f", &premenna[i]);
  for (i=0; i<pocet_prem; i++)      /* vypocita sucet ich druhych mocnin */
		  mocnina[i]= mocnina[i-1] + (premenna[i] * premenna[i]);
  return(mocnina[(pocet_prem) - 1]);
}

/* funkcia k funkcii text() na prepis malych pismen na velke */
void prepis_text(int pocet_pismen, int *citaj_text, FILE *subor_citaj_tx, FILE *subor_pis_tx)
{ int i;   i=0;               /* nacitaju sa vsetky znaky */
  while ((citaj_text[i] = getc(subor_citaj_tx)) != EOF ) i++;
	pocet_pismen=i;
  for (i=0; i< pocet_pismen; i++) {    /* prepise male pismena na velke */
/*	  if ((citaj_text[i] >= 'a') && (citaj_text[i] <= 'z'))
	  citaj_text[i] = citaj_text[i] - 32 ;    prepise male na velke */
	  putc (toupper(citaj_text[i]), subor_pis_tx );                  }
}

norma()
{ int i, pocet_prem ;
  FILE *subor_citaj_nm, *subor_pis_nm;
  char nazov_suboru_nm[255];
  float *premenna, *mocnina;

  clrscr();        /* zadate nazov suboru, s ktorym chcete pracovat */
  printf("\nVypocet normy vektora.");
  printf("\nZadajte nazov suboru, s ktorym chcete pracovat.");
  printf("\n\nnazov: ");
  scanf("%s", &nazov_suboru_nm);

  if ((subor_citaj_nm = fopen(nazov_suboru_nm, "r")) == NULL )   /* otvorenie suboru na citanie */
	  { printf("\nSubor %s sa nepodarilo otvorit !!!\n", nazov_suboru_nm);
	printf("Operacia bola neuspesna, program bude ukonceni");
	return(0);  }

  /* testuje, ci sa prvy udaj rovna nejakemu cislu a nie znaku */
  while ((pocet_prem = getc(subor_citaj_nm)) != '\n' ) {
	if ((pocet_prem < '0' ) || (pocet_prem > '9') )
	   { printf("\nNepodarilo sa citat zo suboru '%s', program bude ukonceny !!!", nazov_suboru_nm);
	 printf("\nPocet premennych musi byt cislo !!!");
	 return(0); }                }

  /* nacita zo suboru, kolko je premennych */
  fclose(subor_citaj_nm); subor_citaj_nm = fopen(nazov_suboru_nm, "r");
  fscanf(subor_citaj_nm, "%d", &pocet_prem);

  if ((premenna=(float*)malloc(pocet_prem*sizeof(float))) == NULL )
	 { printf("\n Malo pamati, program bude ukonceny"); return(0); }
  if ((mocnina=(float*)malloc(pocet_prem*sizeof(float))) == NULL )
	 { printf("\n Malo pamati, program bude ukonceny"); return(0); }
  vypocet_norma(i,pocet_prem,subor_citaj_nm,premenna,mocnina );

  if ((subor_pis_nm = fopen("NEWTEXT.NMB" , "w")) == NULL )  /* otvorenie suboru pre zapis */
	 { printf("\nSubor NEWTEXT.NMB sa nepodarilo otvorit !!!\n");
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);  }

  /* Zapis vysledku do suboru */
  fprintf(subor_pis_nm, "%f" , sqrt(mocnina[(pocet_prem) - 1]));

  if (fclose(subor_citaj_nm) == EOF)    /* uzavretie subora na citanie */
	 { printf("Subor '%s' sa nepodarilo uzavriet !!!\n", nazov_suboru_nm);
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);}
  if (fclose(subor_pis_nm) == EOF)      /* uzavretie subora na pisanie */
	 { printf("Subor NEWTEXT.NMB sa nepodarilo uzavriet !!!\n");
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);}

  printf("\nOperacia bola uspesne ukoncena, vysledny zapis v subore NEWTEXT.NMB");
}

text()
{ int  *citaj_text,citaj_text_dlzka, pocet_pismen, i;
  FILE *subor_citaj_tx, *subor_pis_tx;
  char nazov_suboru_tx[255];

  clrscr();
  printf("\nPrepisanie malych pismen v texte na velke.");
  printf("\nZadajte nazov suboru, s ktorym chcete pracovat.");
  printf("\n\nnazov: ");
  scanf("%s", &nazov_suboru_tx);

  if ((subor_citaj_tx = fopen(nazov_suboru_tx, "r")) == NULL )  /* otvorenie suboru na citanie */
	 { printf("\nSubor '%s' sa nepodarilo otvorit !!!\n", nazov_suboru_tx);
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);}

  if ((subor_pis_tx = fopen("NEWTEXT.LTT" , "w")) == NULL )  /* otvorenie suboru pre zapis */
	 { printf("\nSubor NEWTEXT.LTT sa nepodarilo otvorit !!!\n");
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);  }

  /* cita zo suboru TEXT.LTT a zapisuje same velke pismena do NEWTEXT.LTT */
  /* ak to je male pismeno, zapise ho ako velke (preto -32) */

  while ((citaj_text_dlzka = getc(subor_citaj_tx)) != EOF ) i++;
	pocet_pismen=i;
  fclose(subor_citaj_tx); subor_citaj_tx = fopen(nazov_suboru_tx, "r");

  if ((citaj_text=(int*)malloc(pocet_pismen*sizeof(int))) == NULL)
	 { printf("\n Malo pamati, program bude ukonceny"); return(0); }

  prepis_text(pocet_pismen, citaj_text, subor_citaj_tx, subor_pis_tx);

  if (fclose(subor_citaj_tx) == EOF)    /* uzavretie subora na citanie */
	 { printf("Subor '%s' sa nepodarilo uzavriet !!!\n", nazov_suboru_tx);
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);}
  if (fclose(subor_pis_tx) == EOF)      /* uzavretie subora na pisanie */
	 { printf("Subor NEWTEXT.LTT sa nepodarilo uzavriet !!!\n");
	   printf("Operacia bola neuspesna, program bude ukonceni");
	   return(0);}

  printf("\nOperacia bola uspesne ukoncena, vysledny zapis v subore NEWTEXT.LTT");
}

main()                 /* ***** HLAVNY PROGRAM ******* */
{ int odpoved;

  clrscr();                  /* ponuka, z ktorej si mozete vybrat */
  printf("\n Ponuka: 1 - Prepis malych pismen na velke");
  printf("\n         2 - Vypocet normy vektora");
  printf("\n         3 - Koniec\n"); printf("\n Vasa volba: ");
	do {   odpoved=getch();    /* musite si vybrat jednu z moznosti */
	} while ((odpoved !='1') && (odpoved !='2') && (odpoved !='3'));
  putchar(odpoved);     delay(300);

  switch (odpoved) {   /* Podla toho, co si zvolite */
	case '1': text();break;
	case '2': norma();break;
	case '3': printf("\n *** Szabolcs Puskas ***"); break; }
  delay(2000);
}