#include<stdio.h>
#include<string.h>
#include<conio.h>
#include <graphics.h>
#include <stdlib.h>
#include <math.h>


typedef struct {
  char name[10];
  char cars[10];
  char color[10];
  float tel; } FUNCTION;

  //Prototypy funkcii
int  delete_p (FUNCTION pole[],int n);   //Vymazanie polozky
int  add (FUNCTION pole[],int n);        //Pridanie polozky

void write_table(FUNCTION pole[],int n);   //Vypis na obrazovku
void write_menu(void);                  //Vypis menu na obrazovku

void sort1(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j);   //Usporiadanie
void sort2(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j);   //Usporiadanie
void sort3(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j);   //usporiadanie

void change_name(FUNCTION pole[],int n);     //Vymenit meno niektorej polozky
void change_cars(FUNCTION pole[],int n);     //Vymenit auto niektorej polozky
void change_tel(FUNCTION pole[],int n);   //Vymenit tel.cislo niektorej polozky
void change_color(FUNCTION pole[],int n); //vymenit farbu niektorej polozky

void save_b (FUNCTION pole[],FILE *fb, int n);   //Zapis do binarneho suboru
void save_t (FUNCTION pole[],FILE *fw, int n);   //Zapis do textoveho suboru
int  load_t (FUNCTION pole[],FILE *fr);          //Nacitanie zo vstupneho suboru

/* VSTUPNY SUBOR:   'vstup.txt'
   VYSTUPNE SUBORY: 'binary.dat, vystup.txt   */

void main(void) {

  int n, i=0, j=0;
  char c,ch;
  FILE *fr,*fw,*fb;
  FUNCTION pole[10], p_pole;

//predobrazovka
  clrscr();
  int gd,gm,chyba;
	int xcenter, ycenter;
		gd=DETECT;
		initgraph(&gd,&gm,"j:\\tc\\bgi");
			chyba=graphresult();
			if (chyba){
			clrscr();
			setcolor(BLUE);
			cprintf("graficka chyba :%s",grapherrormsg(chyba));
		exit(1);
}
			rectangle(0,0,getmaxx(),getmaxy());
			setcolor(getmaxcolor());
			 xcenter = getmaxx() / 2;
			ycenter = getmaxy() / 2;
	   setfillstyle(LINE_FILL,BLUE);
		  fillellipse(xcenter,ycenter,100,100);
		 setfillstyle(SOLID_FILL,RED);
		 fillellipse(xcenter,ycenter,100,50);
		settextjustify(CENTER_TEXT,CENTER_TEXT);
		settextstyle(GOTHIC_FONT,HORIZ_DIR,5);
		outtextxy(getmaxx() /2,getmaxy() /2, "RENT A CAR");
			settextjustify(LEFT_TEXT,TOP_TEXT);
			settextstyle(TRIPLEX_FONT,HORIZ_DIR,2);
			outtextxy(getmaxx() /10,getmaxy() /10,"ARPAD JAKAB ");
			settextjustify(LEFT_TEXT,TOP_TEXT);
	settextstyle(TRIPLEX_FONT,HORIZ_DIR,1.3);
	outtextxy(getmaxx() /10,getmaxy() /7," KRUZOK C24 ");
			settextjustify(RIGHT_TEXT,BOTTOM_TEXT);
			settextstyle(SANS_SERIF_FONT,HORIZ_DIR,1.15);
	outtextxy(getmaxx() /1.3,getmaxy() /1.1," All Right Reserved By WINSHIT 98 ");
	getch();
closegraph();
clrscr();
  if ((fr=fopen("vstup.txt","r")) == NULL) {
	printf("Do not open input file data.in!\n\a");
	return;
  }
  n=load_t(pole,fr);
  write_menu();


  while ((c=getch()) != 'q') {
	switch (c) {

	  case 'n':
		if ((fr=fopen("vstup.txt","r")) == NULL) {
		  printf("Do not open file ascii.in!\n\a");
		  return;
		}
		n=load_t(pole,fr);
		break;

	  case 'o':
		if ((fw=fopen("vystup.txt", "w")) == NULL) {
		  printf("Do not open file ascii.out!\n\a");
		  return;
		}
		save_t(pole,fw,n);
		break;

	  case 'b':
		if ((fb=fopen("binary.dat","wb")) == NULL) {
		  printf("Do not open file binary.out!\n\a");
		  return;
		}
		save_b(pole,fb, n);
		break;



	  case 'w': write_table (pole, n); getch();     break;
	  case 's': printf("Usporiadat podla: abecedy(1) auta(2) farby(3)?");
			ch = getch();
			switch (ch) {
			  case '1': sort1(pole,&p_pole,n,i,j); break;
			  case '2': sort2(pole,&p_pole,n,i,j); break;
			  case '3': sort3(pole,&p_pole,n,i,j); break;
			}

			break;
	  case 'm': change_name (pole,n);               break;
	  case 'c': change_cars (pole,n);               break;
	  case 'r': change_color(pole,n);	        	break;
	  case 't': change_tel (pole,n);                break;
	  case 'a': n=add (pole,n);                     break;
	  case 'd': n=delete_p (pole,n);                break;

	}

	write_menu();
  }
  clrscr();
  gd=DETECT;
		initgraph(&gd,&gm,"j:\\tc\\bgi");
			rectangle(0,0,getmaxx(),getmaxy());
			  int midx, midy;
			int radius = 10;
			midx = getmaxx() / 2;
			midy = getmaxy() / 2;
			setcolor(getmaxcolor());
		for(int qwe=0;qwe<100;qwe+=5){
			circle(midx, midy, (radius+qwe)); }
				for(int asd=0;asd<100;asd+=8){
					circle(midx+asd, midy+(asd-2), (radius+asd)); }
				   setlinestyle(DOTTED_LINE,NORM_WIDTH,1);
			   for(int wer=0;wer<100;wer+=6){
				 rectangle(0+wer*2, 0+wer*2, 10+wer,10+wer);}
				for(int zxc=0;zxc<100;zxc+=7){
					circle(midx-(zxc*2.3), midy+(zxc-2), (radius+zxc)); }
					settextjustify(CENTER_TEXT,LEFT_TEXT);
					settextstyle(GOTHIC_FONT,HORIZ_DIR,5);
					outtextxy(getmaxx() /2,getmaxy() /3, "GAME OVER");

  getch();
  fcloseall();

}

/*#########################################################################*/
//                      vypis na obrazovku

void write_table(FUNCTION pole[], int n) {

  int i;
  printf("\n");
  printf("\t\t\t\tMEMBERS:\n");
  printf("\n");
  printf("C\tNAME\t\tCAR\t\tCOLOR\t\tTEL.NUMBER\n");
  printf("\n");
  for (i=0;i < n;i++) {
	printf("%d.\t",i+1);
	printf("%s\t\t",pole[i].name);
	printf("%s\t\t",pole[i].cars);
	printf("%s\t",pole[i].color);
	printf("\t  %.0f\n",pole[i].tel);
  }
  printf("\n");

}

/*#########################################################################*/
//                     Vypis menu na obrazovku

void write_menu(void) {
  clrscr();
  printf("ͻ\n");
  printf("Add new entry                                  (a) \n");
  printf("Delete entry                                   (d) \n");
  printf("ĺ\n");
  printf("Change name                                    (m) \n");
  printf("Change car                                     (c) \n");
  printf("Change color                                   (r) \n");
  printf("Change tel.number                              (t) \n");
  printf("ĺ\n");
  printf("Sort                                           (s) \n");
  printf("ĺ\n");
  printf("Save to   BINARY file                          (b) \n");
  printf("Save to   ASCII file                           (o) \n");
  printf("Load from ASCII file                           (n) \n");
  printf("ĺ\n");
  printf("Show on screen                                 (w) \n");
  printf("QUIT                                           (q) \n");
  printf("ͼ\n");
}

/*#########################################################################*/
//                  funkcia nacita udaje zo vstupneho suboru

int load_t(FUNCTION pole[],FILE *fr) {
  int i=0; float x;

  do {
	fscanf(fr, "%s", pole[i].name);
	fscanf(fr, "%s", pole[i].cars);
	fscanf(fr, "%s", pole[i].color);
	fscanf(fr, "%f", &x);
	pole[i].tel=x;
	i++;
  } while (!feof(fr));

  return i;
}

/*#########################################################################*/
//               Usporiada prvkov podla abecedy

void sort1(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j) {   /*Definicia funkcie usporiadat podla mena*/
	 int d,a,b;
	 d=((a=strlen(pole[i].name)) > (b=strlen(pole[i+1].name))) ? a : b;
	 if (j == d) return;
	 if (n == 1) return;
	 else {
	   for ( ;i < (n-1);i++) {
		 if ((pole[i].name)[j] > (pole[i+1].name)[j])  {
			   p_pole[0]=pole[i+1];
			   pole[i+1]=pole[i];
			   pole[i]=p_pole[0];
		 }
		 if ((pole[i].name)[j] == (pole[i+1].name)[j])
		   sort1(pole,p_pole,n,i,j+1);
	   }
	 i=j=0;
	 sort1(pole,p_pole,n-1,i,j);
	 }
}

/*#########################################################################*/
//               usporiada prvkov :BY CARS

void sort2(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j) {   /*Definicia funkcie usporiadat podla kruzkov*/
	  int d,a,b;
	  d=((a=strlen(pole[i].cars)) > (b=strlen(pole[i+1].cars))) ? a : b;
	  if (j == d) return;
	  if (n == 1) return;
	  else {
		for ( ;i < (n-1);i++) {
		  if ((pole[i].cars)[j] > (pole[i+1].cars)[j])  {
			 p_pole[0]=pole[i+1];
				 pole[i+1]=pole[i];
				 pole[i]=p_pole[0];
		  }
		  if ((pole[i].cars)[j] == (pole[i+1].cars)[j])
			 sort2(pole,p_pole,n,i,j+1);
		  }
		  i=0; j=0;
		  sort2(pole,p_pole,n-1,i,j);
		}
}
/*#########################################################################*/
//                   usporiadanie :BY  COLOR


void sort3(FUNCTION pole[],FUNCTION p_pole[],int n,int i,int j){
	 int d,a,b;
	 d=((a=strlen(pole[i].color)) > (b=strlen(pole[i].color))) ? a : b;
	 if (j == d) return;
	 if (n == 1) return;
	 else {
		for ( ;i < (n-1);i++) {
		   if ((pole[i].color)[j] > (pole[i+1].color)[j])  {
			   p_pole[0]=pole[i+1];
				 pole[i+1]=pole[i];
				 pole[i]=p_pole[0];
		  }
		  if ((pole[i].color)[j] == (pole[i+1].color)[j])
			   sort3(pole,p_pole,n,i,j+1);
		  }
		  i=0; j=0;
		  sort3(pole,p_pole,n-1,i,j);
		}
}
/*#########################################################################*/
//                funkca zapise vysledok do vystupneho suboru

void save_t(FUNCTION pole[],FILE *fw,int n) {   /*Definicia funkcie zapis do vystup.txt*/

  int i;
  fprintf(fw, "/*******************************\n\t**ZADANIE:3**");
  fprintf(fw, "\n");
  fprintf(fw, "C\tName\t\tCars\t\tColor\t\tTel.number\n");
  fprintf(fw, "\n");
  for (i=0;i < n;i++) {
  long qwe;
	fprintf(fw, "%d.\t",i+1);
	fprintf(fw, "%s\t\t",pole[i].name);
	fprintf(fw, "%s\t\t",pole[i].cars);
	fprintf(fw, "%s\t\t",pole[i].color);
	qwe=pole[i].tel;
	fprintf(fw, "%ld\n",qwe);
  }
  fprintf(fw, "\n");

}

/*#########################################################################*/
//                zmena meno hociktorej polozky :CHANGE NAMES

void change_name(FUNCTION pole[],int n) {   /*Funkcia umoznuje zmenit meno hociktorej polozky*/


 int d,x;
 printf("\nZmenit meno ktorej polozky v poradi?");
 scanf("%d",&d); getchar();
 if (d > n) {
   printf("Polozka cislo %d neexistuje!\n\a",d);
   getchar();
   return;
 }
 else {
   printf("Zadaj nove meno polozky cislo %d :",d);
   scanf("%s", &pole[d-1].name);
   getchar();
 }
 return;
}

/*#########################################################################*/
//                zmena :CHANGE CARS

void change_cars(FUNCTION pole[],int n) {

 int d,x;
 printf("\nZmenit auto ktorej polozky v poradi?");
 scanf("%d",&d);
 getchar();
 if (d > n) {
		printf("Polozka cislo %d neexistuje!\n\a",d);
		getchar();
		return;
 }
 else {
		printf("Zadaj nove auto polozky cislo %d :",d);
		fgets((pole[d-1]).cars,10,stdin);
		x=strlen((pole[d-1]).cars);
		((pole[d-1]).cars)[x-1]='\0';
 }
  return;
}
/*#########################################################################*/
//zmenit farbu hociktorej polozky
void change_color(FUNCTION pole[],int n){
	 int x,d;
	 printf("\nZmenit farbu ktorej polozky v poradi?");
	 scanf("%d",&d);
	 getchar();
	 if (d > n) {
		  printf("Polozka cislo %d neexistuje!\n\a",d);
		  getchar();
		  return;
		  }
  else {
		  printf("Zadaj novu farbu polozky cislo %d  :",d);
		  fgets((pole[d-1]).color,10,stdin);
		  x=strlen((pole[d-1]).color);
		  ((pole[d-1]).color)[x-1]='\0';
  }
  return;
}


/*#########################################################################*/
//               zmeni tel.cislo hociktorej polozky :CHANGE TEL.CISLO

void change_tel(FUNCTION pole[],int n) {


 int d,x;
 printf("\nZmenit tel.cislo ktorej polozky v poradi?");
 scanf("%d",&d);
 getchar();
 if (d > n) {
		printf("Polozka cislo %d neexistuje!\n\a",d);
		getchar();
		return;
 }
 else {
		printf("Zadaj novy tel.cislo polozky cislo %d :",d);
		scanf("%f",&((pole[d-1]).tel));
		getchar();
 }
 return;
}

/*#########################################################################*/
//                Funkcia umoznuje pridat novu polozku

int add (FUNCTION pole[],int n) {    /*Funkcia umoznuje pridat novu polozku*/


 int x;

 printf("\nZadaj meno novej polozky :");
 fgets((pole[n]).name,10,stdin);
 x=strlen((pole[n]).name);
 ((pole[n]).name)[x-1]='\0';
 printf("Zadaj auto novej polozky :");
 fgets((pole[n]).cars,10,stdin);
 x=strlen((pole[n]).cars);
 ((pole[n]).cars)[x-1]='\0';
 printf("zadaj farbu novej polozky  :");
 fgets((pole[n]).color,10,stdin);
 x=strlen((pole[n]).color);
 ((pole[n]).color)[x-1]='\0';
 printf("Zadaj tel.cislo novej polozky :");
 scanf("%f",&((pole[n]).tel));
 getchar();
 n++;
 return(n);
}

/*#########################################################################*/
//                Funkcia umoznuje odobrat polozku

int delete_p(FUNCTION pole[],int n) {


 int d;
 printf("\nZadaj cislo polozky, ktoru chces vymazat :");
 scanf("%d",&d); getchar();
 if (d > n) {
		printf("Polozka cislo %d neexistuje!\n\a",d);
		return(n);
 }
 else {
		pole[d-1]=pole[n-1];
 }
 n--;
 return(n);
}

/*#########################################################################*/
//                zapis do binarneho suboru

void save_b(FUNCTION pole[],FILE *fb, int n) {   /*Definicia funkcie zapis do binary.dat*/
  fwrite(pole,sizeof(FUNCTION), n, fb);
}
