/***********************************
**ZADANIE: 2                      **
**SUBOR:   zadani31.cpp           **
**JAZYK:   Borland C 3.1          **
**AUTOR:   Antal Miroslav ,A5 **
***********************************/

/*Tento program ma za ulohu vytvorit a spravovat evidenciu liekov v lekarni

VST    : vstup subor,chary[80] retazec,pcisla smernik na alokovane pole cisel,ch,i,j,zosuboru pomocne premenne
VST P. : vstup subor musi byt spravne naformatovany, zadane cisla musia byt cele
VYST   : vystup subor, j pocet cisel, pcisla, i pocet velkych pismen
VYST P.: */



#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#define MAXN 50

typedef struct {
  char meno[20];
  long evcislo;
  char comment[50];
} liek;


int readvalues(liek []);
int findvalue(liek [], int, char *, FILE *, FILE *);
int changevalue(liek [], int, char *, FILE *, FILE *);
int deletevalue(liek [], int, char *, FILE *, FILE *);
int addvalue(liek [], int, FILE *, FILE *);
int rangevalues(liek [], int, FILE *, FILE *);

main()
{
  FILE *vyst_txt;
  FILE *vyst_bin;

  char ch, zosuboru;
  int count;
  int i,j;
//  pdrogs[MAXN];
  liek *pdrogs;
  char *pname;

  vyst_txt = fopen("vyst_txt.txt", "wt");
  vyst_bin = fopen("vyst_bin.bin", "wb");

  pdrogs = (liek *)malloc(50*(sizeof(liek)));
  count = readvalues(pdrogs);
  fprintf(vyst_txt,"MENO : Bertusek Rastislav\nKRUZOK: A5\nZADANIE: 3\n\n\n");


  for(;;)
  {
	clrscr();
	printf("Mate nasledujuce moznosti volby:\n(a)  zmena zadanych hodnot o lieku\n(b)  usporiadanie liekov podla mena\n(c)  vyhladanie lieku podla jeho mena.\n(d)  vymazanie lieku z evidencie\n(e)  pridanie lieku do evidencie\n(f)  zapis evidencie do binarneho suboru\n(g)  zapis evidencie do textoveho suboru: ");
	ch = getchar();
	switch (ch)
	{
	  case 'a':
		   printf("\n\n\nZadajte meno lieku, ktoreho hodnotu chcete zmenit: ");
		   scanf("%s", pname);
		   changevalue(pdrogs, count, pname, vyst_txt, vyst_bin);
		   break;
	  case 'b':
		   rangevalues(pdrogs, count, vyst_txt, vyst_bin);
		   break;
	  case 'c':
		   printf("\n\n\nZadajte meno lieku, ktory chcete najst: ");
		   scanf("%s", pname);
		   findvalue(pdrogs, count, pname, vyst_txt, vyst_bin);
		   break;
	  case 'd':
		   printf("\n\n\nZadajte meno lieku, ktory chcete vymazat: ");
		   scanf("%s", pname);
		   count = deletevalue(pdrogs, count, pname, vyst_txt, vyst_bin);
		   break;
	  case 'e':
		   count = addvalue(pdrogs, count, vyst_txt, vyst_bin);
		   break;
	  case 'f':
		   fwrite(pdrogs,sizeof(liek),count,vyst_bin);
		   printf("\n\n\nVsetky polozky boli uspesne zapisane do binarneho suboru.");
		   getchar();
		   getchar();
		   break;
	  case 'g':
		   for (i=0; i < count; i++) fprintf(vyst_txt,"\nPolozka c.%d je s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
		   printf("\n\n\nVsetky polozky boli uspesne zapisane do textoveho suboru.");
		   getchar();
		   getchar();
		   break;
	  default: exit(0);
	}
  }
  fclose(vyst_txt);
  fclose(vyst_bin);
}


/* Funkcia, ktora nacita lieky do evidencie zo vstupneho suboru*/
int readvalues(liek pdrogs[])
{
  FILE *vst_txt;
  int i,j,k;
  vst_txt = fopen("lieky.txt", "rt");
  i = 0;
  while(!feof(vst_txt))
  {	fscanf(vst_txt,"%s",pdrogs[i].meno);
	fscanf(vst_txt,"%s",pdrogs[i].comment);
	fscanf(vst_txt,"%ld",&pdrogs[i].evcislo);
	i++;
  }
  fclose(vst_txt);
  return(i);
}


/* Funkcia, ktora spocita pocet velkych pismen v retazci ret*/
int deletevalue(liek pdrogs[], int count, char *name, FILE *vyst_txt, FILE *vyst_bin)
{
int i,j,finded;
  finded = 0;
  for (i = 0; i < count; i++)
    if (strncmp(pdrogs[i].meno, name, strlen(name)) == 0)
    {
      finded = 1;
      printf("\nBola vymazana polozka c.%d s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
      fprintf(vyst_txt,"\n\n\nBola vymazana polozka c.%d s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
      strcpy(pdrogs[i].meno, pdrogs[count - 1].meno);
      strcpy(pdrogs[i].comment, pdrogs[count - 1].comment);
	  pdrogs[i].evcislo = pdrogs[count - 1].evcislo;
      strcpy(pdrogs[count - 1].meno, "");
      strcpy(pdrogs[count - 1].comment, "");
      pdrogs[count - 1].evcislo = 0;
    }
  if (!finded) printf("\n\n\nNebola najdena ziadna polozka s menom '%s'.\n\n", name);
  getchar();
  getchar();
  return(--count);
}


/* Funkcia, ktora spocita pocet velkych pismen v retazci ret*/
int addvalue(liek pdrogs[], int count, FILE *vyst_txt, FILE *vyst_bin)
{
  printf("\n\n\nZadajte meno lieku c.%d           : ", count + 1);
  scanf("%s", pdrogs[count].meno);
  printf("Zadajte komentar lieku c.%d:      : ", count + 1);
  scanf("%s", pdrogs[count].comment);
  printf("Zadajte evidencne cislo lieku c.%d: ", count + 1);
  scanf("%ld", &pdrogs[count].evcislo);
  fprintf(vyst_txt,"\n\n\nBola pridana polozka c.%d s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n\n",count+1,pdrogs[count].meno,pdrogs[count].comment,pdrogs[count].evcislo);
  getchar();
  return(++count);
}


/* Funkcia, ktora spocita pocet velkych pismen v retazci ret*/
int findvalue(liek pdrogs[], int count, char *name, FILE *vyst_txt, FILE *vyst_bin)
{
int i,finded;
  finded = 0;
  for (i = 0; i < count; i++)
	if (strncmp(pdrogs[i].meno, name, strlen(name)) == 0)
	{
	  finded = 1;
	  printf("\nBola najdena polozka c.%d s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
	  fprintf(vyst_txt,"\n\n\nBola najdena polozka c.%d s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
	}
  if (!finded) printf("\n\n\nNebola najdena ziadna polozka s menom '%s'.\n\n", name);
  getchar();
  getchar();
  return(1);
}


/* Funkcia, ktora spocita pocet velkych pismen v retazci ret*/
int rangevalues(liek pdrogs[], int count, FILE *vyst_txt, FILE *vyst_bin)
{
int i,ranged;
long evcislotemp;
char menotemp[20],commenttemp[50];
  ranged = 0;
  while (!ranged)
  {
	ranged = 1;
	for (i = 0; i < count-1; i++)
	  if (strcmp(pdrogs[i].meno, pdrogs[i+1].meno) > 0)
	  {
	ranged = 0;
	strcpy(menotemp,pdrogs[i].meno);
	strcpy(commenttemp,pdrogs[i].comment);
	evcislotemp = pdrogs[i].evcislo;

	strcpy(pdrogs[i].meno,pdrogs[i+1].meno);
	strcpy(pdrogs[i].comment,pdrogs[i+1].comment);
	pdrogs[i].evcislo = pdrogs[i+1].evcislo;

	strcpy(pdrogs[i+1].meno,menotemp);
	strcpy(pdrogs[i+1].comment,commenttemp);
	pdrogs[i+1].evcislo = evcislotemp;

      }
  }
  printf("\n\n\nVsetky polozky boli uspesne zoradene.");

    for (i = 0; i < count; i++)
      fprintf(vyst_txt,"\nPolozka c.%d je s tymito hodnotami:\nmeno lieku      : %s\nkomentar        : %s\nevidencne cislo : %ld\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
  getchar();
  getchar();
  return(1);
}


/* Funkcia, ktora spocita pocet velkych pismen v retazci ret*/
int changevalue(liek pdrogs[], int count, char *name, FILE *vyst_txt, FILE *vyst_bin)
{
int i;
int finded;
char selected;
  finded = 0;
  for (i = 0; i < count; i++)
	if (strncmp(pdrogs[i].meno, name, strlen(name)) == 0)
	{
	  finded = 1;
	  printf("\nZadana polozka c.%d je s tymito hodnotami:\n(a)  meno lieku      : %s\n(b)  komentar        : %s\n(c)  evidencne cislo : %ld\n\n",i+1,pdrogs[i].meno,pdrogs[i].comment,pdrogs[i].evcislo);
	  printf("Co chcete zmenit? (Zadajte pismeno hodnoty, ktoru chcete zmenit.): ");
	  selected = getchar();
      selected = getchar();
      switch (selected)
      {
      case 'a' : printf("Zadajte nove meno hore uvedenej polozky: ");
		 scanf("%s", pdrogs[i].meno);
		 getchar();
		 break;
      case 'b' : printf("Zadajte novy komentar hore uvedenej polozky: ");
		 scanf("%s", pdrogs[i].comment);
		 getchar();
		 break;
      case 'c' : printf("Zadajte nove evidencne cislo hore uvedenej polozky: ");
		 scanf("%ld", pdrogs[i].evcislo);
		 getchar();
      default  : break;
      }
    }
  if (!finded)
  {
	printf("\n\n\nNebola najdena ziadna polozka s menom '%s'.\n\n", name);
    getchar();
    getchar();
  }

  return(1);
}