/************************************
*	Zadanie       : 3               *
*	Meno          : Peter           *
*	Priezvisko    : Bizik           *
*	Cislo kruzku  : C 27            *
*************************************/


/*
vstupy : z klavesnice, z text. suboru - not yet, z bin .suboru
vystupy : monitor, text. subor, bin. subor
uziv. funkcie : Otvor_subor, Tried_Data, VlozNovy, ZmazZaznam,
				Uloz_Data, Menu_1, Menu_2, Nacitaj_riadok
*/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

#define SAVEFILE	"pbzad3.bin"
//#define SAVEFILEX "Vstup.txt"
#define MAXNAZOV	51		// maximalna dlzka mena a priezviska
#define MAXZAZNAM	50		// max. pocet nacitatelnych struktur

struct TELZOZNAM
{
	char Meno[MAXNAZOV];
	char Priezvisko[MAXNAZOV];
	int Predvolba;
	int Cislo;
};
//void Vstup_zo_Suboru(struct TELZOZNAM zaznam[], int *poczaz, FILE *file);
void Otvor_subor(struct TELZOZNAM zaznam[], int *poczaz, FILE *file);
void Tried_Data(struct TELZOZNAM zaznam[], int poczaz);
void VlozNovy(struct TELZOZNAM zaznam[], int *poczaz);
void ZmazZaznam(struct TELZOZNAM zaznam[], int *poczaz);
void Uloz_Data(struct TELZOZNAM zaznam[], int poczaz, FILE *file);
int Menu_2(struct TELZOZNAM zaznam[], int poczaz);
int Menu_1(struct TELZOZNAM zaznam[], int *poczaz);
void Nacitaj_riadok(char riadok[], int dlzka);


int main()
{
	FILE *file;
	TELZOZNAM zaznam[MAXZAZNAM];	// pole struktur TELZOZNAM
	int poczaz;						// pocet v-zaznamov - kolko sa nacita zo vstupu
	// otvorim vstupny subor
	if( (file = fopen(SAVEFILE, "rb")) == NULL )	// ak sa nepodarilo otvorit
		poczaz = 0;
	else	// nacitam data z binarneho suboru
	{
		Otvor_subor(zaznam, &poczaz, file);
		fclose(file);
	}

	int fexit = 0;

	do
	{
		fexit = Menu_1(zaznam, &poczaz );

	}while(!fexit);

	file = fopen(SAVEFILE, "wb");		// vytvorim ho a otvorim
	Uloz_Data(zaznam, poczaz, file);
	fclose(file);

	clrscr();
	return 0;
}
//void Vstup_zo_Suboru(struct TELZOZNAM zaznam[], int *poczaz, FILE *filex);
// Naplnenie prvkov pola datami zo vstupneho textoveho suboru
/*{
	FILE *filex;
	filex = fopen("Vtup.txt","rt");

	int poc = 0;

	fread(&poc, sizeof(int), 1, filex);
	if( poc > MAXZAZNAM )	//test, aby neprepisala pamat
		poc = MAXZAZNAM;

		//teraz nacitam 'poc' zaznamov zo suboru jednym tahom:
	fread(zaznam, sizeof(TELZOZNAM), poc, filex);

		// zapamatam pocet nacitanych zaznamov
	*poczaz = poc;
}*/

void Otvor_subor(TELZOZNAM zaznam[], int *poczaz, FILE *file)
// Naplnenie prvkov pola datami zo vstupneho binarneho suboru                 */
{
	int poc = 0;

	fread(&poc, sizeof(int), 1, file);

	if( poc > MAXZAZNAM )	//test, aby neprepisala pamat
		poc = MAXZAZNAM;

		//teraz nacitam 'poc' zaznamov zo suboru jednym tahom:
	fread(zaznam, sizeof(TELZOZNAM), poc, file);

		// zapamatam pocet nacitanych zaznamov
	*poczaz = poc;
}

void Tried_Data(TELZOZNAM zaznam[], int poczaz)
// Usporiadanie prvkov podla retazcovych poloziek (bubble sort)
{
	int i, trflag = 1;
	TELZOZNAM zaz;

	for(--poczaz; poczaz > 0 && trflag; poczaz--)
	{
		trflag = 0;
		for(i = 0; i < poczaz; i++)
		{
			if( strcmp(zaznam[i].Priezvisko, zaznam[i + 1].Priezvisko) > 0 )
			{
				//vymena, prekopirovanie bloku pamati
				memcpy(&zaz, &zaznam[i], sizeof(TELZOZNAM));
				memcpy(&zaznam[i], &zaznam[i + 1], sizeof(TELZOZNAM));
				memcpy(&zaznam[i + 1], &zaz, sizeof(TELZOZNAM));

				trflag = 1;
			}
		}
	}
}

void VlozNovy(TELZOZNAM zaznam[], int *poczaz)
// Nacita nove data a ulozi ich do databazi                                   */
{
	int p = *poczaz;
	int x;

	clrscr();
	printf("\n\n\n\t\t\tVLOZENIE NOVEHO UCASTNIKA\n\n");

	if(p == MAXZAZNAM - 1)		// test ci uz nahodou nieje databaza plna
	{
		printf("\nDatabaza je uz plna, nemozno vkladat data !\n");
		getch();
		return;
	}

	printf("\n\tMeno: ");
		Nacitaj_riadok(zaznam[p].Meno, MAXNAZOV);
	printf("\n\tPriezvisko: ");
		Nacitaj_riadok(zaznam[p].Priezvisko, MAXNAZOV);
	printf("\n\tPredvolba : ");
		scanf("%d",&zaznam[p].Predvolba);
	printf("\tCislo : ");
		scanf("%d", &zaznam[p].Cislo);

	*poczaz = p + 1;
}

void ZmazZaznam(TELZOZNAM zaznam[], int *poczaz)
	/*
	Nacita meno ucastnika, prehlada pole zaznam[] a ak tam taky ucastnik je,
	skopiruje posledny zaznam v poli na jeho miesto a znizi pocet zaznamov
	*/
{
	int i, p = *poczaz;
	char ucastnik[MAXNAZOV];


	clrscr();
	printf("\n\n\n\t\t\tZMAZANIE UCASTNIKA\n\n");
	printf("\tMeno: ");
		scanf("%30s", ucastnik);

	for(i = 0; i < p; i++)
		if( !strcmp(zaznam[i].Meno, ucastnik) )		//ak sa rovnaju nazvy
			break;

	if(i == p )	//ak nenasial ucastnik s danym nazvom
	{
		printf("CHYBA: Ucastnik s nazvom %s sa v databaze nenachadza !\n", ucastnik);
		getch();
		return;
	}

	if(i != p - 1) 	//ak nieje to posledny zaznam v poli zaznam[]
		memcpy(&zaznam[i], &zaznam[p - 1], sizeof(TELZOZNAM));		//skopirujem rovno cely blok pamete

	*poczaz = p - 1;
}

void Uloz_Data(TELZOZNAM zaznam[], int poczaz, FILE *file)
/* ulozi pole zaznam (presnejsie len jeho zaplnenu cast) do bin. suboru      	*/
{
	fwrite(&poczaz, sizeof(int), 1, file);
	fwrite(zaznam, sizeof(TELZOZNAM), poczaz, file);
}

int Menu_2()
	/*
	Zobrazi a caka na uzivatelovu volbu. Vrati stlaceny znak.
	*/
{
	clrscr();
	printf("\n\n\n\t\t\tVYHLADANIE UCASTNIKA\n\n");
	printf("\t\tPodla Mena     N\n");
	printf("\t\tPodla Priezviska     Z\n");
	printf("\n\t\tNaspat do Hlavneho Menu   M\n\n\n");
	printf("\t\tTvoja volba: ");

	return toupper(getch());
}

int Menu_2(TELZOZNAM zaznam[], int poczaz)
	/*
	Podla toho,co stlacil uzivatel vykona funkciu
	vrati 	1, ak bol zvoleny odchod z programu
			0,ak nejaka z funkcii, alebo zly klaves
	*/
{
	clrscr();
	printf("\n\n\n\t\t\tVYHLADANIE UCASTNIKA\n\n");
	printf("\t\tPodla Mena                  N\n");
	printf("\t\tPodla Priezviska            Z\n");
	printf("\n\t\tNaspat do Hlavneho Menu   M\n\n\n");
	printf("\t\tTvoja volba: ");

	int key = toupper(getch());

	if(key == 'M')		//NASPAT DO H.M.
		return 1;

	clrscr();
	printf("\n\n\n\t\t\tVYHLADANIE UCASTNIKA");

	switch(key)
	{
		case 'N':		//podla mena
			{
			char meno[MAXNAZOV];

			printf("\n\n\n\t\tZadaj meno: ");
			scanf("%30s", meno);
			clrscr();
			for(int i = 0; i < poczaz; i++)
				if( strstr(zaznam[i].Meno, meno) != NULL )
					printf("%s\t%s\t%d\t%d\t%d\n", zaznam[i].Meno, zaznam[i].Priezvisko, zaznam[i].Predvolba, zaznam[i].Cislo);
			//printf("Nenasiel som !");
			getch();
			break;
			}

		case 'Z':		//podla priezviska
			{
			char priezvisko[MAXNAZOV];

			printf("\n\n\n\t\tZadaj priezvisko: ");
			scanf("%30s", priezvisko);
			clrscr();
			for(int i = 0; i < poczaz; i++)
				if( strstr(zaznam[i].Priezvisko, priezvisko) != NULL )
					printf("%s\t%s\t%d\t%d\t%d\n", zaznam[i].Meno, zaznam[i].Priezvisko, zaznam[i].Predvolba, zaznam[i].Cislo);
			//printf("Nenasiel som !");
			getch();
			break;
			}
	}
	return 0;
}


int Menu_1(TELZOZNAM zaznam[], int *poczaz)
	/*
	Podla toho,co stlacil uzivatel vykona funkciu
	vrati 	1, ak bol zvoleny odchod z programu
			0,ak nejaka z funkcii, alebo zly klaves
	*/
{
	clrscr();
	printf("\n\n\n\t\t\tHLAVNE MENU\n\n");
	printf("\t\tUlozenie do suboru                     U\n");
	printf("\t\tVlozenie noveho ucastnika do databazy  N\n");
	printf("\t\tZmazanie ucastnika z databazy          Z\n");
	printf("\t\tVypisanie zoznamu vsetkych ucastnikov  V\n");
	printf("\t\tVyhladanie ucastnikov ...              H\n");
	printf("\n\t\tKoniec programu a nahratie           K\n\n\n");
	printf("\t\tTvoja volba: ");

	int key = toupper(getch());

	switch(key)
	{   case 'U':
		{
		   FILE *file1;
		   file1 = fopen("vypis.txt","wt");
		   Tried_Data(zaznam, *poczaz);
		   fprintf(file1,"---------------------------------------------------------------\n");
		   fprintf(file1,"                Meno          Priezvisko Predvolba    Cislo\n");
		   fprintf(file1,"---------------------------------------------------------------\n");
			for(int i = 0; i < *poczaz; i++)
			fprintf(file1,"%20s%20s%10d%10d\n", zaznam[i].Meno, zaznam[i].Priezvisko, zaznam[i].Predvolba, zaznam[i].Cislo);
			fclose(file1);
			break;
		 }
		case 'V':		//VYPISANIE VSETKYCH - abecedne striedene podla Priezviska
		{
			Tried_Data(zaznam, *poczaz);
			//vypisanie vsetkych:
			clrscr();
			printf("----------------------------------------------------------------\n");
			printf("                Meno          Priezvisko Predvolba     Cislo\n");
			printf("----------------------------------------------------------------\n");
			for(int i = 0; i < *poczaz; i++)
				printf("%20s%20s%10d%10d\n", zaznam[i].Meno, zaznam[i].Priezvisko, zaznam[i].Predvolba, zaznam[i].Cislo);
			getch();
			break;
		}
		case 'H':		//VYHLADANIE UCASTNIKA PODLA MENU_2
			while( !Menu_2(zaznam, *poczaz));
			break;

		case 'N':		//VLOZENIE NOVEHO
			VlozNovy(zaznam, poczaz);
			break;

		case 'Z':		//ZMAZANIE
			ZmazZaznam(zaznam, poczaz);
			break;

		case 'K':		//SAVE & EXIT
			return 1;
	}
	return 0;
}

void Nacitaj_riadok(char riadok[], int dlzka)
/* Pomocna funkcia pre nacitanie riadku 													*/
{
	int i = 0;
	int c;
	while(i < dlzka) {
		c = getche();
		if((c == '\r') || (c == '\n')) {
			riadok[i] = '\0';
			break;
		}
		else if(c == '\b')  riadok[i--] = '\0';
		else riadok[i++] = c;
	}
}

