/*******************************
*  MENO: MILAN LEHOCKY "A"      *
*  ZADANIE: cislo 3             *
*  VSTUPNY SUBOR: DUKE3.DAT     *
*  VYSTUPNE SUBORY: DUKE3.TXT   *
*                   DUKE3.BIN   *
********************************/

#include<stdlib.h>
#include<string.h>
#include<io.h>
#include<stdio.h>
#include<dos.h>
#include<conio.h>
#define KONIEC 'N'
#define KONEC 'n'
#define clearbuff() while(getchar()!='\n')

typedef struct tel{                          //deklaracia struktury
	 char meno[15];
	 char priez[20];
	 char cislo[20];
	 char ulica[20];
	 char cdomu[10];
	 char mesto[30];
	} TEL;

int read_data(FILE *f, TEL human[])                       //definicia funkcie
{
 /* UCEL: Nacitanie udajov zo suboru
  * VSTUPNE PREMENNE: f
  * VSTUPNA PODMIENKA: f je pointer na vstupny subor
  * VYSTUPNE PREMENNE: i
  * VYSTUPNA PODMIENKA: i-1 je pocet prvkov v subore */

 int i=0;

 while(!feof(f)){          //cyklus sa ukonci, ked f ukazuje na koniec suboru
  fscanf(f,"%s %s", human[i].meno, human[i].priez);
  fscanf(f,"%s", human[i].cislo);
  fscanf(f,"%s %s", human[i].ulica, human[i].cdomu);
  fscanf(f,"%s", human[i].mesto); i++;}
 return(--i);
}

void save_textdata(FILE *save, int p, TEL human[])        //definicia funkcie
{
 /* UCEL: Ulozenie udajov do textoveho subora
  * VSTUPNE PREMENNE: save, p
  * VSTUPNA PODMIENKA: save je pointer na vystupny subor
			   p je pocet struktur */

 int i=0;
/* FILE *fbinar;

 fbinar=fopen("duke3.bin","wb");

 write(p,human,p*sizeof(TEL));*/

 for (i=0;i<p;i++){
  fprintf(save,"\n%s %s\n", (human+i)->meno, (human+i)->priez);
  fprintf(save,"%s\n", (human+i)->cislo);
  fprintf(save,"%s %s\n", (human+i)->ulica, (human+i)->cdomu);
  fprintf(save,"%s\n", (human+i)->mesto);}
}

void save_binardata(char c[9],int p, int overwrite,TEL human[])         //definicia funkcie
{
 /* UCEL: Ulozenie udajov do binarneho subora
  * VSTUPNE PREMENNE: s, p
  * VSTUPNA PODMIENKA: s je meno vystupneho textoveho suboru
			   p je pocet prvkov
  * POZNAMKA: Meno vystupneho binarneho suboru je rovnake ako textoveho,
		   koncovka je .bin              */

 FILE *fbinar;
 char binout[15];

 sprintf(binout,"%s.bin",c);

 if (overwrite==1) fbinar=fopen(binout,"wb");
 else if (overwrite==-1) fbinar=fopen(binout,"a+");
 else {cprintf("\n\n   Chyba pri zapise binarneho suboru ..");getch();}

 fwrite(human,sizeof(TEL),p,fbinar);
 fclose(fbinar);
}

void modify_data(int j, TEL human[])                      //definicia funkcie
{
 /* UCEL: Uprava zvoleneho prvku
  * VSTUPNE PREMENNE: j
  * VSTUPNA PODMIENKA: j je poradove cislo prvku */

 char g;

 do {                           //cyklus sa ukonci stlacenim 'N' ('n')
 clrscr();
 textcolor(WHITE);
 gotoxy(32, 5);
 cprintf("\n\nUPRAVA DATABAZY");
 textcolor(LIGHTCYAN);

 printf("\n\nPoradove cislo %d", j+1);
 printf("\n\n\t\t\tMENO   : %s %s", human[j].meno, human[j].priez);
 printf("\n\t\t\tTELEFON: %s", human[j].cislo);
 printf("\n\t\t\tADRESA : %s %s", human[j].ulica, human[j].cdomu);
 printf("\n\t\t\tMESTO  : %s", human[j].mesto);

 gotoxy(1,20);
 textcolor(WHITE);
 cprintf("Meno-[1]  Telefon-[2]  Adresa-[3]  Mesto-[4]  Nazad-[N]");

 switch((g=getch())) {
 case '1': gotoxy(8, 17);cprintf("Nove meno:");  //zmena mena a priezviska
		scanf("%s %s", human[j].meno, human[j].priez);
		break;
 case '2': gotoxy(8, 17);cprintf("Nove cislo telefonu:"); //zmena tel.cisla
		scanf("%s", human[j].cislo);
		break;
 case '3': gotoxy(8, 17);cprintf("Nova adresa:");  //zmena adresy
		scanf("%s %s", human[j].ulica, human[j].cdomu);
		break;
 case '4': gotoxy(8, 17);cprintf("Nove mesto:");    //zmena mesta
		scanf("%s", human[j].mesto);
	}
 textcolor(LIGHTCYAN);
 }
 while(g!=KONIEC && g!=KONEC);
}

void insert_data(int k, TEL human[])                      //definicia funkcie
{
 /* UCEL: Vlozenie noveo prvku
  * VSTUPNE PREMENNE: k
  * VSTUPNA PODMIENKA: k je poradove cislo noveho prvku */

 clrscr();
 textcolor(WHITE);
 gotoxy(32, 5);
 cprintf("\n\nUPRAVA DATABAZY");
 textcolor(LIGHTCYAN);
 printf("\n\nPoradove cislo %d", k+1);
 textcolor(WHITE);
 gotoxy(10, 14);
 cprintf("Meno      :");gotoxy(10, 15);
 cprintf("Tel. cislo:");gotoxy(10, 16);
 cprintf("Adresa    :");gotoxy(10, 17);
 cprintf("Mesto     :");

 gotoxy(21, 14);               //nacitanie poloziek noveho prvku
 scanf("%s %s", human[k].meno, human[k].priez);gotoxy(21, 15);
 scanf("%s", human[k].cislo);gotoxy(21, 16);
 scanf("%s %s", human[k].ulica, human[k].cdomu);gotoxy(21, 17);
 scanf("%s", human[k].mesto);
 textcolor(LIGHTCYAN);
}

void sort_name(int pocet, TEL human[])                    //definicia funkcie
{
 /* UCEL: Usporiadanie prvkov podla mena
  * VSTUPNE PREMENNE: pocet
  * VSTUPNA PODMIENKA: pocet je pocet vsetkych prvkov
  * POZNAMKA: ak je v-ty prvok abecedne vacsi ako v+1, prvky sa vymenia */

 int u, v;
 TEL pom;

 strcpy((human+pocet)->meno,"zzzzz");     //osetrenie usporiadania

 for (u=0;u<pocet;u++) {
	  for (v=0;v<pocet;v++) {
		if (strcmp(human[v].meno, human[v+1].meno)>0) {
			pom=human[v];human[v]=human[v+1];human[v+1]=pom;
  }}}
}

void sort_surname(int pocet, TEL human[])                 //deinicia funkcie
{
 /* UCEL: Usporiadanie prvkov podla priezviska
  * VSTUPNE PREMENNE: pocet
  * VSTUPNA PODMIENKA: pocet je pocet vsetkych prvkov
  * POZNAMKA: ak je v-ty prvok abecedne vacsi ako v+1, prvky sa vymenia */

 int u, v;
 TEL pom;

 strcpy((human+pocet)->priez,"zzzzz");    //osetrenie usporiadania

 for (u=0;u<pocet;u++) {
	  for (v=0;v<pocet;v++) {
		if (strcmp(human[v].priez, human[v+1].priez)>0) {
			pom=human[v];human[v]=human[v+1];human[v+1]=pom;}
	 }}
}

void sort_city(int pocet, TEL human[])                    //definicia funkcie
{
 /* UCEL: usporiadanie prvkov podla mesta
  * VSTUPNE PREMENNE: pocet
  * VSTUPNA PODMIENKA: pocet je pocet vsetkych prvkov
  * POZNAMKA: ak je v-ty prvok abecedne vacsi ako v+1, prvky sa vymenia */

 int u, v;
 TEL pom;

 strcpy((human+pocet)->mesto,"zzzzz");

 for (u=0;u<pocet;u++) {
	  for (v=0;v<pocet;v++) {
		if (strcmp(human[v].mesto, human[v+1].mesto)>0) {
			pom=human[v];human[v]=human[v+1];human[v+1]=pom;}
	 }}
}

int find_name(char *name, int p, TEL human[], TEL result[])             //definicia funkcie
{
 /* UCEL: Vyhladanie prvkov s rovnakym menom
  * VSTUPNE PREMENNE: name, p
  * VSTUPNA PODMIENKA: name je pointer na retazec hladaneho mena
			   p je pocet prvkov v poli human
  * VYSTUPNE PREMENNE: founded
  * VYSTUPNA PODMIENKA: founded je pocet najdenych prvkov
  * POZNAMKA: Najdene prvky sa ukladaju
		   do pomocneho pola struktur result */

 int k, founded=0;

 for (k=0;k<p;k++) {
	  if (!strcmp(name, human[k].meno)) {
		  result[founded]=human[k];
		  founded++;}}
 return(founded);
}

int find_surname(char *surname, int p, TEL human[], TEL result[])       //definicia funkcie
{
 /* UCEL: Vyhladanie prvkov s rovnakym priezviskom
  * VSTUPNE PREMENNE: name, p
  * VSTUPNA PODMIENKA: name je pointer na retazec hladaneho mena
  * VYSTUPNE PREMENNE: founded
  * VYSTUPNA PODMIENKA: founded je pocet najdenych prvkov
  * POZNAMKA: Najdene prvky sa ukladaju
		   do pomocneho pola struktur result */

 int k, founded=0;

 for (k=0;k<p;k++) {
	  if (!strcmp(surname, human[k].priez)) {
		  result[founded]=human[k];
		  founded++;}}
 return(founded);
}

int find_tel(char *tel, int p, TEL human[], TEL result[])               //definicia funkcie
{
 /* UCEL: Vyhladanie prvkov s rovnakym telefonnym cislom
  * VSTUPNE PREMENNE: name, p
  * VSTUPNA PODMIENKA: name je pointer na retazec hladaneho mena
  * VYSTUPNE PREMENNE: founded
  * VYSTUPNA PODMIENKA: founded je pocet najdenych prvkov
  * POZNAMKA: Najdene prvky sa ukladaju
		   do pomocneho pola struktur result */

 int k, founded=0;

 for (k=0;k<p;k++) {
	  if (!strcmp(tel, human[k].cislo)) {
		  result[founded]=human[k];
		  founded++;}}
 return(founded);
}

int find_street(char *street, int p, TEL human[], TEL result[])         //definicia funkcie
{
 /* UCEL: Vyhladanie prvkov s rovnakou ulicou
  * VSTUPNE PREMENNE: name, p
  * VSTUPNA PODMIENKA: name je pointer na retazec hladaneho mena
  * VYSTUPNE PREMENNE: founded
  * VYSTUPNA PODMIENKA: founded je pocet najdenych prvkov
  * POZNAMKA: Najdene prvky sa ukladaju
		   do pomocneho pola struktur result */

 int k, founded=0;

 for (k=0;k<p;k++) {
	  if (!strcmp(street, human[k].ulica)) {
		  result[founded]=human[k];
		  founded++;}}
 return(founded);
}

int find_city(char *city, int p, TEL human[], TEL result[])             //definicia funkcie
{
 /* UCEL: Vyhladanie prvkov s rovnakym mestom
  * VSTUPNE PREMENNE: name, p
  * VSTUPNA PODMIENKA: name je pointer na retazec hladaneho mena
  * VYSTUPNE PREMENNE: founded
  * VYSTUPNA PODMIENKA: founded je pocet najdenych prvkov
  * POZNAMKA: Najdene prvky sa ukladaju
		   do pomocneho pola struktur result */

 int k, founded=0;

 for (k=0;k<p;k++) {
	  if (!strcmp(city, human[k].mesto)) {
		  result[founded]=human[k];
		  founded++;}}
 return(founded);
}

void show_result(int founded, TEL result[])                //definicia funckie
{
 /* UCEL: Zobrazenie najdenych prvkov
  * VSTUPNE PREMENNE: founded
  * VSTUPNA PODMIENKA: founded je pocet najdenych prvkov */

 int j=0;
 char ot3;

 if (founded==0) {
	   gotoxy(32,12);textcolor(LIGHTRED);
	   cprintf("!Nebolo najdene!");getch();
	   textcolor(LIGHTCYAN);}
 else {

 do {
  clrscr();
  textcolor(WHITE);
  gotoxy(34, 5);
  cprintf("\n\nVYHLADAVANIE");
  textcolor(LIGHTCYAN);
  printf("\n\nPocet najdenych zaznamov %d", founded);
  printf("\n\nPoradove cislo %d", j+1);
  printf("\n\n\t\t\tMENO   : %s %s", result[j].meno, result[j].priez);
  printf("\n\t\t\tTELEFON: %s", result[j].cislo);
  printf("\n\t\t\tADRESA : %s %s", result[j].ulica, result[j].cdomu);
  printf("\n\t\t\tMESTO  : %s", result[j].mesto);
  gotoxy(1,20);
  textcolor(WHITE);
  cprintf("Nazad-[N]");
  textcolor(LIGHTCYAN);
  ot3=getch();
  if (ot3=='H'){ if (j==0) continue;
			  else j--; }
  else if (ot3=='P'){ if (j==(founded-1)) continue;
			  else j++; }
  }while(ot3!=KONEC && ot3!=KONIEC);
  }
}

void delete_data(int j, int poc, TEL human[])             //defincia funkcie
{
 /* UCEL: Vymazanie zvoleneho prvku
  * VSTUPNE PREMENNE: j, poc
  * VSTUPNA PODMIENKA: j je poradove cislo zvoleneho prvku
			   poc je pocet vsetkych prvkov
  * POZNAMKA: Pri vymazani j-teho prvku sa prvky za nim dostanu
		   o jeden index dopredu  */

 int i;

 for (i=j;i<poc;i++) {
		 human[i]=human[i+1];}
}

void main(void)
{
 /* UCEL: Praca s vytvorenou alebo nacitanou databazou
  * VSTUPNE PREMENNE: fin
  * VSTUPNA PODMIENKA: fin je vstupny subor  */


 TEL human[50], *point=NULL, result[50];
 FILE *fin=NULL, *fout=NULL;
 char ot1, ot2, ot3, ot4, namein[9], extenin[4], filein[15];
 char nameout[9], extenout[4], fileout[15];
 char *findname, *findsurname, *findtel, *findstreet, *findcity;
 int poc, j=0, otw=1, pom=0;

 findname=(char *)malloc(15);       //alokovanie pamate pre
 findsurname=(char *)malloc(20);    //     najdene
 findtel=(char *)malloc(20);        //           polozky
 findstreet=(char *)malloc(20);     //
 findcity=(char *)malloc(30);       //

do {                     //program sa ukonci stlacenim '7'
 clrscr();
 textcolor(WHITE);
 gotoxy(36,5);
 cprintf("\n\nHLAVNE MENU");
 textcolor(LIGHTCYAN);

 printf("\n\n\n\t\t1 - Nova databaza");
 printf("\n\n\t\t2 - Otvorit subor");
 printf("\n\n\t\t3 - Ulozit databazu");
 printf("\n\n\t\t4 - Prezretie databazy");
 printf("\n\n\t\t5 - Upravit databazu");
 printf("\n\n\t\t6 - Vyhladavanie");
 printf("\n\n\t\t7 - KONIEC !\n");
 ot1=getch();


/*  VYTVORENIE NOVEJ DATABAZY  --------------------------------------*/

 if (ot1=='1'){ j=0;
		do {
		clrscr();
		textcolor(WHITE);
		gotoxy(33, 5);
		clearbuff();
		cprintf("\n\nNOVA DATABAZA");
		textcolor(LIGHTCYAN);
		printf("\n\nPoradove cislo %d", j+1);
		textcolor(WHITE);
		gotoxy(10, 14);
		cprintf("Meno      :");gotoxy(10, 15);
		cprintf("Tel. cislo:");gotoxy(10, 16);
		cprintf("Adresa    :");gotoxy(10, 17);
		cprintf("Mesto     :");gotoxy(1, 20);
		cprintf("Dalsi-[medzera]  Zrusit-[Z]  Koniec-[ENTER]");
		gotoxy(21, 14); textcolor(LIGHTCYAN);
		scanf("%s %s", human[j].meno, human[j].priez);gotoxy(21, 15);  //zadavanie poloziek
		scanf("%s", human[j].cislo);gotoxy(21, 16);
		scanf("%s %s", human[j].ulica, human[j].cdomu);gotoxy(21, 17);
		scanf("%s", human[j].mesto);gotoxy(1, 20);
		point=&human[0];      //nastavenie na zaciatok pola struktur
		poc=j+1;;
		clearbuff();
		ot3=getch();
		if (ot3=='z' ||ot3=='Z') {
				   delete_data(j, j+1, human);--j;--poc;
				   if (j<0) point=NULL;
				   else { clrscr();
				  textcolor(WHITE);
				  gotoxy(33, 5);
				  cprintf("\n\nNOVA DATABAZA");
				  textcolor(LIGHTCYAN);
				  printf("\n\nPoradove cislo %d", j+1);
				  gotoxy(10, 14);
				  textcolor(WHITE);
				  cprintf("Meno      :");
				  printf("%s %s",human[j].meno,human[j].priez);gotoxy(10, 15);
				  cprintf("Tel. cislo:");
				  printf("%s",human[j].cislo);gotoxy(10, 16);
				  cprintf("Adresa    :");
				  printf("%s %s",human[j].ulica,human[j].cdomu);gotoxy(10, 17);
				  cprintf("Mesto     :");
				  printf("%s",human[j].mesto);gotoxy(1, 20);
				  cprintf("Dalsi-[medzera]  Koniec-[ENTER]");clreol();
				  gotoxy(1, 20);textcolor(LIGHTCYAN);
				  ot3=getch();
								 }
				   }
		if (ot3==' ') ++j;
		 }while(ot3==' ');
		   }

/*  NACITANIE DATABAZY ZO VSTUPNEHO SUBORU  -------------------------*/

 if (ot1=='2'){
		do {
		clearbuff();
		clrscr();
		textcolor(WHITE);
		gotoxy(32, 5);
		cprintf("\n\nOTVORENIE SUBORU");
		textcolor(LIGHTCYAN);
		   printf("\n\n\n\tSubor - meno:         koncovka:");
		   gotoxy(22,10);gets(namein);     //zadanie mena
		   gotoxy(40,10);gets(extenin);    //    a koncovky suboru
		   sprintf(filein,"%s.%s",namein,extenin);
		   fin=fopen(filein,"rt");     //otvorenie subora
		   if (!fin) {textcolor(RED);    //-ak sa nedajde subor
			 cprintf("\n\n        !!   Nemozem najst %s   !!\n",filein);
			 textcolor(LIGHTCYAN);
			 printf("\nZnovu [A\\N] ?");
			 ot2=getch();
			 if (ot2=='a' || ot2=='A') continue;
			 else break;
			 }
		   }
		   while(!fin);
		   if (fin) poc=read_data(fin, human);   //volanie funkcie na nacitanie prvkov databazy
		  }

/*  ULOZENIE DATABAZY DO TEXTOVEHO A BINARNEHO SUBORU ---------------*/

 if (ot1=='3'){ if (!fin && !point){      //v pripade, ze sa este databaza
			   gotoxy(40, 14);    //nenacitala alebo nevytvorila
			   textcolor(LIGHTRED);
			   cprintf("NIE JE CO ULOZIT..");
			   textcolor(LIGHTCYAN);
			   delay(900);continue;}
		else {
		do {
		pom=0;
		clrscr();
		clearbuff();
		textcolor(WHITE);
		gotoxy(30, 5);
		cprintf("\n\nULOZIT DATABAZU");
		textcolor(LIGHTCYAN);
		printf("\n\n\n\tSubor - meno:         koncovka:");
		gotoxy(22,10);
		gets(nameout);                //zadanie mena a
		gotoxy(40,10);gets(extenout); //koncovky vyst. text. suboru
		sprintf(fileout,"%s.%s",nameout,extenout);
		if (fopen(fileout, "rt")) {    //v pripade, ze subor uz existuje
			 do {
			 textcolor(LIGHTRED);gotoxy(1, 12);
			 cprintf("        !!   Subor %s uz existuje   !!\n",fileout);
			 textcolor(LIGHTCYAN);
			 printf("\nPrepisat-[P]  Pokracovat v subore-[O]  Znova-[Z]  Nazad do menu-[N] ?");
			 ot2=getch();
			   if (ot2=='p' || ot2=='P') {otw=1;fout=fopen(fileout,"wt");pom=1;}
			   if (ot2=='n' || ot2=='N') {otw=0;pom=1;}
			   if (ot2=='o' || ot2=='O') {otw=-1;fout=fopen(fileout,"a");pom=1;}
			   if (ot2=='z' || ot2=='Z') {otw=1;pom=1;}
			 }while(!pom);
		   }
		else fout=fopen(fileout,"wt");
		}while(!fout && otw!=0);
		if (otw!=0) {
		 save_textdata(fout, poc, human);    //volanie funkcie na ulozenie textovych udajov
		 save_binardata(nameout, poc, otw, human);  // a na ulozenie binarnych udajov
			}
		 }
	 }

/*  PREZRETIE DATABAZY  ---------------------------------------------*/

 if (ot1=='4'){ if (!fin && !point){       //v pripade, ze sa este databaza
			   gotoxy(43, 16);     //nenacitala alebo nevytvorila
			   textcolor(LIGHTRED);
			   cprintf("NIE JE DATABAZA..");
			   textcolor(LIGHTCYAN);
			   delay(900);continue;}
		else {
		j=0;
		do {               //cyklus sa ukonci stlacenim 'N' ('n')
		clrscr();
		textcolor(WHITE);
		gotoxy(30, 5);
		cprintf("\n\nPREZERANIE DATABAZY");
		textcolor(LIGHTCYAN);
		printf("\n\nPocet zaznamov %d", poc);
		printf("\n\nPoradove cislo %d", j+1);
		printf("\n\n\t\t\tMENO   : %s %s", human[j].meno, human[j].priez);
		printf("\n\t\t\tTELEFON: %s", human[j].cislo);
		printf("\n\t\t\tADRESA : %s %s", human[j].ulica, human[j].cdomu);
		printf("\n\t\t\tMESTO  : %s", human[j].mesto);
		gotoxy(1,20);
		textcolor(WHITE);
		cprintf("Nazad-[N]");
		textcolor(LIGHTCYAN);
		ot3=getch();
		if (ot3=='H'){ if (j==0) continue; //bariera
				   else j--; }          //posun o index nizsie
		else if (ot3=='P'){ if (j==(poc-1)) continue; //bariera
					else j++; }     //posun o index vyssie
		}while(ot3!=KONEC && ot3!=KONIEC);
		}
		   }

/*  UPRAVA DATABAZY -------------------------------------------------*/

 if (ot1=='5'){ if (!fin && !point){
			   gotoxy(41, 18);    //v pripade, ze sa este databaza
			   textcolor(LIGHTRED);    //nenacitala alebo nevytvorila
			   cprintf("NIE JE DATABAZA..");
			   textcolor(LIGHTCYAN);
			   delay(900);continue;}
		else {
		j=0;
		do {          //cyklus sa ukonci stlacenim 'N' ('n')
		clrscr();
		textcolor(WHITE);
		gotoxy(32, 5);
		cprintf("\n\nUPRAVA DATABAZY");
		textcolor(LIGHTCYAN);
		printf("\n\nPocet zaznamov %d", poc);
		printf("\n\nPoradove cislo %d", j+1);
		printf("\n\n\t\t\tMENO   : %s %s", human[j].meno, human[j].priez);
		printf("\n\t\t\tTELEFON: %s", human[j].cislo);
		printf("\n\t\t\tADRESA : %s %s", human[j].ulica, human[j].cdomu);
		printf("\n\t\t\tMESTO  : %s", human[j].mesto);
		gotoxy(1,20);
		textcolor(WHITE);
		cprintf("Zmenit-[ENTER]  Zoradit-[Z]  Pridat-[Ins]  Vymazat-[Del]  Nazad-[N]");
		textcolor(LIGHTCYAN);
		ot3=getch();
		if (ot3=='H'){ if (j==0) continue;  //bariera
				   else --j; }          //posunutie o index nizsie
		else if (ot3=='P'){ if (j==(poc-1)) continue;  //bariera
					else ++j; }     //posunutie o index vyssie
		else if (ot3==13) modify_data(j, human); //volanie funkcie na upravu
						  //zvoleneho prvku
		else if (ot3=='R') insert_data(poc++, human); //volanie funkcie na
							   //pridanie noveho prvku
		else if (ot3=='Z' || ot3=='z') {  //usporiadanie prvkov
			  gotoxy(2, 22);
			  printf("Podla: Mena-[1]  Priezviska-[2]  Mesta-[3]");
			  ot4=getch();                          //Podla:
			  if (ot4=='1') sort_name(poc, human);         //mena
			  else if (ot4=='2') sort_surname(poc, human); //priezviska
			  else if (ot4=='3') sort_city(poc, human);    //mesta
			  else continue;
			   }
		else if (ot3=='S') {         //vymazanie zvoleneho prvku
				gotoxy(2, 22);
				printf("Naozaj vymazat [A\\N]?");
				ot4=getch();
				if (ot4=='a' || ot4=='A') {
					if (poc<=1) {point=NULL;fin=NULL;break;}
					else delete_data(j,poc--, human); //volanie funkcie na vymazanie prvku
						  if (j>=poc) j=poc-1;
				   }
				else continue;
			   }
		}while(ot3!=KONEC && ot3!=KONIEC);
		}
		   }

/*  VYHLADAVAIE  ----------------------------------------------------*/

 if (ot1=='6'){ if (!fin && !point){
			   gotoxy(37, 20);       //v pripade, ze sa este databaza
			   textcolor(LIGHTRED);  //nenacitala alebo nevytvorila
			   cprintf("NIE JE DATABAZA..");
			   textcolor(LIGHTCYAN);
			   delay(900);continue;}
		else {
		j=0;
		do {          //cyklus sa ukonci stlacenim 'N' ('n')
		clrscr();
		textcolor(WHITE);
		gotoxy(34, 5);
		cprintf("\n\nVYHLADAVANIE");
		textcolor(LIGHTCYAN);
		gotoxy(1, 20);
		textcolor(WHITE);
		cprintf("Meno-[1]  Priezvisko-[2]  Tel.cislo-[3]  Ulicu-[4]  Mesto-[5]  Nazad-[N]");
		textcolor(LIGHTCYAN);
		ot3=getch();
		if (ot3=='1') { gotoxy(8, 17);printf("Hladane meno:");
				gets(findname);     //zadanie hladaneho mena
				show_result(find_name(findname, poc, human, result), result);}  //volanie funkcii na vyhladanie a zobrazenie
		else if (ot3=='2') { gotoxy(8, 17);printf("Hladane priezvisko:");
				gets(findsurname);  //zadanie hladaneho priezviska
				show_result(find_surname(findsurname, poc, human, result), result);} //volanie funkcii na vyhladanie a zobrazenie
		else if (ot3=='3') { gotoxy(8, 17);printf("Hladane cislo:");
				gets(findtel);      //zadanie hladaneho tel. cisla
				show_result(find_tel(findtel, poc, human, result), result);} //volanie funkcii na vyhladanie a zobrazenie
		else if (ot3=='4') { gotoxy(8, 17);printf("Hladana ulica:");
				gets(findstreet);   //zadanie hladanej ulice
				show_result(find_street(findstreet, poc, human, result), result);} //volanie funkcii na vyhladanie a zobrazenie
		else if (ot3=='5') { gotoxy(8, 17);printf("Hladane mesto:");
				gets(findcity);     //zadanie hladaneho mesta
				show_result(find_city(findcity, poc, human,result), result);} //volanie funkcii na vyhladanie a zobrazenie

		}while (ot3!=KONIEC && ot3!=KONEC);
		   }
		  }
 }
 while(ot1!='7');       //ukoncenie cyklu (programu)
 clrscr();
 gotoxy(30, 10);textcolor(LIGHTGREEN+BLINK);
 cprintf("THANK U FOR USING !!");
 textcolor(WHITE);gotoxy(76,25);cprintf("duke");gotoxy(1,1);
 getch();
 fclose(fin);
 fclose(fout);
}
