// ZADANIE CISLO 3
// Tibor Szabo  C26
// 1.rocnik  11.05.2000
// Program popisujuci evidenciu ucasnikov telefonnej siete
//
// Vstup z textoveho aj z binarneho subora, vystup tiez do textoveho aj do
// binarneho subora. V programe sa treba riadit instrukciami v dolnej casti
// obrazovky.
//**************************************************************************

#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>

typedef struct tel{             // deklaracia struktury
	 char meno[15];             // 1. retazova polozka
	 char priez[20];            // 2. ret. polozka
	 char cislo[20];            // 1. ciselna polozka
	 char ulica[20];
	 char cdomu[10];            // 2. cis. polozka
	 char mesto[30];
	} TEL;
TEL telecom[50], *point=NULL, pom, vysledok[50];

//*****FUNKCIA NA VYPIS MENU*****
void menu(int aktivna_polozka)
{
  clrscr();                                // vycistenie obrazovky
  textcolor(15);                           // nastavenie farby pisma
  gotoxy(30,1);                            // presun na urcite miesto obrazovky
  cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
  textcolor(9);
  gotoxy(2,5);
  cprintf("Zadajte vasu volbu (pohyb  alebo  a potvrdenie ENTER) :       \n");
  textcolor(15);
  gotoxy(5,8);
  cprintf("1.  Nova databaza  ");               // tlac na obrazovku
  gotoxy(5,10);
  cprintf("2.  Otvorit subor ");
  gotoxy(5,12);
  cprintf("3.  Ulozit databazu  ");
  gotoxy(5,14);
  cprintf("4.  Prezerat databazu  ");
  gotoxy(5,16);
  cprintf("5.  Upravit databazu  ");
  gotoxy(5,18);
  cprintf("6.  Vyhladavanie  ");
  gotoxy(5,20);
  cprintf("7.  Koniec programu  ");

//*****VYZNACENIE AKTIVNEJ POLOZKY PODLA CISLA*****
  if (aktivna_polozka == 1) {
	textcolor(10);                         // nastavenie farby pisma
	gotoxy(5,8);
	printf("1.");
	cprintf(" Nova databaza");            // ferebna tlac
  }
  if (aktivna_polozka == 2) {
	textcolor(10);
	gotoxy(5,10);    					   // presun na urcite miesto obrazovky
	printf("2.");                          // tlac na obrazovku
	cprintf(" Otvorit subor");
  }
  if (aktivna_polozka == 3) {
	textcolor(10);                         // nastavenie farby pisma
	gotoxy(5,12);
	printf("3.");                          // tlac na obrazovku
	cprintf(" Ulozit databazu");
	}
  if (aktivna_polozka == 4) {
	textcolor(10);                         // nastavenie farby
	gotoxy(5,14);                          // presun na urcite miesto obrazovky
	printf("4.");
	cprintf(" Prezerat databazu");
  }
  if (aktivna_polozka == 5) {              // podmienka if
	textcolor(10);                         // nastavenie farby
	gotoxy(5,16);
	printf("5.");                          // tlac na obrazovku
	cprintf(" Upravit databazu");
  }
  if (aktivna_polozka == 6) {
	textcolor(10);                         // nastavenie farby pisma
	gotoxy(5,18);
	printf("6.");
	cprintf(" Vyhladavanie");
  }
  if (aktivna_polozka == 7) {
	textcolor(10);
	gotoxy(5,20);                          // presun na urcite miesto obrazovky
	printf("7.");
	cprintf(" Koniec programu");          // farebna tlac na obrazovku
  }
}

//*****FUNKCIA NA POHYB V MENU*****
int pohyb_menu(void)
{
  int pozicia,klavesa;                   // deklaracia premennych
  pozicia = 1;
  klavesa = 0;
  menu(1);

  while (1){                             // nekonecny cyklus
	klavesa = getch();                   // cakanie na klavesu

	if (klavesa == 80) {
	  pozicia = pozicia + 1;             // posun o riadok dole
	  if (pozicia == 8) pozicia = 1;
	  menu(pozicia);                     // vratenie hodnoty
	}

	if (klavesa == 72) {
	  pozicia = pozicia - 1;             // posun o riadok hore
	  if (pozicia == 0) pozicia = 7;
	  menu(pozicia);
	}

	if (klavesa == 13) break;            // enter ukoncuje
  }
  return(pozicia);                       // vracanie polohy kurzora
}

//*****FUNKCIA NA NACITANIE UDAJOV ZO SUBORA*****
int read_data(FILE *f)
{
 int i=0;                            // deklaracia premennych

 while (!feof(f)) {          //cyklus sa ukonci, ked f ukazuje na koniec suboru
   fscanf(f,"%s %s", telecom[i].meno, telecom[i].priez);
   fscanf(f,"%s", telecom[i].cislo);
   fscanf(f,"%s %s", telecom[i].ulica, telecom[i].cdomu);
   fscanf(f,"%s", telecom[i].mesto);
   i++;
 }
 return(--i);                         // vratenie hodnoty
}

//*****FUNKCIA NA ULOZENIE UDAJOV DO TEXTOVEHO SUBORA*****
void save_textdata(FILE *save, int p)
{
  int i=0;                           // deklaracia premennych
  for (i=0; i<p; i++) {
	fprintf(save,"\n%s %s\n", (telecom+i)->meno, (telecom+i)->priez);
	fprintf(save,"%s\n", (telecom+i)->cislo);
	fprintf(save,"%s %s\n", (telecom+i)->ulica, (telecom+i)->cdomu);
	fprintf(save,"%s\n", (telecom+i)->mesto);}
  }

//*****FUNKCIA NA ULOZENIE UDAJOV DO BINARNEHO SUBORA*****
void save_binardata(char s[9],int p, int overwrite)
{
  FILE *fbinar;
  char binout[15];                      // deklaracia premennych
  sprintf(binout,"%s.bin",s);

  if (overwrite==1) fbinar=fopen(binout,"wb");
  if (overwrite==-1) fbinar=fopen(binout,"a+");
	else cprintf("\n\n   Chyba pri zapise do binarneho suboru ..");

  fwrite(&telecom,sizeof(TEL),p,fbinar);   // pisanie do binarneho subora
  fclose(fbinar);                        // zatvorenie subora
  }

//***** DEFINICIA FUNKCIE NA UPRAVU ZVOLENEHO PRVKU*****
void modify_data(int j)
{
  char g;                        // deklaracia premennych

  do {                           // cyklus sa ukonci stlacenim 'N' ('n')
  clrscr();                      // vycistenie obrazovky
  gotoxy(30,1);
  textcolor(15);                  // nastavenie farby
  cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE\n\r");
  gotoxy(1,4);
  cprintf("\n\nUprava databazy:\n\r");textcolor(11);
  cprintf("\nPoradove cislo zaznamu:   ");textcolor(9);cprintf("%d\n\n", j+1);textcolor(10);printf("\n\n\r");
  cprintf("\nMeno a priezvisko:");textcolor(15);cprintf(" %s %s", telecom[j].meno, telecom[j].priez);textcolor(10);
  cprintf("\n\rTelefonne cislo  :");textcolor(15);cprintf(" %s", telecom[j].cislo);textcolor(10);
  cprintf("\n\rAdresa           :");textcolor(15);cprintf(" %s %s", telecom[j].ulica, telecom[j].cdomu);textcolor(10);
  cprintf("\n\rMesto            :");textcolor(15);cprintf(" %s", telecom[j].mesto);textcolor(15);
  gotoxy(1,23);
  textcolor(15);
  cprintf("1 - zmenit meno a priezvisko    3 - zmenit adresu                      \n\r");
  cprintf("2 - zmenit telefonne cislo      4 - zmenit mesto            N - naspet     ");

  switch((g=getch())) {
	case '1': gotoxy(1, 22);cprintf("Nove meno je:");           //zmena mena a priezviska
		scanf("%s %s", telecom[j].meno, telecom[j].priez);
		break;
	case '2': gotoxy(1, 22);cprintf("Nove cislo telefonu je:"); //zmena tel.cisla
		scanf("%s", telecom[j].cislo);
		break;
	case '3': gotoxy(1, 22);cprintf("Nova adresa je:");         //zmena adresy
		scanf("%s %s", telecom[j].ulica, telecom[j].cdomu);
		break;
	case '4': gotoxy(1, 22);cprintf("Nove mesto je:");          //zmena mesta
		scanf("%s", telecom[j].mesto);
		break;
	}
 textcolor(11);
 }
 while((g != 'N') && (g != 'n'));
}

//*****FUNKCIA NA VLOZENIE NOVEHO PRVKU*****
void insert_data(int k)
{
  clrscr();                                // vycistenie obrazovky
  textcolor(15);                           // nastavenie farby
  gotoxy(30,1);
  cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
  gotoxy(1,6);
  cprintf("Uprava databazy:");     // farebna tlac na obrazovku
  textcolor(11);
  gotoxy(1,8);
  cprintf("Poradove cislo zaznamu :   ");textcolor(9);cprintf("%d", k+1);
  textcolor(10);
  gotoxy(1,13);
  cprintf("\n\nMeno a priezvisko:");gotoxy(1,16);
  cprintf("Telefonne cislo  :");gotoxy(1,17);
  cprintf("Adresa           :");gotoxy(1,18);
  cprintf("Mesto            :");
  gotoxy(1,23);
  textcolor(15);
  cprintf("ENTER - skok na dalsi riadok       N - navrat do menu");
  gotoxy(19, 15);               //nacitanie poloziek noveho prvku
  scanf("%s %s", telecom[k].meno, telecom[k].priez);gotoxy(19, 16);
  scanf("%s", telecom[k].cislo);gotoxy(19, 17);
  scanf("%s %s", telecom[k].ulica, telecom[k].cdomu);gotoxy(19, 18);
  scanf("%s", telecom[k].mesto);
  textcolor(11);
}

//*****FUNKCIA NA USPORIADANIE PRVKOV PODLA MENA*****
void sort_name(int pocet)
{                                         // deklaracia premennych
 int u, v;

 strcpy((telecom+pocet)->meno,"zzzzz");     //osetrenie usporiadania

  for (u=0;u<pocet;u++) {
	for (v=0;v<pocet;v++) {
	  if (strcmp(telecom[v].meno, telecom[v+1].meno)>0) {
		pom=telecom[v];telecom[v]=telecom[v+1];telecom[v+1]=pom;
	  }
	}
  }
}

//*****FUNKCIA NA USPORIADANIE PRVKOV PODLA PRIEZVISKA*****
void sort_surname(int pocet)
{
  int u, v;                                // deklaracia premennych

  strcpy((telecom+pocet)->priez,"zzzzz");    //osetrenie usporiadania

  for (u=0;u<pocet;u++) {
	for (v=0;v<pocet;v++) {
	  if (strcmp(telecom[v].priez, telecom[v+1].priez)>0) {
		pom=telecom[v];telecom[v]=telecom[v+1];telecom[v+1]=pom;
	  }
	}
  }
}

//*****FUNKCIA NA USPORIADANIE PRVKOV PODLA MESTA*****
void sort_city(int pocet)
{
  int u, v;                                // deklaracia premennych

  strcpy((telecom+pocet)->mesto,"zzzzz");

  for (u=0;u<pocet;u++) {
	for (v=0;v<pocet;v++) {
	  if (strcmp(telecom[v].mesto, telecom[v+1].mesto)>0) {
		pom=telecom[v];telecom[v]=telecom[v+1];telecom[v+1]=pom;
	  }
	}
  }
}

//*****FUNKCIA NA VYHLADAVANIE PRVKOV S ROVNAKYM MENOM*****
int find_name(char *name, int p)
{
  int k, najdene =0;                       // deklaracia premennych

  for (k=0;k<p;k++) {
	if (!strcmp(name, telecom[k].meno)) {
	  vysledok[najdene ]=telecom[k];
	  najdene ++;
	}
  }
  return(najdene );                        // vratenie poctu najdenych prvkov
}

//*****FUNKCIA NA VYHLADAVANIE PRVKOV S ROVNAKYM PRIEZVISKOM*****
int find_surname(char *surname, int p)
{
  int k, najdene =0;                       // deklaracia premennych

  for (k=0; k<p; k++) {
	if (!strcmp(surname, telecom[k].priez)) {
	  vysledok[najdene ]=telecom[k];
	  najdene ++;                          // zvecsovanie o jedna
	}
  }
  return(najdene );                        // vratenie hodnoty
}

//*****FUNKCIA NA VYHLADAVANIE PRVKOV S ROVNAKYM TELEFONNYM CISLOM*****
int find_tel(char *tel, int p)
{
  int k, najdene =0;                       // deklaracia premennych

  for (k=0; k<p; k++) {
	if (!strcmp(tel, telecom[k].cislo)) {
	  vysledok[najdene ]=telecom[k];
	  najdene ++;
	}
  }
  return(najdene );                        // vratenie hodnoty
}

//*****FUNKCIA NA VYHLADAVANIE PRVKOV S ROVNAKOU ULICOU
int find_street(char *street, int p)
{
  int k, najdene =0;                       // deklaracia premennych

  for (k=0; k<p; k++) {
	if (!strcmp(street, telecom[k].ulica)) {
	  vysledok[najdene ]=telecom[k];
	  najdene++;
	}
  }
  return(najdene );                        // vretenie hodnoty
}

//*****FUNKCIA NA VYHLADAVANIE PRVKOV S ROVNAKYM MESTOM*****
int find_city(char *city, int p)
{
  int k, najdene =0;                       // deklaracia premennych

  for (k=0; k<p; k++) {
	if (!strcmp(city, telecom[k].mesto)) {
	  vysledok[najdene ]=telecom[k];
	  najdene++;
	}
  }
  return(najdene );                         // vratenie hodnoty premennej
}

//****FUNKCIA NA ZOBRAZENIE NAJDENYCH PRVKOV*****
void show_vysledok(int najdene )
{
  int j=0;                                 // deklaracia premennych
  char klav3;

  if (najdene == 0) {
	gotoxy(50,23);
	textcolor(RED);
	cprintf("Nebolo najdene");
	getch();							   // cakanie na klavesu
	textcolor(11);                         // nastavenie farby pisma
  }
  else {

  do {
	clrscr();                              // vycistenie obrazovky
	gotoxy(30,1);
	cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
	textcolor(15);
	gotoxy(1, 4);
	cprintf("\n\nVyhladavanie:\n\r");
	textcolor(11);
	cprintf("\n\nPocet najdenych zaznamov:  ");textcolor(9);cprintf(" %d", najdene );textcolor(11);
	cprintf("\n\n\rPoradove cislo:  ");textcolor(9);cprintf(" %d", j+1);
	gotoxy(5,14);textcolor(10);
	cprintf("\n\rMeno a priezvisko:");textcolor(15);cprintf(" %s %s", telecom[j].meno, telecom[j].priez);textcolor(10);
	cprintf("\n\rTelefonne cislo  :");textcolor(15);cprintf(" %s", telecom[j].cislo);textcolor(10);
	cprintf("\n\rAdresa           :");textcolor(15);cprintf(" %s %s", telecom[j].ulica, telecom[j].cdomu);textcolor(10);
	cprintf("\n\rMesto            :");textcolor(15);cprintf(" %s", telecom[j].mesto);textcolor(15);
	gotoxy(1,23);
	textcolor(15);
	cprintf("N - naspet");
	textcolor(11);
	klav3=getch();									// cakanie na klavesu
	if (klav3 == 'H') {
	  if (j == 0) continue;
	  else j--; }
	else if (klav3 == 'P') {
	  if (j == (najdene - 1)) continue;
	  else j++; }
	}while((klav3 != 'n') && (klav3 != 'N'));
  }
}

//****FUNKCIA NA VYMAZANIE ZVOLENEHO PRVKU*****
void delete_data(int j, int poc)
{
  int i;                           // deklaracia premennych
  for (i=j;i<poc;i++) {
	telecom[i]=telecom[i+1]; }
}

//*************************
//***** TELO PROGRAMU *****
//*************************
void main(void)
{
  FILE *fin=NULL, *fout=NULL;      // definovanie suborov
  char vege;                       // deklaracia premennych
  char klav1, klav2 , klav3, klav4, namein[9], extenin[4], filein[15];
  char nameout[9], extenout[4], fileout[15];
  char *findname, *findsurname, *findtel, *findstreet, *findcity;
  int poc, j=0, otw, pom=0;        // deklaracia premennych
  int volba;

  findname=(char *)malloc(15);       //alokovanie pamate pre najdene polozky
  findsurname=(char *)malloc(20);    //alokovanie
  findtel=(char *)malloc(20);        //           pamate
  findstreet=(char *)malloc(20);     //                  pre
  findcity=(char *)malloc(30);       //                      polozky

  do {
	clrscr();                        // vycistenie obrazovky

	volba = pohyb_menu();            // pohyb v menu
	if (volba == 1) {
	  klav1 = '1'; }                 // nastavenie
	if (volba == 2) {
	  klav1 = '2'; }                 //        konstant
	if (volba == 3) {
	  klav1 = '3'; }                 //              pre
	if (volba == 4) {
	  klav1 = '4'; }                 //                 dalsiu
	if (volba == 5) {
	  klav1 = '5'; }                 //                     pracu
	if (volba == 6) {
	  klav1 = '6'; }                 //                        programu
	if (volba == 7) {
	  klav1 = '7'; }

//*****VYTVORENIE NOVEJ DATABAZY*****
 if (klav1 == '1') {
   j=0;                            // deklaracia premennych
   do {
	 clrscr();					   // vycistenie obrazovky
	 gotoxy(30,1);
	 textcolor(15);
	 cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
	 gotoxy(1, 5);
	 cprintf("\nNova databaza");
	 textcolor(11);
	 cprintf("\n\nPoradove cislo:   ");textcolor(9);cprintf("%d", j+1);
	 textcolor(15);
	 gotoxy(5, 14);
	 cprintf("Meno a prizvisko :");gotoxy(5, 15);
	 cprintf("Telefonne cislo  :");gotoxy(5, 16);
	 cprintf("Adresa           :");gotoxy(5, 17);
	 cprintf("Mesto            :");gotoxy(1, 23);
	 cprintf("Z - zrusit novy zaznam          U - ponechat novy zaznam\n\r");
	 cprintf("ENTER - skok na dalsi riadok    N - navrat do menu");
	 gotoxy(23, 14); textcolor(11);
	 scanf("%s %s", telecom[j].meno, telecom[j].priez);gotoxy(23, 15);  //zadavanie poloziek
	 scanf("%s", telecom[j].cislo);gotoxy(23, 16);
	 scanf("%s %s", telecom[j].ulica, telecom[j].cdomu);gotoxy(23, 17);
	 scanf("%s", telecom[j].mesto);gotoxy(1, 23);
	 point=&telecom[0];      				  //nastavenie na zaciatok pola struktur
	 poc=j+1;;
	 klav3=getch();							  // cakanie na klavesu
	 if ((klav3 == 'z') || (klav3 == 'Z')) {
	   delete_data(j, j+1);--j;--poc;
	   if (j<0) point=NULL;
	   else {
		 clrscr();						   	// vycistenie obrazovky
		 textcolor(15);
		 gotoxy(1, 5);
		 cprintf("\n\nNova databaza:");
		 textcolor(11);
		 printf("\nPoradove cislo:   ");textcolor(9);cprintf("%d", j+1);
		 gotoxy(5, 14);
		 textcolor(15);
		 cprintf("Meno a priezvisko:");
		 printf("%s %s",telecom[j].meno,telecom[j].priez);gotoxy(5, 15);
		 cprintf("Telefonne cislo  :");
		 printf("%s",telecom[j].cislo);gotoxy(5, 16);
		 cprintf("Adresa           :");
		 printf("%s %s",telecom[j].ulica,telecom[j].cdomu);gotoxy(23, 5);
		 cprintf("Mesto            :");
		 printf("%s",telecom[j].mesto);gotoxy(1, 23);
		 cprintf("Z - zrusit novy zaznam\n\r         U - ponechat novy zaznam  ");
		 cprintf("ENTER - skok na dalsi riadok       N - navrat do menu");
		 clreol();
		 gotoxy(1,20);textcolor(11);
		 klav3=getch(); }							// cakanie na klavesu
	   }
	   if (klav3 == ' ') ++j;
	 }while(klav3 == ' ');
   }

//*****NACITANIE DATABAZY ZO VSTUPNEHO SUBORU*****
 if (klav1 == '2') {
   do {
	 clrscr();							// vycistenie obrazovky
	 textcolor(15);
	 gotoxy(30,1);
	 cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
	 gotoxy(1, 2);
	 cprintf("\n\nOtvorenie vstupneho subora:");
	 textcolor(5);
	 cprintf("\n\n\rmeno subora    :\n\r");
	 cprintf("koncovka subora:");
	 textcolor(11);
	 gotoxy(1,23);
	 cprintf("ENTER - skok na dalsi riadok");
	 gotoxy(18,6);gets(namein);     //zadanie mena
	 gotoxy(18,7);gets(extenin);    //    a koncovky suboru
	 sprintf(filein,"%s.%s",namein,extenin);
	 fin=fopen(filein,"rt");     //otvorenie subora
	 if (!fin) {textcolor(2);   //-ak sa nenajde subor
	   gotoxy(1,23);
	   cprintf("Subor %s sa neda najst!\n",filein);
	   getchar();
	   gotoxy(1,23);
	   cprintf("Chces otvorit iny subor? [ A-ano | N-nie ] ?");
	   klav2 =getch();								// cakanie na klavesu
	   if ((klav2  == 'a') || (klav2  == 'A')) continue;
	   else break; }
	 } while(!fin);
	 if (fin) poc=read_data(fin);   //volanie funkcie na nacitanie prvkov databazy
}

//*****ULOZENIE DATABAZY DO TEXTOVEHO A BINARNEHO SUBORU*****
  if (klav1 == '3') {
	if (!fin && !point) {      //v pripade, ze sa este databaza
	  gotoxy(1, 23);           //nenacitala alebo nevytvorila
	  textcolor(5);
	  cprintf("Najprv treba mat otvorenu databazu\n\r");
	  textcolor(15);
	  cprintf("Pokracuj stlacenim entera");
	  getch();								// cakanie na klavesu
	  textcolor(11);
	  continue;}
	else {
	  do {
		pom=0;
		clrscr();							// vycistenie obrazovky
		gotoxy(30,1);
		textcolor(15);
		cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
		textcolor(5);
		gotoxy(1, 5);
		cprintf("\nUlozenie databazy:\n\r");
		textcolor(11);
		cprintf("\nmeno subora    :\n\r");
		cprintf("koncovka subora:");
		gotoxy(1,23);
		textcolor(15);
		cprintf("Pre binarny vystupny subor pouzite koncovku BIN                        \n\r");
		cprintf("Pre textovy vystupny subor koncovku TXT (alebo inu)                        ");
		textcolor(11);
		gotoxy(18,8);
		gets(nameout);                //zadanie mena a
		gotoxy(18,9);gets(extenout); //koncovky vyst. text. suboru
		sprintf(fileout,"%s.%s",nameout,extenout);
		if (fopen(fileout, "rt")) {    //v pripade, ze subor uz existuje
		  do {
			textcolor(2);gotoxy(1,23);
			cprintf("Subor %s uz existuje!                                        \n\r",fileout);
			textcolor(11);textcolor(15);
			cprintf("P - prepisat subor          S - spat do menu                         \n\r");
			cprintf("O - dopisat do subora       N - nove meno subora                         ");
			klav2 =getch();							// cakanie na klavesu
			if ((klav2  == 'p') || (klav2  == 'P')) {
			  otw=1;
			  fout=fopen(fileout,"wt");pom=1;
			}
			if ((klav2  == 's') || (klav2  == 'S')) {
			  otw=0;
			  pom=1;
			}
			if ((klav2  == 'o') || (klav2  == 'O')) {
			  otw=-1;
			  fout=fopen(fileout,"a");
			  pom=1;
			}
			if ((klav2  == 'n') || (klav2  == 'N')) {
			  otw=1;
			  pom=1;
			}
		  } while(!pom);
		}
		else fout=fopen(fileout,"wt");
	  }while((!fout) && (otw != 0));
	  if (otw != 0) {
		if (extenout == "bin") {
		  save_binardata(nameout, poc, otw); } //volanie funkcie na ulozenie textovych udajov
		else
		  save_textdata(fout, poc);            // a na ulozenie binarnych udajov

	  }
	}
  }

//*****PREZRETIE DATABAZY*****
  if (klav1 == '4') {
	if (!fin && !point) {       //v pripade, ze sa este databaza
	  gotoxy(1, 23);           //nenacitala alebo nevytvorila
	  textcolor(5);
	  cprintf("Najprv treba mat otvorenu databazu\n\r");
	  textcolor(15);
	  cprintf("Pokracuj stlacenim entera");
	  getch();					// cakanie na klavesu
	  textcolor(11);
	  continue;
	}
	else {
	  j=0;
	  do {                              //cyklus sa ukonci stlacenim 'N' ('n')
		clrscr();						// vycistenie obrazovky
		textcolor(15);
		gotoxy(30,1);
		cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
		gotoxy(1, 4);
		cprintf("\n\nPrezeranie databazy:\n\n\r");textcolor(11);
		cprintf("Pocet zaznamov databazy:   ");textcolor(10);cprintf("%d\n\r", poc);textcolor(11);
		cprintf("Poradove cislo zaznamu :   ");textcolor(10);cprintf("%d", j+1);
		gotoxy(5,14);textcolor(10);
		cprintf("\n\rMeno a priezvisko:");textcolor(15);cprintf(" %s %s", telecom[j].meno, telecom[j].priez);textcolor(10);
		cprintf("\n\rTelefonne cislo  :");textcolor(15);cprintf(" %s", telecom[j].cislo);textcolor(10);
		cprintf("\n\rAdresa           :");textcolor(15);cprintf(" %s %s", telecom[j].ulica, telecom[j].cdomu);textcolor(10);
		cprintf("\n\rMesto            :");textcolor(15);cprintf(" %s", telecom[j].mesto);textcolor(15);
		gotoxy(1,24);
		cprintf("N - navrat do menu");
		textcolor(11);
		klav3=getch();					// cakanie na klavesu
		if (klav3 == 'H') {
		  if (j==0) continue;           //bariera
		  else j--; }                   //posun o index nizsie
		else if (klav3 == 'P') {
		  if (j == (poc-1)) continue;   //bariera
		  else j++; }                   //posun o index vyssie
	  } while((klav3 != 'n') && (klav3 != 'N'));
	}
  }

//*****UPRAVA DATABAZY*****
  if (klav1 == '5') {
	if (!fin && !point) {
	  gotoxy(1, 24);          //v pripade, ze sa este databaza
	  textcolor(5);    //nenacitala alebo nevytvorila
	  cprintf("Najprv treba mat otvorenu databazu\n\r");
	  textcolor(15);
	  cprintf("Pokracuj stlacenim entera");
	  getch();					 // cakanie na klavesu
	  continue;}
	  else {
		j=0;
		do {                     //cyklus sa ukonci stlacenim 'N' ('n')
		  clrscr();              // vycistenie obrazovky
		  gotoxy(30,1);
		  textcolor(15);
		  cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
		  gotoxy(1, 4);
		  cprintf("\n\nUprava databazy:\n\n\r");textcolor(11);
		  cprintf("Pocet zaznamov databazy:   ");textcolor(10);cprintf("%d\n\r", poc);textcolor(11);
		  cprintf("Poradove cislo zaznamu :   ");textcolor(10);cprintf("%d", j+1);
		  gotoxy(5,14);textcolor(10);
		  cprintf("\n\rMeno a priezvisko:");textcolor(15);cprintf(" %s %s", telecom[j].meno, telecom[j].priez);textcolor(10);
		  cprintf("\n\rTelefonne cislo  :");textcolor(15);cprintf(" %s", telecom[j].cislo);textcolor(10);
		  cprintf("\n\rAdresa           :");textcolor(15);cprintf(" %s %s", telecom[j].ulica, telecom[j].cdomu);textcolor(10);
		  cprintf("\n\rMesto            :");textcolor(15);cprintf(" %s", telecom[j].mesto);textcolor(15);
		  gotoxy(1,23);
		  textcolor(15);
		  cprintf("V - vymazat         Z - zoradit                            \n\r");
		  cprintf("D - pridat          M - zmenit          N - navrat do menu     ");
		  textcolor(11);
		  klav3 = getch();		   	// cakanie na klavesu
		  if (klav3 == 'H') {
			if (j == 0) continue;   //bariera
			else --j; }             //posunutie o index nizsie
		  else
			if (klav3 == 'P') {
			  if (j == (poc-1)) continue;  //bariera
			  else ++j; }                  //posunutie o index vyssie
			else
			  if ((klav3 == 'm') || (klav3 == 'M')) modify_data(j); //volanie funkcie na upravu zvoleneho prvku
			  else
				if ((klav3 == 'd') || (klav3 == 'D')) insert_data(poc++); //volanie funkcie na pridanie noveho prvku
				else
				  if ((klav3 == 'Z') || (klav3 == 'z')) {  //usporiadanie prvkov
					gotoxy(1, 23);textcolor(15);
					cprintf("M - zoradit podla mena             C - zoradit podla mesta                  \n\r");
					cprintf("P - zoradit podla priezviska       N - naspet                                ");
					klav4 = getch();                                                //Podla:
					  if ((klav4 == 'm') || (klav4 == 'M')) sort_name(poc);         //mena
					  else
						if ((klav4 == 'p') || (klav4 == 'P')) sort_surname(poc);    //priezviska
						else
						 if ((klav4 == 'c') || (klav4 == 'C')) sort_city(poc);      //mesta
						 else
						   if ((klav4 == 'n') || (klav4 == 'N')) continue;
				  }
				  else
					if ((klav3 == 'v') || (klav3 == 'V')) {         //vymazanie zvoleneho prvku
					  gotoxy(1, 22);
					  printf("Chces naozaj vymazat tuto polozku? [ A-ano | N-nie ]");
					  klav4 = getch();
					  if ((klav4 == 'a') || (klav4 == 'A')) {
						if (poc<=1) {
						point=NULL;
						fin=NULL;
						break; }
					  else delete_data(j,poc--); //volanie funkcie na vymazanie prvku
			  if (j >= poc) j=poc-1;
			}
		  else continue;
		}
	  }while ((klav3 != 'n') && (klav3 != 'N'));
	}
  }

//*****VYHLADAVANIE*****
  if (klav1 == '6') {
	if (!fin && !point) {
	  gotoxy(1, 23);       //v pripade, ze sa este databaza
	  textcolor(5);  //nenacitala alebo nevytvorila
	  cprintf("Najprv treba mat otvorenu databazu\n\r");
	  textcolor(15);
	  cprintf("Pokracuj stlacenim entera");
	  getch();					   // cakanie na klavesu
	  continue;}
	else {
	  j=0;
	  do {                         //cyklus sa ukonci stlacenim 'N' ('n')
		clrscr();                  // vycistenie obrazovky
		gotoxy(30,1);
		textcolor(15);
		cprintf("PROGRAM NA EVIDENCIU UCASNIKOV TELEFONNEJ SIETE");
		gotoxy(1, 4);
		cprintf("\n\nVyhladavanie:\n\n\r");
		cprintf("Pocet zaznamov databazy:   ");textcolor(9);cprintf("%d\n\n\n\r", poc);
		gotoxy(5,14);textcolor(10);
		cprintf("\n\rMeno a priezvisko:");
		cprintf("\n\rTelefonne cislo  :");
		cprintf("\n\rAdresa           :");
		cprintf("\n\rMesto            :");
		gotoxy(1,23);
		textcolor(15);
		cprintf("M - pohladat meno           U - pohladat ulicu     T - pohladat tel. cislo\n\r");
		cprintf("P - pohladat priezvisko     O - pohladat mesto     N - naspat                 ");
		textcolor(11);
		klav3 = getch();						// cakanie na klavesu
		if ((klav3 == 'm') || (klav3 == 'M')) {
		  gotoxy(1,22);
		  printf("Hladane meno je:");
		  gets(findname);     //zadanie hladaneho mena
		  show_vysledok(find_name(findname, poc)); }  //volanie funkcii na vyhladanie a zobrazenie
		else
		  if ((klav3 == 'p') || (klav3 == 'P')) {
			gotoxy(1, 22);
			printf("Hladane priezvisko je:");
			gets(findsurname);  //zadanie hladaneho priezviska
			show_vysledok(find_surname(findsurname, poc));} //volanie funkcii na vyhladanie a zobrazenie
		  else
			if ((klav3 == 't') || (klav3 == 'T')) {
			  gotoxy(1, 22);
			  printf("Hladane cislo je:");
			  gets(findtel);      //zadanie hladaneho tel. cisla
			  show_vysledok(find_tel(findtel, poc));} //volanie funkcii na vyhladanie a zobrazenie
			else
			  if ((klav3 == 'u') || (klav3 == 'U')) {
				gotoxy(1, 22);
				printf("Hladana ulica je:");
				gets(findstreet);   //zadanie hladanej ulice
				show_vysledok(find_street(findstreet, poc));} //volanie funkcii na vyhladanie a zobrazenie
			  else
				if ((klav3 == 'o') || (klav3 == 'O')) {
				  gotoxy(1, 22);
				  printf("Hladane mesto je:");
				  gets(findcity);     //zadanie hladaneho mesta
				  show_vysledok(find_city(findcity, poc));} //volanie funkcii na vyhladanie a zobrazenie

		} while((klav3 != 'N') && (klav3 != 'n'));
	  }
	}
  }
  while(klav1 != '7');        //ukoncenie cyklu (programu)
  textcolor(15);
  clrscr();                   // vycistenie obrazovky
  fclose(fin);                // zatvorenie vstupnehosubora
  fclose(fout);               // zatvorenie vystupneho subora
  cprintf("Program sa ukoncil.");
  delay(500);                 // cakanie pol sekundy
  exit(1);                    // ukoncenie programu
}
