/*****************************************************************************
*Meno a priezvisko: Peter Roman							    Kruzok: B - 13   *
*Zadanie: 3                                                 Datum:  5.5.1999 *
*Nazov:		Databaza vydeozaznamu  ktora obsahuje  Nazov filmu,  Zaner       *
*           daneho filmu, Zaciatok v minutach,  Dlzku filmu v minutach       *
*		                        a Cislo danej kazety                         *
*			Celi program je realizovany velmi jednoducho. Pre zaciatok       *
*			je dobre si precitat info, kde je vsetko vysvetlene.			 *
*			Program vyuziva bynarne nacitavanie  aj ukladanie o suboru.       *
*                                                                            *
*****************************************************************************/
// nacitanie potrebnych kniznic
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#define max 1000 // definovanie konstanty maximalneho pola struktur
#define pauza 1000
// definovanie strukturi
typedef struct {
  char nazov[20],
	   zaner[20];
  int  cislo_kazety,
	   zaciatok,
	   dlzka;
  } videozaznam;

int uvod()
{
 /* uvodna obrazovka - zobrazi zakladne udaje o autorovi*/
 char odpoved;
 clrscr();

 textcolor(10);
 gotoxy(1,1);
  cprintf("Meno a priezvisko: Peter Roman");
 gotoxy(50,1);
  cprintf("Kruzok: B-13\n");
 gotoxy(50,2);
  cprintf("Zadanie: 3");
 gotoxy(28,25);
  cprintf("Chces pokracovat?(A/N)");
 odpoved = 'n';
 while (odpoved != 'a') {
   gotoxy(52,25);
   cprintf(" ");
   gotoxy(52,25);
   cscanf("%c", &odpoved);
   if (odpoved == 'n') {
	 textcolor(7);
	 clrscr();
	 return 0;
   }
 }
 textcolor(7);
 clrscr();
}


void vymaz_pole(int pocet[3], videozaznam db[max]) // premaze cele pole tak ze tam zapise 0
{
 int i;
 for (i = 0; i < 3; i++)
   pocet[i] = 0;
 for (i = 0; i < max; i++) {
   strcpy( db[i].nazov, "");
   strcpy( db[i].zaner, "");
   db[i].zaciatok = 0;
   db[i].dlzka = 0;
   db[i].cislo_kazety = 0;
 }
}

zisti_prit_vst_sub() // zisti pritomnost vstupneho suboru "videozaznam.dat
{
 char odpoved;
 int c,o = 0;
 FILE *fr, *fw;

 clrscr(); // vymaze obrazovku
 if ((fr = fopen ("video.dat", "rb")) == NULL) { // ak sa ho podarilo otvorit to zanmena ze je pritomny
   fclose(fr);
   textcolor(12);
   cprintf("\007Nepodarilo sa otvorit vstupni subor alebo sa nenasiel!\n\r");
   cprintf("Ma sa pokracovat s prazdnou databazou? (A/N) Ak nie tak sa program ukonci.\n\r");
   textcolor(7);
 } else return 2;

 while (o == 0) {
   odpoved = getch();
   if (odpoved == 'n' || odpoved == 'N') {
	 clrscr();
	 return 0;
   }
   if (odpoved == 'a' || odpoved == 'A') {
	 clrscr();
	 return 1;
   }
 }
}

nacitaj_udaje_zo_suboru(videozaznam db[max], int pocet[3]) // nacita udaje zo vstupneho suboru
{
 int i;
 FILE *fr;

 fr = fopen ("video.dat","rb"); // otvori vstupni subor pre binarne nacitavanie
 fread(&pocet[0] , sizeof(pocet), 1, fr); // nacita pocet zaznamov
 if (pocet[0] > max) {
   clrscr();
   textcolor(12);
   cprintf("\007Pocet nacitanich zaznamov je viac ako dovoluje parameter!\n\r");
   textcolor(7);
   return 0;
 }

 for (i = 0; i < pocet[0]; i++) {
   fread(&db[i], sizeof(videozaznam), 1, fr); // binarne nacitavanie zaznamov zo subaru
 }
 pocet[1] = pocet[0]; // nastavenie poctu aktualnych zaznamov
 fclose(fr);
}

void zorad_podla_nazvu(videozaznam db[max], int pocet[3]) // zoradenie zaznamov podla abecedy
{
 int i,k;
 videozaznam pomoc[1]; // vytvorenie pomocneho pola videozaznamov
 for (i = 0; i < (pocet[1] - 1); i++) {
   if (pocet[1] > i) {
	 for (k = i; k < pocet[1]; k++) {
	   if (strcmp(db[i].nazov,db[k].nazov) > 0) { // abecedne porovnavanie dvoch zaznamov
		 pomoc[0] = db[i];
		 db[i] = db[k];
		 db[k] = pomoc[0];
	   }
	 }
   }
 }
}

void nakresli_tabulku() // funkcia pre nakreslenie zaznamu
{
 int i, x =1, y = 1;
 textcolor(15);
// vykresli sa prvy riadok
 gotoxy(x,y);
 cprintf("");
 for (i = 2; i < 22; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 23; i < 43; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 44; i < 54; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 55; i < 65; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 66; i < 76; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 // vykreslia sa stlpce
 for (i = 2; i < 20; i++) {
   gotoxy(1,i);
   cprintf("");
   gotoxy(22,i);
   cprintf("");
   gotoxy(43,i);
   cprintf("");
   gotoxy(54,i);
   cprintf("");
   gotoxy(65,i);
   cprintf("");
   gotoxy(76,i);
   cprintf("");
 }
// vykresly sa ciara
 y = 3;
 gotoxy(1,y);
 cprintf("");
 for (i = 2; i < 22; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 23; i < 43; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 44; i < 54; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 55; i < 65; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 66; i < 76; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");

// vykresli sa spodna hranica
   y = 20;
   gotoxy(1,y);
 cprintf("");
 for (i = 2; i < 22; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 23; i < 43; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 44; i < 54; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 55; i < 65; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");
 for (i = 66; i < 76; i++) {
   gotoxy(i,y);
   cprintf("");
 }
 cprintf("");

 textcolor(10);
 gotoxy(2,2);
  cprintf("    Nazov filmu     ");
 gotoxy(23,2);
  cprintf("    Zaner filmu     ");
 gotoxy(44,2);
  cprintf(" Zaciatok ");
 gotoxy(55,2);
  cprintf("   Dlzka  ");
 gotoxy(66,2);
  cprintf("Cislo kaz.");
 textcolor(7);
}

void napln(int y) // naplni sa komunikacny riadok znakom " "
{
 int i;
 gotoxy(1,y);
 for (i = 1; i <= 80; i++) {
   textcolor(7);
   cprintf(" ");
 }
}

void ovpanel1()
{//vypise sa ovladaci panel1
 napln(22);
 textcolor(11);
 gotoxy(1,22);
  cprintf("F1 - info     F2 - najdi     F3 - pridaj zaznam  F4 - zmaz zaznam    F5 - koniec");
 textcolor(7);
}

void ovpanel2()
{
 napln(22);
 textcolor(11);
 gotoxy(1,22);
  cprintf("Najdi :          F1 - nazov filmu         F2 - cislo kazety          F5 - naspet");
 textcolor(7);
}

void vymaz(int y) // vymaze y -ty riadok v tabulke
{
 gotoxy(2,y);
  printf("                    ");
 gotoxy(23,y);
  printf("                    ");
 gotoxy(44,y);
  printf("          ");
 gotoxy(55,y);
  printf("          ");
 gotoxy(66,y);
  printf("          ");
}

void vypis(videozaznam db [max], int pocet[3]) // vypisu sa zaznami do tabulky
{
 int i = 4, aktual;
 aktual = pocet[2]; //vypis od aktualneho zaznamu


 if (pocet[1] != 0) {
   textbackground(1);
   textcolor(15);
   i = 4;
   vymaz(i);
   gotoxy(2,i);
	cprintf("%20s",db[aktual].nazov);
   gotoxy(23,i);
	cprintf("%20s",db[aktual].zaner);
   gotoxy(44,i);
	cprintf("%10d",db[aktual].zaciatok);
   gotoxy(55,i);
	cprintf("%10d",db[aktual].dlzka);
   gotoxy(66,i);
	cprintf("%10d",db[aktual].cislo_kazety);
   textbackground(0);
   aktual++;
   if (pocet[2] < pocet[1]) {
	 for (i = 5; (i < ((pocet[1] - pocet[2]) + 4) && i < 20); i++, aktual++) {
	   vymaz(i);
	   gotoxy(2,i);
		cprintf("%20s",db[aktual].nazov);
	   gotoxy(23,i);
		cprintf("%20s",db[aktual].zaner);
	   gotoxy(44,i);
		cprintf("%10d",db[aktual].zaciatok);
	   gotoxy(55,i);
		cprintf("%10d",db[aktual].dlzka);
	   gotoxy(66,i);
		cprintf("%10d",db[aktual].cislo_kazety);
	 }
   }
 }
 for (i = i; i < 20; i++) vymaz(i);
 textcolor(7);
}

test(videozaznam db[max], int pocet[3], int cislo)
{
 int i = 0;
 for (i = 0; i < pocet[1]; i++) {
   if (cislo == db[i].cislo_kazety) {
	 pocet[2] = i;
	 vypis(db, pocet);
	 napln(24);
	 textcolor(12);
	 gotoxy(1,24);
	 cprintf("\007Kazeta s danym cislom uz existuje!");
	 textcolor(7);
	 delay(pauza);
	 napln(24);
	 return 0;
   }
 }
 return 1;
}

void vloz_zaznam(videozaznam db[max], int pocet[3]) // vlozenie zaznamu do databazi
{
 char text[20];
 int i = pocet[1], cislo,p = 0;

 napln(24);
 if (i >= max) {
   textcolor(12);
   gotoxy(1,24);
	cprintf("\007Nemozno pridat viac zaznamov!");
   textcolor(7);
   delay(pauza);
   napln(24);
 }
 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj nazov filmu: ");
 fflush(stdin);
 gets(text);
 strcpy (db[i].nazov, text);
 napln(24);

 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj zaner filmu: ");
 fflush(stdin);
 gets(text);
 strcpy (db[i].zaner,text);
 napln(24);

 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj zaciatok [min]: ");
 scanf("%10d", &cislo);
 db[i].zaciatok = cislo;

 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj dlzku filmu [min]: ");
 scanf("%10d", &cislo);
 db[i].dlzka = cislo;

 while(p == 0) {
   napln(24);
   textcolor(14);
   gotoxy(1,24);
	cprintf("Zadaj cislo kazety: ");
   textcolor(7);
   scanf("%10d", &cislo);
   p = test(db, pocet,cislo);
 }
   db[i].cislo_kazety = cislo;
   napln(24);

 textcolor(7);
 pocet[1] += 1;
}

najdi_nazov(videozaznam db[max], int pocet[3]) // vyhlada zadani vydeozaznam v databaze
{
 int i = 0, p = 0,k = 0;
 char text[20];
 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj nazov filmu, ktory chces vyhladat: ");
 fflush(stdin);
 gets(text);
 napln(24);

 while (p == 0) {
   if (strcmp(text,db[i].nazov) == 0) { // porovnavanie zaznamov
	 p = 1;
	 pocet[2] = i;
   } else p = 0;
   if (i >= max) {
	 textcolor(12);
	 gotoxy(1,24);
	  cprintf("\007Nenasiel sa zodpovedajuci nazov filmu!");
	 k = 1;
	 textcolor(7);
	 delay(pauza);
	 p = 1;
   }
   i++;
 }
 napln(24);
 if (k == 1) return 0;
}

najdi_cislo(videozaznam db[max], int pocet[3]) // vyhlada zadany vydeozaznam v databaze
{
 int i = 0, p = 0,k = 0, c = 0;
 textcolor(14);
 gotoxy(1,24);
  cprintf("Zadaj cislo kazety, ktory chces vyhladat: ");
 fflush(stdin);
 scanf("%d", &c);
 napln(24);

 while (p == 0) {
   if (c == db[i].cislo_kazety) { // porovnavanie zaznamov
	 p = 1;
	 pocet[2] = i;
   } else p = 0;
   if (i >= max) {
	 textcolor(12);
	 gotoxy(1,24);
	  cprintf("\007Nenasiel sa film so zodpovedajucim cislom!");
	 k = 1;
	 textcolor(7);
	 delay(pauza);
	 p = 1;
   }
   i++;
 }
 napln(24);
 if (k == 1) return 0;
}



odstran(videozaznam db[max], int pocet[3]) // odstranenie zaznamu z databazy
{
 int i,k,o = 0;
 char c = 'o';
 textcolor(12);
 gotoxy(1,24);
  cprintf("\007Naozaj chces odstranit tento zaznam?! (A/N)");
 while (o == 0) {
   c = getch();
   if (c == 'n' || c == 'N') {
	 napln(24);
	 return 0;
   }
   if (c == 'a' || c == 'A') o = 1; else o = 0;
 }
 napln(24);
 i = pocet[2];
 if (pocet[1] > 0) {
   if (i == (pocet[1] - 1)) {
	 pocet[2] -=1;
	 pocet[1] -=1;
   } else {
	   for (k = i; k < (pocet[1] - 1); k++)
		 db[k] = db[k + 1];
	   pocet[1] -= 1;
	 }
 } else {
	 pocet[2] = 0;
	 pocet[1] = 0;
   }
}

uloz_zaznami(videozaznam db[max], int pocet[3]) // ulozenie zaznamov do databazy
{
 FILE *fw;
 int i;

 if ((fw = fopen("video.dat","wb")) == NULL) {
   textcolor(12);
   gotoxy(1,24);
	cprintf("\007Databazu sa nepodarilo otvorit pre ulozenie!");
   delay(pauza);
   napln(24);
   return 0;
   textcolor(7);
 }
 fwrite(&pocet[1], sizeof(pocet), 1, fw);
 for (i = 0; i < pocet[1]; i++) {
   fwrite(&db[i], sizeof(videozaznam), 1, fw);
 }
 if (fclose(fw) != EOF) {
   textcolor(12);
   gotoxy(1,24);
	cprintf("Databaza bola uspesne ulozena!");
   textcolor(7);
   delay(pauza);
   napln(24);
 }
}

void posuv(int p, videozaznam db[max], int pocet[3])
{
 switch(p) {
   case 72 : if (pocet[2] == 0) break; // sipka smerom hore
			 pocet[2] -= 1;
			 if (pocet[2] < 0) pocet[2] = 0;
			 vypis(db,pocet);
			 break;
   case 75 : if (pocet[2] == 0) break; // sipka dolava
			 pocet[2] -= 16;
			 if (pocet[2] < 0) pocet[2] = 0;
			 vypis(db,pocet);
			 break;
   case 77 : if (pocet[2] == (pocet[1] - 1)) break; // sipka doprava
			 pocet[2] += 16;
			 if (pocet[2] > (pocet[1] - 1)) {
			   if (pocet[1] == 0) pocet[2] = 0; else
				 if (pocet[1] > 0) pocet[2] = (pocet[1] - 1);
			 }
			 vypis(db,pocet);
			 break;
   case 80 : if (pocet[2] == (pocet[1] -1)) break;
			 pocet[2] += 1; // sipka smerom dole
			 if (pocet[2] > (pocet[1] - 1)) {
			   if (pocet[1] == 0) pocet[2] = 0; else
				 if (pocet[1] > 0) pocet[2] = (pocet[1] - 1);
			 }
			 vypis(db,pocet);
			 break;
   default : break;
 }
}


koniec() // ukoncenie programu
{
 int i = 0;
 char o;
 textcolor(12);
 gotoxy(1,24);
  cprintf("\007Naozaj chces ukoncit program? (A/N)");
 textcolor(7);
 while(i == 0) {
   o = getch();
   if (o == 'n' || o == 'N') {
	 napln(24);
	 return 0;
   }
   if (o == 'a' || o == 'A') {
	 napln(24);
	 return 1;
   }
 }
}

void info() // vypis informacii tzv. help
{
 clrscr();
 textcolor(10);
 gotoxy(9,7);
 cprintf("Cely program sa ovlada velmi  jednoducho. Sipkxami hore a dole");
 gotoxy(9,8);
 cprintf("sa zaznami psuvaju  o jedno hore  alebo dole. Stlacenim lavej");
 gotoxy(9,9);
 cprintf("sipky  sa  posunu zaznami  o jednu  stranku hore a  stalcenim");
 gotoxy(9,10);
 cprintf("pravej  sipky sa  posunu zaznami  o jednu stranku dole. Potom");
 gotoxy(9,11);
 cprintf("tu este mame klavesi od F1 - F5 ktorych vyznam je hned jasny.");
 gotoxy(9,12);
 cprintf("V pripade ked sa stane ze pri zadavani udajov  stlacite enter");
 gotoxy(9,13);
 cprintf("naprazdno a posunie  sa vam celi obsah databazi  smerom hore,");
 gotoxy(9,14);
 cprintf("tak po ukonceni vkladania  zaznamov stlacite F1  to jest info");
 gotoxy(9,15);
 cprintf("a stl. enter. A tymto sa vsetko vrati do povodneho stavu.");
 gotoxy(9,16);
 cprintf("Po ukonceni programu sa databaza ulozi do suboru!");
 gotoxy(9,17);
 cprintf("               --- stlac enter ---");
 getch();
 textcolor(7);
 clrscr();
}
/***************** hlavny program ********************/
int main()
{
 char c;
 int pokracuj = 0;
 videozaznam db[max]; // vytvorenie pola zaznamov
 _setcursortype(0); // vypnutie blikajuceho kurzora

 int pocet[3]; // 0 - pre pocet nacitanych suborov 1 - pre pocet aktualnych suborov 2 - cislo aktualneho zaznamu, na ktorom sa nachadza kurzor

 if (uvod() == 0) {
   _setcursortype(2);
   return 0;
 }

 vymaz_pole(pocet,db); // vymaze sa pole zaznamov aj pole poctu
 pokracuj = zisti_prit_vst_sub();
 if (pokracuj == 0) return 0;
 if (pokracuj == 2) {
   printf("nacitavaju sa udaje zo suboru!");
   nacitaj_udaje_zo_suboru(db,pocet);
 }
 pokracuj = 0;
 clrscr();
 nakresli_tabulku(); // nakresli sa tabulka
 ovpanel1();
 vypis(db,pocet); // vypisu sa do tabulky zaznami

 do {
   do {
	 c = getch();
	 if (c == 59 || c == 60 || c == 61 || c == 62 || c == 63 || c == 72 ||
		 c == 75 || c == 77 || c == 80)
	   pokracuj = 1;
	   else pokracuj = 0;
   } while (pokracuj == 0);
   switch(c) {
	 case 59 : info(); // info
			   nakresli_tabulku();
			   ovpanel1();
			   vypis(db,pocet);
			   break;
	 case 60 : ovpanel2();
			   do {
				 do {
				   c = getch();
				   if ( c == 59 || c == 60 || c == 63 || c == 72 || c == 75 ||
						c == 77 || c == 80) pokracuj = 1;
					 else pokracuj = 0;
				 } while(pokracuj == 0);
					 switch(c) {
					   case 59 : if (najdi_nazov(db,pocet) == 0) break; //najdi podla nazvu
								 vypis(db,pocet);
								 break;
					   case 60 : if (najdi_cislo(db,pocet) == 0) break; // najdi podla cisla kazety
								 vypis(db,pocet);
								 break;
					 }
					 posuv(c, db, pocet);
			   } while( c != 63);
			   ovpanel1();
			   c = 27;
			   break;
	 case 61 : vloz_zaznam(db,pocet); //pridaj zaznam
			   zorad_podla_nazvu(db,pocet);
			   vypis(db,pocet);
			   break;
	 case 62 : odstran(db,pocet); //vymaz
			   vypis(db,pocet);
			   break;
	 case 63 : if (koniec() == 1) { //koniec
				 uloz_zaznami(db,pocet);
				 break;
			   } else
				   c = 27;
			   break;
   }
   posuv(c, db, pocet);
 } while ( c != 63); // ak sa stlacila klavesa F5 program sa  ukonci
 clrscr();
 textcolor(12);
 gotoxy(37,12);
  cprintf("Koniec");
 textcolor(7);
 delay(pauza);
 clrscr();
 _setcursortype(2); // zapnutie blikajuceho kurzora
}