/***************************************************************************
* Meno a priezvisko : Mario Komjathy        Cislo kruzku : C/26            *
*                           						   *
* Tento program je venovany tim co potrebuju urobit databazu pre zvierata  *
* v Zoologickej zahrade. Na pouzivanie je jednoduchy pre kazdeho           *
* zrozumitelny.                                                            *
****************************************************************************/

#include <conio.h>
#include <alloc.h>                                   // Pouzivane kniznice
#include <dos.h>
#include <stdio.h>
#include <process.h>
#include <string.h>
#define maxs 100

typedef struct zaznam{                               // Definovanie structury
 int cislo;
 char nazov[15];
 char druh[20];
 char rok[5];
 }zaznam;

void ukladaj(zaznam db[maxs],int maxi)
{
 int i,u,arma;
 char pom[15],pom1[15],pom2[20],pom3[20],pom4[5],pom5[5];
 run:
 arma=1;
 for (i=0;i<maxi-1;i++)
 {
  strcpy(pom,db[i].nazov);                 // Kopirovanie retazca
  strcpy(pom1,db[i+1].nazov);
  strcpy(pom2,db[i].druh);
  strcpy(pom3,db[i+1].druh);
  strcpy(pom4,db[i].rok);
  strcpy(pom5,db[i+1].rok);
  u = strcmp(pom,pom1);
  if (u>0) {
	     strcpy(db[i].nazov,pom1);
	     strcpy(db[i+1].nazov, pom);
	     strcpy(db[i].druh,pom3);
	     strcpy(db[i+1].druh, pom2);
	     strcpy(db[i].rok,pom5);
	     strcpy(db[i+1].rok, pom4);
	     arma=0;
	    }
 }
 if (arma==0) goto run;
}

void plnka(int a,int b,int c,int d,int e,int f)      // Vyplnanie pozadia
{
 int x,z;
 textcolor(e);
 textbackground(f);
  for (x=a;x<=c+1;x++) {
		   gotoxy(x,b);
		   cprintf("%c", char(176));
		   if (x==c) {
			       x=a-1;
			       b=b+1;
			     }
		   if (b==d+1) x=c+1;
		  }
}

void riadok()					     // Vykresli modry kurzor
{
 gotoxy(2,16);
 textcolor(0);
 textbackground(1);
 cprintf("                                                                              ");
}

void nacit(zaznam db[maxs],int maxi,int u)           // Nacitanie zaznamov zo
{                                                    // suboru do pola struct
 int k = 0;
 int i;
 plnka(2,16,79,22,3,3);
 riadok();
 textcolor(15);
 textbackground(1);
 for (i=u;i<maxi;i++)
  {
  if (k!=0) textbackground(3);
   gotoxy(5,k+16);
   cprintf("%4d",db[i].cislo);
   gotoxy(15,k+16);
   cprintf("|%15s",db[i].nazov);
   gotoxy(35,k+16);
   cprintf("|%20s",db[i].druh);
   gotoxy(70,k+16);
   cprintf("|%5s",db[i].rok);
   k++;
   if (k==7) i=maxi;
  }
}
void nulovanie(zaznam db[maxs])                      // Nulovanie pola struct
{
 int i;
 for(i=0;i<maxs;i++)
 {
  db[i].cislo = 0;
  strcpy(db[i].druh , "");
  strcpy(db[i].nazov , "");
  strcpy(db[i].rok , "");
 }
}

void ramik(int a,int b,int c,int d,int e,int f)      // ramik(1,1,80,24,14,1)
{
 int x,y,w,q;
 textcolor(e);
 textbackground(f);
 gotoxy (a,b); cprintf ("%c", char(218));
 gotoxy (c,b); cprintf ("%c", char(191));
 gotoxy (a,d); cprintf ("%c", char(192));
 gotoxy (c,d); cprintf ("%c", char(217));
  q = b+1;
  for (x=a+1;x<c;x++) {
		   gotoxy(x,b);
		   cprintf("%c", char(196));
		   gotoxy(x,d);
		   cprintf("%c", char(196));
		  }
  for (y=b+1;y<d;y++) {
		   gotoxy(a,y);
		   cprintf("%c", char(179));
		   gotoxy(c,y);
		   cprintf("%c", char(179));
		  }
  for (w=a+1;w>0;w++) {textcolor(f);
		   gotoxy(w,q);
		   cprintf("%c",char(219));
		   if (w==c-1) {
				  w=a;
				  q=q+1;
				}
		   if (q==d) w=-8;
		  }
}

void locate(int a,int b,char c[80],int d,int e)      // Posunie text do urcit.
{                                                    // pozicie
 textcolor(d);
 textbackground(e);
 gotoxy(a,b);
 cprintf("%s",c);
 textcolor(7);
 textbackground(0);
}

koniec(zaznam db[maxs], int maxi)                    // Koniec programu
{
 FILE *fw;
 int i;
 if ((fw = fopen("vstup.dat","w")) == NULL)
 {
  textbackground(0);
  clrscr();
  ramik(15,8,68,10,7,1);
  locate(26,9,"Subor sa nepodarilo vytvorit",0,7);
  delay(5000);
  textbackground(0);
  clrscr();
  exit(1);
 }
 fprintf(fw,"%d\n",maxi);
 for(i=0;i<maxi;i++)                                 // Ulozenie do subora
 {                                                   // z pola
  fprintf(fw,"%d %s %s %s\n",(db+i)->cislo,(db+i)->nazov,(db+i)->druh,(db+i)->rok);
 }
 textcolor(7);
 textbackground(0);
 clrscr();
 printf("Copyright (c) 2000, by Mario Komjathy");
 _setcursortype(2);
 if (fclose(fw)==EOF)
 {
  textbackground(0);
  clrscr();
  ramik(23,8,58,11,7,1);
  locate(25,9,"Subor sa nepodarilo uzatvorit",15,7);
  delay(5000);
  textbackground(0);
  clrscr();
  exit(1);
 }
 exit(1);
 return 0;
}
vymazat(zaznam db[maxs], int i, int maxi)            // Vymaze zaznam
{
  int poko=0;
  plnka(1,2,80,12,1,7);
  ramik(20,8,60,11,7,1);
  gotoxy(22,9);
  textcolor(7);
  textbackground(1);
  cprintf(" Naozaj chcete vymazat zaznam : [A/N]");
  gotoxy(54,10);
  cprintf("(ESC)");
  textbackground(0);
  while(poko==0)
  {
   switch(getch())       // Ak ano tak sa nakopiruje posledny
   {                     // do tohto a vyprazni sa
	 case 'a' : {
				 strcpy(db[i].druh , db[maxi-1].druh);
				 strcpy(db[i].nazov , db[maxi-1].nazov);
				 strcpy(db[i].rok , db[maxi-1].rok);
				 db[maxi-1].cislo = 0;
				 strcpy(db[maxi-1].druh , "");
				 strcpy(db[maxi-1].nazov , "");
				 strcpy(db[maxi-1].rok , "");
				 maxi = maxi - 1;
				}
	 case 'n' : poko=1;break;
	 case 27  : poko=1;break;
	 case 'N' : poko=1;break;
   }
  }
  plnka(20,8,60,11,1,7);
  ukladaj(db,maxi);
  nacit(db,maxi,i);
  return maxi;
}
doplnit(int maxi,zaznam db[maxs],int i)                    // Doplni novy zaznam
{
 plnka(1,2,80,12,1,7);
 ramik(15,8,65,12,7,1);
 gotoxy(18,9);
 textcolor(7);
 textbackground(1);
 cprintf("Zadajte nazov zvierata ,druh a rok narodenia:");
 gotoxy(20,10);
 cprintf("(piste to za sebou a vynechavajte medzeru)\n");
 textbackground(0);
 gotoxy(20,11);
 cprintf("                                          ");
 gotoxy(20,11);
 scanf("%s %s %s",db[maxi].nazov,db[maxi].druh,db[maxi].rok);
 db[maxi].cislo = maxi+1;
 _setcursortype(0);
 maxi = maxi + 1;
 plnka(15,8,65,12,1,7);
 ukladaj(db,maxi);
 nacit(db,maxi,i);
 return (maxi);
}
hladat(zaznam db[maxs],int maxi)                     // Hlada zaznam
{
 char stra[20];
 char kolko[maxs];
 char cho;
 int kolo,aaa,i,bbb=0,poc,a;
 plnka(1,2,80,12,1,7);
 ramik(10,8,70,12,7,1);
 gotoxy(25,9);
 textcolor(7);
 textbackground(1);
 cprintf(" Vyberte podla coho chcete hladat :");
 gotoxy(13,10);
 cprintf("1. Nazov zvierata, 2. Druh zvieratav, 3. Rok narodenia");
 gotoxy(65,11);
 cprintf("(ESC)");
 while(1)
 {
  cho = getch();
  switch(cho)
  {
   case 27: goto koniec_b;
   case '1' : {
		   plnka(10,8,70,12,1,7);
		   ramik(17,8,63,11,7,1);
		   gotoxy(20,9);
		   textcolor(7);
		   textbackground(1);
		   cprintf("Zadajte hladany nazov zvierata :");
		   textbackground(0);
		   gotoxy(20,10);
		   cprintf("                                          ");
		   gotoxy(20,10);
		   scanf("%s",stra);
		   poc = 0;
		   for(i=0;i<maxi;i++)
		   {
		kolo = strcmp(stra,db[i].nazov); // Porovnavanie dvoch ret.
		if (kolo == 0) {
				kolko[poc] = i;
				poc++;
				   }
		   }
		   if (poc>1) {
			   bbb = 0;
			   a = 0;
			   bbb = kolko[a];
			   nacit(db,maxi,bbb);
			   textbackground(0);
			   a++;
			   while(a != poc)
			   {
				 plnka(17,8,63,11,1,7);
				 ramik(17,8,63,11,7,1);
				 gotoxy(19,9);
				 textcolor(7);
				 textbackground(1);
				 cprintf(" Naslo sa viac nazvov stlacajte TABULATOR");
				 gotoxy(58,10);
				 cprintf("(ESC)");
				 textbackground(0);
				 _setcursortype(0);
				switch(getch())
				{
				 case 9 : {
					bbb = kolko[a];
					nacit(db,maxi,bbb);
					textbackground(0);
					a++;
					break;
					  }
				 case 27 : a = poc;break;
				}
			   }
			   goto koniec_b;
			  }
			   if (poc==1) aaa=0;
		   if (aaa == 0) goto koniec_a;
		   else {
			 bbb = 0;
			 plnka(17,8,63,11,1,7);
			 ramik(17,8,63,11,7,1);
			 gotoxy(24,9);
			 textcolor(7);
			 textbackground(1);
			 cprintf(" Vas nazov zvierata nebol najdeny");
			 gotoxy(58,10);
			 cprintf("(ESC)");
			 _setcursortype(0);
			 while(1)
			 {
			  switch(getch())
			  {
			  case 27 :goto koniec_c;
			  }
			 }
			}

		  }
   case '2' : {
		   plnka(10,8,70,12,1,7);
		   ramik(17,8,63,11,7,1);
		   gotoxy(20,9);
		   textcolor(7);
		   textbackground(1);
		   cprintf("Zadajte hladany druh zvierata :");
		   textbackground(0);
		   gotoxy(20,10);
		   cprintf("                                          ");
		   gotoxy(20,10);
		   scanf("%s",stra);
		   poc = 0;
		   for(i=0;i<maxi;i++)
		   {
		kolo = strcmp(stra,db[i].druh);
		if (kolo == 0) {
				kolko[poc] = i;
				poc++;
				   }
		   }
		   if (poc>1) {
			   bbb = 0;
			   a = 0;
			   bbb = kolko[a];
			   nacit(db,maxi,bbb);
			   textbackground(0);
			   a++;
			   while(a != poc)
			   {
				 plnka(17,8,63,11,1,7);
				 ramik(17,8,63,11,7,1);
				 gotoxy(19,9);
				 textcolor(7);
				 textbackground(1);
				 cprintf(" Naslo sa viac druhov stlacajte TABULATOR");
				 gotoxy(58,10);
				 cprintf("(ESC)");
				 textbackground(0);
				 _setcursortype(0);
				switch(getch())
				{
				 case 9 : {
					bbb = kolko[a];
					nacit(db,maxi,bbb);
					textbackground(0);
					a++;
					break;
					  }
				 case 27 : a = poc;break;
				}
			   }
			   goto koniec_b;
			  }
			   if (poc==1) aaa=0;
		   if (aaa == 0) goto koniec_a;
		   else {
			 bbb = 0;
			 plnka(17,8,63,11,1,7);
			 ramik(17,8,63,11,7,1);
			 gotoxy(24,9);
			 textcolor(7);
			 textbackground(1);
			 cprintf(" Vas druh zvierata nebol najdeny");
			 gotoxy(58,10);
			 cprintf("(ESC)");
			 _setcursortype(0);
			 while(1)
			 {
			  switch(getch())
			  {
			  case 27 :goto koniec_c;
			  }
			 }
			}

		  }
   case '3' : {
		   plnka(10,8,70,12,1,7);
		   ramik(17,8,63,11,7,1);
		   gotoxy(20,9);
		   textcolor(7);
		   textbackground(1);
		   cprintf("Zadajte hladany rok narodenia :");
		   textbackground(0);
		   gotoxy(20,10);
		   cprintf("                                          ");
		   gotoxy(20,10);
		   scanf("%s",stra);
		   poc = 0;
		   for(i=0;i<maxi;i++)
		   {
		kolo = strcmp(stra,db[i].rok);
		if (kolo == 0) {
				kolko[poc] = i;
				poc++;
				   }
		   }
		   if (poc>1) {
			   bbb = 0;
			   a = 0;
			   bbb = kolko[a];
			   nacit(db,maxi,bbb);
			   textbackground(0);
			   a++;
			   while(a != poc)
			   {
				 plnka(17,8,63,11,1,7);
				 ramik(17,8,63,11,7,1);
				 gotoxy(19,9);
				 textcolor(7);
				 textbackground(1);
				 cprintf(" Naslo sa viac rokov nar. stlacajte TAB");
				 gotoxy(58,10);
				 cprintf("(ESC)");
				 textbackground(0);
				 _setcursortype(0);
				switch(getch())
				{
				 case 9 : {
					bbb = kolko[a];
					nacit(db,maxi,bbb);
					textbackground(0);
					a++;
					break;
					  }
				 case 27 : a = poc;break;
				}
			   }
			   goto koniec_b;
			  }
			   if (poc==1) aaa=0;
		   if (aaa == 0) goto koniec_a;
		   else {
			 bbb = 0;
			 plnka(17,8,63,11,1,7);
			 ramik(17,8,63,11,7,1);
			 gotoxy(24,9);
			 textcolor(7);
			 textbackground(1);
			 cprintf(" Vas rok narodenia nebol najdeny");
			 gotoxy(58,10);
			 cprintf("(ESC)");
			 _setcursortype(0);
			 while(1)
			 {
			  switch(getch())
			  {
			  case 27 :goto koniec_c;
			  }
			 }
			}

		  }
  }
 }
 koniec_a:
 plnka(10,5,70,13,1,7);
 textcolor(7);
 textbackground(0);
 bbb = kolko[0];
 koniec_c:
 plnka(17,8,63,11,1,7);
 nacit(db,maxi,bbb);
 koniec_b:
 plnka(10,5,70,13,1,7);
 return bbb;
}
update (zaznam db[maxs],int i,int maxi)              // Prepisovanie zaznamu
{
  int poko=0;
  char pom[20];
  plnka(1,2,80,12,1,7);
  ramik(17,8,63,11,7,1);
  gotoxy(19,9);
  textcolor(7);
  textbackground(1);
  cprintf(" Chcete prepisat 1. Nazov, 2. Druh, 3.Rok");
  gotoxy(57,10);
  cprintf("(ESC)");
  textbackground(0);
  while(poko==0)
  {
   switch(getch())
   {
	 case '1' : {
		      plnka(17,8,63,11,1,7);
		      ramik(23,8,58,11,7,1);
		      gotoxy(26,9);
		      textcolor(7);
		      textbackground(1);
		      cprintf("Zadajte novy nazov zvierata :");
		      textbackground(0);
		      gotoxy(26,10);
		      cprintf("                             ");
		      gotoxy(27,10);
			  scanf("%s",pom);
		      strcpy(db[i].nazov , pom);
		      _setcursortype(0);
		      plnka(23,8,58,11,1,7);
		      poko=1;
		      break;
		}
	 case '2' : {
		      plnka(17,8,63,11,1,7);
		      ramik(23,8,58,11,7,1);
		      gotoxy(26,9);
		      textcolor(7);
		      textbackground(1);
		      cprintf("Zadajte novy druh zvierata : ");
		      textbackground(0);
		      gotoxy(26,10);
		      cprintf("                             ");
		      gotoxy(27,10);
			  scanf("%s",pom);
		      strcpy(db[i].druh , pom);
		      _setcursortype(0);
		      plnka(23,8,58,11,1,7);
		      poko=1;
		      break;
		}
	 case '3' : {
		      plnka(17,8,63,11,1,7);
		      ramik(20,8,60,11,7,1);
		      gotoxy(22,9);
		      textcolor(7);
		      textbackground(1);
		      cprintf("Zadajte novy rok narodenia zvirata :");
		      textbackground(0);
		      gotoxy(22,10);
		      cprintf("                                    ");
		      gotoxy(23,10);
			  scanf("%s",pom);
		      strcpy(db[i].rok , pom);
		      _setcursortype(0);
		      plnka(20,8,60,11,1,7);
		      poko=1;
		      break;
		}
	 case 27  : poko=1;break;
   }
  }
  plnka(17,8,63,11,1,7);
  ukladaj(db,maxi);
  nacit(db,maxi,i);
  return 0;
}
void o_programe()                                    // Nieco o programe
{
 plnka(1,2,80,12,1,7);
 ramik(25,5,55,12,15,1);
 locate(36,6,"SrnaSoft",15,1);
 locate(34,7,"Version 1.0",15,1);
 locate(30,8,"Copyright (c) 2000 by",15,1);
 locate(33,9,"Mario Komjathy",15,1);
 locate(27,11," Press any key to Continue ",15,2);
 getch();
 plnka(25,5,55,12,1,7);
}
pomoc()                                              // Pomoc v programe
{
 FILE *fr;
 int i;
 char pom[81];
 if ((fr = fopen("plus.hlp","r")) == NULL)
 {
  ramik(20,11,60,13,0,7);
  locate(28,12,"Subor plus.hlp sa nenasiel",0,7);
  delay(5000);
  plnka(1,2,80,13,1,7);
  goto run;
 }
 ramik(1,2,80,14,15,1);
 for(i=0;i<11;i++)
 {
  fgets(pom,80,fr);
  gotoxy(9,i+3);
  textcolor(15);
  textbackground(1);
  cprintf("%s",pom);
 }
 getch();
 plnka(1,2,80,14,1,7);
 if (fclose(fr) == EOF)
 {
  ramik(20,11,60,13,0,7);
  locate(28,12,"Subor plus.hlp sa neuzavrel",0,7);
  delay(5000);
  plnka(1,2,80,13,1,7);
 }

 run:
 return 0;
}

dolava (int contat)                                  // Pohyb kurzoru
{
 if (contat == 2) {
		   locate (26,1," Pomoc ",0,7);
		   locate (10,1," Editovanie ",0,2);
		  }
 if (contat == 1) {
		   locate (10,1," Editovanie ",0,7);
		   locate (2,1," Subor ",0,2);
		  }
 if (contat == 0) contat = contat + 1;
 contat = contat - 1;
 return contat;
}


doprava (int contat)
{
 if (contat == 0) {
		   locate (2,1," Subor ",0,7);
		   locate (10,1," Editovanie ",0,2);
		  }
 if (contat == 1) {
		   locate (10,1," Editovanie ",0,7);
		   locate (26,1," Pomoc ",0,2);
		  }
 if (contat == 2) contat = contat - 1;
 contat = contat + 1;
 return contat;
}


dole (int contot,int contat)
{
 if (contat == 1){
		  if (contot == 0)
		  {
		    locate(11,3," Vymazat ---- ",0,7);
		    locate(11,4," Doplnit ---- ",0,2);
		  }
		  if (contot == 1)
		  {
		    locate(11,4," Doplnit ---- ",0,7);
		    locate(11,5," Hladat  ---- ",0,2);
		  }
		  if (contot == 2)
		  {
		    locate(11,5," Hladat  ---- ",0,7);
		    locate(11,6," Update  ---- ",0,2);
		  }
		  if (contot == 3) contot = contot - 1;
 }
 if (contat == 2){
		  if (contot == 0)
		  {
		    locate(27,3," O programe ",0,7);
		    locate(27,4," Pomoc - F1 ",0,2);
		  }
		  if (contot == 1) contot = contot - 1;
 }
 contot = contot + 1;
 return contot;
}


hore (int contot,int contat)
{
 if (contat == 1){
		  if (contot == 3)
		  {
		    locate(11,6," Update  ---- ",0,7);
		    locate(11,5," Hladat  ---- ",0,2);
		  }
		  if (contot == 2)
		  {
		    locate(11,5," Hladat  ---- ",0,7);
		    locate(11,4," Doplnit ---- ",0,2);
		  }
		  if (contot == 1)
		  {
		    locate(11,4," Doplnit ---- ",0,7);
		    locate(11,3," Vymazat ---- ",0,2);
		  }
		  if (contot == 0) contot = contot + 1;
 }
 if (contat == 2){
		  if (contot == 1)
		  {
		    locate(27,3," O programe ",0,2);
		    locate(27,4," Pomoc - F1 ",0,7);
		  }
		  if (contot == 0) contot = contot + 1;
 }
 contot = contot - 1;
 return contot;
}


main()                                               // Hlavny program
{
 zaznam db[maxs];
 FILE *fr;
 int a = 1,maxi = 0,i,x,aa;
 char b[15],c[20],d[5];
 int contat = 0,contot = 0;
 nulovanie(db);
 if ((fr = fopen("vstup.dat","r")) == NULL)
 {
  textbackground(0);
  clrscr();
  ramik(15,8,65,10,15,7);
  locate(21,9,"Subor sa nenasiel v aktualnom Adresary",0,7);
  delay(5000);
  textbackground(0);
  clrscr();
  exit(1);
 }
  nulovanie(db);                    // Vynuluje pole
  fscanf(fr,"%d",&maxi);
  for (i=0;i<maxi;i++)
  {
   fscanf(fr,"%4d%15s%20s%5s",&x,b,c,d);
   db[i].cislo= x;
   strcpy(db[i].nazov,b);
   strcpy(db[i].druh,c);
   strcpy(db[i].rok,d);
  }
 ukladaj(db,maxi);
 textcolor(7);
 textbackground(0);
 clrscr();
 _setcursortype(0);
 plnka(1,2,80,23,1,7);
 textcolor(0);
 textbackground(7);
 gotoxy(1,1);
 cprintf("  Subor   Editovanie      Pomoc                                                 ");
 gotoxy(1,24);
 cprintf("  F10 - Menu   F1 - Pomoc                                                       ");
 ramik(1,15,80,23,15,3);
 locate(5,15," Cislo ",15,3);
 locate(19,15," Nazov zvierata ",15,3);
 locate(45,15," Druh zvierata ",15,3);
 locate(71,15," Rok nar.",15,3);
 nacit(db,maxi,0);
 i=0;
 if (fclose(fr) == EOF)
 {
  textbackground(0);
  clrscr();
  printf("Subor sa nepodarilo spravne uzatvorit");
  exit(1);
 }
while(a!=0)
{
 switch(getch())
 {
  case 0  : {
	     switch(getch())
	     {
	      case 72 :{ // Hore
			aa = i = i - 1;
			textcolor(7);
			textbackground(0);
			riadok();
			if (i==-1) {
				    aa=0;
				    i=0;
				   }
			textbackground(0);
			nacit(db,maxi,aa);
			break;
		       }
	      case 80 :{ // Dole
			aa = i = i + 1;
			textcolor(7);
			textbackground(0);
			riadok();
			if (i==maxi) {
				      aa=maxi-1;
				      i=maxi-1;
				     }
			textbackground(0);
			nacit(db,maxi,aa);
			break;
		       }
	      case 59 : pomoc();break;
	      case 68 : {
			 locate(2,1," Subor ",0,2);
			  while(a!=0)
			  {
			    switch(getch())
			    {
			       case 0 : {
					  switch(getch())
					  {
			      /*dolava*/    case 75 : contat = dolava(contat);break;
			      /*doprava*/   case 77 : contat = doprava(contat);break;
					    default : {
						       sound(1200);
						       delay(80);
						       nosound();
						      }
					  }
					  break;
					}
			       case 13 : {
					    if (contat == 0)
					    {
					     ramik (2,2,12,4,0,7);
					     locate(3,3," Koniec  ",0,2);
					    }
					    if (contat == 1)
					    {
					     ramik (10,2,25,7,0,7);
					     locate(11,3," Vymazat ---- ",0,2);
					     locate(11,4," Doplnit ---- ",0,7);
					     locate(11,5," Hladat  ---- ",0,7);
					     locate(11,6," Update  ---- ",0,7);
					    }
					    if (contat == 2)
					    {
					     ramik (26,2,39,5,0,7);
					     locate(27,3," O programe ",0,2);
					     locate(27,4," Pomoc - F1 ",0,7);
					    }
					      while(a!=0)
					      {
						switch(getch())
						{
						   case 13 : {
								 if (contat == 0)
								 {
								  if (contot == 0) koniec(db,maxi);
								 }
								 if (contat == 1)
								 {
								  if (contot == 0) maxi = vymazat(db,i,maxi);
								  if (contot == 1) maxi = doplnit(maxi,db,i);
								  if (contot == 2) i = hladat(db,maxi);
								  if (contot == 3) update(db,i,maxi);
								 }
								 if (contat == 2)
								 {
								  if (contot == 0) o_programe();
								  if (contot == 1) pomoc();
								 }
								 contot = 0;
								 a=0;
								 break;
								   }
						 case 0 : {
							   switch(getch())
							   {
						   /*dole*/      case 80 : contot = dole(contot,contat);break;
						   /*hore*/      case 72 : contot = hore(contot,contat);break;
								 default : {
									sound(1200);
									delay(80);
									nosound();
								       }
							   }
							   break;
							  }
						 case 27 : {
							    plnka(1,2,80,8,1,7);
							    a=0;
							    contot = 0;
							    break;
							   }
						 default : {
							    sound(1200);
							    delay(80);
							    nosound();
							   }
						}
					      }
					    a=1;
						break;
					   }

			       case 27 : {
					  locate(1,1,"  Subor   Editovanie      Pomoc     ",0,7);
					  a=0;
					  contat = 0;
					  break;
					 }
			       default : {
					  sound(1200);
					  delay(80);
					  nosound();
					 }
			    }
			  }
			  break;
			}
	      default : {
			  sound(1200);
			  delay(80);
			  nosound();
			}
	     }
	     a=1;
	     break;
	    }
  default : {
	     sound(1200);
	     delay(80);
	     nosound();
	    }
 }
}

textbackground(0);
textcolor(7);
clrscr();
_setcursortype(2);
return 0;
}