entity Adder is
 port(A1,A2,A3,A4,B1,B2,B3,B4,Carry_In: in Bit;
        Y1,Y2,Y3,Y4,Carry_Out: out Bit);
end Adder;

architecture beh of Adder is
 signal Tmp_carry1: Bit;
 signal Tmp_carry2: Bit;
 signal Tmp_carry3: Bit;
  
 component Full_adder
  port(A,B,Carry_in: in Bit; AB,Carry_out: out Bit);
 end component;
 
 begin
 
  F1: Full_adder
  	 port map(A=>A1 , B=>B1 , Carry_in=>Carry_In , AB=>Y1 , Carry_out=>Tmp_carry1);
 	
  F2: Full_adder
 	 port map(A=>A2 , B=>B2 , Carry_in=>Tmp_carry1 , AB=>Y2 , Carry_out=>Tmp_carry2);	          	
 	
  F3: Full_adder
 	 port map(A=>A3 , B=>B3 , Carry_in=>Tmp_carry2 , AB=>Y3 , Carry_out=>Tmp_carry3);
 	
  F4: Full_adder
 	 port map(A=>A4 , B=>B4 , Carry_in=>Tmp_carry3 , AB=>Y4 , Carry_out=>Carry_Out);
 	
 end beh;			