entity D_PO is
  port(Din,Cl,Rn: in Bit; Q,Qnot: out Bit);
end D_PO;
architecture beh of D_PO is      
  begin
    B: process(Cl,Rn,Din) begin                     
          if Rn='0' then
              Q<='0';
              Qnot<='1';
            else if (Cl='1' and Cl'Event) then
              Q<=Din;
              Qnot<= not Din;
            end if;
          end if;    
        end process ;        
  end beh;   
---------------------------------------------------------------------------------------
entity Counter is
  port(Enable,Resetn,Up,Clk: in Bit; Cout: out Bit; Vystup: out Bit_vector (3 downto 1));
end Counter;

architecture beh of Counter is
  component D_PO
    port(Din,Cl,Rn: in Bit; Q,Qnot : out Bit);
  end component;  
  component And_Gate
    port(Ain1,Ain2,Ain3: in Bit;Aout: out Bit);
  end component;
  component Sum
    port(Up: in Bit;Sin: in Bit_vector(3 downto 1); Carryout: out Bit; Sout: out Bit_vector(3 downto 1));
  end component;

  signal Temp_cout,Clock: Bit;
  signal Temp_sum,Temp_dpo: Bit_vector(3 downto 1);
   begin
      Vystup<=Temp_dpo;
      OA: And_Gate port map(Ain1=>Clk,Ain2=>Clk,Ain3=>Enable,Aout=>Clock);
      O_Sum: Sum port map(Up=>Up,Sin=>Temp_dpo,Carryout=>Temp_cout,Sout=>Temp_sum);
      O_Dpo1:D_PO port map(Din=>Temp_sum(1),Cl=>Clock,Rn=>Resetn,Q=>Temp_dpo(1));
      O_Dpo2:D_PO port map(Din=>Temp_sum(2),Cl=>Clock,Rn=>Resetn,Q=>Temp_dpo(2));
      O_Dpo3:D_PO port map(Din=>Temp_sum(3),Cl=>Clock,Rn=>Resetn,Q=>Temp_dpo(3));            
      O_Dpo4:D_PO port map(Din=>Temp_cout,Cl=>Clock,Rn=>Resetn,Q=>Cout);                  
   end beh; 
      