data segment
kalk    db 13,10,'ͻ'
        db 13,10,' J E D N O D U C H A   K A L K U L A C K A '
        db 13,10,'ͼ$'
text1   db 13,10,'Zadaj $'
text2   db '.cslo (065535): $'
znova   db 13,10,10,'Chces zadat znovu? (A=no, N=nie)$'
chyba1  db 7,13,10,'Chyba! Nezadal si cslo.$'
chyba2  db 7,13,10,'Chyba! Zadal si velk cslo.$'
chyba3  db 'Chyba! Nastal prenos.$'
chyba4  db 'Chyba! Delenie nulou.$'
zvysok  db '   zvysok = $'
scitanie  db ' + $'
odcitanie db ' - $'
nasobenie db ' * $'
delenie   db ' / $'
rovna_sa  db ' = $'
new_line  db 13,10,'$'
vst     db 6,7 dup (?)
cislo1  dw ?
cislo2  dw ?
data ends

code segment
assume cs:code,ds:data
start:  mov ax,seg data
        mov ds,ax
        mov ah,9
        mov dx,offset kalk
        int 21h
start1: mov ah,9
        mov dx,offset new_line
        int 21h
        mov ch,2                ;pocitadlo; ch=2 cislo1 , ch=1 cislo2
znovu:  mov ah,9
        mov dx,offset text1
        int 21h
        mov ah,2
        mov dl,ch
        xor dl,3                ;negacia dl; DL=1 <- ak DL=2; DL=2 <- ak DL=1
        or dl,30h
        int 21h
        mov ah,9
        mov dx,offset text2
        int 21h
        mov ah,0ah
        mov dx,offset vst
        int 21h                 ;nacit. vst1 cisla
        mov si,dx
        mov cl,[si+1]           ;pocet skutocne nacit. znakov
        add si,2                ;si=prvy znak
cyk1:   cmp byte ptr [si],'0'
        jb error1
        cmp byte ptr [si],'9'
        jbe dalej1
error1: mov ah,9
        mov dx,offset chyba1
        int 21h
        jmp znovu
dalej1: inc si
        dec cl
        jnz cyk1
        mov si,offset vst+2
        mov cl,[si-1]           ;pocet skutocne nacit. znakov
        xor ax,ax               ;cislo
cyk2:   mov bx,10
        mul bx
        cmp dx,0                ;nenastalo prenos do DX
        jz dalej2
error2: mov ah,9
        mov dx,offset chyba2
        int 21h
        jmp znovu
dalej2: and byte ptr [si],0fh
        add al,[si]
        adc ah,0
        jc error2               ;ak CF=1 nastal prenos
        inc si
        dec cl
        jnz cyk2
        cmp ch,2
        jnz dalej3
        mov cislo1,ax
dalej3: dec ch
        jnz znovu
        mov cislo2,ax
        mov ah,9                ;********** Scitanie **********
        mov dx,offset new_line
        int 21h
        mov dx,offset new_line
        int 21h
        mov ax,cislo1
        call prevod
        mov ah,9
        mov dx,offset scitanie
        int 21h
        mov ax,cislo2
        call prevod
        mov ah,9
        mov dx,offset rovna_sa
        int 21h
        mov ax,cislo1
        add ax,cislo2
        jnc sem1
        mov ah,9
        mov dx,offset chyba3
        int 21h
        jmp skok1
sem1:   call prevod
skok1:  mov ah,9                ;********** Odcitanie **********
        mov dx,offset new_line
        int 21h
        mov ax,cislo1
        call prevod
        mov ah,9
        mov dx,offset odcitanie
        int 21h
        mov ax,cislo2
        call prevod
        mov ah,9
        mov dx,offset rovna_sa
        int 21h
        mov ax,cislo1
        sub ax,cislo2
        jnc sem2
        mov ah,9
        mov dx,offset chyba3
        int 21h
        jmp skok2
sem2:   call prevod
skok2:  mov ah,9                ;********** Nasobenie **********
        mov dx,offset new_line
        int 21h
        mov ax,cislo1
        call prevod
        mov ah,9
        mov dx,offset nasobenie
        int 21h
        mov ax,cislo2
        call prevod
        mov ah,9
        mov dx,offset rovna_sa
        int 21h
        mov ax,cislo1
        mul cislo2
        cmp dx,0                ;ak DX=0 nenastal prenos
        jz sem3
        mov ah,9
        mov dx,offset chyba3
        int 21h
        jmp skok3
sem3:   call prevod
skok3:  mov ah,9                ;********** Delenie **********
        mov dx,offset new_line
        int 21h
        mov ax,cislo1
        call prevod
        mov ah,9
        mov dx,offset delenie
        int 21h
        mov ax,cislo2
        call prevod
        mov ah,9
        mov dx,offset rovna_sa
        int 21h
        mov ax,cislo1
        xor dx,dx
        cmp cislo2,0            ;delenie nulou
        ja sem4
        mov ah,9
        mov dx,offset chyba4
        int 21h
        jmp skok4
sem4:   div cislo2
        push dx
        call prevod
        mov ah,9
        mov dx,offset zvysok
        int 21h
        pop ax
        call prevod
skok4:  mov ah,9                ;********** Skoncit? **********
        mov dx,offset znova
        int 21h
stlac:   mov ah,7
        int 21h                 ;caka na stlac klav. AL=stlaceny znak
        cmp al,0
        ja tam2
        int 21h
        jmp stlac
tam2:   cmp al,'a'
        jnz tam
tam1:   jmp start1
tam:    cmp al,'A'
        jz tam1
        cmp al,'n'
        jz koniec
        cmp al,'N'
        jnz stlac
koniec: mov ax,4c00h
        int 21h


prevod  proc near               ;vst.:  AX = cislo
                                ;vyst.: vypisane cislo na obr.
        mov bx,10000
prevod1:xor dx,dx
        div bx                  ;DX=zvysok AX=cislo <- DX:AX / 10
        push dx
        mov ah,2
        mov dl,al
        or dl,30h
        int 21h
        mov ax,bx
        xor dx,dx
        mov bx,10
        div bx                  ;DX=zvysok AX=cislo <- DX:AX / 10
        mov bx,ax
        pop ax
        cmp bx,10
        jae prevod1
        mov ah,2
        mov dl,al
        or dl,30h
        int 21h                 ;posledna cifra
        ret
prevod endp

code ends
end start