;ZADANIE c.2
;Vytvorte  program,  ktory  nacita  z  textoveho suboru postupnost
;celych cisel (aspon 10) so znamienkom  v desiatkovej ciselnej sustave,
;potom ich transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom
;kode a potom podla priania pouzivatela:
;A:
;a) vypocita sumu  vsetkych cisel a vypise ju
;b) usporiada cisla vzostupne resp. zostupne a zapise usporiadanu postupnost
;   cisel do noveho textoveho suboru,
;c) vydeli dve vybrane cisla a vypise vysledok
;d) vynasobi dve cisla a vypise vysledok
;e) ukonci vykonavanie programu.

; Tibor Szabo
; 2.rocnik

ZAS SEGMENT STACK 'STACK'
        DW      100    DUP(?)
ZAS ENDS

DATA SEGMENT
        MENU    DB      10,13,'MENU:',10,13
		DB	'<1> Sucet prvkov',10,13
                DB      '<2> Usporiadanie prvkov vzostupne',10,13
                DB      '<3> Nasobenie dvoch prvkov',10,13
                DB      '<4> Delenie dvoch prvkov',10,13
		DB	'<5> Vypis nacitanych cisel',10,13
                DB      '<6> Koniec programu',10,13,'$'
        ERROR   DB      10,13,'Chyba pri citani vstupneho suboru!',10,13,'$'
        ERROR1  DB      10,13,'Chyba pri zapise do suboru!',7,10,13,'$'
        ERROR2  DB      10,13,'Nulou sa nedeli!',7,10,13,'$'
        ERROR3  DB      10,13,'Zadany prvok neexistuje!',10,13,'$'
        DOKOPY  DB      10,13,'Sucet prvkov je ','$'
        TOK     DB      10,13,'Pretecenie! ',10,13,'$'
        PODEL   DB      10,13,'Podiel prvkov je ','$'
        ZVYSOK  DB      10,13,'Zvysok po deleni je ','$'
        ZADAJ   DB      10,13,'Zadaj pismena cisel. ',10,13,'$'
	SUCINX	DB	10,13,'Vysledok sucinu je ','$'
        NACIT   DB      'Nacitane prvky:',10,13,10,13,'$'
        NADOL   DB      'Vzostupne usporiadanie cisel: ',10,13,10,13,'$'
        VSTUP   DB      'A:\VSTUP.TXT',0
        VYSTUP  DB      'A:\VYSTUP.TXT',0
        BAFER   DB      100 DUP(?)  
        CISEL   DW      50 DUP(?)     
        FHAND   DW      0                     
        ZNAKOV  DB      0       
        POCET   DW      0                
        RAD     DW      0               
        PRETOK  DW      0               
        HORSA   DW      0               
        DOLSA   DW      0               
        ZAPOR   DB      0             
DATA ENDS

CODE SEGMENT
        ASSUME DS:DATA,CS:CODE,SS:ZAS

START:  CALL NACITAJ			;nacitanie dat zo vstupneho suboru
        CALL KONVERT            	;konverzia retazca na pole znakov

MENUX:  CALL VYMAZ
	MOV AX,SEG MENU			;vypis menu
        MOV DS,AX			;
        MOV DX, OFFSET MENU		;
        CALL RETPIS                     ;vypis menu
CYK:    MOV AH,8                        ;nacitany ZNAKX vracia v AL
        INT 21H				;volanie sluzby DOS-u
	CMP AL,31H			;porovnava s cislami
	JE MEDZI1			;	
	CMP AL,32H			;ak sa rovna, skoci
	JE MEDZI2			;
	CMP AL,33H			;
	JE MEDZI3			;	
	CMP AL,34H			;
	JE MEDZI4			;
	CMP AL,35H			;
	JE MEDZI5			;
	CMP AL,36H			;
	JE KONIEC			;
	JMP CYK				;skok do cyklu	

MEDZI1: CALL SUCET			;volanie procedury
        JMP MENUX			;skok do menu
MEDZI2:	CALL VYMAZ			;
	CALL ZORADIT			;
        JMP MENUX			;
MEDZI3: CALL VYMAZ			;
	CALL NASOBIT			;
        JMP MENUX			;
MEDZI4: CALL VYMAZ			;
	CALL DELIT			;
        JMP MENUX			;
MEDZI5: CALL VYMAZ			;vymaze obrazovku			
	CALL VYPCIS			;
	JMP MENUX			;skok do menu

;*** vypis cisel ****
VYPCIS	PROC NEAR
	MOV DX,SEG DATA	        	;vypis textu
        MOV DS,DX			;  
        MOV DX,OFFSET NACIT		;
        CALL RETPIS			;vypis retazca
        CALL VYPISC                     ;vypis cisel zo vstupneho suboru
	CALL DALEJ			;
	RET				;navrat
VYPCIS	ENDP				;koniec proc.	

;*** opusti program ***
KONIEC	PROC NEAR
	CALL VYMAZ			;vymazanie obrazovky
	MOV AX,4C00H			;koniec	
        INT 21H
KONIEC ENDP

;*** vymaze obrazovku ***
VYMAZ	PROC NEAR
	PUSH AX				;ulozenie AX do stacku
	MOV AX, 03H			;vymazanie obrazovky
	INT 10H				;volanie sluzby DOS-u 
	POP AX
	RET				;navrat z procedury
VYMAZ ENDP				;koniec procedury

;*** vypis retazca ***
RETPIS  PROC NEAR			;procedura 
        PUSH AX				;ulozenie reg. AX
        MOV AH,9                	;ocakava pripravenost dat na DS:DX
        INT 21H				;volanie sluzby DOS-u
        POP AX				;vyber reg. AX zo stacku
        RET				;koniec procedury	
RETPIS	ENDP

;*** novy riadok ***
RIADOK	PROC NEAR
	PUSH AX				;ulozenie AX do stacku
	PUSH DX				;ulozenie DX do stacku
	MOV AH,02H			;do AH ide zac. riadku
	MOV DL,0DH			;do DL ide enter
	INT 21H				;volanie sluzby DOS-u
	MOV AH,02H			;do AH ide zac. riadku
	MOV DL,0AH			;do DL ide enter
	INT 21H				;volanie sluzby DOS-u
	POP DX				;vybratie DX zo stacku
	POP AX				;vybratie AX zo stacku
	RET				;navrat z procedury
RIADOK ENDP				;koniec procedury	

;*** vypis znaku ***
ZNAKPIS PROC NEAR                       ;procedura pre vypis znaku
        PUSH AX				;ulozenie reg. AX
        MOV AH,2                        ;ocakava pripravenost dat v DL
        INT 21H				;volanie sluzby DOS-u
        POP AX				;vyber reg. AX zo stacku
        RET				;navrat z procedury
ZNAKPIS ENDP				;koniec procedury	

;*** nacitanie znaku ***
CAKAJ PROC NEAR                         ;procedura pre nacitanie 1 znaku
        MOV AH,8                        ;nacitany ZNAKX vracia v AL
        INT 21H				;volanie sluzby DOS-u
        RET				;navrat z procedury
CAKAJ ENDP				;koniec procedury	

;*** program ide dalej *** 
DALEJ PROC NEAR                         ;procedura pre POKRACOVANIE
        PUSH AX				;ulozenie reg. AX
        MOV AH,8                        ;nacitany ZNAKX vracia v AL
        INT 21H				;volanie sluzby DOS-u
        POP AX				;vyber reg. AX zo stacku
        RET				;navrat z procedury
DALEJ ENDP				;koniec procedury	

;*** nacitanie cisel ***
NACITAJ PROC NEAR                         
        MOV AX,SEG DATA			;vypis textu
        MOV DS,AX			;
        MOV DX,OFFSET VSTUP		;
        MOV AH,3DH                      ;otvorenie vstupneho suboru
        MOV AL,0			;atribut otvarenia
        INT 21H				;
        JNC NASLO			; 
        MOV AX,SEG DATA                 ;vypis chyby
        MOV DS,AX			;
        MOV DX,OFFSET ERROR		;
        CALL RETPIS			;
        CALL KONIEC			;koniec
NASLO:  MOV FHAND,AX                    ;uloz filehandle
        MOV AX,SEG DATA			;
        MOV DS,AX			;
        MOV DX,OFFSET BAFER		;
        MOV AH,3FH                      ;citaj zo subora
        MOV BX,FHAND			;
        MOV CX,100H			;100 nacitanych znakov
        INT 21H                         ;
        JNC ZATVOR                      ;
        MOV AX,SEG DATA                 ;vypis chyby
        MOV DS,AX			;
        MOV DX,OFFSET ERROR		;
        CALL RETPIS			;
        CALL KONIEC			;koniec
ZATVOR: MOV ZNAKOV, AL                  ;pocet nacitanych znakov
        MOV AH,3EH                      ;zatvorenie vstupneho suboru
        MOV BX,FHAND			;
        INT 21H				;
        CMP ZNAKOV,0                    ;porovnanie
        JNE END1                        ;
        MOV AX,SEG DATA			;vypis chyby	
        MOV DS,AX			;
        MOV DX,OFFSET ERROR		;
        CALL RETPIS			;
        CALL KONIEC			;koniec
END1:   RET				;navrat
NACITAJ ENDP				;koniec proc.

;*** zmena ret. na cislo ***
ZMENA PROC NEAR                         
        PUSH AX                         ;ulozenie reg.
        PUSH BX				;
        PUSH CX				;
        PUSH DX				;	
        MOV CX,0                        ;nulovanie poctu
        XOR DX,DX			;
        MOV RAD,1                       ;nastavenie 1
        DEC BX				;dekrem.
SPET1:  DEC BX                          ;
        MOV AX,OFFSET BAFER             ;zac. retazca
        CMP AX,BX			;porovnanie
        JG EXI1                         ;
        XOR AX,AX			;nulovanie
        MOV AL,[BX]                     ;
        CMP AL,'0'                      ;porovnanie
        JL EXI1				;
        CMP AL,'9'			;porovnanie
        JG EXI1                         ;
        SUB AL,'0'                      ;ascii hodnota
        CMP AL,0                        ;porovnanie
        JE EXI3                         ;
SPET2:  ADD DX,RAD                      ;pripocitanie
        DEC AL				;dekrem.
        JNZ SPET2			;
EXI3:   MOV AX,RAD                      ;
        PUSH BX				;ulozenie reg.
        MOV BL,10			;
        MUL BL				;nasobenie
        POP BX				;
        CMP RAD,1000			;porovnanie
        JNE EXI4			;
        MOV AX,10000			;
EXI4:   MOV RAD,AX			;
        INC CX                          ;inkrementovanie
        JMP SPET1                       ;
EXI1:   JCXZ ENDE                       ;koniec, ak nebola konverzia
        CMP AL,'-'                      ;je pred cislom - 
        JNE EXI2                        ;
        NEG DX                          ;zmenu cisla na zaporne
EXI2:   MOV BX,OFFSET CISEL             ;zapis cisla do pola 
        ADD BX,POCET                    ;adresu pridavaneho prvku
        ADD BX,POCET
        INC POCET                       ;inkrem.
        MOV [BX],DX                     ;uloz cislo 
ENDE:   POP DX				;vyvolanie reg.
        POP CX				;
        POP BX				;
        POP AX				;
        RET				;navrat
ZMENA ENDP				;koniec

;*** konverzia buffera na cisla ***
KONVERT PROC NEAR 	       
        MOV BX,OFFSET BAFER   		;adresa
        XOR CX,CX			;nulovanie 
        MOV CL,ZNAKOV           	;pocet nacitanych znakov
NASPAT1:MOV AL,[BX]             	;natiahni znak
        INC BX               		;inkrem.
        CMP AL,'-'              	;porovnanie
        JE DALE1                	;
COJE:   CMP AL,'0'              	;porovnanie
        JL ZNAKX			;
        CMP AL,'9'			;porovnanie
        JG ZNAKX                	;
        JMP DALE1              		;ak ano, testuj dalsi ZNAKX
ZNAKX:  CALL ZMENA           		;znak na cislo a zapis do pola
DALE1:  LOOP NASPAT1  		        ;opakuj 
        INC BX				;inkrem.
        CALL ZMENA	                ;prevod
        RET				;navrat
KONVERT ENDP				;koniec proc.

;*** vypise cislo ***
CISLOPIS PROC NEAR              
        PUSH AX         	        ;ulozenie reg.
        PUSH BX				;
        PUSH CX				;
        PUSH DX				;
        MOV BX,OFFSET BAFER     	;nastavenie
        MOV ZNAKOV,0            	;nastavenie 0
        CMP AX,0                	;je zaporne?
        JGE POROV1              	;ak nie, skok
        NEG AX                  	;negacia
        MOV DL,'-'              	;vypis znaku
        CALL ZNAKPIS			;
        MOV [BX],DL             	;zapis minusky
        INC BX				;inkrementovanie
        INC ZNAKOV              	;
POROV1: MOV DL,0			;nastavenie 0
        CMP AX,10000            	;porovnanie 
        JL TISIC                	;skok
MIN1:   SUB AX,10000            	;odcitanie 10000
        INC DL				;inkrem.
        CMP AX,0			;porovnanie
        JG MIN1				;skok
        ADD AX,10000            	;pricitanie pos. odcitania
        DEC DL                  	;dekrement DL
        ADD DL,'0'              	;ascii hodnota
        CALL ZNAKPIS            	;vypis znaku
        MOV [BX],DL             	;ulozenie znaku
        INC BX				;inkrem.
        INC ZNAKOV			;inkrem.
TISIC:  MOV DL,0                	;nulovanie
        CMP AX,1000			;porovnanie
        JL STO				;
MIN2:   SUB AX,1000			;odcitanie
        INC DL				;inkrem.
        CMP AX,0			;porovnanie
        JG MIN2				;
        ADD AX,1000			;pripocitanie
        DEC DL				;dekrem.
        ADD DL,'0'			;ascii
        CALL ZNAKPIS			;vypis znaku
        MOV [BX],DL			;ulozenie znaku	
        INC BX				;inkrem.
        INC ZNAKOV			;	
STO:    MOV DL,0                	;nulovanie
        CMP AX,100			;porovnanie
        JL DESAT			;
MIN3:   SUB AX,100			;odcitanie
        INC DL				;inkrem.
        CMP AX,0			;porovnanie
        JG MIN3				;
        ADD AX,100			;pripocitanie
        DEC DL				;dekrem.
        ADD DL,'0'			;ascii	
        CALL ZNAKPIS			;vypis znaku
        MOV [BX],DL			;ulozanie znaku
        INC BX				;imkrem.
        INC ZNAKOV			;	
DESAT:  MOV DL,0                	;nulovanie
        CMP AX,10			;porovnanie
        JL JEDNA			;
MIN4:   SUB AX,10			;odcitanie
        INC DL				;inkrem.
        CMP AX,0			;porovnanie
        JG MIN4				;
        ADD AX,10			;pripocitanie
        DEC DL				;dekrem.
        ADD DL,'0'			;ascii
        CALL ZNAKPIS			;vypis znaku
        MOV [BX],DL			;ulozenie
        INC BX				;inkrem.	
        INC ZNAKOV			;
JEDNA:  MOV DL,AL               	;
        ADD DL,'0'			;ascii
        CALL ZNAKPIS			;vypis
        MOV [BX],DL			;ulozenie
        INC BX				;inkrem.
        INC ZNAKOV			;
        MOV DL,10               	;odriadkovanie
        MOV [BX],DL			;
        INC BX				;
        INC ZNAKOV			;
        MOV DL,13			;
        MOV [BX],DL			;
        INC ZNAKOV			;
        POP DX				;vyvolanie reg.
        POP CX				;
        POP BX				;
        POP AX				;
        RET				;navrat
CISLOPIS ENDP				;koniec

;*** vypise vsetky cisla ***
VYPISC PROC NEAR                        ;procedura 
        PUSH DX                         ;ulozenie do stacku 
        PUSH BX				;
        PUSH AX				;
        MOV BX,OFFSET CISEL             ;do BX ide adresa pola cisiel
        MOV CX,POCET                    ;do CX ide pocet cisiel
REPETE: MOV AX,[BX]                     ;natiahni cislo z pola
        ADD BX,2                        ;zvys adresu dalsieho cisla
        CALL CISLOPIS                   ;vypis cislo
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        LOOP REPETE                     ;skoc na dalsie cislo
        CALL RIADOK			;novy riadok
        POP AX				;vyvolanie reg.
        POP BX				;
        POP DX				;
        RET				;navratz proc.
VYPISC ENDP				;koniec proc.

;*** sucet cisel ***
SUCET PROC NEAR                         
        MOV PRETOK,0                    ;nastavenie na 0
        XOR AX,AX                       ;
        MOV CX,POCET                    ;
        MOV BX,OFFSET CISEL             ;adresa cisiel
OPAKUJ: ADD AX,[BX]                     ;pripocitaj cislo k AX 
        ADD BX,2			;pripocitaj 2
        LOOP OPAKUJ                     ;skoc na dalsie cislo
        MOV DX,SEG DATA			;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET DOKOPY		;
        CALL RETPIS			;
        CALL CISLOPIS                   ;vypis suctu
	CALL RIADOK			;novy riadok	
        CMP PRETOK,0                    ;porovnanie
        JE END2                         ;
        MOV DX,SEG DATA	                ;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET TOK		;
        CALL RETPIS			;
END2:   CALL DALEJ                      ;caka na klavesu
        RET				;navrat
SUCET ENDP				;koniec proc.

;*** vypis prvkov ***
VYSTPIS PROC NEAR    
        PUSH DX                         ;ulozenie reg.
        PUSH BX				;
        PUSH AX				;
        MOV AH,3CH                      ;vytvor subor
        XOR CX,CX			;nulovanie
        MOV DX,SEG DATA			;meno vyst. sub.
        MOV DS,DX			;
        MOV DX,OFFSET VYSTUP		;
        INT 21H				;
        JNC ZNACIT                      ;
        MOV AX,0                        ;nulovanie AX
        MOV DX,SEG DATA			;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET ERROR1		;
        CALL RETPIS			;
ZNACIT: MOV FHAND,AX                    ;ulozenie filehandle
        MOV BX,OFFSET CISEL		;nastavenie adr.	
        MOV CX,POCET			;nastavenie poctu
ZOSUB:  MOV AX,[BX]                     ;cislo z retazca
        ADD BX,2			;posun o 2
        CALL CISLOPIS                   ;vypis 
        MOV AH,40H			;	
        PUSH BX				;ulozenie reg.
        MOV BX,FHAND			;
        PUSH CX				;ulozenie reg.
        XOR CX,CX			;
        MOV CL,ZNAKOV			;nastavenie poctu znakov
        MOV DX,SEG DATA			;vypis textu	
        MOV DS,DX                       ;
        MOV DX,OFFSET BAFER             ;
        INT 21H                         ;
        POP CX				;vyvolanie reg.
        POP BX				;
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        LOOP ZOSUB		        ;opakuj pre vsetky cisla
	CALL RIADOK			;skok do dalsieho riadku
        MOV AH,3EH                      ;zatvorenie vystupneho subora
        MOV BX,FHAND			;
        INT 21H				;
        POP AX				;vyvolanie registrov
        POP BX				;	
        POP DX				;	
        RET				;skok z proc.
VYSTPIS ENDP				;koniec proc.

;*** vzostupne zoradenie ***
ZORADIT PROC NEAR            
        MOV DX,SEG DATA			;nastavenie adresy retazca
        MOV DS,DX			;
        MOV DX,OFFSET NADOL		;
        CALL RETPIS			;volanie vypisu retazca	
        MOV CX,POCET			;do CX ide pocet
        MOV BX,OFFSET CISEL		;
        MOV HORSA,0                     ;nulovanie 
        MOV DOLSA,0                     ; 
ZOR1:   PUSH BX                         ;ulozenie reg.   
        ADD BX,HORSA                    ;do BX ide horsa   
        MOV AX,[BX]                     ;adresa BX    
        POP BX                          ;vyvolanie reg.    
        PUSH BX                         ;ulozenie reg.     
        ADD BX,DOLSA                    ;do BX ide dolsa   
        MOV DX,[BX]                     ;adresa BX    
        POP BX				;vyvolanie reg.
        ADD DOLSA,2			;posunutie dolsa
        CMP AX,DX			;porovnanie
        JLE ZOR2			;skok
        PUSH BX				;ulozenie reg. 
        ADD BX,HORSA			;do BX ide horsa
        MOV [BX],DX			;na adr. BX ide DX
        POP BX				;vyvolanie reg. 
        PUSH BX				;ulozenie reg. 
        ADD BX,DOLSA			;posun o dolsa
        SUB BX,2			;minus 2
        MOV [BX],AX			;na adr. Bx ide AX	
        POP BX				;vyvolanie reg. 
ZOR2:   MOV AX,POCET			;do AX ide pocet
        ADD AX,POCET			;pripocitanie
        CMP DOLSA,AX			;porovnaie
        JL ZOR1				;	
        ADD HORSA,2			;pripocitanie 2
        MOV AX,HORSA			;presun
        MOV DOLSA,AX			;
        LOOP ZOR1			;skok
        CALL VYSTPIS                    ;vypis do suboru
        CALL DALEJ			;caka na klavesu
        RET				;navrat z proc.
ZORADIT ENDP				;koniec proc

;*** nasobenie cisel ***
NASOBIT PROC NEAR
        MOV BX,OFFSET CISEL		;nastavenie adresy
        MOV CX,POCET			;nastavenie poctu
        MOV DL,'A'			;do DL ide A
REPET1: MOV AX,[BX]                     ;nastavenie cisla
        ADD BX,2			;pripocitanie 2
        CALL ZNAKPIS			;vypis znaku
        MOV DH,DL			;pismeno do DH
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        MOV DL,'='			;vypis rovna sa
        CALL ZNAKPIS			;
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        CALL CISLOPIS			;vypis cisla
        CALL RIADOK			;posun o riadok
        MOV DL,DH			;do DL ide pismeno
        INC DL				;inkrementovanie
        LOOP REPET1			;skok
	CALL RIADOK			;novy riadok
        MOV DX,SEG DATA			;vypis retazca
        MOV DS,DX			;
        MOV DX,OFFSET ZADAJ		;	
        CALL RETPIS			;
        MOV CX,2			;pripocitanie 2
REPET2: CALL CAKAJ			;nacitanie pismena
        MOV AH,0			;porovnanie
        CMP AL,90                       ;ci bolo stlacene povolene pismeno
        JNG NAS2                        ;skok 
        SUB AL,'a'                      ;
        JMP NAS3                        ;skok
NAS2:   SUB AL,'A'                      ;
NAS3:   CMP AL,0			;porovnaie s 0
        JL CHYB1			;skok
        CMP AX,POCET			;porovnanie s postom	
        JGE CHYB1			;skok	
        MOV BX,OFFSET CISEL		;
        ADD BX,AX                       ;vyratanie adresy zvoleneneho
        ADD BX,AX                       ;
        MOV AX,[BX]			;ulozenie adr.
        CMP CX,2			;porovanie s 2
        JNE NAS1			;skok
        MOV DX,AX			;AX ide do DX
NAS1:   LOOP REPET2			;skok
        JMP NAS10			;preskok chyby
CHYB1:  MOV DX,SEG DATA	                ;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET ERROR3		;
        CALL RETPIS			;
        JMP END3			;koniec
NAS10:  MOV BX,DX			;
        XOR DX,DX			;nulovanie	
        MOV ZAPOR,0                     ;nastavenie 0
        CMP AX,0                        ;porovnanie s 0
        JNL NAS4                        ;ak je kladne, skok
        MOV ZAPOR,1                     ;nastavenie 1
        NEG AX                          ;vypis ako kladne cislo
NAS4:   CMP BX,0                        ;porovnanie s 0
        JNL NAS5			;ak zaporne, skok
        CMP ZAPOR,1			;porovnanie
        JNE NAS9			;skok
        MOV ZAPOR,0			;nastavenie 0
        JMP NAS8			;skok
NAS9:   MOV ZAPOR,1			;nastavenie 1
NAS8:   NEG BX				;negacia
NAS5:   MUL BX                          ;nasobenie 
        JC NAS12			;skok
        TEST ZAPOR,1			;test
        JZ NAS7				;skok
        NEG AX				;negacia
NAS7:	MOV DX,SEG DATA	                ;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET SUCINX		;
        CALL RETPIS			;
        CALL CISLOPIS			;vypis cisla
	JMP END3			;skok
NAS12:  MOV DX,OFFSET TOK		;vypis retazca	
        CALL RETPIS			;
END3:   CALL CAKAJ			;caka na klavesu
        RET				;navrat
NASOBIT ENDP				;koniec

;*** delenie ***
DELIT PROC NEAR                         
        MOV BX,OFFSET CISEL		;nastavenie adr.
        MOV CX,POCET			;nastavenie poctu
        MOV DL,'A'			;do DL ide A
ZOPAK1: MOV AX,[BX]                     ;nastavenie cisla
        ADD BX,2			;pripocitanie 2
        CALL ZNAKPIS			;vypis znaku
        MOV DH,DL			;pismeno do DH
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        MOV DL,'='			;vypis rovna sa
        CALL ZNAKPIS			;
        MOV DL,' '			;vypis medzery
        CALL ZNAKPIS			;
        CALL CISLOPIS			;vypis cisla
        CALL RIADOK			;posun o riadok
        MOV DL,DH			;do DL ide pismeno			
        INC DL				;inkrementovanie
        LOOP ZOPAK1			;skok
	CALL RIADOK			;novy riadok	  
        MOV DX,SEG DATA	                ;vypis retazca
        MOV DS,DX			;
        MOV DX,OFFSET ZADAJ		;
        CALL RETPIS			;
        MOV CX,2			;pripocitanie 2
ZOPAK2: CALL CAKAJ			;nacitanie pismena
        MOV AH,0			;porovnanie
        CMP AL,90                       ;ci bolo stlacene povolene pismeno
        jng DELI2                       ;skok 
        SUB AL,'a'                      ;
        JMP DELI3                       ;skok 
DELI2:  SUB AL,'A'                      ; 
DELI3:  CMP AL,0			;porovnaie s 0
        JL CHYBA3			;skok
        CMP AX,POCET			;porovnanie s poctom	
        JGE CHYBA3			;skok
        MOV BX,OFFSET CISEL		;
        ADD BX,AX                       ;vyratanie adresy 
        ADD BX,AX                       ;
        MOV AX,[BX]			;ulozenie adr.
;        CALL CISLOPIS			;vypis cisla			
        CMP CX,2			;porovnanie
        JNE DELI1			;skok
;        MOV DL,'/'
;        CALL ZNAKPIS
        MOV DX,AX
DELI1:  LOOP ZOPAK2			;skok
        JMP DELI10			;skok
CHYBA2: MOV DX,SEG DATA	               ;vypis chyby
        MOV DS,DX			;
        MOV DX,OFFSET ERROR2		;	
        CALL RETPIS			;
        JMP END4			;koniec
CHYBA3: MOV DX,SEG DATA	               ;vypis chyby
        MOV DS,DX			;
        MOV DX,OFFSET ERROR3		;
        CALL RETPIS			;
        JMP END4			;koniec
DELI10: XCHG AX,DX			;vymena	
        CMP DX,0                        ;porovnanie s 0?
        JE CHYBA2                       ;skok
        MOV BX,DX			;
        XOR DX,DX			;nulovanie
        MOV ZAPOR,0                     ;nastavenie 0
        CMP AX,0                        ;porovnanie
        JNL DELI4                       ;skok
        MOV ZAPOR,1                     ;nastavenie 0
        NEG AX                          ;negacia
DELI4:  CMP BX,0                        ;porovnanie
        JNL DELI5			;skok
        CMP ZAPOR,1			;porovnaie
        JNE DELI9			;skok
        MOV ZAPOR,0			;nastavenie 0
        JMP DELI8			;skok
DELI9:  MOV ZAPOR,1			;nastavenie 1
DELI8:  NEG BX				;negacia
DELI5:  DIV BX                          ;delenie
        PUSH DX                         ;zvysok po deleni je DX
        PUSH AX                         ;celocielny podiel je AX
        MOV DX,SEG DATA			;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET PODEL		;
        CALL RETPIS			;
        POP AX				;vyvolanie AX
        TEST ZAPOR,1			;test
        JZ DELI6			;preskok
        NEG AX				;negacia
DELI6:  CALL CISLOPIS                   ;vypis podielu 
        MOV DX, SEG DATA		;vypis textu
        MOV DS,DX			;
        MOV DX,OFFSET ZVYSOK		;	
        CALL RETPIS			;
        POP AX				;vyvolanie AX
        TEST ZAPOR,1			;test
        JZ DELI7			;preskok
        NEG AX				;negacia
DELI7:  CALL CISLOPIS			;vupis cisla
END4:   CALL CAKAJ			;caka na klavesu
        RET				;navrat
DELIT ENDP				;koniec

CODE	ENDS
	END START