;Zadanie c.1.
;Text zadania: Napiste program, ktory nacita z klavesnice retazec znakov
;        (max.100 znakov) a podla  menu vykona  jednu z moznosti:
;                a) vypise retazec znakov na obrazovku
;                b) vypise poradove cislo miesta, kde sa nachadza prvy krat znak nacitany
;                    z klavesnice,ak ho nenajde vypise o tom spravu.
;                c) vypise retazec v obratenom porad,
;                d) vypise pocet cislic v retazci
;                e) male pismena konvertuje na velke
;                f) velke pismena konvertuje na male
;                g) ukonci vykonavanie programu.
;         Po vykonani zvolenej moznosti sa program vrati na vypis menu.
;



;Autor:  Marek Catlos
;Termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001




title z

;;;;;;;;;;;;;; data seg ;;;;;;;;;;;;;;;

data    segment
menu    db      'Zadaj jednu z moznosti',10,13
	db      'A - Vypis retazca na obrazovku',10,13
	db      'B - Zistenie poradovne cisla zadaneho znaku v retazci',10,13
	db      'C - Vypis retazca v obratenom poradi',10,13
	db      'D - Zistenie poctu cislic v retazci',10,13
	db      'E - Konverzia malych pismen na velke',10,13
	db      'F - Konverzia velkych pisme na male',10,13
	db      'Q - Ukoncenie programu',10,13,'$'

vypZRet db      ' Zadaj retazec na spracovanie do 100 znakov',10,13,'$'
vypZZnak db     ' Zadaj hladany znak',10,13,'$'
vypNZnak db     ' zadany znak sa v retazci nenachadza',10,13,'$'
vypPC   db      ' poradove cislo zadaneho znaku je',10,13,'$'
vypRet  db      ' Zadany retazec je :',10,13,'$'
vypObr  db      ' Obrateny retazec je :',10,13,'$'
vypPCis db      ' Pocet cislic v danom retazci je :',10,13,'$'
vypKRe  db      ' Novy retazec je :',10,13,'$'


NR      db      10,13                           ; novy riadok 
konZn   db      '$'                             ; koncovy znak
cisla   db      '0123456789'                    ; pouzite na vypis cislic
buff    db      3 dup(?),10,13,'$'              ; buffer na cisla

retazec db      101                                 ;max pocet znakov (+ enterom)
pocet   db      ?                                   ;jeho info o pocte nac znakov
retaz   db      103 dup (?)                         ;3 znaky na novy riadok a '$'
rVel    db      103 dup (?)                         ;retazec velkych pismen
rMal    db      103 dup (?)                         ;retazec malych pismen

data    ends

;;;;;;;;; code seg ;;;;;;;;;;;;;;;

code    segment
@start: assume  ds:data,cs:code
	mov     ax,     seg data                ;init ds registra
	mov     ds,     ax

	mov     dx,     offset vypZRet          ; vypis zadaj ret s ktorym sa bude...
	mov     ah,     09h                     ; vypis retazca
	int     21h

	mov     dx,     offset retazec          ; nacitanie retazca
	mov     ah,     0ah
	int     21h

@menu:  mov     dx,     offset menu             ; vypis menu
	mov     ah,     09h
	int     21h

	mov     ah,     01h                     ; nacita znak do al
	int     21h

	cmp     al,     41h                     ;porovnanie s malym a velkym A
	jz      @ulohaA
	cmp     al,     61h
	jz      @ulohaA

	cmp     al,     42h                     ; porovnanie s b a B
	jz      @ulohaB
	cmp     al,     62h
	jz      @ulohaB

	cmp     al,     43h                     ; porovnanie s c a C
	jz      @ulC
	cmp     al,     63h
	jz      @ulC

	cmp     al,     44h                     ; porov s d a D
	jz      @ulD
	cmp     al,     64h
	jz      @ulD

	cmp     al,     45h                     ; porovnanie c e a E
	jz      @ulE
	cmp     al,     65h
	jz      @ulE

	cmp     al,     46h                     ; porovnanie c f a F
	jz      @ulF
	cmp     al,     66h
	jz      @ulF

	cmp     al,     51h                     ; porovnanie s q a Q
	jz      @konie
	cmp     al,     71h
	jz      @konie

@konie: jmp     @koniec               ; pretoze je dlzka podmieneneho skoku          
@ulC:   jmp     @ulohaC               ; obmedzena, pouzivam nepodmieneny skok
@ulD:   jmp     @ulohaD
@ulE:   jmp     @ulohaE
@ulF:   jmp     @ulohaF

;;;;;;;;;;;;;;;; uloha a ;;;;;;;;;;;;;;;;;;

@ulohaA:  ; prida do ret 10,13,'$'
	xor     cx,     cx                      ;nul cx
	mov     cl,     pocet                   ;do cl pocet
	mov     si,     cx
	mov     [retaz+si],10                   ; za retazec da enter + $
	inc     si
	mov     [retaz+si],13
	inc     si
	mov     dl,     konZn
	mov     [retaz+si],dl

	mov     dx,     offset vypRet           ; vypis : Zadany ret je ...
	mov     ah,     09h
	int     21h

	mov     dx,     offset retaz            ; ozaj vypise ret
	mov     ah,     09h
	int     21h
	jmp     @menu                           ;vrati sa do menu

;;;;;;;;;;;;;;;;;;;;;; uloha B ;;;;;;;;;;;;;;;;;

@ulohaB:   ;zisti porad cislo  znaku
	mov     dx,     offset vypZZnak         ; vypis Zadaj hladany znak
	mov     ah,     09h
	int     21h

	mov     ah,     01h                     ; nacita znak do reg al
	int     21h

	xor     si,     si                      ; nul si,cx a nastavi sa na pocet
	dec     si
	xor     cx,     cx
	mov     cl,     pocet

@cykZn: inc     si                              ; porovnava jednotlive zn ret s nacit Zn
	cmp     [retaz+si],al                   ; ak sa nerovnaju hladaj dalej  
	jnz     @loop
	jz      @skoc
@loop:  loop    @cykZn

	jmp     @nZnak                          ; vypis ze znak sa nenachadza

@skoc:  mov     ax,     si                      ; vypise porad cislo znaku
	inc     ax
	mov     si,     3
@slucka2:
	dec     si                              ; prevod cisla z reg ax do bufferu
	mov     bx,     10
	xor     dx,     dx
	div     bx                              ; do ax ulozi celu cast
	mov     di,     dx                      ; do dx ulozi zvysok
	mov     dl,     [cisla+di]
	mov     [buff +si],dl                   ; do bufferu vloz cislicu
        cmp     ax,     0h
	jnz     @slucka2

	mov     dx,     offset vypPC            ; vypis porad cislo znaku je
	mov     ah,     09h
	int     21h

	mov     dx,     offset buff             ; vypis cisla znaku z buffera
	mov     ah,     09h
	int     21h

	jmp     @menu

@nZnak: mov     dx,     offset vypNZnak         ;vypis Hlad znak sa nenachadza
	mov     ah,     09h
	int     21h
	jmp     @menu

;;;;;;;;;;;;;;;;; uloha C ;;;;;;;;;;;;;;;;;;;;

@ulohaC:        ; napise ret v obrat poradi
	mov     dx,     offset vypObr           ; vypis Obrateny ret je:
	mov     ah,     09h
	int     21h

	xor     cx,     cx
	mov     cl,     pocet                   ; do countera vrazi pocet nac znakov

@cykObr:dec     cl
	mov     si,     cx
	mov     dl,     [retaz+si]              ; vypisuje znak po znaku od zadu
	mov     ah,     02h                     ; dekrementuje si
	int     21h
	cmp     cx,     0
	jnz     @cykObr

	mov     dx,     offset NR               ; prida novy riadok
	mov     ah,     09h
	int     21h

	jmp     @menu

;;;;;;;;;;;;;;;;;; uloha D ;;;;;;;;;;;;;;;;;;;;

@ulohaD:        ; zisti poc cislic v retazci
	xor     cx,     cx                      ;nul cx,bx,si
	mov     cl,     pocet                   ; do countra da pocet
	xor     si,     si
	dec     si
	xor     bx,     bx
@cyklC: inc     si
	cmp     [retaz+si],30h                  ;ak hodnota momentalne nast
	jb      @loopC                          ;znaku nie je <30,39> prehladavaj
	cmp     [retaz+si],39h                  ;dalej. ak je zvys bx = counter
	ja      @loopC
	inc     bx
@loopC: loop    @cyklC

	mov     dx,     offset vypPCis
	mov     ah,     09h
	int     21h

	mov     ax,     bx
	mov     si,     3
@cykPr:
	dec     si                              ; prevod cisla z reg ax do bufferu
	mov     bx,     10
	xor     dx,     dx
	div     bx
	mov     di,     dx
	mov     dl,     [cisla+di]
	mov     [buff +si],dl
        cmp     ax,     0h
	jnz     @cykPr

	mov     dx,     offset  Buff            ; vypise poc cislic v retazci
	mov     ah,     09h
	int     21h

	jmp     @menu

;;;;;;;;;;;;;;;;;       uloha E ;;;;;;;;;;;;;;;;;;

@ulohaE:        ;konverzia malych pismen na velke
	mov     dx,     offset retaz            ; dx nastav na zac retazca
	mov     si,     dx
	mov     bx,     offset rVel             ; bx na zaciatok konverzovaneho ret
	xor     ax,     ax                      ; nul ax,cx
	xor     cx,     cx
	mov     cl,     pocet                   ; counter = dlzka retaz
@cykE:  mov     al,     [si]
	cmp     al,     60h                     ;porovnaj s 'A'
	jbe     @skocE                          ; ak je pod A prepis ho do bx
	cmp     al,     7bh                     ; male z
	ja      @skocE

	sub     al,     20h                     ; zvacsi pismeno

@skocE: mov     [bx],   al
	inc     si
	inc     bx
	loop    @cykE

	xor     cx,     cx                      ;nul cx
	mov     cl,     pocet                   ;do cl pocet
	mov     si,     cx                      ;za rvel retazec da enter a $
	mov     [rVel+si],10
	inc     si
	mov     [rVel+si],13
	inc     si
	mov     dl,     konZn
	mov     [rVel+si],dl

	mov     dx,     offset vypKRe           ; vypis Novy retazec je :
	mov     ah,     09h
	int     21h

	mov     dx,     offset rVel             ; vypis konv retazca
	mov     ah,     09h
	int     21h

	jmp     @menu

;;;;;;;;;;;;;;;;; uloha F ;;;;;;;;;;;;;;;;;;;;;

@ulohaF:        ;konverzia velkych pismen na male
	mov     dx,     offset retaz            ; dx nastav na zac retazca
	mov     si,     dx
	mov     bx,     offset rMal             ; bx na zaciatok konverzovaneho ret
	xor     ax,     ax                      ; nul ax,cx
	xor     cx,     cx
	mov     cl,     pocet                   ; counter = dlzka retaz
@cykF:  mov     al,     [si]
	cmp     al,     41h                     ;porovnaj s 'A'
	jbe     @skocF                          ; ak je pod A prepis ho do bx
	cmp     al,     5bh                     ; male z
	ja      @skocF

	add     al,     32                      ; zvacsi pismeno

@skocF: mov     [bx],   al
	inc     si
	inc     bx
	loop    @cykF

	xor     cx,     cx                      ;nul cx
	mov     cl,     pocet                   ;do cl pocet
	mov     si,     cx                      ;za rMal retazec da enter a $
	mov     [rMal+si],10
	inc     si
	mov     [rMal+si],13
	inc     si
	mov     dl,     konZn
	mov     [rMal+si],dl

	mov     dx,     offset vypKRe           ; vypis Novy retazec je :
	mov     ah,     09h
	int     21h

	mov     dx,     offset rMal             ; vypis konvertovaneho retazca
	mov     ah,     09h
	int     21h

	jmp     @menu

@koniec: mov     ax,     4c00h
	int     21h

code    ends
	end     @start


; zhodnotenie:
; Program z.exe je plne funkcny. Bol napisany vo Windows 95 pri simulacii Dosu
; aplikaciou turbo asembler. Vstupne obmedzenia su :
; retazec moze byt dlhy minimalne 1 a maximalne 100 znakov.
; program vyuziva sluzby dosu, Biosu : nacitanie znaku   mov ah,1h
                                       vypis znaku       mov ah,2h
                                       vypis retazca     mov ah,09h
                                       nacitanie retazca mov ah,0ah
                                       prerusenie        int 21h
