;ZADANIE c.1
;Napte program, ktor nacta z klvesnice retazec znakov (max.100 znakov) a podla  menu vykon  jednu z monost:
;a) vype retazec znakov na obrazovku
;b) vype poradov cslo miesta, kde sa nachdza prvy krat znak nacitany z klavesnice,ak ho nenajde vypise o tom spravu.
;c) vype retazec v obrtenom porad,
;d) vype pocet cslic v retazci
;e) mal psmen konvertuje na velk
;f) velke psmen konvertuje na male
;g) ukonc vykonvanie programu.
;
;Po vykonan zvolenej moznosti sa program vrti na vpis menu.

;Autor: Stefan Trgala
;Termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001

;program vykonava pracu s retazcami: nacitanie, vypis, dalej vypis cisel ako znakov (treba ich
;  na znaky najskor konvertovat), konvertovanie malych pismen na velke a naopak.
;program je funkcny, bez obmedzeni
;program bol vypracovany na pocitaci Pentium 133MHz


.286
.model small
.stack 100h  
.data

  data1 db "  Zadaj retazec : $"			;retazce, ktore vypisujeme ako hlasenia
  data2 db "  Retazec je : $"
  data3 db "  Cislic je : $"
  data4 db "  Zadaj znak ktory hladas :$"
  cisla db "0123456789"
  nenasli db "  Znak v retazci nie je$"     
  nasli db "  Znak je na pozicii : $"
  buffer db 4 dup(?),"$"				;pomocny retazec
  retazec db 100 dup (100,?)				;retazec s ktorym pracujeme
  znak db 3 dup (2,?)					;retazec sluziaci na vyber z menu
  menu1 db "    Moznosti",10,13,"$"		   	;retazce z menu
  menu2 db 10,13,"  a) vypis retazec$"
  menu3 db 10,13,"  b) najdi znak$"
  menu4 db 10,13,"  c) vypis v obratenom poradi$"
  menu5 db 10,13,"  d) pocet cislic v retazci$"
  menu6 db 10,13,"  e) konvertuj pismena na velke$"
  menu7 db 10,13,"  f) konvertuj pismena na male$"
  menu8 db 10,13,"  g) koniec$"

.code
ideal

proc menu			;vypise menu
    pusha			;ulozi registre do stacku
    mov ah,09			;nastav sluzbu DOSu pre vypisanie retazca

    mov dx,offset menu1		;do dx vlozi offsetovu adresu menu1
    int 21h			;volaj sluzbu DOSu
    mov dx,offset menu2
    int 21h
    mov dx,offset menu3
    int 21h
    mov dx,offset menu4
    int 21h
    mov dx,offset menu5
    int 21h
    mov dx,offset menu6
    int 21h
    mov dx,offset menu7
    int 21h
    mov dx,offset menu8
    int 21h
    popa			;kopiruje registre zo stacku
    ret  
endp menu

proc clrscr			;zmazanie obrazovky
    pusha
    mov ax,0B800h		;do ax dame adresu zaciatku videopamate
    mov es,ax			
    mov di,0

    mov cx,25*80		;rozmer obrazovky
    mov ah,07h
    mov al,' '			;tymto vyplni celu obrazovku
    rep stosw

    mov dx,0605h
    call nastav 
    popa
    ret 
endp clrscr

proc nastav			;nastavi kurzor
    pusha
    mov ah,02			;nastavi sluzbu obrazovky
    mov bx,0
    int 10h			;sluzba obrazovky
    popa
    ret
endp

proc nacitaj			;nacita retazec
    pusha
    call clrscr
    mov dx,offset data1		;vypise retazec data1
    mov ah,9			
    int 21h			

    mov dx,061ah
    call nastav			;nastavi poziciu kurzora
    mov ah,0ah			;nacita retazec
    mov dx,offset retazec
    int 21h			

    mov ch,0			
    mov cl,[retazec+1]		;prida dolar na koniec retazca
    mov bx,offset retazec
    add bx,2
    add bx,cx
    mov al,'$'
    mov [ds:bx],al

    popa
    ret
endp nacitaj

proc vypis			;vypise retazec
    pusha
    call clrscr
    mov ah,09			;vypise retazec data2
    mov dx,offset data2
    int 21h			
    mov dx,offset retazec	;vypise retazec znak po znaku
    mov si,dx
    inc si
    xor cx,cx                   ;nuluj CX
    mov cl,[ds:si]              ;do CL pocet opakovani
 
 Opak:
    mov ah,02h                 
    inc si
    mov dl,[ds:si]             ;do DL znak z retazca
    int 21h                    
    loop Opak               
    mov ah,0
    int 16h
    popa
    ret
endp vypis

proc volba2			;vypise poradove cislo miesta zadaneho znaku, alebo
    pusha			;vypise spravu, ze znak sa v retazci nenachadza
    call clrscr
    mov ah,09h			;vypise retazec data4
    mov dx,offset data4
    int 21h			
    mov dx,0622h 		;nastavi kurzor
    call nastav
    mov ah,0ah			;nacita znak
    mov dx,offset znak
    int 21h			
    mov dx,0906h
    call nastav
    mov al,[znak+2]    		;nacita znak
    mov ch,0
    mov cl,[retazec+1]
    mov si,2
    
xx1:mov dl,[retazec+si]		;cyklus prejde cely retazec a zisti, 
    cmp dl,al			;ci sa dany znak v ret.nachadza
    jz nas
    inc si
    loop xx1

nas: cmp cx,0			;cx je 0 ak uz presiel cely retazec
    jz nen
    dec si
    mov ah,09h			;vypis o vysledku hladania
    mov dx,offset nasli
    int 21h			
    mov ax,si			
    call vypcisl
    jmp labbel

nen:mov ah,09h			;vypis o vysledku hladania
    mov dx,offset nenasli
    int 21h			
        
labbel:mov ah,0
    int 16h
    popa
    ret
endp volba2

proc volba3			;vypise retazec v obratenom poradi
    pusha
    call clrscr
    mov ah,09			;vypise retazec data2
    mov dx,offset data2
    int 21h			
    mov dx,0618h
    call nastav			;nastavi poziciu kurzora	
    mov ch,0			
    mov cl,[retazec+1]		;v cl je pocet znakov v retazci
    mov bx,offset retazec
    add bx,cx			
    inc bx			;adresa posledneho znaku v retazci

    mov ah,02			
la3:mov dl,[ds:bx]		;zobrazi retazec znak po znaku
    int 21h			
    dec bx			;posuva sa naspat
    loop la3

    mov ah,0			;caka na stlacenie klavesy	
    int 16h

    popa
    ret
endp volba3

proc volba4			;vypise pocet cislic v retazci
    pusha
    mov ch,0
    mov cl,[retazec+1]
    mov bx,2
    mov ax,0			;v ax je pocet cislic
    
mas:mov dl,[retazec+bx]
    cmp dl,30h			;zisti,ci dany znak je cislica,ak ano 
    jb wc			;zvisi ax o 1
    cmp dl,39h
    jg wc
    inc ax
wc :inc bx
    loop mas

    call clrscr

    push ax
    mov dx,offset data3
    mov ah,09h			;nastav sluzbu DOSu pre zobrazenie retazca
    int 21h			;volaj sluzbu DOSu
    pop ax

    mov dx,0615h
    call nastav
    call vypcisl

    mov ah,0			;caka na stlacenie klavesy	
    int 16h
    popa
    ret
endp volba4

proc volba5			;konvertuje male pismena na velke
    pusha
    mov ch,0
    mov cl,[retazec+1]
    mov bx,offset retazec
    add bx,2
    
lab5a:mov dl,[ds:bx]		;prejde cely retazec a ak je dany znak male pismeno
    cmp dl,61h			;zmeni ho na velke na tej istej adrese
    jb lab5b
    cmp dl,7ah
    jg lab5b
    sub dl,32
    mov [ds:bx],dl
lab5b:inc bx
    loop lab5a

    call vypis

    popa
    ret
endp volba5

proc volba6			;velke pismena konvertuje na male
    pusha
    mov ch,0
    mov cl,[retazec+1]
    mov bx,offset retazec
    add bx,2
    
l6a:mov dl,[ds:bx]		;zisti,ci dany znak je velke pismeno
    cmp dl,41h			;ak ano zmeni ho na male
    jb l6b
    cmp dl,5ah
    jg l6b
    add dl,32
    mov [ds:bx],dl
l6b:inc bx
    loop l6a

    call vypis

    popa
    ret
endp volba6

proc vypcisl			;vypise cislo
    pusha
    mov bx,10     ;zaklad

    mov di,4
lab:dec di
    mov dx,0
    div bx              	;dx:=ax/bx
    mov si,dx           	;si:=zvysok
    mov dl,[cisla+si]   	;dl:=cislo vo forme znaku
    mov [buffer+di],dl  	;zapis cislo vo forme znaku do pomocneho retazca
    cmp ax,0
    jnz lab

    mov dx,offset buffer
    add dx,di
    mov ah,09h			;nastav sluzbu DOSu
    int 21h			;volaj sluzbu DOSu
    
    popa
    ret
endp vypcisl


;-------hlavny program---------

start:  mov ax,@data
        mov ds,ax
	call clrscr		;zmazanie obrazovky
	call nacitaj		;nacitanie retazca
repeat:	call clrscr
	call menu		;vypis menu
 
case:   mov ah,01h		;podla stlacenia klavesy (a,b,c,d,e,f,g) vykona prislusny skok
        int 21h			;prerusenie DOS-u - nacita znak
        cmp al,'a' 		;vypis retazca
        jz case1		;podmieneny skok
        cmp al,'b'		;hlada v retazci hladany znak
        jz case2
        cmp al,'c'		;vypise retazec v obratenom poradi
        jz case3
        cmp al,'d'		;zisti pocet cislic v retazci
        jz case4
        cmp al,'e'		;konvertuje pismena v retazci na velke
        jz case5
        cmp al,'f'		;konvertuje pismena v retazci na male
        jz case6
        cmp al,'g'		;koniec programu
        jz konec
        jmp case

case1:  call vypis		;vola proceduru na vypis retazca
        jmp repeat		;nepodmieneny skok na navestie repeat
case2:  call volba2      	;vola proceduru na hladanie znaku v retazci
	jmp repeat
case3:  call volba3		;vola proceduru na vypis retazca v obratenom poradi
	jmp repeat
case4:  call volba4		;vola proceduru na zistenie poctu cislic v retazci
	jmp repeat
case5:  call volba5		;vola proceduru na konvertovanie pismen na velke
        jmp repeat
case6:  call volba6		;vola proceduru na konvertovanie pismen na male
	jmp repeat
konec:	mov ax,4c00h    	;odovzda riadenie DOSu
        int 21h			
end start			
