;Zadanie c.1 Lubomir Hlavek

clrscr macro                ;makro, ktore volam z programu
  call _clrscr              ;procedura na vymazanie obrazovky
endm                        ;koniec makra
gotoxy macro x,y            ;makro volane z programu
  mov dl,x                  ;presum x-ovej sur do registra
  mov dh,y                  ;presun y-ovej sur do registra
  call _gotoxy              ;volanie procedury
endm                        ;koniec makra
write macro s               ;makro volane z programu
  mov dx,offset s           ;presum adresy vypisovaneho textu do registra dx
  call _write               ;volanie procedury na vypis
endm                        ;koniec makra

zas segment stack           ;deklaracia zasobnikoveho segmentu
  dw 100 dup (?)            ;alokovanie 200B, ktore sa neinicializiju
zas ends                    ;koniec zasobnikoveho segmentu
data segment                ;deklaracia datoveho segmentu
max db 100                  ;deklaracia premennej max=100
pocet db 0                  ;deklaracia premennej pocet=0
vstup db 100 dup (?)        ;deklaracia premennej vstup s alokovanim 100B neinicializovanych
vystup db 100 dup (?)       ;deklaracia premennej vystup s alokovanim 100B neinicializovanych
 textA db '1. Vypisat retazec na obrazovku$'            ;texty - konstanty
 textB db '2. Vypisat poradove cislo zadaneho znaku$'
 textC db '3. Vypisat retazec v obratenom poradi$'
 textD db '4. Vypisat pocet cislic v retazci$'
 textE db '5. Male skonvertovat na velke$'
 textF db '6. Velke skonvertovat na male$'
 textG db '7. Ukoncit program$'
 textH db 'Zadaj retazec (max 100 znakov)$'
 textI db 'Zadaj znak: $'
 textJ db 'Prva pozicia znaku je: $'
 textL db 'This program is created by Lubomir Hlavek$'
 textM db 'Zadany znak sa v retazci nenachadza!$'
 textN db 'Zadany znak sa v retazci nachadza na pozicii cislo: $'
 textO db 'Pocet cislic v retazci je: $'
data ends                   ;koniec datoveho segmentu
code segment                ;zaciatok kodoveho segmentu
assume cs:code,ds:data,ss:zas ;direktivy pre prekladac - pouzitie, kodoveho,datoveho a zasobnikoveho segmentu
start:mov ax,seg data       ;presun segmentovej adresy datoveho segmentu do ax
      mov ds,ax             ;presun adresy z ax do ds
      clrscr                ;vymazanie obrazovky a nastavenie textoveho modu
      gotoxy 15h,04h        ;nastavienie kurzora na x=15h,y=04h
      write textH           ;vypisanie prislusneho retazca - textH
      gotoxy 15h,05h        ;nastavenie kurzora
      mov dx,offset max     ;presun adresy max do registra dx
      mov ah,0ah            ;presun cisla obsluhy do registra ah - nacitanie retazca
      int 21h               ;volanie prerusenia
menu: clrscr
      gotoxy 15h,07h
      write textA
      gotoxy 15h,08h
      write textB
      gotoxy 15h,09h
      write textC
      gotoxy 15h,0ah
      write textD
      gotoxy 15h,0bh
      write textE
      gotoxy 15h,0ch
      write textF
      gotoxy 15h,0Dh
      write textG
      
      mov ah,01h            ;presun cisla intrukcie do ah - nacitanie znaku
      int 21h               ;volanie prerusenia
      cmp al,31h            ;porovnanie obsahu premennej al s 31h = klavesa 1
      jnz next2             ;ak sa cisla rovnaju - nevykona sa - podmieneny skok
      clrscr
      gotoxy 15h,05h
      mov bl,byte ptr [pocet] ;do bl sa vlozi hodnota z adresy pocet
      xor bh,bh                     ;vynulovanie registra bh
      mov byte ptr [vstup+bx],'$'   ;na koniec nacitaneho retazca prida '$' - aby sa dal vypisat
      write vstup
      mov ah,01h            ;nacitanie znaku
      int 21h
      jmp menu              ;koniec prveho prikazu - skace sa na menu
next2:cmp al,32h            ;al sa porovnava s 32h - klavesa 2
      jnz next3             ;aj sa aj nerovna 32 - skoci sa na navestie next3
      clrscr
      gotoxy 15h,05h
      write textI
      mov ah,01h            ;nacitanie znaku - ascii znaku bude ulozeny v al
      int 21h
      xor bx,bx             ;vynulovanie registra bx
znovu:cmp al,byte ptr [vstup+bx] ;porovnanie hodnoty registra al - (nacitany znak)s bytovou hodnotou na adrese [vstup+bx]
      jz found              ;ak je zhoda tak skoci na navestie found
      inc bx                ;inkrementuje bx
      cmp byte ptr [pocet],bl ;porovnanie hodnoty registra s hodnotou ulozenou na adrese pocet - ci uz nie je koniec retazca
      jnz znovu             ;ak nie je koniec retazca, tak skoci na znovu
      gotoxy 15h,06h        
      write textM           ;vypise oznamenie o nenajdeni znaku v retazci
      mov ah,01h            ;nacitanie znaku - pocka na stlacenie klavesy
      int 21h
      jmp menu              ;koniec vykonaneho prikazu na hladanie pozicie znaku (ak znak nebol najdeny)  - skace sa spat na menu
found:gotoxy 15h,06h        ;sem sa skoci ak program najde zadany znak
      write textN
      inc bx                ;inkrementacia registra bx
      mov ax,bx             ;presun hodnoty z registra bx do registra ax
      mov bl,0Ah            ;do bl sa vlozi cislo 10d
      div bl                ;hodnota v ax sa deli hodnotou bl a vysledok sa ulozi v al a zvisok v ah
      mov dx,ax
      add dl,30h            ;k hodnote v registry dl sa pripocita 30h aby sme ziskali ascii cisla v dl
      mov ah,02h            ;do ah sa vlozi cislo obsluhy na vypisanie znaku ktoreho ascii hodnota je v dl
      int 21h               
      mov dl,dh             ;do dl sa vlozi hodnota z dh a postup sa opakuje
      mov ah,02h            ;presun cisla obsluhy na vypisanie znaku
      add dl,30h
      int 21h
      mov ah,01h            ;nacitanie klavesy - pocka na stlacenie klavesy            
      int 21h
      jmp menu              ;koniec prikazu na vypisanie pozicie znaku(ak bol znak najdeny) - skok spat do menu
next3:cmp al,33h            ;poravnanie obsahu registra s 33h - prikaz 3
      jnz next4             ;ak sa nerovna 34h skoci a na navestie next4
      clrscr
      gotoxy 15h,05h
      mov dx,offset vstup   ;presun adresy premennej vstup do registra dx
      xor ch,ch             ;vynulovanie registra ch
      mov cl,[pocet]        ;presun hodnoty na adrese pocet do registra cl
      xor bx,bx
znova1:mov si,cx            ;hodnota v registry cx sa vlozi do indexoveho registra si
      mov dl,byte ptr [vstup+si-1] ;do dl sa vlozi znak na adrese vstup+si-1 -dolar nemenime
      mov byte ptr [vystup+bx],dl  ;na adresu vystup+bx sa vlozi znak v dl
      inc bx
      loop znova1           ; dekrementuje se cx a skoci sa na navestie znova1
      mov byte ptr [vystup+bx],'$' ;prida sa na koniec $, aby sa to dalo vypisat
      write vystup          
      mov ah,01h            ;pocka na stlacenie klavesy
      int 21h
      jmp menu              ;koniec prikazu- skoci sa do menu
next4:cmp al,34h            ;hodnota v al sa porovnala s 34h
      jnz next5             ;ak sa nerovna, skace sa na navestie next5
      clrscr
      gotoxy 15h,05h
      write textO
      mov cl,byte ptr [pocet] ;do cl sa vlozi hodnota na adrese pocet - pocet znakov v retazci
      xor ch,ch               ;vynulovanie registrov ch,si,bl
      xor si,si
      xor bl,bl
znovu2:cmp byte ptr [vstup+si],'0' ;znak na adrese vstup+si sa porovna s '0'
      jl prip                 ;skace sa, ak je mensi
      cmp byte ptr [vstup+si],'9'  ;znak na adrese vstup+si sa porovna s '9'
      jg prip                 ;skace sa, ak je vacsi
      inc bl
prip: inc si                  ;si sa inkrementne vzdy, v bl je pocet cisel   
      loop znovu2
      mov ax,bx               
      mov bl,0Ah              ;do bl sa vlozi 10d
      div bl                  ;hodnota v ax sa deli hodnotou v bl v al je podiel a v ah zvysok
      mov dx,ax               
      add dl,30h              ;k dl se pripocita 30h - ziskame ascii povodneho cisla v dl
      mov ah,02h              ;do ah sa vlozi cislo obsluhy na vypisanie znaku, ktoreho ascii je v dl
      int 21h
      mov dl,dh               ;po vypisani sa do dl vlozi obsah dh - zvysok
      add dl,30h              ;k dl sa pripocita 30h z rovnakeho dovodu
      int 21h
      mov ah,01h              ;do ah sa vlozi cislo obsluhy na nacitanie znaku
      int 21h 
      jmp menu                ;koniec prikazu - navrat do menu
next5:cmp al,35h              ;hodnota v al sa porovna s 35h
      jnz next6               ;ak sa nerovna, tak sa skace na navestie next6
      clrscr
      gotoxy 15h,05h
      mov cl,byte ptr [pocet] ;do cl sa vlozi hodnota na adrese pocet
      xor ch,ch
      xor si,si
znovu3:mov dl,byte ptr [vstup+si]  ;do dl sa vlozi hodnota znakuna adrese [vstup+si]
      cmp dl,61h              ;hodnota tohoto znaku sa porovna s 61h -male 'a'
      jl neni                 ;ak je ascii znaku v dl mensi tak sa skoci na navestie neni
      cmp dl,7ah              ;teraz sa ascii znaku v dl porovna s 7ah -male 'z'
      jg neni                 ;ak je ascii znaku v dl vacsi tak sa skoci na navestie neni
      sub dl,20h              ;od ascii znaku v dl sa odpocita 20h - tym dostaneme ascii toho isteho znaku, ale velkeho
neni: mov byte ptr [vystup+si],dl  ;na si-te miesto na adrese vystup sa vlozi hodnota v dl
      inc si
      loop znovu3             ;po inkrementacii si sa dekrementuje cx a skace sa na navestie znovu3
      mov byte ptr [vystup+si],'$' ;pred vypisanim sa na koniec vystupneho retazca vlozi '$'
      write vystup
      mov ah,01h              ;pocka sa na stlacinie klavesy
      int 21h
      jmp menu                ;koniec prikazu - skace sa do menu
next6:cmp al,36h              ;hodnota v al sa porovna s 36k
      jnz next7               ;ak sa nerovna, tak sa skace na navestie next7
      clrscr
      gotoxy 15h,05h
      mov cl,byte ptr [pocet]
      xor ch,ch
      xor si,si
znovu4:mov dl,byte ptr [vstup+si] ;do dl a vlozi ascii znaku na adrese [vstup+si]
      cmp dl,41h              ;ascii v dl sa porovna s 41h - velke 'A'
      jl neni1                ;ak je mensi, tak sa skace na navestie neni1
      cmp dl,5ah              ;ascii v dl sa porovna s 5ah
      jg neni1                ;ak je vacsi, tak sa skace ne navestie neni1
      add dl,20h              ;k dl sa pripocita 20h, tym dostaneme v dl ascii toho isteho, ale maleho znaku
neni1:mov byte ptr [vystup+si],dl ;ascii v dl sa vlozi na si-te miesto adresy [vstup]
      inc si
      loop znovu4             ;dekrementuje sa cx a skoci sa na navestie next6
      mov byte ptr [vystup+si],'$'  ;na koniec sa za retazec vlozi '$', aby sa dal vypisat
      write vystup
      mov ah,01h
      int 21h                 ;pocka sa na stlacenie klavesy
      jmp menu                ;koniec prikazu - skace sa na menu
next7:cmp al,37h              ;hodnata v al sa porovna s 37h
      jnz next8               ;ak sa nerovna, skace sa na next8
      mov ax,4c00h            ;koniec programu - korektny navrat do dosu
      int 21h
next8:jmp menu                ;ak sa program dostane sem, tak potom nebola stalcena klavesa 1-7, teda sa skace do znovu menu

_clrscr proc near             ;deklaracia procedury _clrscr - vymazanie obrazovky
  mov ax,0003h                ;do ax sa vlozi parametre grafickeho modu 80x25
  int 10h
  mov dx,offset textL         ;do dx sa presunie adresa offsetova textu textL
  mov ah,09h                  ;do ah sa vlozi cislo obsluhy na vypisanie retazca
  int 21h
  ret                         ;navrat k miestu, odkial bola procedura volana
_clrscr endp                  ;koniec procedury

_gotoxy proc near             ;deklaracia procedury _gotoxy -nastavenie kurzora na zadane suradnice
  mov ax,0200h                ;do ax sa vlozi cislo obsluhy na nastavenie kurzora
  int 10h
  ret                         ;navrat k miestu, odkial bola procedura volana
_gotoxy endp                  ;koniec procedury

_write proc near              ;deklaracia procedury _write - vipisanie retazca
  mov ah,09h                  ;do ah sa vlozi cislo obsluhy na vypisanie retazca
  int 21h
  ret                         ;navrat k miestu, odkial bola procedura volana
_write endp                   ;koniec procedury

code ends                     ;koniec kodoveho segmentu
end start
