
;ZADANIE c.1.

;Napiste program, ktory nacita z klavesnice retazec znakov (max.100 znakov) a 
;podla  menu vykona  jednu z moznosti:
;a) vypise retazec znakov na obrazovku
;b)vypise poradove cislo miesta, kde sa nachadza prvy krat znak nacitany z     
;klavesnice,ak ho nenajde vypise o tom spravu.
;c) vypise retazec v obratenom poradi,
;d) vypise pocet cislic v retazci
;e) male pismena konvertuje na velke
;f) velke pismena konvertuje na male
;g) ukonci vykonavanie programu.

;Po vykonani zvolenej moznosti sa program vrati na vypis menu.

;Autor:  Peter HLOCKY  
;Termin odovzdania: 24.10.2000
;2.roc.,sk.rok 2000/2001


ZAS	SEGMENT	STACK				;zasobnik
	DW	128 DUP(?)
ZAS	ENDS

DATA	SEGMENT
TEXT	DB	'Zadaj retazec: $'
TEXT2	DB	'Zadaj hladany znak: $'
TEXT3	DB	'Zadany znak sa nenasiel.$'
TEXT4	DB	'Zadany znak sa nachadza na $'
TEXT5	DB	' mieste.$'
TEXT6	DB	'Pocet cislic v retazci: $'
MENU	DB	'1 - VYPIS RETAZEC NA OBRAZOVKU',10,13		;DEFINICIA TEXTOV PRE MENU
	DB	'2 - NAJDI ZNAK',10,13
	DB	'3 - VYPIS OBRATENY RETAZEC',10,13
	DB	'4 - ZISTI POCET CISLIC',10,13
	DB	'5 - KONVERTUJ MALE PISMENA NA VELKE',10,13
	DB	'6 - KONVERTUJ VELKE PISMENA NA MALE',10,13
	DB	'7 - KONIEC PROGRAMU$'

RETAZEC	DB	101 						;REZERVOVANIE MIESTA V PAMATI PRE RETAZEC 
VYSTUP	DB	101 DUP(?)
DATA 	ENDS

CODE	SEGMENT
	ASSUME	DS:DATA,CS:CODE, SS:ZAS

START:
	MOV 	AX,SEG DATA				
	MOV	DS,AX					;INICIALIZACIA DS
	MOV	DX,OFFSET TEXT
	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	AH,09H					
	INT	21H					;VYPIS POZIADAVKY NA ZADANIE RETAZCA
	MOV	DX,OFFSET RETAZEC
	MOV	AH,0AH
	INT	21H					;NACITANIE RETAZCA
	ADD	DX,2					;NASTAVENIE RETAZCA NA 1.ZNAK
	MOV	DI,DX
	MOV	BL,BYTE PTR [DI-1]			;V BX BUDE POCET ZNAKOV RETAZCA
	MOV	BH,0
	MOV	BYTE PTR [BX+DI],'$'			;RETAZEC SA UKONCI $
	
OPAK:	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET MENU				;VYPISANIE MENU
	MOV	AH,09H
	INT	21H	
	
	MOV	AH,08H
	INT	21H					;NACITANIE ZNAKU PRE VOLBU
	CMP	AL,'1'					;ZISTUJE CI BOL STLACENA NIEKTORA Z VOLIEB
	JE	VYPIS					;AK BOLA STLACENA 1 SKOC NA NA KONTRETNU FUNKCIU
	JMP	TEST1
VYPIS:	MOV	AX,3					;VYPISOVANIE RETAZCA
	INT	10H					;VYMAZANIE OBRAZOVKY						
	MOV	DX,OFFSET RETAZEC+2			;IBA ZNAKY RETAZCA SA HODIA DO DX
	MOV	AH,09H
	INT	21H					;VYPIS RETAZCA
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK					;SKOK NA ZACIATOK

TEST1:	CMP	AL,'2'					;NACHADZANIE ZNAKU
	JE	NAJDI
	JMP	TEST2
NAJDI:	MOV	AX,3				
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET TEXT2
	MOV	AH,09H					
	INT	21H
	MOV	AH,1
	INT	21H					;NACITANIE HLADANEHO ZNAKU 
	MOV	DX,OFFSET RETAZEC+2
	MOV	SI,DX
	XOR	CX,CX					;VYMAZANIE CX
	INC	CX					;ABY SA UVUVAZOVAL 1. ZNAK AKO NULTY
	MOV	BL,'$'
POROV:	CMP	BL,[SI]					;POROVNAVA CI NIEJE POSLEDNY ZNAK $
	JE	NENI					;AK SADOSTANE KU ZNAKU '$' VYHODNOTI ZE NIC NENASIEL
	CMP	AL,[SI]
	JE	ROVNE					;SKOCI AK NASIEL DANI ZNAK
	INC	SI					;DALSI ZNAK	
	INC	CX					;KOLKI V PORADI
	JMP	POROV
	MOV	AX,3					
	INT	10H					;VYMAZANIE OBRAZOVKY
NENI:	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET TEXT3
	MOV	AH,09H
	INT	21H
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK

ROVNE:	MOV	AX,3				
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET TEXT4				;INFO PRE UZIVATELA
	MOV	AH,09H					
	INT	21H
	CMP	CX,100					;TU VYPISE CISLO ROVNAKO AKO PRI 4.FUNKCII			
	JE	STOX					;VYKONA SA AK JE POCET CISLIC 100
	MOV	AX,CX					;VYKONAVA SA AK JE CISLO VACSIE AKO 9
	AAM						;PODELI AX 10 ADO AH DA VYSLEDOK,DO AL DA ZVYSOK
	XOR	DX,DX					;VYNULUJE SA DX
	MOV	DL,30H					;30H JE '0'
	ADD	DL,AH
	PUSH	AX					;ZALOHUJE AX
	MOV	AH,02H
	INT	21H					;VYPISE DESIATKY
	XOR	DX,DX					;VYNULUJE SA DX
	MOV	DL,30H					;30H JE '0'
	POP	AX					;VYTIAHNE AX(KVOLI AL KDE JE ZVYSOK DELENIA
	ADD	DL,AL
	MOV	AH,02H
	INT	21H					;VYPISE JEDNOTKY
	MOV	DX,OFFSET TEXT5
	MOV	AH,09H					
	INT	21H
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK	
STOX:	MOV	DX,31H					
	MOV	AH,02H
	INT	21H					;VYPISE SA JEDNOTKA
	MOV	DX,30H
	MOV	AH,02H
	INT	21H					;VYPISE SA 0
	MOV	DX,30H
	MOV	AH,02H
	INT	21H					;VYPISE SA 0
	MOV	DX,OFFSET TEXT5
	MOV	AH,09H					
	INT	21H
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK	

TEST2:	CMP	AL,'3'					;OBRACANIE RETAZCA
	JE	OBRAT
	JMP	TEST3
OBRAT:	MOV	DX,OFFSET RETAZEC+2			;IBA ZNAKY RETAZCA SA HODIA DO DX
	MOV	SI,DX
	MOV	BX,OFFSET VYSTUP
	MOV	CH,0					;POCET ZNAKOV SA DA DO BL
	MOV	CL,[SI-1]
	ADD	SI,CX					;NASTAVI SA NA POSLEDNY ZNAK RETAZCA
	MOV	BX,SI
	DEC	SI					;PRESKOCI $
	INC	BX
	MOV	DX,BX					
NAV2:	MOV	AL,[SI]					;CYKLUS PRE SAMOTNU VYMENU
	MOV	[BX],AL	
	DEC	SI
	INC	BX
	LOOPNE	NAV2
	MOV	AL,'$'					;RETAZEC SA UKONCI $
	MOV	[BX],AL
	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	AH,09H
	INT	21H					;VYPIS RETAZCA
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK					;SKOK NA ZACIATOK



TEST3:	CMP	AL,'4'
	JE	CISLA
	JMP	TEST4
CISLA:	MOV	AX,3			
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	DX,OFFSET TEXT6				;INFO PRE UZIVATELA
	MOV	AH,09H
	INT	21H					;NACITANIE RETAZCA
	MOV	DX,OFFSET RETAZEC+1			;RETAZEC DO DX, +1 LEBO DALEJ SA 1 X INKREMENTNE
	MOV	SI,DX
	XOR	CX,CX					;VYNULOVANIE CL
NECIS:	INC	SI
	MOV	AL,[SI]					;PRVKY RETAZCA SA DAJU DO AL
	CMP	AL,'$'
	JE	KONRET					;KONIEC RETAZCA
	CMP	AL,2FH					
	JBE	NECIS
	CMP	AL,3AH
	JNB	NECIS
	INC	CL					;INKREMENTNE CL AK JE CILSO
	JMP	NECIS

KONRET:	CMP	CX,100								
	JE	STO					;VYKONA SA AK JE POCET CISLIC 100
	MOV	AX,CX					;VYKONAVA SA AK JE CISLO VACSIE AKO 9
	AAM						;PODELI AX 10 ADO AH DA VYSLEDOK,DO AL DA ZVYSOK
	XOR	DX,DX					;VYNULUJE SA DX
	MOV	DL,30H					;30H JE '0'
	ADD	DL,AH
	PUSH	AX					;ZALOHUJE AX
	MOV	AH,02H
	INT	21H					;VYPISE DESIATKY
	XOR	DX,DX					;VYNULUJE SA DX
	MOV	DL,30H					;30H JE '0'
	POP	AX					;VYTIAHNE AX(KVOLI AL KDE JE ZVYSOK DELENIA
	ADD	DL,AL
	MOV	AH,02H
	INT	21H					;VYPISE JEDNOTKY
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK	
STO:	MOV	DX,31H					
	MOV	AH,02H
	INT	21H					;VYPISE SA JEDNOTKA
	MOV	DX,30H
	MOV	AH,02H
	INT	21H					;VYPISE SA 0
	MOV	DX,30H
	MOV	AH,02H
	INT	21H					;VYPISE SA 0
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK	

TEST4:	CMP	AL,'5'					;KONVERZIA MALE NA VELKE
	JE	MALVEL
	JMP	TEST5
MALVEL:	MOV	DX,OFFSET RETAZEC+2			;IBA ZNAKY RETAZCA SA HODIA DO DX
	MOV	SI,DX
	MOV	BX,OFFSET VYSTUP
	MOV	CH,0					;POCET ZNAKOV SA DA DO BL
	MOV	CL,[SI-1]
	MOV	BX,SI					
NAV1:	MOV	AL,[SI]					;CYKLUS PRE SAMOTNU VYMENU
	CMP	AL,60H
	JBE	DALEJ					;PRESKOCI INE NEZ MALE PISMENO
	CMP	AL,7BH
	JNB	DALEJ					;AK JE VELKE TAK SKOCI
	SUB	AL,20H					;UROBI KONVERZIU
DALEJ:	MOV	[BX],AL					;DA UZ SPRAVNY ZNAK DO BX
	INC	SI
	INC	BX
	LOOPNE	NAV1					
	MOV	AL,'$'					;RETAZEC SA UKONCI $
	MOV	[BX],AL
	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	AH,09H
	INT	21H					;VYPIS RETAZCA
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK					;SKOK NA ZACIATOK



TEST5:	CMP	AL,'6'
	JE	VELMAL
	JMP	TEST6
VELMAL:	MOV	DX,OFFSET RETAZEC+2			;IBA ZNAKY RETAZCA SA HODIA DO DX
	MOV	SI,DX
	MOV	BX,OFFSET VYSTUP
	MOV	CH,0					;POCET ZNAKOV SA DA DO BL
	MOV	CL,[SI-1]
	MOV	BX,SI					
NAV3:	MOV	AL,[SI]					;CYKLUS PRE SAMOTNU VYMENU
	CMP	AL,40H
	JBE	DALEJ2					;PRESKOCI INE NEZ MALE PISMENO
	CMP	AL,5BH
	JNB	DALEJ2					;AK JE VELKE TAK SKOCI
	ADD	AL,20H					;UROBI KONVERZIU
DALEJ2:	MOV	[BX],AL					;DA UZ SPRAVNY ZNAK DO BX
	INC	SI
	INC	BX
	LOOPNE	NAV3					
	MOV	AL,'$'					;RETAZEC SA UKONCI $
	MOV	[BX],AL
	MOV	AX,3
	INT	10H					;VYMAZANIE OBRAZOVKY
	MOV	AH,09H
	INT	21H					;VYPIS RETAZCA
	MOV	AH,08H
	INT	21H					;NACITANIE KLAVESI PRE POKRACOVANIE
	JMP	OPAK					;SKOK NA ZACIATOK




TEST6:	CMP	AL,'7'				;UKONCENIE PROGRAMU
	JE	KONIEC
	JMP	OPAK
KONIEC:	MOV	AX,4C00H
	INT	21H	
		
CODE	ENDS
	END	START



;Zhodnotenie:
;Program vykonava pozozadovane ulohy a je plne funkcny vzhladom na technicke 
;prostriedky uzivatela. Pri zadavani vstupneho retazca treba dbat nato, aby 
;nebol prekroceny maximalny pocet znakov (100 zn.). Program tuto podmienku 
;nekontroluje nakolko to nieje pozadovane v zadani ulohy. Pripadne vylepsenia 
;by mohli obsahovat prave testovanie dlzky retazca. Program pracuje pod DOSom a 
;vyuziva sluzby BIOSu.   


