; Ivan Straka "A" Infb 21 - b13
; Zadanie cislo 1

ZAS	SEGMENT	STACK
	db	100h DUP(?)
ZAS	ENDS
DATA	SEGMENT	
TRet	db	'Zadajte retazec znakov: ',10,13,'$'
Tmenu	db	'F1 - vypise retazec znakov na obrazovku',10,13
	db	'F2 - vypise miesto prveho vyskytu znaku',10,13
	db	'F3 - vypise retazec v obrtenom porad',10,13
	db	'F4 - vypise pocet cslic v retazci',10,13
	db	'F5 - male psmen konvertuje na velke',10,13
	db	'F6 - velke psmen konvertuje na male',10,13
	db	'F7 - ukonc vykonvanie programu.',10,13,'$'
TNoz	db	' - Znak sa nenachadza v retazci.$'
TZnak	db	'Zadajte hladani znak: $'
TZnak1	db	'Znak "$'
TZnak2	db	'" sa nachadza na pozicii: $'
TPcis	db	'Pocet cislic v retazci je: $'
Text	db	100h DUP(0)
TextL	db	0
DATA	ENDS

CODE	SEGMENT
	ASSUME	CS:CODE,DS:DATA,SS:ZAS
START:	
	mov	dx,SEG DATA		;do dx <- segment DATA
	mov	ds,dx			;nastav ds na DATA
	call	cls			;zavolaj cls
	mov	dx,offset TRet		;do dx vloz offset TRet
	mov	ah,09h			;DOS funkcia na vypis retazcu
	int	21h			;dos sluzba
	call	nacitaj			;zavolaj nacitaj
HLoop:	call	menu			;zavolaj menu
repeat:	mov	ah,08h            	;DOS funkcia pre vstup znaku bez echa
	int	21h             	;Volanie sluzby dosu
	cmp	al,0			;porovnaj al(znak - vystup sluzby) s 0
	jnz	repeat			;ak <> 0 skoc na repeat
	mov	ah,08h          	;
	int	21h             	;
	cmp	al,3bh          	;porovnanie znaku s 3bh - F1
	jz	f1			;ak sa zhoduje (=0) skoc na f1
	cmp	al,3ch          	;\
	jz	f2			;|
	cmp	al,3dh  	        ;|
	jz	f3			;|
	cmp	al,3eh          	;| testy klavesov
	jz	f4			;| zistovanie ktora klavesa  
	cmp	al,3fh          	;| bola stlacena
	jz	f5			;|
	cmp	al,40h          	;|
	jz	f6			;|
	cmp	al,41h          	;/ -f7
	jz	Koniec			;skoc na koniec
	jmp	repeat			;znova nacitaj klavesu
f1:	call	fun1			;Zavolaj podprogram fun1
	jmp	HLoop			;skoc na zaciatok
f2:	call	fun2			;\
	jmp	HLoop			;|
f3:	call	fun3			;| volanie prislusnych podprogramov
	jmp	HLoop			;|
f4:	call	fun4			;|
	jmp	HLoop			;|
f5:	call	fun5			;|
	jmp	HLoop			;|
f6:	call	fun6			;|
	jmp	HLoop			;/
Koniec:					;
	mov	ah,4ch	          	;DOS funkcia pre ukoncenie programu
	int	21h     	        ;DOS volanie
					;*****************************
nacitaj	PROC				;podprogam nacitaj
	mov	di,0h			;vynuluj di
	mov	cx,100			;maximalny pocet znakov (opakovani)
nacl:	mov	ah,01h			;Dos sluzba na vstup znaku s echom
	int	21h			;Volanie sluzby
	cmp	al,13			;porovnanie znaku s kodom ENTERu (13)
	jz	nace			;ak bol ENTER (=0) koniec nacitavania
	mov	Text[di],al		;Ulozenie nacitaneho znaku na poz. di
	inc	di			;incrementacia di, ukazuje na dalsi znak (prazdne miesto)
	loop	nacl			;ak cx<>0, nie je nacitany posledny znak opakuj slucku
nace:	mov	al,'$'			;kod ukoncovacieho znaku (konec retazca)
	mov	Text[di],al		;uloz znak
	mov	ax,di			;di = pocet nacitanych znakov
	mov	TextL,al		;uloz pocet znakov do TextL			
	ret				;koniec podprogramu
nacitaj	ENDP				;
					;
cls	PROC				;podprogram cls (vymazanie obrazovky)
	push	ax			;\
	push	bx			;| ulozenie registrov do zaobnika
	push	cx			;|
	push	dx			;/	
	mov	cx,0h			;nastavenie vstupnych hodnot pre volanie funkcie	
	mov	dh,25			;
	mov	dl,80			;
	mov	al,0			;
	mov	bh,07			;
	mov	ah,06h			;sluzba 06 - posuv obrazovky nahor, vymazanie
	int 	10h			;volanie video sluzby
	mov	bh,0			;nastavenie kurzora na poziciu 0,0 (lavy horny roh)
	mov	dx,0			;
	mov	ah,02h			;sluzba 02
	int	10h			;
	pop	dx			;\
	pop	cx			;|
	pop	bx			;| obnovenie registrov zo zasobnika
	pop	ax			;/
	ret				;navrat z podprogramu
cls	ENDP				;Koniec podprogramu
					;
VypisT	PROC				;Podprogram na vypis text, dx adresa textu (offset)
	push	ax			;ulozenie ax do zasodnika
	mov	ah,09h			;vypis textu je 9 funkcia dosu
	int	21h			;volanie funkcie dosu
	pop	ax			;obnovenie ax zo zasobnika
	ret				;navrat z podprogramu
VypisT	ENDP				;koniec podprogramu
					
VypisZ	PROC				;Podprogram pre vypis 1 znaku, vst dl
	push	ax			;ul. ax do zasobnika
	mov	ah,02h			;2 funkcia dosu, vypis znaku
	int	21h			;volanie sluzby dosu
	pop	ax			;obnovenie ax zo zasobnika
	ret				;navrat z podprogramu
VypisZ	ENDP				;koniec podprogramu

WaitK	PROC				;Podprogram na cakanie na znak, klavesu
	push	ax			;ul. ax do zas.
	mov	ah,08h			;funkcia na nacitanie znaku bez echa
	int	21h			;volanie sluzby dosu
	pop	ax			;obn. ax
	ret				;navrat z pod.
WaitK	ENDP				;k. p.

menu	PROC				;Podprogram menu
	call	cls			;- vymazanie obrazovky
	mov	dx,offset Tmenu		;nastavenie dx na offset (adrasu) Tmenu
	mov	ah,09h			;sluzba 09 - vypis retazca
	int	21h			;volanie sluzby DOSu
	ret				;navrat z podprogramu
menu	ENDP				;koniec podprogramu
					;
VypisC	PROC				;Podprogram VypisC - Vypis cisiel 0-9999, vst. ax
	cmp	ax,99			;porovnanie cisla s 99
	jle	Vyp1			;ak <= skoc na Vyp1 - vypisujem len 2 cislice
	mov	bl,100			;inak vyp. 4 cislice. - delenec 
	div	bl			;delenie ax/100 (al=podiel, ah=zvysok)
	push	ax			;ulozenie ax do zasobnika
	aam				;konverzia na BCD. ah 1 cislica(0-9), al 2.
	add	ah,30h			;pripocitanie 30h - uprava na ascii kod
	mov	dl,ah			;dl - vst. reg pre VypisZ
	call	VypisZ			;volanie VypisZ - vypisanie znaku
	add	al,30h			;uprava na ascii kod 2. cislica
	mov	dl,al			;
	call	VypisZ			;
	pop	ax			;obnovenie ax (hlavne je ah - zvysok)
	mov	al,ah			;presuv zvysku do al
Vyp1:	aam				;\
        add     ah,30h			;|
        mov     dl,ah			;| to iste ako o 9 riadkov vyssie
	call	VypisZ			;|
        add     al,30h			;|
        mov     dl,al			;|
	call	VypisZ			;/
	ret        			;navrat z podprogramu
VypisC	ENDP				;koniec podprogramu
					
fun1	PROC				;Vypis retazca
	call	cls			;Vymazanie obr.
	mov	dx,offset Text		;- offset (adresa) retazca
	call	VypisT			;Vypis
	call	WaitK			;Cakanie
	ret				;navrat
fun1	ENDP				;koniec podprogramu
					
fun2	PROC				;Vypis 1. pozicie znaku
	call	cls			;Vymazanie obr.
	mov	dx,offset TZnak		;- offset (adresa) textu (Zadajte znak:)
	call	VypisT			;Vypis
	mov	ah,01h			;- sluzba na nacitanie znaku 
	int	21h			;volanie sluzby dosu
	mov	di,0			;index 1. pismena 
	mov	bl,al			;presun do bl nacitany znak
	mov	cl,TextL		;cl = dlzka retazca
	xor	ch,ch			;nulovanie ch
f2l:	mov	al,Text[di]		;nacitanie znaku retazca na pozicii urcenej v di
	cmp	al,bl			;porovnie znakov
	jz	f2r			;ak sa rovnaju skoc na f2r
	inc     di                      ;inak incrementuj di - dalsi znak
        loop    f2l                     ;slucka na f2l, pokym cx<>0
        mov     dx,offset TNoz          ;preslo celym retazcom a nenaslo hl. znak
        call    VypisT			;Vypis textu ze znak sa v retazci nenachadza
	call    WaitK			;cakanie na stlacenie klavesi
        ret                             ;navrat z podprogramu
f2r:	call	cls			;znaky sa rovnaju, vymazanie obrazovky
	mov	dx,offset TZnak1	;vypis textu (Znak ")	
	call	VypisT			;
	mov	dl,bl			;v bl je hladany znak
	call	VypisZ			;vypis znaku
        mov     dx,offset TZnak2	;vypis textu (" sa nachadza na pozicii )	
	call	VypisT			;
	mov	ax,di			;v di je index znaku (pozicia pocitana od 0) 
	inc	ax			;uprava pre pocitanie do 1
	call	VypisC			;vypis cisla
	call	WaitK			;cakanie na klavesu
	ret				;navrat z podprogramu
fun2	ENDP				;
							
fun3	PROC				;podrpogram vypisu retazca od zadu (obratene)
	call	cls			;vymazanie obr.
	mov	cl,TextL		;velkost retazca
	mov	ch,0			;
	mov	di,cx			;- indez posledneho znaku (ukoncovaci)
	dec	di			;- index posledneho zobrazovaneho znaku
f3loop:	mov	dl,Text[di]		;nacitanie znaku na di pozicie
	dec	di			;decremenovanie indexu predchadzajuci znak
	call	VypisZ			;vypis znaku
	loop	f3loop			;slucka cx opakovany (dlzka retazca)
	call	WaitK			;cakanie na klavesu
	ret				;navrat
fun3	ENDP				;koniec podprogramu
					
fun4	PROC				;podprogram pre vypis poctu cisel v retazci
	call	cls			;vymazanie obrazovky
	mov	cl,TextL		; - dlzka retazca
	mov	ch,0			;\
	mov	di,0			;| pociatocna nastavenie registrov
	mov	bl,0			;/
f4loop:	mov	al,Text[di]		;znak z retazca
	inc	di			;index dalsieho znaku
	cmp	al,'0'			;porovnanie s kodom 0
	jl	f4c			;ak < skoc
	cmp	al,'9'			;porovnanie s kodom 9
	jg	f4c			;ak > skoc
	inc	bl			;ak sa nachadza medzi 0-9 inc bl - pocet cislic 
f4c:	loop	f4loop			;slucka na f4loop - cx krat - dlzka retazca
	mov	dx,offset TPcis		;\ vypis retazca
	call	VypisT			;/   - Pocet cisli v retazci je
	mov	ah,0			;
	mov	al,bl			;- pocet cislic
	call	VypisC			;vypis cisla
	call	WaitK			;cakanie na stisk klavesy
	ret				;navrat
fun4	ENDP				;koniec podprogramu
							
fun5	PROC				;podprogram na konverziu na velke pismena
	mov	cl,TextL		;- dlzka retazca	
	mov	ch,0			;\ 
	mov	di,0			;/ pociatocne nastavenie
f5loop:	mov	al,Text[di]		;znak z retazca
	cmp	al,'a'			;porovnanie s kodom a
	jl	f5c			;ak < skoc na f5c
	cmp	al,'z'			;porovnanie s kodom z
	jg	f5c			;ak > skoc na f5c
	sub	al,20h			;odcitaj 20h rozdiel 'a'-'A' - uprava na velke pismeno
	mov	Text[di],al		;prepis znak v retazci, uloz upraveny
f5c:	inc	di			;index dalsieho znaku
	loop	f5loop			;slucka na f5loop
	ret				;navrat
fun5	ENDP				;koniec podprogramu
							
fun6	PROC				;podprogram na konverziu na male pismena
	mov	cl,TextL		;- dlzka retazca	
	mov	ch,0			;\ 
	mov	di,0			;/ pociatocne nastavenie
f6loop:	mov	al,Text[di]		;znak z retazca
	cmp	al,'A'			;porovnanie s kodom A
	jl	f6c			;ak < skoc na f6c
	cmp	al,'Z'			;porovnanie s kodom Z
	jg	f6c			;ak > skoc na f6c
	add	al,20h			;pripocitaj 20h rozdiel 'a'-'A' - uprava na male pismeno
	mov	Text[di],al		;prepis znak v retazci, uloz upraveny
f6c:	inc	di			;index dalsieho znaku
	loop	f6loop			;slucka na f6loop
	ret				;navrat
fun6	ENDP				;koniec podprogramu

CODE	ENDS				;koniec segmentu CODE
	END	START			;koniec Programu a nastavenie zaciatku na START
							