;ZADANIE2
;EDUARD CHRVALA B9
printf	macro	what			;Makro na vypis textov
	mov	dx,offset what
	mov	ah,09h
	int	21h
	endm

data 	segment
menu1	db 'Vypisat zoznam cisel'	;Jednotlive polozky menu
menu2	db 'Suma vsetkych cisel'
menu3	db 'Usporiadat cisla vzostupne'
menu4	db 'Usporiadat cisla zostupne'
menu5	db 'Vydelit dve cisla'
menu6	db 'Vynasobit dve cisla'
menu7	db 'Ukoncit program'
result	db 100  dup(?)			;Pomocny buffer na rozne ucely
nrs	db 100 	dup(?)			;Vstupny buffer s cislami v ASCII hodnote
numbers	db 100 	dup(?)			;Vstupny bufer s cislami v bin. tvare (po konverzii)
filen	db 'vstup.txt',0		;Nazov vstupneho suboru
fileh	dw ?				;Handle vstupneho suboru
ofilen	db 'vystup.txt',0		;Nazov vystupneho suboru
errtext	db 'Subor sa neotvoril!$'	;Chybove spravy pre pracu so subormi
er2text	db 'Subor sa nezatvoril!$'
seprtr	db ': $'			;Oddelovac pouzivany pri numerickom menu
divtxt1	db 'Zadaj delenca:',0Dh,0Ah,'$'		;Pomocne texty
divtxt2	db 'Zadaj delitela:',0Dh,0Ah,'$'
multxt1	db 'Zadaj prvy sucinitel:',0Dh,0Ah,'$'
multxt2	db 'Zadaj duhy sucinitel:',0Dh,0Ah,'$'
upover	db 'Vysledok je prilis velky!$'		;Chybove spravy
dnover	db 'Vysledok je prilis maly!$'
divzero	db 'Delenie nulou!$'
cntnum	dw ?				;Premenna obsahujuca pocet cisel
data	ends

prog	segment
	assume 	cs:prog,ds:data
start:
	mov	bx,data
	mov	ds,bx
	mov	es,bx			;ES register je pouzivany pri vypise menu (INT10h)
	call	_open			;Otvorenie vstupneho suboru
	call	_read			;Jeho nacitanie do bufferu 'nrs'
	call	_close			;Zatvorenie suboru
	call	_convrt			;Konverzia do dvojkoveho tvaru, prepis do bufferu 'numbers'
	mov	si,1
opak3:	call	_menu			;Hlavne menu, v SI je vratena zvolena polozka menu
	cmp	si,1			;Ak sa polozka menu rovna 1,
	jnz	prskc23
	call	_gview			;zobrazime nacitane cisla
	jmp	opak3			;a navrat do hlavneho menu,
prskc23:cmp	si,2			;inak: Ak sa polozka menu rovna 2,...
	jnz	prskc24
	call	_sum			;Suma vsetkych cisel
	jmp	opak3
prskc24:cmp	si,3
	jnz	prskc26
	call	_sortup			;Vzostupne zotriedenie
	jmp	opak3
prskc26:cmp	si,4
	jnz	prskc29
	call	_sortdn			;Zostupne zotriedenie
	jmp	opak3
prskc29:cmp	si,5
	jnz	prskc30
	call	_div			;Delenie dvoch cisel
	jmp	opak3
prskc30:cmp	si,6
	jnz	prskc34
	call	_mul			;Nasobenie dvoch cisel
	jmp	opak3
prskc34:mov	ax,4C00h		;Ak nebola zvolena ziadna z vyssie uvedenych poloziek,
	int	21h			;ukoncenie programu

_open	proc	near			;//////////Otvorenie suboru\\\\\\\\\\\\
	mov	dx,offset filen		;meno suboru
	mov	al,0			;otvorit pre citanie
	mov	ah,3Dh			;DOS podfn. 3Dh
	int	21h
	jc	oerror			;Ak nsatala chyba
	mov	bx,offset fileh
	mov	[bx],ax			;Ulozenie vrateneho handle suboru do premennej
	ret
oerror:	printf	errtext			;V pripade chyby zobrazime chybovu hlasku
	mov	ax,4C00h
	int	21h			;a ukoncime program
	ret					
_open	endp

_close	proc	near			;///////////Zatvorenie suboru\\\\\\\\\\
	mov	ah,3Eh			;DOS podfn. 3Eh
	mov	bx,offset fileh		;Handle suboru
	mov	dx,[bx]
	mov	bx,dx
	int	21h
	jc	cerror			;Ak nastala chyba
	ret
cerror:	printf	er2text			;vypiseme chybovu hlasku
	mov	ax,4C00h
	int	21h			;a ukoncenie programu
_close	endp

_read	proc	near			;//////////Nacitanie suboru\\\\\\\\\\\\
	mov	dx,offset nrs		;Adresa bufferu dat
opak1:	mov	bx,offset fileh		;Handle suboru
	mov	cx,[bx]
	mov	bx,cx
	mov	cx,1			;Citame 1 Byte
	mov	ah,3Fh			;DOS podfn. 3Fh
	int	21h
	jc	fend			;Ak nastala chyba, sme na konci suboru,
	cmp	ax,0			;ako aj ak pocet nacitanych dat sa rovna 0
	jz	fend
	inc	dx			;Zvysime offset
	jmp	opak1			;a pokracujeme v citani
fend:	mov	bx,dx
	mov	dx,24h			;Na koniec bufferu pridame znak '$'
	mov	[bx],dx
	ret
_read	endp

_write	proc	near			;///////////Zapis do suboru\\\\\\\\\\\\
	push	si
	call	_strcon			;Konverzia cisel na ASCII retazec
	mov	dx,offset ofilen	;Meno vystupneho suboru
	mov	ah,3Dh			;DOS podfn. 3Dh
	mov	al,1			;Otvorit pre zapis
	int	21h			;Otvorenie suboru
	jnc	prskc38			;Ak subor neexistuje,
	mov	ah,3Ch			;treba ho vytvorit (podfn. 3Ch)
	mov	dx,offset ofilen
	mov	cx,0			;Atributy suboru
	int	21h
	jc	oerror			;V pripade poruchy vypis chyby a ukoncenie
prskc38:mov	di,0			;Zistovanie poctu zapisovanych Byte
	mov	bx,offset nrs		;(dlzka vstupneho bufferu 'nrs')
next13:	mov	dl,byte ptr[bx+di]
	inc	di
	cmp	dl,24h			;V bufferi sa hlada ukoncovaci znak '$'
	jnz	next13
	dec	di
	mov	bx,ax			;Handle suboru
	mov	cx,di			;Pocet zapisovanych byte
	mov	dx,offset result	;Vystupom procedury '_strcon' je buffer 'result'
	mov	ah,40h			;DOS podfn. 40h
	int	21h
	mov	ah,3Eh			;Zatvorenie suboru
	int	21h
	pop	si
	ret
_write	endp

_view	proc	near		;///Zobrazenie cisla v desiatkovej sustave\\\\\
	push	ax
	push	cx			;Ochrana registrov
	mov	dx,0
	mov	di,0			;Inicializacia
	mov	bx,offset numbers	;Vstupne pole zobrazovanych cisel
	mov	ax,[bx+si]		;Procedura dostane v SI poradove cislo zobrazobanej polozky
	cmp	ax,32768		;Ak je cislo mensie ako 0,
	jb	next3
	sub	dx,ax			;prevedieme ho na kladne (doplnkovy kod)
	mov	ax,dx
	push	ax
	mov	ah,02h
	mov	dl,2Dh			;a pred cislom zobrazime znak '-'
	int	21h
	pop	ax
next3:	mov	cx,10			;Priprava delitela cisla
	mov	dx,0
	div	cx			;Cislo sa vydeli 10
	cmp	ax,0			;Ak je vysledok 0
	jz	prskc14			;konci sa cyklus
	push	bx
	mov	bx,offset result
	mov	byte ptr[bx+di],dl	;Zvysok po deleni sa presunie do pomocneho bufferu na DI poziciu
	inc	di			;Inkrement aktualnej pozicie
	pop	bx
	mov	dx,0
	jmp	next3			;Cyklus sa opakuje, pokym je vysledok delenia 0
prskc14:mov	bx,offset result
	mov	byte ptr[bx+di],dl	;Nakoniec sa ulozi aj posledna cislica
	mov	cx,di
	cmp	cx,0			;Ak je pocet cislic 1 (SI+1),
	jz	prskc16			;rovno sa zobrazi,
prskc15:mov	di,cx			;ostatne sa zobrazuju v cykle
	mov	dl,byte ptr[bx+di]
	add	dl,30h			;Kazda cislica sa prevedie na ASCII,
	mov	ah,02h
	int	21h			;a zobrazi sa
	loop	prskc15
prskc16:mov	dl,byte	ptr[bx]
	add	dl,30h
	mov	ah,02h
	int	21h			;Zobrazenie posledej cislice
	mov	dl,0Dh
	int	21h
	mov	dl,0Ah
	int	21h			;CR, LF
	pop	cx
	pop	ax			;Obnova registrov
	ret
_view	endp

_gview	proc	near			;///////Zobrazenie vsetkych cisel\\\\\\\
	mov	bx,offset cntnum
	mov	cx,[bx]			;Zistenie poctu cisel
	push	si
	mov	si,0
prskc20:call	_view			;Pri zobrazovani sa cyklicky vola procedura '_view',
	add	si,2			;ktorej parametrom je poradove cislo polozky v SI
	loop	prskc20
	pop	si
	call	_wait			;Cakanie na stlacenu klavesu
	ret
_gview	endp

_convrt	proc	near			;///////Konverzia znakov na cisla\\\\\\\
	mov	cx,0
	mov	bx,offset nrs		;Adresa textoveho retazca
next16:	mov	dx,0
next15:	mov	al,byte ptr[bx]		;Nacitanie znaku
	mov	ah,0
	cmp	ax,2Dh			;Ak sa znak rovna '-',
	jnz	prskc39
	mov	ch,1			;Nastavime vlajku 'Zaporne cislo'
	inc	bx			;a prejdeme na dalsi znak
	jmp	next15
prskc39:cmp	ax,24h			;Ak sa znak rovna '$',
	jz	prskc40			;skok na koniec procedury
	cmp	ax,0Dh			;Ak sa znak rovna CR (Enter),
	jnz	prskc41
	add	bx,2			;prejdeme o dve pozicie dalej
	push	bx			;(pretoze za CR je este LF)
	cmp	ch,1			;Ak je nastavena vlajka 'Zaporne cislo'
	jnz	prskc42
	mov	ax,-1
	mul	dx			;vynasobime vygenerovane cislo -1
	mov	dx,ax
	mov	ch,0			;Nulovanie vlajky 'Zaporne cislo' pre buduce pouzitie
prskc42:mov	bx,offset numbers	;Cislo ulozime do vystupneho bufferu na offset SI
	mov	[bx+si],dx
	add	si,2
	pop	bx
	jmp	next16
prskc41:push	ax			;Vlastna konverzia cisla:
	mov	ax,10
	mul	dx			;Doterajsi medzisucet (na zac. 0) sa vynasobi 10
	mov	dx,ax
	pop	ax
	sub	ax,30h			;znak sa prevedie na cislicu
	add	dx,ax			;a pripocita sa k medzisuctu
	inc	bx			;Inkrement pozicie v retazci
	jmp	next15			;a presun na dalsi znak
prskc40:mov	ax,si			;Nakoniec je v SI pozicia posledneho cisla
	mov	bl,2
	div	bl			;Po vydeleni dvomi
	mov	ah,0			;(kazde cislo ma dva Byte)
	mov	si,ax			;mame pocet cislic
	mov	bx,offset cntnum
	mov	[bx],si			;ktory ulozime do na to urcenej premennej
	ret
_convrt	endp

_sum	proc	near			;/////////Sucet vsetkych cisel\\\\\\\\\
	push	si
	mov	bx,offset cntnum
	mov	cx,[bx]			;Pocet cislic pre scitanie
	mov	dx,0			;Nulovanie medzisuctu
	mov	bx,offset numbers	;Adresa pola cisel
next5:	mov	ax,[bx]			;Nacitanie cisla
	add	dx,ax			;Pricitanie k medzivysledku
	jo	overfl			;Ak nastalo pretecenie, koniec
	add	bx,2			;Zvysenie adresy
	loop	next5			;Opakovanie cyklu
	mov	bx,offset cntnum
	mov	ax,[bx]			;Na koniec pola cisel
	mov	bl,2
	mul	bl
	mov	si,ax			;sa prida jedna polozka,
	add	si,2
	mov	bx,offset numbers
	mov	[bx+si],dx		;do ktorej sa ulozi vysledok suctu
	call	_view			;aby mohol byt zobrazeny procedurou '_view'
	call	_wait			;Cakanie na stlacenu klavesu
	pop	si
	ret
overfl:	jc	prskc43			;Ak nastalo pretecenie,
	printf	upover			;vypise sa chyba namiesto vysledku
	call	_wait
	pop	si
	ret
prskc43:printf	dnover			;Pri preteceni v zapornych cislach podobne
	call	_wait
	pop	si
	ret
_sum	endp

_sortup	proc	near			;//////////Vzostupne triedenie\\\\\\\\\\
next7:	mov	bx,offset cntnum
	mov	cx,[bx]			;Pocet cisel pre triedenie
	dec	cx			;-1
	mov	di,0			;Nulovanie vlajky zmeny
	mov	bx,offset numbers	;Adresa bufferu pre triedenie
next6:	mov	ax,[bx]
	mov	dx,[bx+2]		;Nacitaju sa dve susedne polozky,
	cmp	ax,dx			;porovnaju sa,
	jl	prskc25			;ak je druha mensia nez prva,
	mov	[bx+2],ax
	mov	[bx],dx			;vymenia sa
	mov	di,1			;a nastavi sa vlajka zmeny
prskc25:add	bx,2			;Prechod na dalsie dve pozicie
	loop	next6			;Prejde sa cele pole cisel
	cmp	di,1			;a to sa cyklicky opakuje
	jz	next7			;pokym je nastavena vlajka zmeny
	call	_write			;Zapis du vystupneho suboru
	call	_gview			;Vypis na obrazovku
	ret
_sortup	endp

_sortdn	proc	near			;/////////Zostupne triedenie\\\\\\\\\\\
next9:	mov	bx,offset cntnum	;(pracuje rovnako ako vzostupne triedenie,
	mov	cx,[bx]			; jediny rozdiel je, ze polozky vymiena
	dec	cx			; ak je druha vacsia nez prva)
	mov	di,0
	mov	bx,offset numbers
next8:	mov	ax,[bx]
	mov	dx,[bx+2]
	cmp	ax,dx
	jg	prskc28
	mov	[bx+2],ax
	mov	[bx],dx
	mov	di,1
prskc28:add	bx,2
	loop	next8
	cmp	di,1
	jz	next9
	call	_write
	call	_gview
	ret
_sortdn	endp

_nmmenu	proc	near			;/////////////Ciselne menu\\\\\\\\\\\\\
	push	si			;(Pouziva sa pri vybere clenov nasobenia
	mov	bx,offset cntnum	; a delenia)
	mov	cx,[bx]			;Pocet cisel v poli
	mov	si,1			;Poradove cislo
next10:	mov	dx,si
	add	dx,96			;prevedie sa na pismeno
	push	si
	mov	ah,02
	int	21h			;a zobrazi sa ako znak
	printf	seprtr			;Zobrazenie oddelovaca
	pop	si
	push	si
	dec	si
	mov	ax,si			;Poradove cislo
	mov	dl,2
	mul	dl			;sa musi vynasobit dvomi
	mov	si,ax
	call	_view			;pre pouzitie ako vstupny parameter procedury '_view'
	pop	si
	inc	si			;Inkrement poradoveho cisla
	loop	next10			;Cyklicke opakovanie podla poctu cisel
opak4:	mov	ah,08h
	int	21h			;Cakanie na stlacenu klavesu
	cmp	al,97
	jl	opak4
	cmp	al,122			;Testuje sa, ci je klavesa male pismeno
	jg	opak4
	sub	al,96			;Stlacena klavesa sa prevedie na cislo
	mov	bx,offset cntnum
	mov	cx,[bx]
	cmp	al,cl			;a este sa otestuje, ci je mensia alebo rovna
	jg	opak4			;poctu cisel v poli
	mov	ah,0
	dec	al
	mov	bl,2			;Cislo sa musi vynasobit dvomi,
	mul	bl
	mov	si,ax
	mov	bx,offset numbers	;Aby sa mohla vytvorit nova polozka  v poli numbers
	mov	ax,[bx+si]		;kde sa umiestni zvolene cislo
	push	ax
	call	_view			;aby sa mohlo zobrazit procedurou '_view'
	pop	ax			;Procedura vracia zvolene cislo v AX
	pop	si
	ret
_nmmenu	endp

_div	proc	near			;//////////Delenie dvoch cisel\\\\\\\\\\
	push	si
	printf	divtxt1			;Text 'Zadaj delenca'
	call	_nmmenu			;Uzivatel si zvoli prve cislo
	push	ax			;Procedura ho vrati v AX
	printf	divtxt2			;Text 'Zadaj delitela'
	call	_nmmenu			;Volba duheho cisla
	mov	bx,ax
	cmp	bx,0			;Ak je menovatel rovny nule,
	jz	zero			;skok na obsluhu chyby
	pop	ax
	mov	dx,0
	cmp	ax,32768		;Ak je citatel zaporny, vysledok je nepresny, treba korigovat
	jb	prskc31
	cmp	bx,32768		;Ak je aj menovatel zaporny,
	jb	prskc33
	mov	cx,0
	sub	cx,ax
	mov	ax,cx
	mov	cx,0
	sub	cx,bx
	mov	bx,cx			;obidva prevedieme na kladne
	div	bx			;a vydelime ako kladne
	jmp	prskc32
prskc33:mov	cx,0			;Ak je zaporny len citatel,
	sub	cx,ax			;prevedieme ho na kladny,
	mov	ax,cx
	div	bx			;vydelime,
	mov	cx,0
	sub	cx,ax			;a vysledok zase treba previest na zaporny
	mov	ax,cx
	jmp	prskc32
prskc31:idiv	bx			;Pri kladnom citateli prevedieme delenie bez uprav
prskc32:mov	bx,offset cntnum
	push	ax
	mov	ax,[bx]
	inc	ax
	mov	bl,2
	mul	bl
	mov	si,ax
	pop	ax
	mov	bx,offset numbers	;Vysledok delenia umiestnime na koniec pola cisel
	mov	[bx+si],ax
	call	_view			;a zobrazime pomocou '_view'
	call	_wait
	pop	si
	ret
zero:	printf	divzero			;Pri deleni nulou zobrazime spravu
	call	_wait			;a cakame na klavesu
	pop	ax
	pop	si
	ret
_div	endp

_mul	proc	near			;////////////Nasobenie\\\\\\\\\\\\\\\\\
	push	si
	printf	multxt1			;Vypis textu 'Zadaj prvy sucinitel'
	call	_nmmenu			;Vyber prveho sucinitela
	push	ax
	printf	multxt2			;Vypis textu 'Zadaj druhy sucinitel'
	call	_nmmenu			;Vyber druheho sucinitela
	mov	bx,ax
	pop	ax
	imul	bx			;Nasobenie
	jo	overfl1			;Ak nastalo pretecenie
	mov	bx,offset cntnum
	push	ax
	mov	ax,[bx]
	inc	ax
	mov	bl,2
	mul	bl
	mov	si,ax
	pop	ax
	mov	bx,offset numbers	;Cislo ulozime na novu poziciu v poli
	mov	[bx+si],ax
	call	_view			;Aby sme ho mohli zobrazit pomocou '_view'
	call	_wait
	pop	si
	ret
overfl1:printf	upover
	call	_wait
	pop	si
	ret
_mul	endp

_strcon	proc	near
	push	si
	mov	bx,offset cntnum
	mov	cx,[bx]
	mov	bx,offset numbers
	mov	di,offset result
next12:	push	cx
	mov	si,0
	mov	ax,[bx]
	cmp	ax,0
	jg	prskc35
	mov	byte ptr[di],2Dh
	inc	di
	mov	dx,0
	sub	dx,ax
	mov	ax,dx
	jmp	prskc35
prskc36:mov	cl,dl
	mov	ch,0
	add	cl,30h
	push	cx
	inc	si
prskc35:mov	cx,10
	mov	dx,0
	div	cx
	cmp	ax,0
	jnz	prskc36
	add	dx,30h
	mov	byte ptr[di],dl
	inc	di
	mov	cx,si
	cmp	cx,0
	jz	prskc37
next11:	pop	ax
	mov	byte ptr[di],al
	inc	di
	loop	next11
prskc37:mov	byte ptr[di],0Dh
	mov	byte ptr[di+1],0Ah
	add	di,2
	add	bx,2
	pop	cx
	loop	next12
	pop	si
	ret
_strcon	endp

_menu	proc 	near			;//////////////Hlavne menu\\\\\\\\\\\\\\
opak2:	call	_clear			;Vymazanie obrazovky
	mov 	bp,offset menu1		;Priprava registrov pre int10h - adresa retazca
	mov	cx,offset menu2 - offset menu1	;Dlzka retazca
	mov	dh,8			;Riadok
	mov	dl,25			;Stlpec
	mov	bh,0			;Stranka obrazovky
	mov	bl,15			;Atribut ( biely text,cierne pozadie)
	cmp	si,1			;Ak je zvolena polozka menu c. 1,
	jnz	preskc3
	add	bl,16			;zmenime pozadie na modre
preskc3:mov	ah,13h			;Cislo podfunkcie int10h
	mov	al,0			;Mod zobrazenia
	int 	10h			;Vypis prvej casti menu na obrazovku
	mov	bp,offset menu2		;Adresa druhej casti menu
	mov	cx,offset menu3 - offset menu2	;Dlzka retazca
	inc	dh			;Novy riadok
	mov	bl,15			;Biele pismo, cierne pozadie
	cmp	si,2			;Ak bola zvolena polozka menu c. 2,
	jnz	preskc4
	add	bl,16			;zmenime pozadie na modre
preskc4:int	10h			;Zobrazenie druhej casti menu
	mov	bp,offset menu3		;			.
	mov	cx,offset menu4 - offset menu3	;		.
	inc	dh			;			.
	mov	bl,15
	cmp	si,3
	jnz	preskc5
	add	bl,16
preskc5:int	10h
	mov	bp,offset menu4
	mov	cx,offset menu5 - offset menu4
	inc	dh
	mov	bl,15
	cmp	si,4
	jnz	preskc6
	add	bl,16
preskc6:int	10h
	mov	bp,offset menu5
	mov	cx,offset menu6 - offset menu5
	inc	dh
	mov	bl,15
	cmp	si,5
	jnz	preskc7
	add	bl,16
preskc7:int 	10h
	mov	bp,offset menu6
	mov	cx,offset menu7 - offset menu6
	inc	dh
	mov	bl,15
	cmp	si,6
	jnz	preskc8
	add	bl,16
preskc8:int	10h
	mov	bp,offset menu7
	mov	cx,offset result - offset menu7
	inc	dh
	mov	bl,15
	cmp	si,7
	jnz	preskc9
	add	bl,16
preskc9:int 	10h
;	mov	bp,offset menu8
;	mov	cx,offset result - offset menu8
;	inc	dh
;	mov	bl,15
;	cmp	si,8
;	jnz	prskc18
;	add	bl,16
;prskc18:int	10h			;Zobrazenie poslednej casti menu na obrazovku
	mov	ah,08h
	int	21h			;Nacitanie klavesy {bez echa)
	cmp	al,0			;Ak je klavesa 0 (rozsireny kod)
	jnz	preskoc
	int	21h			;treba volat druhy krat
preskoc:cmp	al,72			;Ak bola stlacena sipka hore
	jz	hore
	cmp	al,80			;Ak bola stlacena sipka dole
	jz 	dole
	cmp	al,13			;Ak bol stlaceny ENTER
	jz	ok
dole:	inc	si			;SIPKA DOLE: zvysime cislo polozky menu
	cmp	si,8			;Ak sme na konci menu,
	jnz	preskc2
	mov	si,1			;presunieme sa na zaciatok menu
preskc2:jmp	opak2			;a nove prekreslenie
hore:	dec	si			;SIPKA HORE: znizime cislo polozky menu
	cmp	si,0			;Ak sme na zaciatku menu,
	jnz	preskc1
	mov	si,7			;presunieme sa na koniec menu
preskc1:jmp	opak2			;a znovu prekreslime
ok:	ret				;ENTER: ukoncenie procedury, v SI je zvolena polozka
_menu	endp

_clear	proc	near			;//////////Vymazanie obrazovky\\\\\\\\\\
	mov	ah,06h			;Pouzijeme podfunkciu pre rolovanie okna
	mov	ch,0			;Suradnice laveho horneho rohu okna
	mov	cl,0
	mov	dh,24			;Suradnice praveho dolneho rohu okna
	mov	dl,79
	mov	al,0			;Vymazat cele okno
	mov	bh,15			;Atribut pre prazdne riadky (biele pismo na ciernom pozadi)
	int	10h			;Vykonanie vymazania okna
	mov	ah,02h
	mov	bh,0
	mov	dx,0
	int	10h			;Nastavenie kurzora do laveho horneho rohu obrazovky
	ret
_clear	endp

_wait	proc	near			;//////Cakanie na stlaveny klaves\\\\\\
	mov	ah,01h
	int	21h
	ret
_wait	endp

prog	ends
end	start