;-----------------------------------------------------------------------------
; Zadanie c. 2, Ondrej Hluchy, 14. 11. 2000, 2. roc., sk. rok 2000/2001
;-----------------------------------------------------------------------------

.model tiny

.code
org 100h                                        ;program bude typu COM

start:          call    clrscr                  ;vycisti obrazovku
                mov     di, offset header       ;napise hlavicku
                call    puts
                mov     di, offset input
                call    fopen                   ;otvori subor
                jnc     continue0               ;CF = 1 ? nastala chyba
                mov     di, offset message0a    ;sprava o nenajdeni suboru
                call    puts
                mov     di, offset text3        ;sprava o cakani na klavesu
                call    puts
                call    getch                   ;caka na klavesu
                jmp     quit
continue0:      mov     [handle], ax            ;ulozi rukovat
                mov     di, offset text0        ;sprava o citani zo suboru
                call    puts
                xor     cx, cx                  ;CX - pocet nacitanych cisel
                mov     si, offset numbers      ;SI - offset pola, kam sa nacitaju cisla
again:          mov     ax, [handle]            ;AX - rukovat suboru
                mov     di, offset string       ;DI - pointer kam sa nacita retazec
                call    fgets                   ;hlada v subore cislo (retazec)
                cmp     byte ptr [di], 0        ;nenasiel ?
                jz      close
                call    puts                    ;vypise nacitane cislo
                call    wherexy                 ;zisti poziciu kurzora
                mov     dl, 30
                call    gotoxy                  ;nastavi poziciu kurzora
                call    atoi                    ;konverzia retazca na cislo
                jc      badnumber               ;CF = 1 ? cislo nebolo v rozsahu
                mov     [si], ax                ;ulozi cislo do pola
                inc     si
                inc     si
                inc     cx                      ;CX - pocet cisel
                mov     di, offset text1        ;sprava cislo je 'Ok.'
                call    puts
                jmp     again
badnumber:      mov     di, offset text2        ;sprava cislo je 'Mimo rozsah!'
                call    puts
                jmp     again
close:          mov     [count], cx             ;ulozi pocet cisel
                cmp     cx, 0                   ;pocet cisel = 0 ?
                jnz     continue1
                mov     di, offset message0b    ;sprava o subore bez cisel
                call    puts
continue1:      mov     di, offset crlf         ;novy riadok
                call    puts
                mov     di, offset text3        ;sprava o cakani na klavesu
                call    puts
                call    getch                   ;caka na klavesu
                mov     ax, [handle]
                call    fclose                  ;zatvori subor
                cmp     [count], 0              ;pocet cisel = 0 ?
                jz      quit
repeat:         call    clrscr                  ;vycisti obrazovku
                mov     di, offset header       ;napise hlavicku
                call    puts
                mov     di, offset menu         ;napise menu
                call    puts
readkey:        call    getch                   ;caka na klavesu
m1:             cmp     al, '1'                 ;stlacil som '1' ?
                jnz     m2
                call    menu1                   ;obsluha 1. volby
                jmp     repeat
m2:             cmp     al, '2'                 ;stlacil som '2' ?
                jnz     m3
                call    menu2                   ;obsluha 2. volby
                jmp     repeat
m3:             cmp     al, '3'                 ;stlacil som '3' ?
                jnz     m4
                call    menu34                  ;obsluha 3. a 4. volby
                jmp     repeat
m4:             cmp     al, '4'                 ;stlacil som '4' ?
                jnz     m5
                call    menu34                  ;obsluha 3. a 4. volby
                jmp     repeat
m5:             cmp     al, '5'                 ;stlacil som '5' ?
                jnz     readkey
quit:           call    clrscr                  ;vycisti obrazovku
                int     20h                     ;ukoncenie programu

;-----------------------------------------------------------------------------
; Vycisti obrazovku a nastavi kurzor do laveho horneho rohu.
;-----------------------------------------------------------------------------
clrscr          proc    near
                push    es
                push    di
                push    ax
                push    cx
                mov     ax, 0B800h              ;B800h  - segment videopamate
                mov     es, ax
                xor     di, di
                mov     cx, 2000                ;80 * 25 * 2 = 2000
                mov     al, 0                   ;znak, ktorym sa vyplni obrazovka
                mov     ah, 7 + 0 * 16          ;atribut znaku
                rep     stosw
                mov     dl, 0                   ;x - suradnica
                mov     dh, 0                   ;y - suradnica
                call    gotoxy                  ;nastavi polohu kurzora
                pop     cx
                pop     ax
                pop     di
                pop     es
                ret
clrscr          endp

;-----------------------------------------------------------------------------
; Nastavi poziciu kurzora.
; Vstup: DH - riadok (suradnica y)
;        DL - stlpec (suradnica x)
;-----------------------------------------------------------------------------
gotoxy          proc    near
                push    ax
                push    bx
                push    dx
                mov     bh, 0                  ;stranka obrazovky
                mov     ah, 02h                ;nastavi polohu kurzora
                int     10h
                pop     dx
                pop     bx
                pop     ax
                ret
gotoxy          endp

;-----------------------------------------------------------------------------
; Zisti poziciu kurzora.
; Vystup: DH - riadok (suradnica y)
;         DL - stlpec (suradnica x)
;-----------------------------------------------------------------------------
wherexy         proc    near
                push    ax
                push    bx
                push    cx
                mov     bh, 0                   ;stranka obrazovky
                mov     ah, 03h                 ;zisti polohu kurzora
                int     10h
                pop     cx
                pop     bx
                pop     ax
                ret
wherexy         endp

;-----------------------------------------------------------------------------
; Cita znak z klavesnice.
; Vystup: AL - znak z klavesnice
;         AH = 1 v pripade rozsirenych klaves, inak AH = 0
;-----------------------------------------------------------------------------
getch           proc    near
                mov     ah, 08h                 ;vstup bez echa
                int     21h
                mov     ah, 0
                cmp     al, 0                   ;AL = 0 ? bola stlacena rozsirena klavesa
                jnz     gend
                mov     ah, 08h                 ;treba volat dvakrat pre rozsirene klavesy
                int     21h
                mov     ah, 1
gend:           ret
getch           endp

;-----------------------------------------------------------------------------
; Otvori subor.
; Vstup: ES:DI - pointer na meno suboru zakoncene s '\0'
; Vystup: AX - rukovat suboru
;-----------------------------------------------------------------------------
fopen           proc    near
                push    dx
                push    ds
                mov     ax, es
                mov     ds, ax
                mov     dx, di
                mov     ax, 3D00h               ;otvori subor pre citanie
                int     21h
                pop     ds
                pop     dx
                ret
fopen           endp

;-----------------------------------------------------------------------------
; Vytvori subor.
; Vstup: ES:DI - pointer na meno suboru zakoncene s '\0'
; Vystup: AX - rukovat suboru
;-----------------------------------------------------------------------------
fcreate         proc    near
                push    cx
                push    dx
                push    ds
                mov     ax, es
                mov     ds, ax
                mov     dx, di
                mov     cx, 0                   ;atributy suboru
                mov     ah, 3Ch                 ;vytvori subor
                int     21h
                pop     ds
                pop     dx
                pop     cx
                ret
fcreate         endp

;-----------------------------------------------------------------------------
; Zatvori subor.
; Vstup: AX - rukovat suboru
;-----------------------------------------------------------------------------
fclose          proc    near
                push    ax
                push    bx
                mov     bx, ax                  ;BX - rukovat suboru
                mov     ah, 3Eh                 ;zatvori subor
                int     21h
                pop     bx
                pop     ax
                ret
fclose          endp

;-----------------------------------------------------------------------------
; Hlada v subore cisla (napisane ako retazec).
; Vstup: AX - rukovat suboru
;        ES:DI - pointer na pole, kam chceme ulozit cislo (retazec)
; Vystup: ES:DI - pointer na retazec (cislo) zakonceny '\0'
; Popis: Procedura hlada v subore cislo so znamienkom, t. j. cita znaky zo
;        suboru az kym nenarazi na '-' alebo na '0' az '9'. Potom tieto znaky
;        zapisuje do retazca dovtedy, kym nenarazi na iny znak ako su znaky
;        vymenovane vyssie.
;-----------------------------------------------------------------------------
fgets           proc    near
                push    ds
                push    di
                push    si
                push    bx
                push    cx
                push    dx
                mov     si, 0                   ;SI - indikuje najdene cislo
                mov     bx, ax                  ;BX - rukovat suboru
                mov     cx, 1                   ;CX - pocet citanych znakov
                mov     dx, offset char         ;[char] - buffer pre nacitany znak
fgetc:          mov     ah, 3fh                 ;cita zo suboru
                int     21h
                jc      eof                     ;CF = 1 ? pri citani nastala chyba
                mov     ah, al                  ;AH - pocet nacitanych znakov
                mov     al, [char]              ;AL - nacitany znak
                cmp     ah, 0                   ;AH = 0 ? koniec suboru
                jz      eof
                cmp     al, '-'                 ;AL = '-' ? uloz
                jz      store
                cmp     al, '0'                 ;AL < '0' ? skok
                jb      fgend
                cmp     al, '9'                 ;AL > '9' ? skok
                ja      fgend
store:          mov     es:[di], al             ;uloz znak do retazca
                inc     di
                mov     si, 1                   ;SI = 1 ? naslo sa cislo
                jmp     fgetc
fgend:          cmp     si, 0                   ;SI = 0 ? hladaj dalej
                jz      fgetc
eof:            mov     byte ptr es:[di], 0     ;zakoncenie retazca s '\0'
                pop     dx
                pop     cx
                pop     bx
                pop     si
                pop     di
                pop     ds
                ret
fgets           endp

;-----------------------------------------------------------------------------
; Zapis do suboru.
; Vstup: AX - rukovat suboru
;        ES:DI - pointer na retazec zakonceny '\0'
; Popis: Procedura zapise do suboru retazac zakonceny '\0'
;-----------------------------------------------------------------------------
fputs           proc    near
                push    ds
                push    di
                push    bx
                push    cx
                push    dx
                mov     bx, ax                  ;BX - rukovat suboru
                mov     cx, 1                   ;CX - pocet zapisovanych znakov
                mov     dx, offset char         ;[char] - buffer pre zapisovany znak
fputc:          mov     al, es:[di]             ;AL - znak z retazca
                mov     [char], al              ;[char] obsahuje znak pre zapis
                inc     di
                cmp     al, 0                   ;testuje ci je koniec retazca
                jz      fpend
                mov     ah, 40h                 ;zapis do suboru
                int     21h
                jmp     fputc
fpend:          pop     dx
                pop     cx
                pop     bx
                pop     di
                pop     ds
                ret
fputs           endp

;-----------------------------------------------------------------------------
; Konvertuje retazec na cislo so znamienkom.
; Vstup: ES:DI - pointer na retazec zakonceny '\0'
; Vystup: AX - cislo so znamienkom
;         CF = 0 ak je cislo z intervalu <-32768, 32767> inak CF = 1
;-----------------------------------------------------------------------------
atoi            proc    near
                push    di
                push    cx
                push    dx
                xor     cx, cx                  ;v CX sa bude vyrabat cislo
                xor     ah, ah                  ;AH - informacia o znamienku
                cmp     byte ptr es:[di], '-'
                jne     doatoi                  ;ak je kladne, skok na doatoi
                inc     di                      ;preskoci '-'
                mov     ah, 1                   ;cislo je zaporne
doatoi:         mov     al, es:[di]             ;nacita znak do AL
                inc     di
                xor     al, '0'                 ;prevod ASCII znaku na cislicu
                cmp     al, 10                  ;ak znak nebol cislica,
                jae     notdigit                ;skok na notdigit
                shl     cx, 1                   ;nasledujucich devat riadkov
                jc      error                   ;nasobi cislo v CX desiatimi
                mov     dx, cx                  ;pomocou posunov
                shl     cx, 1                   ;3 * shl cx, 1 je vlastne
                jc      error                   ;CX * 8, pricom po prvom posune
                shl     cx, 1                   ;sa cislo v CX odpamata v DX
                jc      error                   ;na konci sa to spocita a
                add     cx, dx                  ;dostaneme CX * 8 + CX * 2 = CX * 10
                jc      error
                add     cl, al                  ;tu sa pripocita cislica v AL
                adc     ch, 0                   ;ak nastal prenos, pripocita sa k CH
                jc      error
                jmp     doatoi
notdigit:       cmp     ah, 0                   ;ak je cislo kladne,
                je      positive                ;skok na positive
                cmp     cx, 32768               ;ak je CX > 32768,
                ja      error                   ;skok na error
                neg     cx                      ;zmeni cislu v CX znamienko
                clc
                jmp     noerror
positive:       cmp     cx, 32767               ;ak je CX > 32767,
                ja      error                   ;skok na error
                clc
                jmp     noerror
error:          stc
noerror:        mov     ax, cx
                pop     dx
                pop     cx
                pop     di
                ret
atoi            endp

;-----------------------------------------------------------------------------
; Konvertuje cislo so znamienkom na retazec.
; Vstup: AX - cislo so znamienkom
;        ES:DI - pointer na pole, kam chceme ulozit retazec
; Vystup: ES:DI - pointer na retazec zakonceny '\0'
; Popis: Procedura do prveho znaku retazca ulozi '-' ak je cislo zaporne,
;        urobi absolutnu hodnotu cisla, zavola proceduru PUTI na vlastny
;        prevod cisla a nakoniec retazec ukonci znakom '\0'.
;-----------------------------------------------------------------------------
itoa            proc    near
                push    di
                push    ax
                push    bx
                push    dx
                cmp     ax, 0
                jge     doit                    ;ak je cislo zaporne, tak
                mov     byte ptr es:[di], '-'   ;retazec bude zacinat s '-'
                inc     di
                neg     ax                      ;cislo v AX zmeni znamienko
doit:           call    puti                    ;prevod cisla na retazec
                mov     byte ptr es:[di], 0     ;zakoncenie retazca s '\0'
                pop     dx
                pop     bx
                pop     ax
                pop     di
                ret
itoa            endp

;-----------------------------------------------------------------------------
; Rekurzivna procedura pouzivana procedurou ITOA na ziskanie jednotlivych
; cislic z cisla ulozeneho v AX.
; Vstup: AX - cislo bez znamienka (ITOA urobila absolutnu hodnotu)
;        ES:DI - pointer na pole, kam chceme ulozit  ratazec
; Vystup: ES:DI - pointer na retazec (bez zakoncovacej '\0')
; Popis: Procedura deli cislo v AX desiatimi tak dlho az je vysledok 0 a pritom
;        sa ukladaju do zasobnika jednotlive zvysky po deleni. Tieto potom
;        po konverzii na ASCII cislicu vytvaraju jednotlive znaky retazca.
;-----------------------------------------------------------------------------
puti            proc    near
                mov     bx, 10
                xor     dx, dx
                div     bx                      ;cislo v AX sa deli cislom 10
                or      ax, ax                  ;ak je vysledok 0,
                jz      done                    ;cislo je rozlozene
                push    dx                      ;zvysky po deleni sa ukladaju do zasobnika
                call    puti
                pop     dx                      ;zvysky po deleni sa vyberaju zo zasobnika
done:           or      dl, '0'                 ;prevod cislice na ASCII znak
                mov     es:[di], dl             ;ulozenie znaku do retazca
                inc     di
                ret
puti            endp

;-----------------------------------------------------------------------------
; Vypise retazec na obrazovku od aktualnej pozicie kurzora.
; Vstup: ES:DI - adresa retazca zakonceneho '\0'
; Popis: Procedura vypisuje na obrazovku jednotlive znaky retazca az po '\0'.
;-----------------------------------------------------------------------------
puts            proc    near
                push    di
                push    ax
                push    dx
pstart:         mov     al, es:[di]             ;AL - znak z retazca
                inc     di
                cmp     al, 0                   ;testuje ci je koniec retazca
                jz      pend
                call    putc                    ;zobraz znak
                jmp     pstart
pend:           pop     dx
                pop     ax
                pop     di
                ret
puts            endp

;-----------------------------------------------------------------------------
; Zobraz znak.
; Vstup: AL - zobrazovany znak
;-----------------------------------------------------------------------------
putc            proc    near
                push    ax
                push    dx
                mov     dl, al                  ;DL - zobrazovany znak
                mov     ah, 02h                 ;zobraz znak
                int     21h
                pop     dx
                pop     ax
                ret
putc            endp

;-----------------------------------------------------------------------------
; Obsluha 1. volby z menu.
;-----------------------------------------------------------------------------
menu1           proc    near
                call    clrscr                  ;vycisti obrazovku
                mov     di, offset header       ;napise hlavicku
                call    puts
                xor     bx, bx                  ;BX - informacia o preteceni
                xor     dx, dx                  ;DX - sucet cisel
                mov     cx, [count]             ;CX - pocet cisel
                mov     si, offset numbers      ;SI - offset pola z cislami
repeat1:        mov     ax, [si]                ;AX - cislo z pola
                add     dx, ax                  ;DX = DX + AX
                jno     next                    ;OF = 1 ? pretecenie, inak OF = 0
                mov     bx, 1                   ;BX = 1 - pretecenie
next:           inc     si
                inc     si
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                mov     di, offset crlf         ;novy riadok
                call    puts
                loop    repeat1
                mov     di, offset crlf         ;novy riadok
                call    puts
                cmp     bx, 0                   ;BX = 1 - pretecenie
                jnz     overflow
                mov     di, offset message1a    ;odpoved
                call    puts
                mov     ax, dx                  ;AX - sucet cisel
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                jmp     menu1end
overflow:       mov     di, offset message1b    ;sprava o preteceni
                call    puts
menu1end:       mov     di, offset crlf         ;novy riadok
                call    puts
                call    puts
                mov     di, offset text3        ;sprava o cakani na klavesu
                call    puts
                call    getch                   ;caka na klavesu
                ret
menu1           endp

;-----------------------------------------------------------------------------
; Obsluha 2. volby z menu.
;-----------------------------------------------------------------------------
menu2           proc    near
                mov     cx, [count]             ;CX - pocet cisel
                mov     si, offset numbers      ;SI - offset pola z cislami
                mov     di, offset numbers2     ;DI - offset pola pre vytriedene cisla
                rep     movsw                   ;kopirovanie prveho pola do druheho
                mov     cx, [count]             ;CX - pocet cisel
                cmp     cx, 2                   ;CX < 2 ? netreba triedit
                jb      sortend
                dec     cx                      ;tu zacina triedenie
sort1:          xor     si, si
                xor     dx, dx
sort2:          mov     ax, [numbers2 + si]
                mov     bx, [numbers2 + si + 2]
                cmp     ax, bx                  ;AX > BX ? vymen cisla
                jle     nochange
                mov     [numbers2 + si], bx
                mov     [numbers2 + si + 2], ax
nochange:       inc     si
                inc     si
                inc     dx
                cmp     cx, dx
                jnz     sort2
                loop    sort1                   ;tu konci triedenie
sortend:        mov     di, offset output
                call    fcreate                 ;vytvori subor
                mov     [handle], ax            ;ulozi rukovat suboru
                mov     cx, [count]             ;CX - pocet cisel
                mov     si, offset numbers2     ;SI - offset pola s vytriedenymi cislami
repeat2:        mov     ax, [si]                ;AX - cislo z pola
                inc     si
                inc     si
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                mov     ax, [handle]
                call    fputs                   ;zapis retazca do suboru
                mov     di, offset crlf         ;novy riadok v subore
                mov     ax, [handle]
                call    fputs
                loop    repeat2
                mov     ax, [handle]
                call    fclose                  ;zatvori subor
                call    clrscr                  ;vycisti obrazovku
                mov     di, offset header       ;napise hlavicku
                call    puts
                mov     di, offset message2     ;informacia o zapise do suboru
                call    puts
                mov     di, offset text3        ;sprava o cakani na klavesu
                call    puts
                call    getch                   ;caka na klavesu
                ret
menu2           endp

;-----------------------------------------------------------------------------
; Obsluha 3. a 4. volby z menu.
;-----------------------------------------------------------------------------
menu34          proc    near
                mov     [case], al              ;[case] - volba, ktora sa obsluhuje
                call    clrscr                  ;vycisti obrazovku
                mov     di, offset header       ;napise hlavicku
                call    puts
                mov     dx, 'a'                 ;DX - sluzi na indexovanie pola
                mov     cx, [count]             ;CX - pocet cisel
                mov     si, offset numbers      ;SI - offset pola z cislami
repeat3:        mov     al, dl                  ;zobrazi znak v AL
                call    putc
                mov     al, '.'                 ;zobrazi '.'
                call    putc
                mov     al, ' '                 ;zobrazi ' '
                call    putc
                mov     ax, [si]                ;AX - cislo z pola
                inc     si
                inc     si
                inc     dx
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                mov     di, offset crlf         ;novy riadok
                call    puts
                loop    repeat3
                call    puts                    ;novy riadok
                mov     di, offset message34a   ;poziadavka na vyber 1. cisla
                call    puts
getc3a:         call    getch                   ;caka na klavesu
                cmp     ax, 'a'                 ;AX < 'a' ? skus znova
                jb      getc3a
                cmp     ax, dx                  ;AX > DX ? skus znova
                jae     getc3a
                sub     ax, 'a'                 ;AX - poradie vybraneho cisla v poli
                shl     ax, 1                   ;AX * 2 lebo pole je zlozene z wordov
                mov     bx, ax                  ;BX - umiestnenie cisla v poli
                mov     ax, [numbers + bx]      ;AX - cislo z pola
                mov     [number1], ax           ;ulozenie 1. cisla
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                mov     di, offset crlf         ;novy riadok
                call    puts
                mov     di, offset message34b   ;poziadavka na vyber 2. cisla
                call    puts
getc3b:         call    getch                   ;caka na klavesu
                cmp     ax, 'a'                 ;AX < 'a' ? skus znova
                jb      getc3b
                cmp     ax, dx                  ;AX > DX ? skus znova
                jae     getc3b
                sub     ax, 'a'                 ;AX - poradie vybraneho cisla v poli
                shl     ax, 1                   ;AX * 2 lebo pole je zlozene z wordov
                mov     bx, ax                  ;BX - umiestnenie cisla v poli
                mov     ax, [numbers + bx]      ;AX - cislo z pola
                cmp     [case], '4'             ;ktoru volbu obsluhujeme ?
                jz      case4a
                cmp     ax, 0                   ;obsluhujeme delenie a 2. cislo = 0 ?
                jz      getc3b                  ;vyber ine cislo
case4a:         mov     [number2], ax           ;ulozenie 2. cisla
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                mov     di, offset crlf         ;novy riadok
                call    puts
                call    puts
                mov     ax, [number1]           ;AX - 1. cislo
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                cmp     [case], '4'             ;ktoru volbu obsluhujeme ?
                jz      case4b
                mov     di, offset divide       ;napise ' / '
                jmp     print
case4b:         mov     di, offset multiply     ;napise ' * '
print:          call    puts
                mov     ax, [number2]           ;AX - 2. cislo
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                mov     di, offset equals       ;napise ' = '
                call    puts
                mov     [resultsign], 0         ;znamienko vysledku
                mov     [remaindersign], 0      ;znamienko zvysku
                xor     dx, dx
                mov     ax, [number1]           ;AX - 1. cislo
                mov     bx, [number2]           ;BX - 2. cislo
                cmp     ax, 0                   ;AX >= 0 ?
                jge     plus1
                neg     ax                      ;AX = 0 - AX
                xor     [resultsign], 1         ;zmen znamienko vysledku
                xor     [remaindersign], 1      ;zmen znamienko zvysku
plus1:          cmp     bx, 0                   ;BX >= 0 ?
                jge     plus2
                neg     bx                      ;BX = 0 - BX
                xor     [resultsign], 1         ;zmen znamienko vysledku
plus2:          cmp     [case], '4'             ;ktoru volbu obsluhujeme ?
                jz      case4c
                div     bx                      ;3. volba - delenie
                jmp     sign
case4c:         mul     bx                      ;4. volba - nasobenie
                cmp     dx, 0                   ;DX > 0 ? pretecenie pri nasobeni
                jz      sign
                mov     di, offset message4     ;sprava o preteceni pri nasobeni
                call    puts
                jmp     case4d
sign:           cmp     [resultsign], 0         ;znamienko vysledku
                jz      plus3
                neg     ax                      ;AX - vysledok
plus3:          mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
                cmp     [case], '4'             ;ktoru volbu obsluhujeme ?
                jz      case4d
                cmp     [remaindersign], 0      ;znamienko zvysku
                jz      plus4
                neg     dx                      ;DX - zvysok (po deleni)
plus4:          mov     di, offset remainder    ;napise '   zvysok   '
                call    puts
                mov     ax, dx                  ;AX - zvysok
                mov     di, offset string
                call    itoa                    ;konverzia cisla na retazec
                call    puts                    ;vypis skonvertovaneho cisla
case4d:         mov     di, offset crlf         ;novy riadok
                call    puts
                call    puts
                mov     di, offset text3        ;sprava o cakani na klavesu
                call    puts
                call    getch                   ;caka na klavesu
                ret
menu34          endp

;-----------------------------------------------------------------------------
; Data.
;-----------------------------------------------------------------------------
header          db 'Zadanie c. 2, Ondrej Hluchy, 14. 11. 2000, 2. roc., sk. rok 2000/2001', 0Dh, 0Ah, 0Dh, 0Ah, 0
menu            db '1. Vypocitat sumu vsetkych cisel.', 0Dh, 0Ah
                db '2. Usporiadat cisla.', 0Dh, 0Ah
                db '3. Vydelit dve vybrane cisla.', 0Dh, 0Ah
                db '4. Vynasobit dve vybrane cisla.', 0Dh, 0Ah
                db '5. Ukoncit vykonavanie programu.', 0
text0           db 'Citanie udajov zo suboru "zad2.in"...', 0Dh, 0Ah, 0Dh, 0Ah, 0
text1           db 'Ok.', 0Dh, 0Ah, 0
text2           db 'Mimo rozsah!', 0Dh, 0Ah, 0
text3           db 'Stlacte lubovolny klaves...', 0
message0a       db 'Subor "zad2.in" nenajdeny!', 0Dh, 0Ah, 0Dh, 0Ah, 0
message0b       db 'Subor "zad2.in" neobsahuje ziadne cisla!', 0Dh, 0Ah, 0
message1a       db 'Suma vsetkych cisel je: ', 0
message1b       db 'Pri vypocte sumy doslo k preteceniu.', 0
message2        db 'Usporiadana postupnost cisel bola zapisana do suboru "zad2.out."', 0Dh, 0Ah, 0Dh, 0Ah, 0
message34a      db 'Vyberte si 1. cislo: ', 0
message34b      db 'Vyberte si 2. cislo: ', 0
message4        db 'Pri vypocte sucinu doslo k preteceniu.', 0
crlf            db 0Dh, 0Ah, 0
input           db 'zad2.in', 0
output          db 'zad2.out', 0
handle          dw 0
numbers         dw 100 dup (0)
numbers2        dw 100 dup (0)
number1         dw 0
number2         dw 0
count           dw 0
string          db 80 dup (0)
char            db 0
multiply        db ' * ', 0
divide          db ' / ', 0
equals          db ' = ', 0
remainder       db '   zvysok   ', 0
resultsign      db 0
remaindersign   db 0
case            db 0

end start