;ZADANIE C.2
;Vytvorte program, ktroy nacita z textoveho suboru postupnost
;celych cisel so znamienkom v desiatkovej ciselnej sustave (aspon
;10), potom ich transformuje na cisla v dvojkovej ciselnej sustave
;v doplnkovom kode a potom podla priania uzivatela:
;	a) vypocita sumu vsetkych cisel a vypise ju
;	b) usporiada cisla vzostupne a zapise usporiadanu postupnost cisel
;   	   do noveho textoveho suboru
;	c) vydeli dve dane sla a vypise vysledok
;	d) vynsob dve sla a vype vsledok
;	e) ukonci vykonavanie programu

;Autor: Stefan Trgala
;nazov suboru: zadanie2.asm
;Termin odvzdania: 14.11.2000
;2 roc.,sk.rok 2000/2001

;program bol napisany na pocitaci Pentium 133MHz, 64MB RAM, Win98
;obmedzenia programu: vstupne hodnoty musia byt cisla z intervalu -128 az 127 
;musi existovat vstupny subor
;maximalna dlzka vstupneho retazca 256 znakov

.286	
.model small  
.stack 100h   ; zasobnik velky 100h
.data	      ; datova cast
cisla   db "0123456789"
buffer  db 5 dup(?),"$"
nadpis	db "      Menu 	  ",10,13,"$" ; cisla 10,13 kvoli zariadkovaniu
moz1	db 10,13,"  a) sucet cisel                  $"
moz2	db 10,13,"  b) usporiadaj a zapis cisla do suboru $"
moz4 	db 10,13,"  c) delenie                      $"
moz5	db 10,13,"  d) nasobenie                    $"
moz6    db 10,13,"  e) koniec                       $"
vet 	db 10,13," cisla : $"
vet1    db 10,13," sucet : $"
vet2    db 10,13," nastala aritmeticka chyba $"
vet3    db 10,13," zapisane do suboru vystup.txt $"
vet4    db 10,13," zapisane do suboru zostup.txt $"
vet5	db 10,13," prvky, ktore chces delit (od jedna): $"
vet6	db 10,13," prvky, ktore chces nasobit (od jedna): $"
vet7    db 10,13," celociselny vysledok : $"
vet8    db 10,13," Zvysok po deleni : $"
prr	db 10,13,"$"
subor   db "vstup.txt",0
subor2  db "vystup.txt",0
subor3  db "zostup.txt",0
retaz   db ' ',100h dup("$")
medzera db ' $'
pole    db 30h dup(?)
cislo   db 3,4 dup(' ')
kam	db ?
ktorys  dw ?
vysl    db ?
stabx   dw ?
pocet   dw ?
vstup   dw ?
vystup1 dw ?
vystup2 dw ?
desat   db 10
mjedna  db -1

	.code			; kodova cast

nacitaj proc
    pusha
    mov dx,offset subor
    mov ax,3d00h
    int 21h
    mov vstup,ax         	;sluzba otvorenia suboru

    mov ah,3fh			;sluzba citania zo suboru
    mov bx,vstup
    mov dx,offset retaz
    inc dx           
    mov cx,100h
    int 21h
    mov bx,ax
    mov [retaz+bx],' '		;nacitanie a korekcia retazca pridanim medzier

    mov ah,3eh			;sluzba zavretia suboru
    mov bx,vstup
    int 21h
       
    popa
    ret
nacitaj endp

chyba proc			;vypise chybove hlasenie
  pusha
  mov ah,9
  mov dx,offset vet2
  int 21h

  popa
  ret
chyba endp

vyppol proc		;proc.na vypisanie pola
    pusha
    mov dx,offset medzera
    mov di,0

fo8:cmp di,pocet        ;for di:=0 to pocet do
    jz ef8
    mov al,[pole+di]	
    cbw			;znamienkova uprava al->ax
    call vypcisl	;vypis ax
    mov cx,1
    mov ah,kam		;v kam 09 ak na obrazovku inak 40h ak do suboru
    mov bx,ktorys	;v bx handle suboru
    int 21h
    
    inc di
    jmp fo8
ef8:       
    popa
    ret
vyppol endp 

prevednac proc		;v premennej vysl je cislo ktore sa nachadza na [bx] vo forme retazca
    pusha
			;[BX] -> zaciatok, po medzeru
loo:inc bx		; cyklus sa dostane na konec cisla tj. bx ukazuje na jednotky
    mov al,ds:[bx]
    cmp al,' '
    jz k5			
    cmp al,0dh
    jz k5
    jmp loo
k5:

    mov stabx,bx	;kvoli navratu do proc strtonum
    dec bx
    
    mov cx,1		
    mov dx,0
lo1:mov al,ds:[bx]	;do al cifra c ASCII
    cmp al,'-'		;ak uz minus
    jz min		
    cmp al,' '		;alebo medzera
    jz ko		;koniec
    sub al,30h   	;v al cislo
    mul cl       	;ax=al*cl
    add dl,al    	;dl=vysledok 
    mov al,cl	 
    mul desat	 	;ax=al*10
    mov cl,al	 
    dec bx
    jmp lo1
min:mov al,dl
    imul mjedna		;vynasob minus jedna ak bolo minus
    mov vysl,al
    jmp ko1
ko :mov vysl,dl		;vysl=cislo
ko1:popa
    ret
prevednac endp

strtonum proc		;naplni pole cislami ktore su v retazci retaz
    pusha
    mov bx,offset retaz
    mov di,0
n1 :inc bx		;opakuj
    mov al,ds:[bx]    
    cmp al,'$'		;za pokim neni "$"
    jz ko2
    cmp al,' '		;alebo " "
    jz n1
    call prevednac 	;ak ani jedno potom bx ukazuje na prvu cifru cisla. Preved na cislo
    mov al,vysl	
    mov [pole+di],al	;nacitane cislo do pola
    inc di
    mov bx,stabx	;obnov ukazovatel
    jmp n1
ko2:mov pocet,di	;pocet=pocet nacitanych cisel
    popa
    ret
strtonum endp

clrscr proc			; procedura maze obrazovku
    			        
    pusha			; uloz registre 
    mov ax,03h			; nastavi mod obrazovky,cim aj premaze obrazovku
    int 10h
   
    mov dx,0605h		; dh = riadok, dl = stlpec
    call setcur 		
    popa			; obnov registre
    ret 			; navrat
clrscr endp 
	
setcur proc		;nastavi poziciu kurzora na dh:dl
    pusha
    mov ah,02   	; cislo sluzby BIOSu na nastavenie kurzoru
    mov bx,0		; cislo videostranky
    
    int 10h		; BIOS

    popa
    ret
setcur endp

menu proc		   ; procedura na vypisanie menu		
    pusha
    mov ah,09		   ; ah=9 sluzba na vypis retazca
    mov dx,offset nadpis   ; do dx vlozi offset nadpisu	
    int 21h
    mov dx,offset moz1     ; vypisy ostatnych retazcov
    int 21h
    mov dx,offset moz2
    int 21h
    mov dx,offset moz4
    int 21h
    mov dx,offset moz5
    int 21h
    mov dx,offset moz6
    int 21h
    popa
    ret  
menu endp

vypcisl proc		
    pusha
    mov bx,10       ;zaklad
    mov cx,ax       ;neskor kvoli znamienku
    cmp ax,0 	    ;ak > 0 potom vypis
    jg va1	    ;inak	
    not ax	    ;prevedie  na doplnkovy kod
    inc ax	    	

va1:mov di,5
lll:dec di		; di ukazuje do buffera
    mov dx,0
    idiv bx             ;dx = ax mod bx
    mov si,dx           ;do si zbytok
    mov dl,[cisla+si]   ;do dl pismeno (si vyberie z retazca cisel podla svojej hodnoty)
    mov [buffer+di],dl  ;zapis. do bufferu odzadu
    cmp ax,0		;testuje ci je cela cast nula
    jnz lll

    cmp cx,0
    jge vat		;je < 0
    dec di 
    mov [buffer+di],'-' ;vypis aj minus
vat:mov dx,offset buffer;je >=0  
    add dx,di		; korekcia kvoli neplneniu buffera odpredu
    mov ah,kam
    mov bx,ktorys
    mov cx,5
    sub cx,di
    int 21h		;vypis buffer
    
    popa
    ret
vypcisl endp

suma proc 	;spocita cisla v pole a vypise vysledok. Ak pretecenie hlasi chybu
    pusha
    call clrscr
    mov dx,offset vet
    mov ah,9
    int 21h
    mov kam,09h
    call vyppol			;vola proceduru na vypisanie cisel pola
    mov ah,9
    mov dx,offset vet1		;vypise retazec 'Suma:'
    int 21h

    mov cx,pocet
    mov bx,0
    mov si,0
lo2:mov al,byte ptr[pole+si]	;do al pole[si]
    cbw				;al->ax
    add bx,ax			;bx=bx+ax
    jo er1			;nastalo pretecenie
    inc si			;ak nie, pokracuj
    loop lo2

    mov ax,bx			;vypis ax
    mov kam,09h			;na obrazovku
    call vypcisl		
    jmp da3

er1:call chyba			;vypis chybu

da3:mov ah,0
    int 16h

    popa
    ret 
suma endp

vusppo proc			;vzostupne usporiada pole
    pusha
poc dw ?
    mov ax,pocet		;uporiadanie vyberom najvacsieho prvku
    mov poc,ax
    dec poc

    mov cx,0
fo1:cmp cx,poc
    jz ef1
    mov di,cx
    mov al,[pole+di]
    mov bx,cx
    inc bx
fo2:   cmp bx,pocet
       jz ef2
       
       cmp byte ptr [pole+bx],al
       jg nic
       mov di,bx
       mov al,[pole+bx]
   nic:   
       inc bx
       jmp fo2
ef2:   
    mov si,cx
    mov ah,[pole+si]
    mov [pole+di],ah
    mov [pole+si],al
    
    inc cx
    jmp fo1
ef1:
    popa
    ret
vusppo endp

vzostup proc		;usporiadane pole zapise do suboru
    pusha
    call vusppo        ; usporiadaj pole
    mov ah,3ch
    mov dx,offset subor2
    mov cx,0
    int 21h 
    mov vystup1,ax	
    mov ktorys,ax	
    mov kam,40h		;do suboru
    call vyppol

    call clrscr
    mov ah,9 
    mov dx,offset vet3
    int 21h
    mov ah,00
    int 16h
    popa
    ret
vzostup endp

zusppo proc		;zusppo		zostupne usporiada pole
    pusha
poc1 dw ?
    mov ax,pocet	;vyberom najmensieho prvku
    mov poc1,ax
    dec poc1

    mov cx,0
fo5:cmp cx,poc1
    jz ef5
    mov di,cx
    mov al,[pole+di]
    mov bx,cx
    inc bx
fo6:   cmp bx,pocet
       jz ef6
       
       cmp byte ptr [pole+bx],al
       jl nic1
       mov di,bx
       mov al,[pole+bx]
  nic1:   
       inc bx
       jmp fo6
ef6:   
    mov si,cx
    mov ah,[pole+si]
    mov [pole+di],ah
    mov [pole+si],al
    
    inc cx
    jmp fo5
ef5:
    popa
    ret
zusppo endp

zostup proc		;usporiadane pole zapise do subora
    pusha
    call zusppo        ; usporiadaj pole

    mov ah,3ch
    mov dx,offset subor3
    mov cx,0
    int 21h 
    mov vystup2,ax
    mov ktorys,ax

    mov kam,40h

    call vyppol
       
    call clrscr
    mov ah,9 
    mov dx,offset vet4
    int 21h

    mov ah,00
    int 16h
    
    popa
    ret
zostup endp

nacitajc proc		        ;nacita cislo z klavesnice
    pusha
    mov ah,0ah
    mov dx,offset cislo
    int 21h			;nacitaj retazec
    mov bx,offset cislo		
    inc bx
    mov byte ptr ds:[bx],' '    ;korekcia pre proc. preved na c
    inc bx			;nastav ukazovatel
    call prevednac		;preved na cislo
    popa
    ret
nacitajc endp

vydel proc 
    pusha
    call clrscr			;zmazanie obrazovky
    mov kam,09h
    call vyppol			;vypise pole cisel
    mov dx,offset vet5
    mov ah,9
    int 21h

    call nacitajc		;nacitaj cisl
    mov al,vysl			;v al cislo
    cbw				;al->ax
    dec ax			;zniz o jedno kvoli indexovaniu od nuly
    mov si,ax			;si ukazovatel na citatela

    mov dx,0734h
    call setcur
    
    call nacitajc		;nacitaj cisl
    mov al,vysl
    cbw
    dec ax
    mov di,ax

    mov al,[pole+si]
    cbw
    mov bl,[pole+di]
    cmp bl,0
    jz nula

    idiv bl		

    mov bx,ax
    mov ah,9
    mov dx,offset vet7
    int 21h
    mov al,bl
    cbw
    call vypcisl	;vypise vysledok delenia

    mov ah,9
    mov dx,offset vet8
    int 21h
    mov al,bh
    cbw
    call vypcisl	;vypise zvysok po deleni
    jmp pokracuj

nula:call chyba

pokracuj:
    mov ah,0
    int 16h

    popa
    ret
vydel endp    

vynas proc 		;nasobenie cisel
    pusha
    call clrscr
    mov kam,09h
    call vyppol
    mov dx,offset vet6
    mov ah,9
    int 21h

    call nacitajc	;nacitaj cislo
    mov al,vysl
    cbw
    dec ax
    mov si,ax

    mov dx,0734h
    call setcur
    
    call nacitajc
    mov al,vysl
    cbw
    dec ax
    mov di,ax

    mov al,[pole+si]
    mov bl,[pole+di]

    imul bl

    mov bx,ax
    mov ah,9
    mov dx,offset vet7
    int 21h
    mov ax,bx
    call vypcisl

    mov ah,0
    int 16h

    popa
    ret
vynas endp    


;hlavny program

start:  mov ax,@data
        mov ds,ax		; ds data

opak:	call clrscr
	call menu
	call nacitaj
        call strtonum
 
case:   mov ah,0
        int 16h

        cmp al,'a' 	; monosti
        jz c1
        cmp al,'b'
        jz c2
        cmp al,'c'
        jz c4
        cmp al,'d'
        jz c5
        cmp al,'e'
        jz c6

        jmp case

c1:      call suma	;set sel
         jmp opak
c2:      call vzostup	;vzostupn usporiadanie sel
	 jmp opak
c4:      call vydel	;delenie sel
         jmp opak
c5:      call vynas	;nsobenie sel
	 jmp opak
c6:      jmp konec	;koniec programu
 
konec:	mov ax,4c00h    ;navrat riadenia dosu
        int 21h
end start
