; zadanie cislo 2

;Text zadania: Vytvorte program, ktory nacita z textoveho
;       suboru postupnost cisel so znamienkom v desiatkovej
;       ciselnej sustave, potom ich transformuje na cisla v
;       dvojkovej ciselnej sustave a potom podla priania
;       pouzivatela:
;       a) vypocita sumu vsetkych cisel a vypise ju
;       b) usporiada cisla a novu postupnost zapise do
;          noveho textoveho suboru
;       c) vydeli dve vybrane cisla a vypise vysledok
;       d) vynasobi dve vybrane cisla a vypise vysledok
;       q) ukonci program
;
;       Vysledky treba vypisovat v desiatkovej ciselnej sustave.
;       Ak naastane pretecenie, program na to musi upozornit
;
;AUTOR : MAREK CATLOS
;termin odovzdania :
;2.roc.,sk.rok 99/00

;vstup : z2.dat
;vystup: z2.out
;nazov : z2.asm

title z2

;;;;;;;;;;;;;;;;;;;; stack seg ;;;;;;;;;;;;;;;;;;;;;;;;;;

zasob   segment stack
        dw      64 dup(?)
zasob   ends

;;;;;;;;;;;;;;;;;;;; data seg  ;;;;;;;;;;;;;;;;;;;;;;;;;;

data    segment

vVMoz   db      'Vyber jednu z uvedenych moznosti:',10,13,'$'
vOverf  db      'error - nastalo pretecenie',10,13,'$'
vSuma   db      'Suma je: ',10,13,'$'
vPor1   db      'Zadaj poradie prveho cisla :',10,13,'$'
vPor2   db      'Zadaj poradie druheho cisla :',10,13,'$'
vZvysok db      'Zvysok: $'


cestaIn db      'z2.dat',0                              ; implicitne predpokl cesta
cestaOut db     'z2.out',0                              ; nastavil sa na 0 - ty prvok v subore
                                                        
NL      db      10,13,'$'                               ; novy riadok
fileIn  dw      ?                                       ; handler vstup suboru
fileOut dw      ?                                       ; handler vystup suboru
buff    db      ?                                       ; buffer na nacitanie cisel
znam    db      0
EOF     db      ?                                       ; je 1 ak nastane end of file inak 0

fEText  struc                                           ; struktura poloziek chybovych sprav o dlzke 30
        db      30 dup(?)
fEText  ends
fE      fEText  <'function number invalid!$'>
        fEText  <'file not found!$'>
        fEText  <'path not found!$'>
        fEText  <'no handle available!$'>
        fEText  <'acces denied!$'>
        fEText  5 dup(<>)
        fEText  <'open mode invalid!$'>

sort    dw      100 dup(?)                              ; usortovane cisla

menu    db      'a) vypocet sumy nacitanych cisel',10,13
        db      'b) usortovanie cisel a zapis do z2.out',10,13
        db      'c) delenie dvoch vybranych cisel',10,13
        db      'd) nasobenie dvoch cisel',10,13
        db      'q) quit program',10,13,'$'

data    ends

;;;;;;;;;;;;;;;;;;;; code segment ;;;;;;;;;;;;;;;;;;;;;;;

code    segment
        assume  ds:data,cs:code,ss:zasob

;;;;;;;;;;;;;;;;;;;;;;;;; procedury ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;; FILE ERROR ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FILEERR         PROC                            ; procedura vypise chybu ktora nastala
        push    ax                              ; do zasobnika dal chybove hlasenie
        mov     ah,     09h
        mov     dx,     offset NL               ; skoc na novy riadok
        int     21h

        pop     ax                              ; nacita zo zas cislo chyby
        mov     bl,     size fEText             ; dlzka textu chyby do bl
        dec     ax                              ; index od nuly prva chyba je 1
        mul     bl                              ; ax*bl
        add     ax,     offset fE               ; ax + relat adr fE = zaciatok textov chyb
        mov     dx,     ax
        mov     ah,     09h                     ; vypis chyby
        int     21h

        mov     ah,     4ch                     ; koniec proc
        int     21h

FILEERR endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NACITAJ CISLO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NACITCISLO      proc                            ; nacita cislo zo suboru s handlerom v bx z aktualnej adr
        mov     znam,   0                       ; default nast znamienka je 0
@NC3:   mov     ah,     3fh                     ; nacitanie retazca
        mov     cx,     1                       ; kolko znakov ma nacitat  v bx je handle suboru                                               
        mov     dx,     offset buff             ; do coho to ma nacitat
        int     21h

        xor     cx,     cx
        jnc     @NC1
        call    FILEERR
@NC1:   cmp     ax,     0                       ; testuje ci nacital nejaky znak
        je      @endNC                          ; ak nie tak ukonci proceduru

        cmp     buff,   02dh                    ; test ci je buff znamienko
        jne     @NC2                            ; ak nie tak pokracuj
        mov     znam,   1                       ; inak nastav znamienko na 1
@NC2:   cmp     buff,   30h                     ; porovnava cislo ci je vacsie ako nula a mensie ako 9
        jb      @NC3                            ; ak je mensie tak nacitava dalej
        cmp     buff,   39h
        ja      @NC3
        xor     ax,     ax                      ; ak nacital cislo vynul ax, do ktoreho potom ulozi cele cislo v doplnkovom kode
        push    ax                              ; ax -> stack

@NC6:   pop     ax                              ; vytiahne ax zo zasobnika
        mov     cx, 10
        mul     cx                              ; ax krat 10
        mov     cl,     buff
        sub     cl,     30h                     ; lebo hodnota ascii 0 az 9 je 30 az 39
        add     al,     cl
        jnc     @NC4                            ; ak nastalo pretecenie zvacsi ah
        inc     ah
@NC4:
        push    ax                              ; ax -> stack
        mov     ah,     3fh                     ; nacitanie dalsej cislice
        mov     cx,     1
        mov     dx,     offset buff
        int     21h
        jnc     @NC5                            ; ak chyba zavolaj FILEERR
        call    FILEERR
@NC5:   xor     cx,     cx
        cmp     ax,     0
        je      @endNC2
        cmp     buff,   30h                     ; porovnava cislo ci je vacsie ako nula a mensie ako 9
        jb      @endNC3                         ; ak je mensie tak ukonci nacitavanie
        cmp     buff,   39h
        ja      @endNC3
        jmp     @NC6

@endNC3:mov     cx,     1
@endNC2:
        pop     ax                              ; vytiahne cislo zo zas
        cmp     znam,   1
        jne     @endNC
        neg     ax                              ; ak je znamienko zaporne zneguje ax => doplnkovy kod
@endNC: ret
NACITCISLO      endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; VYPISCISLO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

VYPISCIS        proc                            ; vypise cslo z doplnkoveho kodu na monitor v desiatkovej sustave
        mov     bh,     ah                      ; znamienko ah vrazi do pomocnej bh
        and     bh,     080h                    ; maska 1000 0000b znamienko necha, ostatne vynuluje
        cmp     bh,     080h                    ; zistuje ci je prvy bit znamienko
        jne     @VC4                            ; ak nie cislo je kladne
        push    ax                              ; ak ano ulozi ho na zasobnik

        mov     ah,     02h                     ; vypis znamienka
        mov     dx,     2dh
        int     21h

        pop     ax                              ; vytiahne cislo zo zas
        neg     ax                              ; negacia na kladne cislo
@VC4:   mov     cx,     9999                    ; maximalne cislo moze mat 5 cislic
@VC2:   inc     cx
        xor     dx,     dx                      ; nul dx
        div     cx                              ; ax <= ax/cx
        push    dx                              ; ax = najvacsia cifra ; dx = zvysok
        cmp     al,     0                       ; porovna al s 0
        jne     @VC3
        xor     dx,     dx                      ; ak sa rovna nule
        mov     ax,     cx                      ; do ax ulozi zvysok po deleni ( cele nase cislo )
        mov     bx,     10
        div     bx                              ; ax <= ax/10
        mov     cx,     ax                      ; posunie sa o jedno cislo
        pop     ax
        loop    @VC2                            ; skonci ak sme otest poslednu cislicu

        push    ax
@VC3:   mov     ah,     02h                     ; vypis znaku
        add     al,     30h
        mov     dl,     al
        int     21h

        xor     dx,     dx                      ; nul dx
        mov     ax,     cx
        mov     bx,     10
        div     bx
        mov     cx,     ax                      ; cx prirad  cx/10
        pop     ax
        dec     cx

@VC1:   inc     cx
        cmp     cx,     1                       ; test ci to nie je posledna cifra
        je      @endVC                          ; ak je tak skonci a vypis poslednu cifru
        cmp     cx,     0                       ; ci este je nejaka cislica
        je      @endVC2                         ; ak ano tak skoc na okamzity koniec proc

        xor     dx,     dx                      ; nul dx
        div     cx                              ; ax deli cx
        push    dx                              ; dx na zas

        mov     ah,     02h                     ; vypis cifry
        add     al,     30h
        mov     dl,     al
        int     21h

        xor     dx,     dx
        mov     ax,     cx
        mov     bx,     10
        div     bx
        mov     cx,     ax                      ; cx <- cx/10
        pop     ax                              ; vyberie cislo zo zas
        loop    @VC1                            ; ak sa tam este nejake nachadza opakuje vypis

@endVC: mov     dl,     al                      ; vypis poslednej cislice
        add     dl,     30h
        mov     ah,     02h
        int     21h
@endVC2:ret

VYPISCIS        endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; VYPIS DO SUBORU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

VYPISSUB        proc                            ; to iste co vypisCisla len do suboru
        mov     cx,     bx                      ; do suboru s handlerom bx

        mov     bh,     ah
        and     bh,     080h
        cmp     bh,     080h                    ; zistuje ci je prvy bit znamienko
        jne     @VS4                            ; ak nie cislo je kladne
        push    ax                              ; ak ano ulozi ho na zasobnik

        push    cx

        mov     ah,     40h                     ; vypis znamienka
        mov     bx,     cx                      ; vstupy pre tlac do suboru = bx handler suboru
        mov     cx,     1                       ; kolko znakov ma nacitat
        mov     buff,   2dh
        mov     dx,     offset buff
        int     21h

        pop     cx
        pop     ax                              ; vytiahne cislo zo zas
        neg     ax                              ; negacia na kladne cislo

@VS4:   mov     bx,     cx
        mov     cx,     9999                    ; maximalne cislo moze mat 5 cislic
@VS2:   inc     cx
        xor     dx,     dx                      ; nul dx
        div     cx                              ; ax <= ax/cx
        push    dx                              ; ax = najvacsia cifra ; dx = zvysok
        cmp     al,     0                       ; porovna al s 0
        jne     @VS3
        xor     dx,     dx                      ; ak sa rovna nule
        mov     ax,     cx                      ; do ax ulozi zvysok po deleni ( cele nase cislo )
        push    bx
        mov     bx,     10
        div     bx                              ; ax <= ax/10
        pop     bx
        mov     cx,     ax                      ; posunie sa o jedno cislo
        pop     ax
        loop    @VS2                            ; skonci ak sme otest poslednu cislicu

        push    ax
@VS3:   push    cx
        mov     ah,     40h                     ; vypis znaku
        mov     cx,     1
        add     al,     30h
        mov     buff,   al
        mov     dx,     offset buff
        int     21h

        pop     cx

        xor     dx,     dx                      ; nul dx
        mov     ax,     cx

        push    bx
        mov     bx,     10
        div     bx

        pop     bx
        mov     cx,     ax                      ; cx prirad  cx/10
        pop     ax
        dec     cx

@VS1:   inc     cx
        cmp     cx,     1                       ; test ci to nie je posledna cifra
        je      @endVS                          ; ak je tak skonci a vypis poslednu cifru
        cmp     cx,     0                       ; ci este je nejaka cislica
        je      @endVS2                         ; ak ano tak skoc na okamzity koniec proc

        xor     dx,     dx                      ; nul dx
        div     cx                              ; ax deli cx
        push    dx                              ; dx na zas
        push    cx

        mov     ah,     40h                     ; vypis cifry
        add     al,     30h
        mov     buff,   al
        mov     cx,     1
        mov     dx,     offset buff
        int     21h

        pop     cx
        xor     dx,     dx
        mov     ax,     cx
        push    bx
        mov     bx,     10
        div     bx

        pop     bx
        mov     cx,     ax                      ; cx <- cx/10
        pop     ax                              ; vyberie cislo zo zas
        loop    @VS1                            ; ak sa tam este nejake nachadza opakuje vypis

@endVS: mov     dl,     al                      ; vypis poslednej cislice
        add     dl,     30h
        push    cx
        mov     ah,     40h
        mov     cx,     1
        mov     buff,   dl
        mov     dx,     offset buff   
        int     21h
        pop     cx
@endVS2:ret

VYPISSUB        endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ULOHA1 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ULOHA1          proc                            ; vypocita celkovu sumu cisel
        xor     bx,     bx
@11:    push    bx                              ; bx -> zas
        mov     bx,     fileIn                  ; do bx da handler suboru
        call    NACITCISLO                      ; nacita cislo
        pop     bx                              ; aktualizuje sumu zo zas

        cmp     cx,     0                       ; test na EOF
        je      @1dalej                         ; ak ano tak skoc na vypis sumy

        add     bx,     ax                      ; pripocita k bx cislo nacitane
        jo      @1overf                         ; ak nastalo pretecenie tak  skoc na vypis pretecenia
        push    bx                              ; bx,cx -> zas
        push    cx
        call    VYPISCIS                        ; 

        mov     ah,     09h
        mov     dx,     offset NL
        int     21h

        pop     cx
        pop     bx
        cmp     cx,     0
        je      @1dalej
        jmp     @11
@1dalej:
        push    bx

        mov     ah,     09h                     ; vypis 'Suma je:'
        mov     dx,     offset vSuma
        int     21h

        pop     ax
        call    VYPISCIS
        jmp     @1end
@1overf:
        mov     ah,     09h                     ; vypis chyby pretecenia
        mov     dx,     offset vOverf
        int     21h
@1end:  mov     ah,     42h                     ; nastavi aktualnu adr v subore fileIn na 0
        mov     bx,     fileIn
        xor     dx,     dx
        xor     al,     al
        xor     cx,     cx
        int     21h

        ret
ULOHA1          endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ULOHA2 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ULOHA2          proc

        mov     ah,     3ch                     ;otvorenie suboru normal
        mov     cx,     0                       ; citaci/zapisovaci mod
        mov     dx,     offset  cestaOut
        int     21h                             ; ax = handler na novootv subor z2.out

        jnc     @sOutOK
        call    FILEERR
@sOutOK:
        mov     fileOut,ax                      ; handler ulozi do fileOut
        mov     bx,     fileIn
        call    NACITCISLO
        mov     cx,     0
        mov     si,     0
        mov     sort[si],ax                     ; nacitane cislo ulozi do prveho prvku pola sort
@21:    inc     cx                              ; v cx je pocet cisel v sorte
        mov     bx,     fileIn                  ; bx <- handler fileIn
        push    cx                              ; odlozi cx do zas
        call    NACITCISLO
        mov     EOF,    cl                      ; proc NACITCISLO vracia cx = 0 len na konci suboru, inak 1

        cmp     EOF,    0                       ; test ci koniec suboru, aby este raz nezbehol s nulou
        je      @27

        pop     cx
        push    cx
        inc     cx                              ; incrementuje uz zas hodnotu cx
        mov     si,     0
        mov     di,     0

@24:    cmp     ax,     sort[si]                ; porovna prave nacitane cislo s vsetkymi cislami v sorte
        jle     @25
        jmp     @26
@25:    mov     di,     1                       ; ak je mensie ako najmensie v sorte

        mov     bx,     sort[si]                ; vymeni nacitane cislo za prve 
        mov     sort[si],ax
        mov     ax,     bx

        add     si,     2
        loop    @25
        inc     cx
@26:    add     si,     2
        loop    @24
@211:   sub     si,     2
        cmp     di,     1
        je      @27
        mov     sort[si],ax                     ; ak je cislo najvacsie, ulozi ho na koniec
@27:    pop     cx
        cmp     EOF,    0                       ; ci nie je koniec suboru
        je      @23                             ; ak nastal tak skoci na @23
        jmp     @21                             ; ak nie tak to cele opakuj s dalsim cislom

@23:    mov     si,     0
        inc     cx

@28:    mov     bx,     fileOut                 ; do bx <- handler fileOut
        mov     ax,     sort[si]
        push    cx
        call    VYPISSUB
        pop     cx
        push    cx
        cmp     cx,     1
        je      @29                             ; zapis do vystup suboru

        mov     ah,     40h
        mov     cx,     1
        mov     buff,   09h                     ; tabulator do suboru - oddeli cisla
        mov     dx,     offset buff
        int     21h
@29:    pop     cx
        add     si,     2
        loop    @28                             ; vypis vsetkych cisel

        mov     ah,     3eh                     ; uzavrie vystupny subor
        mov     bx,     fileOut
        int     21h

        mov     ah,     42h                     ; nastavenie ukazovatela suboru
        mov     bx,     fileIn                  ; na zaciatok
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h

        mov     cx,     12
        mov     si,     0
@vSort: mov     ax,     sort[si]
        push    cx
        call    VYPISCIS

        mov     ah,     09h
        mov     dx,     offset  NL
        int     21h

        pop     cx
        add     si,     2
        loop    @vSort
        ret

ULOHA2          endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ULOHA3 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ULOHA3          proc                            ; nacita poradia dvoch visle a vydeli ich
@init:  mov     bx,     fileIn
        call    NACITCISLO
        push    cx
        call    VYPISCIS

        mov     ah,     09h                     ; vypis noveho riadku
        mov     dx,     offset NL
        int     21h

        pop     cx
        cmp     cx,     0                       ; ak EOF = 1 skoc na init a vypis dalsie cislo
        jne     @init

        mov     ah,     09h                     ; vypis zadaj poradie prveho cisla
        mov     dx,     offset  vPor1
        int     21h

        xor     cx,     cx
@32:    mov     ah,     01h                     ; nacita cislo
        int     21h
        cmp     al,     13                      ; ak enter
        je      @33
        mov     ah,     0
        sub     al,     30h
        push    ax                              ; aktualne cislo do stacku
        mov     ax,     cx                      ; doterajsie cislo z cx do ax
        mov     cx,     0ah                     ; konstantu 10 do cx
        mul     cx                              ; vynasobit doterajsi vysledok 10
        mov     cx,     ax                      ; vratit vysledok do cx
        pop     ax                              ; obnovit povodnu hodnotu ax
        add     cx,     ax                      ; prida nacitanu cislicu do ax
        jmp     @32

@33:    push    cx
        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h
        pop     cx

@31:    push    cx                              ; nacitava do vtedy, kym nanarazi na cislo so zadanym poradim
        call    NACITCISLO
        pop     cx
        loop    @31

        push    ax                              ; nacitane cislo -> ZAS

        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h

        xor     cx,     cx
        mov     ah,     09h                     ; novy riadok
        mov     dx,     offset NL
        int     21h

        mov     ah,     09h
        mov     dx,     offset vPor2
        int     21h

@35:    mov     ah,     01h                     ; nacita cislo
        int     21h
        cmp     al,     13                      ; ak enter
        je      @34
        mov     ah,     0
        sub     al,     30h
        push    ax                              ; aktualne cislo do stacku
        mov     ax,     cx                      ; doterajsie cislo z cx do ax
        mov     cx,     0ah                     ; konstantu 10 do cx
        mul     cx                              ; vynasobit doterajsi vysledok 10
        mov     cx,     ax                      ; vratit vysledok do cx
        pop     ax                              ; obnovit povodnu hodnotu ax
        add     cx,     ax                      ; prida nacitanu cislicu do ax
        jmp     @35
@34:    push    cx                              ; nacitava dovtedy, kym nenarazi na druhe cislo
        call    NACITCISLO
        pop     cx
        loop    @34

        push    ax
        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h

        xor     cx,     cx
        mov     ah,     09h                     ; novy riadok
        mov     dx,     offset NL
        int     21h

        pop     bx
        pop     ax
        push    ax
        push    bx
        push    bx
        call    VYPISCIS                        ; vypis 1 cisla

        mov     ah,     02h                     ; vypis '/'
        mov     dl,     2fh
        int     21h

        pop     ax
        call    VYPISCIS                        ; vypis druheho cisla

        mov     ah,     02h                     ; vypis '='
        mov     dl,     0cdh
        int     21h

        pop     bx
        pop     ax
        xor     dx,     dx

        idiv    bx                              ; vydeli ax/bx = ax celociselny vysledok, dx = zvysok
        push    dx
        call    VYPISCIS

        mov     ah,     09h
        mov     dx,     offset vZvysok
        int     21h

        pop     dx
        mov     ax,     dx
        call    VYPISCIS
        ret

ULOHA3          endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ULOHA4 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ULOHA4          proc                            ; nacita poradia dvoch visle a vydeli ich
@init4: mov     bx,     fileIn
        call    NACITCISLO
        push    cx
        call    VYPISCIS

        mov     ah,     09h                     ; vypis noveho riadku
        mov     dx,     offset NL
        int     21h

        pop     cx
        cmp     cx,     0                       ; ak EOF = 1 skoc na init a vypis dalsie cislo
        jne     @init4

        mov     ah,     09h                     ; vypis zadaj poradie prveho cisla
        mov     dx,     offset  vPor1
        int     21h

        xor     cx,     cx
@42:    mov     ah,     01h                     ; nacita cislo
        int     21h
        cmp     al,     13                      ; ak enter
        je      @43
        mov     ah,     0
        sub     al,     30h
        push    ax                              ; aktualne cislo do stacku
        mov     ax,     cx                      ; doterajsie cislo z cx do ax
        mov     cx,     0ah                     ; konstantu 10 do cx
        mul     cx                              ; vynasobit doterajsi vysledok 10
        mov     cx,     ax                      ; vratit vysledok do cx
        pop     ax                              ; obnovit povodnu hodnotu ax
        add     cx,     ax                      ; prida nacitanu cislicu do ax
        jmp     @42

@43:    push    cx
        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h
        pop     cx

@41:    push    cx                              ; nacitava do vtedy, kym nanarazi na cislo so zadanym poradim
        call    NACITCISLO
        pop     cx
        loop    @41

        push    ax                              ; nacitane cislo -> ZAS

        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h

        xor     cx,     cx
        mov     ah,     09h                     ; novy riadok
        mov     dx,     offset NL
        int     21h

        mov     ah,     09h
        mov     dx,     offset vPor2
        int     21h

@45:    mov     ah,     01h                     ; nacita cislo
        int     21h
        cmp     al,     13                      ; ak enter
        je      @44
        mov     ah,     0
        sub     al,     30h
        push    ax                              ; aktualne cislo do stacku
        mov     ax,     cx                      ; doterajsie cislo z cx do ax
        mov     cx,     0ah                     ; konstantu 10 do cx
        mul     cx                              ; vynasobit doterajsi vysledok 10
        mov     cx,     ax                      ; vratit vysledok do cx
        pop     ax                              ; obnovit povodnu hodnotu ax
        add     cx,     ax                      ; prida nacitanu cislicu do ax
        jmp     @45
@44:    push    cx                              ; nacitava dovtedy, kym nenarazi na druhe cislo
        call    NACITCISLO
        pop     cx
        loop    @44

        push    ax
        mov     ah,     42h                     ; posunie sa na zaciatok suboru
        mov     bx,     fileIn
        xor     cx,     cx
        xor     dx,     dx
        xor     al,     al
        int     21h

        xor     cx,     cx
        mov     ah,     09h                     ; novy riadok
        mov     dx,     offset NL
        int     21h

        pop     bx
        pop     ax
        push    ax
        push    bx
        push    bx
        call    VYPISCIS                        ; vypis 1 cisla

        mov     ah,     02h                     ; vypis '*'
        mov     dl,     2ah
        int     21h

        pop     ax
        call    VYPISCIS                        ; vypis druheho cisla

        mov     ah,     02h                     ; vypis '='
        mov     dl,     0cdh
        int     21h

        pop     bx
        pop     ax
        xor     dx,     dx

        imul    bx                              ; vynasobi ax*bx = ax celociselny vysledok

        jnc     @4nasOK                         ; ak nenastalo pretecenie tak pokracuj
        mov     ah,     09h                     ; ak nie tak vypis overflow
        mov     dx,     offset  vOverf
        int     21h

@4nasOK:call    VYPISCIS
        ret

ULOHA4          endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; PROGRAM ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

@start: mov     ax,     seg data
        mov     ds,     ax                      ;priradenie seg data do registra ds

        mov     ah,     3dh                     ; otvorenie suboru
        mov     al,     0                       ; citaci mod
        mov     dx,     offset cestaIn          ; nastavi dx na adresu suboru z2.dat
        int     21h                             
        jnc     @fileOk                         ; ak nenastala chyba = nenastal prenos skoc na fileOk
        call    FILEERR                         ; ak hej - zavolaj fileErr
@fileOk:
        mov     fileIn, ax                      ; do fileIn ulozi handler z2.dat

@menu:  mov     ah,     09h                     ; vypis cisteho riadku
        mov     dx,     offset NL               
        int     21h

        mov     ah,     09h                     
        mov     dx,     offset vVMoz            ; vypis vyber si jednu z moznosti
        int     21h

        mov     ah,     09h                     ; vypis cisteho riadku
        mov     dx,     offset NL               
        int     21h

        mov     ah,     09h                     ; vypis menu
        mov     dx,     offset menu
        int     21h

        mov     ah,     01h                     ; nacita z klav znak
        int     21h

        push    ax                              ; odlozi ho do buffera

        mov     ah,     09h                     ; vypis cisteho riadku
        mov     dx,     offset NL               
        int     21h

        pop     ax                              ; vytiahnutie znaku z buff

        cmp     al,     41h                     ; porovnanie s 'a'
        je      @uloha1
        cmp     al,     61h                     ; porovnanie s 'A'
        je      @uloha1

        cmp     al,     42h                     ; porovnanie s 'b'
        je      @uloha2
        cmp     al,     62h                     ; porovnanie s 'B'
        je      @uloha2
        
        cmp     al,     43h                     ; porovnanie s 'c'
        je      @uloha3
        cmp     al,     63h                     ; porovnanie s 'C'
        je      @uloha3

        cmp     al,     44h                     ; porovnanie s 'd'
        je      @uloha4
        cmp     al,     64h                     ; porovnanie s 'D'
        je      @uloha4

        cmp     al,     51h                     ; porovnanie s 'q'
        je      @koniec
        cmp     al,     71h                     ; porovnanie s 'Q'
        je      @koniec
        

@uloha1:call    ULOHA1
        jmp     @menu
@uloha2:call    ULOHA2
        jmp     @menu
@uloha3:call    ULOHA3  
        jmp     @menu
@uloha4:call    ULOHA4
        jmp     @menu
@koniec:
        mov     ah,     3eh                     ; zatvori subor s handlerom bx
        int     21h


@end:   mov     ah,     4ch                     ;instrukcia na ukoncenie programu
        int     21h                             
code    ends
        end     @start


; ZHODNOTENIE:
; PROGRAM JE PLNE FUNKCNY. SPLNA VSETKY POZADOVANE KRITERIA S ROZSAHOM NACITANIA
; CISEL ZO SUBORU OD -9999 DO 9999. PROGRAM BOL PISANY V MS DOS PROMPT WIN95.
; BOLI V NOM POUZITE INSTRUKCIE DOS A BIOSU PRE PRERUSENIE, OTVORENIE,ZATVORENIE
; ZO SUBORU, CITANIE, ZAPIS, POHYB V SUBORE, VYPIS A NACIT ZNAKOV A RETAZCOV
; NA OBRAZOVKU. V ULOHE B TRIEDI PRVKY SUBORU VZOSTUPNE.
; VSTUPNY SUBOR:Z2.DAT
; VYSTUP SUBOR  :Z2.OUT
; MENO ZDROJ. SUB:Z2.ASM

