use work.all;
entity detector	is
port  (
	x: in bit;
	clock: in bit;
	y: out bit
	);
end entity detector;

architecture struct of detector is

signal	Z11,Z12,Z13,Z21,Z22,Z23,y1,y2 : bit;
signal d1,d2,d3,d4,d5,d6 : bit;
component decko port (
	d: in bit;
	clk: in bit;
	q: out bit;
	qn: out bit
	);
end component decko;

begin

d11: decko port map (
	d=>d1,
	clk=>clock,
	q=>z11
--	qn=>not(z11)
	);
d12: decko port map (
	d=>d2,
	clk=>clock,
	q=>Z12
--	qn=>not(Z12)
	);	
d13: decko port map (
	d=>d3,
	clk=>clock,
	q=>Z13
--	qn=>not(Z13) 
	);		
d21: decko port map (
	d=>d4,
	clk=>clock,
	q=>z21
--	qn=>not(z21)
	);
d22: decko port map (
	d=>d5,
	clk=>clock,
	q=>z22
--	qn=>not(z22)
	);	
d23: decko port map (
	d=>d6,
	clk=>clock,
	q=>z23
--	qn=>not(z23)
	);
	d1 <= (not(Z12) and Z13) or (Z11 and Z13 and x) or (not(Z11) and not(z13) and x);
	d2 <= x or Z11 or not(z13) or not(Z12);
	d3 <= (not(Z12) and not(x)) or (not(Z11) and Z12 and Z13) or (Z11 and not(Z13) and x);
	d4<= (not(Z21) and Z22 and not(z23) and not(x))or(Z23 and x) or (Z21 and not(Z22) and not(x));
	d5<= (z22 and not(z23)) or (not(z22) and x) or Z21;
	d6<= Z21 and Z22 and not(x);
	y1 <= (Z11 and Z12 and Z13);
	y2 <=(Z21 and (not(Z22)) and (not(Z23)));
	y <= (y1 or y2);
end architecture struct;
