; program treba linkovat s volbou /t aby vznikol .com subor
;****************************************************
;**       Zadanie c.2                              **
;** Termin odovzdania: 9.11.1998                   **
;** Marian Habsuda          Michal Mravcak         **
;** Nacitanie  a zad a)     Zad b) a c)            **
;****************************************************

;* Vytvorte program, ktory nacita z textoveho suboru postupnost celych cisel
;* so znamienkom v desiatkovej sustave (aspon 10), transformuje ich do
;* dvojkovej ciselnej sustavy v doplnkovom kode a potom podla priania uzivatela:
;* a) Vypocita arimeticky priemer vsetkych cisel
;* b) Usporiada cisla vzostupne a zapise usporiadanu postupnost cisel do noveho
;*    textoveho suboru
;* c) Vynasobi alebo vydeli dve vybrane cisla
;* d) Ukonci vykonavanie programu

;*******************************************************************************
;****************************** Vypracovanie ***********************************
;*******************************************************************************

MODEL TINY
;MODEL SMALL
P8086
jumps

;_stack SEGMENT STACK 'stack'
;	DW      0100h DUP (?)
;_stack ends


_data SEGMENT 'DATA'
	menu    DB      10,13,'             Vyberte volbu:',10,13,10,'1) Aritmeticky priemer',10,13,'2) Usporiadanie cisel vzostupne a zapis do suboru',10,13,'3) Vynasobenie alebo vydelenie dvoch vybranych cisel',10,13,'4) Padla ...',10,13,'$'
	Indata  DB      10,13,'Nacitane cisla :$'
	prompt1 DB      10,13,'Aritmeticky priemer : $'
	prompt2 DB      10,13,'Cisla v rastucom poradi vyzeraju takto:$'
	prompt3 DB      10,13,'Zadaj 1. cislo,  operaciu a  2. cislo',10,13,'$'
	prompt4 DB	10,13,'Vysledok je: $'
	prompts DB      10,13,'Obsah vstupneho suboru',10,13,'$'
	toobig	DB	10,13,'Vysledok je prilis velky !!! $'
	numbers DW	50 DUP (0)
	infile  DB      'zad2.in',0
	outfile DB      'zad2.out',0
	numbers2 		DW	3 DUP (0)
	inbuffer  		DB      100 DUP ('$')
	inbuffer2		DB	10,?,10 DUP (?)
	was_space		DB	?
	Non_of_the_above        DB      10,13,'Zadany retazec neobsahoval ziadny platny znak (cislo)!$'
	file_not_found          DB      10,13,'Nenasiel som subor!$'
	invalid_path            DB      10,13,'Neexitujuca cesta k suboru!$'
	OutHandle		DW	?
	Sign			DB	?
	mul10			DW	10
	Buffer          DB      10      DUP(?)
	BufferEnd       DB      '$'
_data ends

_code SEGMENT 'code'
	ASSUME cs:_code
;	ASSUME cs:_code, ds:_data, ss:_stack
startupcode
;	MOV ax, SEG _data
;	MOV ds, ax              ;set the initial conditions
;Reading the file and handle the possible errors
	MOV AX, 3D00H			;open the in-file and set to read-only
	LEA DX, infile
	INT 21H				;executing DOS function
	JNC _Good			;if CF is 0  = there are no errors
	CMP AX, 2			;error is 2 if invalid file name
	JNE _if_3			;if not 2 try error No.: 3      
	LEA DX, file_not_found		;write the error
	MOV AH, 09H
	INT 21H
	JMP _Koniec			;on error close the program
_if_3:  CMP AX, 3			;error is 3 if invalid path
	LEA DX, invalid_path            
	MOV AH, 09H
	INT 21H
	JMP _Koniec
_Good:  MOV BX, AX			;Copying File  Handle from ax to bx
	LEA DX, inbuffer+1		;reading the content of the file
	MOV CX, 01H
_Read:  MOV AX, 3F00H			;set the DOS function "read
	INT 21H				;using a handle"
	CMP AX, 0			;if there were 0 chars read
	JE _EOF				;we're at the end of the file
	INC DX 				;otherwise go ahead
	JMP _Read
_EOF:   MOV AH, 3EH			;closing the file handle
	INT 21H
	LEA BX, inbuffer+1
	SUB DX, BX
	DEC BX				;write the length of the string
	MOV [BX], DL			;to its beginning. Usefull when searching for numbers
	LEA DX, prompts			;"file read successfully"
	MOV ah, 09H
	INT 21H
	MOV AL, [BX]
	CMP AL, 0			;Chech if length isn't 0.
	JNE _IsFilled
	LEA DX, Non_of_the_above	;write there were no chars in the file
	INT 21H
	JMP _Koniec
_IsFilled:	
	LEA BX, inbuffer
	MOV CL, [BX]
_Write:	INC BX				;writing the string: one char at once
	MOV DL, [BX]			;to be able to present the extended chars
	MOV AH, 02H			;mainly the '$' sign.
	INT 21H
	LOOP _Write
;Converting the input string 'inbuffer' to numbers
	LEA BX, inbuffer
	LEA DX, numbers
	CALL ascii2int	
_Menu:	

	MOV ah, 8
	int 21h

	MOV ah, 00			;Clear Screen
	MOV al, 03
	int 10h

	LEA DX, menu			;The main menu 
	MOV AH, 09h
	INT 21H

	MOV  dx, offset Indata
	mov  ah, 09
	int 21h

	MOV  dx, offset inbuffer + 1
	mov  ah, 09
	int 21h


	MOV AH, 08H
	INT 21H
	CMP AL, '1'
	JE _Mean
	CMP AL, '2'
	JE _Sort&save
	CMP AL, '3'
	JE _Multi
	CMP AL, '4'
	JE _Koniec
	JMP _Menu
_Multi:
	CALL Multiply			
	JMP _Menu
_Sort&save:
	LEA BX, numbers			;setting BX for the procedure
	CALL sort
	MOV AH, 3CH			;create file and get the handle
	XOR CX, CX
	LEA DX, outfile
	INT 21H	
	MOV SI, AX			;save handle in SI
	XOR DI, DI
	MOV CX, numbers			;set CX to the number of elements

_Writing:
	ADD DI, 2			;pointer to the actual number to write
	MOV BX, numbers+DI
	CALL int2ascii			;converting
	MOV BX, DX			;store the result in BX
	PUSH CX				;new CX for inner loop
	XOR CX, CX
_Inloop:
	MOV AL, [BX]			;counting the number of chars in the
	INC CL				;string, cl holds the size
	INC BX				;next byte
	CMP AL, '$'			;if al='$' then we're at the end
	JNE _Inloop
	MOV AX, ' '			;replace $ with ' ' for nicer output
	MOV [BX-1], AX			;
	MOV AH, 40H			;
	MOV BX, SI			;
	INt 21H				;fwrite cl chars to file
	MOV [BufferEnd], '$'		;set the $ back so the proc int2ascii works again
	POP CX				;restore cx for outer loop
	LOOP _Writing
	MOV AH, 3EH			;closing the file handle
	INT 21H
	JMP _Menu

_Mean:
	XOR CX, CX
	XOR AX, AX
	LEA BX, numbers
	MOV CL, [BX]			;Number of numbers
	MOV DL, CL
	ADD BX, 2			;next word
_Adding:
	ADD AX, [BX]			;compute the SUM of the elements
	ADD BX, 2			;moving to the next word
	LOOP _Adding
	IDIV DL				;divide the result by num_of_elements
	MOV CX, AX			;store the result in CX
	LEA DX, prompt1			;formatting string output.
	MOV AH, 09H
	INT 21H
	XOR BX, BX
	MOV BL, CL
	CAll int2ascii			;convert numbers to ascii string
	INT 21H
	MOV AH, 02H
	MOV DL, ' '
	INT 21H
	MOV BL, CH
	MOV AH, 09H
	CAll int2ascii
	INT 21H
	MOV AH, 02H
	MOV DL, '/'
	INT 21H
	MOV BX, numbers
	CALL int2ascii
	MOV AH, 09H
	INT 21H
	JMP _Menu			;end Mean
_Koniec:
	MOV AH, 4CH
	INT 21H

;/////////////////////////////////////////////////////////////////////
;////This converts an ASCIIZ string into a signed integer        /////
;////INPUT:     BX      - pointer to the string                  /////
;////OUTPUT:    dx,     - Pointer to the number(s)               /////
;////Destroyed  AX,DI,BX,DX                                      /////
;/////////////////////////////////////////////////////////////////////
ascii2int PROC NEAR
	XOR DI, DI			;zero some registers
	XOR AX, AX
	XOR CH, CH
	MOV CL, [BX]			;set the length of the string
	INC CL				;Because the last char is EOF
					;and we need one more cycle 
_Search:
	INC BX				;set to the first char
	CMP CL, 0			;if cl is 0 go to hell
	JE _Endproc			;hell=end
	DEC CL
	MOV CH, [BX]			;avoid warning messages at compile time
					;by using the same data types
	CMP CH, 2DH			;if signed
	JE _Sign			
	CMP CH, '0'			;if char is:
	JGE _Greaterthan0		;>0
	JMP _Newnumber

_Greaterthan0:
	CMP CH, '9'			;and <9
	JLE _Lessthan9
	JMP _Newnumber
_Lessthan9:
	MOV was_space, 0		;
	PUSH DX
	IMUL mul10			;multiply AX by 10
	ADD AL, [BX]			;Add new number
	SUB AL, 48			;ascii -> int
	POP DX
	JMP _Search	

_Newnumber:
	CMP was_space,1			;if there was a space (or any non numeric char)
	JE _Search			;we don't want to do the rest, so jump back
	CMP Sign,1			;if the number was signed
	JNE _Positive
	NEG AX				;negate it, so we get a negative number
_Positive:
	PUSH BX
	MOV BX, DX		
	MOV [BX+DI+2], AX		;write the result to [bx]
	POP BX
	ADD DI,2			;beginning from the second word (0th word=num of elements)
	MOV was_space, 1		;set there was a space already
	MOV sign, 0			;clear sign
	XOR AX, AX
	JMP _Search

_Sign:	MOV [Sign],1			;setting sing, so we later know it has to be negated
	JMP _Search

_endproc:
	SHR DI,1			;adjusting DI to number of elements
	MOV BX, DX
	MOV [BX], DI			;write DI to 0th word
	RET	
ascii2int ENDP


;/////////////////////////////////////////////////////////////////////
;////This converts a signed integer into an ASCIIZ string        /////
;////INPUT:     bx      - the number                             /////
;////OUTPUT:    ds:dx   - addres of the string to be printed     /////
;////Destroyed  dx                                               /////
;/////////////////////////////////////////////////////////////////////
int2ascii PROC NEAR
	PUSH ax
	PUSH bx
	PUSH cx
	PUSH di
	CMP  bx, 0
	JGE  positive
	MOV  [sign], 1
	NEG  bx
positive:
	MOV  ax, bx
	MOV  cx, 10
	LEA  di, BufferEnd
	DEC  di
again:  XOR  dx, dx
	IDIV cx
	ADD  dl, 30h
	MOV  BYTE PTR [di], dl
	DEC  di
	CMP  ax, 0
	JNE  again

	INC  di
	CMP  [sign],1
	JNE  positive2
	DEC  di
	MOV  BYTE PTR [di], '-'
positive2:
	MOV  dx, di     
	MOV  [sign], 0
	POP  di
	POP  cx
	POP  bx
	POP  ax
	RET
int2ascii ENDP


;/////////////////////////////////////////////////////////////////////
;////This sorts the numbers in at bx and returns bx              /////
;////INPUT:     bx      - pointer to the the numbers             /////
;////OUTPUT:              already sorted numbers in bx           /////
;////Destroyed  bx                                               /////
;/////////////////////////////////////////////////////////////////////
sort PROC NEAR
	MOV SI, BX
	MOV DI, [BX]			;number of elements
	DEC DI				;we only need n-1 loops for sorting
_Outerloop:
	MOV CX, DI			;set the number of cycles
	MOV BX, SI			;restore bx to its original value
_Innerloop:
	ADD BX, 2			;n-th element in the lop
	MOV AX, [BX]
	CMP AX, [BX+2]			;if n>n+1 than swap
	JG  _Swap
	LOOP _Innerloop
	RET
_Swap:	MOV DX, [BX+2]
	MOV [BX+2], AX
	MOV [BX], DX
	JMP _Outerloop
sort ENDP

;/////////////////////////////////////////////////////////////////////
;////This divides or multiplies two numbers stored in inbuffer   /////
;////INPUT:     inbuffer2                                        /////
;////OUTPUT:    result printed to the screen                     /////
;////Destroyed  bx, dx, ax, cx, di, si                           /////
;/////////////////////////////////////////////////////////////////////
Multiply PROC NEAR
	MOV AH, 09H
	LEA DX, prompt3			;input
	INT 21H
	MOV AH, 0AH
	LEA DX, inbuffer2		;store the string in inbuffer2
	INT 21H
	MOV BX, DX
	ADD BX, 1			;moving the pointer by 1 t the length of inbuffer2
	LEA DX, numbers2		;destination pointer for ascii2int
	CALL ascii2int			;extracting necessary numbers
	LEA BX, inbuffer2+1		;move to the length
_Divormul:
	INC BX
	MOV AL, [BX]			;looking for the operator * or /
	CMP AL, '/'
	JE _Divide
	CMP AL, '*'
	JE _Muli
	JMP _Divormul
_Divide:
	MOV DI, [numbers2+2]
	SHL DI, 1			;moving by 2*element (=moving by a word)
	LEA BX, numbers+DI		;storing the DI-th element in BX 
	MOV AX, [BX]
	MOV DI, [numbers2+4]		;looking for the second operand
	SHL DI, 1
	LEA BX, numbers+DI
	XOR CX, CX
	MOV CX, [BX]			;store it in CX
	XOR DX, DX
	CMP AX, 0			;if ax<0 we want to set DX to FFFF (negative number) 
	JGE _Divnow
	MOV DX, 0FFFFH
_Divnow:
	IDIV CX				;Divide DX:AX by CX
	MOV CX, AX			;store the result in CX
	MOV DI, DX
	LEA DX, prompt4			;formatting string output.
	MOV AH, 09H
	INT 21H
	XOR BX, BX
	MOV BX, CX
	CAll int2ascii			;convert numbers to ascii string
	INT 21H
	MOV AH, 02H
	MOV DL, '+'
	INT 21H
	MOV BX, DI
	MOV AH, 09H
	CAll int2ascii
	INT 21H
	MOV AH, 02H
	MOV DL, '/'
	INT 21H
	MOV DI, [numbers2+4]
	SHL DI, 1
	MOV BX, numbers+DI
	CALL int2ascii
	MOV AH, 09H
	INT 21H
	RET
_Muli:	
	MOV DI, [numbers2+2]		;same as above
	SHL DI, 1
	LEA BX, numbers+DI
	MOV AX, [BX]			;store first operand in AX
	MOV DI, [numbers2+4]		;same as in div
	SHL DI, 1
	LEA BX, numbers+DI
	MOV SI, [BX]			;store the second operand in SI
	IMUL SI
	JO _Overflow			;if the result of imul overflows, let us know
	MOV BX, AX
	MOV AH, 09H			;formatting output
	LEA DX, prompt4
	INT 21H
	CALL int2ascii
	INT 21H
	RET
_Overflow:
	MOV AH, 09H
	LEA DX, toobig
	INT 21H
	RET
Multiply ENDP
_code ends
END
