;zadanie c.2

_pusha macro
push ax
push bx
push cx
push dx
push si
push di
push bp
push sp
endm

;--------------------------------------------------------------------
.286
;--------------------------------------------------------------------
_stack segment stack 'stack'
dw 512 dup (?)
_stack ends
;--------------------------------------------------------------------
data segment
o_cislo         db 0,0,0,0,0            ;buffer pre vypis cisla
                db 0                    ;asciiz terminator; pre vypis /po O ASCII/
pocet_cislic    db 0                    ;pocet cislic pre wr_number
zaporne         db 0                    ;flag ci je cislo zaporne
pocet_cisiel    db 0                    ;pocet cisel
cisla           dw 15 dup(0)            ;pole na cisla momentalne na 15 cisiel /na vstup/
bola_vymena     db 0                    ;flag pre buble algoritmus
_si   dw 0                              ;ukazatel konca cisla v ascii forme
_di   dw 0                              ;ukazatel do pola cisiel
x10   dw 1                              ;premenna 'exponentu' /kolko krat nasob/
temp  dw 0                              ;pomocna premenna pre prevadzanie do wordu /ASCII->BIN/
medzera db ' '                          ;medzera /oddelovac pri zapise/
minus   db '-'                          ;znak minus /minus pre zapis/
handle dw 0                             ;handle pre out_file
filename db 'cisla.txt',0               ;meno vstupneho suboru
out_name db 'cisla.out',0               ;meno vystupneho suboru
op_err_mess  db 'Subor cisla.txt som nenasiel',13,10,"$"
rewr_mess db 'nemozem vytvorit subor cisla.out',13,10,'$'
_aa equ $                                         ;zac. adresa 13,10,'....',"$"
vyp2_mess  db 13,10,'Usporiadane prvky : ',"$"
dlzka2 equ ($ - _aa) -1                           ;od zac. odcitam adr. "$"+1
                                                  ;ale -1 lebo nechcem $
                                                  ;len pre vypis do suboru
_bb equ $
vyp1_mess  db       'Nacitane prvky    : ',"$"
dlzka1 equ ($ - _bb) -1                           ;huh to je to iste :-)))
vstup db 256 dup(0)                     ;vstupny buffer pre ascii cisla
      db 0
max dw 0                                ;hranica ukazatela ascii cisiel
data ends
;--------------------------------------------------------------------
code segment byte public
assume cs:code ,ds:data, ss:_stack

start:
        mov     ax,data                 ;inicializacia segmentov
        mov     ds,ax
        mov     es,ax

        call    open_file               ;otvori sa subor a precitaju sa cisla
        call    open_out_file           ;vytvori sa vystupny subor
        mov     si,offset vstup         ;da do si zac. adr. vst.
        add     si,max                  ;vypocita konecnu adresu
        mov     max,si                  ;da ju do max /posledny znak z suboru adr./

        mov     si,offset vstup         ;inicializuje vstupne premenne
        mov     _si,si                  ;ukazovatel na vstup
        mov     di,offset cisla
        mov     _di,di                  ;ukazovatel na prevedene ciselka

;--------------------------------------------------------------------
;vyhladavanie cisla
znova:  mov     si,_si                 ;si <- posledny si
        mov     zaporne,0              ;vynuluje flagy a pocitadlo ...
        mov     pocet_cislic,0
        cld                            ;spracovava od zaciatku ...
zn1:    lodsb                          ;hladam prvy platny znak
        cmp     si,max
        ja      von                    ;ak je si za hranicou skonci s hladanim

        cmp     al,'-'
        je      zap                    ;ak je to '-' tak nastav zaporny flag
        cmp     al,'0'
        jb      zn1
        cmp     al,'9'
        ja      zn1                    ;ak to je nieco ine skoc na dalsi znak /0..9/

        inc     pocet_cislic          ;nasiel platny znak zvisi pocet_cislic

zn2:    lodsb                         ;hladam prvy neplatny znak
        cmp     si,max                ;aby som zistil koniec cisla
        ja      von                   ;ak je konec tak preved ...
        cmp     al,'0'
        jb      f_ret
        cmp     al,'9'
        ja      f_ret
        inc     pocet_cislic
        jmp     zn2                   ;ak nenasiel neplatne ide odznovu
                                      ;a inkrementuje pocet_cislic

zap:
        mov     zaporne,1             ;sem skoci ak znak bol '-' a nastavi flag
        jmp     zn1


f_ret:                                ;nasiel koniec cisla
        mov     _si,si
        dec     si                    ;uprava si=si-2 aby ukazoval na
        dec     si                    ;posledny znak cisla, lebo uz bol o 2 dalej.
                                      ;nemienim vysvetlovat preco.
        xor     cx,cx
        mov     cl,pocet_cislic
        call    prevod                ;prevedie cislo na word
        mov     di,_di                ;kam ho mam ulozit ??? haaaa ???
        cld                           ;nerob dec, ale inc di
        stosw                         ;ktory ulozi do pola
        mov     _di,di                ;haha zas ho uloziiii
        inc     pocet_cisiel          ;zvysi pocet_cislic
        jmp     znova                 ;ide odznova az kym nenarazi
                                      ;na maximalnu hranicu ukazatela
;--------------------------------------------------------------------
;von vyvencit psa !!!
von:
        call    vyp1                  ;vypise spravu
        call    wr1                   ;zapise hlasku aj do suboru
        call    vypis                 ;vypise nacitane cisla
        call    tried                 ;utriedi ich
        call    vyp2                  ;vypise novu hlasku
        call    wr2
        call    vypis                 ;vypise utriedene cisla
        call    close_out_file        ;zavrie vystupny subor
        mov     ax,4c00h              ;skonci
        int     21h
;--------------------------------------------------------------------
;zavretie za mreze suboru ...
close_out_file:
        mov     ah,3eh
        mov     bx,handle
        int     21h
        ret
;---------------------------------------------------------------------
;Otvorenie a vytvorenie potrebnych subrov s osetrenim na chyby v stanici
;cerveneho kriza MASH 4077
open_file:                            ;nacita cisla zo suboru cisla.txt
        mov     ax,3d00h              ;open file /read only/
        mov     dx,offset filename
        int     21h
        jc      open_error            ;ak nenasiel vypis hlasku a skonci
        mov     bx,ax                 ;vloz handle do bx
        mov     ah,3fh                ;read file
        mov     cx,256                ;256 znakov /max nacitanych/
        mov     dx,offset vstup       ;uloz ich do vstup
        int     21h                   ;potrebuje v bx handle
        mov     max,ax                ;do max daj kolko znakov nacital
        mov     ah,3eh                ;close file
        int     21h
        ret

open_error:
        mov     ah,9                  ;vypis hlasky ze nenasiel subor
        mov     dx,offset op_err_mess
        int     21h
        mov     ax,4c01h
        int     21h

open_out_file:
        mov     ah,3ch
        xor     cx,cx                 ;atributy normal
        mov     dx,offset out_name
        int     21h
        jc      r_err                 ;ak bola chyba, vypis hlasku ...
        mov     handle,ax             ;odloz handle suboru ...
        ret
r_err:
        mov     dx,offset rewr_mess   ; vypis chyb. hlasky a koniec ....
        mov     ah,9
        int     21h
        mov     ax,4c01h
        int     21h
;--------------------------------------------------------------------
;prevod ASCII --> binary
prevod:
        pusha
        xor     cx,cx
        mov     cl,pocet_cislic
        mov     temp,0
        mov     x10,1                ;najprv budem nasobit 10 len raz
        std                          ;speracuj od konca /co ja viem co, trebars bielizen/
        cmp     cx,1                 ;ak je pocet cislic len 1 tak neni co
        je      _1cislo              ;prevadzat /no je co ale neni co/
        dec     cx                   ;znizim cx lebo posledne cislo nenasobim 10
        lodsb                        ;len ho nacitam spravim z neho cislo
        sub     al,'0'
        mov     byte ptr temp,al     ;a dam ho zatial do tempu

pr:
        push    cx
        lodsb                        ;citam dalsi znak
        mov     ah,0
        sub     al,'0'               ;upravim na cislo /nie na .../
        mov     cx,x10               ; heoreeeka bude sa nasobit desiatimi !!!!
        mov     bx,10                ; cim sa bude nasobit ??? /ak 10 tak 10b/

nas:    mul     bx                   ;x10 krat nasobim 10
        loop    nas

        add     temp,ax              ;pripocitam vysledok k tempu
        inc     x10                  ;Pozooor, bude sa nasobit o 1 krat viac !!!
        pop     cx
        loop    pr                   ;spravi dec cx a jumpik
        mov     ax,temp              ;vysledok vracia v ax /no fuj babo/
        jmp     _minus               ;obskok /to je dobre slovo za 5b/

_1cislo:                             ;sem skoci ak pocet cislic bolo 1
        lodsb
        sub     al,'0'
        mov     ah,0

_minus:
        cmp     zaporne,1            ;ak bol flagbzapornej hodnoty
        jne     p_ret                ;Kak nebolo zaporne tak skoci

        not     ax                   ;prevod na pozrne, neee ???
        add     ax,1

P_ret:
        mov     temp,ax              ;pomocka ako obist popa
        popa                         ;bez toho aby som stratil povodny ax
        mov     ax,temp
        ret
;--------------------------------------------------------------------
;funkcia na vypis cisiel
vypis:
        mov     si,offset cisla
        mov     cl,pocet_cisiel
        mov     ch,0
        cld                          ;chod od zaciatku
pis1:   lodsw                        ;nacita word
        call    wr_number            ;a vypise ho v ascii reprezentacii
        call    writeln              ;vypise medzeru
        loop    pis1                 ;pocet ciel krat vypise
        ret
;--------------------------------------------------------------------
;bublifuk !!! jedna bublinka vyssie ako druha .. C je sraaavne, vatsia
;leti vyssie ... 10b
tried:
        pusha
        cmp     pocet_cisiel,1      ;ak je len jedno cislo neni co triedit
        je      utriedene

tried2:
        mov     si,offset cisla
        mov     bola_vymena,0       ;nastavenie kontrolnehu flagu ...
        xor     cx,cx
        mov     cl,pocet_cisiel
        dec     cx                  ;mozes porovnavat n-1 krat

tried1:
        mov     ax,[si]
        cmp     ax,[si+2]           ;ak je nasledovne cislo vacsie ako predchadzajuce
        jg      vymen               ;tak ich navzajom vymen /jump if greater/
        jmp     tr_d


vymen:
        push    [si]               ;vymen cisla navzajom pomocou
        push    [si+2]             ;zasobniku
        pop     [si]
        pop     [si+2]
        mov     bola_vymena,1      ;nastav flag ze bola vymena

tr_d:
        inc     si                 ;zvis pointer o 2 ,lebo je to word
	inc	si
        loop    tried1
        cmp     bola_vymena,1     ;ak bola vymena opakuje cyklus,
                                  ;pokial sa nezacykli. Potom vyhrava bicykel ...
        je      tried2

utriedene:
        popa
        ret
;--------------------------------------------------------------------
;prevod binary-->ASCII ??? ze by ??? ale aaaano !!!
wr_number:
        pusha
        mov     pocet_cislic,0
        mov     zaporne,0
        mov     di,offset o_cislo+4
        std                            ;aaa ideme od konca
        mov     bx,10                  ;delitel 10

        cmp     ax,32767               ;ak je cislo vacsie ako 32767 je zaporne
        jbe     del                    ;ak je kladne, tak skok
        mov     zaporne,1              ;nastav flag ze je zaporne
        not     ax                     ;preved ho na kladne cislo
        add     ax,1
del:
        xor     dx,dx                  ;delim 32 bitovo ... /inak pretekaju .../
        div     bx                     ;del cislo 10 /v AX podiel, v DX zvysok/
        cmp     ax,0                   ;ak je vysledok 0 idem prec
        je      konec                  ;v dx je zvysok  po deleni
        push    ax                     ;ktory reprezentuje poslednu cislicu
        mov     ax,dx
        add     al,'0'                 ;preved byte na ascii znak
        stosb                          ;zapis ho do bufru, pisem odzadu
        inc     pocet_cislic           ;zvys pocet cislic
        pop     ax
        jmp     del                    ;opakuj to kym ax<>0, pokial nezblbnes ...
 konec:
        mov     ax,dx                  ;zapisem poslednu (teda prvu cifru)
        add     al,'0'
        stosb
        inc     pocet_cislic

        cmp     zaporne,0
        je      dalej
        mov     dl,'-'                ;ak bolo zaporne vypisem '-'
        mov     ah,2                  ;vypis jedneho znaku na obrazovku
        int     21h

dalej:
        mov      si,offset o_cislo
        mov      al,5
        sub      al,pocet_cislic     ;upravi si tak aby ukazoval na prvu
        mov      ah,0                ;cislicu
        add      si,ax               ;si ukazuje na zaciatocnu cislicu
        call     write_file          ;
        call     wr_0                ;vypise asciiz string
        popa
        ret
;--------------------------------------------------------------------
;vypis ASCIIZ stringu vsade gde sa da ...
wr_0:                                ;asciiz vypisovac
        cld
wr_n:   lodsb                        ;citam byte
        cmp     al,0                 ;ak je nula koncim
        je      wr_ret
        mov     ah,2                 ;vypisujem pomocou DOS-u
        mov     dl,al
        int     21h
        jmp     wr_n                 ;kde sa to cykli ??? no predsa tu !!!
wr_ret:
        ret

writeln:                              ;vypise medzeru
        pusha
        mov     ah,2
        mov     dl,' '
        int     21h
        popa
        ret

write_file:
        pusha
        cmp     zaporne,1                  ;ak je zaporne tak zapis '-'
        jne     no
        mov     ah,40h                     ;sluzba write file
        mov     cx,1                       ;jeden znak
        mov     bx,handle                  ;do bx daj handle
        mov     dx,offset minus            ;dx offset znaku '-'
        int     21h
no:
        mov     ah,40h                     ;sluzba write
        mov     bx,handle
        mov     cl,pocet_cislic            ;do cx pocet cislic
        mov     ch,0
        mov     dx,si                      ;v si je zaciatok cislic
        int     21h                        ;
        mov     ah,40h
        mov     cx,1
        mov     dx,offset medzera          ;a este pridaj medzeru za cislo
        int     21h
        popa
wri_ret:
        ret
;--------------------------------------------------------------------
;vypis na obrazovku nejakych hlasiek
vyp2:   pusha                         ;vypisuje hlasky ze 'nacitane cisla' atd.
        mov     dx,offset vyp2_mess
        jmp     v_dal1
vyp1:   pusha
        mov     dx,offset vyp1_mess
v_dal1:
        mov     ah,9
        int     21h
        popa
        ret
;--------------------------------------------------------------------
;vypis do suboru
wr2:   pusha                         ;vypisuje hlasky ze 'nacitane cisla' atd.
        mov     cx,dlzka2
        mov     dx,offset vyp2_mess
        jmp     v_dal11
wr1:    pusha
        mov     cx,dlzka1
        mov     dx,offset vyp1_mess
v_dal11:
        mov     ah,40h               ;zapis do subru
        mov     bx,handle            ;kam to zapise ??? C je spravne ...
        int     21h
        popa
        ret
code ends                             ;uf konecne konec zdrojaku :-)))
end start                             ;alebo kaanec filma ???
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;tu odhr?znuuut !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

