#include <stdio.h>
#include <conio.h>
#define MEM_SIZE 10
#define FALSE 0
#define TRUE !0

typedef struct _member {   //        	: poloka ZVP.
			int	value;
			int	next;
			} M_member;

		M_member memory[MEM_SIZE];  //	: samotn ZVP.
		char	m_FirstEmpty; 	  //	: ukazovatel na prv voln prvok ZVP.

//  Funkcie:

void M_Empty(){

//	Funkcia inicializuje ZVP a zreaz poloky next, prv voln prvok bude 0.
		int i;
		for(i=0;i<MEM_SIZE;i++){
			memory[i].next 		= i+1;
		}
		memory[MEM_SIZE-1].next = MEM_SIZE-1;
		m_FirstEmpty = 0;
		return;
}

char M_IsEmpty(){

//	Funkcia vrti TRUE alebo FALSE poda nastavenia m_FirstEmpty.
//	Ak u nie je voln prvok v ZVP nastav sa m_FirstEmpty na -1.

	if ( m_FirstEmpty == -1 )
		return FALSE;
	else
		return TRUE;
}



int  M_New(void){

//	Funkcia obsad prv voln prvok poda m_FirstEmpty a nastav ukazovatel na dal voln
//	prvok. Vrti index alokovanho prvku.

	 int n;
	 
	 if( !M_IsEmpty() ) {
		 printf("\nPamat plna.\n");
		 return FALSE;
	 }

	 n = m_FirstEmpty;

	 printf("Prvok %d alokovany.\n",m_FirstEmpty);
	 memory[m_FirstEmpty].value =  666;
	 m_FirstEmpty =  memory[m_FirstEmpty].next;

	 if ( n == memory[n].next ) 
		 m_FirstEmpty = -1;

	 if (m_FirstEmpty==-1) printf("To bola posledna volna cast pamate. \n");
		else printf("Ukazovatel pre prvu volnu cast pamati je %d.\n",m_FirstEmpty);
	 return n;
}

int  M_Dispose(int x){

//	Funkcia uvoln prvok zo ZVP poda indexu x. Najskr zist i dan prvok u nie je 
//	uvolnen, ak no vype sprvu.

	 int n;
	 n = m_FirstEmpty;
	 if( m_FirstEmpty == -1 ){
		 memory[x].next = x;
		 m_FirstEmpty = x;
		 printf("Prvok %d uvolneny.\n",x);
		 memory[m_FirstEmpty].value = 0;
		 return 0;
	 }
	 while( memory[n].next != n ) {
		if( memory[n].next == x ) {
			printf("Prvok %d uz bol uvolneny.\n",x);
			return -1;
		}
		n=memory[n].next;
	 }

	if( memory[n].next == x ) {
		printf("Prvok %d uz bol uvolneny.\n",x);
		return -1;
	}
	memory[n].next=x;
	memory[x].next=x;
    	memory[x].value = 0;
printf("Prvok %d uvolneny.\n",x);
	return 0;
}



void M_Display( void ) {

//	Funkcia zobrazuje obsah ZVP poda indexu.
	 if (m_FirstEmpty==-1) printf("Nie je volna pamat. \n");
		else printf("Ukazovatel pre prvu volnu cast pamati je %d.\n",m_FirstEmpty);

	for( int i=0; i < MEM_SIZE; i++)
		printf("%d ", i);

	printf ( "\n" );
	for( i=0; i < MEM_SIZE; i++)
	  if( memory[i].value == 666 ) 
	    printf("* ");
	  else 
		printf("%1d ", memory[i].next);

	printf("\n\n");
	return;
}

int main(){     

//	Funkcia main zobrazuje vodn menu a vol jednotliv funkcie.
	
	char c;    
	int num;
        clrscr();
	M_Init();	
	do{    
		printf("Zretazena pamat.\n");
printf("A - Alokovanie\n");
	printf("D - Dispose\n");
	printf("Z - Zobrazenie stavu\n");
	printf("K - Koniec.\n");             
	c = getch();      
	switch(c){              
		case 'a' : 
				M_New();
				break;
		case 'z' :
				M_Display();
				break;
		case 'd' : 
				fflush(stdin);
				printf("DISPOSE Zadaj index 0-%d: ",MEM_SIZE-1); 
				scanf("%d",&num);
				M_Free(num);
				break;
		
	}
			
	}while(c != 'k');
	
	printf("Koniec.\n");	
	return 0;
}
