PROGRAM Zretazena_volna_pamet;
USES crt;
CONST adrmin=0;
      adrmax=255;
      nilz=-1;
      poc:byte=0;
{--------------------------}
      koniec:boolean=false;
      prec:boolean=false;
      n=4;
      lhx=1; lhy=5;
      pdx=lhx+17; pdy=lhy+n;
      menu:array[1..n] of string=('Zretaz VP        ','Poskytni prvok   ',
				  'Vrat prvok       ','Koniec           ');
    ktora:byte=1;
TYPE adresa=adrmin..adrmax;
     slovo=integer;
     hlpam=array[adresa] of slovo;
     ind=nilz..adrmax;
var pamet:hlpam;
    zvp,prv:ind;
procedure on;
begin
  asm
    mov ah,01
    mov ch,4
    mov cl,5
    int 10h
  end;
end;
procedure off;
begin
  asm
    mov ah,01
    mov ch,20h
    mov cl,0
    int 10h
  end;
end;
procedure ramcek(xh,yh,xd,yd:byte);
var x,y:byte;
begin
  gotoxy(xh,yh);
  write('');
  for x:=xh to xd do write('');
  writeln('');
  for y:=yh+1 to yd do
  begin
    gotoxy(xh,y);
    write('');
    for x:=0 to xd-xh do write(' ');
    writeln('');
  end;
  gotoxy(xh,yd+1);
  write('');
  for x:=0 to xd-xh do write('');
  writeln('')
end;
procedure hl_menu_;
var c:char;
    x:byte;
begin
  textbackground(0);
  textcolor(7);
  ramcek(lhx,lhy,pdx,pdy);
  for x:=1 to n do
  begin
    if x=1 then
    begin
      textbackground(7);
      textcolor(0);
    end
           else
    begin
      textbackground(0);
      textcolor(7);
    end;
    gotoxy(lhx+2,lhy+x);
    write(menu[x]);
  end;
  repeat
    c:=readkey;
    case c of
     'H':begin
           if ktora<>1 then
           begin
             textbackground(0);
             textcolor(7);
             gotoxy(lhx+2,lhy+ktora);
             write(menu[ktora]);
             dec(ktora);
             textbackground(7);
             textcolor(0);
             gotoxy(lhx+2,lhy+ktora);
             write(menu[ktora]);
           end;
         end;
     'P':begin
           if ktora<>n then
           begin
             textbackground(0);
             textcolor(7);
             gotoxy(lhx+2,lhy+ktora);
             write(menu[ktora]);
             inc(ktora);
             textbackground(7);
             textcolor(0);
             gotoxy(lhx+2,lhy+ktora);
             write(menu[ktora]);
           end;
         end;
    end;
  until c=#13;
  textbackground(0);
  textcolor(7);
end;
function isempty(zvp:ind):boolean;
{test ci je v ZVP este nejaky volny prvok}
begin
  isempty:=(zvp=nilz);
end;
procedure empty(var zvp:ind);
{vytvori zaciatocne zretazenie volnej pamete}
var ukaz:ind;
begin
  ukaz:=adrmin;
  while (ukaz<adrmax-2) do
  begin
    pamet[ukaz+1]:=ukaz+2;
    inc(ukaz,2);
  end;
  pamet[adrmax]:=nilz;
  zvp:=adrmin;
end;
procedure new(var zvp,prvok:ind);
{poskytne prvok z volnej pameti}
begin
  if isempty(zvp) then writeln('Pamet je vycerpana!')
                  else
                    begin
                      prvok:=zvp;
                      zvp:=pamet[zvp+1];
                    end;
end;
procedure dispose(var zvp,prvok:ind);
{vrati prvok do volnej pameti}
begin
  pamet[prvok+1]:=zvp;
  zvp:=prvok;
end;
procedure zobraz;
var x,y,pom:integer;
begin
  y:=1;
  for x:=1 to 6 do
  begin
    gotoxy(24+9*(x-1),1);
    write('ind uk.  ');
  end;
  pom:=0;
  for x:=1 to 128 do
  begin
    inc(y);
    gotoxy(23+9*((x-1) div 23),y);
    if ((pamet[(x-1)*2+1])<>(-1)) then write(' ',((x-1)*2):3,'>',pamet[(x-1)*2+1],'  ')
                                  else write(' ',((x-1)*2):3,'>',pamet[(x-1)*2+1],'  ');
    if (zvp div 2)=(x-1) then
    begin
      gotoxy(23+9*((x-1) div 23),y);
      write('>');
    end;
    if (x mod 23)=0 then y:=1;
  end;
end;
procedure _new;
begin
  new(zvp,prv);
  if not(isempty(zvp)) then
  begin
    inc(poc);
    pamet[prv+1]:=-1;
  end;
end;
procedure _dispose;
begin
  if poc<>0 then
  begin
    gotoxy(1,12);
    on;
    writeln('Ktory prvok?');
    readln(prv);
    dispose(zvp,prv);
    off;
    gotoxy(1,12);
    writeln('                       ');
    write('                       ');
  end
            else
            begin
              gotoxy(1,12);
              write('Nie je obsadeny ziaden');
              gotoxy(1,13);
              write('prvok ZVP!');
              readkey;
              gotoxy(1,12);
              writeln('                       ');
              write('                       ');
            end;
end;
{Hlavne telo programu}
procedure rob;
var cislo:ind;
begin
  if ktora=1 then empty(zvp);
  if ktora=2 then _new;
  if ktora=3 then _dispose;
  if ktora=4 then koniec:=true;
  zobraz;
end;
procedure start;
begin
  clrscr;
  off;
  zobraz;
  repeat
    hl_menu_;
    rob;
  until koniec;
  on;
  clrscr;
end;
begin
  start;
end.
