{
ZRETAZENA VOLNA PAMET
Zadanie cislo 1.
Jan Dolezaj
Kruzok 2 TKL
Odbor Telekomunikacie
Skolsky rok 1998/99

	
        Signatura: ZVP - zretaz. volna pamat
		   polozka - prvok zo ZVP
		   bool - boolovsky typ
	operacie
	EMPTY :               -> ZVP       - zaciatocne zretazenie volnej pamati Z
	ISEMPTY:          ZVP -> bool      - test, ci ZVP obsahuje volny prvok
	NEW:              ZVP -> polozka   - poskytnutie pameti 
	DISPOSE: polozka, ZVP -> ZVP       - uvolnenie obsadeneho prvku ZVP

	reprezentacia:	polozka - struktura s prvkami:
			   elm - typu char 
			   ukazovatel -  typu integer
			ZVP - pole s 25 prvkami typu polozka
}
program zvpp (input,output);

{---pouzite graficke znazornenie---}
const
  KONIECZVP = -1;
  VOLNE = ' ';
  POUZITE = '$';

type
  elmptr=integer;
  elm = char;
  polozka = record       { struktura pametovej bunky } 
    data: elm;           { jej hodnota }
    ukazovatel: elmptr;  { smernik na dalsiu }
  end;
  zvpt = array [0..25] of polozka;   { cela pamet } 

var
   zvp: zvpt;
   volba,prvok,ukazovatel: integer;

{***************
 funkcia na zobrazenie ZVP na obrazovke
****************}

procedure printzvp( mem: zvpt; velkost: integer);
var i:integer;

begin
  writeln;
  if ( ukazovatel <> KONIECZVP ) then begin
    writeln;
    for i:=0 to ukazovatel-1 do write('   '); { ukazovatel na prvy volny prvok }
    writeln('\/');
  end;
  for i:=0 to velkost-1 do write(i:3);  { vypis pametovych miest }
  writeln;
  for i:=0 to velkost-1 do write(mem[i].data:3); { vypis obsahu pam. miest } 
  writeln;
  for i:=0 to velkost-1 do write(mem[i].ukazovatel:3); { vypis smernikov }
  writeln;
end;

{****************************
empty uvolni vsetky prvky ZVP ---> zmeni obsah buniek->data
zinicializuje smerniky
******************************}

procedure empty(var ppp: zvpt;velkost: integer);
var i:elmptr;

begin
  for i:=0 to velkost-1 do begin
    ppp[i].data:=VOLNE;
    ppp[i].ukazovatel:=i+1;
  end;
  ppp[velkost-1].ukazovatel:=KONIECZVP;{ ukonci ZVP tak, ze posledny smernik }
				       { ukazuje na KONIECZVP }
  ukazovatel:=0;                    { Globalny ukazovatel je na zaciatku ZVP }
end;

{********************
isempty - ak free1 (prvy volny ) je -1 funkcia vrati
FALSE - pamet je plna, inak TRUE - pamet este nie je plna
*********************}

function isempty( free1: integer): Boolean;
begin
  if ( free1 = KONIECZVP ) then isempty:=FALSE
  else isempty:=TRUE;
end;

{****************
new1 obsadi vzdy iba jeden volny prvok ZVP ak je este volna
pamet, na zistenie ci je este pamet volna vola funkciu isempty 
Funkcia vrati smernik na prvy volny prvok
*****************}

function new1(var mem:zvpt;var prvy:integer):elmptr;
begin
	if isempty(prvy) then begin
		new1:=prvy;             
		prvy:=mem[prvy].ukazovatel;
		end
	else
		writeln('Nieto volny prvok!!!');
end;

{******************
funckia newz obsadi pozadovany pocet prvkou ZVP tak ze prislusny
pocet krat zavola funkciu new1 
*******************}

function newz(var mem: zvpt ;free1: integer): integer;
var i,count,ii:integer;
    c:char;
begin
   i := free1;    { prvy volny }
   count := 0;
   if ( not isempty(free1) ) then begin
     writeln;
     write('Nieto co obsadit ! Skus uvolnit');
     read(c);
     newz:=free1;
   end else begin
   
   {** Zistim pocet volnych miest **}
 
      while(mem[i].ukazovatel<>KONIECZVP) do begin
       count:=count+1;
       i:=mem[i].ukazovatel;
     end;
   
     count:=count+1;
     writeln;
     write('Je ',count,' volnych prvkov! Kolko chces obsadit?:');
     repeat
       read(i);
       if( (i>count) or (i<0)) then
         write('Zadal si chybne cislo! Skus znova(max=',count,'):');
     until( (i<=count) and (i>=0) );
     if ( i=0 ) then begin
	write('0 => Neobsadzujem nic ...');
	newz:=free1;
     end else begin
  {** samotne obsadenie pamete **} 

       for ii:=0 to i-1 do mem[new1(mem,free1)].data:=POUZITE;
       newz:=free1;    { vrati ukazovatel na prvy volny }
     end;
   end;
end;

{***************
isused funkcia pre Dispose 
zistim ci prvok ktory chcem uvolnit je pouzivany alebo nie

****************}

function isused(mem: zvpt;pol,free1: elmptr): boolean;
var i:elmptr;
begin
  isused:=TRUE;
  i:=free1;
  if i = pol then isused := FALSE;
  while(i<>KONIECZVP) do begin
    if mem[i].ukazovatel=pol then isused:=FALSE;
    i:=mem[i].ukazovatel;
  end;
end;

{************
funkcia dispose uvolni zadany prvok, ukazovatel v tomto prvku zmeni 
na free1 cize na prvy volny
a vrati ukazovatel na tento uvolneny prvok
*************}

function dispose(var mem: zvpt;prvok,free1: elmptr): elmptr;
begin
  if( not isused(mem,prvok,free1) ) then begin
    writeln;
    write('Prvok ',prvok,' nie je obsadeny neda sa uvolnit !!!');
    dispose:=free1;
  end else begin
    mem[prvok].data:=VOLNE;
    mem[prvok].ukazovatel:=free1;
    dispose:=prvok;
  end;
end;

{*******************
procedura menu vypise na obrazovku menu
********************}

procedure menu;
begin
  writeln('Menu:');
  writeln(' 1.new');writeln(' 2.dispoze');
  writeln(' 3.Empty');writeln(' 4.End');
  write('Volba:');
end;

{*******************
hlavny program
postupne vola jednotlive funkcie a procedury, podla volby
********************}


begin
  empty(zvp,25);
  repeat
    printzvp(zvp,25);
    menu;
    read(volba);
    case volba of
      1 : ukazovatel:=newz(zvp,ukazovatel);    {  New   }
      2 : begin                                {  Dispose  }
            write('Zadaj,ktory prvok:');
            read(prvok);
            ukazovatel:=dispose(zvp,prvok,ukazovatel);
          end;
      3 : empty(zvp,25);                       {  Empty  }
      4 : ;                                    {  End  }
  end;
  until(volba=4);
end.

