
#include<stdio.h>
#include<stdlib.h>

#define	max	100

typedef int hodnoty;

typedef void* tree;

struct treeelm{
	tree Lnasl;
	tree Pnasl;
	tree predchodca;
	hodnoty	hodnota;
}treeelm;

int	index,pole1[max],pole2[max];

tree	empty(){return(NULL);}
tree	predchodca(tree strom){return(strom->predchodca);}
tree	Lnasl(tree strom){return(strom->Lnasl);}
tree	Pnasl(tree strom){return(strom->Pnasl);}
tree	koren(tree strom){
	if(strom==NULL) return(NULL);
	else
		if(predchodca(strom)!=NULL) return(koren(strom->predchodca));
		else return(strom);}
hodnoty	hod(tree strom){return(strom->hodnota);}
tree	emptyn(tree strom,hodnoty hodnota){
tree pom,tkoren=koren(strom);
	if(tkoren==NULL){
		printf("Vytaram novy strom\n");
		pom=malloc(sizeof(treeelm));
		pom->hodnota=hodnota;
		pom->Lnasl=NULL;
		pom->Pnasl=NULL;
		pom->predchodca=NULL;
		strom=pom;
		return(pom);
		}
	else{
		do{
			pom=tkoren;
			if(hodnota < tkoren->hodnota) tkoren=tkoren->Lnasl;
			else tkoren=tkoren->Pnasl;
			}while(tkoren!=NULL);
		tkoren=malloc(sizeof(treeelm));
		if(hodnota < pom->hodnota){
			pom->Lnasl=tkoren;
			printf("Pridavam novy vrchol vlavo pod %i\n",hod(pom));
			}
		else{
			pom->Pnasl=tkoren;
			printf("Pridavam novy vrchol vpravo pod %i\n",hod(pom));
			}
		tkoren->hodnota=hodnota;
		tkoren->Lnasl=NULL;
		tkoren->Pnasl=NULL;
		tkoren->predchodca=pom;
		return(tkoren);
		}
}

tree	vyhladaj(tree strom,hodnoty hodn){
		if(hod(strom)==hodn) return(strom);
		else
			if(hodn<hod(strom)){
				if(NULL!=strom->Lnasl) return(vyhladaj(strom->Lnasl,hodn));
				}
			else{
				if(NULL!=strom->Pnasl) return(vyhladaj(strom->Pnasl,hodn));
				}
		return(NULL);
}
/*-----------------------------------------------*/

void	clrpole(){int i;for(i=0;i<max;i++){pole1[i]=0;pole2[i]=0;}}

void	prejdi(tree strom,int hlbka){
	if(strom==NULL) return;
	else{
/*		printf("Hlbka:%i - hod:%i\n",hlbka,hod(strom));*/
		pole1[index]=hlbka;pole2[index++]=hod(strom);
		prejdi(strom->Lnasl,hlbka+1);
		prejdi(strom->Pnasl,hlbka+1);
		}
}

tree	zmaz(tree strom){
hodnoty	delhod=hod(strom);
tree newtree=empty();
int i,maxind;
	clrpole();
	prejdi(koren(strom),1);
	for(i=0;i<index;i++) if(pole1[i]>maxind) maxind=pole1[i];
	for(i=1;i<=maxind;i++) printline(i,maxind);
	for(i=0;i<index;i++) if(pole2[i]!=delhod) newtree=emptyn(newtree,pole2[i]);
	return(newtree);
}

void	printline(int line,int maxind){
int	i;
	for(i=0;i<=(maxind-line);i++) printf("   ");
	for(i=0;i<index;i++) if(pole1[i]==line) printf(" %3i ",pole2[i]);
	printf("\n");
}

void	printtree(tree strom){
int	i,maxind=0;
	index=0;
	clrpole();
	prejdi(koren(strom),1);
	for(i=0;i<index;i++) if(pole1[i]>maxind) maxind=pole1[i];
	for(i=1;i<=maxind;i++) printline(i,maxind);
}

void main(){
char	znak;
hodnoty	myhod;
tree mytree=empty();

	do{
		printf("emptyn  koren  lnasl  pnasl  Predchodca  vyhladanie  zmazanie  Koniec:");
		scanf("%c",&znak);
		switch(znak){
			case	'e':printf("Zadaj hodnotu noveho vrcholu:");
						scanf("%i",&myhod);
						mytree=emptyn(mytree,myhod);
						break;
			case	'k':mytree=koren(mytree);
						break;
			case	'l':if(NULL!=Lnasl(mytree)) mytree=Lnasl(mytree);
						break;
			case	'p':if(NULL!=Pnasl(mytree)) mytree=Pnasl(mytree);
						break;
			case	'P':if(NULL!=predchodca(mytree)) mytree=predchodca(mytree);
						break;
			case	'v':printf("Zadaj hodnotu,ktoru mam vyhladat:");
						scanf("%i",&myhod);
						if(NULL==vyhladaj(koren(mytree),myhod)) printf("Hodnota %i sa v strome nenachadza\n",myhod);
						else mytree=vyhladaj(koren(mytree),myhod);
						break;
			case	'z':mytree=zmaz(mytree);
						break;
			}
		printf("HJ\n");
		printtree(mytree);
		if(mytree!=NULL) printf("Hodnota aktualneho vrcholu je %i\n",hod(mytree));
	}while(znak!='K');

}

