uses crt;

type Pzoz=^Tzoz;
     Tzoz=record
                meno:string[20];
                nasl:Pzoz;
     end;

var
   prvy,akt,novy:Pzoz;
   got,got2:char;




function LISTINIT:Pzoz;
var vstup:string[20];
begin
     writeln;write('Zadajte meno: ');
     readln(vstup);
     new(novy);
     novy^.meno:=vstup;
     novy^.nasl:=NIL;
     LISTINIT:=novy;
end;




procedure FIRSTONE;
begin
     akt:=prvy;
end;




procedure SUCCESSOR(var akt:Pzoz);
begin
     if akt=NIL then begin writeln('nie je zvoleny aktualny prvok!'); exit; end;
     akt:=akt^.nasl;
end;




procedure POSTDELETE(var akt:Pzoz);
var dalsi:Pzoz;
begin
     if akt=NIL then begin writeln('nie je aktualny prvy prvok!'); exit; end;
     if akt^.nasl=NIL then begin writeln('niet co mazat!'); exit; end;
     dalsi:=akt^.nasl;
     akt^.nasl:=dalsi^.nasl;
     dispose(dalsi);
end;





procedure DELETEFIRST(var prvy:Pzoz);
var old:Pzoz;
begin
     if prvy=NIL then begin writeln('nie je zvoleny prvy prvok!'); exit; end;
     old:=prvy;
     prvy:=prvy^.nasl;
     dispose(old);
end;





function COPY(var akt:Pzoz):string;
begin
     if akt=NIL then begin writeln('nie je zvoleny aktualny prvok!'); exit; end;
     COPY:=akt^.meno;
end;





function COPYFIRST(var prvy:Pzoz):string;
begin
     if prvy=NIL then begin writeln('nie je zvoleny prvy prvok!'); exit; end;
     COPYFIRST:=prvy^.meno;
end;






procedure POSTINSERT(var akt:Pzoz);
var vstup:string[20];
begin
     if akt=NIL then begin writeln('nie je zvoleny aktualny prvok!'); exit; end;
     writeln;write('Zadaj meno: ');
     readln(vstup);
     new(novy);
     novy^.meno:=vstup;
     if akt^.nasl=NIL then novy^.nasl:=NIL
                      else novy^.nasl:=akt^.nasl;
     akt^.nasl:=novy;
end;





procedure INSERTFIRST(var prvy:Pzoz);
var vstup:string[20];
begin
     if prvy=NIL then begin writeln('nie je zvoleny prvy prvok!'); exit; end;
     writeln;write('Zadaj meno: ');
     readln(vstup);
     new(novy);
     novy^.meno:=vstup;
     novy^.nasl:=prvy;
     prvy:=novy;
end;





procedure ACTUALIZE(var akt:Pzoz);
var vstup:string[20];
begin
     if akt=NIL then begin writeln('nie je zvoleny aktualny prvok!'); exit; end;
     writeln;write('Zadaj novy hodnotu: ');
     readln(vstup);
     akt^.meno:=vstup;
end;





function ACTIVE(var akt:Pzoz):boolean;
begin
     ACTIVE:=akt=NIL;
end;

procedure IS_ACTIVE(var akt:Pzoz);
begin
     if ACTIVE(akt)=true then writeln('Aktualny prvok je NIL')
                          else writeln('Aktualny prvok ma meno: ',akt^.meno);
end;



procedure PRINT;
begin
     novy:=prvy;
     writeln;write('|');
     while novy<>NIL do
     begin
          if akt=novy then write('->',novy^.meno,'|')
                      else write(novy^.meno,'|');
          novy:=novy^.nasl;
     end;
     writeln;
end;




begin
     prvy:=NIL;akt:=NIL;novy:=NIL;
     clrscr;
     repeat
           writeln;textcolor(red);writeln('    VYBER');writeln;
           textcolor(7);
           writeln('1 ... ListInit');
           writeln('2 ... FirstOne');
           writeln('3 ... Successor');
           writeln('4 ... PostDelete');
           writeln('5 ... DeleteFirst');
           writeln('6 ... Copy');
           writeln('7 ... CopyFirst');
           writeln('8 ... PostInsert');
           writeln('9 ... InsertFirst');
           writeln('0 ... Actualize');
           writeln('a ... Active');
           writeln('p ... Print');
           writeln('q ... Quit');writeln;

           textcolor(lightred);
           if prvy=NIL then writeln('Prvy nie je definovany')
                       else writeln('Meno prveho prvku:         ',prvy^.meno);
           if akt=NIL then writeln('Aktuanly nie je definovany')
                      else writeln('Meno aktualneho prvky:     ',akt^.meno);
           if (akt^.nasl=NIL)or(akt=NIL) then writeln('Aktualny nema nasledovnika')
                      else writeln('Nasledovnik aktualneho:    ',akt^.nasl^.meno);
           textcolor(yellow);
           writeln;write('Aktualny front: ');PRINT;
           textcolor(lightgreen);
           got:=readkey;
           case got of
                '1':prvy:=LISTINIT;
                '2':FIRSTONE;
                '3':SUCCESSOR(akt);
                '4':POSTDELETE(akt);
                '5':DELETEFIRST(prvy);
                '6':writeln('Meno aktivneho:',COPY(akt));
                '7':writeln('Meno prveho:',COPYFIRST(prvy));
                '8':POSTINSERT(akt);
                '9':INSERTFIRST(prvy);
                '0':ACTUALIZE(akt);
                'a':IS_ACTIVE(akt);
                'p':PRINT;
                'q':writeln;
           else
                  textcolor(lightred+blink);
                  writeln('Skus este raz');
           end;
           textcolor(7);
     until got='q';


end.
