/*
Meno : Martin Chripko
Kruzok : tlk - 2
Zadanie : 2
Odbor : Telekomunikacie


	Signatura: pamat - zasobnik typu stack
		   prvok - prvok zo zasobnika

	operacie

	PushM    :     Stack,prvok -> Stack
	PopM	 :     	     prvok -> Stack
	TopM	 :     	     Stack -> prvok
	IsEmpty  :     	     Stack -> Bool
	Empty    :     	    	   -> Stack

	reprezentacia: pamat - pole typu short o velkosti [velkost+1]
		       vrch  - unsigned integer (ukazovatel vrchu zasobnika)

/*
Meno : Martin Chripko
Kruzok : tlk - 2
Zadanie : 2
Odbor : Telekomunikacie


	Signatura: pamat - zasobnik typu stack
		   prvok - prvok zo zasobnika

	operacie

	PushM    :     Stack,prvok -> Stack
	PopM	 :     	     prvok -> Stack
	TopM	 :     	     Stack -> prvok
	IsEmpty  :     	     Stack -> Bool
	Empty    :     	    	   -> Stack

	reprezentacia: pamat - pole typu short o velkosti [velkost+1]
		       vrch  - unsigned integer (ukazovatel vrchu zasobnika)

*/

#include<stdio.h>
#include<stdlib.h>
#define velkost 19

short pamat[velkost+1];
unsigned int vrch=0;

/* deklaracia funkcii */

void PushM(short Prvok);
short PopM();
short TopM();
char IsEmpty();
void Empty();


/* funkcia PushM vlozi novy prvok do zasobnika */

void PushM(short Prvok)
  {if (IsEmpty()) printf("\nZasobnik je plny");
	else pamat[--vrch]=Prvok;}     //Vlozi novy prvok do zasobnika

/* funkcia PopM vymaze prvok zo Zasobnika ak nie je zasobnik prazdny */

short PopM()
  {
  if(vrch<=velkost)
  return pamat[vrch++];
  else
	{
	printf("\nZasobnik je prazdny  ");
	return 0;
	}
  }

/* funkcia TopM vrati hodnotu prvku na vrchole zasobnika */

short TopM()
  {return pamat[vrch];}

/* funkcia IsEmpty vrati ci je pamet prazdna/plna (True/False) */

char IsEmpty()
  {return (vrch==0);}

/* funkcia Empty vynuluje pamet (Inicializuje sa na zaciatku) */

void Empty()
  {unsigned short i=0;
  for (i=0;i<velkost;i++) pamat[i]=0;
  vrch=velkost+1;
  }

/* funkcia showmem - vypis pamete na obrazovku */

void showmem()
  {unsigned short i=0;
  printf("\nObsah zasobniku : \n");
  for (i=0; i<=velkost ;i++)
  printf("%d %d %s \n",i,pamat[i],(i==vrch)?"<-- Vrch zas.":"");
  }

/* Hlavny program */

void main()
{
int klv,cislo;
Empty();
while(1)
  {
  showmem();
  printf("\t\t\t\t1-Push\t2-Pop\t3-Top\t4-Koniec\n");
  scanf("%d",&klv);
  switch(klv)
      {
      case 1 : scanf("%d",&cislo);PushM(cislo);break;
      case 2 : printf("Vybrany prvok : %d",PopM());break;
      case 3 : printf("Prvok na vrchole zasobnika : %d",TopM());break;
      case 4 : exit(1);
      }
  }
}
