#include <stdio.h>
#include "tab.h"

extern void destr(tab *);
extern void empty(tab *);
extern int search(char *, tab *);
extern int insert(tab *, char *, elm);
extern int deletet(tab *, char *);
extern int iseq(char *, char *);
extern elm readt(tab *, char *);

void cprint(tab *t, int i)
{
	polz1 *nova;

	printf("%d -> ", i);

	nova = t[i];
	do
	{
		printf("%s ", nova->key);
		nova = nova->next;
	} while (nova);
	putchar('\n');
}

void tprint(tab *t)
{
	int i;
	for ( i = 0 ; i < N ; ++i )
		if (t[i]) cprint(t, i);	
	putchar('\n');
}

int parse(char *c, tab *t)
{
	elm e;
	char kluc[L+1];
	char kluc2[L+1];

	switch ((int) c[0])
	{
		case 'q':
			destr(t);
			return 0;
		case 'h':
			printf("possible commands: insert, delete, print, quit, read, kiseq, search\n");
			break;
		case 'i':
			scanf("%s", kluc);
			if (insert(t, kluc, 0) < 0) printf("kluc %s tam uz je\n", kluc);
			break;
		case 'd':
			scanf("%s", kluc);
			if (deletet(t, kluc) < 0) printf("kluc %s tam nebol\n", kluc);
			break;		
		case 'r':
			scanf("%s", kluc);
			if ((e = readt(t, kluc)) < 0) printf("kluc %s tam nebol\n", kluc);
			else printf("pod klucom %s je hodnota %d\n", kluc, e);
			break;
		case 'k':
			scanf("%s", kluc);
			scanf("%s", kluc2);
			if (iseq(kluc, kluc2)) printf("yes\n");
			else printf("no\n");
			break;
		case 's':
			scanf("%s", kluc);
			if (search(kluc, t)) printf("yes\n");
			else printf("no\n");
			break;
		case 'p':
			tprint(t);
			break;	
		default:
			printf("type `help' for help\n");
	}
	return 1;
}

int main(int argc, char *argv[])
{
	tab t[N];
	char c[10] = "h";
	argc++;

	empty(t);

	while (parse(c, t))
	{
		printf("%s> ", argv[0]);
		scanf("%9s", c);
	}
	return 0;
}
