/*
Lubomir Remiar		3 INF 8

DRUHY: tab,elm,key,Bool
OPERACIE:
	empty:      -> tab
	insert: tab, elm -> tab
	read: tab, key -> elm
	delete: tab, key -> tab
	iseq: key, key -> Bool
	search: key, tab -> Bool
Tabulka je implementovana pomocou pola
*/
#include <stdio.h>
#include <string.h>
#include <conio.h>
#define MAX_TAB 10
typedef struct Tabulka
		{
		int posledny;
		char *prvky[MAX_TAB];
		};
typedef enum   {FALSE,TRUE} Bool;

struct Tabulka slovnik;



void empty(void)
{
	slovnik.posledny=-1;
}

void insert (const char *slovo)
{
	if (slovnik.posledny==MAX_TAB-1) { printf ("Tabulka je plna\n"); return; }
	slovnik.posledny++;
	slovnik.prvky[slovnik.posledny]=new char[strlen(slovo)+1];
	strcpy(slovnik.prvky[slovnik.posledny],slovo);
}

char * read (const char *kluc)
{
	int i=0;
	slovnik.prvky[slovnik.posledny+1]=(char *)kluc;
	while (kluc[0]!=slovnik.prvky[i][0] || kluc[1]!=slovnik.prvky[i][1]) i++;
	if (i<=slovnik.posledny) return slovnik.prvky[i];
        else return NULL;
}

void del (const char *kluc)
{
	int i=0,j;
	if (slovnik.posledny==-1) { printf ("Tabulka je prazdna\n");return; }
	slovnik.prvky[slovnik.posledny+1]=(char *)kluc;
	while (kluc[0]!=slovnik.prvky[i][0] || kluc[1]!=slovnik.prvky[i][1]) i++;
	if (i<=slovnik.posledny)
		{
		delete slovnik.prvky[i];
		for (j=i;j<slovnik.posledny;j++)
			slovnik.prvky[j]=slovnik.prvky[j+1];
		slovnik.posledny--;
		}
}

Bool search(const char *kluc)
{
	int i=0;
	slovnik.prvky[slovnik.posledny+1]=(char *)kluc;
	while (kluc[0]!=slovnik.prvky[i][0] || kluc[1]!=slovnik.prvky[i][1]) i++;

	if (i<=slovnik.posledny) return TRUE;
	else return FALSE;
}

void vypis (void)
{int i,j;
	printf ("**************		Tabulka 	**************\n");
	for (i=0;i<=slovnik.posledny;i+=4)
		{
		for (j=i;j<=i+3 && j<=slovnik.posledny;j++)
			printf ("%15s",slovnik.prvky[j]);
		printf("\n");
		}
	printf ("**************	    Koniec   Tabulky 	**************\n");
}

void main(void)
{
   int i;
   char pom[15],*pom2,sw;

   empty();
   clrscr();
   for (;;)
      {
       printf ("Vyber funkciu:\n");
       printf ("1. Insert\t2. Read\t\t3. Delete\n4. Search\t5. Vypis\t6. Koniec\n");
       sw=getc(stdin);
       switch (sw)
	 {
	  case '1':printf ("Zadaj slovo:");
		   scanf("%s",pom);
		   insert(pom);
		   break;
	  case '2':printf("Zadaj kluc:");
		   scanf("%2s",pom);
		   pom2=read(pom);
		   if (pom2) printf ("Slovo s klucom '%s' je %s\n",pom,pom2);
		   else printf("Slovo s klucom '%s' sa nenaslo\n",pom);
		   break;
	  case '3':printf("Zadaj kluc:");
		   scanf("%2s",pom);
		   del(pom);
		   break;
	  case '4':printf("Zadaj kluc:");
		   scanf("%2s",pom);
		   if (search(pom)) printf ("Slovo s klucom '%s' je v slovniku\n",pom);
		   else printf("Slovo s klucom '%s' nie je v slovniku\n",pom);
		   break;
	  case '5':vypis();break;
          case '6':return;
	 }
       getc(stdin);
      }
}


/*   insert("Ahoj");
   insert("Cau");
   insert("pokus");
   insert("Slovo");
   insert("Skuska");
   vypis();
   del("Sl");
   vypis();
   if (search("po")) printf ("Anoooooooooooo");
	else printf ("Nieeeeeeeeeeee");
   printf ("%s",read("Ca"));*/

