#include<stdio.h>
#include<conio.h>
#include<dos.h>

typedef struct {      //front je reprezentovany strukturou
  int  prvy,posledny; //ukazovatel na prvy a posledny prvok
  int vozen[11];      //pole int-ov tvoriace front
} front;

int pred(int prv){
//vrati naspat index predch prvku
  if(prv==0)          //prvy prvok=>vrati posledny
    return(10);
  else
    return(prv-1);    //inak ukazovatel - 1
}

int nasl_ind(int prv){
//funkcia vrati nasl index prvku
 if(prv==10)          //posledny prvok vrati
   return(0);         //ukazovatel na prvy
 else
   return(prv+1);     //inak posledny + 1
}//nasl_ind

front empty(front kolaj){
//procedura vytvori prazdny front
kolaj.prvy=0;         //nastavi index prveho na 0
kolaj.posledny=10;    //index posledneho na 10
return(kolaj);
}//empty


int isempty(front kolaj){
//vrati 1 ak je front prazdny
if((nasl_ind(kolaj.posledny))==kolaj.prvy)
  return(1);          //ak posledny index je pred
else                  //prvym => nasl. prvok
  return(0);          //je prvok prvy vo fronte
}//isempty


front insert(front kolaj, int prvok){
//vlozi prvok do frontu
if(nasl_ind(nasl_ind(kolaj.posledny))==kolaj.prvy){
  printf("Kolaj je plna\n");
  delay(3000);
}
else{
  kolaj.posledny=nasl_ind(kolaj.posledny);
  kolaj.vozen[kolaj.posledny]=prvok;
}
  return(kolaj);
}//front


int first(front kolaj){
//vrati prvy prvok frontu
if(isempty(kolaj)==1){
  return('!');  //ak je front prazdny vrati '!'
}//if
else            //inak vrati hodnotu prveho prvku
  return(kolaj.vozen[kolaj.prvy]);
}//first


front vyprav_vlak(front vlak){
//funkcia vyprazdni plny front
int i;
for(i=0;i<11;i++){
  if((first(vlak))!='!'){
    vlak.prvy=nasl_ind(vlak.prvy);
    vlak.vozen[pred(pred(vlak.prvy))]='.';
  }
}
return(vlak);
}//vyprav_vlak


void main(void){
//deklacia premennych
front k[5];
int i,j,n,key=0;
int pom,l4=0,l5=0,j4=0,s4=8,zmena;

//vytvori 5 prazdnych frontov
for(i=0;i<5;i++){
  k[i]=empty(k[i]);
  for(j=0;j<11;j++)
    k[i].vozen[j]='.';
}


while(key!='k'){
  clrscr();
  for(i=0;i<5;i++){         //vypise obsah
    gotoxy(5,5+i);          //vsetkych piatich frontov
    printf("K%d",i+1);
    pom=k[i].prvy;
    n=0;
    while(n<10){
      gotoxy(20-n,5+i);
      putchar(k[i].vozen[pom]);
      pom=nasl_ind(pom);
      n++;
    }
  }
  for(i=3;i<5;i++) //testuje ci 4. alebo 5. front nie je plny
    if(nasl_ind(nasl_ind(k[i].posledny))==k[i].prvy){
      printf("\n\nKolaj K%d plna, vlak sa vypravuje.",i+1);
      k[i]=vyprav_vlak(k[i]);
      if(i==3){
	l4=0;j4=0;s4=8;
      }
      else
	l5=0;
    }

  //vypis menu
  printf("\np - pridaj vozen\n");
  printf("t - tried\n");
  printf("k - koniec\n");


  //operacie menu
  switch(getch()){
  case 'p':{  printf("Napis cislo kolaje(1-3)\n");
	      j=(getche()-'0');
	      if((j!=1)&&(j!=2)&&(j!=3)){
		printf("\nZle cislo");
		delay(3000);
		break;
	      }//if
	      printf("\nTyp vozna (j,s,l,o)\n");
	      i=getch();
	      if((i!='j')&&(i!='s')&&(i!='l')&&(i!='o')){
		printf("\nNeznami vozen");
		delay(3000);
		break;
	      }//if
	      k[j-1]=insert(k[j-1],i);//prida vozen do frontu
	      break;
	   }

  case 't':{  for(i=0;i<3;i++) {//triedi vozne, z kazdeho frontu
	      pom=first(k[i]);  //vybere posledny vozen a zatriedi
	      zmena=0;
	      switch(pom){
	      case 'l': { if(l4==0){//len jedna lokomotiva
			    k[3]=insert(k[3],pom);
			    zmena=1;l4=1;
			  }
			  else
			    if(l5==0){//len jedna lomot
			      k[4]=insert(k[4],pom);
			      zmena=1;l5=1;
			    }
			  break;
			}

	      case 'j': { if((l4==1)&&(j4==0)){//uz musi byt lokom
			    k[3]=insert(k[3],pom);//len jeden jedal
			    zmena=1;j4=1;
			  }
			  else{
			    if(l5==1){//uz musi byt lokomotiva
			      k[4]=insert(k[4],pom);
			      zmena=1;
			    }
			  }
			  break;
			}

	      case 's': { if((l4==1)&&(s4>0)){//lokomotiva a menej
			    k[3]=insert(k[3],pom);//ako osem spacich
			    s4--;
			    zmena=1;
			  }
			  else{
			    if(l5==1){//lokomotiva
			      k[4]=insert(k[4],pom);
			      zmena=1;
			    }
			  }
			  break;
			}

	      case 'o': { if(l5==1){//lokomotiva
			    k[4]=insert(k[4],pom);
			    zmena=1;
			  }
			  break;
			}
	      default : { break;
			}
	      }//switch
	      if(zmena==1){//ak bola zmena posun index prveho
		k[i].prvy=nasl_ind(k[i].prvy);
		k[i].vozen[pred(pred(k[i].prvy))]='.';
	      }//if(zmena
	      }//for


	      break;
	   }

  case 'k':{  key='k';
	      break;
	   }

  default: {  break;
	   }
  }//switch

}//while
}//main










