# the increment operator has a little built-in magic, see following 
$T = "Magic autoincrement";
print "\n **** $T ***", '-' x 40, "\n";
print ++($foo = "99");
print ++($foo = "a0");
print ++($foo = "Az");
print ++($foo = "zz");
# the quoting can be double or single
print ++($foo = 'Ba');

# if value is NOT like that, it does not work
$foo = '&&a';
print ++($foo); 

$T = "Decrement has NO MAGIC";
print "\n **** $T ***", '-' x 40, "\n";

# the decrement operator is NOT magical, see following 
print --($foo = "99");
print --($foo = "a0");
print --($foo = "Aa");
print --($foo = "zz");

$T = "Negating operator";
print "\n **** $T ***", '-' x 40, "\n";
print -10, " ";
print !10, " ";
print ~10, " ";


$T = "String repetition";
print "\n **** $T ***", '-' x 40, "\n";
print  '-' x 40, "\n";
print  '-' x40, "\n";
$tab = 25;
# if in scalar context, it repeats
print "\t" x ($tab/8), ' ' x ($tab%8), "HERE!\n";        # tab over

@ones = (1) x 10;           # a list of 80 1's
# if left is list in parenthesis
@twos = (2) x @ones;        # set all elements to 2
print "@ones\n";
print "@twos\n";
pop @twos;
@tres = (3) x @twos;        # set all elements to 3
print "@tres\n";
# @tres = (4 5 6) x @twos;        # set all elements to 5
# this is Syntax error


$T = "Exponentiation";
print "\n **** $T ***", '-' x 40, "\n";
print -2**4, " ", -(2**4), " ", (-2)**4; 


$T = "Concat";
print "\n **** $T ***", '-' x 40, "\n";
$foo = "100";
$bar = "50";
$a = $foo+$bar;
$b = $foo.$bar;
print "$a $b\n";
$foo = "aaa";
$bar = "bb";
$a = $foo+$bar;
$b = $foo.$bar;
print "$a $b\n";

$T = "Shift";
print "\n **** $T ***", '-' x 40, "\n";
$foo = "100";
$bar = 100;
$gee = "abcd";
$a = $foo<<4;
$b = $bar<<4;
$c = $foo>>2;
$d = $bar>>2;
$e = $gee << 0;

print "$a $b $c $d $e\n";


__END__

 **** Magic autoincrement ***----------------------------------------
100a1BaaaaBb1
 **** Decrement has NO MAGIC ***----------------------------------------
98-1-1-1
 **** Negating operator ***----------------------------------------
-10  -11 
 **** String repetition ***----------------------------------------
----------------------------------------
----------------------------------------
			 HERE!
1 1 1 1 1 1 1 1 1 1
2 2 2 2 2 2 2 2 2 2
3 3 3 3 3 3 3 3 3

 **** Exponentiation ***----------------------------------------
-16 -16 16
 **** Concat ***----------------------------------------
150 10050
0 aaabb

 **** Shift ***----------------------------------------
1600 1600 25 25 0
