// PGView.h : interface of the CPGView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PGVIEW_H__F5BCA925_5D04_11D2_B9D1_00A02439D76D__INCLUDED_)
#define AFX_PGVIEW_H__F5BCA925_5D04_11D2_B9D1_00A02439D76D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CPGView : public CScrollView
{
protected: // create from serialization only
	CPGView();
	DECLARE_DYNCREATE(CPGView)

// Attributes
public:
	CPGDoc* GetDocument();
	UINT m_uView;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPGView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	CPoint prevPoint;
	BYTE rotacia;	//1=x, 2=y, 4=z
	void OnInitialUpdate();
	virtual ~CPGView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPGView)
	afx_msg void OnViewPoints();
	afx_msg void OnViewWireframe();
	afx_msg void OnViewWireframe2();
	afx_msg void OnUpdateViewPoints(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewWireframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewWireframe2(CCmdUI* pCmdUI);
	afx_msg void OnViewStenovy();
	afx_msg void OnUpdateViewStenovy(CCmdUI* pCmdUI);
	afx_msg void OnButton32778();
	afx_msg void OnButton32779();
	afx_msg void OnUpdateButton32778(CCmdUI* pCmdUI);
	afx_msg void OnButton32780();
	afx_msg void OnButton32781();
	afx_msg void OnButton32782();
	afx_msg void OnUpdateButton32780(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButton32781(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButton32782(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in PGView.cpp
inline CPGDoc* CPGView::GetDocument()
   { return (CPGDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CNastav dialog


class CNastavenie : public CDialog
{
// Construction
public:
	CNastavenie(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CNastavenie)
	enum { IDD = IDD_NASTAVENIE1 };
	int		m_posunx;
	int		m_posuny;
	int		m_posunz;
	int		m_otocx;
	int		m_otocy;
	int		m_otocz;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNastavenie)
	public:
	virtual int DoModal(UINT &,UINT &,UINT &,int &,int &,int &);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CNastavenie)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CStredDialog dialog

class CStredDialog : public CDialog
{
// Construction
public:
	CStredDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CStredDialog)
	enum { IDD = IDD_STRED1 };
	int		m_stredx;
	int		m_stredy;
	int		m_stredz;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStredDialog)
	public:
	virtual int DoModal(CBod *);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CStredDialog)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PGVIEW_H__F5BCA925_5D04_11D2_B9D1_00A02439D76D__INCLUDED_)
