/* LEX_JED.H  */

/* popis kodov lex. jed. pre LA  */

#define LJ_EOF		-1

#define LJ_const	0
#define LJ_CIARKA 	1
#define LJ_var 		2
#define LJ_procedure 	3
#define LJ_call 	4
#define LJ_begin 	5
#define LJ_if 		6
#define LJ_while 	7


#define LJ_read 	8
#define LJ_write 	9
#define LJ_IDENT 	10
#define LJ_BODKOCIARKA 	11
#define LJ_BODKA 	12
#define LJ_end 		13
#define LJ_odd 		14
#define LJ_ROVNITKO 	15
#define LJ_NEROVNE 	16
#define LJ_MENSIE 	17
#define LJ_VACSIE 	18
#define LJ_MENEJROVNO 	19
#define LJ_VIACROVNO 	20

#define LJ_PLUS 	21
#define LJ_MINUS 	22
#define LJ_KRAT 	23
#define LJ_LOMITKO 	24
#define LJ_CISLO 	25
#define LJ_OTVORKA 	26
#define LJ_ZATVORKA 	27
#define LJ_then 	28
#define LJ_do 		29
#define LJ_PRIRADENIE	30
#define LJ_record 	32  //record !!!!







#define KLUC_SLOVA_L	0
//prvy oddelovac
#define ODDELOVACE_L	16
//prvy netextovy oddelovac
#define ODDELOVACE_H	33
//posledny oddelovac

const char* rslov[ODDELOVACE_H]={"const",",","var","procedure","call","begin",
			   "if","while","read","write","IDENTIFIKATOR",";",".","end","odd","=","<>",
			   "<",">","<=",">=","+","-","*","/","CISLO","(",")","then","do",":=","E","record"};
