#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

void main(void)
{
	FILE *vystup;
	int Vystup(int *,float *);
	int Vstup[5][25]=
					{
					 {-1,-1,1,1,1,-1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,1,1,1},
					 {-1,-1,1,1,-1,-1,1,-1,-1,-1,-1,-1,1,1,-1,-1,1,-1,-1,-1,-1,-1,1,1,-1},
					 {-1,1,-1,-1,1,-1,1,-1,-1,1,-1,1,1,1,1,-1,1,-1,-1,1,-1,1,-1,-1,1},
					 {-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,-1,1,1,1},
					 {1,-1,-1,-1,1,1,1,-1,-1,1,1,-1,1,-1,1,1,-1,-1,1,1,1,-1,-1,-1,1}
					};
	int VystupP[5]={1,1,-1,-1,-1};
	int i,j,p;
	float E,S,w[4],Vaha[25],Eta=.05;
	char VstupChar[5]={'I','E','H','L','N'};
	char Fcia;

	if ((vystup = fopen("percklas.txt","a")) == NULL)
	{
		printf("\nNemozem otvorit subor \"percklas.txt\" !");
		exit(1);
	}

	do{
		clrscr();
		p=0;
		for(i=0;i<25;i++)
			Vaha[i]=(10-rand()%20)/10.0;

		printf("\nRychlost ucenia je %f\n",Eta);
		fprintf(vystup,"\n\nRychlost ucenia je %f",Eta);

		do{
			S=0;

			for(i=0;i<5;i++)
			{
				fprintf(vystup,"\nPismeno %c je ",VstupChar[i]);
				printf("\nPismeno %c je ",VstupChar[i]);

				if(Vystup(Vstup[i],Vaha)==1)
				{
					fprintf(vystup,"samohlaska.");
					printf("samohlaska.");
				}
				else
				{
					fprintf(vystup,"spoluhlaska.");
					printf("spoluhlaska.");
				}

				S+=pow(VystupP[i]-Vystup(Vstup[i],Vaha),2);
			}

			E=0.5*S;
			printf("\nCyklus%d Chyba:%6.3f ",p,E);
			fprintf(vystup,"\nCyklus%d Chyba:%6.3f",p++,E);

			for(j=0;j<4;j++)
			{
				w[j]=0;

				for(i=0;i<5;i++)
					w[j]+=Eta*(VystupP[i]-Vystup(Vstup[i],Vaha))*Vstup[i][j];

				Vaha[j]+=w[j];
			}
		}while(E>0);

		printf("\nNEXT?(x/N)");
	}while(getch()!='n');
}

int Vystup(int*vstup,float *Vaha)
{
	float x=0;

	for(int i=0;i<25;i++)
		x+=Vaha[i]*vstup[i];
	if (x>0)
		return 1;
	else
		return -1;
}
