
class DAtom
{
  Bod * prvok;
  DAtom *predch;
  DAtom *nasled;
  friend class DList;
  DAtom (Bod * px):prvok(px) {}
  public:
  Bod * akt() {return prvok;}
};

class DList
{
  //nasl dekl. brani prekladacu pouzit dane metody v programe
  private:
  DList (const DList &);
  DList & operator=(const DList &);

  public:
  DAtom *kurzor;

  DList ():kurzor(NULL) { }
  int isempty() {return (kurzor==NULL);}
  void ins(Bod *);
  int  del();
  DAtom *next() { return(kurzor=kurzor->nasled);}
  DAtom *prev() { return(kurzor=kurzor->predch);}
  Bod * akt() {return kurzor->prvok;}
};
void DList::ins(Bod * p)
{
  DAtom *temp;
  temp=new DAtom(p);
  if (isempty())
    {
     kurzor=temp;
     kurzor->nasled=temp;
     kurzor->predch=temp;
    }
  else
    {
     temp->nasled=kurzor->nasled;
     temp->predch=kurzor;
     kurzor->nasled=temp;
     temp->nasled->predch=temp;
     kurzor=temp;
    }
}
int DList::del()
{
 DAtom *temp;
 if (!isempty())
   {
    temp=kurzor;
    kurzor=temp->predch;
    if (kurzor==temp) kurzor=NULL;
    else
      {
       kurzor->nasled=temp->nasled;
       temp->nasled->predch=kurzor;
      }
    delete temp;
    return 1;
   }
 else return 0;
}

