#include "bita.h"
#include <stdlib.h>

int main()
{
  bita *bar,*baw;
  uchar sz;
  uint ch;
  BOOLEAN ok;

  if ((bar = bitar_create("in.txt"))==NULL) {
    fprintf(stderr,"Not enough memory.\n");
    return 1;
  }
  if ((baw = bitaw_create("out.txt"))==NULL) {
    fprintf(stderr,"Not enough memory.\n");
    return 1;
  }

  ok=1;
  while (ok) {
    sz = random(16)+1;
    ok = bita_read(bar,sz,&ch);
    if (ok) bita_write(baw,sz,ch);
  }
  while (bita_read(bar,1,&ch))
    bita_write(baw,1,ch);
  bitar_drop(bar);
  bitaw_drop(baw);
  return 0;
}