/***************************
**ZADANIE:  1
**SUBOR  :  zadanie.cpp
**JAZYK  :  Borland C 3.1
**AUTOR  :
******************************/

#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

float fun(float x);  	 // funkcia pre vypocet funkcnej hodnoity v bode x
void a_(FILE *);      	 // uloha a - vypocet f(x) pre x z intervalu
void b_(FILE *);      	 // uloha b - vypocet f(x) pre x zo vstupu
void PisExtremy(FILE *,float min,float max,float priem);
		   //zapise hodnoty min, max a priemer do suboru/na obrazovku

//**************************** M A I N **************************************
void main(void)
{ FILE *f;
  int c;

do {
 printf("\n-----------------------------------------------------------------");
 printf("\nA / vypocet f(x) pre x z intervalu");
 printf("\nB / vypocet f(x) pre x zo vstupu");
 printf("\nTvoja volba: ");
 c=toupper(getche());				//nacitanie volby zadavania x
} while ((c!='A') && (c!='B'));

c=='A' ? a_(f):b_(f);				//vykonanie prislusnej funkcie
printf("\n");
}


//*********************DEFINICIA FUNKCIE*******************************
void a_(FILE *f)
 /* UCEL:    funkcia vykona ulohu s hodnotami x z intervalu
  * VSTUPNE PREMENNE:   f - vystupny subor
  * VYSTUPNE PREMENNE:  N/A	*/
{ float h, 				//horna hranica intervalu
		d,			//dolna hranica intervalu
		k,			//krok vypoctu
		fx,			//funkcna hodnota v bode
		min,			//minimum z funkcnych hodnot
		max,			//maximum z funkcnych hodnot
		priem;  		//aritmeticky priemer funkcnych hodnot;
  int i=0;				//pocet zadanych premennych

//**************************************************************************
  printf("\n\nZadaj dolnu hranicu: ");	//nacitanie hodnot od uzivatela
  scanf("%f",&d);
  printf("Zadaj hornu hranicu: ");
  scanf("%f",&h);
  printf("Zadaj velkost kroku: ");
  scanf("%f",&k);
  if (h<d) {				//vymena hranic, ak dolna > horna
   fx=h;
   h=d;
   d=fx;
  }

  if ((f=fopen("vystup.txt","wt"))==NULL)  	//otvorenie vystupneho suboru
   printf("Chyba pri otvarani vystupenho suboru!\a");   //a vypis chyby
  printf("\n      x          f(x)\n");
  fprintf(f,"\n      x          f(x)\n");

  fx=fun(d);					//priradenie funkcnej hodnoty
  fprintf(f,"%10.3f  %10.3f\n",d,fx);         	//zapis do suboru x a f(x)
  printf("%10.3f  %10.3f\n",d,fx);	        //dtto. na obrazovku
  max=fx;       				//inicializacia maxima
  min=fx;					//inicalizacia minima
  priem=fx;					//inicializacia priemeru
  d+=k;                                         //zvysenie dolnej hranice o k
  i++;						//zvysenie poctu premennych

  while (d<=h) {				//kym je dolna hranica<=horna
   i++;
   fx=fun(d);					//priradenie funkcnej hodnoty
   fprintf(f,"%10.3f  %10.3f\n",d,fx);        	//zapis do suboru x a f(x)
   printf("%10.3f  %10.3f\n",d,fx);	        //dtto. na obrazovku
   if (fx>max) max=fx;		        //ak fx>maximum, tak maximum=f(x)
   if (fx<min) min=fx;		        //dtto. pre fx<minimum
   priem+=fx;				//pripocitanie f(x) do suctu f. hodnot
   d+=k;				//zvysenie dolnej hranice o krok
  }

  if ((d-k)<h) {			//spracovanie hornej hranice,
   i++;					//pokial na nu nevysiel krok
   fx=fun(h);                           //postup rovnaky ako v cykle ^
   fprintf(f,"%10.3f  %10.3f\n",h,fx);
   printf("%10.3f  %10.3f\n",h,fx);
   if (fx>max) max=fx;
   if (fx<min) min=fx;
   priem+=fx;
  }

  priem/=i;				//vypocet aritm. priemeru

  PisExtremy(f,min,max,priem);		//zapis hodnot do suboru/na obrazovku
  fclose(f);	                        //uzatvorenie vystupneho suboru
}

//*********************DEFINICIA FUNKCIE*******************************
void b_(FILE *f)
 /* UCEL:    funkcia vykona uloha s hodnotami x zo vstupu
  * VSTUPNE PREMENNE:   f - vystupny subor
  * VYSTUPNE PREMENNE:  N/A       */
{ char vstup[20];
  float x,				//vstup funkcie f(x)
	fx,                             //funkcna hodnota v bode
	min,                            //minimum funkcnych hodnot
	max,                            //maximum funkcnych hodnot
	priem;                          //aritmeticky priemer funkcnych hodnot
  int i=0;
//**********************************************************************
  printf("\n\nZadavanie ukonci pismenom K\n");
  if ((f=fopen("vystup.txt","wt"))==NULL)  	//otvorenie vystupneho suboru
   printf("Chyba pri otvarani vystupenho suboru!\a\n");   //a vypis chyby
  if (stricmp(gets(vstup),"K")==0) {            //ak bolo zadane K...
   fclose(f);                                   //zavri vyst. subor
   exit(0);                                     //ukonci program
  }
  fprintf(f,"\n      x          f(x)\n");

  x=atof(vstup);                                //konverzia string->float
  fx=fun(x);				       	//priradenie funkcnej hodnoty
  fprintf(f,"%10.3f  %10.3f\n",x,fx);         	//zapis do suboru x a f(x)
  printf("%10.3f  %10.3f\n",x,fx);	        //dtto. na obrazovku
  max=fx;       				//inicializacia maxima
  min=fx;					//inicalizacia minima
  priem=fx;					//inicializacia priemeru
  i++;						//zvysenie poctu premennych

  while (stricmp(gets(vstup),"K")!=0) {         //kym nie je zadane K...
  x=atof(vstup);                                //konvertuje string->float
  fx=fun(x);					//priradenie funkcnej hodnoty
  fprintf(f,"%10.3f  %10.3f\n",x,fx);		//zapis do suboru x a f(x)
  printf("%10.3f  %10.3f\n",x,fx);		//dtto. na orazovku
  if (fx>max) max=fx;			//ak f(x)>maximum, tak maximum=f(x)
  if (fx<min) min=fx;			//dtto. pre f(x)<minimum
  priem+=fx;                            //pripocitanie f(x) do suctu f. hodnot
  i++;                                  //zvysenie poctu zadanych cisel
  }

  priem/=i;				//vypocet aritmetickeho priemeru

  PisExtremy(f,min,max,priem);          //zapis hodnot do suboru/na obrazovku
  fclose(f);	                        //uzatvorenie vystupneho suboru

}

//*********************DEFINICIA FUNKCIE*******************************
float fun(float x)
 /* UCEL:    funkcia vrati hodnotu matematickej funkcie v cisle x
  * VSTUPNE PREMENNE:   x
  * VYSTUPNE PREMENNE:  fx    -hodnota funkcie v bode x */
{ const PI=3.1415;                                  //definovanie cisla pi
 return(x/(x+4)+(sin(x/2-PI/3))*(sin(x/2-PI/3)));   //vypocet funkcnej hodnoty
}


//*********************DEFINICIA FUNKCIE*******************************
void PisExtremy(FILE *f,float min,float max,float priem)
 /* UCEL:    funkcia zapise minimum, maximum a priemer do soboru/na obrazovku
  * VSTUPNE PREMENNE:   f   -vystupny subor
  *			min,max,priem    -hodnoty minima, maxima, priemeru

  * VYSTUPNE PREMENNE:  N/A  */
{ fprintf(f,"\nMinimum funkcnych hodnot: %10.3f",min);         //zapis udajov
  printf("\nMinimum funkcnych hodnot: %10.3f",min);            //do vystupneho
  fprintf(f,"\nMaximum funkcnych hodnot: %10.3f",max);              //suboru
  printf("\nMaximum funkcnych hodnot: %10.3f",max);	            //a na
  fprintf(f,"\nAritmeticky priemer funkcnych hodnot: %10.3f",priem);
  printf("\nAritmeticky priemer funkcnych hodnot: %10.3f",priem); //obrazovku
}


































































































































//(c)1999 by Ludovit Fulop :-)