

//   Meno    :  Richard Hrubizna
//   Kruzok  :  TLK 2
//   Zadanie :  2
//   Odbor   :  Telekomunikacie


//   typedef struct{
//	      char polozka; -ulozena hodnota zasobnika
//	       int miesto;  -ukazuje na vrch zasobnika (ak je -1 tak je vrch)
//	       } stackelm;
//   zasobnik[N+1] -pole sturctur (typu elm) reprezetjuce zasobnik
//   operacie: empty                     ->zasobnik									     */
//             push    zasobnik,elm -> zasobnik
//             pop     zasobnik -> elm,zasobnik
//             isempty zasobnik -> bool
//
//	      									                                             */

#include<stdio.h>
#include<stdlib.h>
#include<conio.h>

#define N 10             //definovanie konstant
#define TRUE 1
#define FALSE 0

//--------------------------------------------------------------------------
// Globalne premenne

typedef struct{                            //dana struktura
		   char polozka;
		   int miesto;
} elm;

elm zasobnik[N+1];

//-------------------------------------------------------------------------

void empty(void);                      // deklarovanie funkcii
void push(char c);
int pop(void);
isempty(void);
void vypis(void);
void menu(void);

//-------------------------------------------------------------------------
// Hlavny program

int main(void){
int v;
clrscr();
menu();
empty();
vypis();

while(v != 'k'){
  gotoxy(3,10);
  printf("Zadaj volbu: ");
  v=getch();                                 // prepnutie podla volby
  switch ((char) v){

	case 'e': empty();
		  break;

	case 'p': gotoxy(4,11);
		  if(zasobnik[N].miesto==-1) {
		  printf("Zasobnik je plny");
		  getch();
		  } else {
		  printf("Chces vlozit: ");
		  push( (char)getche());
		  }
		  break;

	case 'o': if (isempty()==TRUE){
		  printf("Zasobnik je prazdny!");
		  getch();
		  } else{
		  printf("Vybrata polozka: %c ",pop());
		  getch();
		  }
		  break;

	case 'i': if (isempty()==TRUE){
				  printf("Zasobnik je prazdny!");
				  getch();
				  }
		  else{
			   printf("Zasobnik nie je prazdny!");
			   getch();
		 }
		 break;
	}

  clrscr();
  menu();
  vypis();

}
  return(0);
}

//     P O P I S     F U N K C I I
//--------------------------------------------------------------------------
// Funkcia Empty

void empty(void)
{
int i;
 for(i=0;i<=N;i++){                          // vytvorenie zasobnika
	 if (i==0) zasobnik[i].miesto = -1;
	else zasobnik[i].miesto = 0;
 }
}

//--------------------------------------------------------------------------
// Funkcia Push

void push(char c){
int i,pom;
if(zasobnik[0].miesto == -1) {  // pre pripad ze zasobnik je prazdny
	 zasobnik[0].miesto=0;      // zmena ukazovatela na vrch zasobnika
	 zasobnik[1].miesto=-1;
	 zasobnik[1].polozka=c;     // vkladanie polozky do zasobnika
} else for(i=N-1;i>0;i--) if (zasobnik[i].miesto == -1){         // ak je tam aspon jedna polozka
				zasobnik[i+1].polozka=c;             // vkladanie polozky do zasobnika
				zasobnik[i].miesto=0;                // zmena ukazovatela na vrch zasobnika
				zasobnik[i+1].miesto=-1;
			}
}

//--------------------------------------------------------------------------
// Funkcia POP

int pop( void){
 int i,pom;
 for(i=0;i<=N;i++) if (zasobnik[i].miesto == -1) pom=i-1;
 zasobnik[pom+1].miesto=0;   // zmena ukazovatela na vrch zasobnika
 zasobnik[pom].miesto=-1;
 return (zasobnik[pom+1].polozka); // vracia vybratu polozku
}

//--------------------------------------------------------------------------
// Funkcia IsEmpty

isempty(){
if (zasobnik[0].miesto==-1) return(TRUE);
       else return(FALSE);
}

//--------------------------------------------------------------------------
// Funkcia Menu

void menu (void)
{
  gotoxy(1,4);
  printf("e - Empty");
  printf("\np - Push");
  printf("\no - Pop");
  printf("\ni - IsEmpty");
  printf("\nk - Koniec");
  gotoxy(3,14);
  printf("     ");
  printf("Zasobnik                                                      \n");
  printf("     ");
  gotoxy(25,13);
  printf("9    8    7    6    5    4    3    2    1    0");

 }

//--------------------------------------------------------------------------
// Funkcia Vypis

void vypis(void)
{
 int i = 0;
 if(zasobnik[0].miesto!=-1) do {
	  i++;
	  gotoxy(20+5*i,14);
	  printf("%c",zasobnik[i].polozka);
   } while(zasobnik[i].miesto!=-1);
   while(++i<N) {
	  gotoxy(20+5*i,14);
	  printf(" ");
   }
}

