%Vytvorenie inverzneho modelu systemu pomocou ANFIS-u

data=[y w]
% Trenovacie data vstupu y a vystupu w (inverzny model)


fismat=genfis1(data,10,'trimf')
% Generovanie zakladneho fuzzy systemu (so Sugeno uvazovanim) pouzitim GENFIS1
% Pre danu trenovaciu mnozinu (data), pre 10 fuzzy mnozin vstupu, 'trimf' znamena ze 
% fuzzy mnoziny su v tvare trojuholniku


try=anfis(data,fismat,30)
%Anfis pomocou gradientovej metody minimalizuje kvadrat odchylky pozadovaneho a trenovacieho
%vystupu pre dany vektor vstupu. Optimalizaciou upravuje sirku mnozin zakladneho fuzzy
%systemu (fismat) a hodnoty vystupu z jedotlivych pravidiel Sugeno modelu. Konecny fuzzy system
%(po 50 krokoch) sa priradi fis premennej try. 

fuzzy(try)

