function ur=reg(h2,dh1,dh2,h1)
lambda1=-0.5;
lambda2=-0.5;
alfa1=2.08e-5;
alfa2=1.63e-5;
S1=2.025e-3;
beta1=alfa1/S1;
S2=S1;
beta2=alfa1/S2;
beta3=alfa2/S2;
h2w=0.1;
w=h2w;
m1=0.5;
m2=0.5;

h1w=w*(1+(beta3*beta3)/(beta2*beta2));
h1p=m1*h1w+(1-m1)*h1;
h2p=m2*w+(1-m2)*h2;
Ks=beta2/(2*S1*sqrt(h1p-h2p));
f=0.5*beta1*beta2+0.5*beta2*beta2-0.5*beta2*beta3*sqrt(h2p/(h1p-h2p))+0.5*beta2*beta3*sqrt((h1p/h2p)-1)-0.5*beta3*beta3;
U1=-f;
U2=Ks*1.02e-5-f;

y=h2-w;
if(y<0) 
   uj=U1;
else 
   uj=U2;
end
r0=-lambda1*lambda2;
r1=lambda1+lambda2;
if(((y<0)&(dh2>Ks*uj/lambda1))|(y>0)&(dh2<Ks*uj/lambda1)) 
   u=uj*(1-lambda2*(y-0.5*((dh2*dh2)/(Ks*uj)+(Ks*uj)/(lambda1*lambda1)))/(dh2));
else 
   u=r0*y+r1*dh2;
end
if(u<U1) 
   u=U1;
end
if(u>U2) 
   u=U2;
end
ur=(u+f)/Ks;