function out=ps(r,par)
%out=r^2-2*r+1;

i=par(1);
Td=par(2);
Pam=par(3);
tB=par(4);
Pbm=par(5);

if r==0
   TT=(Pam-Td);D=exp(-(tB-Td)/TT);
   switch i
          case 1, 
             out=Td-TT*(D-1)-Pbm;
          case 2, 
             out=Td-D^2*(TT+tB-Td)+TT-Pbm;
          case 3, 
             out=Td-D^3*(2*TT^2+4*TT*(tB-Td)+3*(tB-Td)^2)/2/TT+TT-Pbm;
          case 4,  
             out=Td-D^4*(3*TT^3+9*TT^2*(tB-Td)+12*TT*(tB-Td)^2+8*(tB-Td)^3)/3/TT/TT+TT-Pbm;
          otherwise, disp('Unknown method.')
   end;
elseif r==1
   switch i
          case 1, 
             TT=(Pam-Td);D=exp(-(tB-Td)/TT);
             out=Td-TT*(D-1)-Pbm;
          case 2, 
             TT=2*(Pam-Td)/3;D=exp(-(tB-Td)/TT);
             q2=r-2;
             out=Td-TT*D^2*(q2+4*D^q2)/2+3*TT/2-Pbm;
          case 3, 
             TT=6*(Pam-Td)/11;D=exp(-(tB-Td)/TT);
             q2=r-2;q3=r-3;
             out=Td-TT*D^3*(2-9*D^q2+18*D^q3)/6+11*TT/6-Pbm;
          case 4,  
             TT=12*(Pam-Td)/25;D=exp(-(tB-Td)/TT);
             q2=r-2;q3=r-3;q4=r-4;
             out=Td-TT*D^4*(q4+16*D^q2-36*D^q3+48*D^q4)/12+25*TT/12-Pbm;
          otherwise, disp('Unknown method.')
   end;
else          
   switch i
          case 1, 
             TT=(Pam-Td);
             D=exp(-(tB-Td)/TT);
             out=Td-TT*(D-1)-Pbm;
          case 2, 
             %hudzo
             q2=r-2; q4=r-4;  
             TT=2*q2*(Pam-Td)/q4;
             D=exp(-(tB-Td)/TT);D2=D^(-q2);
             out=Td-TT*(D^2*q2^2-4*D2)/(2*r*q2)+TT*q4/(2*q2)-Pbm;
             %jamro
             %q2=2-r; q4=4-r;  
             %TT=q2*(Pam-Td)/q4;
             %D=exp(-(tB-Td)/TT);D2=D^(q2/2);
             %out=Td+TT*(D*q2^2-4*D2)/(r*q2)+TT*q4/q2-Pbm;
          case 3, 
             q3=r-3; q23=2*r-3;  
             TT=3*q3*q23*(Pam-Td)/(27-18*r+2*r^2);
             D=exp(-(tB-Td)/TT);D3=D^(-q3);D23=D^(-q23);
             out=Td-TT*(D^3*(q23*q3)^2-18*D3*q23^2+9*D23*q3^2)/(6*q23*q3*r^2)+TT*(27-18*r+2*r^2)/(3*q3*q23)-Pbm;
          case 4,  
             q2=r-2; q4=r-4; q34=3*r-4;  
             TT=4*q2*q4*q34*(Pam-Td)/(-128+144*r-44*r^2+3*r^3);
             D=exp(-(tB-Td)/TT);D4=D^(-q4);D2=D^(-2*q2);D34=D^(-q34);
             out=Td-TT*(D^4*(q2*q4*q34)^2-48*D4*(q2*q34)^2+12*D2*(q34*q4)^2-16*D34*(q2*q4)^2)/(12*r^3*q2*q4*q34)+TT*(-128+144*r-44*r^2+3*r^3)/(4*q2*q4*q34)-Pbm;
          otherwise, disp('Unknown method.')
   end;
          
end         
