clc;
clear;

disp('Linearny model');
disp('');
Q=0;
Qv=0;
v1=16;
v2=4;
T=5;
b0=0;b1=0;b2=0;b3=0;
randn('seed',1);


u0=[1 1 1 1 1 1 1 1];
u1=[1 -1 1 -1 1 -1 1 -1];
u2=[1 1 -1 -1 1 1 -1 -1];
u3=[1 1 1 1 -1 -1 -1 -1];

m=[5 1 5 1 5 1 5 1;4 4 0 0 4 4 0 0;2*T 2*T 2*T 2*T T T T T]'; 

for k=1:8,v=m(k,:);
   for i=1:3;
    y(k,i)=(2*(350-328))/v(1)*sqrt(v(2))*exp(-v(3)/T)+randn;
   end
   y(k,4)=(y(k,1)+y(k,2)+y(k,3))/3;
   Q=Q+(y(k,1)-y(k,4))^2+(y(k,2)-y(k,4))^2+(y(k,3)-y(k,4))^2;
end

for k=1:8
    b0=b0+(u0(k)*y(k,4)/8);
    b1=b1+(u1(k)*y(k,4)/8);
    b2=b2+(u2(k)*y(k,4)/8);
    b3=b3+(u3(k)*y(k,4)/8);
end    

b=[b0 b1 b2 b3];
S2=Q/v1;
SB2=S2/8;
SB=sqrt(SB2);

% Test statistickej vyznamnosti
t0975=2.12;
delta=SB*t0975;

for k=1:8;
    yv(k)=b0*u0(k)+b1*u1(k)+b2*u2(k)+b3*u3(k);
end

% Test adekvatnosti lin.modelu
for k=1:8
    Qv=Qv+(y(k,4)-yv(k))^2;
end
Qv=3*Qv;
S2v=Qv/v2;
pomer=S2v/S2;

disp('y = ');
disp(y);
disp('Q = ');
disp(Q);
disp('b = ');
disp(b);
disp('yv = ');
disp(yv');
disp('S2 = ');
disp(S2);
disp('SB = ');
disp(SB);
disp('Qv = ');
disp(Qv);
disp('S2v = ');
disp(S2v);
disp('Pomer =');
disp(pomer)